#!/bin/bash

FILECONFIG="/etc/nagruzka/config.conf"

if [ -e $FILECONFIG ]; then
    source -x /usr/share/nagruzka/parse_toml.sh $FILECONFIG

    DATE=`date +%Y-%m-%d`

    # Нет доступа до ключа?
    # Выходим
    UIDPROD=`sudo cat /sys/class/dmi/id/product_uuid` || exit 0

    mysqldump --host=$Dbhost --port=$Dbport --user=$Dblogin --password=$Dbpass $Dbname \
    conversion \
    converter \
    converter_type \
    extension \
    fields \
    fieldsobject \
    fieldsvalue \
    filterparamis \
    filterparamname \
    graphics \
    graphicstype \
    groupusers \
    interprise \
    log_info \
    manufacturer \
    mark \
    menu_items \
    meter \
    meter_extra_type \
    meter_type \
    meterparameter \
    meterplace \
    metertypeparameter \
    metertypevariable \
    metervariable \
    mime \
    model \
    parameter \
    parameterdatatype \
    place \
    placetype \
    reports \
    rule \
    timezone \
    typefields \
    user \
    user_rule \
    usersinterprise \
    verification_meter \
    verificationmeter | gzip > "/usr/share/nagruzka/${DATE}.sql.gz"
    wget --post-file "/usr/share/nagruzka/${DATE}.sql.gz" "http://online.nagruzka.net/backup/${UIDPROD}/${DATE}/" -q
    rm -rf "/usr/share/nagruzka/${DATE}.sql.gz"

else
    echo "Нет файла конфигурации"
fi
