DROP PROCEDURE IF EXISTS MeterSaveData;

DELIMITER $$
$$
CREATE PROCEDURE `MeterSaveData`(IN meter INT ,IN v INT , IN p INT , IN y INT , IN m INT , IN d INT , IN h INT)
    COMMENT 'Сохранение данных'
BEGIN
 
    
  /*
   * 1. Сохранить данные
   * 2. Сохранить нулевое
   * 3. Обновить последние данные
   */
  
  -- Идентификатор данных куда вставили данные.
  DECLARE ID_SAVED_DATA INT DEFAULT 0;
  DECLARE ID_DAY_DATA INT DEFAULT 0;
  DECLARE ID_METERLAST INT DEFAULT 0;
  DECLARE ID_LOGINFO INT DEFAULT 3;


  -- Сначала надо проверить существуют ли уже данные.
  -- Если существуют то указатель делаем на эти данные
  SELECT id,loginfo_id INTO ID_SAVED_DATA,ID_LOGINFO FROM meterdatahour 
    WHERE meter_id      = meter
      AND parameter_id  = p
      AND `year`        = y
      AND `month`       = m
      AND `day`         = d
      AND `hour`        = h;
  
  
  IF ID_LOGINFO != 3 THEN
    DELETE from meterdatahour where id = ID_SAVED_DATA;
    SET ID_SAVED_DATA = 0;
  END IF;

  -- Данных нет то надо добавить их
  IF ID_SAVED_DATA = 0 THEN
    insert into `meterdatahour` (`meter_id`,`parameter_id`,`year`,`month`,`day`,`hour`,`value`,`tarif_id`,`loginfo_id`,`add_time`) 
    values (meter,p,y,m,d,h,v,0,3,NOW());
    SET ID_SAVED_DATA = LAST_INSERT_ID();
  END IF;


  -- Теперь у нас есть ID_SAVED_DATA. Надеюсь отличный от 0
  -- Надо или создать или обновить дневные даныне
  SELECT id INTO ID_DAY_DATA 
    FROM meterdatahour 
    where meter_id=meter and parameter_id=p and year=y and month=m and day=d and hour=0;
 
  -- Дневных данных нету. Надо их создать
  IF ID_DAY_DATA = 0 THEN
    insert into `meterdatahour` (`meter_id`,`parameter_id`,`year`,`month`,`day`,`hour`,`value`,`tarif_id`,`loginfo_id`,`add_time`) 
    values (meter,p,y,m,d,0,v,0,3,NOW());
    SET ID_DAY_DATA = LAST_INSERT_ID();
  END IF;


  -- Теперь у нас есть надеюсь и данные и дневные данные.
  -- Проверим есть ил последние данные
  -- Если есть - обновляем
  -- Если нет - добавляем
  SELECT id INTO ID_METERLAST FROM meterlast WHERE meter_id = meter AND `parameter_id` = p;
  
  -- Нет - добавляем
  IF ID_METERLAST = 0 THEN
    INSERT INTO meterlast
    (meter_id, meterdatahour_id, meterdatahour_skip_id, parameter_id, is_done, `year`, `month`, `day`, `hour`, priority, created_at, updated_at, deleted_at)
    VALUES(meter, ID_SAVED_DATA, ID_SAVED_DATA, p, 0, y, m, d, h, 0, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP, CURRENT_TIMESTAMP);
    SET ID_METERLAST = LAST_INSERT_ID();
  END IF;
  
  UPDATE meterlast set meterdatahour_id =ID_SAVED_DATA, `year` = y , `month` = m,`day` = d,`hour`=h WHERE id = ID_METERLAST;

END$$
DELIMITER ;
