DROP PROCEDURE IF EXISTS Meterok;

DELIMITER $$
$$
CREATE PROCEDURE `Meterok`()
BEGIN
  
  DECLARE done INT DEFAULT FALSE;
  
  DECLARE METERID INT DEFAULT 0;
  DECLARE COUNTSUCESS INT DEFAULT 0;


  DECLARE METERID_METER_RES INT DEFAULT 0;
  DECLARE COUNTALL_METER_RES INT DEFAULT 0;
  DECLARE COUNTSUCESS_METER_RES INT DEFAULT 0;
  DECLARE ISOK_METER_RES INT DEFAULT 0;
  
  DECLARE VIRT_OK_METER_RES INT DEFAULT 0;
  
  DECLARE VIRT_ALL_METER_RES INT DEFAULT 0;

  
  
  
  DECLARE METPAR_COUNT_OK INT DEFAULT 0;

  
  DECLARE METPAR_COUNT_ALL INT DEFAULT 0;

  
  DECLARE METPAR_IS_OK_FINAL INT DEFAULT 0;


  DECLARE ALL_METER_CONVERTER_RES INT DEFAULT 0;
  DECLARE OK_METER_CONVERTER_RES INT DEFAULT 0;
  DECLARE CONVERTERID_CONVERTER_RES INT DEFAULT 0;
  

  
  DECLARE cur_meterdataour CURSOR FOR 
  select 
    meter.id,
    count(*) as count_sucess
  from meter 
  left join timezone on timezone.id = meter.timezone_id
  left join meterdatahour
    on meterdatahour.`year` = YEAR( date_add( UTC_TIMESTAMP(), INTERVAL timezone.diff minute ) )

    and meterdatahour.`month` = MONTH( date_add( UTC_TIMESTAMP(), INTERVAL timezone.diff minute ) )
    and meterdatahour.`day` = DAY( date_add( UTC_TIMESTAMP(), INTERVAL timezone.diff minute ) )
    and meterdatahour.`hour` = 0
    and meterdatahour.loginfo_id = 3 
    and meterdatahour.meter_id = meter.id 
  where meterdatahour.`year` = YEAR( date_add( UTC_TIMESTAMP(), INTERVAL timezone.diff minute ) )
    and meterdatahour.`month` = MONTH( date_add( UTC_TIMESTAMP(), INTERVAL timezone.diff minute ) )
    and meterdatahour.`day` = DAY( date_add( UTC_TIMESTAMP(), INTERVAL timezone.diff minute ) )
    and meterdatahour.`hour` = 0
    and meterdatahour.loginfo_id = 3 
    and meterdatahour.meter_id = meter.id
  group by meterdatahour.meter_id;


  
  DECLARE cur_meter_res CURSOR FOR 
  SELECT 
    meter_id,
    count_all_parameters,
    count_sucess_parameter,
    virt_all,
    virt_is_ok
  FROM meter_res;

  
  
  DECLARE cur_meter_res_final CURSOR FOR
  select meter_id,is_ok from meter_res;

  
  
  DECLARE cur_converter_res_final CURSOR FOR
  select converter_id,meters_all,meter_ok from converter_res;

  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = TRUE;


  
  
  
  
  DROP TABLE IF EXISTS meter_res;
  DROP TABLE IF EXISTS converter_res;

  CREATE TEMPORARY TABLE meter_res (
    meter_id INT UNSIGNED NOT NULL,
    type_id INT UNSIGNED NOT NULL,
    count_all_parameters INT UNSIGNED,
    count_sucess_parameter INT UNSIGNED,
    is_ok INT UNSIGNED,
    virt_is_ok INT UNSIGNED,
    virt_all INT UNSIGNED
  );
  
 

  

  
  INSERT INTO meter_res ( meter_id , count_all_parameters , count_sucess_parameter , type_id , is_ok) 
    SELECT meter.id , 0 , 0 , meter.type_id , 0
    FROM meter
    left join meter_type on meter_type.id = meter.type_id
    where meter.converter_id > 0 
  ;

  
  update meter_res 

  right join 
    (
      SELECT 
      metertypeparameter.metertype_id,
      count(*) AS count_all
      FROM metertypeparameter
      left join parameter 
        on `parameter`.id = metertypeparameter.parameter_id
      where metertypeparameter.is_use = 1 
      and parameter.ident not like 'EVENT%' 
      GROUP BY metertypeparameter.metertype_id
    ) as metertypeparameter_tmp 
    on metertypeparameter_tmp.metertype_id = meter_res.type_id
  set meter_res.count_all_parameters = metertypeparameter_tmp.count_all;

  

  
  update meter_res 
  LEFT join 
    (
      SELECT 
        count(*) as count_is_ok,
        meter.id
      FROM meterparameter
      LEFT JOIN meter 

      ON meter.id = meterparameter.virtual_meter_id
      LEFT JOIN meter as m
        ON m.id = meterparameter.meter_id
      where m.is_ok = 1
      group by meterparameter.virtual_meter_id
    )as metertypeparameter_tmp 
    on metertypeparameter_tmp.id = meter_res.meter_id
  set meter_res.virt_is_ok = IFNULL( metertypeparameter_tmp.count_is_ok , 0 );

  
  
  update meter_res 
  LEFT join 
    (
      SELECT 
        IFNULL( count(*) , 0 ) as count_all,
        IFNULL(meter.id , 0 ) as id
      FROM meterparameter
      LEFT JOIN meter 
      ON meter.id = meterparameter.virtual_meter_id
      LEFT JOIN meter as m
        ON m.id = meterparameter.meter_id
      group by meterparameter.virtual_meter_id
    )as metertypeparameter_tmp 
    on metertypeparameter_tmp.id = meter_res.meter_id
  set meter_res.virt_all = IFNULL( metertypeparameter_tmp.count_all , 0 );


  
  
  
  OPEN cur_meterdataour;

  read_loop: LOOP
    fetch cur_meterdataour into METERID, COUNTSUCESS;
    IF done THEN
      LEAVE read_loop;
    END IF;
    update meter_res set count_sucess_parameter = COUNTSUCESS where meter_id = METERID;
  END LOOP;

  CLOSE cur_meterdataour;


  
  SET done = FALSE;
  
  
  
  
  OPEN cur_meter_res;

  read_loop: LOOP
    fetch cur_meter_res 
    into METERID_METER_RES, COUNTALL_METER_RES, COUNTSUCESS_METER_RES , 
      VIRT_ALL_METER_RES , VIRT_OK_METER_RES;
    
    IF done THEN
      LEAVE read_loop;
    END IF;

    
    IF COUNTSUCESS_METER_RES = COUNTALL_METER_RES THEN
      UPDATE meter_res set is_ok = 1 WHERE meter_id = METERID_METER_RES;
    
    
    
    ELSE
      IF VIRT_ALL_METER_RES > 0 AND VIRT_OK_METER_RES = VIRT_ALL_METER_RES THEN
        UPDATE meter_res set is_ok = 1 WHERE meter_id = METERID_METER_RES;
      END IF;
    END IF;
  END LOOP;

  CLOSE cur_meter_res;


  
  SET done = FALSE;



  OPEN cur_meter_res_final;

  read_loop: LOOP
    fetch cur_meter_res_final into METERID, METPAR_IS_OK_FINAL;
    IF done THEN
      LEAVE read_loop;
    END IF;
    update meter set is_ok = METPAR_IS_OK_FINAL where id = METERID;
  END LOOP;

  CLOSE cur_meter_res_final;

  
  DROP TABLE IF EXISTS meter_res;

  
  CREATE TEMPORARY TABLE converter_res (
    converter_id INT UNSIGNED NOT NULL,
    meters_all INT UNSIGNED NOT NULL,
    meter_ok INT UNSIGNED NOT NULL
  );
  
  INSERT INTO converter_res ( converter_id , meters_all , meter_ok) 
    SELECT converter.id , 0 , 0
    FROM converter
    where converter.is_excluded = 0 
  ;

  update converter_res 
  LEFT join 
    (
      select converter_id as id , count(*) as count_meters
      from meter 
      where converter_id > 0
      group by converter_id
    )as meters_tmp 
    on meters_tmp.id = converter_res.converter_id
  set converter_res.meters_all = IFNULL( meters_tmp.count_meters , 0 );


  update converter_res 
  LEFT join 
    (
      select converter_id as id , count(*) as count_meters
      from meter 
      where converter_id > 0
      and is_ok = 1
      group by converter_id
    )as meters_tmp 
    on meters_tmp.id = converter_res.converter_id
  set converter_res.meter_ok = IFNULL( meters_tmp.count_meters , 0 );


 
  SET done = FALSE;


  
  OPEN cur_converter_res_final;

  read_loop: LOOP
    fetch cur_converter_res_final into CONVERTERID_CONVERTER_RES, 
      ALL_METER_CONVERTER_RES , 
      OK_METER_CONVERTER_RES;
    IF done THEN
      LEAVE read_loop;
    END IF;
    IF ALL_METER_CONVERTER_RES = 0 THEN
      update converter set meter_ok = 1 where id = CONVERTERID_CONVERTER_RES;
    ELSEIF ALL_METER_CONVERTER_RES = OK_METER_CONVERTER_RES THEN
      update converter set meter_ok = 1 where id = CONVERTERID_CONVERTER_RES;
    ELSEIF OK_METER_CONVERTER_RES = 0 THEN
      update converter set meter_ok = 0 where id = CONVERTERID_CONVERTER_RES;
    ELSE
      update converter set meter_ok = 2 where id = CONVERTERID_CONVERTER_RES;
    END IF;
  END LOOP;

  CLOSE cur_converter_res_final;

  
END$$
DELIMITER ;
