DROP PROCEDURE IF EXISTS SelectMeter_v2;

DELIMITER $$
$$
CREATE  PROCEDURE `SelectMeter_v2`(licenses INT)
BEGIN
  
    
  CREATE TEMPORARY TABLE IF NOT EXISTS meterlicenses AS (
    SELECT meter.* FROM meter left join converter on converter.id = meter.converter_id 
    where meter.converter_id > 0 and meter.is_excluded = 0 and converter.is_excluded = 0
--     and meter.id = 666
   limit licenses
  );
  
  select 
  CEIL(meterlicenses.id) as id,
  CEIL(meterlicenses.converter_id) as converter_id,
  CEIL(meterlicenses.type_id) as type_id,
  CEIL(meterlicenses.num_485) as num_485,
  meterlicenses.num_serial as num_serial,
  CONCAT(meterlicenses.password,"") as password,
  CEIL(meterlicenses.coef)as coef,
  meterlicenses.timezone_id,
  meterlicenses.is_excluded,
  meterlicenses.interprise ,
  metertypeparameter.parameter_id,
  IF ( meterlast.id IS NULL , 0 , meterlast.id) as ml_id,
  IF ( meterlast.year IS NULL , 0 , meterlast.year) as year,
  IF ( meterlast.month IS NULL , 0 , meterlast.month) as month,
  IF ( meterlast.day IS NULL , 0 , meterlast.day) as day,
  IF ( meterlast.hour IS NULL , 0 , meterlast.hour) as hour
  from meterlicenses
  left outer  join metertypeparameter 
    on metertypeparameter.metertype_id = meterlicenses.type_id
  left outer join meterlast 
    on meterlast.meter_id = meterlicenses.id 
    and meterlast.parameter_id = metertypeparameter.parameter_id
  ;
  
  drop table meterlicenses;
END$$
DELIMITER ;
