<?php
include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );


header('Content-Type: application/json; charset=utf-8');

    //~ ini_set('display_errors','1');
    //~ error_reporting( E_ALL );



/*
  Ошибки при формировании
  @param Int пользователький код ошибки
  @param String строка расшифровки ошибки
*/
function ErrorJSON( $code , $msg ){
  ToJSON(array(
    'ident' => $code,
    'error' => $msg
  ));
}




if( !Self()->Is ){
  Site()->GoToAuth();
}



/*
  Дополнительные поля для конвертора
*/
function apply_converter( &$oObject , &$res ){
  $res['meters_count']        = $oObject->Meters->Count;
  $res['meters_error_count']  = $oObject->MetersError->Count;
  $res['title']               = $oObject->Title;
  return $res;
}




/*
  Дополнительные поля для виртуального конвертора
*/
function apply_vconverter( &$oObject , &$res ){
  $res['meters_count']        = $oObject->Meters->Count;
  $res['meters_error_count']  = $oObject->MetersError->Count;
  $res['title']               = $oObject->Title;
  return $res;
}


/*
  Дополнительные поля для виртуального конвертора
*/
function apply_cconverter( &$oObject , &$res ){
  $res['meters_count']        = $oObject->Meters->Count;
  $res['meters_error_count']  = $oObject->MetersError->Count;
  $res['title']               = $oObject->Title;
  return $res;
}


/*
  Дополнительные поля для пользователей
*/
function apply_user( &$oObject , &$res ){
  $res['title']               = $oObject->Title;
  $res['ruleplace']           = $oObject->RulePlacesArray;
  return $res;
}


/*
  Дополнительные поля для прибора учета
*/
function apply_meter( &$oObject , &$res ){
  $res['title']               = $oObject->Title;
  $res['link']               = $oObject->GetLink();
  return $res;
}




/*
  Дополнительные поля для прибора учета
*/
function apply_vmeter( &$oObject , &$res ){
  $res['title']               = $oObject->Title;
  $res['extra_type']          = $oObject->Meter_extra_type->Id;
  return $res;
}


/*
  Дополнительные поля для прибора учета
*/
function apply_cmeter( &$oObject , &$res ){
  $res['title']               = $oObject->Title;
  return $res;
}


/*
  Дополнительные поля для мест
*/
function apply_place( &$oObject , &$res ){
  $res['places_count']        = $oObject->GetChildren()->Count;
  $res['bankbook']            = $oObject->BankBook;
  $res['meters']              = $oObject->Meters->Count;
  return $res;
}


/*
  Дополнительные поля для мест
*/
function apply_group( &$oObject , &$res ){
  $res['title']        = $oObject->Title;
  return $res;
}


/*
  Дополнительные поля для мест
*/
function apply_rule( &$oObject , &$res ){
  $res['title']        = $oObject->Title;
  return $res;
}


/*
  Дополнительные поля для мест
*/
function apply_meterplace( &$oObject , &$res ){
  $res['converter']        = $oObject->Meter->Converter->Id;
  return $res;
}


/*
  Дополнительные поля для mail
*/
function apply_mail( &$oObject , &$res ){
  $res['ids']        = $oObject->PlacesIds;
  return $res;
}



/*
  Дополнительные поля заглушка
*/
function _empty( &$oObject , &$res ){
  return $res;
}



/*
  Подбираем коллбек функцию по объекту
  @param Object
  @return String
*/
function GetCallBackByObject( &$Object ){
  switch( get_class( $Object ) ){
    case 'converter'    : return  'apply_converter';
    case 'place'        : return  'apply_place';
    case 'meter'        : return  'apply_meter';
    case 'user'         : return  'apply_user';
    case 'vconverter'   : return  'apply_vconverter';
    case 'cconverter'   : return  'apply_cconverter';
    case 'vmeter'       : return  'apply_vmeter';
    case 'cmeter'       : return  'apply_cmeter';
    case 'group'        : return  'apply_group';
    case 'rule'         : return  'apply_rule';
    case 'meterplace'   : return  'apply_meterplace';
    case 'mail'         : return  'apply_mail';
    default             : return '_empty';
  }
}





$RESULT = array();


$Filter = array();

/*
  Преобразование списка объектов в JSON
  @param Array
  @return JSON
*/
function ElementsToJSON( $Elements , $callback_even = null ){
  $p = array();
  foreach( $Elements as $iObject ){
    $p[] = GetToJSON( $iObject , $callback_even );
  }
  ToJSON($p);
}


/*
  Преобразование одного элмента в объект JSON
  @param TObject
  @return Array
*/
function GetToJSON( &$oObject , $callback_even = null ){
  
  $fields = array();
  if( isset( $oObject->FieldsToJSON ) ){
    $fields = $oObject->FieldsToJSON;
  }  
  
  $res = array();
  
  foreach( $fields as $F => $f ){
    if( is_object( $oObject->$F ) ){
      $res[ $f ] = (int) $oObject->$F->Id;
      continue;
    }
    
    $v = $oObject->$F;
    
    if( isset( $oObject::$FInit[$F] ) ){
      switch( $oObject::$FInit[$F]['type'] ){
        case 'id':
        case 'int' :
           $v = (int) $v;
        break;
      }
    }
    $res[ $f ] = $v;
  }
  
  if($callback_even) $res = $callback_even( $oObject , $res );
  
  return $res;
}


/*
  Преодразование JSON в массив из полей объекта
  Обратная операция GetToJSON
  @param Object экземляр объекта
  @param Array массив значений
  @return Array
*/
function reparseJSON( $oObject,$a = array() ){
  
  $fields = array();
  
  if( isset( $oObject->FieldsToJSON ) ){
    $fields = $oObject->FieldsToJSON;
  } 
  
  $res = array();
  
  foreach( $fields as $F => $f ){
    
    if( isset( $a[$f] ) ){
      
      $m = $F;
      
      if( isset( $oObject::$FInit[ $F ]['object'] ) ){
        $m = $F."Id";
      }
      
      $res[ $m ] = $a[$f];
      
      if( preg_match( '/nterprise$/', $F ) ){
        $res[ $m ] = Self()->Interprise->Id;
      }
      
    }
  }
  
  /*
    Получение невалидных данных
  */
  foreach( $a as $F => $f ){
    if( !array_search( $F , $fields ) ){
      $res['not_valid_json'][ $F ] = $f;
    }
  }
  
  return $res;
  
}


/*
  Преобразование в JSON
  @param Any
*/
function ToJSON( $res ){
  echo json_encode( $res , JSON_UNESCAPED_UNICODE );
  //~ echo DB::Status();
  if( !defined( "__PHPUNIT_PHAR__" ) ){
    die();
  }else{
    return false;
  }
}




/*
  Поддерживаемые экземпляры объектов
*/
$Objects = array(
  'converter'       => true,
  'cconverter'      => true,
  'vconverter'      => true,
  'meter'           => true,
  'vmeter'          => true,
  'place'           => true,
  'convertertype'   => true,
  'meter_type'      => true,
  'config'          => true,
  'parameter'       => true,
  'meterparameter'  => true,
  'timezone'        => true,
  'metertype'       => true,
  'meterplace'      => true,
  'conversion'      => true,
  'user'            => true,
  'meterdatahour'   => true,
  'cmeter'          => true,
  'meterformula'    => true,
  'group'           => true,
  'rule'            => true,
  'mail'            => true,
  'meterhelper'     => true,
  'converterhelpers'=> true,
  'archive'         => true,
  'archivemeter'    => true,
  'model'           => true,
);



/*
  Если необходимо посмотреть все поддерживаемые объекты
*/
if( isset( $_GET['listen_objects'] ) ){
  echo json_encode( $Objects , true );
  if( !defined( "__PHPUNIT_PHAR__" ) ){
    die();
  }else{
    return false;
  }
}


$Object = null;


/*
  Если есть объект
*/
if( isset( $_GET['object'] ) ){
  
  $_GET['origin_object'] = $_GET['object'];
  
  switch( $_GET['object'] ){
    case 'filter' : 
      $_GET['object'] = 'meter';
    break;
    //~ case 'vmeter' : 
      //~ $_GET['object'] = 'meter';
    //~ break;
  }
  
  if( isset( $Objects[ $_GET['object'] ] ) ){
    $Object = $_GET['object'];
  }else{
    ErrorJSON( "invalid_obj","Нет такого объекта" );
  }
}

if( !property_exists( $Object , 'FieldsToJSON' ) ){
  ErrorJSON( "list_prop_not_found" , "Пожалуйста сообщите администратору эту ошибку" );
}


/*
  Получение структуры объекта
*/
if( isset( $_GET['describe'] ) ){
  $R = array();
  if( property_exists( $Object::Id(0) , FieldsToJSON ) ){
    $R = array_values( $Object::Id(0)->FieldsToJSON );
  }
  ToJSON( $R );
}


/*
  Полученеи описания всх его полей
*/
if( isset( $_GET['description'] ) ){
  $A = array();
  foreach( $Object::Id(0)->FieldsToJSON as $F=>$f ){
    
    $ru = "";
    
    if( isset( $Object::$FInit[$F]['rus'] ) ){
      $ru = $Object::$FInit[$F]['rus'];
    }
    
    $A[$f] = $ru;
  }
  ToJSON( $A );
}



/*
  Фильтрация
*/
if( isset( $_GET['filter'] ) ){
  $filter_pre = explode(';',$_GET['filter']);
  foreach( $filter_pre as $f ){
    $res = explode(':',$f);
      
    $z = "";
    
    preg_match('/([^=|>|>=|<|<=|!=|LIKE|IS NULL|NOT IN|IN]*)([=|>|>=|<|<=|!=|LIKE|IS NULL|NOT IN|IN]*)/' , $res[0] , $m);
    
    if( isset( $m[2] ) && $m[2] ){
      $res[0] = $m[1];
      $z = " ".$m[2];
    }
    
    $Fields = $Object::Id(0)->FieldsToJSON;
    
    $I = array_search( $res[0] , $Fields );
    
    if( !$I ) continue;
  
    $Filter['Filter'][ $I . $z ] = $res[1];
  }
}

if( isset( $_GET['limit'] ) && !isset($Filter['Filter']['Id']) ){
  $Filter['Limit'] = $_GET['limit'];
}



//~ if( isset( $_GET['type'] ) ){
  //~ $type = 0;
  //~ if( $_GET['type'] == 'virtual' ){
    //~ $type = convertertype::FindByIdent('VIRTUAL')->Id;
  //~ }
  //~ $Filter['Filter']['Type'] = $type;
//~ }


if( $_GET['object'] == 'converter' ){
  
    $array_types = array(
      'default' => '',
      'virtual' => 'VIRTUAL',
      'calc' => 'CALC'
    );
    
    if( !isset( $_GET['type'] ) ){
      $_GET['type'] = 'default';
    }
    
    foreach( $array_types as $key =>  $v ){
      if( isset( $_GET['type'] ) && $_GET['type'] == $key ){
        unset( $array_types[ $key ] );
      }
    }
    
    $A = array();
    
    foreach( $array_types as $key => $v ){
      if(!convertertype::FindByIdent( $v )) continue;
      $A[] = convertertype::FindByIdent( $v )->Id;
    }
  
  
    $Filter['Filter']['Type NOT IN'] = $A;
}elseif( $_GET['object'] == 'converter' ){
  $array_types = array(
      'default' => '',
      'virtual' => 'VIRTMETER',
    );
    
    if( !isset( $_GET['type'] ) ){
      $_GET['type'] = 'default';
    }
    
    foreach( $array_types as $key =>  $v ){
      if( isset( $_GET['type'] ) && $_GET['type'] == $key ){
        unset( $array_types[ $key ] );
      }
    }
    
    $A = array();
    
    foreach( $array_types as $key => $v ){
      if(!metertype::FindByIdent( $v )) continue;
      $A[] = metertype::FindByIdent( $v )->Id;
    }
  
  
    $Filter['Filter']['Type NOT IN'] = $A;
}elseif( $_GET['object'] == 'user' ){
  $Filter['Filter']['Interprise'] = Self()->Interprise->Id;
}


$Elements = array();

$METHOD = "";

if( isset( $_SERVER['HTTP_X_HTTP_METHOD_OVERRIDE'] ) ){
  if( $_SERVER['HTTP_X_HTTP_METHOD_OVERRIDE'] ){
    $METHOD = $_SERVER['HTTP_X_HTTP_METHOD_OVERRIDE'];
  }
}

if(  $METHOD ){
  switch(  $METHOD ){
    case 'PUT' :
      if( isset( $Filter['Filter']['Id'] ) && $Filter['Filter']['Id'] ){
        $O = $Object::Id( $Filter['Filter']['Id'] );
        $Ar = reparseJSON( $O , (array)json_decode($_POST['model']));
        $O->UpdateByArray($Ar);
        ToJSON( GetToJSON($O , GetCallBackByObject($O) ) );
      }else{
        $Ar = reparseJSON($Object::Id(0 ) , (array)json_decode($_POST['model']));
        $Add = $Object::AddByArray($Ar);
        if( !$Add ) $Add = $Object::Id(0);
        ToJSON( GetToJSON($Add , GetCallBackByObject($Add)) );
      }
      if( !defined( "__PHPUNIT_PHAR__" ) ){
        TObject2::CleanAllObjects();
        die();
      }else{
        return false;
      }
    break;
    case 'DELETE':
      if( isset( $Filter['Filter']['Id'] ) ){
        if( !$Object::Id( $Filter['Filter']['Id'] )->Is ){
          echo "droped";die();
        }
        $Object::Id( $Filter['Filter']['Id'] )->Delete();
        echo "droped";
        die();
      }
    break;
  }
}



if( 
    isset( $Filter['Filter']['Id'] ) && 
    (
      isset($_GET['ping_tcp']) ||
      isset($_GET['ping_udp']) ||
      isset($_GET['ping'])
    )
  ){
  $Filter = array();
}

if( $_GET['object'] == "meterdatahour" ){
  $oMeter = meter::Id( $Filter['Filter']['Meter'] );
  if( !isset($Filter['Filter']['Year']) ){
    $Filter['Filter']['Year'] = $oMeter->Date->format('Y');
  }
  if( !isset($Filter['Filter']['Month']) ){
    $Filter['Filter']['Month'] = $oMeter->Date->format('m');
  }
  if( !isset( $Filter['Filter']['Day'] ) ){
    $Filter['Filter']['Day'] = $oMeter->Date->format('d');
  }
}



if( isset( $_GET['list_use_group'] ) ){
  $Filter = array();
}

if( isset( $_GET['place_open'] ) ){
  $mail = mail::Filter( $Filter );
  if( $mail->Count ){
    $mail = $mail->First;
    $_Filter = $Filter;
    $Filter = array();
  }
}


if( isset( $_GET['converter_open'] ) ){
  $_Filter = $Filter;
  $Filter = array();
}

if( $Filter ){
  $Elements = $Object::Filter( $Filter )->Elements;
}else{
  
  
  if( isset( $_GET['place_open'] ) ){
    $mail = mail::Filter( $_Filter );
    if( $mail->Count ){
      $mail = $mail->First;
      $Filter['Filter']['Id'] = explode(",",$mail->PlacesIds);
      $_GET['tree'] = true;
      $_GET['origin_object'] = 'place';
      $_GET['all_parent'] = true;
    }
  }

  switch( $_GET['origin_object'] ){
    case 'convertertype' :
      $Elements = convertertype::All()->Elements;
    break;
    case 'archivemeter' :
      $SQL = Utils::Strip("
        select 
          converter.* 
        from 
          archivemeter 
        left join 
          meter on meter.id = archivemeter.meter_id
        left join 
          converter on converter.id = meter.converter_id
          where archivemeter.archive_id = {$_Filter['Filter']['Archive']}
          group by converter.id
      ");
      $t = converter::Id(0);
      $Elements = TListGroup::Prepare( $SQL , $t )->Elements;
    break;
    case 'converter' :
      if( isset($_GET['tree']) ){
        $Elements = converter::All()->Elements;
      }elseif( isset( $_GET['ping_tcp'] ) ){
        echo converter::Ping( $_REQUEST['ip'] , $_REQUEST['port'] , convertertype::Id($_REQUEST['type']) );
        die();
      //~ }elseif( isset( $_GET['ping_udp'] ) ){
        //~ echo converter::Ping( $_REQUEST['ip'] , $_REQUEST['port'] , 'UDP' );
        //~ die();
      //~ }elseif( isset( $_GET['ping'] ) ){
        //~ echo converter::PingICMP( $_REQUEST['ip'] );
        //~ die();
      }else{
        $Elements = Site()->GetRealConvertersByPages()->Elements;
      }
    break;
    case 'vconverter' :
        $Elements = Site()->VirtualConverters->Elements;
    break;
    case 'cconverter' :
        $Elements = Site()->Cconverters->Elements;
    break;
    case 'user' :
        
        $Filter = array( 
          'Filter' => array( 
            'Interprise' => Self()->Interprise->Id
          )
        );
        $Elements = user::Filter($Filter)->Elements;
    break;
    case 'meter' :
      if( isset($_GET['filter']) ){
        $Filter = array();
        foreach( explode(',',$_GET['filter']) as $F ){
          $o = explode(':',$F);
          if( $o[0] == 'place' ){
            $Elements = place::Id( $o[1] )->Meters->Elements;
          }
        }
      }
    break;
    case 'place' :
      $Elements = place::Filter($Filter)->Elements;
    break;
    case 'filter' :
      $Elements = Site()->MeterFilter->Elements;
    break;
    case 'config' :
      $Filter = array(
        'Filter'  => array(
          'Parametr LIKE' => '%ru.%'
        )
      );
      $Elements = config::Filter($Filter)->Elements;
    break;
    case 'parameter' :
    
    
      $method = "AllParameters";
      
      if( isset( $_GET['is_active'] ) ){
        
        $method = "ActiveParametersData";
        
        if( isset( $_GET['type'] ) ){
          switch( $_GET['type'] ){
            case 'data' : $method = "ActiveParametersData"; break;
          }
        }
        
      }
      
      if( isset( $_GET['meter'] ) ){
        $Elements = meter::Id( $_GET['meter'] )->$method->Elements;
      }elseif( isset( $_GET['vmeter'] ) ){
        $Elements = vmeter::Id( $_GET['vmeter'] )->$method->Elements;
      }elseif( isset( $_GET['vconverter'] ) ){
        $Elements = vconverter::Id( $_GET['vconverter'] )->$method->Elements;
      }elseif( isset( $_GET['converter'] ) ){
        $Elements = converter::Id( $_GET['converter'] )->$method->Elements;
      }elseif( isset( $_GET['place'] ) ){
        $Elements = place::Id( $_GET['place'] )->$method->Elements;
      }


    break;
    case 'metertype' :
      $Elements = metertype::All()->Elements;
    break;
    case 'timezone' :
      $Elements = timezone::All()->Elements;
    break;
    default:
      //$Elements = Site()->GetPlaceByPages()->Elements;
    break;
  }
}

/*
  Коолбек функции
*/
if( isset( $_GET['tree'] ) ){
  if( isset( $_GET['all_parent'] ) ){
    $Elements = place::Filter($Filter)->First->ParentAll->Elements;
  }
  if( isset( $_GET['place_open'] ) ){
    
    $p = array();
    
    foreach( place::Filter($Filter)->Elements as $iPlace ){
      $p[] = $iPlace->ToJsTree;
      foreach( $iPlace->ParentAll->Elements as $oPlace ){
        $p[] = $oPlace->ToJsTree;
      }
    }
    echo ToJSON( $p );
  }
  if( method_exists( $Object , 'GetToJsTree' ) ){
    $p = array();
    foreach( $Elements as $iObject ){
      $p[] = $iObject->ToJsTree;
    }
    echo ToJSON( $p );
  }
}else{
  if( $Elements ){
    echo ElementsToJSON( $Elements , GetCallBackByObject( $Elements[0] ) );
  }else{
    echo  ToJSON( array() );
  }
}


ErrorJSON( "invalid_cmd","Не верная команда" );

//~ var_dump($Filter);
