<?php
include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );

if( !Self()->Is ){
  if( !defined( "__PHPUNIT_PHAR__" ) ){
    Site()->GoToAuth();
  }else{
    echo "404"; 
    return false;
  }
}

header('Content-Type: application/json; charset=utf-8');

$res = array();

$Res = TListGroup::Init();

if( isset( $_GET['converter'] ) ){
  $Filter = array(
      'Filter' => array(
          'Converter' => $_GET['converter']
      )
  );
  $Res = meter::Filter( $Filter );
}elseif( isset( $_GET['place'] ) ){
  $Res = place::Id( (int) $_GET['place'] )->Meters;
}elseif( isset( $_GET['type'] ) ){
  switch( $_GET['type'] ){
    case "lorawan" :
      $Res = Site()->GetMetersImpulses();
    break;
  }
}else{
  $Res = meter::All();
}


foreach( $Res->Elements as $iMeter ){

  if( isset( $_GET['jstree'] ) ){
    $row_class = $iMeter->IsOk
                  ? 'text-success'
                  : 'text-danger';

    if( $iMeter->IsExcluded ){
      $row_class = "text-muted";
    }

    $res[] = array(
        'id'          => (int) $iMeter->Id,
        'text'        => htmlspecialchars($iMeter->Title,ENT_QUOTES),
        'parent'      => "converter_tree_".$iMeter->Converter->Id,
        'icon'        => Site()->Config('icon.meter') . " {$row_class}"
    );
  }else{
    $res[] = array(
        'id'          => (int) $iMeter->Id,
        'about'       => $iMeter->About,
        'converter'   => (int) $iMeter->Converter->Id,
        'type'        => (int) $iMeter->Type->Id,
        'num485'      => $iMeter->Num485,
        'num_serial'  => $iMeter->NumSerial,
        'password'    => $iMeter->Password,
        'coef'        => (int) $iMeter->Coef,
        'timezone'    => (int) $iMeter->Timezone->Id,
        'is_excluded' => (int) $iMeter->IsExcluded,
        'in_use'      => (bool) $iMeter->Inuse,
        'is_ok'       => (bool) $iMeter->IsOk
    );
  }
}

echo json_encode( $res , JSON_UNESCAPED_UNICODE );