<?php
include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );

$Uid = time() . rand(11111,99999);

header('Content-Encoding: UTF-8');
ignore_user_abort(true);
ob_start();

ini_set('display_errors','1');
    error_reporting( E_ALL );

file_put_contents( "log.log" , "start_log\n" );

function dolog( $msg ){
  file_put_contents( "log.log" , "[mem: " . mem() . "]  ".$msg . "\n" , FILE_APPEND );
}


function mem(){
  return memory_get_usage() / 1024 / 1024;
}



function delTree($dir) { 
 $files = array_diff(scandir($dir), array('.','..')); 
  foreach ($files as $file) { 
    (is_dir("$dir/$file")) ? delTree("$dir/$file") : unlink("$dir/$file"); 
  } 
  return rmdir($dir); 
} 


function greadArchive( $File , $Uid ){
  if( file_exists( $File ) ){
    
    
    
    $zip = new ZipArchive;
    
    $res = $zip->open( $File );
    
      
    if(
      $zip->statName('meterdatahour.csv') &&
      $zip->statName('loginfo.csv') &&
      $zip->statName('meter.csv') &&
      $zip->statName('metertype.csv') &&
      $zip->statName('converter.csv') &&
      $zip->statName('convertertype.csv') &&
      $zip->statName('parameter.csv') &&
      $zip->statName('shema.json')
    ){
      
      if( $res ){
        $zip->extractTo("./{$Uid}");
        $zip->close();
        
        
        chdir( $Uid );
        
        
        /*
          Сначала открываем shama
        */
        
        $SHEMA_JSON = file_get_contents( "shema.json" );
        
        $SHEMA = json_decode($SHEMA_JSON);
        
        if( !property_exists( $SHEMA->info , 'delimiter' ) ){
          $SHEMA->info->delimiter = ";";
        }
        if( !property_exists( $SHEMA->info , 'enclosure' ) ){
          $SHEMA->info->enclosure = "\"";
        }
        
        if( isset( $_GET['file'] ) ){
          echo archive::AddByArray(array(
            'Name'    => $SHEMA->info->origin_name,
            'YearSt'  => $SHEMA->info->year_start,
            'MonthSt' => $SHEMA->info->month_start,
            'DaySt'   => $SHEMA->info->day_start,
            'YearSp'  => $SHEMA->info->year_stop,
            'MonthSp' => $SHEMA->info->month_stop,
            'DaySp'   => $SHEMA->info->day_stop,
            'Text'    => $SHEMA->info->date_create,
            'Its'     => $SHEMA->info->description
          ))->Id;
          flush();
        }
        
        
        
        /*
          Таблица соответсивия
          ключ - это номер строки
          значение - идентиикатор
        */
        $map = array();
        
        
        

        foreach( array(
          'loginfo',
          'metertype',
          'convertertype',
          'converter',
          'meter',
          'parameter',
          'meterdatahour',
        ) as $name_t ){
          
          $line = 0;
        
          
          if (($handle = fopen("{$name_t}.csv", "r")) !== FALSE) {
              while (($data = fgetcsv($handle, 1000,  $SHEMA->info->delimiter , $SHEMA->info->enclosure )) !== FALSE) {
                
                $row = array();
                
                if( property_exists( $SHEMA->shema , $name_t ) ){
                  foreach( $SHEMA->shema->$name_t as $i => $Ident ){
                    
                    if( !isset( $data[$i] ) ){
                      dolog( "{$name_t} not found {$Ident} in shema. break" );
                      break 2;
                    }
                    
                    $row[ $Ident ] = $data[$i];
                  }
                }else{
                  dolog( "{$name_t} not found in shema. break" );
                  break;
                }
                
                $Filter = array('Filter' => array());
                
                
                switch( $name_t ){
                  case 'loginfo' :
                    $Filter['Filter']['Logtext']    = $row['Logtext']   ;
                  break;
                  case 'metertype' :
                    $Filter['Filter']['DllId']      = $row['DllId']     ;
                  break;
                  case 'convertertype' :
                    $Filter['Filter']['DllId']      = $row['DllId']     ;
                  break;
                  case 'parameter' :
                    $Filter['Filter']['Ident']      = $row['Ident']     ;
                  break;
                  case 'converter' :
                     $row['InterpriseId'] = Self()->Interprise->Id ;
                    $Filter['Filter']['Ip']         = $row['Ip']        ;
                    $Filter['Filter']['Port']       = $row['Port']      ;
                    if( isset( $row['Type'] ) && $map['convertertype'][$row['Type']] ){
                      $Filter['Filter']['Type']       = $map['convertertype'][$row['Type']]      ;
                      $row['TypeId'] = $Filter['Filter']['Type'];
                    }else{
                      dolog( "converter >> not found key [Type] or key in map where key equals [Id]" );
                    }
                  break;
                  case 'meter' :
                    $row['NumSerial'] = str_replace("'" , '' , $row['NumSerial'] ) ;
                    $row['InterpriseId'] = Self()->Interprise->Id ;
                    if( isset( $row['Type'] ) && $map['metertype'][$row['Type']] ){
                      $row['Type'] = $map['metertype'][$row['Type']];
                      $Filter['Filter']['Type']         = $row['Type']      ;
                    }else{
                      dolog( "meter >> not found key [Type] or key in map where key equals [Id]" );
                    }
                    $Filter['Filter']['NumSerial']    = $row['NumSerial'];
                    $Filter['Filter']['Num485']       = $row['Num485']    ;
                    $Filter['Filter']['Password']     = $row['Password']  ;
                  break;
                  case 'meterdatahour' :
                    if( isset( $row['Meter'] ) && isset($map['meter'][$row['Meter']]) ){
                      $row['MeterId'] = $map['meter'][$row['Meter']];
                      $Filter['Filter']['Meter']      = $map['meter'][$row['Meter']]     ;
                    }else{
                      dolog( "meterdatahour >> not found key [Meter] or key in map where key equals [Id]" );
                    }
                    if( isset( $row['Parameter'] ) && isset( $map['parameter'][$row['Parameter']] ) ){
                      $row['ParameterId'] = $map['parameter'][$row['Parameter']];
                      $Filter['Filter']['Parameter']  = $map['parameter'][$row['Parameter']] ;
                    }else{
                      dolog( "meterdatahour >> not found key [Parameter] or key in map where key equals [Id]" );
                    }
                    if( isset( $row['Loginfo'] ) && $map['loginfo'][$row['Loginfo']] ){
                      $row['LoginfoId'] = $map['loginfo'][$row['Loginfo']];
                    }else{
                      dolog( "meterdatahour >> not found key [Loginfo] or key in map where key equals [Id]" );
                    }
                    $Filter['Filter']['Year']       = $row['Year']      ;
                    $Filter['Filter']['Month']      = $row['Month']     ;
                    $Filter['Filter']['Day']        = $row['Day']       ;
                    $Filter['Filter']['Hour']       = $row['Hour']      ;
                    continue;
                  break;
                }
                
                
                if( empty( $Filter['Filter'] ) ){
                  dolog( "{$name_t} empty filter!" );
                  continue;
                }
                
                $res = $name_t::Filter( $Filter );
                
                if( !$res->Count ){
                  switch( $name_t ){
                    case 'loginfo' :
                      $Loginfo = loginfo::AddByArray( $row );
                      dolog( "append loginfo {$Loginfo->Id}" );
                    break;
                    case 'metertype' :
                      $Loginfo = metertype::AddByArray( $row );
                      dolog( "append metertype {$Loginfo->Id}" );
                    break;
                    case 'convertertype' :
                      $Loginfo = convertertype::AddByArray( $row );
                      dolog( "append convertertype {$Loginfo->Id}" );
                    break;
                    case 'parameter' :
                      $Loginfo = parameter::AddByArray( $row );
                      $map['parameter'][$line] = $Loginfo->Id;
                      dolog( "append parameter {$Loginfo->Id}" );
                    break;
                    case 'converter' :
                      $Loginfo = converter::AddByArray( $row );
                      dolog( "append converter {$Loginfo->Id}" );
                    break;
                    case 'meter' :
                      $Loginfo = meter::AddByArray( $row );
                      $map['meter'][$line] = $Loginfo->Id;
                      dolog( "append meter {$Loginfo->Id}" );
                    break;
                    case 'meterdatahour' :
                      $Loginfo = meterdatahour::AddByArray( $row );
                      dolog( "append meterdatahour {$Loginfo->Id}" );
                    break;
                  }
                  
                  if( $name_t != 'meterdatahour' && isset($Loginfo) ) $map[ $name_t ][ ++$line ] = $Loginfo->Id;
                  
                }else{
                  
                  switch( $name_t ){
                    case 'loginfo' :
                      dolog( "loginfo isset {$res->First->Title}" );
                    break;
                    case 'metertype' :
                      dolog( "metertype isset {$res->First->Title}" );
                    break;
                    case 'convertertype' :
                      dolog( "convertertype isset {$res->First->Title}" );
                    break;
                    case 'parameter' :
                      dolog( "parameter isset {$res->First->Title}" );
                    break;
                    case 'converter' :
                      dolog( "converter isset {$res->First->Title}" );
                    break;
                    case 'meter' :
                      dolog( "meter isset {$res->First->Title}" );
                    break;
                    case 'meterdatahour' :
                      dolog( "meterdatahour isset {$res->First->Title}" );
                    break;
                  }
                  
                  if( $name_t != 'meterdatahour' ) $map[ $name_t ][ ++$line ] = $res->First->Id;
                  
                }
                
                
              }
              fclose($handle);
          }
          
          
        }
        
        chdir( __DIR__ . '/../' );
        delTree( __DIR__ . "/".$Uid );
        
      }else{
        echo "zip_not_opened";
        //~ TODO error
      }
    }else{
      echo "files_not_full";
      //~ TODO error
    }
    
  }
}




if( mkdir( $Uid , 0755 ) ){
  
  if( isset( $_GET['id'] ) ){
    $oArchive = archive::Id( $_GET['id'] );
    
    $File = $oArchive->TransName . ".zip";
    greadArchive( $File , $Uid );
    
  }else{
    if( isset( $_GET['file'] ) ){
      greadArchive( $_GET['file'] , $Uid );
    }
    //~ delTree( __DIR__ . "/".$Uid );
  }

}else{
  //~ TODO error
}

