page = 1
count = "10"
pages = []

Filter = Backbone.Model.extend
	defaults :
		types : []
		is_ok : [0,1]
		count : count
		page  : page

filter = new Filter


IsOk = Backbone.View.extend
	el : "#is_ok_container"
	events : 
		"click input" : (e)->
			filter_checked = []
			$(@$el).find(':checked').each((i , e)->
				filter_checked.push Number($(e).val())
			)
			filter.set( 'is_ok' , filter_checked )

new IsOk

Meter = Backbone.Model.extend
	defaults :
		id : 0
		about : ""
		meter_title : ""
		meter_type : 0
		meter_id : 0
		converter : 0
		converter_about : ""
		num_serial : ""
		password : ""
		timezone_id : 0
		num485 : 0
		model : ""
		number_plomb : ""
		mark : ""
		status : 0
		checked : false
		first_date_verification : ""
		date_verification : ""
		interval_verification : 60 # in months
	url : ()->
    return "/api/?object=vmeter&filter=id:" + this.get('id')
  parse : (a) ->
  	a.id = Number(a.id)
  	return a


Meters = Backbone.Collection.extend
	model : Meter
	url : ()->
		"/api/imeters/?" + $.param(filter.toJSON())

	user_fetch : ()->
		###
		$('#meters').before(
			$('<div></div>')
			.addClass 'loader_circle_bg'
			.append(
				$('<div></div>')
				.addClass 'loader_circle' 
			)
		)
		###
		$('#meters').prepend(
	    $('<div>').attr(
	      id : 'CAPNAG'
	    ).css(
	      width: '50px'
	      height: '50px'
	      zIndex : 1002
	    ).append(
	      $('<div/>').addClass('page-preloader-cover').append(()->
	        [1,2,4,3].map((item)->
	          $(@).append(
	            $('<div/>').addClass('page-preloader__cube page-preloader--cube' + item)
	          )
	        ,@)
	      )
	    )
	  )
		meters.fetch(success:(r)->
			$('#CAPNAG').remove()
			$('.page-preloader-cover').remove()
			return
		,error:()->
			$('#CAPNAG').remove()
			$('.page-preloader-cover').remove()
		)
		false

meters = new Meters

filter.on "change" , meters.user_fetch

MetersList = Backbone.View.extend
	template : "#meters_tpl"
	el : "#meters"

	collection : meters

	initialize : ()->
		@listenTo @.collection, "sync" , @.render
		@listenTo @.collection, "remove" , @.render
		@.render()

	render : ()->
		tpl = _.template $(@.template).html()
		tpl_c = tpl meters : @.collection.toArray()
		$(@.$el).find('tbody').empty().append(tpl_c)

	events :
		"click #converter_add_meter" : ()->
			new MeterEditAdd new Meter(id : 0)
			false

		"click .fa-copy" : (e)->
			new MeterEditAdd( meters.get( $(e.target).closest('tr').attr('id') ).clone().set('id' , 0) )

		"click .fa-pencil" : (e)->
			new MeterEditAdd( meters.get( $(e.target).closest('tr').attr('id') ) )

		"click .fa-times" : (e)->
			new MeterDelete( meters.get( $(e.target).closest('tr').attr('id') ) )

new MetersList
# meters.fetch()
meters.user_fetch()



MeterType = Backbone.Model.extend
	defaults :
		id : 0
		title : 0
		use : 0

MeterTypes = Backbone.Collection.extend
	model : MeterType

metertypes = new MeterTypes

metertypes.on "change" , ()->
	filter_types = []
	for i,e in metertypes.where( use : 1 )
		filter_types.push i.get('id')

	filter.set('types' , filter_types)

$(document).ready(()->
	$('#metertype_container').find('option').each((i,op)->
		m = new MeterType id : Number( $(op).val() ) , title : $(op).text() , use : 0
		metertypes.add m
	)
)


# То что еще не выбрали
MeterTypesTrash = Backbone.View.extend
	el : "#metertype_container"
	template : "#metertype_container_tpl"
	collection : metertypes
	initialize : ()->
		@.listenTo @.collection , "change" , @.render
		@.render()
	events :
		"change" : (e)->
			@.collection.find(id : Number( $(e.target).val() ) ).set( use : 1 )
			# $(e.target).find(":selected").remove()
			false

	render : ()->
		tpl = _.template( $(@.template).html() )
		$(@.$el).empty().append( tpl( selected : @.collection.where( use : 0 ) ) )

$(document).ready(()->
	new MeterTypesTrash
)



MeterTypesChanged = Backbone.View.extend
	el : "#metertypes_change_container"
	collection : metertypes
	template : "#metertypes_change_container_tpl"
	initialize : ()->
		@.listenTo @.collection , "change" , @.render
		@.render()

	render : ()->
		tpl = _.template( $(@.template).html() )
		$(@.$el).empty().append( tpl( selected : @.collection.where( use : 1 ) ) )

	events :
		"click a" : (e)->
			id = Number $(e.target).closest('span').attr('data-id')
			@.collection.find( id : id ).set( use : 0 )
			false

new MeterTypesChanged

$('#check_all').on('change' , (e)->
	check = $(e.target).prop('checked')
	$('#meters').find('input[type="checkbox"]').each((i,el)->
		if $(el).attr('id') isnt "check_all"
			$(el).prop('checked' , check)
			meters.find( id : Number( $(el).val() ) ).set( checked : $(el).prop('checked') )
	)
)

$('#meters').on('change' , 'input[type="checkbox"]' , (e)->
	if $(e.target).attr('id') isnt "check_all"
		m = meters.find( id : Number( $(e.target).val() ) )
		if typeof m != "undefined"
			m.set( checked : $(e.target).prop('checked') )
)

Actions = Backbone.View.extend
	el :"#actions_meters"
	template : "#actions_meters_tpl"
	collection : meters
	initialize : ()->
		@.listenTo @.collection , "change" , @.render
		@.render()

	render : ()->
		tpl = _.template( $(@.template).html() )
		$(@.$el).empty().append( tpl( meters : @.collection.where( checked : true ) ) )

	events :
		"click #delete_meters" :(e)->
			return false if $(e.target).hasClass('disabled')
			new MeterDelete
			false

		# Исключение приборов
		"click #excluded_meters" : (e)->
			for meter in @.collection.where( checked : true )
				
				if Number( meter.get("is_excluded") ) == 0 || !meter.get("is_excluded")
					meter.set( "is_excluded" : 1 )
				else
					meter.set( "is_excluded" : 0 )
				meter.set( checked : false )
				meter.save()
			@.collection.trigger("sync")
			false


new Actions


MeterDelete = Backbone.View.extend
	template : "#device_delete_modal"
	collection : meters
	modal : null
	initialize : (model = null)->
		@.model = model
		@.render()

	render : ()->
		tpl = _.template( $(@.template).html() )
		@.modal = $(tpl() ).modal('show')

		self = @
		@.modal.on "click" , "#delete", ()->
			if self.model != null
				self.model.destroy( dataType:"text" ,
					success : ()->
						self.collection.remove( self.model )
				)
			for el , i in self.collection.where( checked : true )
				el.destroy( dataType : "text" , success : (res,r)->
					if r == "droped"
						self.collection.remove( el )
				)
			$(self.modal).modal('hide')


MeterEditAdd = Backbone.View.extend
	template : "#meter_edit_add"
	model : new Meter(id:0)
	initialize : (model)->
		@model = model
		@.render()

	render : ()->
		tpl_c = _.template( $(@.template).html() )
		@$el = $(tpl_c( meter : @.model )).modal('show')
		self = @
		$(@$el).on('hidden.bs.modal' , ()->
			$(@).remove()
		).on('shown.bs.modal' , ()->
			new CountChanelsView( self.model )
		)


	events : 

		"keyup #about_meter" : (e)->
			@model.set('about' , $(e.target).val() )


		"click #save_meter" : (e)->
			$(@$el).modal('hide')
			@model.save(null , success : ()->
				meters.fetch()
			)

		"keyup #num_serial_form" : (e)->
			@model.set('num_serial' , $(e.target).val() )

		"change #meter_type" : (e)->
			@model.set('meter_extra_type_id' , $(e.target).val() )

		"change #meter_parent" : (e)->
			@model.set('meter_id' , $(e.target).val())
			@model.trigger('set_count' , $(e.target).find(':selected').attr('data-count_input'))



CountChanelsView = Backbone.View.extend
	el : "#count_chanels"
	template : "#count_chanels_tpl"
	count : 0

	initialize : (model)->
		self = @
		@listenTo model , "change:meter_id" , @render
		model.on('set_count' , ( count )->
			self.render( count )
		)
		@render()

	render : ( count = 0 ) ->
		console.log( count )
		tpl_c = _.template( $(@.template).html() )
		$(@$el).empty().append( tpl_c( count : count ) )


Pagination  = Backbone.View.extend
	el :"#pagination"
	template : "#pagination_tpl"

	initialize : ()->
		@.render()

	render: ()->
		tpl_c = _.template( $(@.template).html() )
		$(@.$el).empty().append( tpl_c( pages : pages , active_count : count , active_page : page  ) )

	events :
		"click .paginator_pages a" : (e)->
			page = Number($(e.target).text())
			filter.set( page : page )
			@.render()
			false

		"click .paginator_counter a" : (e)->
			count = $(e.target).text()

			if isNaN( count )
				count = "all"
			filter.set( count : count )
			# meters.fetch()
			meters.user_fetch()
			replacePagination()
			@.render()
			false

pagination = new Pagination


meters.on('sync' , ()->
	replacePagination()
)

replacePagination = ()->
	$.get('/api/imeters/?get_pages=' + count + "&"+$.param(filter.toJSON()), (data)-> 

		# Если 3 "острова"
		# 	Начало
		# 	Середина
		# 	Конец
		# 	Пользовательский

		# Всегда рисуем Начальный остров и Пользовательский (то где стоит пользователь)
		# Если страниц хватает нарисовать Промежуточный и Оконечный то рисуем и их

		# Сколько страниц магнитится к островам пигинации
		magnet = 2

		# page - Текущая страница

		all = Number(data)

		pages = []


		# Рисуем начальный остров
		if page > magnet
			for i in [1..magnet]
				if i <= 0
					continue
				if pages.indexOf(i) == -1
					pages.push i

		# Рисуем конец
		if page < all - magnet
			for i in [(all-magnet+1)..all]
				if i > all
					continue
				if pages.indexOf( i ) == -1
					pages.push i

		# Рисуем середину

		# Проверяем чтобы не было размазанной пагинации из-за наслоения середины + пользовательского
		# [10][11][12][13][14][15][16][17][18][19]
		# | 		Середина		 ||	Пользовательский |
		is_before = [Math.ceil(all/2-magnet)..Math.ceil(all/2 + magnet)].indexOf( page - magnet - 1 ) == -1
		is_after = [Math.ceil(all/2-magnet)..Math.ceil(all/2 + magnet)].indexOf( page + magnet + 1 ) == -1

		if is_before && is_after

			for i in [Math.ceil(all/2-magnet)..Math.ceil(all/2 + magnet)]
				if i <= 0
						continue
				if i > all
						continue
				if pages.indexOf( i ) == -1
					pages.push i

		# Рисуем пользовательский
		for i in [(page-magnet)..(page+magnet)]
			if i <= 0
					continue
			if i > all
					continue
			# проверим что таких страниц еще нету
			if pages.indexOf(i) == -1
				pages.push i

		pages = pages.sort((a, b)->
		  return a - b
		)

		for v , i in pages
			if v == "..."
				continue
			if v >= all
					continue
			if v+1 != pages[i+1]
				pages.splice(i+1, 0, "...")

		pagination.render()
	, "JSON")
