#
# Конвертеры
#
LORA_MODEL = Backbone.Model.extend
	defaults :
		id : 0
		about : ""
		ip : ""
		port : 0
		type : 0
		login : ""
		pass : ""
	url : ()->
		"/api/lora/" + @.get('id') + "/"
 
LORA_COLECT = Backbone.Collection.extend
	model : LORA_MODEL
	url : "/api/lora/"


#
# Типы
#
LORATYPE_MODEL = Backbone.Model.extend
	defaults:
		id : 0
		title : ""

LORATYPE_COLLECT = Backbone.Collection.extend
	model : LORATYPE_MODEL
	url : "/api/loratype/"

lora_collect_gl = new LORA_COLECT
loratype_collect_gl = new LORATYPE_COLLECT


# Общий вид списка
LORA_LIST_VIEW = Backbone.View.extend
	el : "#lora_list"
	template : "#lora_list_tpl"
	collection : lora_collect_gl
	collection_types : loratype_collect_gl
	initialize : ()->

		# Добавили модель
		@listenTo @collection , "add_model" , (add_model)->
			@collection.add add_model
			@render()

		# Редактированили модель
		@listenTo @collection , "up_model" , ()->
			@render()

		# Удалили модель
		@listenTo @collection , "del_model" , ( del_model )->
			@collection.remove del_model
			@render()

		@render()
	render : ()->
		tpl_c = _.template( $(@template).html() )
		$(@$el).empty().append( tpl_c( 
			lora_collection : @.collection.toArray() 
			loratype_collection : @collection_types
		) )

	events :
		"click #add_converter_modal" : ( e )->
			new LORA_ADD_VIEW( new LORA_MODEL  , @collection)
			false

		"click .lora_edit_item" : ( e )->
			cid = $(e.target).closest("tr").attr('id')
			new LORA_ADD_VIEW( @collection.get(cid) , @collection )
			false

		"click .lora_delete_item" :( e )->
			cid = $(e.target).closest("tr").attr('id')
			new LORA_DELETE_VIEW( @collection.get(cid) , @collection )
			false



# Вид для модального окна добавления
LORA_ADD_VIEW = Backbone.View.extend
	template : "#lora_add_tpl"
	render : ()->
		self = @
		tpl_c = _.template( $(@template).html() )
		@$el = $( tpl_c( lora_model : @model ) ).modal('show')

	initialize : ( _model , _collection )->
		@model = _model
		@collection = _collection
		@render()

	events:
		"keyup #about_lora" : (e)->
			@model.set 'about' , $(e.target).closest('#about_lora').val()

		"keyup #ip_lora" : (e)->
			@model.set 'ip' , $(e.target).closest('#ip_lora').val()

		"keyup #port_lora" : (e)->
			val =  $(e.target).closest('#port_lora').val()
			@model.set 'port' , Number( val )

		"keyup #login_lora" : (e)->
			@model.set 'login' , $(e.target).closest('#login_lora').val()

		"keyup #pass_lora" : (e)->
			@model.set 'pass' , $(e.target).closest('#pass_lora').val()

		"click #save" : ()->
			self = @
			trigger = if @model.get('id') then "up_model" else "add_model"
			@model.save null , 
				success : (m)->
					self.collection.trigger(trigger , m)
					$(self.$el).modal('hide')
				error : ()->
					$(self.$el).modal('hide')



# Вид для удаления базовой станции
LORA_DELETE_VIEW = Backbone.View.extend
	template : "#lora_delete_tpl"
	initialize : ( _model , _collection )->
		@model = _model
		@collection = _collection
		@render()
	render : ()->
		self = @
		tpl_c = _.template( $(@template).html() )
		@$el = $( tpl_c( lora_model : @model ) ).modal('show')

	events : 
		"click #delete" : ()->
			self = @
			@model.destroy
				dataType : "text"
				success :(model,req)->
					if req == "droped"
						self.collection.trigger('del_model' , model)
						$(self.$el).modal('hide')


$(document).ready ()->
	lora_collect_gl.fetch
		success:()->

			# Подгружаем типы
			loratype_collect_gl.fetch
				success : ()->
					new LORA_LIST_VIEW
				error : ()->
					console.log("error type")

		error : ()->
			console.log("error")
