
# Выдернуто из скриптов родного софта
deviceTypes = [
    id: 1
    name: 'СИ-11'
    count_channels: 4
,
    id: 3
    name: 'СИ-13 Меркурий'
    count_channels: 6
,
    id: 4
    name: 'ТД-11'
    count_channels: 1
,
    id: 5
    name: 'ТП-11'
    count_channels: 1
,
    id: 6
    name: 'MC-0101'
    count_channels: 1
,
    id: 7
    name: 'AS-0101'
    count_channels: 1
,
    id: 8
    name: 'MS-0101'
    count_channels: 1
,
    id: 9
    name: 'СВЭ1'
    count_channels: 1
,
    id: 10
    name: 'SS-0101'
    count_channels: 1
,
    id: 11
    name: 'СИ-21'
    count_channels: 4
,
    id: 12
    name: 'Электросчетчик'
    count_channels: 1
,
    id: 13
    name: 'GM-2'
    count_channels: 1
,
    id: 14
    name: 'LM-1'
    count_channels: 1
]





LORA_MODEL = Backbone.Model.extend
	is_socket_connect : false
	is_socket_auth : false
	token : ""
	socket : null
	active : false
	defaults :
		id : 0
		about : ""
		ip : ""
		port : 0
		type : 0
		login : ""
		pass : ""
		device_type : _.first(deviceTypes)
	url : ()->
		"/api/lora/" + @.get('id') + "/"

	__get_devices : ()->
		@socket.send JSON.stringify(
	  	"cmd" : "get_devices_req"
	  	"token" : @token
	  )

	__get_gataways : ()->
		@socket.send JSON.stringify(
	  	"cmd" : "get_gateways_req"
	  	"token" : @token
	  )

	__get_coverage_map_req : ( callback )->
		@socket.send JSON.stringify(
	  	"cmd" : "get_device_appdata_req"
	  	"token" : @token
	  )


	__delete_model : ( model )->
		@socket.send JSON.stringify(
			"cmd" : "delete_device_appdata_req"
			"data_list" : [
				"devEui" : model.get('lora_model').get('devEui')
			]
			"token" : @token
		)


	__save_app_devices : ( model )->
		@socket.send JSON.stringify(
				"cmd" : "manage_device_appdata_req"
				"data_list" : [
					"devEui" : model.get('lora_model').get('devEui')
					"device_type" : String( model.get('lora_model').get('device_type') )
				]
				"token" : @token
			)

	__save_counter : ( model )->

		if model.get('id') == 0 || model.get('lora_model').get('devEui') == ""
			@socket.send JSON.stringify(
				"cmd" : "manage_devices_req"
				"devices_list" : [ model.get('lora_model').toJSON() ]
				"token" : @token
			)

		else

			@socket.send JSON.stringify(
				"cmd" : "manage_devices_req"
				"devices_list" : [
					"devEui" : model.get('lora_model').get('devEui')
					"devName" : model.get('lora_model').get('devName')
					"class" : model.get('lora_model').get('class')
				]
				"token" : @token
			)


ConverterType = Backbone.Model.extend
	defaults :
		id : 0
		title : 0
		use : 0

ConverterTypes = Backbone.Collection.extend
	model : ConverterType
	url : "/api/lora_converter_type/"

converter_types = new ConverterTypes


MeterType = Backbone.Model.extend
	defaults :
		id : 0
		title : 0
		use : 0

MeterTypes = Backbone.Collection.extend
	model : MeterType
	url : "/api/lora_meter_type/"

meter_types = new MeterTypes





ABR_MODEL = Backbone.Model.extend
	defaults :
		appsKey : ""
		devAddress : null
		nwksKey : ""

OTAA_MODEL = Backbone.Model.extend
	defaults :
		appEui : ""
		appKey : ""
		last_join_ts : 0
		
CNANELMASK_MODEL = Backbone.Model.extend
	defaults :
		channel1En : true
		channel2En : true
		channel3En : true
		channel4En : true
		channel5En : true
		channel6En : true
		channel7En : true
		channel8En : true
		channel9En : false
		channel10En : false
		channel11En : false
		channel12En : false
		channel13En : false
		channel14En : false
		channel15En : false
		channel16En : false

FREQUENCYPLAN_MODEL = Backbone.Model.extend
	defaults : 
		freq4 : 867100000
		freq5 : 867300000
		freq6 : 867500000
		freq7 : 867700000
		freq8 : 867900000


POSITION_MODEL = Backbone.Model.extend
	defaults :
		altitude : 0
		latitude : 0
		longitude : 0

SETTINGSAPPLYSTATUS_MODEL = Backbone.Model.extend
	defaults :
		channelMaskApllied : true
		delayRx1Applied : true
		drRx2Applied : true
		freq4Applied : true
		freq5Applied : true
		freq6Applied : true
		freq7Applied : true
		freq8Applied : true
		freqRx2Applied :true

LORA_DEVICE_MODEL = Backbone.Model.extend
	defaults :
		ABP : new ABR_MODEL
		OTAA : new OTAA_MODEL
		adr : false
		channelMask : new CNANELMASK_MODEL
		class: "CLASS_A"
		delayJoin1:5
		delayJoin2:0
		delayRx1:1
		delayRx2:0
		devEui:""
		devName:"",
		drRx2:0
		fcnt_down:0
		fcnt_up:0
		freqRx2:869525000
		frequencyPlan : new FREQUENCYPLAN_MODEL
		lastRssi:0
		lastSnr:0
		last_data_ts:0
		position : new POSITION_MODEL
		preferDr:5
		preferPower:14
		reactionTime:1000
		rxWindow:2
		serverAdrEnable : true
		settingsApplyStatus : new SETTINGSAPPLYSTATUS_MODEL
		useDownlinkQueueClassC : false

	__set : ( data )->
		@set('ABP' , new ABR_MODEL( data.ABP ) )
		@set('OTAA' , new OTAA_MODEL( data.OTAA ) )
		@set('channelMask' , new CNANELMASK_MODEL( data.channelMask ) )
		@set('frequencyPlan' , new FREQUENCYPLAN_MODEL( data.frequencyPlan ) )
		@set('position' , new POSITION_MODEL( data.position ) )
		@set('settingsApplyStatus' , new SETTINGSAPPLYSTATUS_MODEL( data.settingsApplyStatus ) )

LORA_DEVICE_COLLECTION = Backbone.Collection.extend
	model : LORA_DEVICE_MODEL

	__add : (data)->

		for device in data
			d = new LORA_DEVICE_MODEL(device)
			d.__set(device)
			@add(d)


Meter = Backbone.Model.extend
	defaults :
		id : 0
		about : ""
		meter_type_title : ""
		type : 0
		converter : 0
		converter_about : ""
		num_serial : ""
		password : ""
		timezone_id : 0
		num485 : 0
		model : ""
		number_plomb : ""
		mark : ""
		status : 0
		checked : false
		first_date_verification : ""
		date_verification : ""
		interval_verification : 60 # in months
		lora_model : new LORA_DEVICE_MODEL

	url : ()->
    return "/api/?object=meter&filter=id:" + @get('id')



Meters = Backbone.Collection.extend
	model : Meter
	url : ()->
		"/api/?object=meter&filter=converter:" + lora_id

	user_fetch : ()->
		$('#meters').prepend(
	    $('<div>').attr(
	      id : 'CAPNAG'
	    ).css(
	      width: '50px'
	      height: '50px'
	      zIndex : 1002
	    ).append(
	      $('<div/>').addClass('page-preloader-cover').append(()->
	        [1,2,4,3].map((item)->
	          $(@).append(
	            $('<div/>').addClass('page-preloader__cube page-preloader--cube' + item)
	          )
	        ,@)
	      )
	    )
	  )
		meters.fetch(success:(r)->
			$('#CAPNAG').remove()
			$('.page-preloader-cover').remove()
			return
		,error:()->
			$('#CAPNAG').remove()
			$('.page-preloader-cover').remove()
		)
		false


meters_collect = new Meters





lora_device_collection = new LORA_DEVICE_COLLECTION

lora_model_gl = new LORA_MODEL( id : lora_id )

lora_model_gl.on("change:ip change:port" , ()->

	self = @

	if @get('ip') != "" && @get('port') != 0

		if @socket != null 
			@socket.close()

		# Авторизуемся
		@socket = new WebSocket("ws://" + @get('ip') + ":" + @get('port') + "/")
		@socket.onopen = ()->
		  console.log("Соединение установлено.")
		  self.is_socket_connect = true
		  self.trigger('is_socket_connect_change')
		  self.socket.send JSON.stringify(
		  	"cmd" : "auth_req"
		  	"login" : self.get('login')
		  	"password" : self.get('pass')
		  )

		@socket.onclose = (event)->
		  if event.wasClean
		    console.log('Соединение закрыто чисто')
		  else
		    console.log('Обрыв соединения')
		  console.log('Код: ' + event.code + ' причина: ' + event.reason)

		@socket.onmessage = (event)->
			data = JSON.parse(event.data)

			if data.cmd == "auth_resp"
				if data.status
					self.is_socket_auth = true
					self.token = data.token
					self.trigger('is_socket_auth_change')

					self.__get_gataways()

					self.__get_devices()

					self.__get_coverage_map_req()


			else if data.cmd == "manage_devices_resp"


				for _device in data.device_add_status

					_meter = meters_collect.findWhere({num_serial : _device.devEui})
					if _device.status == "updated" || _device.status == "added" || _device.status == "nothingToUpdate"

						if typeof _meter != "undefined"
							_meter.save()
							self.__save_app_devices( _meter )


			# Пришел ответ с пожключенными устройствами
			else if data.cmd == "get_devices_resp"


				# Что делает этот кусок кода?
				# Предположим что у нас уже есть список приборов в БД и подключенных к Базовой станции
				# Надо найти общие и записать в meters_sucess
				# Дальше все, которые есть на базовке мы сохраняем в бд
				# Все которые остались в meters_collect мы удаляем
				# После этого завершаем синхронизацию

				# Создаем список приборов из базовой станции
				lora_device_collection.__add( data.devices_list )



				for _device in lora_device_collection.toArray()
					m_ = meters_collect.findWhere( num_serial : _device.get('devEui') )
					if typeof m_ != "undefined"
						m_.set('lora_model' , _device)
				return

				
				# Включаем тригер синхронизации
				meters_collect.trigger("custom_sync" , true)

				# Совпавшие из БД и на базовой станции
				meters_sucess = new Meters

				
				# Собираем совпавшие приборы
				for _device in lora_device_collection.toArray()

					findRes = meters_collect.where(
						num_serial : _device.get('devEui')
					)

					for _remove_meter , i in findRes
						if !i
							meters_sucess.add _remove_meter
						else
							# Убираем дубликаты
							_remove_meter.destroy()
						meters_collect.remove _remove_meter

				# Удаляем все приборы, которых нет на базовке
				for _meter in meters_collect.toArray()
					_meter.destroy()

				for _device in lora_device_collection.toArray()

					find_meter = meters_sucess.where( num_serial : _device.get('devEui') )

					if find_meter.length
						continue

					new_meter = new Meter(
						num_serial : _device.get('devEui')
						converter : lora_id
						about : _device.get('devName')
						type_id : meter_types.at(0).get('id')
					)

					new_meter.save(null,success:(new_model)->
						meters_collect.add( new_meter )
						meters_collect.trigger("add")
					)

					meters_collect.add( new_meter )

				meters_collect.add( meters_sucess.toArray() )

				meters_collect.trigger("custom_sync" , false)
				meters_collect.trigger("add")

			else if data.cmd == "get_gateways_resp"
				if data.gateway_list.length > 0
					self.active = data.gateway_list[0].active
					self.trigger('active_change')


			# Через этот тип у прибора можно достать тип
			else if data.cmd == "get_device_appdata_resp"
				for _device in data.devices_list
					findDevice = meters_collect.findWhere( num_serial : _device.devEui )

					# Закидываем прибору тип из родного софта
					if typeof findDevice != "undefined"
						device_type = _.find( deviceTypes , id : Number( _device.device_type ) )
						if typeof device_type == "undefined"
							device_type = _.first( deviceTypes )
						findDevice.set('device_type' , device_type )
						meters_collect.trigger('add')

				self.__get_gataways()


		@socket.onerror = (error)->
		  console.log("Ошибка " + error.message)
)



# Заголовок страницы
LORA_H1_VIEW = Backbone.View.extend
	el : "#lora_h1"
	model : lora_model_gl
	initialize : ()->
		@render()
		@listenTo @model , "sync" , @render
	render : ()->
		$(@$el).text( @model.escape('about') )



# Хлебные крошки
LORA_BREADS_VIEW = Backbone.View.extend
	el : "#lora_brads"
	model : lora_model_gl
	initialize : ()->
		@render()
		@listenTo @model , "sync" , @render
	render : ()->
		$(@$el).text( @model.escape('about') )




# Таблица со свойствами
LORA_PROPERTIES_VIEW = Backbone.View.extend
	el : "#lora_properties"
	template : "#lora_properties_tpl"
	model : lora_model_gl
	collection : converter_types
	socket_status : false
	initialize : ()->
		@render()
		@listenTo @model , "sync" , @render
		@listenTo @model , "is_socket_connect_change" , @render
		@listenTo @model , "is_socket_auth_change" , @render
		@listenTo @model , "active_change" , @render
		@listenTo @collection , "sync" , @render
	render : ()->
		tpl_c = _.template( $(@template).html() )
		$(@$el).empty().append tpl_c
				lora_model : @model
				types : @collection.toArray()

	events :
		"click #converter_edit_modal" : ()->
			new LORA_ADD_VIEW( @model , null )
			false



# Вид для модального окна добавления
LORA_ADD_VIEW = Backbone.View.extend
	template : "#lora_add_tpl"
	render : ()->
		self = @
		tpl_c = _.template( $(@template).html() )
		@$el = $( tpl_c(
			lora_model : @model 
		) ).modal('show')

	initialize : ( _model , _collection )->
		@model = _model
		@collection = _collection
		@render()

	events:
		"keyup #about_lora" : (e)->
			@model.set 'about' , $(e.target).closest('#about_lora').val()

		"keyup #ip_lora" : (e)->
			@model.set 'ip' , $(e.target).closest('#ip_lora').val()

		"keyup #port_lora" : (e)->
			val =  $(e.target).closest('#port_lora').val()
			@model.set 'port' , Number( val )

		"keyup #login_lora" : (e)->
			@model.set 'login' , $(e.target).closest('#login_lora').val()

		"keyup #pass_lora" : (e)->
			@model.set 'pass' , $(e.target).closest('#pass_lora').val()

		"click #save" : ()->
			self = @
			trigger = if @model.get('id') then "up_model" else "add_model"
			@model.save null , 
				success : (m)->
					$(self.$el).modal('hide')
				error : ()->
					$(self.$el).modal('hide')




# Вид для удаления базовой станции
LORA_DELETE_VIEW = Backbone.View.extend
	template : "#delete_counter_tpl"
	initialize : ( _model , _collection )->
		@model = _model
		@collection = _collection
		@render()
	render : ()->
		self = @
		tpl_c = _.template( $(@template).html() )
		@$el = $( tpl_c( lora_model : @model ) ).modal('show')

		$(@$el).on('hidden.bs.modal' , ()->
			$(@).remove()
			self.collection.trigger('sync')
		)

	events :
		"click #delete_counter" : ()->
			self = @
			lora_model_gl.__delete_model( @model )
			@model.destroy( dataType : "text" , success:()->
				self.collection.remove( self.model )
				$(self.$el).modal('hide')
			)



LORA_CHILD_VIEW = Backbone.View.extend
	el : "#lora_meters"
	collection : meters_collect
	sync : false
	template : "#lora_meters_tpl"
	initialize : ()->
		@render()
		@listenTo @collection , "sync" , @render
		@listenTo @collection , "add" , @render
		@listenTo meter_types , "sync" , @render
		@listenTo @collection , "custom_sync" , ( stat_sync )->
			@sync = stat_sync
			@render()
	render : ()->
		tpl_c = _.template( $(@template).html() )
		
		$(@$el).empty().append( tpl_c( 
			devices : @collection.toArray() 
			sync : @sync
			types : meter_types
		) )

	events : 

		"click #lora_add_meter" : (e)->
			new LORA_COUNTER_ADD_EDIT_MODAL( new Meter( converter : lora_id ) )
			false


		"click .converter_meter_edit" : (e)->
			cid = $(e.target).closest('tr').attr('id')
			new LORA_COUNTER_ADD_EDIT_MODAL( meters_collect.get( cid ) )
			false


		"click .converter_meter_delete" : ( e )->
			cid = $(e.target).closest('tr').attr('id')
			new LORA_DELETE_VIEW( meters_collect.get( cid ) , meters_collect )
			false




# Вид отвечающий за отображение
# Activation by personalisation (ABP)
LORA_COUNTER_ADD_EDIT_MODAL_ACTIVATION_PRES = Backbone.View.extend
	el : "#activation_by_pers"
	template : "#activation_by_pers_tpl"
	initialize : ( model )->
		@model = model

		@model.get('lora_model').get('ABP').on 'change:devAddr' , ()->
			valid = false
			r = new RegExp('([A-F|a-f|0-9]{8})')
			if r.test( @get('devAddr') )
				valid = true

			_action = if valid then "removeClass" else "addClass"
			$('#devAddr_label')[_action]('text-danger')

		@model.get('lora_model').get('ABP').on 'change:appsKey' , ()->
			valid = false
			r = new RegExp('([A-F|a-f|0-9]{32})')
			if r.test( @get('appsKey') )
				valid = true

			_action = if valid then "removeClass" else "addClass"
			$('#appsKey_label')[_action]('text-danger')

		@model.get('lora_model').get('ABP').on 'change:nwksKey' , ()->
			valid = false
			r = new RegExp('([A-F|a-f|0-9]{32})')
			if r.test( @get('nwksKey') )
				valid = true

			_action = if valid then "removeClass" else "addClass"
			$('#nwksKey_label')[_action]('text-danger')



		@render()
	events :
		"keyup #devAddr_input" : (e)->
			@model.get('lora_model').get('ABP').set('devAddress' , parseInt(Number($(e.target).val()).toString(10),16) )

		"keyup #appsKey_input" : (e)->
			@model.get('lora_model').get('ABP').set('appsKey' , $(e.target).val() )

		"keyup #nwksKey_input" : (e)->
			@model.get('lora_model').get('ABP').set('nwksKey' , $(e.target).val() )

	render : ()->
		activation_by_pers_c = _.template( $(@template).html() )
		$( @$el).empty().append( activation_by_pers_c(
			lora_model : @model
		))



# Over-the-air activation (OTAA)
LORA_COUNTER_ADD_EDIT_MODAL_OVER_THE_AIR = Backbone.View.extend
	el : "#over_the_air"
	template : "#over_the_air_tpl"
	initialize : ( model )->
		@model = model
		@render()

		@model.get('lora_model').get('OTAA').on 'change:appEui' , ()->
			valid = false
			r = new RegExp('([A-F|a-f|0-9]{16})')
			if r.test( @get('appEui') )
				valid = true

			_action = if valid then "removeClass" else "addClass"
			$('#AppEUI_label')[_action]('text-danger')


		@model.get('lora_model').get('OTAA').on 'change:appKey' , ()->
			valid = false
			r = new RegExp('([A-F|a-f|0-9]{32})')
			if r.test( @get('appKey') )
				valid = true

			_action = if valid then "removeClass" else "addClass"
			$('#AppKey_label')[_action]('text-danger')


	render : ()->
		over_the_air_c = _.template( $(@template).html() )
		$( @$el).empty().append( over_the_air_c(
			lora_model : @model
		))

	events :
		"keyup #AppEUI_input" : (e)->
			@model.get('lora_model').get('OTAA').set('appEui' , $(e.target).val() )

		"keyup #AppKey_input" : (e)->
			@model.get('lora_model').get('OTAA').set('appKey' , $(e.target).val() )



LORA_COUNTER_ADD_EDIT_MODAL_MAIN_SETTINGS = Backbone.View.extend
	el : "#main_settings"
	template : "#main_settings_tpl"
	initialize : ( model )->
		@model = model
		@render()

		@model.get('lora_model').on 'change:devEui' , ()->
			valid = false
			r = new RegExp('([A-Z|a-z|0-9]{16})')
			if r.test( @get('appKey') )
				valid = true

			_action = if valid then "removeClass" else "addClass"
			$('#DevEUI_label')[_action]('text-danger')


	render : ()->
		over_the_air_c = _.template( $(@template).html() )
		$( @$el).empty().append( over_the_air_c(
			lora_model : @model
		))


	events :
		"keyup #DevEUI_input" : (e)->
			@model.get('lora_model').set('devEui' , $(e.target).val() )
			@model.set('num_serial' , $(e.target).val() )

		"change #changedClass" : (e)->
			@model.get('lora_model').set('class' , $(e.target).val() )
			console.log( @model.get('lora_model').get('class') )

		"keyup #DevName_input" : (e)->
			@model.get('lora_model').set('devName' , $(e.target).val() )
			@model.set('about' , $(e.target).val() )

		"change #changedType" : (e)->
			_device_type = _.find( deviceTypes , { id : Number( $(e.target).val() ) } )

			if typeof _device_type == "undefined"
				_device_type = _.first( deviceTypes )

			_meter_type = meter_types.findWhere( title : _device_type.name )

			@model.get('lora_model').set('device_type' , _device_type.id )
			@model.set('type' , _meter_type.get('id') )
			@model.set('device_type' , _device_type )



# Модальное окно для редактирования , добавления приборов
LORA_COUNTER_ADD_EDIT_MODAL = Backbone.View.extend
	template : "#lora_counter_add_edit"

	initialize : ( model )->
		@model = model
		@render()

		@listenTo @model ,"sync" , ()->
			$(@$el).modal('hide')

	render : ()->
		self = @
		tpl_c = _.template( $(@template).html() )

		@$el = $( tpl_c(
			lora_model : @model
		) ).modal('show')

		$(@$el).on('shown.bs.modal' , ()->
			new LORA_COUNTER_ADD_EDIT_MODAL_ACTIVATION_PRES( self.model )
			new LORA_COUNTER_ADD_EDIT_MODAL_OVER_THE_AIR( self.model )
			new LORA_COUNTER_ADD_EDIT_MODAL_MAIN_SETTINGS( self.model )
		).on('hidden.bs.modal' , ()->
			$(@).remove()
		)

	events :
		"click #expert_sessings_contoller" :(e)->

			action = if $(e.target).find('i').hasClass('fa-chevron-circle-down') then "removeClass" else "addClass"

			$('#expert_sessings')[action]('hide')

			if $(e.target).find('i').hasClass('fa-chevron-circle-down')
				$(e.target).find('i').removeClass('fa-chevron-circle-down')
				.addClass("fa-chevron-circle-up")
			else
				$(e.target).find('i').removeClass('fa-chevron-circle-up')
				.addClass("fa-chevron-circle-down")

			false

		"change #changedClass" :(e)->

			action = if $(e.target).val() == "CLASS_C" then "removeClass" else "addClass"

			$('#classCsettings')[action]('hide')


		"click #save" : ()->

			if !@model.get('id')
				console.log( @model.toJSON() )
				meters_collect.add( @model )
			lora_model_gl.__save_counter( @model )

			false




$(document).ready ()->
	converter_types.fetch()
	meter_types.fetch(success : ()->
		meters_collect.fetch()
		lora_model_gl.fetch()
		new LORA_CHILD_VIEW
	)
	new LORA_H1_VIEW
	new LORA_BREADS_VIEW
	new LORA_PROPERTIES_VIEW
