PLACE_CHILD_COUNT = 10
PLACE_CHILD_PAGE = 1



MODAL_SUCCESS = Backbone.View.extend
	template : '#modal_success_tpl'
	initialize : ( msg )->
		@render( msg )
		@
	
	render : ( msg )->
		swal
			title: msg
			text: ""
			timer: 800
			type: "success"
			showConfirmButton: false



PLACE = Backbone.Model.extend

	defaults :
		id : 0
		title : ''
		place : 0
		type : 1
		bankbook : ""

	url : ()-> '/api/place/' + this.get('id') + "/";

	validate : ()-> "empty_title" if this.get('title') == this.defaults.title




PLACES = Backbone.Collection.extend
	model : PLACE
	url : ()->
		count = PLACE_CHILD_COUNT || 10
		page = PLACE_CHILD_PAGE || 1
		'/api/place/?place=' + place.get('id') + '&page=' + page + '&count=' + count



place = new PLACE id: id
places = new PLACES














# Общий вид наследования на добавление / редактирования
PLACE_EDIT_NEW_VIEW = Backbone.View.extend

	# Какое дествие будет выполнять вид
	# Редактирование
	# Добавление
	action : null


	template : "#place_modal_children_tpl"
	

	model : null


	new_place : null


	modal : null


	initialize : (place)->
		return false if !place?

		@model = place
		tpl = _.template $(@template).html()

		if @model.get('id') is 0
			@.model.set 'title' , $('.page-header').text().trim()

		@new_place = if @.action is "edit" then @model else new PLACE place : @model.get('id')

		@modal = tpl 
			place : @new_place
			place_parent : @model

		@.$el = $(@modal)
		@.render()


	render : ()->
		$(@.$el).modal 'show'
		.on "hide.bs.modal" , ()->
			$("#place_modal_children").remove()



	# Обновляем поля таким путем, потому что модальное окно не перерисовать
	update : (e)->

		type = Number($("#place_change_type").val())

		ident = '#place_kvartira_fields, #place_form_title'
		$( ident )[ if type is 4 then "show" else "hide" ]()

		ident = '#place_bankbook'
		$( ident )[ if type is 2 then "show" else "hide" ]()

		ident = '[name="Title"]'
		$( ident ).closest('.form-group')[ if type is 4 then "hide" else "show" ]()

		if type == 4
			$ "#template_place_view"
			.html ()->
				res = ""
				for i in [0...4]
					res += "<small>" + $('[name="template"]').val() + (i+1) + "</small><br>"
				res += "<small>...</small>"
				res


	message_success : ""

	progress_added_children : 0

	replaceProgress : ()->
		$('.progress')[ if @.progress_added_children % 100 is 0 then "addClass" else "removeClass" ]('hide')
		$('.progress-bar').text(@.progress_added_children + "%")
		$('.progress-bar').css("width" , @.progress_added_children + "%")


	events :
		"change #place_change_type" : (e)->
			@.new_place.set('type' , Number($(e.target).val()) )
			@.update(e)
			false


		"keyup [name='template']" : (e)->
			@.update(e)
			return


		"keyup [name='count_places']" : (e)->
			@.update(e)
			return

		"keyup #place_form_title input[type='title']" : (e)->
			@.new_place.set('title' , $(e.target).val().trim())


		"keyup #place_bankbook input[type='BankBook']" : (e)->
			@.new_place.set('bankbook' , $(e.target).val().trim())


		"click #add_children" : ()->

			@progress_added_children = 0
			@.replaceProgress()
			
			self = @

			if Number( @.new_place.get('type') ) is 4
				@.new_place.set "title" , "~"
			else
				@.new_place.set "title" , $('[name="Title"]').val()

			$('#place_children_container').append(
				$('<div/>').attr('id','place_add_prev').append(
					$('<div/>').addClass('loader').append(
						$('<div/>').addClass('page-preloader-cover').append(
							$('<div/>').addClass('page-preloader__cube page-preloader--cube1')
						).append(
							$('<div/>').addClass('page-preloader__cube page-preloader--cube2')
						).append(
							$('<div/>').addClass('page-preloader__cube page-preloader--cube4')
						).append(
							$('<div/>').addClass('page-preloader__cube page-preloader--cube3')
						).append(
							$('<div/>').css("clear","both")
						)
					)
				).append(
					$('<div/>').addClass('loader_back')
				)
			)

			@.new_place.save null , success : ()->
				
				add_child = ( prefix , point , ost , place_id )->
					place_m = new PLACE 
						place : place_id
						title : prefix + point
						type : 4

					place_m.save null , success : ()->

						self.progress_added_children = 100 / ost * point
						self.replaceProgress()


						if point isnt ost
							add_child( prefix , ++point  , ost , place_id)
						else
							self.new_place.destroy()
							$ "#place_modal_children"
							.modal('hide')
							places.fetch()

				if Number( self.new_place.get('type')) is 4
					if Number( $('[name="count_places"]').val() ) isnt 0
						add_child( $('[name="template"').val(), 1 , Number( $('[name="count_places"]').val() ) , Number( place.get('id') ) )
				else
					$ "#place_modal_children"
					.modal('hide')
				
				if Number( self.new_place.get('type')) isnt 4
					places.trigger("add_place")






# Модальное окно для редактирования места
PLACE_EDIT = PLACE_EDIT_NEW_VIEW.extend
	message_success : "Изменено!"
	action : "edit"




# Модальное окно для добавления места
PLACE_CHILDREN_ACTION = PLACE_EDIT_NEW_VIEW.extend
	message_success : "Добавлено!"
	action : "add"










PLACE_DELETE = Backbone.View.extend
	template : '#modal_delete_tpl'
	modal : null
	initialize : ( place )->
		return false if !place?
		@.model = place
		@.render()
	render : ()->
		self = @
		tpl = _.template $(@template).html()
		@modal = tpl 
			place : @model
		$(@modal).modal 'show'
		.on "click" , "#delete_object" , ()->
			self.model.destroy success : ()->
				$("#modal_delete").modal('hide')
				replace_children()
				# new MODAL_SUCCESS "Удалено!"
		.on "hide.bs.modal" , ()->
			$("#modal_delete").remove()





PLACE_EDIT_CHILDREN = Backbone.View.extend
	el :"#controller_edit_place"
	initialize : (place)->
		return false if !place?
		new PLACE_EDIT place 





PLACE_CHILDREN = Backbone.View.extend
	el : "#place_children_table"
	model : place
	new_place : null
	modal : null
	collection : places
	initialize : ()->
		self = @
		@listenTo places , "add_place" , ()->
			self.collection.fetch success : ()->
				self.render()
				$('#place_add_prev').remove()
		@
	render : ()->
		replace_children()
	events : 
		"click .add_child a" : ()->
			new PLACE_CHILDREN_ACTION @model
			false
		"click .children_delete" : (e)->
			new PLACE_DELETE @.collection.find( "id" : @.getId(e) )
			false
		"click .children_edit" : (e)->
			new PLACE_EDIT_CHILDREN @.collection.find( "id" : @.getId(e) )
			false

	getId : (e) ->
		Number($(e.target).closest('tr').attr('id').replace('children_place_','')).toString()


replace_children = ()->
	$.get "/tpl/" , 
		data : 
			id : place.get('id')
		tpl : "place_children_table"
		count : PLACE_CHILD_COUNT || 10
		page : PLACE_CHILD_PAGE || 1
	, (data)->
		$("#place_children_table").html($(data).find("#place_children_table").html())
		$("#place_children_table").closest('.panel').find('.children_pagination').html($(data).find(".children_pagination").html())



PAGINATION_CHILDREN = Backbone.View.extend
	r_child : ()->
		places.fetch( success : ()-> new PLACE_CHILDREN )
	el : ".children_pagination"
	events : 
		"click .paginator_counter a" : (e)->
			PLACE_CHILD_COUNT =	$(e.target).text().trim()
			replace_children()
			@.r_child()
			false
		"click .paginator_pages a" : (e)->
			PLACE_CHILD_PAGE = $(e.target).text().trim()
			replace_children()
			@.r_child()
			false



PLACE_EDIT_MAIN = Backbone.View.extend
	el :"#controller_edit_place"
	events : 
		"click" : ()->
			new PLACE_EDIT place
			false


PLACE_H1 = Backbone.View.extend
	el : ".container_h1_place"
	model : place
	initialize : ()->
		@.listenTo @.model , "change:title" , @.render
	render : ()->
		$(@.$el).text(@.model.get('title')) 


PLACE_BREADS = PLACE_H1.extend
	el : ".breadcrumb .active"

PLACE_INFO_TABLE = PLACE_H1.extend
	el : ".container_place_name"




PLACE_EDIT_PARAM = Backbone.View.extend
	el : "#place_edit_parameter"
	model : place
	events : 
		"click" : ()->
			@.modal()
			false
	modal : ()->
		self = @

		$.get "/tpl/" ,
			tpl : "place_parameter_data"
			data : [id]
			change_filter_ht : (()->
				Regexp_Water = new RegExp(/(.*)\/water\//)
				Regexp_Heat = new RegExp(/(.*)\/heat\//)
				url = window.location.pathname
				return "AquaCounter" if Regexp_Water.test( url )
				return "HeatCounter" if Regexp_Heat.test( url )
				return "ElectricityCounter"
			)
			, (data)->
				$('body').append( $(data).html() )
				modal = $('#filterParameterData').modal('show')
				.on "click" , ".list-group-item" , (e)->
					$(e.target).closest('a').toggleClass('active')

				.on "click" , "#deselect_all" , ()->
					$('#sortable').find('.list-group-item').removeClass "active"
				
				.on "click" , "#select_all" , ()->
					$('#sortable').find('.list-group-item').addClass "active"

				.on "click" , "#save_filter" , ()->

					Regexp_Water = new RegExp(/(.*)\/water\//)
					Regexp_Heat = new RegExp(/(.*)\/heat\//)

					countget = 0

					url = window.location.pathname

					if Regexp_Water.test( url )
						change_filter_ht = "AquaCounter"
					else if Regexp_Heat.test( url )
						change_filter_ht = "HeatCounter"
					else
						change_filter_ht = "ElectricityCounter"

					$("#sortable").find(".list-group-item").each((i,el)->
						countget += 1
						pid = $(el).attr('id').replace("parameter_filter_","")
						id = self.model.get('id')
						a = if $(el).hasClass("active") then "e" else "d"
						url = "/place/fp/?id=" + id + "&pid=" + pid + "&i=" + (i+1) + "&a=" + a + "&s=&change_filter_ht=" + change_filter_ht
						$.get url , ()->
							countget -= 1
							if countget == 0
								swal
									title: ""
									text: ""
									timer: 800
									type: "success"
									showConfirmButton: false
								$(modal).modal "hide"
								location.reload()
					)
				.on 'hidden.bs.modal', ()->
					$("#filterParameterData").remove()
				
				$( "#sortable" ).sortable()
				$( "#sortable" ).disableSelection()


METERPLACE = Backbone.Model.extend
	defaults :
		id : 0
		meter : 0
		place : 0
		converter : 0
	url	: ()->
		"/api/?object=meterplace&filter=id:" + @.get('id')

METERPLACES	= Backbone.Collection.extend
	model : METERPLACE
	url	: ()->
		"/api/?object=meterplace&filter=place:" + place.get('id')



PALCE_EDIT_METERS = Backbone.View.extend
	el : "#edit_meters",
	
	collection : new METERPLACES
	
	model : place

	initialize : ()->
		@listenTo @collection , "append cut" , @updateTree

	updateTree : (node , core)->
		return false if !core.event? or typeof core.event is "undefined"

		self = @

		core = core

		$(core.event.target).closest('li').addClass "jstree-loading"

		meter = Number( node.id.replace /([^0-9]*)([0-9]*)/g , (_,f,id)-> id )

		if node.state.selected
			# Проверка на дубликаты
			return false if typeof self.collection.findWhere( meter : meter ) isnt "undefined"

			meterplace = new METERPLACE
				meter : meter
				place : Number( @.model.get('id') )
				converter : Number( node.parent.replace /([^0-9]*)([0-9]*)/g , (_,f,id)-> id )
			meterplace.save null , success : ()->
				self.collection.add meterplace
				$(core.event.target).closest('li').removeClass "jstree-loading"
		else
			self.collection.findWhere( meter : meter ).destroy( dataType : 'text' , success : (res)->
				$(core.event.target).closest('li').removeClass "jstree-loading"
			)


	events : 
		"click" : ()->

			self = @

			$.get "/tpl/" ,
				tpl : "place_modal_edit_meters"
				data : [id]
				, (data)->

					$ data
					.modal('show')

					.on 'shown.bs.modal', ()->
						self.tree("converter")

					.on "click" , "#vconverter_tab" , ()->
						self.tree("vconverter")

					.on "click" , "#converter_tab" , ()->
						self.tree("converter")

					.on "click" , "#cconverter_tab" , ()->
						self.tree("cconverter")

					.on 'hidden.bs.modal', ()->
						location.reload()


	tree : (type)->

		opened_nodes = []
		checked_node = []

		@.collection.fetch success : ( collect )->
			for model in collect.toArray()
				opened_nodes.push type + "_tree_" + model.get('converter')
				for ident,i in ["meter_tree_", "cmeter_tree_", "vmeter_tree_"]
					checked_node.push ident + model.get('meter')
			return


		self = @

		tree = $('.meter_place_changed').data('jstree')
		if typeof tree != "undefined" && tree?
			$('.meter_place_changed').jstree(true).destroy()

		$ '.meter_place_changed'
		.jstree
			"core" :
				"check_callback" : ()-> true
				'themes':
					'name': 'proton'
					'responsive': true
				'data' :
					'url' : (node)->
						return "/api/?object=" + type.replace(/(.?)converter_tree_([0-9]*)/g , (_,p)-> p ).replace('converter','') + "meter&tree=true&filter=converter:" + node.id.replace(type + "_tree_",'') if node.id != '#'
						return '/api/?object='+type+'&tree=true'
			view : self
			"checkbox":
				"three_state": false
			"plugins" : [ "json","types","checkbox","sort" ]
			"sort" : (a, b)->
				a1 = @.get_node(a);
				b1 = @.get_node(b);
				return 0 if a1.text == b1.text
				return if a1.text > b1.text then 1 else -1

		.bind 'load_node.jstree', (e,core)->
			core.node.children.map (ee)-> if ee.match /(.?)converter(.*)/ then $("#" + ee+' > a > .jstree-checkbox').remove()
			core.instance.open_node opened_nodes

		.bind 'open_node.jstree', (e,core)->
			if core.node.id.match /(.?)converter(.*)/ then $("#" + core.node.id+' > a > .jstree-checkbox').remove()
			core.instance.select_node checked_node

		.bind 'select_node.jstree'		, (e,core)->
			self.collection.trigger "append" , core.node ,core

		.bind 'deselect_node.jstree'	, (e,core)->
			self.collection.trigger "cut" , core.node , core

			false






PLACE_VIEW_TO_TREE = Backbone.View.extend
	el : "#block_action_place"

	"click #view_to_tree" : ()->
		@.render()
		false

	render : ()->
		self = @
		$.get '/tpl/?tpl=place_modal_to_tree_empty' , data :
			[place.get('id')]
		,(data)->

			data = data

			# Пришло содержимое модального окна - отдаем на отрисовку
			$(data)
			.modal "show"

			# После открытия окна строим дерево
			.on "shown.bs.modal" , ()->
				$(@).find '.modal-body'
				.empty()
				.jstree
					"core" :
						"check_callback" : ()-> true
						"themes" : 
							'name': 'proton'
							'responsive': true
						"data" :
							"url" : (node)->
								u = "/api/place/?jstree&all"
								return if node.id is "#" then u + "&place=" + node.id else u

						"checkbox" :
							"three_state" : false
						"plugins" : ["json","types"]

				# Выделение ноды - надо перейти на нее
				.bind 'select_node.jstree' , ( e, core )->
					return false if core.node.original.a_attr.href is window.location.pathname
					window.location.pathname = core.node.original.a_attr.href
					false

				.bind "load_node.jstree" , ( e, core )->
					self.collection.fetch
						data :
							id : self.model.get 'id'
							parents : true
						success : ( c )->
							c.add self.model
							c.toArray().map( ( p )->
								core.instance.open_node p.get('id')
							)
					false

				# Открытие ноды. Что то делаем...
				.bind "open_node.jstree" , ( e, core )->

					ds = (c, id)->
						c.instance.select_node id
						c.instance.deselect_node "0"

					if core.node.id is self.model.get('id')
						ds core , core.node.id

					core.node.children.map( ( id )->
						if id is self.model.get 'id'
							ds core , id
					)
				.on 'hidden.bs.modal' , ()->
					$(data).remove()


PLACE_EDIT_MAIN_TITLE = Backbone.View.extend
	el : ".page-header"
	events : 
		"click #edit_main_name" : (e)->
			$("#title_view").hide()
			$("#title_edit").show()
			false
		"click #main_title" : ()->

			$.post('/interprise/my/edit/' , name : $('#name_interprise').val() , ( new_name )->
				$('#span_name_interprise').text( new_name )
				$('.breadcrumb').find('.active').text( new_name )
				$('.container_place_name').text( new_name )
			)
			$("#title_view").show()
			$("#title_edit").hide()
			false


$ document
.ready ()->
	place.fetch success : ()->
		new PLACE_CHILDREN
		false
	places.fetch()
	new PAGINATION_CHILDREN
	new PLACE_EDIT_MAIN
	new PLACE_H1
	new PLACE_BREADS
	new PLACE_INFO_TABLE
	new PLACE_EDIT_PARAM
	new PALCE_EDIT_METERS
	new PLACE_VIEW_TO_TREE
	new PLACE_EDIT_MAIN_TITLE
	false
