// Generated by CoffeeScript 1.9.3
(function() {
  var MODAL_ERROR, MODAL_SUCCESS, PLACE, PLACE_BREADCRUMB, PLACE_INFO, chart_title, place_chart;

  MODAL_ERROR = Backbone.View.extend({
    initialize: function(msg) {
      this.render(msg);
      return this;
    },
    render: function(msg) {
      swal({
        title: msg,
        text: "",
        timer: 800,
        type: "error",
        showConfirmButton: false
      });
      return this;
    }
  });

  MODAL_SUCCESS = Backbone.View.extend({
    template: '#modal_success_tpl',
    initialize: function(msg) {
      this.render(msg);
      return this;
    },
    render: function(msg) {
      return swal({
        title: msg,
        text: "",
        timer: 800,
        type: "success",
        showConfirmButton: false
      });
    }
  });

  PLACE = Backbone.Model.extend({
    defaults: {
      id: 0,
      title: '',
      place: 0,
      type: 1,
      bankbook: ""
    },
    url: function() {
      return '/api/place/' + this.get('id') + "/";
    },
    validate: function() {
      if (this.get('title') === this.defaults.title) {
        return "empty_title";
      }
    }
  });

  Array.prototype.min = function() {
    return Math.min.apply(null, this.reduce(function(res, item) {
      if (item) {
        return res.push(item);
      } else {
        return res;
      }
    }, []));
  };

  chart_title = function() {
    var a, prefix, r, r1, r2, r3, w;
    a = new Date();
    r1 = new RegExp(/^(.*)\/archive\/([0-9]*)\/([0-9]*)\/([0-9]*)\/$/);
    r2 = new RegExp(/^(.*)\/archive\/([0-9]*)\/([0-9]*)\/$/);
    r3 = new RegExp(/^(.*)\/archive\/([0-9]*)\/$/);
    prefix = "График потребления эенергии за ";
    w = window.location.pathname;
    if (r1.test(w)) {
      r = r1.exec(w);
      return prefix + r[2] + "-" + r[3] + "-" + r[4];
    } else if (r2.test(w)) {
      r = r2.exec(w);
      return prefix + r[2] + "-" + r[3];
    } else if (r3.test(w)) {
      r = r3.exec(w);
      return prefix + r[2];
    }
    return "";
  };

  place_chart = function(series_1_2, series_1, series_2, id_container) {
    var Chart, series;
    series = [];
    if (series_1_2 && series_1_2.data) {
      series.push(series_1_2);
    }
    if (series_1 && series_1.data.length) {
      series.push(series_1);
    }
    if (series_2 && series_2.data.length) {
      series.push(series_2);
    }
    Chart = Highcharts.chart(id_container, {
      colors: ['#7cb57c', '#a8b4bd', '#2677b5'],
      chart: {
        renderTo: '#container_highcharts',
        type: 'areaspline'
      },
      title: {
        text: ''
      },
      subtitle: {
        text: ''
      },
      xAxis: {
        allowDecimals: false,
        labels: {
          formatter: function() {
            return this.value;
          }
        }
      },
      yAxis: {
        title: {
          text: typeof YAXIS_PLACE_PARAMETERS !== "undefined" && YAXIS_PLACE_PARAMETERS !== null ? "" : YAXIS_PLACE_PARAMETERS
        },
        labels: {
          formatter: function() {
            return this.value / 1000 + 'k';
          }
        },
        min: [series_1_2.data.min(), series_1.data.min(), series_2.data.min()].min()
      },
      tooltip: {
        pointFormat: '{series.name} <br><b>{point.y:,.0f}</b><br/>За {point.x} час'
      },
      title: {
        text: !series_1_2.length && !series_1.data.length && !series_2.data.length ? 'Нет данных для построения графика' : chart_title()
      },
      plotOptions: {
        areaspline: {
          lineColor: '#666666',
          lineWidth: 1,
          pointStart: 1,
          pointInterval: 1,
          marker: {
            enabled: true,
            symbol: 'circle',
            radius: 3,
            states: {
              hover: {
                enabled: true
              }
            }
          }
        }
      },
      series: series
    });
    return Chart;
  };

  PLACE_INFO = Backbone.View.extend({
    el: '#place_item_info',
    model: place,
    initialize: function() {
      this.listenTo(this.model, 'change', this.render);
    },
    render: function() {
      var self;
      self = this;
      return $.get('/tpl/?tpl=place_one_info', {
        data: [this.model.get('id')]
      }, function(d) {
        $("#place_item_info").closest('.panel').replaceWith($(d));
      });
    }
  });

  PLACE_BREADCRUMB = Backbone.View.extend({
    el: '.breadcrumb .active',
    model: place,
    initialize: function() {
      this.listenTo(this.model, 'change', this.render);
    },
    render: function() {
      return $(this.$el).empty().append(this.model.get('title'));
    }
  });

  $(document).ready(function() {
    new PLACE_H1;
    new PLACE_BREADCRUMB;
    new PLACE_INFO;
    new PLACE_INDEX;
    new PLACE_ACTION;
    return false;
  });

}).call(this);
