<?php
/*
  Name            : CRC-16 CCITT
  Poly (default)  : 0x1021    x^16 + x^12 + x^5 + 1
  Init (default)  : 0xFFFF
  XorOut (default): 0x0000
  Revert          : false
  Check           : 0x29B1 ("123456789")
  MaxLen          : 4095 байт (32767 бит) - обнаружение
    одинарных, двойных, тройных и всех нечетных ошибок
*/
function crc16($sStr, $aParams = array()){
 
   //-- устанавливаем значения по умолчанию у незаданных параметров
   $aDefaults = array(
      "polynome" => 0x1021,
      "init" => 0xFFFF,
      "xor_out" => 0,
   );
 
   foreach ($aDefaults as $key => $val){
      if (!isset($aParams[$key])){
         $aParams[$key] = $val;
      }
   }
 
   //-- инициализируем переменные
   $sStr .= "";
   $crc = $aParams['init'];
   $len = strlen($sStr);
   $i = 0;
 
   //-- считаем
   while ($len--){
      $crc ^= ord($sStr[$i++]) << 8;
      $crc &= 0xffff;
      for ($j = 0; $j < 8; $j++){
// printf ("[%02X]", $crc);
         $crc = ($crc & 0x8000) ? ($crc << 1) ^ $aParams['polynome'] : $crc << 1;
         $crc &= 0xffff;
      }
   }
 
   $crc ^= $aParams['xor_out'];
 
   return $crc;
}
//55 00 00 01 00
$str = ""
	.chr( 0x55 )
	.chr( 0x00 )
	.chr( 0x00 )
	.chr( 0x01 )
	.chr( 0x00 )
//	.chr( 0x29 )
//	.chr( 0x2A )
	;
	
$str1 =  /*chr( 0x55 ) .*/ chr( 0x00 ) . chr( 0x00 )	. chr( 0x01 ) . chr( 0x00 );
$str2 =  /*chr( 0x55 ) .*/ chr( 0x01 ) . chr( 0x00 )	. chr( 0x01 ) . chr( 0x00 );
$str3 =  /*chr( 0x55 ) .*/ chr( 0x02 ) . chr( 0x00 )	. chr( 0x01 ) . chr( 0x00 );
$str4 =  /*chr( 0x55 ) .*/ chr( 0x03 ) . chr( 0x00 )	. chr( 0x01 ) . chr( 0x00 );
	

echo bin2hex($str) . '-><br\>' ;
for( $p = 0; $p<0xFFFF; $p++ )
{
//	for( $x = 0; $x<0xFFFF; $x++ )
	{
		$aParams = array(
			"polynome" => $p,
//			"polynome" => 0x8811,
			"xor_out"  => 0x0000,
			"init"     => 0x0000, //0x2824,
		);
		$rez1 = crc16( $str1, $aParams );
		$rez2 = crc16( $str2, $aParams );
		$rez3 = crc16( $str3, $aParams );
		$rez4 = crc16( $str4, $aParams );
		//if( 0x0d03 == $rez )
		{
			printf( "%04x -> %04x, %04x, %04x, %04x<br/>",$aParams["polynome"], $rez1, $rez2 , $rez3 , $rez4 );
		}
	}
}
