<?php
header("Content-type: text/html; charset=utf-8");
//header("Content-type: text/html; charset=windows-1251");

$address="192.168.5.55";
$port=51960;
$n = 1;

function CulcKS( $arPacket, $ltrim, $rtrim )
{
  $ks = 0;
  for( $i=$ltrim; $i<count($arPacket)-1-$rtrim; $i++ )
  {
    $ks = ($ks+$arPacket[$i])&0xff;
    //echo "$ks <br />";
  }
  return $ks;
}

function PacketCreate( $can_num, $PARAM_TYPE, $can_num_by )
{
  $arPacket = Array(
    FORMAT_FT1_2,
    CONTROL_MASK_BIT_PRM,
    $can_num_by,
    CMD_READ_SLAVE_TKON,
    $can_num,
    L($PARAM_TYPE),
    H($PARAM_TYPE),
    0x00,
    FORMAT_FT1_2_END,
  );
  $arPacket[ count($arPacket)-2 ] = CulcKS( $arPacket, 1, 1 );
  $packet = implode( '', array_map( 'chr', $arPacket ) );
  return $packet;
}

function PacketCreateLong( $can_num, $PARAM_TYPE, $can_num_by, $Length, $STAT_INDEX = 0 )
{
  $PktLen = 9;
  $arPacket = Array(
    FORMAT_FT1_2_LONG,
    $PktLen,
    $PktLen,
    FORMAT_FT1_2_LONG,
    CONTROL_MASK_BIT_PRM,
    $can_num_by,
    CMD_READ_SLAVE_TKON_INDEX,
    $can_num,
    L($PARAM_TYPE),
    H($PARAM_TYPE),
    L($STAT_INDEX),
    H($STAT_INDEX),
    $Length,
    0x00,
    FORMAT_FT1_2_END,
  );
  $arPacket[ count($arPacket)-2 ] = CulcKS( $arPacket, 4, 1 );
  $packet = implode( '', array_map( 'chr', $arPacket ) );
  return $packet;
}

  
define( 'CMD_READ_SLAVE_TKON',  0x11 );
define( 'CMD_READ_SLAVE_TKON_INDEX',  0x19 );


define( 'FORMAT_FT1_1',         0x04 );
define( 'FORMAT_FT1_2',         0x10 );
define( 'FORMAT_FT1_2_LONG',    0x68 );
define( 'FORMAT_FT1_2_END',     0x16 );

define( 'CONTROL_MASK_BIT_PRM', 0x40);


define( 'PARAM_TYPE',           0xF000 );
define( 'PARAM_SERIAL',         0xF001 );
define( 'PARAM_REZHIM',         0xF01A );
define( 'PARAM_F01D',           0xF01D );
define( 'PARAM_NAME',           0xF034 );
define( 'PARAM_QUERY',          0xF004 );
define( 'PARAM_QUERY_PARAM',    0xF00A );
define( 'PARAM_QUERY_PARAM_DESCR',0xF00B );

define( 'PARAM_QUERY_NAMES',    0xF029 );

$Algorutms = Array(
  0x01 => Array( 'IN' => 2, 'OUT' => 1,   'CODE' => '0030', 'NAME' => 'X1+X2 -> Y' ),
  0x10 => Array( 'IN' => 4, 'OUT' => 2,   'CODE' => '0190', 'NAME' => 'Расчет температуры с ТСМ\ТСП' ),
  0x11 => Array( 'IN' => 5, 'OUT' => 2,   'CODE' => '0191', 'NAME' => 'Токовый линейный датчик' ),
  0x16 => Array( 'IN' => 5, 'OUT' => 3,   'CODE' => '0194', 'NAME' => 'Ограничение параметра X' ),
  0x17 => Array( 'IN' => 3, 'OUT' => 1,   'CODE' => '0195', 'NAME' => 'Перевод давления в авс МПА' ),
  0x1C => Array( 'IN' => 2, 'OUT' => 1,   'CODE' => '019C', 'NAME' => 'Расчет энтальпии горячей воды' ),
  0x1F => Array( 'IN' => 3, 'OUT' => 3,   'CODE' => '0290', 'NAME' => 'Ввод параметра с плавающей запятой' ),
  0x28 => Array( 'IN' => 5, 'OUT' => 5,   'CODE' => '0218', 'NAME' => 'Расчет расхода воды' ),
  0x2F => Array( 'IN' => 4, 'OUT' => 3,   'CODE' => '0220', 'NAME' => 'Количество тепла в трубопроводе' ),
  0x30 => Array( 'IN' => 7, 'OUT' => 5,   'CODE' => '0221', 'NAME' => 'Тепло в закрытлй водяной системе' ),
  0x31 => Array( 'IN' => 8, 'OUT' => 11,  'CODE' => '0222', 'NAME' => 'Тепло в открытой водяной системе' ),
  0x32 => Array( 'IN' => 1, 'OUT' => 5,   'CODE' => '0200', 'NAME' => 'Время исправной/неиспавной работы' ),
  0x34 => Array( 'IN' => 1, 'OUT' => 11,  'CODE' => '0223', 'NAME' => 'Накопление расхода' ),
  0x35 => Array( 'IN' => 1, 'OUT' => 8+1, 'CODE' => '0224', 'NAME' => 'Усреднение параметра' ),
  0x36 => Array( 'IN' => 1, 'OUT' => 2,   'CODE' => '028A', 'NAME' => 'Интегрирование' ),
  0x37 => Array( 'IN' => 1, 'OUT' => 1,   'CODE' => '0225', 'NAME' => 'Архив месяцем, на 12 месяцев' ),
  0x38 => Array( 'IN' => 1, 'OUT' => 1,   'CODE' => '0226', 'NAME' => 'Архив суток, на 365/6 дней' ),
  0x39 => Array( 'IN' => 1, 'OUT' => 1, '  CODE' => '0227', 'NAME' => 'Ввод параметра с плавающей запятой' ),
  0x42 => Array( 'IN' => 6, 'OUT' => 10,  'CODE' => '02B2', 'NAME' => 'Тепло ГВС сумарной с утечками' ),
  0x67 => Array( 'IN' => 33,'OUT' => 2,   'CODE' => '0299', 'NAME' => 'Объединение 32 бит с сигнализацией' ),

);

function L( $V )
{
  return ( $V & 0xff );
}

function H( $V )
{
  return $V >> 8;
}

function WaitForAnswer( $socket, &$buf )
{
  $ms = 100*1; // wait timeout
  while( $ms-- )
  {
    if( $len = @socket_recvfrom( $socket, $buf, 1500, MSG_DONTWAIT, $from, $port) )
    {
      return $len;
    }
    if( -1 == $len )
    {
      return 0;
    }
    else
    {
//      echo ".";
      usleep(10*1000);
    }
  }
  return 0;
}

function NetBytesDebug( $buf, $len, $ltrim=0 )
{
//  echo $len." ] ";
  for( $i=$ltrim; $i<$len; $i++ )
  {
    echo sprintf("%02X", ord($buf[$i]) )." ";
  }
  echo "<br />";
}


/*
  $socket = socket_create( AF_INET, SOCK_DGRAM, SOL_UDP );
  socket_set_option( $socket, SOL_SOCKET, SO_BROADCAST, 1 );
  socket_set_option( $socket, SOL_SOCKET, SO_KEEPALIVE, 1 );
  socket_bind( $socket, $address, $port );
//  $buf=socket_read($socket,100,PHP_BINARY_READ);
  file_put_contents("logs/cstrike.log","$buf\n",FILE_APPEND);
*/


$can_num    = 0x01;
//$can_num    = 0xF0;
$can_num_by = 0x05;
$socket = socket_create( AF_INET, SOCK_DGRAM, SOL_UDP );

socket_bind( $socket, '0.0.0.0', $port );



echo "Запрос типа прибора<br />";
$packet = PacketCreate( $can_num, PARAM_TYPE, $can_num_by );
socket_sendto( $socket, $packet, strlen($packet), 0, $address, $port);
if( $len = WaitForAnswer( $socket, $buf ) )
  NetBytesDebug( $buf, $len-2, 6 );

die();

echo "Запрос серийного номера<br />";

$packet = PacketCreate( $can_num, PARAM_SERIAL, $can_num_by );
socket_sendto( $socket, $packet, strlen($packet), 0, $address, $port);
if( $len = WaitForAnswer( $socket, $buf ) )
  NetBytesDebug( $buf, $len-2,6 );



    

echo "Стандартное имя очереди<br />";
$packet = PacketCreateLong( $can_num, PARAM_NAME, $can_num_by, 6 );
//NetBytesDebug( $packet, strlen($packet) );
socket_sendto( $socket, $packet, strlen($packet), 0, $address, $port);
if( $len = WaitForAnswer( $socket, $buf ) )
{
  $name1251 = substr( $buf, 6, $len-6-2 );
//  NetBytesDebug( $buf, $len );
  echo "<b>";
  echo mb_convert_encoding( $name1251, 'UTF-8', 'cp1251' );
  echo "</b><br />";
}

echo "Очередь загружаемых задач<br />";
$paramsstart = 0;
for( $i=0; $i<10; $i++ )
{



  $packet = PacketCreateLong( $can_num, PARAM_QUERY, $can_num_by, 1, $i );
  //NetBytesDebug( $packet, strlen($packet) );
  socket_sendto( $socket, $packet, strlen($packet), 0, $address, $port);
  if( $len = WaitForAnswer( $socket, $buf ) )
  {
//    NetBytesDebug( $buf, $len-2,6 );
    $numold = $paramsstart;
    $algoritm = ord($buf[6])+256*ord($buf[7]);
    $paramsstart = ord($buf[8])+256*ord($buf[9]);
    if( 0xFFFF == $algoritm )
      break;

    $packet = PacketCreateLong( $can_num, PARAM_QUERY_NAMES, $can_num_by, 8, $i*8 );
    //NetBytesDebug( $packet, strlen($packet) );
    socket_sendto( $socket, $packet, strlen($packet), 0, $address, $port);
    if( $len = WaitForAnswer( $socket, $buf ) )
    {
  //    NetBytesDebug( $buf, $len-2,6 );
      $name1251 = substr( $buf, 6, $len-6-2 );
      echo "<br /><b>".sprintf( "%02X: ", $i );
      echo mb_convert_encoding( $name1251, 'UTF-8', 'cp1251' );
      echo "</b><br />";
    }
    echo "Алгоритм ".sprintf( "%02X", $algoritm ).", адрес начала параметров +$paramsstart <br />";
    //echo "= <b>".($paramsstart-$numold)."</b><br />" ;
  }
  if( isset($Algorutms[$algoritm]) )
  {
    $Alg = $Algorutms[$algoritm];
    echo $Alg['NAME']."<br />";
    $paramlen = ($Alg['IN']+$Alg['OUT'])/2;
    $packet = PacketCreateLong( $can_num, PARAM_QUERY_PARAM, $can_num_by, $paramlen, $paramsstart/4 );
    //NetBytesDebug( $packet, strlen($packet) );
    socket_sendto( $socket, $packet, strlen($packet), 0, $address, $port);
    if( $len = WaitForAnswer( $socket, $buf ) )
    {
      NetBytesDebug( $buf, $len-2,6 );
      for( $pn=0; $pn<$Alg['IN']*2; $pn += 2 )
      {
        echo sprintf( "Вх %02X%02X<br />", ord($buf[7+$pn]), ord($buf[6+$pn]) );
      }
      for( $pn=$Alg['IN']*2; $pn<$Alg['OUT']*2+$Alg['IN']*2; $pn += 2 )
      {
        echo sprintf( "Вых %02X%02X<br />", ord($buf[7+$pn]), ord($buf[6+$pn]) );
      }
    }
  }
  else
  {
    echo "no info<br />";
  }



}

for( $i=0; $i<102; $i++ )
{
  $packet = PacketCreateLong( $can_num, PARAM_QUERY_PARAM_DESCR, $can_num_by, 10, $i );
  //NetBytesDebug( $packet, strlen($packet) );
  socket_sendto( $socket, $packet, strlen($packet), 0, $address, $port);
  if( $len = WaitForAnswer( $socket, $buf ) )
  {
//  echo "PARAM_QUERY_PARAM_DESCR ";
    NetBytesDebug( $buf, $len-2,6 );
  }
}


?>
