<?php

include('meter-custom.inc.php');

//define( 'CMD_START1', 0x2F );
//define( 'CMD_START2', 0x3F );
#define ( 'ADDR_LENGTH_8BIT', 0x28);
#define ( 'OPT_8BIT_CRC8', 0x28);
define( 'OPT_16BIT_CRC8', 0x48);

define ( 'CLASS_ACCESS_ERROR', 0x07 );


class MeterCE301 extends Meter
{
  public $Converter = null;
  private $Num = '777777';

/*
  private $NumL = 0x02;
  private $NumH = 0x00;
  private $QueryNumL = 0x20; // 0x4E20 = 20000
  private $QueryNumH = 0x4E;
*/
  private $PassB = Array( 0x00, 0x00, 0x00, 0x00 );
  
  function GetClassName()
  { 
    return 'MeterCE301';
  }
  
  static function TestAllPacket( $Buffer, $Len )
  {
    if($Len < 3 )
      return false;

    if( 
      ord($Buffer[$Len-2])== 0x0D 
      AND ord($Buffer[$Len-1])== 0x0A
    )
    {
      return true;
    }

    if( 
          ord( $Buffer[0]     ) == 0x01
      AND ord( $Buffer[3]     ) == 0x02
      AND ord( $Buffer[$Len-2]) == 0x03
    )
    {
      return true;
    }

    if( 
          ord( $Buffer[0]     ) == 0x02
      AND ord( $Buffer[$Len-2]) == 0x03
    )
    {
      return true;
    }

    echo "Not all";
    return false;
  }
  
  function CuclXORCrc( $arPacket, $Length )
  {
    //unsigned char CRC = 0x00;
    $CRC = CRC_INIT;
    for( $i=1; $i< $Length-1 ; $i++)
    {
      $CRC = ($CRC + $arPacket[$i]) & 0x7F;
//    do 
//      $CRC += $arPacket[$Length];
//    while( $Length-- );
    //echo sprintf( '%02X', $arPacket[$i])." ". sprintf( '%02X', $CRC)." <br />";
    }
    //die();
    return $CRC;
  }

  
  function UpdateCRC( &$arPacket )
  {
    $arPacket[ sizeof($arPacket)-1 ] = $this->CuclXORCrc( $arPacket, sizeof($arPacket) );
  }
  
  function QueryPacketLook( )
  {
    $arPacket = Array( 0x2F, 0x3F );
    $this->Num = intval( $this->Num );
    if( $this->Num == 0 )
      $this->Num = '';
    foreach( str_split(trim($this->Num)) as $N  )
    {
      if( ord($N) )
        array_push( $arPacket, ord($N) );
    }

    array_push( $arPacket, 0x21, 0x0D, 0x0A );
    $arPacketA = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') );
    if( !$arPacketA )
      return false;

    return $arPacketA;
  }

  
  function GenerateQueryPacket( $String )
  {
    $arPacket = Array(
      0x01, 0x52, 0x31, 0x02, 
    );
    foreach( str_split($String) as $N  )
      array_push( $arPacket, ord($N) );

    array_push( $arPacket, 0x03, CRC_INIT );
    $this->UpdateCRC( $arPacket );
    return $arPacket;
  }

  function CuclXORCrc2( $arPacket, $Length )
  {
    $CRC = CRC_INIT;
    //for( $S=0; $S< $Length ; $S++)
    $S = 1;
    {
    for( $i=$S; $i< $Length ; $i++)
    {
      $CRC = ($CRC + $arPacket[$i] ) & 0xFF;


//    do 
//      $CRC += $arPacket[$Length];
//    while( $Length-- );


      echo sprintf( '%02X', $arPacket[$i])." ". sprintf( '%02X', $CRC)." <br />";
    }
//      echo "<hr />";
    }
    return $CRC;
  }

  function CheckPacket( $arPacket )
  {
    $CRC = $this->CuclXORCrc( $arPacket, count($arPacket) );






//    echo sprintf( '%02X',$CRC)."=";
//    echo sprintf( '%02X',$arPacket[ count($arPacket)-1 ])."=";
    if( $arPacket[ count($arPacket)-1 ] != $CRC )
      return 0;
    /*
    if( $arPacket[6]>>4 == CLASS_ACCESS_ERROR )
      return -1;
    */
    $Size = count( $arPacket );
    if( $Size > 0 )
      return $Size;
    return 0;
  }
  
  function GetSubType()
  {
    if( !$this->IsLink() )
      return false;
    $arType = $this->QueryPacketLook();
    if( !$arType )
      return false;
    $arType = array_slice( $arType, 1, count($arType)-2 );
    
    $arPacket = Array( 0x06, 0x30, 0x35, 0x31, 0x0D, 0x0A );
    $arPacketA = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') );
    if( !$arPacketA )
      return false;
    return implode( '', array_map( 'chr', $arType) );
      
      
      
      
    $arPacket = $this->GenerateQueryPacket( 'SNUMB()' );

//    return false;
    if($arPacket = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') ) )
    {
      $Size = $this->CheckPacket( $arPacket ); 
      $arPacket = array_slice( $arPacket, 9, $Size );
      //echo PacketDumpReturn( $arPacket );
      return $arPacket;
    }
    else
      return false;
  }
  
  function GetSerialNumber()
  {
    if( !$this->IsLink() )
      return false;

    $arPacket = $this->GenerateQueryPacket( 'SNUMB()' );

//    return false;
    if($arPacket = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') ) )
    {
      $Size = $this->CheckPacket( $arPacket ); 
      //echo $Size;
      $arSerial = array_slice( $arPacket, 7, $Size-12 );
      //echo PacketDumpReturn( $arPacket );
      //return $arPacket;
      return implode( '', array_map( 'chr', $arSerial ) );
    }
    else
      return false;
    
    return false;













    $arPacket = $this->GenerateQueryPacket( Array( 0xD1, 0x01, 0x1A , 0x00 ) );
    if($arPacket1 = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') ) )
    {
      $arPacket = $this->GenerateQueryPacket( Array( 0xD1, 0x01, 0x1A , 0x01 )  );
      if($arPacket2 = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') ) )
      {
        $arSerial = Array();
         //= array_slice( $arPacket1, 9, 8 );
        for( $i=16; $i>=9; $i--)
          if( $arPacket2[$i] >= 32 )
            $arSerial[] = $arPacket2[$i];
        for( $i=16; $i>=9; $i--)
          if( $arPacket1[$i] >= 32 )
            $arSerial[] = $arPacket1[$i];
        $Serial = implode( '', array_map( 'chr', $arSerial ) );
        return $Serial;
      }
      else
        return false;
    }
    else
      return false;
  }
  function GetDatetime()
  {
    if( !$this->IsLink() )
      return false;
      
      
    $arPacket = $this->GenerateQueryPacket( 'TRSUM()' ); // Разрешение перехода на зимнее/летнее время:
    $arPacketA = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') );
    if( !$arPacketA )
      return false;
    
    $arPacket = $this->GenerateQueryPacket( 'STAT_()' ); // Состояние счётчика.
    $arPacketA = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') );
    if( !$arPacketA )
      return false;

    $arPacket = $this->GenerateQueryPacket( 'DATE_()' );
    $arPacketA_D = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') );
    if( !$arPacketA_D )
      return false;

    $arPacket = $this->GenerateQueryPacket( 'TIME_()' );
    $arPacketA_T = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') );
    if( !$arPacketA_T )
      return false;
    
    
          //var_dump( $arPacket );
      $date = new DateTime();
      $date->setDate( 
        2000+ 10*chr($arPacketA_D[16])+chr($arPacketA_D[17]),
        10*chr($arPacketA_D[13])+chr($arPacketA_D[14]),
        10*chr($arPacketA_D[10])+chr($arPacketA_D[11])
      );
      $date->setTime( 
        10*chr($arPacketA_T[7])+chr($arPacketA_T[8]),
        10*chr($arPacketA_T[10])+chr($arPacketA_T[11]),
        10*chr($arPacketA_T[13])+chr($arPacketA_T[14])
      );
      
//      $date = date_create('2001-01-01');
      //echo date_format($date, 'Y-m-d H:i:s') . "\n";
      return $date;
  }
  
  function GetConfigInfo()
  {
    if( !$this->IsLink() )
      return false;
    $arPacket = $this->GenerateQueryPacket( Array( 0xD0, 0x01, 0x01 ) );
    if( $arPacket = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') ) )
    {
      $Size = $this->CheckPacket( $arPacket ); 
      $arPacket = array_slice( $arPacket, 9, $Size );
      echo PacketDumpReturn( $arPacket );
      return $arPacket;
    }
    return false;
  }
  
  function GetTarifNumValue( $TarifNum )
  {
    if( !$this->IsLink() )
      return false;
    if( !in_array( $TarifNum, Array(1,2,3,4) ) )
    {
      return false;
    }
    // SERV_DIRECT_QUERY | SERV_ACCESS_CMD | 0U;
    $arPacket = $this->GenerateQueryPacket( Array( 0xD2, 0x01, 0x30, $TarifNum-1, 0 ) );
    if( $arPacket = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') ) )
    {
      $Size = $this->CheckPacket( $arPacket );
      if( $Size==4)
      {
        $Value =  $arPacket[9] + ($arPacket[10]<<8) + ($arPacket[11]<<16) + ($arPacket[12]<<24);
        return $Value*10;
      }
      
    }
    return false;
  }
  
  function GetPower( $Time )
  {
    if( !$this->IsLink() )
      return false;
    $day   = date( 'j', $Time );
    $month = date( 'n', $Time );
    $year  = date( 'y', $Time );
    $count = 2;
    $inum  = date( 'G', $Time )*$count;
    //echo "\$day=$day \$month=$month \$year=$year \$inum=$inum ";
    //var_dump( array(BCDto($day), BCDto($month), BCDto($year), BCDto($inum), BCDto($count))); 
    $arPacket = $this->GenerateQueryPacket( Array( 0xD5, 0x01, 0x34, BCDto($day), BCDto($month), BCDto($year), BCDto($inum), BCDto($count) ) );
    //echo "<br />".PacketDumpReturn( $arPacket );
    if( $arPacket = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') ) )
    {
      $Size = $this->CheckPacket( $arPacket );
      if( $Size > 0 )
      {
        return -1;
      }
      return -1;
    }
    return false;
  }
  
}


?>
