<?php

include('meter-custom.inc.php');

define( 'START_END', 0xC0 );
#define ( 'ADDR_LENGTH_8BIT', 0x28);
#define ( 'OPT_8BIT_CRC8', 0x28);
define( 'OPT_16BIT_CRC8', 0x48);

define ( 'CLASS_ACCESS_ERROR', 0x07 );


class MeterCE301M extends Meter
{
  public $Converter = null;
  private $NumL = 0x00; //0xD2;
  private $NumH = 0x00; //0x0C;
  private $QueryNumL = 0xEE; // 0x4E20 = 20000
  private $QueryNumH = 0xEE;
  private $PassB = Array( 0x00, 0x00, 0x00, 0x00 );
  private $Mult = 0;
  
  function SetNumber( $Num )
  {
    $this->NumL = $Num & 0xFF;
    $this->NumH = ($Num >> 8) & 0xFF; 
  }
  
  static function TestAllPacket( $Buffer, $Len )
  {
    if($Len < 3 )
      return false;

    if( 
      ord($Buffer[0])== 0xC0 
      AND ord($Buffer[$Len-1])== 0xC0
    )
    {
      return true;
    }
    return false;
  }
  
  function GetClassName()
  {
    return 'MeterCE301M';
  }
  
  function CulcCRC8( &$Buffer, $Length )
  {
    $crc8tab = Array(
      0x00, 0xb5, 0xdf, 0x6a, 0x0b, 0xbe, 0xd4, 0x61,  0x16, 0xa3, 0xc9, 0x7c, 0x1d, 0xa8, 0xc2, 0x77, // 16
      0x2c, 0x99, 0xf3, 0x46, 0x27, 0x92, 0xf8, 0x4d,  0x3a, 0x8f, 0xe5, 0x50, 0x31, 0x84, 0xee, 0x5b,
      0x58, 0xed, 0x87, 0x32, 0x53, 0xe6, 0x8c, 0x39,  0x4e, 0xfb, 0x91, 0x24, 0x45, 0xf0, 0x9a, 0x2f,
      0x74, 0xc1, 0xab, 0x1e, 0x7f, 0xca, 0xa0, 0x15,  0x62, 0xd7, 0xbd, 0x08, 0x69, 0xdc, 0xb6, 0x03,
      0xb0, 0x05, 0x6f, 0xda, 0xbb, 0x0e, 0x64, 0xd1,  0xa6, 0x13, 0x79, 0xcc, 0xad, 0x18, 0x72, 0xc7,
      0x9c, 0x29, 0x43, 0xf6, 0x97, 0x22, 0x48, 0xfd,  0x8a, 0x3f, 0x55, 0xe0, 0x81, 0x34, 0x5e, 0xeb,
      0xe8, 0x5d, 0x37, 0x82, 0xe3, 0x56, 0x3c, 0x89,  0xfe, 0x4b, 0x21, 0x94, 0xf5, 0x40, 0x2a, 0x9f,
      0xc4, 0x71, 0x1b, 0xae, 0xcf, 0x7a, 0x10, 0xa5,  0xd2, 0x67, 0x0d, 0xb8, 0xd9, 0x6c, 0x06, 0xb3,
      0xd5, 0x60, 0x0a, 0xbf, 0xde, 0x6b, 0x01, 0xb4,  0xc3, 0x76, 0x1c, 0xa9, 0xc8, 0x7d, 0x17, 0xa2,
      0xf9, 0x4c, 0x26, 0x93, 0xf2, 0x47, 0x2d, 0x98,  0xef, 0x5a, 0x30, 0x85, 0xe4, 0x51, 0x3b, 0x8e,
      0x8d, 0x38, 0x52, 0xe7, 0x86, 0x33, 0x59, 0xec,  0x9b, 0x2e, 0x44, 0xf1, 0x90, 0x25, 0x4f, 0xfa,
      0xa1, 0x14, 0x7e, 0xcb, 0xaa, 0x1f, 0x75, 0xc0,  0xb7, 0x02, 0x68, 0xdd, 0xbc, 0x09, 0x63, 0xd6,
      0x65, 0xd0, 0xba, 0x0f, 0x6e, 0xdb, 0xb1, 0x04,  0x73, 0xc6, 0xac, 0x19, 0x78, 0xcd, 0xa7, 0x12,
      0x49, 0xfc, 0x96, 0x23, 0x42, 0xf7, 0x9d, 0x28,  0x5f, 0xea, 0x80, 0x35, 0x54, 0xe1, 0x8b, 0x3e,
      0x3d, 0x88, 0xe2, 0x57, 0x36, 0x83, 0xe9, 0x5c,  0x2b, 0x9e, 0xf4, 0x41, 0x20, 0x95, 0xff, 0x4a,
      0x11, 0xa4, 0xce, 0x7b, 0x1a, 0xaf, 0xc5, 0x70,  0x07, 0xb2, 0xd8, 0x6d, 0x0c, 0xb9, 0xd3, 0x66 
    );

//    unsigned char* BufferU = (unsigned char*)Buffer;
    $crc8 = 0 ;
    //var_dump($Buffer);
    for( $i=1; $i < $Length-2; $i++ )
    {
      //echo $i."->".hex($Buffer[$i])."->".hex($crc8 ^ $Buffer[$i])."->".hex($crc8tab[ $crc8 ^ $Buffer[$i] ])."<br />";
      $crc8 = $crc8tab[ $crc8 ^ $Buffer[$i]];
    }
    return $crc8;
  }
  
  function UpdateCRC( &$arPacket )
  {
    $arPacket[ sizeof($arPacket)-2 ] = $this->CulcCRC8( $arPacket, sizeof($arPacket) );
  }
  
  function GenerateQueryPacket( $Bytes )
  {
    $arPacket = Array(
      START_END,
      OPT_16BIT_CRC8
    );
    array_push( $arPacket, $this->NumL, $this->NumH );
    array_push( $arPacket, $this->QueryNumL, $this->QueryNumH );
    array_push( $arPacket, $this->PassB[0], $this->PassB[1], $this->PassB[2], $this->PassB[3] );
    foreach( $Bytes as $Byte ) 
      array_push( $arPacket, $Byte );
    array_push( $arPacket, CRC_INIT, START_END );
    $this->UpdateCRC( $arPacket );
    return $arPacket;
  }
  
  function CheckPacket( $arPacket )
  {
    $CRC = $this->CulcCRC8( $arPacket, count($arPacket) );
    if( $arPacket[ count($arPacket)-2 ] != $CRC )
      return 0;
    if( $arPacket[6]>>4 == CLASS_ACCESS_ERROR )
      return -1;
    $Size = $arPacket[6] % 16;
    if( $Size > 0 )
      return $Size;
    return 0;
  }
  
  function GetSubType()
  {
    if( !$this->IsLink() )
      return false;
    $arPacket = $this->GenerateQueryPacket( Array(0xD0, 0x01, 0x00) );
    if($arPacket = $this->Converter->Send( $arPacket, Array( $this->GetClassName(), 'TestAllPacket') ) )
    {
      $Size = $this->CheckPacket( $arPacket ); 
      $arPacket = array_slice( $arPacket, 9, $Size );
      //echo PacketDumpReturn( $arPacket );
      return $arPacket;
    }
    else
      return false;
  }
  
  function GetSerialNumber()
  {
    if( !$this->IsLink() )
      return false;
    $arPacket = $this->GenerateQueryPacket( Array( 0xD1, 0x01, 0x1A , 0x00 ) );
    if($arPacket1 = $this->Converter->Send( $arPacket, Array( $this->GetClassName(), 'TestAllPacket') ) )
    {
      $arPacket = $this->GenerateQueryPacket( Array( 0xD1, 0x01, 0x1A , 0x01 )  );
      if($arPacket2 = $this->Converter->Send( $arPacket, Array( $this->GetClassName(), 'TestAllPacket') ) )
      {
        $arSerial = Array();
         //= array_slice( $arPacket1, 9, 8 );
        for( $i=16; $i>=9; $i--)
          if( $arPacket2[$i] >= 32 )
            $arSerial[] = $arPacket2[$i];
        for( $i=16; $i>=9; $i--)
          if( $arPacket1[$i] >= 32 )
            $arSerial[] = $arPacket1[$i];
        $Serial = implode( '', array_map( 'chr', $arSerial ) );
        return $Serial;
      }
      else
        return false;
    }
    else
      return false;
  }
  function GetDatetime()
  {
    if( !$this->IsLink() )
      return false;
    // SERV_DIRECT_QUERY | SERV_ACCESS_CMD | 0U;
    $arPacket = $this->GenerateQueryPacket( Array( 0xD0, 0x01, 0x20 ) );
    if($arPacket = $this->Converter->Send( $arPacket, Array( $this->GetClassName(), 'TestAllPacket') ) )
    {
      //var_dump( $arPacket );
      $date = new DateTime();
      $date->setDate( 
        2000+BCDfrom( $arPacket[9+6] ),
        BCDfrom( $arPacket[9+5] ),
        BCDfrom( $arPacket[9+4] )
      );
      $date->setTime( 
        BCDfrom( $arPacket[9+2] ),
        BCDfrom( $arPacket[9+1] ),
        BCDfrom( $arPacket[9+0] )
      );
      
//      $date = date_create('2001-01-01');
      //echo date_format($date, 'Y-m-d H:i:s') . "\n";
      return $date;
    }
    return false;
  }
  
  function GetConfigInfo()
  {
    if( !$this->IsLink() )
      return false;
    $arPacket = $this->GenerateQueryPacket( Array( 0xD0, 0x01, 0x01 ) );
    if( $arPacket = $this->Converter->Send( $arPacket, Array( $this->GetClassName(), 'TestAllPacket') ) )
    {
      $Size = $this->CheckPacket( $arPacket ); 
      $arPacket = array_slice( $arPacket, 9, $Size );
      echo PacketDumpReturn( $arPacket );

      switch( $arPacket[0] & 0x03 )
      {
        case 0x00: $this->Mult = 1000; echo "00000000";
          break;
        case 0x01: $this->Mult =  100; echo "0000000.0";
          break;
        case 0x02: $this->Mult =   10; echo "000000.00";
          break;
        case 0x03: $this->Mult =    1; echo "00000.000";
          break;
      }

      return $arPacket;
    }
    return false;
  }
  
  function GetTarifNumValue( $TarifNum )
  {
    if( !$this->IsLink() )
      return false;
    if( !in_array( $TarifNum, Array(1,2,3,4) ) )
    {
      return false;
    }
    // SERV_DIRECT_QUERY | SERV_ACCESS_CMD | 0U;
    $arPacket = $this->GenerateQueryPacket( Array( 0xD2, 0x01, 0x30, $TarifNum-1, 0 ) );
    if( $arPacket = $this->Converter->Send( $arPacket, Array( $this->GetClassName(), 'TestAllPacket') ) )
    {
      $Size = $this->CheckPacket( $arPacket );
      if( $Size==4)
      {
        $Value =  $arPacket[9] + ($arPacket[10]<<8) + ($arPacket[11]<<16) + ($arPacket[12]<<24);
        return $Value*10;
      }
      
    }
    return false;
  }
  
  function GetPower( $Time )
  {
    if( !$this->IsLink() )
      return false;
    $day   = date( 'j', $Time );
    $month = date( 'n', $Time );
    $year  = date( 'y', $Time );
    $count = 2;
    $inum  = date( 'G', $Time )*$count;
    //echo "\$day=$day \$month=$month \$year=$year \$inum=$inum ";
//    var_dump( array(BCDto($day), BCDto($month), BCDto($year), $inum, BCDto($count))); 
    $arPacket = $this->GenerateQueryPacket( Array( 0xD5, 0x01, 0x34, BCDto($day), BCDto($month), BCDto($year), $inum, BCDto($count) ) );
    //echo "<br />".PacketDumpReturn( $arPacket );
    if( $arPacket = $this->Converter->Send( $arPacket, Array( $this->GetClassName(), 'TestAllPacket') ) )
    {
      $Size = $this->CheckPacket( $arPacket );
      if( $Size == 6 )
      {
        $Power 
          = $this->Mult * ( ( $arPacket[9] | $arPacket[10]<<8 | $arPacket[11]<<16 )
          + ( $arPacket[12] | $arPacket[13]<<8 | $arPacket[14]<<16 ) );
        
        return $Power ;
      }
      return -1;
    }
    return false;
  }
  
}


?>
