<?php

include('meter-custom.inc.php');

//define( 'CMD_START1', 0x2F );
//define( 'CMD_START2', 0x3F );
#define ( 'ADDR_LENGTH_8BIT', 0x28);
#define ( 'OPT_8BIT_CRC8', 0x28);
define( 'OPT_16BIT_CRC8', 0x48);

define ( 'CLASS_ACCESS_ERROR', 0x07 );


define ( 'CMD_ANSWER_START'   , 0x7E );
define ( 'CMD_END_CR'         , 0x0D );

//define( 'CRC16POLYN', 0x1021 );
//define( 'CRC16POLYI', 0x8408 );
define( 'CRC16POLYI', 0xA001 );

class MeterPSCH3TM extends Meter
{
  public $Converter = null;
//  private $Number = '784';
//  private $Number = '032';

  private $Number = '0'; // 04002152
  
  
//    04002032  
  // 195.58.7.169
  private $Password = '00000';

/*
  private $NumL = 0x02;
  private $NumH = 0x00;
  private $QueryNumL = 0x20; // 0x4E20 = 20000
  private $QueryNumH = 0x4E;
*/
  private $PassB = Array( 0x00, 0x00, 0x00, 0x00 );
  
  function GetClassName()
  { 
    return 'MeterPSCH3TM';
  }
  
  static function TestAllPacket( $Buffer, $Length )
  {
    if( $Length<4 )
      return false;
		// Проверка CRC
    $arPacket = array_map( 'ord', str_split( $Buffer ) );
		$crc_num = MeterPSCH3TM::CRC16Inverse( $arPacket, $Length-2 );
		if( 
			   $arPacket[$Length-2] != ($crc_num & 0xFF)
			or $arPacket[$Length-1] != ($crc_num >> 8)
		)
		{
			return false;
		}
		// Статус ответа
		if( $Length == 4 )
		switch( $arPacket[1] & 0x0F ){
			case 0x00: break; // Все номарльно
			case 0x01: echo "Недопустимая команда или параметр<br/>"; break;
			case 0x02: echo "Внутренняя ошибка счетчика<br/>"; break;
			case 0x03: echo "Недостаточен уровень доступа для запроса<br/>"; break;
			case 0x04: echo "Внутренние часы уже корректировались, в течени суток<br/>"; break;
			case 0x05: echo "Канал чтения не открыт<br/>"; break;
			default: 
				printf( "Код ошибки: 0x%02X", $arPacket[1] );
		}
    return true;
  }
  

function CRC16Normal( $arPacket, $Length ) {
  $result = 0xFFFF;
  if ( $Length > 0) {
      for ($offset = 0; $offset < $Length; $offset++) {
          $result ^= (ord($arPacket[$offset]) << 8);
          for ($bitwise = 0; $bitwise < 8; $bitwise++) {
              if (($result <<= 1) & 0x10000) $result ^= CRC16POLYN;
              $result &= 0xFFFF; /* gut the overflow as php has no 16 bit types */
          }
      }
  }
  return $result;
}
 
static function CRC16Inverse( $arPacket, $Length ) {
    $result = 0xFFFF;
    if ( $Length > 0) {
        for ($offset = 0; $offset < $Length; $offset++) {
            $result ^= $arPacket[$offset];
            for ($bitwise = 0; $bitwise < 8; $bitwise++) {
                $lowBit = $result & 0x0001;
                $result >>= 1;
                if ($lowBit) $result ^= CRC16POLYI;
            }
        }
    }
    return $result;
}


function CulcCRC( &$arPacket, $Length )
{
  $crc_num = $this->CRC16Inverse( $arPacket, $Length );
  $arPacket[] = $crc_num  & 0xFF;
  $arPacket[] = $crc_num >> 8 ;
}


  
  function UpdateCRC( &$arPacket )
  {
    $this->CulcCRC( $arPacket, count($arPacket) );
  }
  
  function QueryPacketLook( )
  {
    $arPacket = Array( 0x2F, 0x3F );
    $this->Num = intval( $this->Num );
    if( $this->Num == 0 )
      $this->Num = '';
    foreach( str_split(trim($this->Num)) as $N  )
    {
      if( ord($N) )
        array_push( $arPacket, ord($N) );
    }

    array_push( $arPacket, 0x21, 0x0D, 0x0A );
    $arPacketA = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') );
    if( !$arPacketA )
      return false;


    return $arPacketA;
  }

  
  function GenerateQueryPacket( $arPacket )
  {
    $this->UpdateCRC( $arPacket );
    return $arPacket;
  }

  function CuclXORCrc2( $arPacket, $Length )
  {
    $CRC = CRC_INIT;
    //for( $S=0; $S< $Length ; $S++)
    $S = 1;
    {
    for( $i=$S; $i< $Length ; $i++)
    {
      $CRC = ($CRC + $arPacket[$i] ) & 0xFF;


//    do 
//      $CRC += $arPacket[$Length];
//    while( $Length-- );


      echo sprintf( '%02X', $arPacket[$i])." ". sprintf( '%02X', $CRC)." <br />";
    }
//      echo "<hr />";
    }
    return $CRC;
  }

  function CheckPacket( $arPacket )
  {
    $CRC = $this->CuclXORCrc( $arPacket, count($arPacket) );






//    echo sprintf( '%02X',$CRC)."=";
//    echo sprintf( '%02X',$arPacket[ count($arPacket)-1 ])."=";
    if( $arPacket[ count($arPacket)-1 ] != $CRC )
      return 0;
    /*
    if( $arPacket[6]>>4 == CLASS_ACCESS_ERROR )
      return -1;
    */
    $Size = count( $arPacket );
    if( $Size > 0 )
      return $Size;
    return 0;
  }
  
  function GetSubType()
  {
    if( !$this->IsLink() )
      return false;
    // #АААППППП21crc1crc2<CR> 
    
    


    $arPacket = $this->GenerateQueryPacket( array(0x00, 0x00) ); // look 

		// авторизация
    $arPacket = $this->GenerateQueryPacket( array(0x00, 0x01, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30 ) );
    $arPacketA = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') );
    if( !$arPacketA )
      return false;

    $arPacket = $this->GenerateQueryPacket( array(0x00, 0x08, 0x12) );
    $arPacketA = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') );
    if( !$arPacketA )
      return false;
		if( count($arPacketA) != 6 )
			return false;

    return array_slice( $arPacketA, 1, 3 );
		
		
//    $arPacket = array( 0x00, 0x00, 0x01, 0xB0 );

  }
  
  function GetSerialNumber()
  {
    if( !$this->IsLink() )
      return false;

    $arPacket = $this->GenerateQueryPacket( 'S' );
    $arPacketA = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') );
    if( !$arPacketA )
      return false;
    $arSerial =  array_slice( $arPacketA, 10, 8 );

    $Serial = implode( '', array_map( 'chr', $arSerial ) );
    return $Serial;
 












    $arPacket = $this->GenerateQueryPacket( Array( 0xD1, 0x01, 0x1A , 0x00 ) );
    if($arPacket1 = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') ) )
    {
      $arPacket = $this->GenerateQueryPacket( Array( 0xD1, 0x01, 0x1A , 0x01 )  );
      if($arPacket2 = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') ) )
      {
        $arSerial = Array();
         //= array_slice( $arPacket1, 9, 8 );
        for( $i=16; $i>=9; $i--)
          if( $arPacket2[$i] >= 32 )
            $arSerial[] = $arPacket2[$i];
        for( $i=16; $i>=9; $i--)
          if( $arPacket1[$i] >= 32 )
            $arSerial[] = $arPacket1[$i];
        $Serial = implode( '', array_map( 'chr', $arSerial ) );
        return $Serial;
      }
      else
        return false;
    }
    else
      return false;
  }
  function GetDatetime()
  {
    if( !$this->IsLink() )
      return false;
      
      
    $arPacket = $this->GenerateQueryPacket( 'TRSUM()' ); // Разрешение перехода на зимнее/летнее время:
    $arPacketA = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') );
    if( !$arPacketA )
      return false;
    
    $arPacket = $this->GenerateQueryPacket( 'STAT_()' ); // Состояние счётчика.
    $arPacketA = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') );
    if( !$arPacketA )
      return false;

    $arPacket = $this->GenerateQueryPacket( 'DATE_()' );
    $arPacketA_D = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') );
    if( !$arPacketA_D )
      return false;

    $arPacket = $this->GenerateQueryPacket( 'TIME_()' );
    $arPacketA_T = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') );
    if( !$arPacketA_T )
      return false;
    
    
          //var_dump( $arPacket );
      $date = new DateTime();
      $date->setDate( 
        2000+ 10*chr($arPacketA_D[16])+chr($arPacketA_D[17]),
        10*chr($arPacketA_D[13])+chr($arPacketA_D[14]),
        10*chr($arPacketA_D[10])+chr($arPacketA_D[11])
      );
      $date->setTime( 
        10*chr($arPacketA_T[7])+chr($arPacketA_T[8]),
        10*chr($arPacketA_T[10])+chr($arPacketA_T[11]),
        10*chr($arPacketA_T[13])+chr($arPacketA_T[14])
      );
      
//      $date = date_create('2001-01-01');
      //echo date_format($date, 'Y-m-d H:i:s') . "\n";
      return $date;
  }
  
  function GetConfigInfo()
  {
    if( !$this->IsLink() )
      return false;
    $arPacket = $this->GenerateQueryPacket( Array( 0xD0, 0x01, 0x01 ) );
    if( $arPacket = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') ) )
    {
      $Size = $this->CheckPacket( $arPacket ); 
      $arPacket = array_slice( $arPacket, 9, $Size );
      echo PacketDumpReturn( $arPacket );
      return $arPacket;
    }
    return false;
  }
  
  function GetTarifNumValue( $TarifNum )
  {
    if( !$this->IsLink() )
      return false;
    if( !in_array( $TarifNum, Array(1,2,3,4) ) )
    {
      return false;
    }
    // SERV_DIRECT_QUERY | SERV_ACCESS_CMD | 0U;
    $arPacket = $this->GenerateQueryPacket( Array( 0xD2, 0x01, 0x30, $TarifNum-1, 0 ) );
    if( $arPacket = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') ) )
    {
      $Size = $this->CheckPacket( $arPacket );
      if( $Size==4)
      {
        $Value =  $arPacket[9] + ($arPacket[10]<<8) + ($arPacket[11]<<16) + ($arPacket[12]<<24);
        return $Value*10;
      }
      
    }
    return false;
  }
  
  function GetPower( $Time )
  {
    if( !$this->IsLink() )
      return false;
    $day   = date( 'j', $Time );
    $month = date( 'n', $Time );
    $year  = date( 'y', $Time );
    $count = 2;
    $inum  = date( 'G', $Time )*$count;
    //echo "\$day=$day \$month=$month \$year=$year \$inum=$inum ";
    //var_dump( array(BCDto($day), BCDto($month), BCDto($year), BCDto($inum), BCDto($count))); 
    $arPacket = $this->GenerateQueryPacket( Array( 0xD5, 0x01, 0x34, BCDto($day), BCDto($month), BCDto($year), BCDto($inum), BCDto($count) ) );
    //echo "<br />".PacketDumpReturn( $arPacket );
    if( $arPacket = $this->Converter->Send( $arPacket, Array($this->GetClassName(), 'TestAllPacket') ) )
    {
      $Size = $this->CheckPacket( $arPacket );
      if( $Size > 0 )
      {
        return -1;
      }
      return -1;
    }
    return false;
  }
  
}


?>
