<?php
header("Content-type: text/html; charset=utf-8");

define( 'OK',                    0 );
define( 'ERROR_SOCKET_CREATE',   1 );
define( 'ERROR_CONNECT_REFUSED', 2 );
define( 'ERROR_CONNECT_TIMEOUT', 3 );

define( 'CRC_INIT', 0x00 );


class converter{
  public $ip = '192.168.5.51';
  public $port = 50000;
  private $socket = null;
  public $LastError = OK;
  private $IsConnected = false;
  public $debug = false;
  public $debugnet = true;
  
  function Log( $Text, $EndOfLine = false )
  {
//    if( !$this->debug ) return;
    echo $Text;
    if( $EndOfLine )
      echo "<br />\n";
  }
  
  function NetLog( $arPacket, $IsIncome=0 )
  {
    if( !$this->debugnet ) return;
    if( $IsIncome )
      echo "<div style='color:blue'>&lt- ";
    else
      echo "<div style='color:red'> -&gt ";
    echo date( " H:i:s." ).round(microtime()*1000)." ".PacketDumpReturn( $arPacket )."</div>";
    flush();
  }

  function Disconnect()
  {
    $this->CloseSocket();
  }
  
  function CloseSocket()
  {
    if( !$this->socket )
      socket_close( $this->socket );
    $this->socket = null;
    $this->IsConnected = false;
  }
  
  function IsConnected()
  {
    return $this->IsConnected;
  }
  
  function CulcCRC( $arPacket )
  {
//    unsigned char* BufferU = (unsigned char*)Buffer;
//    unsigned char crc8 = 0 ;
    $crc = 0x00;
//    int i;
    for( $i=0; $i<count($arPacket); $i++)
    {
      $crc = ( ( $crc + $arPacket[$i]) & 0xFF );
    //echo $crc."<br />";
    }
//    echo $crc;
//    die();
    return (0xFF - $crc);
    //*crc8s = 256 - crc8;
  }
  function Setup( $arParams )
  {
/*

  struct packet
  {
    DWORD Start;
    char not1; // use costom boundrate?
    char CharacterBits ;
    char ParityType;
    char StopBit;
    char FlowControl;
    char not2[5];
    WORD Baudrate;
    char not3[52];
    WORD End;
    char crc;    
  };

*/

    $arPacket = Array( 0xFA, 0xFA, 0x00, 0xFA ); // Start

    switch( $arParams['Baudrate'] ) //not1
    {
      // Известно только 2400 и 9600 остальное предположение
//    case  1200 : array_push( $arPacket, 0x03 ); break;
      case  2400 : array_push( $arPacket, 0x04 ); break;
//    case  4800 : array_push( $arPacket, 0x05 ); break;
      case  9600 : array_push( $arPacket, 0x06 ); break;
//    case 19200 : array_push( $arPacket, 0x07 ); break;
//    case 38400 : array_push( $arPacket, 0x08 ); break;
      default:
        echo "Unknown Baudrate setup";
        return false;
    }
    $Bits = ( $arParams['Bits']-5 );
    if( $Bits<0 or $Bits>4 )
      return false;
    array_push( $arPacket, $Bits ); // CharacterBits
    $arParams['Parity'] = strtolower( $arParams['Parity'] );


    switch( $arParams['Parity'] )// ParityType
    {
      case  'none' : array_push( $arPacket, 0x00 ); break;
      case   'odd' : array_push( $arPacket, 0x01 ); break;
      case  'even' : array_push( $arPacket, 0x02 ); break;
      case  'mark' : array_push( $arPacket, 0x03 ); break;
      case 'space' : array_push( $arPacket, 0x04 ); break;
      default:
        echo "Unknown Parity setup";
        return false;
    }
    
    switch( $arParams['StopBits'] )// StopBit
    {
      case '1' : array_push( $arPacket, 0x00 ); break;
      case '2' : array_push( $arPacket, 0x01 ); break;
      default:
        echo "Unknown StopBits setup";
        return false;
    }
    array_push( $arPacket, 0x00 ); // FlowControl

    array_push( $arPacket, 0x00, 0x00, 0x00, 0x00, 0x00 ); // not2[5];

    $BaudrateL = $arParams['Baudrate'] & 0xFF;
    $BaudrateH = ($arParams['Baudrate'] >> 8 ) & 0xFF;
    array_push( $arPacket, $BaudrateL, $BaudrateH ); // Baudrate
    
    for( $i=0; $i<52; $i++ )
      $arPacket[] = 0x00;

    $arPacket[] = 0xFB;
    $arPacket[] = 0xFB;

    $arPacket[] = $this->CulcCRC( $arPacket );
    
    $Length = count( $arPacket );
    //$this->NetLog( $arPacket );
    $Rez = socket_write( 
      $this->socket,
      implode( '', array_map( 'chr', $arPacket ) ),
      $Length
    );
    if( $Length != $Rez )
      return false;
    
    return true;
  }
  
  function Connect()
  {
    $this->LastError = OK;
    if( !$this->socket ) 
    {
      $this->socket = socket_create( AF_INET, SOCK_STREAM, SOL_TCP );
    }
    if ( $this->socket === false )
    {
      $this->LastError = ERROR_SOCKET_CREATE;
      return false;
    }

    socket_set_nonblock( $this->socket );
  
    $this->Log( "Содение c {$this->ip}:{$this->port} .." );
    $rez = @socket_connect( $this->socket, $this->ip, $this->port );
    //socket_set_block( $socket );
    $sockets_all = array( $this->socket );
    $r = $sockets_all; $w = $sockets_all; $f = $sockets_all;
    switch( socket_select( $r, $w, $f, $time_out_sec = 3  ) )
    {
      case 2:
        $this->Log( "Отказ", true );
        $this->LastError = ERROR_CONNECT_REFUSED;
        $this->CloseSocket();
        return false;
        break;
      case 1:
        $this->IsConnected = true;
        $this->Log( "Ok", true );
        break;
      case 0:
        $this->Log( "Таймаут соединения {$time_out_sec} сек", true );
        $this->LastError = ERROR_CONNECT_TIMEOUT;
        return false;
        break;
    }
    return true;
  }
  
  function Send( $arPacket, $funcTestPacketReady )
  {
    //echo "<div style='color:red'> -&gt ".date( " H:i:s." ).round(microtime()*1000)." ".PacketDumpReturn( $arPacket )."</div>";
      $this->NetLog( $arPacket, 0 );
    $Length = count( $arPacket );
    $Rez = socket_write( 
      $this->socket,
      implode( '', array_map( 'chr', $arPacket ) ),
      $Length
    );
    if( $Length != $Rez )
      return false;

    $lastAccess = time();
    $sockets_all = Array( $this->socket );
    $r = $sockets_all;
    $w = $sockets_all;
    $f = $sockets_all;
    $packet = '';
    $Length = 0;
    $data = '';
    $ReadTimeOut =2; // min 2sec
    while( socket_select( $r,$w, $f , $time_out_sec = 3  ) !== FALSE )
    {
      //if( in_array( $this->socket, $r ) )
      //{
        while ( $InLength = @socket_recv( $this->socket, $data, 1024, 0 ) )
        {
          $packet .= $data;
          $Length += $InLength;
          //echo $InLength.": ".$data."<br />\n"; flush();
          
        }
      //}
      
      //echo "<!-- 1234567890 -->\n";
//      call_user_func( array( 'MeterCE102', 'TestAllPacket' ) );
      if( (time()-$lastAccess > $ReadTimeOut) or call_user_func( $funcTestPacketReady, $packet, $Length) )
      {
        if( time()-$lastAccess > $ReadTimeOut )
          echo "Read TimeOut {$ReadTimeOut} sec";
        break;
      }
      usleep(50);
    }
    //echo $Length; 
    if( $Length )
    {
      $arPacket = array_map( 'ord', str_split( $packet ) );
      $this->NetLog( $arPacket, 1 );
//      echo "<div style='color:blue'> &lt- ".date( " H:i:s." ).round(microtime()*1000)." ".PacketDumpReturn( $arPacket )."</div>";
//      flush();
      return $arPacket;
    }
    
    return false;
  }
  
}

function hex( $b)
{
  return sprintf( "%02X", $b );
}

function PacketDumpReturn( $A )
{
  return implode( ' ', array_map( 'hex', $A ) );
}


?>
