<?php

class shopOfferTask extends sfBaseTask
{
	private $webi_depth = 0;
  protected function configure()
  {
    // // add your own arguments here
     $this->addArguments(array(
       new sfCommandArgument('action', sfCommandArgument::REQUIRED, 'фыв'),
     ));

    $this->addOptions(array(
      new sfCommandOption('application', null, sfCommandOption::PARAMETER_REQUIRED, 'The application name'),
      new sfCommandOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev'),
      new sfCommandOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine'),
      // add your own options here
    ));

    $this->namespace        = 'shop';
    $this->name             = 'offer';
    $this->briefDescription = 'Обновление рекламных предложений с магазина';
    $this->detailedDescription = <<<EOF
The [shop:offer|INFO] task does things.
Call it with:

  [php symfony shop:offer|INFO]
EOF;
  }

  protected function execute($arguments = array(), $options = array())
  {
    // initialize the database connection
    $databaseManager = new sfDatabaseManager($this->configuration);
    $this->connection = $databaseManager->getDatabase($options['connection'])->getConnection();

    // add your code here
	 switch ( $arguments['action'] )
	 {
	 	case 'update':
	 		$this->_execute_update();
	 		break;
		default:
			echo "no action\n";
	 }
  }
  	
	private function _execute_update()
	{
		$this->webi_depth = 0;
		$this->deleted    = 0;
		$this->updated    = 0;
		$this->inserted   = 0;
		$this->error      = false;
		$this->arr_offers = array( 0=>0 );
		
		$con = Doctrine_Manager::getInstance()->connection();
//		$st = $con->execute($sql);
		//return $st->fetchAll();
		
		
		$this->array_offers_list = array();
		$sql = "SELECT ID,md5 FROM shopnag_offers";
		//echo "{$sql}\n";
//		return;
//		$res = $con->execute($sql);
//try{
		;
//		$res = $this->connection->prepare( $sql )->execute();
//		$res = $this->connection->exec( $sql );

		$stmt = $this->connection->prepare( $sql );
		$stmt->execute();
		$InDbCount = $stmt->rowCount();
		

//} catch($e){
//		var_dump( $stmt->fetch() );
//}
//		var_dump( $res );
		//$res = $DB->Query($sql);
		while($row = $stmt->fetch( PDO::FETCH_ASSOC ) )
		{
//			var_dump($row); die();
			$this->array_offers_list[$row["ID"]]=$row["md5"];
		}
		//return;
		
		
		$xml_parser = xml_parser_create();
		xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, true);

		// указываем какие функции будут работать при открытии и закрытии тегов
		xml_set_element_handler($xml_parser, array($this,"_startElement"), array($this,"_endElement") );

		// указываем функцию для работы с данными
		xml_set_character_data_handler( $xml_parser, array($this,"_data") );


		// открываем файл
		$file = 'http://shop.nag.ru/yml.php';
		$file = 'http://shop.nag.ru/yml_special.php';
////		$file = 'http://nag.ru/test.xml';
		echo "Open: {$file}\n";
		$fp = fopen($file, "r");


		$perviy_vxod=1; // флаг для проверки первого входа в файл
		$data="";  // сюда собираем частями данные из файла и отправляем в разборщик xml

		// цикл пока не найден конец файла
		while (!feof ($fp) and $fp)
		{
			$simvol = fgetc($fp); // читаем один символ из файла
			$data.=$simvol; // добавляем этот символ к данным для отправки

			// если символ не завершающий тег, то вернемся к началу цикла и добавим еще один символ к данным, и так до тех пор, пока не будет найден закрывающий тег
			if($simvol!='>') { continue;}
			// если закрывающий тег был найден, теперь отправим эти собранные данные в обработку

			// проверяем, если это первый вход в файл, то удалим все, что находится до тега <?
			// так как иногда может встретиться мусор до начала XML (корявые редакторы, либо файл получен скриптом с другого сервера)
			if($perviy_vxod) {$data=strstr($data, '<?'); $perviy_vxod=0;}
			// теперь кидаем данные в разборщик xml
//			echo "\n=====\n\n";
//			echo $data; 
//			echo "\n=====\n\n";
			if (!xml_parse($xml_parser, $data, feof($fp)))
			{

				// здесь можно обработать и получить ошибки на валидность...
				// как только встретится ошибка, разбор прекращается
				echo "<br>XML Error: ".xml_error_string(xml_get_error_code($xml_parser));
				echo " at line ".xml_get_current_line_number($xml_parser)."\n";
				var_dump( $data);
				$this->error = true;
				break;
			}
			// после разбора скидываем собранные данные для следующего шага цикла.
			$data="";
		}
		fclose($fp);
		xml_parser_free($xml_parser);
		if( !$this->error )
		{
			$sql = "DELETE FROM shopnag_offers WHERE ID NOT IN (".implode(",",$this->arr_offers).")";
			//echo "{$sql}\n";
			$stmt = $this->connection->prepare( $sql );
			$stmt->execute();
			$this->deleted = $stmt->rowCount();
		}
		echo "Товаров в базе {$InDbCount}\n";
		unset($this->arr_offers[0]);
		echo "Получено товаров: ".count($this->arr_offers)."\n";
		echo "Добавлено: {$this->inserted}\nОбновлено: {$this->updated}\nУдалено: {$this->deleted}";
		if( !$this->error )
		{
			echo "\nOK\n";
		}
		else
		{
			echo "\nОшибка работы\n";
		}
	}

	####################################################
	### функция работы с данными
	private function _data ($parser, $data)
	{
		//echo "[{$data}]\n";
		// добавляем данные в массив с указанием вложенности и открытого в данный момент тега
		if(isset($this->webi_data_temp[$this->webi_depth][$this->webi_tag_open[$this->webi_depth]]['data']))
		{
			$this->webi_data_temp[$this->webi_depth][$this->webi_tag_open[$this->webi_depth]]['data'].=$data;
		}
		else
		{
			$this->webi_data_temp[$this->webi_depth][$this->webi_tag_open[$this->webi_depth]]['data'] = $data;
		}
	}
	############################################

	####################################################
	### функция открывающих тегов
	private function _startElement($parser, $name, $attribs)
	{
		if ($this->webi_depth)
		{
			if($this->webi_depth==4 && $this->webi_tag_open[$this->webi_depth]=="OFFER" && isset($this->webi_data_temp[$this->webi_depth]["OFFER"]["attrs"]))
			{
				$this->sql_arr["ID"]= intval($this->webi_data_temp[$this->webi_depth]["OFFER"]["attrs"]["ID"]);				
			}
			// после обработки данных удаляем их для освобождения памяти
			unset($this->webi_data_temp[$this->webi_depth]);
		}
		// теперь пошло открытие следующего тега и дальше обработка его произойдет на следующем шаге
		$this->webi_depth++; // увеличиваем вложенность
		$this->webi_tag_open[$this->webi_depth]=$name; // добавляем открытый тег в массив информаци
		$this->webi_data_temp[$this->webi_depth][$name]['attrs']=$attribs; // теперь добавляем атрибуты тега
		$this->path = implode( '/',$this->webi_tag_open);
		//echo "{$this->path}\n";
		if( $this->path = 'YML_CATALOG/SHOP/CATEGORIES/CATEGORY' )
		var_dump( $attribs );
	}
	###############################################

    #################################################
    ## функция закрывающих тегов
	private function _endElement($parser, $name) 
	{
		//echo "$name\n\n";
		if(isset($this->webi_tag_open[4]) && $this->webi_tag_open[4]=="CURRENCY")// && 
		{
			$this->cur_arr[$this->webi_data_temp[4]["CURRENCY"]["attrs"]["ID"]] = $this->webi_data_temp[4]["CURRENCY"]["attrs"]["RATE"];
		}
		if(isset($this->webi_tag_open[4]) && $this->webi_tag_open[4]=="OFFER")
		{
			if( isset( $this->webi_data_temp[5], $this->webi_data_temp[5][$this->webi_tag_open[5]]["data"]) && $this->webi_tag_open[5]<>"DELIVERY")
				{
					$this->sql_arr["POLE"][] = $this->webi_tag_open[5];
					$this->sql_arr["VALUE"][] = '"'.addslashes($this->webi_data_temp[5][$this->webi_tag_open[5]]["data"]).'"';
					if($this->webi_tag_open[5]=="PRICE") $this->price = $this->webi_data_temp[5][$this->webi_tag_open[5]]["data"];
				}
			
			if($this->webi_depth==4 && !isset($this->webi_data_temp[$this->webi_depth]["OFFER"]["attrs"]))
			{
				if(count($this->sql_arr))
				{
					$this->sql_arr["POLE"][]="USD_PRICE";
					$this->sql_arr["VALUE"][]=$this->price;
					$this->sql_arr["POLE"][]="RUR_PRICE";
					$this->sql_arr["VALUE"][]=round((float)$this->cur_arr["USD"]*(float)$this->price, 2);
					$for_ser = "";
					foreach($this->sql_arr["VALUE"] as $val)
					{
						$for_ser.=$val;
					}
					$this_md5 = md5(serialize($for_ser));
					if(isset($this->array_offers_list[$this->sql_arr["ID"]]))
					{
						if($this_md5<>$this->array_offers_list[$this->sql_arr["ID"]])
						{
							$sql = "UPDATE shopnag_offers SET ";
							$z = 0;
							foreach($this->sql_arr["POLE"] as $val)
							{
								if($z>0)$sql.=', ';
								$sql.=$val.'='.$this->sql_arr["VALUE"][$z];
								$z++;
							}
							$sql.=", md5=".'"'.$this_md5.'"';
							$sql.=" WHERE ID=".$this->sql_arr["ID"];
							//$res = $DB->Query($sql);
							//echo "{$sql}\n";
							$stmt = $this->connection->prepare( $sql );
							$stmt->execute();
							$this->updated ++;
						}
					}
					else
					{
						$sql = "INSERT INTO shopnag_offers (ID,".implode(',',$this->sql_arr["POLE"]).",md5) VALUES (".$this->sql_arr["ID"].",".implode(',',$this->sql_arr["VALUE"]).",".'"'.$this_md5.'"'.")";
//						$res = $DB->Query($sql);
						//echo "{$sql}\n";
						$stmt = $this->connection->prepare( $sql );
						$stmt->execute();
						$this->inserted++;
					}
					$this->arr_offers[]=$this->sql_arr["ID"];
					$this->sql_arr = array();
				}
			}
		}
        unset($this->webi_data_temp); // после обработки данных удаляем массив с данными целиком, так как произошло закрытие тега
        unset($this->webi_tag_open[$this->webi_depth]); // удаляем информацию об этом открытом теге... так как он закрылся
		$this->webi_depth--; // уменьшаем вложенность
    }
    ############################################

}
