<?php

include( $_SERVER['DOCUMENT_ROOT'] . "/task/log.php" );

/***
* Дебаг лога задач : лог всего
*/
if( !defined('TASK_DEBUG_ALL') ){
	define( 'TASK_DEBUG_ALL'    , 1); // все
}

/**
* Дебаг лога задач : лог только ошибок
*/
if( !defined('TASK_DEBUG_ERROR') ){
	define( 'TASK_DEBUG_ERROR'  , 2);
}

/**
* Дебаг лога задач : лог выключен
*/

if( !defined('TASK_DEBUG_OFF') ){
	define( 'TASK_DEBUG_OFF'    , 3);
}




// Ключи для ошибок
if( !defined('TASK_INFO') ){
	define('TASK_INFO'          , 1); // информация
}
if( !defined('TASK_ERROR') ){
	define('TASK_ERROR'         , 2); // ошибка
}


// что хотим логировать. Присвоение
if( !defined('TASK_DEBUG_SET') ){
	define('TASK_DEBUG_SET', TASK_DEBUG_ALL);
}

if( !function_exists('log_task') ){
  function log_task(){
    return true;
  }
}


class Jobs
{
	
	# Максимальное время выполнения
	protected $Time_Run				= 25; 
	
	# Максимальная память на выполнение
	protected $Memory_Run			= 90;
	
	# Время старта
	protected $Start_Time			= null;
	
	# Кол-во изменений БД
	protected $Iteration			= 0;
	
	# нехватка памяти
	protected $MEMORY_LIMIT		= "MEMORY_LIMIT";
	
	# нехватка времени
	protected $TIME_LIMIT			= "TIME_LIMIT_";
	
	# Удачное завершение
	protected $GOOD						= "GOOD";
	
	# Результат выполнения
	protected $Result					= "";
	
	public $Test = false;
	
	public $LID = null;#object
	
	
	function SetTime_Run( $time = 30 ){
		$this->Time_Run = $time;
	}
	
	function SetMemory_Run( $memory = 90 ){
		$this->Memory_Run = (int) $memory;
	}
	
	function ReturnTime_Run(){
		return $this->Time_Run;
	}
	
	function ReturnMemory_Run(){
		return $this->Memory_Run;
	}
	
	# Возврат значений
	function ReturnIteration(){
		return $this->Iteration;
	}
	
	# Возврат значений
	function ReturnResult(){
		return $this->Result;
	}
	
	# Проверка сколько выполняется скрипт
	function GetTimeRun(){
		if( $this->ReturnTimeAction()  >= $this->Time_Run * 0.9 ){
			TObject2::$TaskAction = false;
			$this->WriteResultIter();
			return true;
		}
		return false ;
	}
	
	# Проверка сколько памяти занял скрипт
	function GetMemoryRun(){
		if( $this->ReturnMemoryAction() >= $this->Memory_Run * 0.75  ){
			TObject2::$TaskAction = false;
			$this->WriteResultIter();
			return true;
		}
		return false;
	}
	
	function WriteResultIter(){
    if( !property_exists( $this , 'LID' ) ){
      return false;
    }
		$Log = $this->LID;
		if( !is_object($Log) ) return;
		$SQL = "
		UPDATE {$Log::$SqlTable} SET 
			`{$Log::$FInit['Iteration']['sql']}` =  '{$this->ReturnIteration()}', 
			`text` =  '" . htmlspecialchars(addslashes( ob_get_contents() ) ) . "', 
			`{$Log::$FInit['Statuscrontasklog']['sql']}` =  '{$this->ReturnResult()}' ,
			`{$Log::$FInit['Updb']['sql']}` =  '{$this->ReturnUpdb()}' ,
			`{$Log::$FInit['Timeupdb']['sql']}` =  '{$this->ReturnTimeUpdb()}' ,
			`{$Log::$FInit['Seldb']['sql']}` =  '{$this->ReturnSeldb()}' ,
			`{$Log::$FInit['Timeseldb']['sql']}` =  '{$this->ReturnTimeSeldb()}' ,
			`{$Log::$FInit['Timerun']['sql']}` =  '{$this->ReturnTimeAction()}' ,
			`{$Log::$FInit['Memorypeak']['sql']}` =  '{$this->ReturnMemoryPeak()}' 
		WHERE 
			`id` ={$Log->Id}";
      
    log_task( $this->ReturnTimeAction(), TASK_INFO );
    
    if( !$this->ReturnTimeAction() ){
      $Log->Delete();
    }
      
			DB::Select($SQL);
	}
	
	# Возврат уже использованой памяти
	function ReturnMemoryAction(){
		return round( memory_get_usage() / 1024 / 1024 , 4 );
	}
	
	# Возврат времени , которое скрипт уже отработал
	function ReturnTimeAction(){
		return round( $this->ReturnTimerun() , 4 );
	}
	
	# Возврат кол-ва изменений БД
	function ReturnUpdb(){
		return TMysql::$ResultCron['UpDB']['Count'];
	}
	
	# Возврат времени изменении таблицы
	function ReturnTimeUpdb(){
		return TMysql::$ResultCron['UpDB']['Time'];
	}
	
	# Возврат кол-ва просмотров БД
	function ReturnSeldb(){
		return TMysql::$ResultCron['SelDB']['Count'];
	}
	
	# Возврат кол-ва времени просмотра БД
	function ReturnTimeSeldb(){
		return TMysql::$ResultCron['SelDB']['Time'];
	}
	
	# Возврат кол-ва времени потраченого на выполнение задачи
	function ReturnTimerun(){
		return microtime(true) - $this->Start_Time;
	}
	
	# Возращение пикового потребления памяти
	function ReturnMemoryPeak(){
		return memory_get_peak_usage();
	}
	
	function __construct(){
    
    
    log_task("Запуск класса JOBS" , TASK_INFO);
	
		$Filter = array(
			'Filter' => array(
				'Ident' => $this->GOOD
			)
		);
		
		$this->Result 		= (int) statuscrontasklog::Filter($Filter)->First->Id;
		$this->Start_Time = microtime(true) ;
		TMysql::$Taskcron = true;
		TObject2::$TaskAction = true;
		
		$class = str_replace( "job_" , "" , get_class($this) );
		
		$Filter = array(
			'Filter' => array(
				'Filename' => $class
			),
			'Limit' => 1
		);
		$oCrontask = crontask::Filter($Filter)->First;
		
		if((int) $oCrontask->Timelimit > 0 ){
			$this->Time_Run = (int) $oCrontask->Timelimit;
		}
		if( isset( $_SERVER["argv"] ) ){
		 foreach( $_SERVER["argv"] as $Param ) {
				// переопределить лимит времени для задачи из консоли, с помощью параметра TimeLimit:30
				if( preg_match( '/TimeLimit\:(\d+)/', $Param, $Match ) ) {
					$TL = $Match[1];
					if( $Match[1]>0 ) {
						echo " TimeLimit: $TL\n";
						$this->Time_Run = $TL;
					}
				}
			}
		}
		ini_set('max_execution_time' , $this->Time_Run );
		
		
		$MEMORY = $this->Memory_Run."M";
		if( preg_match( '/^([0-9]+)(B|M|G)$/' , $oCrontask->Memorylimit ) ){
			$MEMORY = $oCrontask->Memorylimit;
		}
		ini_set('memory_limit' , $MEMORY );
		
		
		if( preg_match( '/^([0-9]+)M$/' , $MEMORY ) ){
			$this->Memory_Run = (int) str_replace( "M" , "" , $MEMORY ); 
		}elseif( preg_match( '/^([0-9]+)G$/' , $MEMORY ) ){
			$this->Memory_Run = (int) str_replace( "G" , "" , $MEMORY ) * 1024; 
		}elseif( preg_match( '/^([0-9]+)B$/' , $MEMORY ) ){
			$this->Memory_Run = (int) str_replace( "B" , "" , $MEMORY ) / 1024; 
		}
		
	}
	
	# Увеличение итерации
	function AddIteration(){
		$this->Iteration = $this->Iteration + 1;
	}
	
	# Установка превышения времени
	function SetResult( $ident = "GOOD" , $time = 0 ){
	
		if( $ident == "TIME_LIMIT" ){
	
			$Filter = array(
				'Filter' => array(
					'Ident' => $this->TIME_LIMIT . $time
				)
			);
			if(!statuscrontasklog::Filter($Filter)->Count){
				statuscrontasklog::AddByArray(
					array(
						'Ident' => $this->TIME_LIMIT . $time,
						'Description' => "Время выполнения задания превысило {$time} сек."
					)
				);
			}
			
		}elseif( $ident == "MEMORY_LIMIT" ){
		
			$Filter = array(
				'Filter' => array(
					'Ident' => $this->MEMORY_LIMIT
				)
			);
			
		}
		
		$this->Result = (int) statuscrontasklog::Filter($Filter)->First->Id;
		
	}
	
}
