<?php
// ver 0.0.1
// md5=481f81813558ab2ba22d1ddfaeea7e6a
class TSite extends TObject2{
  static protected $FGlobalStaticObject = null;
  protected function __construct(){}
  protected $_ID = 'Id';
  protected $_F = Array();
  protected $Rule = array();
  static protected $_R = Array();
  static function Init(){
    if(!isset(self::$FGlobalStaticObject)) self::$FGlobalStaticObject = new self();
    return self::$FGlobalStaticObject;
  }
  
  
  
  
  /**
   * Проверка есть ли возможность включать мультидоменность с личным кабинетом
   * 
   * @return boolean
   */
  function IsMultiPrefixUrl(){
    return (bool) Site()->Config('main.domain');
  }
  
  
  
  /**
   * Возвращение протокола соединения
   * 
   * @return string
   */
  function GetProtocol(){
    $protocol = "http";
    if( !isset( $_SERVER["SERVER_PROTOCOL"] ) ){
      return $protocol;
    }
    $protocol = strtolower(substr($_SERVER["SERVER_PROTOCOL"],0,5))=='https'?'https':$protocol;
    return isset($_SERVER["HTTPS"]) ? 'https' : $protocol;
  }
  
  
  
  
  
  
  /**
   * Получение урла для перенаправления после авторизации
   * 
   * @return string
   */
  function GetAuthUrl(){
    
    $url = $this->GetProtocol() . "://";
    
    if( !$this->IsMultiPrefixUrl() ){
      if( isset( $_SERVER['HTTP_HOST'] ) ){
        $url .= $_SERVER['HTTP_HOST'];
      }else{
        // Написать исключение
        return false;
      }
    }else{
      if( Self()->Interprise->Id ){
        $url .= "u".Self()->Interprise->Id.".";
      }else{
        $url .= "online.";
      }
      $url .= Site()->Config('main.domain');
    }
    
    if( isset( $_REQUEST['ref'] ) ){
      $url .= $_REQUEST['ref'];
    }else{
      $url .= "/place/";
    }
    return $url;
  }
  
  
  
  
  
  
  
  /**
   * Получение из урла номера кабинета
   * 
   * @return integer Номер личного кабинета
   */
  function GetUrlNumberEnterprise(){
    if( !$this->IsMultiPrefixUrl() ){
      return false;
    }
    $match = array();
    preg_match('/^u([0-9]*)\.(.*)$/', $_SERVER['HTTP_HOST'] , $match);
    if( $match && isset( $match[1] ) ){
      return (int) $match[1];
    }
    return false;
  }
  
  
  
  
  /**
   * Если ключена проверка на мультикабинет
   * Проверк что урл валиден
   * 
   * @return boolean
   */
  function IsValidUrlMultiCab(){
    if( !$this->IsMultiPrefixUrl() ){
      return true;
    }
    return $this->GetUrlNumberEnterprise() && 
            $this->GetUrlNumberEnterprise() == Self()->Interprise->Id;
  }
  
  
  
  
  
  
  
  /**
   * Генерация ссылки для перенаправления на свой личный кабинет
   * Допустим он сидит под u12.domain.com а должен u13.domain.com
   * 
   * @return string Урл перенаправлния
   */
  function GetRedirectUrl(){
    if( $this->IsValidUrlMultiCab() ){
      return false;
    }
    
    if( isset( $_SERVER['REQUEST_URI'] ) ){
      $_REQUEST['ref'] = $_SERVER['REQUEST_URI'];
    }
    return $this->GetAuthUrl();
  }
  
  
  
  
  
  
  
  
  
  
  /**
   * Проверяет находится ли объект в том же предприятии.
   * Если нет то показывать страницу авторизации
   * 
   * #36323
   * 
   * @param string $object
   * @param int $id
   * 
   * @return boolean
   */
  function IsNotMyObject( $object , $id ){
    
    if( !Self()->Is ){
      return false;
    }
    
    $before_full = $this->GetFullRules();
    
    $GLOBALS['FullRules'] = true;
    
    TObject2::CleanAllObjectsByClass( $object ) ;
    $oObject = $object::Id( $id );
  
    if( isset( $object::$FInit['Interprise'] ) ){
      if( $oObject->Interprise->Id && $oObject->Interprise->Id != Self()->Interprise->Id ){
        smarty()->display( 'auth/index.tpl' );
        die();    
      }
    }
    
    $GLOBALS['FullRules'] = $before_full;
    return true;
  }
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  /**
   * Получение типа запроса к серверу
   * 
   * @return string
   */
  function API_Type(){
    if( !isset( $_SERVER['REQUEST_METHOD'] ) ){
      return "GET";
    }
    if( $_SERVER['REQUEST_METHOD'] == "POST" && isset( $_REQUEST['_method'] ) ){
      return $_REQUEST['_method'];
    }
    return $_SERVER['REQUEST_METHOD'];
  }
  
  
  
  /**
   * Время сервера
   * 
   * @return \DateTime
   */
  function GetDateServer(){
    return new DateTime( 'now' , new DateTimeZone( $this->GetTimezoneServer() ) );
  }
  
  
  /**
   * Полуение времени сервера отновительно пользователя -1 месяц
   * 
   * @return DateTime
   */
  function GetTimeServerMonthDown(){
    $time = clone $this->GetDateServer();
    $time->modify("-1 month");
    return $time;
  }
  
  
  /**
   * Получение временной зоны сервера
   * 
   * @return string
   */
  function GetTimezoneServer(){
    return Site()->Config( 'timezone' , date_default_timezone_get() );
  }
  
  
  
  
  protected $is_first_force_log = true;
  
  /**
   * Оперативное логирование каких либо вещей
   * 
   * @param string $msg
   * @return boolean
   */
  function ForceLog( $msg = "" ){
    
    $msg = $msg."\n";
    
    $force_log = $_SERVER['DOCUMENT_ROOT'] . "/force_log.log";
    
    if( !file_exists( $force_log ) || $this->is_first_force_log ){
      $this->is_first_force_log = false;
      return file_put_contents($force_log, $msg );
    }
    return file_put_contents($force_log, $msg , FILE_APPEND);
  }
  
  
  
  
  /**
   * Есть ли в системе ключ для ускорения выборки по пользовательскому логу
   * 
   * @return boolean
   */
  function GetIsKeyIndexUserlog(){
    $res = DB::FetchArraySelect("SHOW INDEX FROM userlog from {$GLOBALS['CONFIG']['SQL']['DATABASE']} where Key_name = 'object_prop_id'");
    return (bool) $res;
  }
  
  
  
  
  /**
   * Получение пути до библтотеки опроса
   * 
   * Возможные пути содержания по значимости в обратном порядке
   * Конфиг в БД
   * Файл конфига
   * Дефолтное значение
   * 
   * @return string
   */
  public function GetPathToLsaup(){
    
    if( $this->Config( 'path_to_lsaup') ){
      return $this->Config( 'path_to_lsaup' );
    }elseif( isset( $GLOBALS['CONFIG']['PATH_TO_LSAUP'] ) ){
      $this->SetConfig( 'path_to_lsaup' , $GLOBALS['CONFIG']['PATH_TO_LSAUP'] );
      return $this->Config( 'path_to_lsaup' );
    }
    
    return "/home/saup/saup/";
  }










  /*
    Путь куда загрузжать картинки из плейса
    @return String
  */
  function GetPathPlaceFiles( $oPlace ){
    
    $dir = $_SERVER['DOCUMENT_ROOT'] . "/images/place/{$oPlace->Id}/";
    
    if( !file_exists($dir) ){
      mkdir( $dir ,0755 , TRUE );
    }
    return $dir;
  }
  
  
  
  
  
  /*
    Проверка является ли таблица task с типом MEMORY
    
    Позитивный ответ - false
    
    @return Bool
  */
  function GetIsTaskNotMemory(){
    
    if( !$this->GetIsTaskCreate() ) return 0;
    
    $SQL = Utils::Strip("
      show create table task
    ");
    
    $res = DB::Select($SQL);
    
    if( !$res ) return $res;
    
    $res = DB::Fetch( $res );
    
    if( !isset( $res['Create Table'] ) ) return false;
    
    return !preg_match( '/ENGINE=MEMORY/' , $res['Create Table'] );
  }
  
  
  /*
    Проверяет создана ли таблица task
    Позитивный ответ true
    @return Bool
  */
  function GetIsTaskCreate(){
    $SQL = Utils::Strip("
      SHOW TABLES LIKE 'task'
    ");
    
    list($find_table) = array_values( DB::Fetch( DB::Select($SQL) ) );
    
    return $find_table == "task" ;
  }
  
  
  
  /*
    Поиск конфига по его параметру
    @return config
  */
  function ConfigFind( $parametr ){
    $Filter = array( 
      'Filter' => array( 
        'Parametr' => $parametr
      )
    );
    $res = config::Filter($Filter);
    if( $res->Count ){
      return $res->First;
    }
    return config::Id(0);
  }
  
  
  
  
  /*
    Получение экземпляра класса
    @return Object
  */
  function GetEmpty($class){
    return $class::Id(0);
  }
  
  /*
    Перенаправление пользователя туда откуда он пришел 
    на форму добавления пользователя
    @return null
  */
  function GoFormUser(){
    $ref = isset($_REQUEST['REF'])?$_REQUEST['REF']:'/user/';
    header("Location: ".$ref."?success"); die();
  }
  /*
    Перенаправление пользователя туда откуда он пришел 
    на форму добавления пользователя
    @return null
  */
  function GoFormMail(){
    $ref = isset($_REQUEST['REF'])?$_REQUEST['REF']:'/mail/';
    header("Location: ".$ref."?success"); die();
  }
  
  /*
    Перенаправление пользователя туда откуда он пришел 
    на форму добавления пользователя
    @return null
  */
  function GoFormVerification(){
    $ref = isset($_REQUEST['REF'])?$_REQUEST['REF']:'/auth/';
    header("Location: /auth/demo/?success"); die();
  }
  
  /*
    Перенаправление пользователя туда откуда он пришел 
    на форму добавления пользователя
    @return null
  */
  function GoFormGroup(){
    $ref = isset($_REQUEST['REF'])?$_REQUEST['REF']:'/group/';
    header("Location: ".$ref."?success"); die();
  }
  
  
  /*
    Перенаправление пользователя туда откуда он пришел 
    на форму добавления виртуального узла учета
    @return null
  */
  function GoFormVconverter(){
    $ref = isset($_REQUEST['REF'])?$_REQUEST['REF']:'/vconverter/';
    header("Location: ".$ref."?success"); die();
  }
  
  /*
    Перенаправление пользователя туда откуда он пришел 
    на форму добавления виртуального прибор учета
    @return null
  */
  function GoFormVmeter(){
    $ref = isset($_REQUEST['REF'])?$_REQUEST['REF']:'/vmeter/';
    header("Location: ".$ref."?success"); die();
  }
  
  /*
    Перенаправление пользователя туда откуда он пришел 
    на форму добавления калькуляционного прибора учета
    @return null
  */
  function GoFormCmeter(){
    $ref = isset($_REQUEST['REF'])?$_REQUEST['REF']:'/cmeter/';
    header("Location: ".$ref."?success"); die();
  }
  
  /*
    Перенаправление пользователя туда откуда он пришел 
    на форму добавления места
    @return null
  */
  function GoFormPlace()
  {
    $ref = isset($_REQUEST['REF'])?$_REQUEST['REF']:'/place/';
    header("Location: ".$ref); die();
  }

  
  /*
    Перенаправление пользователя туда откуда он пришел 
    на форму добавления калькуляционного узла учета
    @return null
  */
  function GoFormCconverter()
  {
    $ref = isset($_REQUEST['REF'])?$_REQUEST['REF']:'/cconverter/';
    header("Location: ".$ref); die();
  }


  /*
    Получение времени сервера
    @return DateTime
  */
  function GetServerTime(){
    // TODO Указать часовой пояс сервера
    return new DateTime();
  }

  /*
    Получение года на сервере
    @return string
  */
  function GetServerYear(){
    return $this->GetServerTime()->format("Y");
  }

  /*
    Получение месяца на сервере
    @return string
  */
  function GetServerMonth(){
    return $this->GetServerTime()->format("m");
  }

  /*
    Получение дня на сервере
    @return string
  */
  function GetServerDay(){
    return $this->GetServerTime()->format("d");
  }

  /*
    Получение часа на сервере
    @return string
  */
  function GetServerHour(){
    return $this->GetServerTime()->format("H");
  }

  /*
    Получение мнут на сервере
    @return string
  */
  function GetServerMin(){
    return $this->GetServerTime()->format("i");
  }

  /*
    Получение секунд на сервере
    @return string
  */
  function GetServerSec(){
    return $this->GetServerTime()->format("s");
  }



  /*
    Возвращает путь до папки с задачими
    @return String путь до папки с фоновыми задачами
  */
  function GetPathCrontask(){
    return realpath( $_SERVER['DOCUMENT_ROOT']."/task/" );
  }
  
  
  
  /*
    Перенаправление пользователя на страницу авторизации если он не авторизован
  */
  function GoToAuth(){
  
    $arrayExcludedUrl = array();
    
    header('HTTP/1.0 403 Forbidden');
    
    if( !isset( $_SERVER['REQUEST_URI'] ) ){
      return header("Location: /auth/");
    }else{
    
      if( in_array($_SERVER['REQUEST_URI'] , $arrayExcludedUrl) ){
        header("Location: /auth/");
      }else{
        header("Location: /auth/?ref={$_SERVER['REQUEST_URI']}");
      }
    }
    die();
    exit();
  }
  
  
  
  /*
    Перенаправление пользователя на 404 страницу
    @return null
  */
  function Error404(){
    header("Location: /404/");
    die();
    exit();
  }

  
  /*
    Функция возвращает кол-во элементов на странице
   * @task #34697
    @return Int
  */
  function GetCountInPage(){
    if( isset( $_GET['count'] ) ){
      if( $_GET['count'] == "all" || $_GET['count'] == "Все" || !$_GET['count'] ){
        return 1000000;
      }
      return (int) $_GET['count'];
    }
    return 10;
  }
  
  /*
    Возвращает индекс элемента, который нужно взять
    чтобы показать необходимую страницу
    @return Int
  */
  function GetPage(){
    if( isset($_GET['page']) ){
      if( (int) $_GET['page'] - 1  < 0 ) return 0;
      return ((int) $_GET['page']) - 1;
    }
    return 0;
  }
  
  
  
  
  /*
    Получение виртуального типа прибора учета
    @return metertype
  */
  function GetMetertypeVirtual(){
    $Filter = array( 
      'Filter' => array( 
        'DllId' => 'VIRTMETER'
      )
    );
    
    $Res = metertype::Filter($Filter);
    if( !$Res->Count ){
      TObject2::CleanAllObjectsByClass( 'metertype' );
      return metertype::AddByArray(array(
        'DllId' => 'VIRTMETER'
      ));
    }
    
    return $Res->First;
  }  


  function GetMetertypeVirtuals(){
    $t = metertype::Id(0);
    $SQL = "select * from meter_type where dll_id like '%VIRT%' or dll_id like '%LORA%'";
    return TListGroup::Prepare( $SQL , $t );
  }
  
  
  
  
  
  /*
    Получение калькуляционного типа прибора учета
    @return metertype
  */
  function GetMetertypeCalc(){
    $Filter = array( 
      'Filter' => array( 
        'DllId' => 'CALCMETER'
      )
    );
    
    $Res = metertype::Filter($Filter);
    if( !$Res->Count ){
      TObject2::CleanAllObjectsByClass( 'metertype' );
      return metertype::AddByArray(array(
        'DllId' => 'CALCMETER'
      ));
    }
    
    return $Res->First;
  }
  
  
  
  
  
  /*
    Получение калькуляционного типа узла учета
    @return convertertype
  */
  function GetConvertertypeCalc(){
    return convertertype::FindByIdent('CALC');
  }
  
  
  
  
  
  /*
    Все loginfo
    @return TListGroup
  */
  function GetLoginfoAll(){
    return loginfo::All();
  }



  
   
  
  /*
    Получение типов мест
    @return TListGroup
  */
  function GetPlacetypes(){
    return placetype::All();
  }
  
  
  


  /*
    Все конверторы
    @return TListGroup
  */
  function GetConverters(){
    return converter::All();
  }
  
  
  
  


  /*
    Все задачи
    @return TListGroup
  */
  function GetCrontask(){
    return crontask::All();
  }
  
  
  
  


  /*
    Все рассылки
    @return TListGroup
  */
  function GetMails(){
    $Filter = array( 
      'Filter' => array( 
        'Interprise' => Self()->Interprise->Id 
      )
    );
    return mail::Filter( $Filter );
  }
  
  
  
  
  
  
  /*
    Получение только ВИРТУАЛЬНЫХ конверторов
    @return TListGroup
  */
  function GetVirtualConverters(){
    return vconverter::All();
  }
  
  
  
  
  /*
    Получение идентификатора виртуального конвертора
    @return Int
  */
  function GetVirtualConverterType(){
    return convertertype::FindByIdent('VIRTUAL')->Id;
  }
  
  
  
  /*
    Получение конфига по идентификатору
  */
  function ConfigArray( $el ){
    $SQL = Utils::Strip("
      SELECT * FROM `config` WHERE `parametr` LIKE '%ru.{$el}%'
    ");
    
    $t = config::Id(0);
    return TListGroup::Prepare( $SQL , $t );
  }
  
  
  
  /*
    Получение конфига по идентификатору
  */
  function ConfigIcons( $el ){
    $SQL = Utils::Strip("
      SELECT * FROM `config` WHERE `parametr` LIKE '%icon.{$el}'
    ");
    
    $t = config::Id(0);
    return TListGroup::Prepare( $SQL , $t );
  }
  
  
  
  /*
    Получение идентификатора виртуального прибора учета
    @return Int
  */
  function GetVirtualMeterType(){
    return metertype::FindByIdent('VIRTMETER')->Id;
  }
  
  
  /*
    Получение только РЕАЛЬНЫХ конверторов
    @return TListGroup
  */
  function GetRealConverters(){

    $Filter = array(
      'Filter' => array(
        'Type NOT IN' => array(
          convertertype::FindByIdent('VIRTUAL')->Id,
          convertertype::FindByIdent('CALC')->Id,
          convertertype::FindByIdent('VegaLora')->Id,
        ),
        'Id' => Self()->GetConvertersByRulePlaceIds(),
        //~ 'Type !=' => 0,
        'Interprise' => Self()->Interprise->Id
      )
    );
    if( !count(Self()->GetConvertersByRulePlaceIds()) ){
      unset($Filter['Filter']['Id']);
    }
    return converter::Filter( $Filter );
  }
  
  
  
  /*
    Получение только КАЛЬКУЛЯЦИОННЫХ конверторов
    @return TListGroup
  */
  function GetCconverters(){
    return cconverter::All();
  }
  
  
  /*
    Получение среза только реальных для страницы
    @return TListGroup
  */
  function GetRealConvertersByPages(){

    $Converters = $this->GetRealConverters()->GroupBy( Site()->CountInPage )->Elements;
    
    if( !isset( $Converters[ Site()->GetPage() ] ) ){
      return TListGroup::Init();
    }
    
    return $Converters[ Site()->Page ];
  }
  
  
  
  
  
  function ShemaStruct(){
    return array(
    'info' => array(
      'year_start'  ,
      'month_start' ,
      'day_start'   ,
      'year_stop'   ,
      'month_stop'  ,
      'day_stop'    ,
      'origin_name' ,
      'description' ,
      'user_login'  ,
      'interprise'  ,
      'date_create' ,
      'count_mdh'   ,
      'delimiter'   ,
      'enclosure'   
    ),
    'shema' => array()
  );
  }
  
  
  
  
  function ShemaArchive(){
    return array(
      'loginfo' => array(
        'Title' , 
        'Logtext'
      ),
      'metertype' => array(
        'Title',
        'DllId'
      ),
      'convertertype' => array(
        'Title',
        'DllId'
      ),
      'parameter' => array(
        'Title',
        'Ident'
      ),
      'meter' => array(
        'Coef',
        'Type',
        'Num485',
        'NumSerial',
        'Password',
        'Converter'
      ),
      'converter' => array(
        'Ip',
        'Port',
        'Login',
        'Password',
        'About',
        'Type'
      ),
      'meterdatahour' => array(
        'Meter',
        'Parameter',
        'Year',
        'Month',
        'Day',
        'Hour',
        'Value',
        'Loginfo',
        'AddTime',
      )
    );
  }
  
  
  
  function GetArchivesFromLoad(){
    $dir = new DirectoryIterator( $_SERVER['DOCUMENT_ROOT'] . "/archive/" );
    $ar = array();
    
    $ar_isset = array();
    foreach( $this->Archives->Elements as $iArchive ){
      $ar_isset[ $iArchive->TransName ] = 1;
    }
    
    foreach ($dir as $fileinfo) {
      
      if( is_object($fileinfo) && $fileinfo->getExtension() == 'zip' ){
        if (!$fileinfo->isDot() && !isset( $ar_isset[ $fileinfo->getBasename('.zip') ] ) ) {
          
          $zip = new ZipArchive;
          if ($zip->open($fileinfo->getBasename()) === TRUE) {
              $info = json_decode("{}");
              $error = "";
              if( $zip->getFromName('shema.json') ){
                $info = json_decode( $zip->getFromName('shema.json') );
                
                /*
                  Проверка на валидацию схемы
                */
                
                $valid = true;
                
                foreach( $this->ShemaStruct() as $name_t => $attrs ){
                  
                  if( !property_exists( $info , $name_t ) ){
                    $error = "Не верный формат файла shema";
                    $valid = false;
                  }
                  
                  if( !$valid ) break;
                  
                  foreach( $attrs as $Prop ){
                    
                    if( !property_exists( $info->$name_t , $Prop ) ){
                      $error = "invalid $Prop";
                      $valid = false;
                    }
                    
                    if( !$valid ) break 2;
                  }
                }
                
                
              }
              
              $ar[] = array(
                'name' => $fileinfo->getFilename(),
                'info' => property_exists( $info , 'info' ) && !$error ? $info->info : NULL,
                'error' => $error
              );
              $zip->close();
          }
          
        }
      }
    }
    return $ar;
  }
  
  
  
  /*
    Получение всех архивов в системе
    @return Array
  */
  function GetArchives(){
    $Filter = array( 
      'Filter' => array( 
        'Interprise' => Self()->Interprise->Id
    ));
    return archive::Filter($Filter);
  }
  
  
  
  
  
  function GetArchivesByPages(){
    $Converters = $this->Archives->GroupBy( Site()->CountInPage )->Elements;
    
    if( !isset( $Converters[ Site()->Page ] ) ){
      return TListGroup::Init();
    }
    
    return $Converters[ Site()->Page ];
  }
  
  
  /*
    Массив страниц для РЕАЛЬНЫХ конверторов
    @return TListGroup
  */
  function GetArchivesPages( $is_all = false ){
    return Utils::Paginator(
      $this->Archives->Count,
      Site()->GetCountInPage(),
      $is_all
    );
  }
  
  
    
  
  
  

  /*
    Все рассылки по страницам
    @return TListGroup
  */
  function GetMailsByPage(){
    $Elems = $this->Mails->GroupBy( Site()->CountInPage )->Elements;
    
    if( !isset( $Elems[ Site()->Page ] ) ){
      return TListGroup::Init();
    }
    
    return $Elems[ Site()->Page ];
  }
  
  
  
  
  
  
  /*
    Массив страниц для РЕАЛЬНЫХ конверторов
    @return TListGroup
  */
  function GetRealConverterPages( $is_all = false ){
    return Utils::Paginator(
      $this->RealConverters->Count,
      Site()->GetCountInPage(),
      $is_all
    );
  }
  
  
  
  
  
  /*
    Массив страниц для КАЛЬКУЛЯЦИОННЫХ конверторов
    @return TListGroup
  */
  function GetCconverterPage( $is_all = false ){
    return Utils::Paginator(
      $this->Cconverters->Count,
      Site()->GetCountInPage(),
      $is_all
    );
  }
  
  
  
  
  /*
    Все рассылки по страницам
    @return TListGroup
  */
  function GetCconverterByPage(){
    $Elems = $this->Cconverters->GroupBy( Site()->CountInPage )->Elements;
    
    if( !isset( $Elems[ Site()->Page ] ) ){
      return TListGroup::Init();
    }
    
    return $Elems[ Site()->Page ];
  }
  
  
  
  
  
  
  
  
  /*
    Массив страниц для КАЛЬКУЛЯЦИОННЫХ конверторов
    @return TListGroup
  */
  function GetPagesMail( $is_all = false ){
    return Utils::Paginator(
      $this->Mails->Count,
      Site()->GetCountInPage(),
      $is_all
    );
  }
  
  
  
  
  
  
  /*
    Получение среза только ВИРТУАЛЬНЫХ для страницы
    @return TListGroup
  */
  function GetVirtualConvertersByPages(){
    $Converters = $this->Vconverters->GroupBy( Site()->CountInPage )->Elements;
    
    if( !isset( $Converters[ Site()->Page ] ) ){
      return TListGroup::Init();
    }
    
    return $Converters[ Site()->Page ];
  }
  
  
  
  
  
  /*
    Массив страниц для ВИРТУАЛЬНЫХ конверторов
    @return TListGroup
  */
  function GetVconvertersPage( $is_all = false ){
    return Utils::Paginator(
      $this->VConverters->Count,
      Site()->GetCountInPage(),
      $is_all
    );
  }
  
  
  
  // TODO
  function GetPlacePages(){
    return array();
  }
  
  
  
  /*
    Все типы конверторов
    @return TListGroup
  */
  function GetConverterTypes(){
    return convertertype::All();
  }
  
  
  
  /*
    Все конверторы на которых есть ошибки по опросу
    @return TListGroup
  */
  function GetConverterErrors(){
    $Filter = array(
      'Filter' => array(
        'IsOk' => 0,
        'IsExcluded' => 0
      )
    );
    return converter::Filter( $Filter );
  }
  
  
  
  /*
    Исклюбченные приборы учета
    @return TListGroup
  */
  function GetMeterExcluded(){
    $Filter = array( 
      'Filter' => array( 
        'IsExcluded' => 1,
        'Converter >' => 0
      )
    );
    return meter::Filter( $Filter );
  }
  

  # Показ только тех типов по которым есть приборы
  function GetMetertypesFromMeterPage(){

    $SQL = Utils::Strip("
select meter_type.*
from meter_type
left join meter on meter.type_id = meter_type.id
where meter.interprise = " . Self()->Interprise->Id . " 
and meter_type.dll_id NOT IN('VIRTMETER','FILTER','CALC') and meter.converter_id > 0
");

    return TListGroup::Prepare( $SQL , metertype::Id(0) );
  }
  
  
  /*
    Все типы приборов
    @return TListGroup
  */
  function GetMetertypes(){
    $Filter = array( 
      'Filter' => array( 
        'InterpriseId' => 0,
        'Title NOT IN' => array(
          'ТЭКОН',
          'ТЕКОН',
        )
      )
    );
    return metertype::Filter( $Filter );
  }
  
  
  
  
  /*
    Все пользователи
    return TListGroup
  */
  function GetUsers(){
    $Filter = array( 
      'Filter' => array( 
        'Type IN' => array( 0 , 102 ),
      )
    );
    return user::Filter( $Filter );
  }
  
  
  
  /*
    Все часовые пояса
    @return TListGroup
  */
  function GetTimezones(){
    return timezone::All();
  }
  
  
  
  
  /*
    Те пользователи которые пользователь может сотреть
    @return TListGroup
  */
  function GetUsersPub(){
    $Filter = array( 
      'Filter' => array( 
        'Type NOT IN' => array( 1 , 100 , 101 ),
        'Interprise'  => Self()->Interprise->Id
      )
    );
    return user::Filter( $Filter );
  }
  
  
  
  /*
    Все пользователи
    return TListGroup
  */
  function GetGroup(){
    return group::All();
  }
  
  
  
  /*
    Те группы которые пользователь может сотреть
    @return TListGroup
  */
  function GetGroupPub(){
    return group::All();
  }
  
  
  
  /*
    Те роли которые пользователь может сотреть
    @return TListGroup
  */
  function GetRulePub(){
    $Filter = array( 
      'Filter' => array( 
        'Interprise'  => Self()->Interprise->Id
      )
    );
    return rule::Filter( $Filter );
  }
  
  
  /*
    Пользователи по страницам
    @return TListGroup
  */
  function GetUsersByPages(){
    $List = $this->UsersPub->GroupBy( Site()->GetCountInPage() )->Elements;
    if( !isset( $List[ Site()->Page ] ) ){
      return TListGroup::Init();
    }
    return $List[ Site()->Page ];
  }
  
  
  
  /*
    Пользователи по страницам
    @return TListGroup
  */
  function GetGroupByPages(){
    $List = $this->Group->GroupBy( Site()->GetCountInPage() )->Elements;
    if( !isset( $List[ Site()->Page ] ) ){
      return TListGroup::Init();
    }
    return $List[ Site()->Page ];
  }
  
  
  
  
  /*
    Роли по страницам
    @return TListGroup
  */
  function GetRuleByPages(){
    $List = rule::All()->GroupBy( Site()->GetCountInPage() )->Elements;
    if( !isset( $List[ Site()->Page ] ) ){
      return TListGroup::Init();
    }
    return $List[ Site()->Page ];
  }
  
  
  /*
    Пагинатор для пользователей
    @return Array
  */
  function GetUsersPages(){
    return Utils::Paginator(
      $this->UsersPub->Count,
      Site()->GetCountInPage()
    );
  }
  
  
  
  /*
    Только системный лог
  */
  function GetSysLog(){
    
    $SQL = Utils::Strip("
      select userlog.* 
      from userlog 
      left join meter 
        on userlog.object_id = meter.id  
      where 
        meter.interprise = ". Self()->Interprise->Id ." and 
        userlog.object = 'meter'
      order by userlog.id desc 
    ");
    
    $t = userlog::Id(0);
    
    
    $Res= TListGroup::Prepare( $SQL , $t );
    
    $Res->SetLimit(10000);
    
    
    return $Res;
  }
  
  /*
    Только системный лог
  */
  function GetSysLogByPagePages(){
    return Utils::Paginator(
      $this->SysLog->Count,
      Site()->GetCountInPage()
    );
  }
  
  
  
  function GetSysLogByPage(){
    $List = $this->SysLog->GroupBy( Site()->GetCountInPage() )->Elements;
    if( !isset( $List[ Site()->Page ] ) ){
      return TListGroup::Init();
    }
    return $List[ Site()->Page ];
  }
  
  
  
  
  
  /*
    Пагинатор для пользователей
    @return Array
  */
  function GetRulePages(){
    return Utils::Paginator(
      $this->Rules->Count,
      Site()->GetCountInPage()
    );
  }
  
  
  
  /*
    Пагинатор для групп
    @return Array
  */
  function GetGroupPages(){
    return Utils::Paginator(
      $this->Group->Count,
      Site()->GetCountInPage()
    );
  }
  
  
  
  /*
    Задания системы которые ожидают
    @return TListGroup
  */
  function GetTaskWaiting(){
    $Filter = array( 
      'Filter' => array( 
        'Taskstatus' => 1,
        'Interprise' => Self()->Interprise->Id
      )
    );
    return task::Filter( $Filter );
  }
  
  
  
  
  /*
    Получение всех заданий которые ожидают с группировкой 
    по приборам учета и соратировкой
    @return TListGroup
  */
  function GetTaskWaitingASCConverter(){
    $Filter = array( 
      'Filter' => array( 
        'Taskstatus' => 1
      ),
      'Order' => array(
        'Converter' => 'ASC'
      ),
      'GroupBy' => array(
        'Meter'
      )
    );
    return task::Filter( $Filter );
  }




  /*
    Задания системы которые выполняются
    @return TListGroup
  */
  function GetTaskRunning(){
    $Filter = array( 
      'Filter' => array( 
        'Taskstatus' => 2,
        'Interprise' => Self()->Interprise->Id
      )
    );
    return task::Filter( $Filter );
  }
  
  
  
  
  
  /*
    Получение всех заданий которые выполняются с группировкой 
    по приборам учета и соратировкой
    @return TListGroup
  */
  function GetTaskRunningASCConverter(){
    $Filter = array( 
      'Filter' => array( 
        'Taskstatus' => 2
      ),
      'Order' => array(
        'Converter' => 'ASC'
      ),
      'GroupBy' => array(
        'Meter'
      )
    );
    return task::Filter( $Filter );
  }



  /*
    Задания системы которые выполнены
    @return TListGroup
  */
  function GetTaskArchived(){
    $Filter = array( 
      'Filter' => array( 
        'Taskstatus' => 3,
        'Interprise' => Self()->Interprise->Id
      ),
    );
    return task::Filter( $Filter );
  }
  
  
  
  
  
  
  /*
    Массив по сколько показывать на страницах
    @return Array
  */
  function GetArrayCountview(){
    return array(
      10    => 10,
      50    => 50,
      100   => 100,
      500   => 500,
      1000  => 1000,
      'all' => 'Все'
    );
  }




  /*
    вывод уникальных групп действий по тому на что распространяется
    @return TListGroup
  */
  function GetUniqueActionName(){
    $Filter = array(
      'GroupBy' => array(
        'Name'
      )
    );
    return action::Filter( $Filter );
    }
    



  /*
    вывод уникальных групп действий по типу действия
    @return TListGroup
  */
  function GetUniqueActionAction(){
    $Filter = array(
      'GroupBy' => array(
        'Action'
      )
    );
    return action::Filter( $Filter );
  }









  /*
    Формирование get строки из кол-ва и страницы
    @return Sting
  */
  function GetGetPageCountAttrs(){
    $str = "";
    
    if( isset( $_GET['page'] ) || isset( $_GET['count'] ) ){
      $params = array();
      
      if( isset( $_GET['page'] ) ){
        $params[] = "page=".$_GET['page'];
      }
      if( isset( $_GET['count'] ) ){
        $params[] = "count=".$_GET['count'];
      }
      
      return "?". implode('&',$params);
      
    }
    return "";
    
  }
  
  
  
  
  
  
  
  
  
  
  
  function GetFiltesMeterAdd(){

    $Icons = array();
    if ($handle = opendir( $_SERVER['DOCUMENT_ROOT']."/images/meter_add/" )) {
      while (false !== ($entry = readdir($handle))) {

          if( !preg_match('/^(.*)\.(jpg|png|jpeg)$/' , $entry , $m) ) continue;
          $Icons[] = $entry;
      }
      closedir($handle);
    }
    return $Icons;
  }
  
  
  
  
  /*
    Параметры, которые создал пользователь
    @return TListGroup
  */
  function GetVirualParameters(){
    $Filter = array(
      'Filter' => array(
        'Enterprise' => Self()->Interprise->Id,
        'Ident LIKE' => '%USER_%'
      )
    );
    return parameter::Filter($Filter);
  }
  
  
  
  
  
  /*
    Параметры пользователя и общие из системы
    @return TListGroup
  */
  function GetAllParameters(){
    $SQL = Utils::Strip("
      select * from 
      parameter 
      where ( enterprise_id = 0 and lvl4 !='' ) 
      or ( ident like '%USER_%'  and enterprise_id = ". Self()->Interprise->Id .")");
    $t = parameter::Id(0);
    return TListGroup::Prepare( $SQL , $t );
  }





  function GetPlaces(){
    return place::All();
  }
  
  function GetPlacesLvl0(){
    $Filter = array( 
      'Filter' => array( 
        'Place' => 0
      )
    );
    return place::Filter( $Filter );
  }




  
  /*
    Общее меню для статической версии и динамической
    @return Array
  */
  function GetMenuItem(){


    $menu = array(
      array(
        "name"  => $this->Config('ru.place'),
        "icon"  => $this->Config('icon.place'),
        "href"  => Site()->IsAJAX() ? "#place/" : "/place/",
        "index" => "place"
      ),
      array(
        "name"  => $this->Config('ru.converter'),
        "icon"  => $this->Config('icon.converter'),
        "href"  => Site()->IsAJAX() ? "#converter/" : "/converter/",
        "index" => "converter"
      ),
      array(
        "name"  => $this->Config('ru.item_menu_meters' , "Приборы учета"),
        "icon"  => $this->Config('icon.meter'),
        "href"  => Site()->IsAJAX() ? "#meter/" : "/meter/",
        "index" => "meter"
      ),
      // array(
      //   "name"  => $this->Config('ru.vconverter'),
      //   "icon"  => $this->Config('icon.vconverter'),
      //   "href"  => Site()->IsAJAX() ? "#converter/" : "/vconverter/",
      //   "index" => "vconverter"
      // ),
      array(
        "name"  => "Счетчики импульсов",
        "icon"  => "fa fa-sitemap",
        "href"  => Site()->IsAJAX() ? "#vconverter/" : "/vconverter/",
        "index" => "vconverter"
      ),
      array(
        "name"  => $this->Config('ru.cconverter'),
        "icon"  => $this->Config('icon.cconverter'),
        "href"  => Site()->IsAJAX() ? "#converter/" : "/cconverter/",
        "index" => "cconverter"
      ),
      array(
        "name"  => "Сетевые серверы LP-WAN",
        "icon"  => "glyphicon glyphicon-signal",
        "href"  => Site()->IsAJAX() ? "#lorawan/" : "/lorawan/",
        "index" => "lorawan"
      ),
      array(
        "name"  => $this->Config('ru.filter'),
        "icon"  => $this->Config('icon.filter'),
        "href"  => Site()->IsAJAX() ? "#converter/" : "/filter/",
        "index" => "filter"
      ),
      array(
        "name"  => $this->Config('ru.archive'),
        "icon"  => $this->Config('icon.archive'),
        "href"  => Site()->IsAJAX() ? "#converter/" : "/archive/",
        "index" => "archive"
      )
    );


    // if( !Self()->IsRoot ){
    //   unset($menu[4]);
    //   unset($menu[5]);
    //   unset($menu[6]);
    // }

    return $menu;
  }




  
  
  /*
    Получение списка фильтров приборов учета
    @return TListGroup
  */
  function GetMeterFilter(){
    
    $Filter = array( 
      'Filter' => array( 
        'Type'        => metertype::FindByIdent('FILTER')->Id,
        'Converter'   => 0,
        'IsExcluded'  => 0,
        'Interprise'  => Self()->Interprise->Id
      )
    );
    
    
    return meter::Filter($Filter);
  }








  ////////// Ниже все от старой версии


  //~ task #23933 Содержание результата AJAX
  protected $AJAXRes = array(
    'error' => "",
    'result' => null
  );

  protected $isAJAXf = false;

  //~ task #23933
  function AJAXSuccess( $res ){
    $this->isAJAXf = true;
    $this->AJAXRes['result'] = $res;
    exit();
  }

  //~ task #23933
  function AJAXError( $result ){
    //~ smarty()->ConfigLoad('words.conf', 'AJAX' );
    $Error = smarty()->get_config_vars( $result );
    if( $Error !== null ){
      $result = $Error;
    }else{
      $result = "Неизвестная ошибка.";
    }
    $this->isAJAXf = true;
    $this->AJAXRes['error'] = $result;
    exit();
  }
  
  
  
  
  public $cacheMD5_DIR = array();
  

  // Высчитывает md5 всех файлов в директории
  function MD5_DIR($dir){
    if( isset($this->cacheMD5_DIR[$dir]) ) return $this->cacheMD5_DIR[$dir];
    if (!is_dir($dir)){
        return false;
    }

    $filemd5s = array();
    $d = dir($dir);
    
    
    if( $d ){

      while (false !== ($entry = $d->read())){
          if ($entry != '.' && $entry != '..'){
               if (is_dir($dir.'/'.$entry)){
                   $filemd5s[] = $this->MD5_DIR($dir.'/'.$entry);
               }else{
                   $filemd5s[] = md5_file($dir.'/'.$entry);
               }
           }
      }
      $d->close();
    }
    
    $this->cacheMD5_DIR[$dir] = md5(implode('', $filemd5s));
    
    return $this->cacheMD5_DIR[$dir];
  }

/*
 *
 * name: Время последнего изменения состояний конверторов
 * @return string
 *
 */
  function GetConverterTs(){
    return Site()->Config( 'converter.ts' , time() );
  }

  // время последнего изменения файлов css для кеширования
  function GetTsCss(){
    return md5(
      $this->MD5_DIR( $_SERVER['DOCUMENT_ROOT']."/css" ).
      $this->MD5_DIR( $_SERVER['DOCUMENT_ROOT']."/js" )
    );
  }

  // получение результата
  function AJAXResult(){
    return $this->AJAXRes;
  }

  // проверка на то что пользователь пользовался этой функией
  function AJAXIsResult(){
    return $this->isAJAXf;
  }

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}

  function GetClassName() {
    return 'TSite';
  }
  
  
  
  
  
  /**
   * Чтение версии из файла
   */
  function GetVersionTxt(){
    return file_get_contents( $_SERVER['DOCUMENT_ROOT'] . "/version.txt");
  }
  
  
  
  function GetGuest(){
    $Filter = array(
        'Filter' => array(
            'Login' => 'Guest',
            "Interprise" => 0
        )
    );
    $ResUser = user::Filter( $Filter );
    if( !$ResUser->Count ){
      return user::AddByArray(array(
          'Login'         => 'Guest',
          'Pass'          => '',
          'InterpriseId'  => 0
      ));
    }
    return $ResUser->First;
  }
  
  

  function GetLinkLogin(){
    return Self()->IsGuest ? "/back/?ref=".$_SERVER['REQUEST_URI'] : '/back/';
  }

  function GetLinkLoginPublic(){
    return "/?ref=".$_SERVER['REQUEST_URI'];
  }

  function GetAccesses(){
    return access::All();
  }

  # Получение всех типов плейсов
  function GetAllTypesPlace(){
    return placetype::All();
  }

  # Получение всех типов плейсов
  function GetAllConversion(){
    return conversion::All();
  }

  function GetJSONOptions(){
    $a = new report_helper();
    return json_encode( $a->ListFilter() , JSON_NUMERIC_CHECK);
  }

  # параметры, которые создал пользователь
  function GetMyParameters(){
    return $this->VirualParameters;
  }

  # Получение всех пользователей
  function GetAllUser(){
    $t = user::Id(0);
    $SQL = "select * from user WHERE interprise = ".Self()->Interprise->Id." AND id > 101 AND type = 0 ORDER BY IF(fio='',login,fio)";
    $res = TListGroup::Prepare( $SQL , $t );
    $res->Elements;
    $res->SortUser();
    return $res;
  }

  function GetMyFolderPlaceMaps( $Place ){
    $UFolder = $this->GetMyFolderData();
    mkdir( $UFolder."/placemaps" , 0755 );
    mkdir( $UFolder."/placemaps/" . $Place->Id , 0755 );
    mkdir( $UFolder."/placemaps/" . $Place->Id . "/z" , 0755 );
    return $UFolder."/placemaps/" . $Place->Id . "/z";
  }

  function GetMyFolderData(){
    $pathToFolder = realpath( $_SERVER['DOCUMENT_ROOT'])."/../user-data/";
    if( !file_exists($pathToFolder) ){
      mkdir( $pathToFolder , 0755);
    }
    $pathToFolder .= "u" . Self()->Interprise->Id;
    if( !file_exists($pathToFolder) ){
      mkdir( $pathToFolder , 0755 );
    }
    return $pathToFolder;
  }

  function GetMyFolderLogicIcon(){
    $pathToFolder = $this->MyFolderData . "/logicicon";
    if( !file_exists( $pathToFolder ) ){
      mkdir( $pathToFolder , 0755 );
    }
    return $pathToFolder;
  }

  function GetAllLogicIcons(){

    $Icons = array();
    if ($handle = opendir( $this->MyFolderLogicIcon )) {
      while (false !== ($entry = readdir($handle))) {

          if( !preg_match('/^(.*)\.png$/' , $entry , $m) ) continue;
          $Icons[] = $entry;
      }
      closedir($handle);
    }
    return $Icons;
  }

  
  
  
  static function GetAllGroup(){
    $Filter = array(
      'Filter' => array(
        'Type' =>1 ,
      )
    );
    $res = user::Filter($Filter);
    $res->Elements;
    $res->SortUser();
    return $res;
  }
  
  
  
  
  /**
   * Получение конфига и занесение его в память
   * 
   * @param string $param
   * @param any $value
   * @return any
   */
  function Config( $param, $value='' ){

    // Если это получение для форм. Префикс Form.<:string>.<:string>
    if( preg_match('/Form\.(.*)\.(.*)/' , $param) ){
      $param = str_replace(".","_",$param);
      $val = smarty()->get_config_vars($param);
      if( isset( $val ) ) return $val;
    }
    
    // Если конфига еще нет то надо создать
    if( !isset( TSite::$_R['Config'] ) ) {
      foreach( config::All()->GroupBy( 100 )->Elements as $iConfigGroup ){
        foreach( $iConfigGroup->Elements as $iConfig ) {
          TSite::$_R['Config'][$iConfig->Parametr] = array(
            'Value'   => ($iConfig->InputType==1 && preg_match( '|^text\.|', $iConfig->Parametr )) ? nl2br($iConfig->Value) : $iConfig->Value,
            'Object'  => $iConfig
          );
        }
      }
    }
    
    // Если запрашиваемого конфига нет то надо его создать
    if( !isset( TSite::$_R['Config'][$param] ) ) {
      if( $param == 'AdminListElemsPerPage' and empty($value) ){
        $value = 30;
      }

      $Add = Array(
        'Parametr'  => $param,
        'Value'     => $value,
        'About'     => $param,
        'InputType' => preg_match( '/^(text|html)\./', $param ) ? 1 : 0,
      );
      $AddObj = config::AddByArray( $Add );
      TSite::$_R['Config'][$param] = array(
        'Value'   => $value,
        'Object'  => $AddObj,
      );
    }
    return TSite::$_R['Config'][$param]['Value'];
  }
  
  
  
  
  


  
  /**
   * Устновка значения конфига
   * 
   * @param string $param
   * @param any $Value
   */
  function SetConfig( $param, $Value ){
    if( isset(TSite::$_R['Config'][$param]) ){
      TSite::$_R['Config'][$param]['Value']  = $Value;
      TSite::$_R['Config'][$param]['Object']->Value = $Value;
    }else{
      return $this->Config($param, $Value);
    }
    return $Value;
  }
  
  
  
  
  
  
  

  function GetLogoAuthDef(){
    return '/img/new/logonag.png';
  }

  function GetLogoPagesDef(){
    return '/img/new/mainlogo.png';
  }

  function GetLogoAuth(){
    return $this->Config( 'img.auth.' . Self()->Interprise->Id , $this->LogoAuthDef );
  }

  function GetLogoPages(){
    return $this->Config( 'img.pages.' . Self()->Interprise->Id , $this->LogoPagesDef );
  }

  static function CleanConfig()
  {
//    function_init_main_engine();
//    echo "unset\n";
    unset( TSite::$_R['Config'] );
    function_init_main_engine();
  }


  function Objectrule( $param ){
    if( !isset(TSite::$_R['Objectrule']) ) {
      $Filter = array(
        'Filter' => array(
          'Id >' => 0
        )
      );
      foreach( objectrule::Filter($Filter)->Elements as $iObjectRule ){
        TSite::$_R['Objectrule'][$iObjectRule->Ident] = $iObjectRule;
      }
    }
    if( isset(TSite::$_R['Objectrule'][$param]) ) {
      return TSite::$_R['Objectrule'][$param];
    }
    return objectrule::Id(0);
  }


  function GetTitle(){
    return $this->Config('DefaultTitle','Заголовок сайта');
  }

  function GetKeywords(){
    return $this->Config('DefaultKeywords');
  }

  function GetDescription(){
    return $this->Config('DefaultDescription','');
  }

  function NewVerifyQuestion($n){
    $n1 = mt_rand(0,4);
    $r  = mt_rand(3,7);
    $n2 = $r-$n1;
    $z = $n2>=0 ? '+':'';
    $_SESSION['VerifyQuestion'][$n] = "$n1{$z}$n2";
    $_SESSION['VerifyQuestionAnswer'][$n] = $r;
  }

  function InitVerifyQuestion()
  {
    $n = mt_rand(1,999);
    if( !isset(
      $_SESSION['VerifyQuestion']
      ,$_SESSION['VerifyQuestionAnswer']
      ,$_SESSION['VerifyQuestion'][$n]
      ,$_SESSION['VerifyQuestionAnswer'][$n]
    ) )
    {
      $this->NewVerifyQuestion($n);
    }
    return $n;
  }

  function GetTimezone(){
    return timezone::All();
  }

  function GetVerifyQuestion(){
    $n = $this->InitVerifyQuestion();
    return $_SESSION['VerifyQuestion'][$n]."<input name=\"VerifyAnswerNumber\" type=\"hidden\" value=\"{$n}\">";
    //return Array('N'=>$n,'Q'=>$_SESSION['VerifyQuestion']);
  }

  function VerifyAnswer()
  {
    return true;
    $n = isset($_REQUEST['VerifyAnswerNumber'])
      ? intval($_REQUEST['VerifyAnswerNumber'])
      : 0;
    if( !isset(
          $_SESSION['VerifyQuestionAnswer']
          ,$_SESSION['VerifyQuestionAnswer'][$n]
    ) )
    {
      //trigger_error( 'VerifyQuestionAnswer unset' );
      return false;
    }
    if( $_SESSION['VerifyQuestionAnswer'][$n] == intval($_REQUEST['VerifyAnswer']) )
    {
      unset($_SESSION['VerifyQuestion'][$n]);
      unset($_SESSION['VerifyQuestionAnswer'][$n]);
      return true;
    }
    else return false;
  }

  function ReturnMeterConverterCount()
  {
    return true;
    if(meter::All()->Count or converter::All()->Count) return true;
    return false;
  }

  function is_back($tovar_id){
    if( $_SERVER['HTTP_REFERER'] !== ('http://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']) )
      return $_SERVER['HTTP_REFERER'];
    else
      return false;
  }

  function GetError404(){
//    $oFixedpage = textpage::Id( Site()->Config('object.textpage.id.error404',1) );
    //header("HTTP/1.0 404 Not Found");
//    smarty()->assign('oPage', $oFixedpage);
    if(!Self()->IsGuest)
    {
      header("Status: 404 Not Found");
      smarty()->display('404.tpl');
    }
    else
    {
      header("Location: ".Site()->LinkLoginPublic);
    }
    die();
  }

  /* = ========================= */
  function GoFormMeterplace()
  {
    if( Site()->IsAjax() ){
      //~ echo "Success";
      return false;
    }
    $ref = isset($_REQUEST['REF'])?$_REQUEST['REF']:'/back/meterplace/';
    header("Location: ".$ref); die();
  }
  function GoFormMeter()
  {
    if( Site()->IsAjax() ){
      //~ echo "Success";
      return false;
    }
    $ref = isset($_REQUEST['REF'])?$_REQUEST['REF']:'/back/meterplace/';
    header("Location: ".$ref); die();
  }

  function IsAjax(){
    return isset($_SERVER['HTTP_X_REQUESTED_WITH']) && !empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest';
  }

  /*
  function GetConverters()
  {
    $Filter = array(
      'Filter' => array(
        'Type NOT IN' => array(
          convertertype::VirtualConverter()->Id,
          convertertype::CalcConverter()->Id
        ),
      ),
      'Order' => array(
        'About' => 'ASC',
        'Ip'    => 'ASC'
      )
    );
    $res = converter::Filter($Filter);
    $res->Elements;
    $res->SortConverter();
    return $res;
  }
  */

  function GetVConverters(){
    return vconverter::All();
  }
  
  
  
  
  
  /**
   * Все форматы для отчетов
   * 
   * @return TListGroup
   */
  function GetExtensions(){
    $Filter = array(
        'GroupBy' => array( 'Name' )
    );
    return extension::Filter($Filter);
  }


  function GetAllConverters()
  {
    $SQL = str_replace(array("\t","\n","\r")," " , "
    select * from converter
    where interprise = " .Self()->Interprise->Id. "
    ORDER BY FIELD(type_id,".convertertype::CalcConverter()->Id.",".convertertype::VirtualConverter()->Id.") DESC ,
    about ASC , ip ASC
    ");
    $t = converter::Id(0);
    $res = TListGroup::Prepare( $SQL , $t );
    //~ $res->Elements;
    //~ $res->SortConverter();
    return $res;
  }

  function GetRules()
  {
    return rule::All();
  }

  function GetMeters()
  {
    return meter::All();
  }

  function GetConversion(){
    return conversion::All();
  }
  
  /**
   * Получение всех доп типов приборов учета
   * 
   * @return TListGroup
   */
  function GetMeterExtraTypes(){
    return meter_extra_type::All();
  }


  /*
    Возвращает все счетчики импульсов
  */
  function GetMetersImpulses(){
    $Filter = array(
      'Filter' => array(
        'DllId' => array(
          'SNR_RS_COUNTER_8I',
          'LORA_CI_11',
          'LORA_CI_12',
          'LORA_CI_21',
          'LORA_CI_13_MER',
          'LORA_TD_11',
          'LORA_TP_11',
          'LORA_MC_0101',
          'LORA_AS_0101',
          'LORA_MS_0101',
          'LORA_CBE1',
          'LORA_SS_0101',
          'LORA_Electro',
          'LORA_GM_2',
          'LORA_LM_1',
        )
      )
    );
    $ResMeterTypes = metertype::Filter($Filter);
    $res_meter_types = array();
    foreach ($ResMeterTypes->Elements as $iMeterType) {
      $res_meter_types[$iMeterType->Id] = $iMeterType->Id;
    }
    $Filter = array(
      'Filter' => array(
        'Type' => $res_meter_types
      )
    );
    return meter::Filter($Filter);
  }


  protected function GetFullRules()
  {
    return isset( $GLOBALS['FullRules'] )
      and $GLOBALS['FullRules'];
  }
  function GetEnterprise()
  {
    return interprise::Id( isset($_SERVER['HTTP_ENTERPRISE']) ? $_SERVER['HTTP_ENTERPRISE'] : 0 );
  }

  function GetConverterStatus() {
    return array(
      'work'      => 'conv_work',
      'notwork'   => 'conv_notwork',
      'work_notwork'   => 'conv_work_notwork',
      'action'    => 'conv_action',
      'ixcluded'  => 'conv_ixcluded_yes',
    );
  }

  function GetVConverterStatus() {
    return array(
      'work'      => 'conv_work',
      'notwork'   => 'conv_notwork',
      'work_notwork'   => 'conv_work_notwork',
    );
  }

  function GetConverterFields() {
    $R = array();
    if( Self()->IsIssetRule('converter', 'Edit'  ) )                $R['ActionEdit']     = array( 'Name' => 'E' , 'TD' => 'class="action"' );
    if( Self()->IsIssetRule('converter', 'Delete') )                $R['ActionDelete']   = array( 'Name' => 'D' , 'TD' => 'class="action"');
    if( Self()->IsIssetRule('converter', 'ViewAbout'  ) )           $R['ShowTitle']      = array( 'Name' => 'conv_About' );
    if( Self()->IsIssetRule('converter', 'ViewTypeTitle'  ) )       $R['TypeTitle']      = array( 'Name' => 'conv_Type' );
    if( Self()->IsIssetRule('converter', 'ViewIp'  ) )              $R['ShowIp']         = array( 'Name' => 'conv_Ip' );
    if( Self()->IsIssetRule('converter', 'ViewPort'  ) )            $R['ShowPort']       = array( 'Name' => 'conv_Port' );
    if( Self()->IsIssetRule('converter', 'ViewPortcontrol'  ) )     $R['ShowPortcontrol']= array( 'Name' => 'conv_Portcontrol' );
    if( Self()->IsIssetRule('converter', 'ViewShowIsExcluded'  ) )  $R['ShowIsExcluded'] = array( 'Name' => 'conv_Interview' );
    if( Self()->IsIssetRule('converter', 'ViewMetersCount'  ) )     $R['MetersCount']    = array( 'Name' => 'conv_count_meter', 'TD' => 'align=right' );
    return $R;
  }

  function GetVConverterFields() {
    $R = array();
    if( Self()->IsIssetRule('converter', 'Edit'  ) )                $R['ActionEdit']     = array( 'Name' => 'E' , 'TD' => 'class="action"' );
    if( Self()->IsIssetRule('converter', 'Delete') )                $R['ActionDelete']   = array( 'Name' => 'D' , 'TD' => 'class="action"');
    if( Self()->IsIssetRule('converter', 'ViewAbout'  ) )           $R['ShowTitle']      = array( 'Name' => 'conv_About' );
    if( Self()->IsIssetRule('converter', 'ViewMetersCount'  ) )     $R['MetersCount']    = array( 'Name' => 'conv_count_meter', 'TD' => 'align=right' );
    return $R;
  }

  function GetCConverterFields() {
    $R = array();
    if( Self()->IsIssetRule('converter', 'Edit'  ) )                $R['ActionEdit']     = array( 'Name' => 'E' , 'TD' => 'class="action"' );
    if( Self()->IsIssetRule('converter', 'Delete') )                $R['ActionDelete']   = array( 'Name' => 'D' , 'TD' => 'class="action"');
    if( Self()->IsIssetRule('converter', 'ViewAbout'  ) )           $R['ShowTitle']      = array( 'Name' => 'conv_About' );
    if( Self()->IsIssetRule('converter', 'ViewMetersCount'  ) )     $R['MetersCount']    = array( 'Name' => 'conv_count_meter', 'TD' => 'align=right' );
    return $R;
  }


  function GetMeterFields() {
    $R = array();
    if( Self()->IsIssetRule('meter', 'Edit'  ) )            $R['ActionEdit']     = array( 'Name' => 'E' , 'TD' => 'class="action"' );
    if( Self()->IsIssetRule('meter', 'Delete') )            $R['ActionDelete']   = array( 'Name' => 'D' , 'TD' => 'class="action"');
    if( Self()->IsIssetRule('meter', 'ViewAbout'  ) )       $R['ShowAbout']      = array( 'Name' => 'meter_About' );
    if( Self()->IsIssetRule('meter', 'ViewNumSerial'  ) )   $R['ShowNumSerial']  = array( 'Name' => 'meter_NumSerial' );
    if( Self()->IsIssetRule('meter', 'ViewType'  ) )        $R['ShowType']       = array( 'Name' => 'meter_Type' );
    if( Self()->IsIssetRule('meter', 'ViewNum485'  ) )      $R['ShowNum485']     = array( 'Name' => 'meter_Num485' );
    if( Self()->IsIssetRule('meter', 'ViewCoef'  ) )        $R['ShowCoef']       = array( 'Name' => 'meter_Coef' );
    if( Self()->IsIssetRule('meter', 'ViewStatus'  ) )      $R['ShowStatus']     = array( 'Name' => 'meter_Status' );
    return $R;
  }


  function GetMeterReportFields() {
    $R = array();
    if( Self()->IsIssetRule('meter', 'ViewAbout'  ) )       $R['ShowAbout']      = array( 'Name' => 'meter_About' );
    if( Self()->IsIssetRule('meter', 'ViewNumSerial'  ) )   $R['ShowNumSerial']  = array( 'Name' => 'meter_NumSerial' );
    if( Self()->IsIssetRule('meter', 'ViewType'  ) )        $R['ShowType']       = array( 'Name' => 'meter_Type' );
    if( Self()->IsIssetRule('meter', 'ViewNum485'  ) )      $R['ShowNum485']     = array( 'Name' => 'meter_Num485' );
    if( Self()->IsIssetRule('meter', 'ViewCoef'  ) )        $R['ShowCoef']       = array( 'Name' => 'meter_Coef' );
    if( Self()->IsIssetRule('meter', 'ViewStatus'  ) )      $R['ShowStatus']     = array( 'Name' => 'meter_Status' );
    return $R;
  }


  function GetVMeterFields() {
    $R = array();
    if( Self()->IsIssetRule('meter', 'Edit'  ) )            $R['ActionEdit']     = array( 'Name' => 'E' , 'TD' => 'class="action"' );
    if( Self()->IsIssetRule('meter', 'Delete') )            $R['ActionDelete']   = array( 'Name' => 'D' , 'TD' => 'class="action"');
    if( Self()->IsIssetRule('meter', 'ViewAbout'  ) )       $R['ShowAbout']      = array( 'Name' => 'meter_About' );
    return $R;
  }

  function GetLicenseLimit(){
    return Self()->Interprise->LimitMeter;
  }

  function GetLimitIsExceeded(){
    return $this->LicenseLimit <= $this->Meters->Count;
  }



  function GetMarkAll(){
    $Filter = array(
      'Order' => array(
        'Title' => 'ASC'
      )
    );
    return mark::Filter($Filter);
  }


}
