<?php
class Utils
{
	static protected $Result = Array();
  static protected $smtp = null;
  
  
  /*
    Отдает кол-во страниц исходя из общего кол-ва и сколько надо показывать
    @param count_all Общее кол-во
    @param count_page кол-во на странице
    @return Int кол-во страниц
  */
  static function CountPages( $count_all , $count_page ){
    $pages = ceil( $count_all / $count_page );
    return $pages == 1 ? 1 : $pages;
  }
  
  
  /*
    Убираение строк и лишних пробелов
    @param Str String
    @return String
  */
  static function Strip( $str ){
    return preg_replace( '/[\r\n\t|\ \ ]+/', ' ', $str );
  }
  
  
  static function ObjectToJSON( $Object ){
    $Ar = array();
    foreach( $Object::$FInit as $Ident => $set ){
      if( in_array($set['type'],array('fltcnt','multy')) ) continue;
      if( isset( $set['object'] ) ){
        $Ar[ strtolower($Ident) ] = $Object->$Ident->Id;
      }else{
        $Ar[ strtolower($Ident) ] = $Object->$Ident;
      }
    }
    return $Ar;
  }
  
  
  static function ElementsToJSON( $Elements ){
    $Ar = array();
    foreach( $Elements as $iElem ){
      $Ar[] = self::ObjectToJSON($iElem);
    }
    return json_encode( $Ar );
  }
  
  
  
  
  
  
  /*
    Построение навигации
    @param count_all кол-во 
  */
  static function Paginator( $count_all , $count_page , $is_all = false ){
    
    
    $pages = array();
    $pageMore = array(
      'name' => '...',
      'num' => 0
    );
    
    $all_pages = Utils::CountPages( $count_all , $count_page );
    
    /*
      Сколько показывать страниц по краям если 
      пагинатор ушел за пределы
          
          ?
      +-------+
      | 1 | 2 | ... | 600 | ... | 700 | 701 |
      
    */
    $page_count_edge = Site()->Config('ru.sys.page_count_edge' , 1);
    
    /*
      Сколько страницы должно окружать текущую страницу
      
           ?              ?
      +---------+    +---------+
      | 10 | 11 | 12 | 13 | 14 |
    */
    $pages_beside = Site()->Config('ru.sys.page_beside' , 1);
    
    
    for( $i = 0 ; $i < $all_pages ; $i++ ){
      
      
      
      if( !$is_all ){
        
        // принудительное добавление страницы
        $hard = false;
        
        // добавление многоточия
        $is_more = false;

        
        // по бокам
        if( $i <= Site()->Page + $pages_beside && $i >= Site()->Page - $pages_beside ){
          $hard = true;
        }
        
        // первые
        if( $i < $page_count_edge ){
          $hard = true;
        }
        
        
        // последние
        if( $i >= $all_pages - $page_count_edge ){
          $hard = true;
        }

        if( !$hard && $i == $page_count_edge ){
          $hard = true;
          $is_more = true;
        }
        
        if( !$hard && $i == $all_pages - 1 - $page_count_edge){
          $hard = true;
          $is_more = true;
        }
        
        if( !$hard ) continue;
        if( $is_more ){
          if( !$pages[count($pages )-1]['num'] ) continue;
          $pages[] = $pageMore;
          continue;
        }
        
      }
      
      $pages[] = array(
        'num' => $i +1,
        'name' => $i+1,
        'is_active' => $i == Site()->Page
      );
    }    
    return $pages;
  }
  
  
  

  function UploadImageSave($FILE, $path='smallimage'){
    
    $tmp_name = is_array( $FILE['tmp_name'] ) ? $FILE['tmp_name'][0] : $FILE['tmp_name'];
    $size = is_array( $FILE['size'] ) ? $FILE['size'][0] : $FILE['size'];
    
    if( is_uploaded_file( $tmp_name ) and intval( $size )>0 ){
  		$about = $FILE['name'];
      chmod($path, 0777);
      if( $res = move_uploaded_file( $tmp_name , $path.$about) ){
          return true;
      }
    } else return false;

  }

  static function return_bytes($val){
    $val = trim($val);
    $last = strtolower($val{strlen($val)-1});
    switch($last) {
    // The 'G' modifier is available since PHP 5.1.0
    case 'g':
      $val *= 1024;
    case 'm':
      $val *= 1024;
    case 'k':
      $val *= 1024;
    }
    return $val;
  }
  
  static function CreateSmallJpeg($file_orig, $file_dest, $w, $h=0){
    ini_set('memory_limit','128M');
    if( !is_file($file_orig)) return false;
    list($width, $height, $type, $attr) = getimagesize($file_orig);
    if( (memory_get_usage()+8*$width*$height*1.1+filesize($file_orig)) > Utils::return_bytes(ini_get('memory_limit')) ) return  Array('nW'=>-1, 'nH'=>-1, 'oW'=>$width, 'oH'=>$height);
//    if($width*$height>6200000) return  Array('nW'=>-1, 'nH'=>-1, 'oW'=>$width, 'oH'=>$height);
    $handle = fopen($file_orig, "rb");
    $data = fread($handle, filesize($file_orig));
    fclose($handle);
    $im_orig =imagecreatefromstring($data);
    imagealphablending($im_orig, false);
    imagesavealpha($im_orig, true);
    $w_or = imagesx($im_orig);
    $h_or = imagesy($im_orig);
    $prop = $h_or/$w_or; // пропорции оригинального изображения
    if(!$w and !$h) return false;
    if(!$h) $h =($h==0)? $prop*$w : $h;
    elseif(!$w) $w = $h/$prop;
    $im = imagecreatetruecolor($w ,$h );
    $red = imagecolorallocate($im, 255, 0, 0);
    $white = imagecolorallocate($im, 0, 0, 0);    
    //$trans_colour = imagecolorallocatealpha($im, 0, 0, 0, 127);

    // Make the background transparent
    imagecolortransparent($im, $white);

    // Draw a red rectangle
    //imagefilledrectangle($im, 4, 4, 50, 25, $red);    
    
    
    //imagefill($im, 0, 0, $trans_colour);
    
    $rez = imagecopyresampled($im ,$im_orig,0,0,0,0,$w ,$h ,$w_or,$h_or);
    if( preg_match('/.png$/',$file_dest))
      imagepng($im , $file_dest, 9);
    else
      imagejpeg($im , $file_dest, 85);
   
    return Array('nW'=>$w, 'nH'=>$h, 'oW'=>$w_or, 'oH'=>$h_or);
  }



  static function rus2eng($text){
    $converter = array(
        'а' => 'a',   'б' => 'b',   'в' => 'v',
        'г' => 'g',   'д' => 'd',   'е' => 'e',
        'ё' => 'e',   'ж' => 'zh',  'з' => 'z',
        'и' => 'i',   'й' => 'y',   'к' => 'k',
        'л' => 'l',   'м' => 'm',   'н' => 'n',
        'о' => 'o',   'п' => 'p',   'р' => 'r',
        'с' => 's',   'т' => 't',   'у' => 'u',
        'ф' => 'f',   'х' => 'h',   'ц' => 'c',
        'ч' => 'ch',  'ш' => 'sh',  'щ' => 'sch',
        'ь' => '\'',  'ы' => 'y',   'ъ' => '\'',
        'э' => 'e',   'ю' => 'yu',  'я' => 'ya',

        'А' => 'A',   'Б' => 'B',   'В' => 'V',
        'Г' => 'G',   'Д' => 'D',   'Е' => 'E',
        'Ё' => 'E',   'Ж' => 'Zh',  'З' => 'Z',
        'И' => 'I',   'Й' => 'Y',   'К' => 'K',
        'Л' => 'L',   'М' => 'M',   'Н' => 'N',
        'О' => 'O',   'П' => 'P',   'Р' => 'R',
        'С' => 'S',   'Т' => 'T',   'У' => 'U',
        'Ф' => 'F',   'Х' => 'H',   'Ц' => 'C',
        'Ч' => 'Ch',  'Ш' => 'Sh',  'Щ' => 'Sch',
        'Ь' => '\'',  'Ы' => 'Y',   'Ъ' => '\'',
        'Э' => 'E',   'Ю' => 'Yu',  'Я' => 'Ya',

        '–' => '-','/' => '-',
    );
    return strtr($text, $converter);
  }
  
  static function cirilic_file_name($text){
    $converter = array(
        'а' => 'a',   'б' => 'b',   'в' => 'v',
        'г' => 'g',   'д' => 'd',   'е' => 'e',
        'ё' => 'e',   'ж' => 'zh',  'з' => 'z',
        'и' => 'i',   'й' => 'y',   'к' => 'k',
        'л' => 'l',   'м' => 'm',   'н' => 'n',
        'о' => 'o',   'п' => 'p',   'р' => 'r',
        'с' => 's',   'т' => 't',   'у' => 'u',
        'ф' => 'f',   'х' => 'h',   'ц' => 'c',
        'ч' => 'ch',  'ш' => 'sh',  'щ' => 'sch',
        'ь' => '\'',  'ы' => 'y',   'ъ' => '\'',
        'э' => 'e',   'ю' => 'yu',  'я' => 'ya',

        'А' => 'A',   'Б' => 'B',   'В' => 'V',
        'Г' => 'G',   'Д' => 'D',   'Е' => 'E',
        'Ё' => 'E',   'Ж' => 'Zh',  'З' => 'Z',
        'И' => 'I',   'Й' => 'Y',   'К' => 'K',
        'Л' => 'L',   'М' => 'M',   'Н' => 'N',
        'О' => 'O',   'П' => 'P',   'Р' => 'R',
        'С' => 'S',   'Т' => 'T',   'У' => 'U',
        'Ф' => 'F',   'Х' => 'H',   'Ц' => 'C',
        'Ч' => 'Ch',  'Ш' => 'Sh',  'Щ' => 'Sch',
        'Ь' => '\'',  'Ы' => 'Y',   'Ъ' => '\'',
        'Э' => 'E',   'Ю' => 'Yu',  'Я' => 'Ya',
    );
    return strtr($text, $converter);
  }
  
  static function replace_uncorrect_symbol($text = ''){
    $converter = array(
        '-' => '_',   '.' => '_',   ',' => '_',
        ' ' => '_',   '\'' => '',  '(' => '_',
        ')' => '_'
    );
    return strtr($text, $converter);
  }


  static function str2url($str) {
    // переводим в транслит
    $str = Utils::rus2eng($str);
    // в нижний регистр
    $str = strtolower($str);
    // заменям все ненужное нам на "-"
    $str = preg_replace('~[^a-z0-9-]+~u', '-', $str);
    // удаляем начальные и конечные '-'
    $str = trim($str, "-");
    return $str;
  }

  static function EmailValid($email){
    return (preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$/",$email)>0) or
    (preg_match("/<[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})>$/",$email)>0);
  }

  static function addslashes($t)
  {
  	/* @ так нельзя но не могу понять в чем ошибка */
  	return get_magic_quotes_gpc() ? $t : @addslashes($t);
  }

  static function stripslashes($t)
  {
    return get_magic_quotes_gpc() ? $t : stripslashes($t);
  }
  
  static function testRealDate( $Year, $Month, $Day, $Hour )
  {
    $Datetime = new Datetime();
    $Datetime->setDate( $Year, $Month, $Day );
    $Datetime->setTime( $Hour, 0, 0 );
    return 0 == strcmp( $Datetime->format("Y.m.d:H\n"), sprintf( "%04d.%02d.%02d:%02d\n", $Year, $Month, $Day, $Hour ) );
  }
  
  
  function LoadFile($FILE,$t){

    $dir = $_SERVER['DOCUMENT_ROOT'].$t->DirForUploadsFile_1;
    if( !is_dir($dir)) mkdir($dir,0777);
    $dir_t = $_SERVER['DOCUMENT_ROOT'].$t->DirForUploadsFile_1.$t->DirForUploadsFile_2;
    if( !is_dir($dir_t) ) mkdir($dir_t,0777);
    $dir_t_id = $t->DirForUploadsFile;
    if( !is_dir($dir_t_id) ) mkdir($dir_t_id,0777);
    if( is_uploaded_file($FILE['tmp_name']) and intval($FILE['size'])>0 )
    {
      preg_match( '/^(.*)\.([a-z]*)$/' , $FILE['name'] , $m );
      list($source,$_name , $ext) = $m;
      $name = self::str2url($_name).".".$ext;
  		if( move_uploaded_file($FILE['tmp_name'], $t->DirForUploadsFile.$name) ){
  		  chmod($DIR.$name,0666);
  		  return 1;
  		}
  		return 2;
    } else {
    return false;}
  }
  
  
  function LoadFileByPath( $FILE,$ArPath , $w=0 , $h=0){
    
    $path = $_SERVER['DOCUMENT_ROOT'];
    
    $P = "/".implode("/",$ArPath)."/";
    
    foreach( $ArPath as $dir ){
      $path .= $dir."/";
      if( !is_dir($path) ) {
        mkdir($path,0777);
      }
    }
    if( !in_array( $FILE['type'] , array( "image/gif" , "image/jpeg" , "image/png"))) {
      return false;
    }
    if( is_uploaded_file($FILE['tmp_name']) and intval($FILE['size'])>0 )
    {
      preg_match( '/^(.*)\.(gif|jpeg|jpg|png)$/' , $FILE['name'] , $m );
      list($source,$_name , $ext) = $m;
      $name = self::str2url($_name).".".$ext;
      $this->CreateSmallJpeg($FILE['tmp_name'], $path.$name, $w, $h);
  		chmod($path.$name,0666);
  		return $P.$name;
    } else {
    return false;}

  }
  
  

  /**
   * Преодразование JSON в массив из полей объекта
   * 
   * @param object $oObject
   * @param array $a
   * @return array
   */
  static function reparseJSON( $oObject , $a = array() ){
    
    if( !property_exists($oObject, 'FieldsToJSON') ){
      return $a;
    }
    
    

    $fields = array();

    if( isset( $oObject->FieldsToJSON ) ){
      $fields = $oObject->FieldsToJSON;
    } 

    $res = array();

    foreach( $fields as $F => $f ){
      if( isset( $a[$f] ) ){
        $m = $F;
        if( isset( $oObject::$FInit[ $F ]['object'] ) ){
          $m = $F."Id";
        }
        $res[ $m ] = $a[$f];
        if( preg_match( '/nterprise$/', $F ) ){
          $res[ $m ] = Self()->Interprise->Id;
        }
      }
    }

    /*
      Получение невалидных данных
    */
    foreach( $a as $F => $f ){
      if( !array_search( $F , $fields ) ){
        $res['not_valid_json'][ $F ] = $f;
      }
    }
    return $res;
  }



}
