<?php
/*
Имя класса cconverter
Имя файла cconverter.class.php ( cconvertercustom.class.php )
Поля класса:
Id : id
Type : int
About : string
MeterOk : int
Interprise : object
*/
class cconverter extends cconvertercustom{


  public $FieldsToJSON = array(
    'Id'                => 'id',
    'Type'              => 'type',
    'About'             => 'about',
  );
  
  
  
  public $NeedDoUserLog = true;
  
  
  
  function Delete() {
    if( $this->Interprise->Id != Self()->Interprise->Id ){
      return false;
    }
    TObject2::StaticDelete($this);
  }
  
  
  
  
  
  
  static public function &AddByArray($A){
    $A['TypeId'] = convertertype::FindByIdent("CALC")->Id;
    
    if( !$A['TypeId'] ){
      include( $_SERVER['DOCUMENT_ROOT'] . '/install/converter_type.php');
      $A['TypeId'] = convertertype::FindByIdent("CALC")->Id;
    }
    
    if( !isset($A['InterpriseId']) ){
      $A['InterpriseId'] = Self()->Interprise->Id;
    }
    $t = new cconverter();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }
  
  
  

  static public function &AddByRequest(){
    $_REQUEST['TypeId'] = convertertype::FindByIdent("CALC")->Id;
    
    if( !$_REQUEST['TypeId'] ){
      include( $_SERVER['DOCUMENT_ROOT'] . '/install/converter_type.php');
      $_REQUEST['TypeId'] = convertertype::FindByIdent("CALC")->Id;
    }
    
    if( !isset( $_REQUEST['InterpriseId']  ) ){
      $_REQUEST['InterpriseId'] = Self()->Interprise->Id;
    }
    $t = new cconverter();
    TObject2::StaticAddByRequest($t);
    return $t;
  }
  
  
  public function &UpdateByRequest(){
    $_REQUEST['TypeId'] = convertertype::FindByIdent("CALC")->Id;
    $_REQUEST['InterpriseId'] = Self()->Interprise->Id;
    TObject2::StaticUpdateByRequest($this);
  }
  public function UpdateByArray($A){
    $A['TypeId'] = convertertype::FindByIdent("CALC")->Id;
    $A['InterpriseId'] = Self()->Interprise->Id;
    TObject2::StaticUpdateByArray($this,$A);
  }
  





  /*
    Кол-во приборов учета с ошибками
    @return TListGroup
  */
  function GetMetersError(){
    $Filter = array( 
      'Filter' => array( 
        'Converter' => $this->Id,
        'IsOk'      => 0
      )
    );
    return cmeter::Filter( $Filter );
  }
  
  
  
  /*
    Преобразование объекта в массив для построение "дерева"
    @return Array
  */
  function GetToJsTree(){
    return array(
      'text' => htmlspecialchars($this->Title,ENT_QUOTES),
      'id' => "cconverter_tree_".$this->Id,
      'children' => (bool)$this->Meters->Count,
      'parent' => "#",
      'icon' => Site()->Config('icon.cconverter') . " text-{$this->RowClass}"
    );
  }
  
  


  /*
    ссылка на конвертер
    @return String
  */
  function GetLink(){
    return "/cconverter/{$this->Id}/";
  }


  /*
    ссылка на страницу редактирования конвертера
    @return String
  */
  function GetLinkEdit(){
    return "{$this->Link}edit/";
  }
  


  /*
    ссылка на страницу редактирования конвертера
    @return String
  */
  function GetLinkRule(){
    return "{$this->Link}rule/";
  }
  
  
  /*
    Вывод класса конвертора исходя из его статуса
    @return String
  */
  function GetRowClass(){
    if( $this->IsExcluded ){
      return "excluded";
    }
    
    if( $this->MeterOk == 2 ){
      return "warning";
    }elseif( $this->MeterOk == 1 ){
      return "success";
    }else{
      return "danger";
    }
  }
  
  
  
  
  function GetIsExcluded(){
    return false;
  }
  
  
  
  
  
  
  
  /*
    Вывод статуса конвертора
    @return String
  */
  function GetRowTitle(){
    if( $this->IsExcluded ){
      return "Исключен";
    }
    
    if( $this->MeterOk == 2 ){
      return "Есть проблемы";
    }elseif( $this->MeterOk == 1 ){
      return "Все работает";
    }else{
      return "Не работает";
    }
  }
  
  
  
  
  
  
  /*
    Получение списка приборов учета с учетом страниц
    @return TListGroup
  */
  function GetMetersByPages(){
    $Meters = $this->GetMeters()->GroupBy( Site()->CountInPage )->Elements;
    if( !isset( $Meters[ Site()->Page ] ) ){
      return TListGroup::Init();
    }
    return $Meters[ Site()->Page ];
  }
  
  
  
  
  
  
  
  
  /*
    Получение пагинатора для списка приборов учета
    @return Array
  */
  function GetPagesMeters(){
    $all_count = $this->Meters->Count;
    $count_page = Site()->CountInPage;
    
    $pages = array();
    for( $i = 0 ; $i < Utils::CountPages( $all_count , $count_page ) ; $i++ ){
      $pages[] = array(
        'num' => $i +1,
        'name' => $i+1,
        'is_active' => $i == Site()->Page
      );
    }
    return $pages;  
  }
  
  
  
  
  
  
  
  /*
    Ссылка на добавление прибора учета
    @return String
  */
  function GetLinkAddMeter(){
    return "{$this->Link}addmeter/";
  }
  
  
  
  
  
  
  
  /*
    Ссылка на лог событий
    @return TListGroup
  */
  function GetLinkLog(){
    return "{$this->Link}log/";
  }



  /*
    Ссылка на удаление конвертора
    @return String
  */
  function GetLinkDel(){
    return $this->Link."delete/";
  }
  
  
  
  
  
  
  
  /*
    Получение всех прав на этот узел учета
    @return TListGroup
  */
  function GetPermisson(){
    $sql = str_replace( array("\n","\r","\t") , "" , "SELECT link.* FROM link 
    LEFT JOIN objectrule ON objectrule.id = link.objectrule_id
    LEFT JOIN rule ON rule.id = link.rule_id 
    LEFT JOIN user ON user.id = link.user_id
    WHERE objectrule.id = {$this->Objectrule->Id} 
    and link.whyid ={$this->Id} 
    and link.user_id > 101
    and user.type = 0
    and link.interprise_id = {$this->Interprise->Id}
    GROUP BY user_id , rule_id, whyid,objectrule_id
    ORDER BY user.fio ASC");
    $t = new link();
    return TListGroup::Prepare( $sql , $t );
  }
  
  
  
  
  
  
  
  /*
    Получение Объекта ролей для места 
    @return objectrule
  */
  function GetObjectrule(){
    $Filter = array( 
      'Filter' => array( 
        'Ident' => 'Cconverter'
      )
    );
    $ObjectruleFilter = objectrule::Filter( $Filter );
    if( $ObjectruleFilter->Count ){
      return $ObjectruleFilter->first;
    }
    return objectrule::Id(0);
  }
  
  
  
  
  
  
  
  
  /*
    Удобное название для пользователя
    @@return String
  */
  function GetTitle(){
    if( $this->About != ""){
			return $this->About;
		}elseif( $this->Ip != "" && $this->Port != ""){
			return $this->Ip.":".$this->Port;
		}else{
			return "---";
		}
  }
  
  
  
  
  /*
    Удобное название для пользователя
    @@return String
  */
  function GetIp(){
    return 0;
  }
  
  
  
  
  
  
  
  /*
    Фильтр конверторов
    @return TListGroup
  */
  static public function Filter($aParams = null , $etc = array()){
    if( !isset($aParams['TypeId']) ){
      if( !convertertype::FindByIdent("CALC")->Id ){
        include( $_SERVER['DOCUMENT_ROOT'] . '/install/converter_type.php');
      }
      $aParams['TypeId'] = convertertype::FindByIdent("CALC")->Id;
    }
    
    if( !isset( $aParams['Filter']['Interprise'] ) ){
      $aParams['Filter']['Interprise'] = Self()->Interprise->Id;
    }
    $t=new cconverter();
    return TObject2::Filter($t,$aParams);
  }
  
  
  
  /*
    Переопределение стандартного метода для получения только
    калькуляционных
    @return TListGroup
  */
  static public function &All( $c=-1 ){
    if( !isset( 
      cconverter::$_R['All']
    )){
      
      if( !convertertype::FindByIdent("CALC")->Id ){
        include( $_SERVER['DOCUMENT_ROOT'] . '/install/converter_type.php');
        $aParams['TypeId'] = convertertype::FindByIdent("CALC")->Id;
      }
      
      $Filter = array( 
        'Filter' => array( 
          'Type' => convertertype::FindByIdent('CALC')->Id,
          'Interprise' => Self()->Interprise->Id
        )
      );
      cconverter::$_R['All'] = TObject2::Filter( new cconverter() , $Filter);
    }
    return cconverter::$_R['All'];
  }
  
  
  
  /*
    Получение всех приборов учета на этом конверторе
    @return TListGroup
  */
  function GetMeters(){
    $Filter = array( 
      'Filter' => array( 
        'Converter' => $this->Id,
        'Interprise' => Self()->Interprise->Id,
        'Type' => convertertype::FindByIdent('CALC')->Id,
      )
    );
    return cmeter::Filter($Filter);
  }

}
