<?php
/*
Имя класса cmeter
Имя файла cmeter.class.php ( cmetercustom.class.php )
Поля класса:
Id : id
Interprise : object
Converter : object
Type : object
IsOk : string
NumSerial : string
About : string
*/
class cmeter extends cmetercustom{
  
  
  
  
  public $FieldsToJSON = array(
    'Id'                => 'id',
    'About'             => 'about',
    'Converter'         => 'converter',
    'Type'              => 'type',
    'IsOk'              => 'is_ok',
    'NumSerial'         => 'num_serial',
  );  
  
  
  
  public $NeedDoUserLog = true;
  
  
  
  
  
  
  function GetCoef(){
    return 1;
  }
  
  
  
  
  /*
    Формат вывода данных для пользователя
  */
  protected $DateFormat = "d-m-Y";
  
  
  /*
    Формат вывода даты для ссылки
  */
  protected $DateFormatLink = "Y/m/d/";
  
  
  
  
  /*
    Формирование ссылки назад во времени
    @return String
  */
  function GetPrevDateLink(){
    return $this->LinkArchive.$this->PrevDate->format( $this->DateFormatLink );
  }
  
  /*
    Получение предыдущей даты
    @return DateTime
  */
  function GetPrevDate(){
    $date = clone $this->Date;
    $date->modify('-1 day');
    return $date;
  }
  
  
  /*
    Получение удобно читаемой даты для пользователя
    @return String
  */
  function GetPrevDateTitle(){
    return $this->PrevDate->format( $this->DateFormat );
  }
  
  
  /*
    показ текущей даты на месте
    @return String
  */
  function GetDateLink(){
    return $this->Date->format( $this->DateFormat );
  }
  
  
  /*
    Формирование ссылки вперед во времени
    @return String
  */
  function GetNextDateLink(){
    return $this->LinkArchive.$this->NextDate->format( $this->DateFormatLink );
  }
  
  
  /*
    Получение удобно читаемой даты для пользователя
    @return String
  */
  function GetNextDateTitle(){
    return $this->NextDate->format( $this->DateFormat );
  }
  
  
  
  
  /*
    Получение следующей даты
    @return DateTime
  */
  function GetNextDate(){
    $date = clone $this->Date;
    $date->modify('+1 day');
    return $date;
  }
  
  
  
  
  /*
    Ссылка на прибор учета
    @return String
  */
  function GetLinkArchive(){
    
    $sufix = isset( $_GET['start'] ) && isset( $_GET['stop'] )
             ? "archive/".implode( "-" ,array( $_GET['start'] , $_GET['stop'] ))."/"
             : "";
    
    return $this->Link."archive/". $sufix;
  }
  
  
  
  
  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function &AddByArray($A){
    $t = new cmeter();
    $A['TypeId'] = Site()->GetMetertypeCalc()->Id;
    if( !isset( $A['InterpriseId'] ) ){
      $A['InterpriseId'] = Self()->Interprise->Id;
    }
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function &AddByRequest(){
    $t = new cmeter();
    $_REQUEST['TypeId'] = Site()->GetMetertypeCalc()->Id;
    if( !isset( $_REQUEST['InterpriseId'] ) ){
      $_REQUEST['InterpriseId'] = Self()->Interprise->Id;
    }
    TObject2::StaticAddByRequest($t);
    return $t;
  }
  
  
  static public function Filter($aParams = null , $etc = array()){
    $t=new cmeter();
    $aParams['Type'] = metertype::FindByIdent('CALCMETER')->Id;
    if( !isset( $aParams['Interprise'] ) ){
      $aParams['Interprise'] = Self()->Interprise->Id;
    }
    return TObject2::Filter($t,$aParams);
  }
  
  
  static public function All( $c=-1 )
  {
    if( !isset( 
      cmeter::$_R['All']
    )){
      $Filter = array( 
        'Filter' => array( 
          'TypeId' => metertype::FindByIdent('CALCMETER')->Id,
          'InterpriseId' => Self()->Interprise->Id,
        )
      );
      cmeter::$_R['All'] 
      = TObject2::Filter( new cmeter() , $Filter);
    }
    return cmeter::$_R['All'];
  }
  
  
  
  
  
  /*
    Преобразование объекта в элменет дерева
    @return Array
  */
  function GetToJsTree(){
    
    $row_class = $this->IsOk
                  ? 'text-success'
                  : 'text-danger';
    
    return array(
      'text' => htmlspecialchars($this->Title,ENT_QUOTES),
      'id' => "cmeter_tree_".$this->Id,
      'parent' => "cconverter_tree_".$this->Converter->Id,
      'icon' => Site()->Config('icon.cmeter') . " {$row_class}"
    );
  }
  
  
  
  
  
  /*
    Получение всех графиков прибора учета
    @return TListGroup
  */
  function GetGraphs(){
    $Filter = array(
      'Filter' => array(
        'Meter' => $this->Type->Id,
        'Interprise' => Self()->Interprise->Id
      ),
      'Order' => array(
        'Number' => 'DESC'
      )
    );
    
    return graphics::Filter($Filter);
  }

  
  
  
  
  /*
    Возвращает все виды экспортов для плейсов
    @return TListGroup
  */
  function GetReports(){
    $Filter = array(
      'Filter' => array(
        'Objectrule' => $this->Objectrule->Id,
        'Interprise' => array( 0 , Self()->Interprise->Id )
      )
    );
    return reports::Filter( $Filter );
  }
  
  
  
  
  
  
  /*
    Дата последнего рабочего времени
    @return userlog
  */
  function GetLastOkTime(){
    $Filter = array( 
      'Filter' => array( 
        'Object' => get_class($this),
        'Property' => 'IsOk',
        'ObjectId' => $this->Id
      ),
      'Order' => array(
        'Id' => 'DESC'
      )
    );
    return userlog::Filter( $Filter )->First;
  }
  
  
  
  
  
  
  /*
    Когда был добавлен в систему
    @return userlog
  */
  function GetAddToSys(){
    $Filter = array( 
      'Filter' => array( 
        'Object' => get_class($this),
        'Property' => 'Add',
        'ObjectId' => $this->Id
      ),
      'Order' => array(
        'Id' => 'ASC'
      )
    );
    return userlog::Filter( $Filter )->First;
  }
  
  
  
  
  
  
  /*
    Получение Объекта ролей для места 
    @return objectrule
  */
  function GetObjectrule(){
    $Filter = array( 
      'Filter' => array( 
        'Ident' => 'Meter'
      )
    );
    $ObjectruleFilter = objectrule::Filter( $Filter );
    if( $ObjectruleFilter->Count ){
      return $ObjectruleFilter->first;
    }
    return objectrule::Id(0);
  }
  
  
  
  
  
  /*
    Получение всех иконок для прибора
    @return Array
  */
  function GetIcons(){
    $Icons = array();
    $Filter = array( 
      'Filter' => array( 
        'Meter' => $this->Id
    ));
    foreach( logicmeterparameter::Filter($Filter)->Elements as $iIcon ){
      $Icons[ $iIcon->Id ] = $iIcon;
    }
    $Filter = array( 
      'Filter' => array( 
        'Metertype' => $this->Type->Id
    ));
    foreach( logicmeterparameter::Filter($Filter)->Elements as $iIcon ){
      $Icons[ $iIcon->Id ] = $iIcon;
    }
    return $Icons;
  }
  
  
  
  
  
  
  
  
  
  
  /*
    Получение всех прав на этот прибор учета
  */
  function GetPermisson(){
    $sql = str_replace( array("\n","\r","\t") , "" , "SELECT link.* FROM link 
    LEFT JOIN objectrule ON objectrule.id = link.objectrule_id
    LEFT JOIN rule ON rule.id = link.rule_id 
    LEFT JOIN user ON user.id = link.user_id
    WHERE objectrule.id = {$this->Objectrule->Id} 
    and link.whyid ={$this->Id} 
    and link.user_id > 101
    and user.type = 0
    and link.interprise_id = {$this->Interprise->Id}
    GROUP BY user_id , rule_id, whyid,objectrule_id
    ORDER BY user.fio ASC");
    $t = new link();
    return TListGroup::Prepare( $sql , $t );
  }
  
  
  
  
  
  
  /*
    Получение последних данных
    @return TListGroup
  */
	function GetLastData(){
	  $Filter = Array(
		  'Filter' => Array(
			  'Meter' => $this->Id,
		  ),
	  );
		return meterlast::Filter($Filter);
	}
  
  
  
  
  
  
  
  
  
  
  /*
    Ссылка на прибор учета
    @return String
  */
  function GetLink(){
    return "/cmeter/{$this->Id}/";
  }
  
  
  
  /*
    ссылка на лог событий
    @return String
  */
  function GetLinkLog(){
    return "{$this->Link}log/";
  }
  
  
  
  /*
    ссылка на лог событий
    @return String
  */
  function GetLinkFormula(){
    return "{$this->Link}formula/";
  }
  
  
  
  /*
    Ссылка на графики
    @return String
  */
  function GetLinkGraph(){
    return "{$this->Link}graphs/";
  }
  
  
  
  
  /*
    Ссылка на последние данные
    @return String
  */
  function GetLinkLastData(){
    return "{$this->Link}lastdata/";
  }
  
  
  
  
  /*
    Ссылка на права доступа к прибору
    @return String
  */
  function GetLinkRule(){
    return "{$this->Link}rule/";
  }
  
  
  
  
  /*
    Ссылка на пользовательские иконки
    @return String
  */
  function GetLinkIcons(){
    return "{$this->Link}icons/";
  }
  
  
  
  
  /*
    Ссылка на редактирование прибора учета
    @return String
  */
  function GetLinkEdit(){
    return "{$this->Link}edit/";
  }
  
  
  
  
  /*
    Ссылка на экспорт данных
    @return String
  */
  function GetLinkExport(){
    return "{$this->Link}exports/";
  }
  
  
  
  
  
  
  
  /*
    Ссылка на статусы данных
    @return String
  */
  function GetLinkStatuses(){
    return "{$this->Link}statuses/";
  }
  
  
  
  
  
  /*
    ссылка на удаление прибора учета
    @return String
  */
  function GetLinkDelete(){
    return "{$this->Link}delete/";
  }
  
  
  
  
  
   
  
  
  
  /*
    Ссылка на просмотр архивов
    @return String
  */
  function GetLinkReports(){
    return $this->Link."reports/";
  }
  
  
  
  
  
  
  
  /*
    Список формул прибора учета
    @return TListGroup
  */
  function GetFormulaList(){
    $Filter = array( 
      'Filter' => array( 
        'Meter' => $this->Id
      )
    );
    return meterformula::Filter($Filter);
  }
  
  
  
  
  
  
  
  /*
    Список дат для архива
    @return Array
  */
  function GetDateList(){
    
    $MinDate = $this->MinDate();
    
    $ArrayTime = array();
    
    while( $MinDate->getTimestamp() <= $this->MaxDate()->getTimestamp() ){
      $ArrayTime[] = clone $MinDate;
      $MinDate->modify( $this->Mod );
    }
    
    return $ArrayTime;
  }
  
  
  
  
  
  
  
  /*
    Получение минимальной даты для вывода данных
    @return DateTime 
  */
  function MinDate(){
    
    $Date = isset( $_GET['start'] )
            ? new DateTime( preg_replace('/^(\d{4})(\d{2})(\d{2})$/', "$1-$2-$3", $_GET['start']) )
            : clone $this->Date;
    
    switch( $this->IsGetRangeDate() ){
      case 'now' : 
        $Date->setTime(0,0,0);
      case 'hour' : 
        $Date->setTime(0,0,0);
      break;
      case 'day' : 
        $Date->setDate(
          $this->Date->format('Y'),
          $this->Date->format('m'),
          1
        );
      break;
      case 'month' : 
        $Date->setDate(
          $this->Date->format('Y'),
          1,
          1
        );
      break;
    }
    return $Date;
  }
  
  
  
  
  
  
  
  
  
  
  /*
    Время на приборе учета
    @return Datetime
  */
  function GetDate(){
    
    $Date = clone Site()->GetServerTime();
    
    $TZ = $this->Timezone->Ident ? $this->Timezone->Ident : /*$Date->getTimeZone()->getName()*/ 'Asia/Yekaterinburg';

    $Date->setTimeZone( new DateTimeZone( $TZ ) );

    $Year   = isset( $_GET['year'] ) && $_GET['year'] 
                ? (int) $_GET['year'] 
                : $Date->format('Y') ;
                
    $Month  = isset( $_GET['month'] ) && $_GET['month']
                ? (int) $_GET['month'] 
                : $Date->format('m') ;
                
    $Day    = isset( $_GET['day'] ) && $_GET['day']
                ? (int) $_GET['day'] 
                : $Date->format('d') ;
    
    $Date->setDate( $Year , $Month , $Day );
    
    return $Date;
    
  }
  
  
  
  
  
  
  function GetTimezone(){
    return timezone::Id(0);
  }
  
  
  
  
  
  
  /*
    Какой тип данных от прибора хотят получить
    @return String
  */
  function IsGetRangeDate(){
    if( !isset( $_GET['year']   ) ) return "now" ;
    if( !isset( $_GET['month']  ) ) return "month" ;
    if( !isset( $_GET['day']    ) ) return "day";
    return 'hour';
  }
  
  
  
  
  
  
  
  
  /*
    Получение максимальной даты для вывода данных
    @return DateTime 
  */
  function MaxDate(){
    $Date = isset( $_GET['stop'] )
            ? new DateTime( preg_replace('/^(\d{4})(\d{2})(\d{2})$/', "$1-$2-$3", $_GET['stop']) )
            : clone $this->Date;
    
    switch( $this->IsGetRangeDate() ){
      case 'now' : 
        $Date->setTime( $Date->format('H')-1 ,0,0);
      break;
      case 'hour' : 
        $Date->setTime(23,0,0);
      break;
      case 'day' : 
        $Date->setDate(
          $this->Date->format('Y'),
          $this->Date->format('m'),
          1
        );
        $Date->setDate(
          $Date->format('Y'),
          $Date->format('m'),
          $Date->format('m') == Site()->ServerTime->format("m") 
                              ? $this->Date->format('d')
                              : $Date->format('t')
        );
      break;
      case 'month' : 
        $Date->setDate(
          $this->Date->format('Y'),
          $this->Date->format('Y') == Site()->ServerTime->format("Y") 
                                    ? $this->Date->format('m') 
                                    : 12,
          1
        );
        $Date->setDate(
          $Date->format('Y'),
          $Date->format('m'),
          $Date->format('t')
        );
      break;
    }
    return $Date;
  }
  
  
  
  
  
  
  
  
  
  /*
    модификатор для даты
    @return String
  */
  function GetMod(){
    $mod = "+1 hour";
    switch( $this->IsGetRangeDate() ){
      case "day" :
       $mod = "+1 day"; 
      break;
      case "month" :
       $mod = "+1 month"; 
      break;
    }
    return $mod;
  }
  
  
  
  
  
  
  
  /*
    В каком формате выводить данные пользователю
    @return date_format
  */
  function GetFormat(){
    $format = "H:00";
    switch( $this->IsGetRangeDate() ){
      case "day" :
       $format = "M-d"; 
      break;
      case "month" :
       $format = "Y-M"; 
      break;
    }
    return $format;
  }
  
  
  
  
  
  private $LastMDHArchive = null;
  
  
  
  
  /*
    Получение из кеша данных данных по его ключу
    @return meterdatahour
  */
  function GetMDH( $oParameter , $oDate ){
    
    
    if( $this->CacheArchive === null ){
      $this->SetCacheArchive();
    }
    
    if( $this->LastMDHArchive ){
      $this->LastMDHArchive->__destruct();
    }
    
    set_time_limit(5);
    
    $Month  = str_pad($oDate->format('m'),2,"0",STR_PAD_LEFT);
    $Day    = str_pad($oDate->format('d'),2,"0",STR_PAD_LEFT);
    $Hour   = str_pad(($oDate->format('H')+1),2,"0",STR_PAD_LEFT);
    

    switch( $this->IsGetRangeDate() ){
      case 'day' :
        $Hour = "00";
      break;
      case 'month' :
        $Hour = "00";
        $Day = "00";
      break;
    }
    
    if( isset( $this->CacheArchive[ $oParameter->Id ][ ceil($Month) ][ ceil($Day) ][ ceil($Hour) ] ) ){
      $position = $this->CacheArchive[ $oParameter->Id ][ ceil($Month) ][ ceil($Day) ][ ceil($Hour) ];
      
      DB::DataSeek($this->CacheArchiveSource , $position);
      
      $this->LastMDHArchive = meterdatahour::SetFieldsFromObject(DB::Fetch($this->CacheArchiveSource));
      
      return $this->LastMDHArchive;
      
    }
    return meterdatahour::Id(0);
  }
  
  
  
  
  
  
  
  
  
  
  /*
    Кеш всех параметров к прибора
  */
  protected $CacheRealAllParameters = null;
  
  
  /*
    Создание кеша данных
    @return Bool
  */
  protected function SetCacheRealAllParameter(){
    $SQL = Utils::Strip("
      select 
        parameter.* 
      from meterformula 
      left join parameter on parameter.id = meterformula.parameter_id 
      where meter_id = {$this->Id}
    ");
    $t = parameter::Id(0);
    
    $this->CacheRealAllParameters = TListGroup::Prepare( $SQL , $t );
    return true;
  }
  
  



  /*
    Реальные параметры привязанные к виртуальному прибору учета
    @return TListGroup
  */
  function GetRealActiveParametersData(){
    if( $this->CacheRealAllParameters === null ){
      $this->SetCacheRealAllParameter();
    }
    return $this->CacheRealAllParameters;
  }
  
  
  
  
  
  
  
  /*
    Кеш запрашиваемых данных
    @return Bool
  */
  protected $CacheArchive = null;
  
  
  
  
  /*
    Наполенение CacheArchive
    @return Bool
  */
  protected function SetCacheArchive(){
    
    
    
    
    
    
    
    
    
    /*
		 *TODO временно убрано
    if( $this->CacheTasks === null ){
      $this->SetCacheTasks();
    }
    */
    
    if( isset( $_GET['start'] ) ){
      
      DB::Select("DROP TABLE IF EXISTS mdh_date_range");
      
      $SQL = Utils::Strip("
        CREATE TEMPORARY TABLE mdh_date_range (
          year          INT,
          month         INT,
          day           INT,
          hour          INT,
          meter_id      INT,
          parameter_id  INT
        )
      ");
      
      DB::Select( $SQL );
      
      $SQL = Utils::Strip("INSERT INTO mdh_date_range ( year , month , day , hour , meter_id , parameter_id ) VALUES ");
      
      $SQLAR = array();
      
      $counter = 0;
      
      foreach( $this->DateList as $iDate ){
        foreach( $this->RealActiveParametersData->Elements as $iParameter ){
          $SQLAR[] = "(" . $iDate->format("Y,m,d") .",".($iDate->format("H")+1) . ",{$this->Id},{$iParameter->Id})";
          $counter++;
          
          if( count( $SQLAR ) >= 300 ){
            $_SQL = $SQL . implode(",",$SQLAR);
            DB::Select( $_SQL );
            $SQLAR = array();
          }
          
        }
      }
      
      if( $SQLAR ){
        $SQL .= implode(",",$SQLAR);
        
        DB::Select( $SQL );
      }
      
      $SQL = Utils::Strip("
        select meterdatahour.* from meterdatahour 
        left join mdh_date_range 
          on mdh_date_range.year = meterdatahour.year
          and mdh_date_range.month = meterdatahour.month
          and mdh_date_range.day = meterdatahour.day
          and mdh_date_range.hour = meterdatahour.hour
          and mdh_date_range.parameter_id = meterdatahour.parameter_id
          and mdh_date_range.meter_id = meterdatahour.meter_id
        where mdh_date_range.year = meterdatahour.year
          and mdh_date_range.month = meterdatahour.month
          and mdh_date_range.day = meterdatahour.day
          and mdh_date_range.hour = meterdatahour.hour
          and mdh_date_range.parameter_id = meterdatahour.parameter_id
          and mdh_date_range.meter_id = meterdatahour.meter_id
      ");
      
    }else{
      
      $Year   = 0;
      $Month  = 0;
      $Day    = 0;
      $Hour   = 0;
      
      switch( $this->IsGetRangeDate() ){
        case 'hour' :
        case 'now' :
          $Filter = array( 
            'Filter' => array( 
              'Meter'       => (int) $this->Id,
              'Year'        => (int) $this->Date->format('Y'),
              'Month'       => (int) $this->Date->format('m'),
              'Day'         => (int) $this->Date->format('d'),
              'Hour'        => range(1, 24)
            )
          );
        break;
        case 'day' :
          $Filter = array( 
            'Filter' => array( 
              'Meter'       => (int) $this->Id,
              'Year'        => (int) $this->Date->format('Y'),
              'Month'       => (int) $this->Date->format('m'),
              'Day'         => range(1, 31),
              'Hour'        => 0
            )
          );
        break;
        case 'month' :
          $Filter = array( 
            'Filter' => array( 
              'Meter'       => (int) $this->Id,
              'Year'        => (int) $this->Date->format('Y'),
              'Month'       => range(1, 12),
              'Day'         => 0,
              'Hour'        => 0
            )
          );
        break;
      }
    
      $Filter['Limit'] = count($this->RealActiveParametersData->Elements) * 1000;
      
      foreach( $this->RealActiveParametersData->Elements as $iParameter ){
        $Filter['Filter']['Parameter'][] = $iParameter->Id;
      }
      
      $SQL = meterdatahour::Filter( $Filter )->Sql;
      
    }
    
    
    $this->CacheArchiveSource = DB::Select( $SQL );
    
    $i = 0;
    
    while( $Row = DB::Fetch( $this->CacheArchiveSource ) ){
      $this->CacheArchive[ $Row['parameter_id'] ][$Row['month']][$Row['day']][$Row['hour']] = $i++;
    }
    
    if( !$i ) $this->CacheArchive = array();
    
    
    return true;
  }
  
  
  
  
  
  
  
  /*
    Кол-во данных которое можно запросить снова
  */
  public $CountRetry = 0;
  
  
  /*
    Добавление к кол-ву перезапрашиваемых данных
    @return @Bool
  */
  function GetAddCountRetry(){
    $this->CountRetry++;
  }
  
  
  
  
  
  
  
  /*
    Название прибора учета
    @return String
  */
  function GetTitle(){
    if( $this->About != "" ){         // Есть описание?
			return $this->About;
		}elseif( $this->NumSerial != "" ){// Есть серийный номер?
			return $this->NumSerial;
		}
    return "----";
  }
  
  
  
  /*
    Генерирование названия фильтра для данных
    @return String
  */
  function GetNameFilterFromData(){
    return "{$this->Type->DllId}.{$this->Interprise->Id}.";
  }
  
  
  
  
  
  
  /*
    Кеш ресурcа запрашиваемых данных
    @return Bool
  */
  protected $CacheArchiveSource = null;
  
  
  
  
  
  
  
  
  
  /*
    Кеш всех параметров к прибора
  */
  protected $CacheAllParameters = null;
  
  
  /*
    Создание кеша данных
    @return Bool
  */
  protected function SetCacheAllParameter(){
    $SQL = Utils::Strip("
      select 
        parameter.* 
      from meterformula 
      left join parameter on parameter.id = meterformula.parameter_id 
      where meter_id = {$this->Id}
    ");
    $t = parameter::Id(0);
    
    $this->CacheAllParameters = TListGroup::Prepare( $SQL , $t );
    return true;
  }
  
  
  
  /*
    получение ВСЕХ параметров
    @return TListGroup
  */
  function GetAllParameters(){
    if( $this->CacheAllParameters === null ){
      $this->SetCacheAllParameter();
    }
    return $this->CacheAllParameters;
  }
  
  
  
  
  /*
    Построение массива из параметров для склеенного вывода
    @return Array
  */
  function GetHeadActiveParametersData( $after = array() , $before = array() ){
    $a = new HeadTableParameters( $after , $before , $this->ActiveParametersData );
    return $a->RowCol();
  }
  
  
  
  
  
  /*
    Активные параметры при показе данных
    @return TListGroup
  */
  function GetActiveParametersData(){
    return $this->AllParameters;
  }
  
  
  
  
  
  
  /*
    Кеши фильтра параметров данных
  */
  private $CacheFilterParameterData = null;
  
  
  /*
    Кеши фильтра параметров последних данных
  */
  private $CacheFilterParameterLast = null;
  
  
  /*
    Получение параметров из фильтра
    @return TListGroup
  */
  function GetFilterParameterLast(){
    
    if( $this->CacheFilterParameterLast ){
      return $this->CacheFilterParameterLast->Parameters;
    }
    
    $this->CacheFilterParameterLast = $this->GetFilterParameter('last');
    return $this->CacheFilterParameterLast->Parameters;
  }
  
  
  
  /*
    Получение фильтра параметрпов для построяния данных
    @return filterparamobject
  */
  function GetFilterParameterData(){
    if( $this->CacheFilterParameterData ){
      return $this->CacheFilterParameterData->Parameters;
    }
    
    $this->CacheFilterParameterData = $this->GetFilterParameter('');
    return $this->CacheFilterParameterData->Parameters;
  }
  
  
  
  
  
  /*
    Получение объекта фильтра параметров
    @return filterparamname
  */
  function GetFilterParameter( $sufix = "" ){
    $Filter = array( 
      'Filter' => array( 
        'Object'      => 'meter',
        'Interprise'  => Self()->Interprise->Id,
        'ObjectId'    => $this->Id,
        'Sufix'       => $sufix
      )
    );
    $F = filterparamname::Filter($Filter);
    if( $F->Count ){
      return $F->First;
    }else{
      return filterparamname::Id(0);
    }
  }
  


}
