<?php
/*
Имя класса converter
Имя файла converter.class.php ( convertercustom.class.php )
Поля класса:
Id : id
Type : object
Ip : string
Port : int
Login : string
Password : string
About : string
IsExcluded : bool
InUse : ts
MeterOk : int
Interprise : object
Timeoutconnect : int
Timeoutreceive : int
Portcontrol : int
*/


class converter extends convertercustom{
  
  
  public $FieldsToJSON = array(
    'Id'                => 'id',
    'Type'              => 'type',
    'About'             => 'about',
    'Ip'                => 'ip',
    'Port'              => 'port',
    'Login'             => 'login',
    'Password'          => 'password',
    'Timeoutconnect'    => 'timeoutconnect',
    'Timeoutreceive'    => 'timeoutreceive',
    'Portcontrol'       => 'portcontrol',
    'IsExcluded'        => 'is_excluded',
  );
  
  
  
  public $NeedDoUserLog = true;
  
  
  
  
  
  
  /*
    Кеш всех параметров к прибора
  */
  protected $CacheAllParameters = null;
  
  
  /*
    Создание кеша данных
    @return Bool
  */
  protected function SetCacheAllParameter(){
    $SQL = Utils::Strip("
    select parameter.*
    from converter
    left join meter 
      on meter.converter_id = converter.id
    left join metertypeparameter
      on metertypeparameter.metertype_id = meter.type_id
    left join parameter 
      on parameter.id = metertypeparameter.parameter_id
    where converter.id = {$this->Id} 
      and parameter.id is not null
    group by parameter.id
    ");
    $t = parameter::Id(0);
    $this->CacheAllParameters = TListGroup::Prepare( $SQL , $t );
    return true;
  }
  
  



  /*
    Реальные параметры привязанные к виртуальному прибору учета
    @return TListGroup
  */
  function GetAllParameters(){
    if( $this->CacheAllParameters === null ){
      $this->SetCacheAllParameter();
    }
    return $this->CacheAllParameters;
  }
  
  
  
  
  
  /*
    Преобразование объекта в массив для построение "дерева"
    @return Array
  */
  function GetToJsTree(){
    return array(
      'text' => htmlspecialchars($this->Title,ENT_QUOTES),
      'id' => "converter_tree_".$this->Id,
      'children' => (bool)$this->Meters->Count,
      'parent' => "#",
      'icon' => Site()->Config('icon.converter') . " text-{$this->RowClass}"
    );
  }
  
  
  
  /*
    Удобное название для пользователя
    @@return String
  */
  function GetTitle(){
    if( $this->About != ""){
			return $this->About;
		}elseif( $this->Ip != "" && $this->Port != ""){
			return $this->Ip.":".$this->Port;
		}else{
			return "---";
		}
  }
  
  
  
  /**
   * Часть приборов работает, а часть нет
   */
  const NEITRAL_STATUS = 2;
  
  /**
   * Все приборы не работают
   */
  const NEGATIVE_STATUS = 0;
  
  /**
   * Все приборы работают
   */
  const POSITIVE_STATUS = 1;
  
  
  
  
  /*
    Вывод статуса конвертора
    @return String
  */
  function GetRowTitle(){
    if( $this->IsExcluded ){
      return "Исключен";
    }
    
    if( $this->MeterOk == self::NEITRAL_STATUS ){
      return "Есть проблемы";
    }elseif( $this->MeterOk == self::POSITIVE_STATUS ){
      return "Все работает";
    }else{
      return "Не работает";
    }
  }
  
  
  /*
    Для совместимости со старой версией
    @return Int
  */
  function GetIsOk(){
    return $this->MeterOk;
  }
  
  
  
  
  /*
    Конвертер не виртуальный
    @return False
  */
  function GetIsVirtual(){
    return false;
  }
  
  
  
  
  
  /*
    Вывод класса конвертора исходя из его статуса
    @return String
  */
  function GetRowClass(){
    if( $this->IsExcluded ){
      return "muted";
    }
    
    if( $this->MeterOk == self::NEITRAL_STATUS ){
      return "warning";
    }elseif( $this->MeterOk == self::POSITIVE_STATUS ){
      return "success";
    }else{
      return "danger";
    }
  }
  
  
  
  
  /*
    Иконка для конвертора
    @return String
  */
  function GetMiniIcon(){
    if( $this->IsExcluded ){
      return "/img/converter/excluded.png";
    }
    return "/img/converter/default.png";
  }
  

  /**
   * GetLink ССылка на узел учета
   * 
   * Если это лораван то ссылка другая
   *
   * @return strind
   */
  function GetLink(){
    if( strpos( strtolower( $this->Type->DllId ) , strtolower("lora") ) ){
      return "/lorawan/{$this->Id}/";
    }
    return "/converter/{$this->Id}/";
  }
  
  
  function GetIsVirt(){
    return $this->Type->IsVirt;
  }
  
  
  
  /*
    Ссылка на удаление конвертора
    @return String
  */
  function GetLinkDelete(){
    return "{$this->Link}delete/";
  }
  
  /*
    Ссылка на редактирование конвертора
    @return String
  */
  function GetLinkEdit(){
    return "{$this->Link}edit/";
  }
  
  
  /*
    Ссылка на добавление прибора учета
    @return String
  */
  function GetLinkAddMeter(){
    return "{$this->Link}addmeter/";
  }
  
  
  
  /*
    Ссылка на лог событий
    @return TListGroup
  */
  function GetLinkLog(){
    return "{$this->Link}log/";
  }
  
  
  
  
  
  /*
    Ссылка на редактирование исключенности узла учета
    @return String
  */
  function GetLinkExcludedEdit(){
    return "{$this->Link}excluded_edit/";
  }
  
  
  /*
    Получение списка всех страниц по всем конверторам
    @return Array
  */
  static function Pages(){
    $all_count = self::All()->Count;
    $count_page = Site()->CountInPage;
    
    $pages = array();
    for( $i = 0 ; $i < Utils::CountPages( $all_count , $count_page ) ; $i++ ){
      $pages[] = array(
        'num' => $i +1,
        'name' => $i+1,
        'is_active' => $i == Site()->Page
      );
    }
    return $pages;
  } 
  
  
  
  
  
  /*
    Получение списка приборов учета с учетом страниц
    @return TListGroup
  */
  function GetMetersByPages(){
    $Meters = $this->GetMeters()->GroupBy( Site()->CountInPage )->Elements;
    if( !isset( $Meters[ Site()->Page ] ) ){
      return TListGroup::Init();
    }
    return $Meters[ Site()->Page ];
  }
  
  
  
  
  /*
    Получение пагинатора для списка приборов учета
    @return Array
  */
  function GetPagesMeters($is_all=false){
    return Utils::Paginator(
      $this->Meters->Count,
      Site()->GetCountInPage(),
      $is_all
    );
  }
  
  
  /*
    Все события по конвертору
    @return TListGroup
  */
  function GetLog(){
    $Filter = array(
      'Filter' => array(
        'Object' => 'converter',
        'ObjectId' => $this->Id
      ),
      'Order' => array(
        'Its' => 'DESC'
      )
    );
    return userlog::Filter( $Filter );
  }
  
  
  /*
    Все события по конвертору
    @return TListGroup
  */
  function GetLogList(){
    $Log = $this->Log->GroupBy( Site()->CountInPage )->Elements;
    if( !isset( $Log[ Site()->Page ]) ){
      return TListGroup::Init();
    }
    return $Log[ Site()->Page ];
  }
  
  
  
  /*
    Страницы лога
    @return Array
  */
  function GetLogPages(){
    return Utils::Paginator(
      $this->Log->Count,
      Site()->CountInPage
    );
  }
  
  
  
  /*
    Исключен или не исключен в удобном для пользователе виде
    @return String
  */
  function GetIsExcludedTitle(){
    return $this->IsExcluded ? "Исключен" : "Участвует";
  }
  
  
  
  
  
  
  
  /*
    Кол-во приборов учета с ошибками
    @return TListGroup
  */
  function GetMetersError(){
    $Filter = array( 
      'Filter' => array( 
        'Converter' => $this->Id,
        'IsOk'      => 0,
        'Interprise' => Self()->Interprise->Id,
        'Type NOT IN' => array(
          convertertype::GetByAppintment(2)->Id,
          convertertype::GetByAppintment(3)->Id,
        ),
      )
    );
    return meter::Filter( $Filter );
  }
  
  /*
    Кол-во приборов учета с ошибками
    @return TListGroup
  */
  function GetMetersExcluded(){
    $Filter = array( 
      'Filter' => array( 
        'Converter' => $this->Id,
        'IsExcluded'      => 1,
        'Interprise' => Self()->Interprise->Id,
        'Type NOT IN' => array(
          convertertype::GetByAppintment(2)->Id,
          convertertype::GetByAppintment(3)->Id,
        ),
      )
    );
    return meter::Filter( $Filter );
  }
  
  





  /*
    Простой пинг на вопрос-ответ
    @param String Адрес кого оспрашиваем
    @param Int Время в секундах как долго спрашивать
    @return String
  */
  static function PingICMP( $host , $timeout = 1 ) {
    $package = "\x08\x00\x7d\x4b\x00\x00\x00\x00PingHost";
    $result = "Not create soccet";
    if( $socket  = @socket_create(AF_INET, SOCK_STREAM, 1) ){
      socket_set_option($socket, SOL_SOCKET, SO_RCVTIMEO, array('sec' => $timeout, 'usec' => 0));
      socket_connect($socket, $host, null);

      $ts = microtime(true);
      socket_send($socket, $package, strLen($package), 0);
      if (socket_read($socket, 255))
              $result = microtime(true) - $ts;
      else    $result = false;
      socket_close($socket);
    }

    return $result;
  }
  
  
  
  
  
  
  
  
  

  /*
    Проверка соединения до узла учета
    @param String Ip адрес устройства
    @param String Port адрес устройства
    @param String Type Тип соединения ( TCP | UDP )
    @return bool || SocketError 
  */
  static function Ping( $Ip , $Port , $ConverterType ){
    $fp = @fsockopen("tcp://{$Ip}:{$Port}", -1, $errno, $errstr);
    return (int) $fp;
  }
  
  
  
  
  
  
  
  
  /*
    Добавление нового конвертора
    @return place
  */
  static public function AddByArray($A){
    $t = converter::Id(0);
    if( !isset( $A['InterpriseId'] ) ){
      $A['InterpriseId'] = Self()->Interprise->Id;
    }
    if( empty( $A['About'] ) ){
      $A['About'] = $A['Ip'] . $A['Port'];
    }
    TObject2::StaticAddByArray($t,$A);
    $t->RewriteStatusMeterOk();
    return $t;
  }
  
  
  
  
  
  
  function Delete() {
    if( $this->Interprise->Id != Self()->Interprise->Id ){
      return false;
    }
    TObject2::StaticDelete($this);
  }
  
  
  
  
  
  
  
  
  /*
    Добавление нового конвертора
    @return place
  */
  static public function AddByRequest(){
    $t = new converter();
    if( empty( $_REQUEST['About'] ) ){
      $_REQUEST['About'] = $_REQUEST['Ip'] . $_REQUEST['Port'];
    }
    $_REQUEST['InterpriseId'] = Self()->Interprise->Id;
    TObject2::StaticAddByArray($t,$_REQUEST);
    $t->RewriteStatusMeterOk();
    return $t;
  }
  



  /*
    Переопределение стокового метода для выборки всех по назначению 1
    @return TListGroup
  */
  static public function &All($c = -1){
    if( !isset( 
      self::$_R['All']
    )){
      $Filter = array( 
        'Filter' => array( 
          'Interprise' => Self()->Interprise->Id
        ),
        'Order'=>Array('About'=>'ASC' , 'Ip' => 'ASC' , 'Port' => 'ASC')
      );
      
      $Filter_C = array(
          'Filter' => array(
              'DllId' => array('VIRTUAL')
          )
      );
      
      $c = array();
      foreach (convertertype::Filter( $Filter_C )->Elements as $iConvertertype){
        $c[] = $iConvertertype->Id;
      }
      
      if( $c ){
        $Filter['Filter']['Type NOT IN'] = $c;
      }
      
      self::$_R['All'] 
      = TObject2::Filter( new converter(), $Filter );
    }
    return self::$_R['All'];
  }
  
  
  
  
  
  
  static public function Filter($aParams = null , $etc = array()){
    $t=new converter();
    if( Self()->IsRoot && Self()->IsMask ){
      $aParams['Filter']['Interprise'] = Self()->MaskUser->Interprise->Id;
    }
    if( !isset($aParams['Filter']['Interprise']) ){
      $aParams['Filter']['Interprise'] = Self()->Interprise->Id;
    }
    return TObject2::Filter($t,$aParams);
  }
  
  
  
  
  
  /**
   * Получние всех приборов РЕАЛЬНЫХ учета на этом конвертре
   * 
   * @return TListGroup
   */
  function GetMeters(){
    if($this->Is){
      if( !isset(converter::$_R['Meters'][$this->_F[$this->_ID]['value']])){
        $Filter = array( 
          'Filter' => array( 
            'Converter' => $this->Id,
            'Interprise' => Self()->Interprise->Id,
            'Type NOT IN' => array(
              metertype::FindByIdent('VIRTMETER')->Id,
              metertype::FindByIdent('CALCMETER')->Id,
            ),
          )
        );
        if( Self()->IsRoot && Self()->IsMask ){
          $Filter['Filter']['Interprise'] = Self()->MaskUser->Interprise->Id;
        }
        //~ echo meter::Filter( $Filter )->Sql."\n\n";
        converter::$_R['Meters'][$this->_F[$this->_ID]['value']] = 
        meter::Filter( $Filter );
      }
      return converter::$_R['Meters'][$this->_F[$this->_ID]['value']];
    }
    else return TListGroup::Init();
  }


  
  
  /**
   * Перерасчет статуса MeterOk исходя из статусов вложенных приборов учета
   * 
   * @return boolean
   */
  function RewriteStatusMeterOk(){
    
    $count_ok = 0;
    $count_not_ok = 0;
    
    $oMeter = meter::Id(0);
    
    $SQL = Utils::Strip("SELECT * FROM {$oMeter::$SqlTable} WHERE {$oMeter::$FInit['Converter']['sql']} = {$this->Id}");
    
    $res = DB::Select( $SQL );
    
    while( $row = DB::Fetch( $res ) ){
      if( $row[ $oMeter::$FInit['IsOk']['sql'] ] ){
        $count_ok++;
      }else{
        $count_not_ok++;
      }
    }
    
    if( $count_ok == 0 && $count_not_ok == 0 ){
      $this->MeterOk = self::NEGATIVE_STATUS;
    }elseif( $count_ok && $count_not_ok ){
      $this->MeterOk = self::NEITRAL_STATUS;
    }elseif( $count_ok && !$count_not_ok ){
      $this->MeterOk = self::POSITIVE_STATUS;
    }else{
      $this->MeterOk = self::NEGATIVE_STATUS;
    }
    
    $this->Save();
    
    return true;
  }


}
