<?php
/*
Имя класса convertertype
Имя файла convertertype.class.php ( convertertypecustom.class.php )
Поля класса:
Id : id
Title : string
DllId : string
*/
class convertertype extends convertertypecustom{

  
  
  /*
    Таблица соответствия JSON полей к полям конвертора
  */
  public $FieldsToJSON = array(
    'Id'                => 'id',
    'Title'             => 'title',
    'DllId'             => 'dllid',
  );
  
  
  public $NeedDoUserLog = true;
  
  
  
  
  function GetHelper(){
    $Filter = array( 
      'Filter' => array( 
        'Convertertype' => $this->Id
    ));
    if( converterhelpers::Filter( $Filter )->Count ){
      return converterhelpers::Filter( $Filter )->First;
    }
    return converterhelpers::Id(0);
  }
  
  

  
  /*
    Поиск типа конвертора по его идентификатору
    @return convertertype
  */
  static function FindByIdent( $ident ){
    $Filter = array( 
      'Filter' => array( 
        'DllId' => $ident
      )
    );
    $FilterType = convertertype::Filter( $Filter );
    if( $FilterType->Count ){
      return $FilterType->First;
    }
    return convertertype::Id(0);
  }
  
  
  
  /*
    Является ли тип конвертора виртуальным
    @return Bool
    
    UDP Название осталось от старой версии
  */
  function GetIsVirt(){
    return $this->DllId == 'VIRTUAL';
  }
  
  
  /*
    Является ли тип конвертора виртуальным
    @return Bool
  */
  function GetIsVirtual(){
    return $this->IsVirt;
  }
  
  
  
  /*
    Проверка калькудяционный тип конвертора или нет
    @return Bool
  */
  function GetIsCalc(){
    return $this->DllId == 'CALC';
  }


  /*
    Проверка LoRa тип конвертора или нет
    @return Bool
  */
  function GetIsLora(){
    return strpos( $this->DllId , "Lora" );
  }
  
  
  
  /*
    Проверка на то что тип конвертора является реальным а не
    виртуальной сущностью
    @return Bool
  */
  function GetIsReal(){
    return !$this->IsVirtual && !$this->IsCalc;
  }
  
  function GetTitle(){
    if(Self()->Lang != 'ru'){
      return Utils::cirilic_file_name($this->_F['Title']['value']);
    }
    return $this->_F['Title']['value'];
  }
  
  
  
  /*
    Получение КАЛЬКУЛЯЦИОННОГО типа конвертора
    @return convertertype
  */
  static function CalcConverter(){
    $Filter = array( 
      'Filter' => array( 
        'DllId' => 'CALC' 
      )
    );
    $res = convertertype::Filter($Filter);
    if( $res->Count ){
      return $res->first;
    }
    return convertertype::Id(0);
  }
  
  
  
  
  /*
    Получение Первого типа по его назначению
    @return convertertype
  */
  static function GetByAppintment( $Int = 1 ){
    $Filter = array( 
      'Filter' => array( 
        'Converter_appointment' => $Int
      )
    );
    if( convertertype::Filter($Filter)->Count ){
      return convertertype::Filter($Filter)->First;
    }
    return convertertype::Id(0);
  }
  


}
