<?php

/*
		* * * * * выполняемая команда
		- - - - -
		| | | | |
		| | | | ----- День недели (0 - 7) (Воскресенье =0 или =7)
		| | | ------- Месяц (1 - 12)
		| | --------- День (1 - 31)
		| ----------- Час (0 - 23)
		------------- Минута (0 - 59)

*/


class crontab{
	
	# Общие переменные
	public $Min 		= array();
	public $Hour 		= array();
	public $Day 		= array();
	public $Month 	= array();
	public $DayWeek = array();
  
  protected $Date = null;
	
	function __construct( $post = array() ,$date = false ){

    $this->Date = !$date ? new DateTime('now') : $date;
    $Timezone = !Self()->Interprise->Timezone->Id  ? 'UTC' : Self()->Interprise->Timezone->Ident;
    $this->Date->setTimeZone(new DateTimeZone( $Timezone) );
    
    
    foreach( $post as $ident => $values ){
      switch( $ident ){
        case 'Minutes' :
          $Range = "Min";
          $max = 59;
          $min = 0;
        break;
        case 'Hours' :
          $Range = "Hour";
          $max = 23;
          $min = 0;
        break;
        case 'Days' :
          $Range = "Day";
          $max = 31;
          $min = 1;
        break;
        case 'DaysWeek' :
          $Range = "DayWeek";
          $max = 7;
          $min = 0;
        break;
        case 'Months' :
          $Range = "Month";
          $max = 12;
          $min = 1;
        break;
      }
      $validAr = array();
      $all = false;
      foreach( $values as $key => $value ){
        if( preg_match( '/([0-9\/\*\-].?)/' , $value ) ){
          if( $value === "*" ){
            $all = 3;
          }
          if( is_int($value) && $value > $max ) continue;
          if( is_int($value) && $value < $min ) continue;
          $validAr[] = $value;
        }
      }
      if( $Range == "Min" && count($validAr) == 12){
        $all = 1;
      }
      if( $Range == "Hour" && count($validAr) == 24){
        $all = 2;
      }
      if( $Range == "Day" && count($validAr) == 31){
        $all = 4;
      }
      if( $Range == "DayWeek" && count($validAr) == 7){
        $all = 4;
      }
      if( $Range == "Month" && count($validAr) == 12){
        $all = 4;
      }
      if( $all ){
        $validAr = array("*");
      }
      $this->$Range = $validAr;
    }
	}
	
	function __get( $property = '' ){
		$GetMethod = 'Get' . $property;
		if( method_exists( 'crontab' , $GetMethod ) ){
			return $this->$GetMethod();
		}
    if( !property_exists( $this , $property ) ){
      return null;
    }
		return $this->$property;
	}
	
	
	# Построение в линию. Аналог Title
	function GetLine(){
    $res = array();
    foreach( array("Min" , "Hour" , "Day" , "Month" , "DayWeek") as $r ){
      if( empty( $this->$r ) ){
        $this->$r = array(0);
      }
      $res[] = implode(",",$this->$r);
    }
		return implode(" ",$res);
	}
  
  function IsChecked( $value , $where ){
    return in_array( "*" , $this->$where ) || in_array( $value , $this->$where );
  }
  
  function setByStr( $str = '' ){
    $p = array();
    $m = array("Minutes" , "Hours" , "Days" , "Months" , "DaysWeek");
    foreach( explode( " " , $str) as $v ){
      $k = array_shift($m);
      $p[$k] = explode( "," , $v);
    }
    $a = new crontab($p);
    foreach( array("Min" , "Hour" , "Day" , "Month" , "DayWeek") as $r ){
      $this->$r = $a->$r;
    }
    return $a;
  }
  
  
  function GetIsRun( $date = false ){
    foreach( array("Min" , "Hour" , "Day" , "Month" , "DayWeek") as $r ){
      switch( $r ){
        case 'Min':
          $format = "i";
        break;
        case 'Hour':
          $format = "H";
        break;
        case 'Day':
          $format = "d";
        break;
        case 'Month':
          $format = "m";
        break;
        case 'DayWeek':
          $format = "N";
        break;
      }
      // преобразование 7 дня недели в 0
      if( in_array( 7 , $this->$r ) && $r == "DayWeek" ){
        foreach( $this->$r as $i => $days ){
          if( $days == 7 ){
            unset( $this->$r[$i] );
            array_unshift( $this->$r , 0 );
          }
        }
      }
      if( !in_array( "*" , $this->$r ) && !in_array( $this->Date->format( $format ) , $this->$r ) ){
        return false;
      }
    }
    return true; 
  }
	
}
