<?php
/*
Имя класса crontask
Имя файла crontask.class.php ( crontaskcustom.class.php )
Поля класса:
Id : id
Title : string
Description : text
Filename : string
Key : string
Hour : int
Minute : int
IsLog : bool
IsEnabled : bool
IsLocked : ts
NextRun : ts
Timelimit : int
Memorylimit : string
*/
class crontask extends crontaskcustom{
  
  
  private $JOB = false;
  
  
  
  /*
    Получение лога по задаче
    @return TlistGroup
  */
  function GetLog(){
    $Filter = array( 
      'Filter' => array( 
        'Crontask' => $this->Id
      ),
      'Order' => array(
        'Id' => 'DESC'
      )
    );
    return crontasklog::Filter($Filter);
  }
  
  
  
  function GetLogPage( $is_all = false){
    return Utils::Paginator(
      $this->Log->Count,
      Site()->GetCountInPage(),
      $is_all
    );
  }
  
  
  /*
    Получение задачи по идентификатору
    @return crontask
  */
  static function Ident( $name ){
    $Filter = array( 
      'Filter' => array( 
        'Filename' => $name
    ));
    $res = crontask::Filter( $arLook );
    if( $res->Count ){
      return $res->First;
    }
    return crontask::Id(0);
  }
  
  
  
  
  /*
    Получение класса фоновой задачи
    @return Class
  */
  function GetJob() {
    if( !$this->JOB ) {
      $FileName = "{$_SERVER['DOCUMENT_ROOT']}/task/job/class.{$this->Filename}.php";
      if( is_file($FileName) ) {
        include_once( $FileName );
        if( class_exists( $ClassName = "job_{$this->Filename}", false ) ) {
          $this->JOB = new $ClassName();
        }
      }
    }
    if( $this->JOB ) {
      return $this->JOB;
    }
    return false;
  }
  
  
  
  function Run( $ts=null , $test = false )
  {
      $arStatus = array();
      
      if($this->Memorylimit == ""){
        $this->Memorylimit = "90M";
      }
      
      if($this->Timelimit == 0){
        $this->Timelimit = 30;
      }

      $d = new DateTime();

      $this->UpdateByArray(array(
        'IsLocked' => 1,
        'IsEnabled' => 1
      ));
      $this->Save();
      
      # Время для всех скриптов ( Желательено выставлять на ~ 5 сек максимального времени скрипта )
      $max_time = $this->Timelimit + 10;
      
      $max_memory = str_replace( "M" , "" , $this->Memorylimit ) + 10;
      
      ini_set('max_execution_time' , $max_time);
      ini_set('memory_limit' , $max_memory . "M");
      
      $Filter = array(
        'Filter' => array(
          'Ident' => "TIME_LIMIT_{$max_time}"
        )
      );
      
      if(!statuscrontasklog::Filter($Filter)->Count){
        statuscrontasklog::AddByArray(
          array(
            'Ident' => "TIME_LIMIT_{$max_time}",
            'Description' => "Время выполнения задания превысило {$max_time} сек."
          )
        );
      }
      
      $Filter = array(
        'Filter' => array(
          'Ident' => "RUN"
        )
      );
      
      if(!statuscrontasklog::Filter($Filter)->Count){
        statuscrontasklog::AddByArray(
          array(
            'Ident' => "RUN",
            'Description' => "Выполняется"
          )
        );
      }
      
      foreach(statuscrontasklog::All()->Elements as $iStatus){
        $arStatus[ $iStatus->Ident ] = $iStatus;
      }
    
      $timestamp = !is_null( $ts )
        ? "ts:{$ts}"
        : '';
      # Settungs
      $steps = 0;
      
      $PHP = Site()->Config( 'phpcli.path', '/usr/local/bin/php' ); # REWRITE /usr/local/bin/php
      $this->NextRun = $this->ReturnNextRun( $this->Hour , $this->Minute , time() );# Время следующего запуска
      
      /*
        Блокирование FATAL
      */
      $Date = new DateTime();

			$TaskLog = crontasklog::AddByArray( array(																		# Выставляем данные для записи в лог
				'CrontaskId'	 	=> $this->Id,
				'DateStart'			=> $Date->format('Y-m-d H:i:s'),
				'DateEnd'				=> $Date->format('Y-m-d H:i:s'),
				'Text'				 	=> "Запуск задачи \"{$this->Title}\"\n",
        'StatuscrontasklogId' => statuscrontasklog::GetStatusByIdent('RUN')->Id,
				'Timeupdb'			=> 0,
				'Timeseldb'			=> 0,
				'Timerun'				=> 0
      ) );
      
			$Login	= "{$this->Filename}@job";
        
      # Проверям на существование пользователя
      $Filter = array(
        'Filter' => array(
          'Login' => $Login
        )
      );
      
      $oUser = Self();
      
      # инициализируем пользователя
      $FilterUser = user::Filter($Filter);
      if($FilterUser->Count){
        $oUser = $FilterUser->First;
      }
      
      $limits = " -d max_execution_time={$this->Timelimit} -d memory_limit={$this->Memorylimit} -f ";

#			$limits = "";
      
      if( !defined( '__PHPUNIT_PHAR__' ) ) {
        $PHPCMD = "{$_SERVER['DOCUMENT_ROOT']}task/cron_list.php key:{$this->Key} file:{$this->Filename} worker:{$oUser->Id} TL:{$this->Timelimit} lid:{$TaskLog->Id} 2>&1";
      } else {
        $PHPCMD = "{$_SERVER['DOCUMENT_ROOT']}task/cron_list.php key:{$this->Key} file:{$this->Filename} worker:{$oUser->Id} TL:{$this->Timelimit} mode:test {$timestamp} lid:{$TaskLog->Id} 2>&1";
#					echo($PHPCMD);
      }
      
      $output = "{$PHP} {$PHPCMD}";
      echo($PHPCMD . "\n");
      
      $descriptorspec = array(
				0 => array("pipe", "r"),	// stdin - канал, из которого дочерний процесс будет читать
				1 => array("pipe", "w"),	// stdout - канал, в который дочерний процесс будет записывать 
        2 => array("pipe", "w") // stderr - файл для записи
      );

      $cwd = '/home/saup/saup/';
      $env = array('some_option' => 'aeiou');

      $error =  shell_exec( "$PHP -l {$_SERVER['DOCUMENT_ROOT']}task/job/class.{$this->Filename}.php" );
      
      
      # IF FILE ERROR SINTAX
      if( !preg_match( '/(.*)Parse\ error\:\ syntax\ error(.*)/' , $error) ){
      
        $process = proc_open($output, $descriptorspec, $pipes, $cwd, $env);
      
        if (is_resource($process)) {
      
             stream_set_blocking($pipes[1], 0);
          
  
            $end = time() + $max_time;
          
          
            $b0 = stream_set_blocking($pipes[0], 0);
            $b1 = stream_set_blocking($pipes[1], 0);
            $b2 = stream_set_blocking($pipes[2], 0);
          
            $s = proc_get_status($process);
          
            $run = false;
            while ($s['running'] && time() < $end) {
              $s = proc_get_status($process);
              if(is_resource($pipes[1])){
                $output .= stream_get_contents($pipes[1]);
                $s = proc_get_status($process);
              
                $run = $s['running']; # true - Выполняется | false - Завершилось
              
                if(!$s['running']) {
                  $end = time();
                }else{
              
                  $output .= "TIME[" . ($end - time() + $max_time) . "]\n";
                
                  if(($end - time()) > 1){
                    sleep(1);
                    continue;
                  }else{
                    if($s['exitcode'] != 255 ) {
                      $run = true;
                    }
                    $end = time();
                  }
                
                }
              
                fclose($pipes[0]);
                fclose($pipes[1]);
                fclose($pipes[2]);
                
                //posix_kill($s['pid'] , 9); # Если все плохо то лучше завершить
              
              }
            }
            if($run or $s['exitcode'] == 255){
              $output .= "Заблокировано\n";
              if($s['exitcode'] == 255) {
                $output .= "\n{$arStatus['ERROR_PROC']->Title}\n";
                $TaskLog->UpdateByArray(array(
                  'StatuscrontasklogId' => statuscrontasklog::GetStatusByIdent('ERROR_PROC')->Id,
                  'DateEnd'     => $Date->format('Y-m-d H:i:s'),
                ));
              }
              if($run) {
                $output .= "\n".$arStatus['TIME_LIMIT_'.$max_time]->Title."\n"; # "TIME_LIMIT_{$max_time}"
                $TaskLog->UpdateByArray(array(
                  'StatuscrontasklogId' => $arStatus["TIME_LIMIT_{$max_time}"]->Id,
                  'DateEnd'     => $Date->format('Y-m-d H:i:s'),
                ));
                $this->Save();
              }
            
              /*
                Блокирование ERROR
              */
            
            
            }else{
              $TaskLog->UpdateByArray(array(
                'StatuscrontasklogId' => statuscrontasklog::GetStatusByIdent('GOOD')->Id,
                'DateEnd'     => $Date->format('Y-m-d H:i:s'),
              ));
              $this->Save();
            }

            $this->UpdateByArray(array(
              'IsLocked' => 0,
              'IsEnabled' => 1,
            ));
            $this->Save();
          
            TObject2::CleanAllObjects();
            proc_close($process);
          
        }
        
      }

      $MaxTextLength = 2*1024*1024;
      $TaskLog->Text .= mb_strcut( $output , 0, $MaxTextLength );
      $TaskLog->Text .= ( mb_strlen( $output ) > $MaxTextLength ) ? "\n == обрезано ==\n" : "\n == Завершено == \$steps={$steps}\n" ;
      $this->Save();
      $Date = new DateTime();
      $TaskLog->DateEnd = $Date->format('Y-m-d H:i:s');
      return $TaskLog->Text;
  }


  

  
  function GetDescByPage(){
    $Elems = $this->Log->GroupBy( Site()->CountInPage )->Elements;
    
    if( !isset( $Elems[ Site()->Page ] ) ){
      return TListGroup::Init();
    }
    
    return $Elems[ Site()->Page ];
  }
  
  
  
  
  function GetTaskWaiting(){
    return 0;
  }
  
  
  /*
    Проверяет фоновые задачи на валидность
    @return Array массив задач
  */
  static function ListTaskFiles(){
  
    $exluded_task = array(
      'need_calc',
      'add_task_day',
      'group_days',
      'group_months',
      'light',
      'mailto',
      'mdhduplicate',
      'mdhnew',
      'sergey',
      'sergey_day',
      'syslog',
      'tarif_move',
      'test'
    );
    
    
    $arrayValidTasks = array();
    
    $exluded_task_f = array();
    foreach( $exluded_task as $k => $v ){
      $exluded_task_f[$k] = 'class.'. $v .'.php';
    }
    
    $dir = Site()->GetPathCrontask();
    
    foreach( crontask::All()->Elements as $iCrontask ){
      if( in_array( $iCrontask->Filename , $exluded_task ) ){
        $iCrontask->IsEnabled = 0;
      }
      $arInstalledTasks[$iCrontask->Filename] = $iCrontask;
    }
    
    if( is_dir($dir) and $dh = opendir($dir) ) {
      while (($file = readdir($dh)) !== false) {
      
        $KeyMD5 = md5($dir.$file);
        
        if( in_array( $file , $exluded_task_f ) ) continue;
        
        if( filetype( "{$dir}{$file}" ) =='file' and preg_match( '|^class\.(.+)\.php$|', $file, $match ) )  {
          
          
          $PHP = Site()->Config( 'phpcli.path', '/usr/local/bin/php' );
          $output = null;
          exec( "{$PHP} -l {$dir}{$file}", $output, $retval );
          
          $syntax = preg_match( '/No syntax errors detected(.*)/' , $output[0] );
          
          if( $syntax ){
          
            include($dir.$file);
            
            $classname = 'job_'.$match[1];
            
            $arrayValidTasks[$match[1]] = array(
							'file' 			=> $dir.$file,
							'class' 		=> $match[1],
							'login' 		=> $match[1] . "@job",
              'phprun'    => "{$PHP} -l {$dir}{$file}",
							'isvalid'		=> (bool) $syntax,
							'key'				=> $KeyMD5,
							'id'				=> isset($arInstalledTasks[$match[1]]) ? $arInstalledTasks[$match[1]]->Id : 0,
							'cl'				=> 'job_' . $match[1],
							'cl_exists'	=> class_exists( $classname ),
							'f_start'		=> method_exists( $classname , 'Start' ),
							'f_title'		=> method_exists( $classname , 'getTitle' ),
							'f_des'			=> method_exists( $classname , 'getDescription' )
            );
          }
        }
      }
    }
    return $arrayValidTasks;
  }
  
  
  
}
