<?php

defined('LOG_PATH') or define('LOG_PATH'  ,  $_SERVER['DOCUMENT_ROOT'] . "install/log.log");
defined('DUMP_PATH') or define('DUMP_PATH' ,  $_SERVER['DOCUMENT_ROOT'] . "install/dump/");




class install{
  
  
  /*
    Обнуление лога
    @return NULL
  */
  function __construct(){
    file_put_contents( LOG_PATH , "" );
  }
  
  
  /*
    Дозапись в лог
    @param String
    @return Int
  */
  function PutToLog( $msg = "" ){
    return file_put_contents( LOG_PATH , $msg , FILE_APPEND );
  }
  
  
  
  
  
  
  
  /*
    Формирование строки для записи в лог
    @param String Сообщение лога
    @param Исключить метку времени из сообщения лога
    @return Int
  */
  function setLog( $msg= "error_empty_line" , $is_not_time = false ){
    if( $is_not_time ){
      return $this->PutToLog( sprintf( "%s\n" , $msg ) );
    }
    $d = new DateTime('now' , new DateTimeZone("Asia/Yekaterinburg"));
    return $this->PutToLog( sprintf( "[%-19s] %s\n" , $d->format('Y-m-d H:i:s') , $msg ) );
  }
  
  
  
  
  
  
  
  
  
  
  /*
    Лог перезаписи значения в таблице
    @param String Название класса
    @param String Свойство класса
    @param String Старое значение
    @param String Новое значение
    @return Int
  */
  function replaceVal( $class_name , $property , $old , $new ){
    if( $old == $new ){
      return $this->setLog( sprintf( "%s:%-20s ACTUAL" , $class_name , $property ) );
    }
    return $this->setLog( sprintf( "%s:%-20s `%s` -> `%s`" , $class_name , $property , $old , $new ) );
  }
  
  
  
  
  
  
  
  
  
  private function addVal( $Obj ){
    
    $Res = array();
    
    foreach( $this->BackupPatern as $Ident => $val ){
      if( is_object( $Obj->$Ident ) ){
        $Res[ $Ident ] = $Obj->$Ident->Id;
      }else{
        $Res[ $Ident ] = $Obj->$Ident;
      }
    }
    
    return $this->setLog( sprintf( "Добавлено %s %s" , get_class($Obj) , json_encode($Res) ) );
  }
  
  
  
  
  
  
  
  
  /*
    Записываем сюда все что попросили сдампить
  */
  protected $_stack_to_dump = array();
  
  
  
  
  
  
  
  
  /*
  
    Добавление сущности в очередь на дамп
    
    @param String используется для названия файла . Уникальный ключ
    @param String Из какой модели брать данные для обработки
    @param Array Патерн по которому строить дамп
    @param Array Фильтр по которму брать модели
    @return Null
  */
  function AddToDump( $key , $class_name , $patern , $filter = array() ){
    $this->_stack_to_dump[$key] = array(
      'class_name'  => $class_name,
      'patern'      => $patern,
      'filter'      => $filter,
    );
  }
  
  
  
  
  
  
  
  
  
  /*
    Преобразует дамп в строку для записи
    @param Array
    @return String
  */
  function ToStr( $Dump ){
    return "<?php \$dump = " . var_export($Dump , true ) . ";";
  }
  
  
  
  
  
  
  
  
  
  
  
  /*
    Сохранение файла
    @param String Название файла куда сохранять
    @param String что  нужно сохранить
    @return Int
  */
  function save( $file , $tring ){
    return file_put_contents( $file, $tring );
  }
  
  
  
  
  
  
  /*
    
  */
  function dump(){
    foreach( $this->_stack_to_dump as $Ident => $attr ){
      $a = &$this->_stack_to_dump[ $Ident ];
      $class = $a['class_name'];
      
      $output = $this->dump_item( $class::Filter( $a['filter'] ) , $a['patern'] );
      
      if( !$output ){
        $this->setLog("FALSE");
        continue;
      }
      
      $file = DUMP_PATH ."{$Ident}.php";
      
      $res = $this->save( $file , $this->ToStr( $output ) );
      
      unset($this->_stack_to_dump[$Ident]);
    }
    
  }
  
  
  
  
  
  
  /*
    Дамп данных в файлы
    @param TListGroup Массив того что надо сдампить
    @param Array По каким правим делать дамп 
  */
  function dump_item( $TListGroup , $patern ){
    
    if( !$TListGroup->Count ){
      $this->setLog( "empty TListGroup" );
    }
    
    $output = array(
      'class' => get_class($TListGroup->First),
      'elements' => array()
    );
    
    $count_keys = 0;
    
    foreach( $TListGroup->GroupBy(100)->Elements as $iGroup ){
      foreach( $iGroup->Elements as $iElem ){
        $patern_elem = array();
        foreach( $patern as $Field => $attributes ){
          
          if( isset( $attributes['iskey'] ) && $attributes['iskey'] ){
            $count_keys++;
          }
          
          $attributes['value'] = $iElem->$Field;
          if( is_object( $iElem->$Field ) ){
            $attributes['value'] = $iElem->$Field->Id;
          }
          $patern_elem[ $Field ] = $attributes;
        }
        
        $output['elements'][] = $patern_elem;
      }
      $iGroup->ElementsFreeMem;
    }
    
    if( !$count_keys ){
      
      $this->setLog( get_class($TListGroup->First) . " not keys" );
      return false;
    }
    
    return $output;
  }
  
  
  
  
  
  
  
  
  
  
  /* 
    Загрузка на сервер
    @param dump Array
    @return Bool
  */
  function backup(){
    
    
    $Filter = array( 
      'Filter' => array( 
        'Login' => 'admin',
        'Interprise' => 100
      )
    );
    
    $is_first_instaliation = !user::Filter($Filter)->Count;
    
    
    foreach (new DirectoryIterator(DUMP_PATH) as $file) {
      if ($file->isFile()) {
        
        $this->setLog( "\n" , true );
        $this->setLog( "include file : " . DUMP_PATH . $file->getFilename() );
        
        include(DUMP_PATH . $file->getFilename() );
        
        $class_name = $dump['class'];

        if( !count($dump['elements']) ) {
          $this->setLog( "empty elements" );
          continue;
        }
        
        
        foreach( $dump['elements'] as $attributes ){
          
          $this->BackupPatern = $attributes;
          
          $this->setLog( "-----------------" , true );
          
          $Filter = array(
            'Filter' => array()
          );
          
          // Массив который служит для вставки
          $ArrayByAdd = array();
          
          foreach( $attributes as $Ident => $options ){
            
            if( !isset( $options['value'] ) ){
              $options['value'] = 0;
            }
            
            if( $options['iskey'] ){
              $Filter[ 'Filter' ][ $Ident ] = $options['value'];
            }
            
            $IdentP = isset( $class_name::$FInit[ $Ident ]['object'] )
                      ? $Ident."Id"
                      : $Ident ;
            
            $ArrayByAdd[ $IdentP ] = $options['value'];
          }
          
          // Нет ни одного ключа для поиска
          if( empty( $Filter['Filter'] ) ){
            continue;;
          }
          
          if( $is_first_instaliation && $class_name == 'user' && $ArrayByAdd['Login'] == 'admin' ){
            $ArrayByAdd['InterpriseId'] = interprise::All()->First->Id;
          }
          
          $res = $class_name::Filter( $Filter );
          
          
          $this->setLog(" Add Array from added := ".json_encode($ArrayByAdd));
          
          //~ $this->setLog($res->Sql);
          
          // Баз раздумий добавляем
          if( !$res->Count ){
            $Add = $class_name::AddByArray( $ArrayByAdd );
            if( $Add->Is ){
              
              if( isset( $ArrayByAdd['Id'] ) ){
                

                $newid = $ArrayByAdd['Id'];
                $oldid = $Add->Id;
                if( $newid != $oldid ){
                  
                  $t = $class_name::Id($newid);
                  
                  $t->Delete();
                  
                  $t->Save();
                  
                  $sql = "UPDATE {$t->SqlTable} SET id = '{$newid}' WHERE `id`='{$oldid}' LIMIT 1 ";
                  
                  try{
                    DB::Query($sql,false);
                    $this->replaceVal( get_class($t) , 'Id' , $oldid , $newid );
                  }
                  catch (Exception $e) {
                    TObject2::_Error($t,ER_SQL,Array('e'=>$e,'sql'=>$sql));
                  }
                }
              }
              
              $this->addVal( $Add );
              
              if( $is_first_instaliation && $class_name == 'user' && $ArrayByAdd['Login'] == 'admin' ){
                $Add->Save();
                $GLOBALS['Self'] = $Add;
              }
              
            }
            
            
          // Если уже есть то надо смотреть какие поля переписывать
          }elseif( $res->Count == 1 ){
            
            $t = $res->First;
            $newid = $t->Id;
            $oldid = $t->Id;
            
            foreach( $attributes as $Ident => $options ){
            
              if( !isset( $options['value'] ) ){
                $options['value'] = 0;
              }
              
              if( isset( $class_name::$FInit[ $Ident ]['object'] ) ){
                $cl = $class_name::$FInit[ $Ident ]['object'];
                $options['value'] = $cl::Id($options['value']);
              }
              
              if( $options['isreplace'] ){
                
                # Если меняем объект
                if( isset( $class_name::$FInit[ $Ident ]['object'] ) ){
                  $Obj = $options['value'];
                  $old_value = $res->First->$Ident->Id;
                  if( $old_value != $Obj->Id ){
                    
                    $res->First->UpdateByArray(array(
                      $Ident."Id" => $Obj->Id
                    ));
                    
                    $this->replaceVal( $class_name , $Ident , $old_value , $Obj->Id );
                  }
                  
                # Если меняем просто значение
                }else{
                  if( $options['value'] != $res->First->$Ident ){
                    
                    if( $Ident == "Id" ){
                      $newid = $options['value'];
                      continue;
                    }else{
                      $res->First->UpdateByArray(array(
                        $Ident => $options['value']
                      ));
                    }
                    $this->replaceVal( $class_name , $Ident , $res->First->$Ident , $options['value'] );
                  }
                }
              }
              
            }
            
            
            if( $newid != $oldid ){
              
              $class_name::Id($newid)->Delete();
              
              $class_name::Id($newid)->Save();
              
              $sql = "UPDATE {$t->SqlTable} SET id = '{$newid}' WHERE `id`='{$oldid}' LIMIT 1 ";
              try{
                DB::Query($sql,false);
                $this->replaceVal( get_class($t) , 'Id' , $oldid , $newid );
              }
              catch (Exception $e) {
                TObject2::_Error($t,ER_SQL,Array('e'=>$e,'sql'=>$sql));
              }
            }
            
          }else{
            
          
              // ...
              // Если их много то надо думать что делать
              
            
          }
          
        }
        
        
        
        $this->setLog("Install user Attrs := ".json_encode(array( "I" => Self()->Interprise->Id )));
        
        
      }
    }
    
    echo DB::Status();
    
  }
  
  
  
  
  
  /*
    Чтение и вывод бекапа
  */
  function readBackup(){
    
    $output = array();
    
    foreach (new DirectoryIterator(DUMP_PATH) as $file) {
      if ($file->isFile()) {
        
        include(DUMP_PATH . $file->getFilename() );
        
        $class_name = $dump['class'];

        if( !count($dump['elements']) ) {
          $this->setLog( "empty elements" );
          continue;
        }
        
        $output[ $file->getFilename() ] = array();
        
        foreach( $dump['elements'] as $attributes ){
          
          $this->BackupPatern = $attributes;
          
          $Filter = array(
            'Filter' => array()
          );
          
          // Массив который служит для вставки
          $ArrayByAdd = array();
          
          $action = false;
          
          foreach( $attributes as $Ident => $options ){
            
            if( !isset( $options['value'] ) ){
              $options['value'] = 0;
            }
            
            if( $options['iskey'] ){
              $Filter[ 'Filter' ][ $Ident ] = $options['value'];
            }
            
            $IdentP = isset( $class_name::$FInit[ $Ident ]['object'] )
                      ? $Ident."Id"
                      : $Ident ;
            
            $ArrayByAdd[ $IdentP ] = $options['value'];
            
            
            // Нет ни одного ключа для поиска
            if( empty( $Filter['Filter'] ) ){
              continue;;
            }
            
            $res = $class_name::Filter( $Filter );
            
            // Баз раздумий добавляем
            if( !$res->Count ){
              $action = true;
              $ArrayByAdd['add'] = true;
            
            // Если уже есть то надо смотреть какие поля переписывать
            }elseif( $res->Count == 1 ){
              
              $t = $res->First;
              $newid = $t->Id;
              $oldid = $t->Id;
              
              foreach( $attributes as $Ident => $options ){
              
                if( !isset( $options['value'] ) ){
                  $options['value'] = 0;
                }
                
                if( isset( $class_name::$FInit[ $Ident ]['object'] ) ){
                  $cl = $class_name::$FInit[ $Ident ]['object'];
                  $options['value'] = $cl::Id($options['value']);
                }
                
                if( $options['isreplace'] ){
                  
                  # Если меняем объект
                  if( isset( $class_name::$FInit[ $Ident ]['object'] ) ){
                    $Obj = $options['value'];
                    $old_value = $res->First->$Ident->Id;
                    if( $old_value != $Obj->Id ){
                      
                      $action = true;
                      
                      $ArrayByAdd[$Ident]['old_value'] = $old_value;
                      $ArrayByAdd[$Ident]['new_value'] = $Obj->Id;
                      
                    }
                    
                  # Если меняем просто значение
                  }else{
                    if( $options['value'] != $res->First->$Ident ){
                      
                      $action = true;
                      $ArrayByAdd[$Ident."old_value"] = $res->First->$Ident;
                      $ArrayByAdd[$Ident."new_value"] = $options['value'];
                    }
                  }
                }
                
              }
              
            }
            
            
          }
          if( $action ){
            $output[ $file->getFilename() ][] = $ArrayByAdd;
          }
          
        }
        
      }
    }
    
    return $output;
  }
  
  
  
  
  
  
  /*
    Отчет по дампу
  */
  function report_dump(){
    $output = array();
    
    foreach (new DirectoryIterator(DUMP_PATH) as $file) {
      if ($file->isFile()) {
        
        include(DUMP_PATH . $file->getFilename() );
        
        $class_name = $dump['class'];

        if( !count($dump['elements']) ) {
          $this->setLog( "empty elements" );
          continue;
        }
        
        $output[ $file->getFilename() ] = array();
        
        foreach( $dump['elements'] as $attributes ){
          
          $this->BackupPatern = $attributes;
          
          $Filter = array(
            'Filter' => array()
          );
          
          // Массив который служит для вставки
          $ArrayByAdd = array();
          foreach( $attributes as $Ident => $options ){
            
            if( !isset( $options['value'] ) ){
              $options['value'] = 0;
            }
            
            if( $options['iskey'] ){
              $Filter[ 'Filter' ][ $Ident ] = $options['value'];
            }
            
            $IdentP = isset( $class_name::$FInit[ $Ident ]['object'] )
                      ? $Ident."Id"
                      : $Ident ;
            
            $ArrayByAdd[ $IdentP ]['value'] = $options['value'];
            $ArrayByAdd[ $IdentP ]['iskey'] = $options['iskey'];
            $ArrayByAdd[ $IdentP ]['isreplace'] = $options['isreplace'];
          }
          
          $output[ $file->getFilename() ][] = $ArrayByAdd;
          
        }
        
      }
    }
    
    return $output;
  }
  
  
  
  
  /*
    Получение лога инсталятора
    @return String
  */
  function readLog(){
    return file_get_contents( LOG_PATH );
  }
  
  
  
}