<?php
/*
Имя класса mail
Имя файла mail.class.php ( mailcustom.class.php )
Поля класса:
Id : id
User : object
Interprise : object
Create : int
Change : int
Tplmail : text
Reports : object
Crontab : string
Listmail : text
Name : string
Objects : text
Enabled : bool
*/
class mail extends mailcustom{

  
  
  
  public $FieldsToJSON = array(
    'Id'                => 'id',
    'Crontab'           => 'crontab',
    'Listmail'          => 'listmail',
    'Name'              => 'name',
    'Enabled'           => 'enabled',
  );  
  
  
  
  
  function GetIsEveryDay(){
    preg_match('/^(.*) (.*) (.*) (.*) (.*)$/' , $this->Crontab , $m );
    if( !$m ) return false;
    list( $any , $minutes , $hours , $day , $months , $week ) = $m;
    return $day == "*";
  }
  
  
  
  
  function GetIsWeekDay(){
    preg_match('/^(.*) (.*) (.*) (.*) (.*)$/' , $this->Crontab , $m );
    if( !$m ) return false;
    list( $any , $minutes , $hours , $day , $months , $week ) = $m;
    return $week != "*";
  }
  
  
  
  
  
  function GetIsCustomDay(){
    preg_match('/(.*) (.*) (.*) (.*) (.*)/' , $this->Crontab , $m );
    if( !$m ) return false;
    list( $any , $minutes , $hours , $day , $months , $week ) = $m;
    var_dump($minutes , $hours , $day , $months , $week);
    return $day != "*";
  }
  
  
  
  
  
  function GetPlacesIds(){
    preg_match('/^\{report type=\"place\:(data|info)\" filter\=\"id\:(.*)\"\}$/' , $this->Tplmail , $m );
    if( !$m ){
      return 0;
    }
    list( $any , $type , $ids ) = $m;
    return $ids;
  }
  
  
  
  
  function GetHour(){
    preg_match('/^(.*) (.*) (.*) (.*) (.*)$/' , $this->Crontab , $m);
    if( !$m ) return "-";
    return $m[2];
  }
  
  
  
  function GetEmails(){
    return explode("\n" , $this->Listmail);
  }
  
  
  function GetMin(){
    preg_match('/^(.*) (.*) (.*) (.*) (.*)$/' , $this->Crontab , $m);
    if( !$m ) return "-";
    return $m[1];
  }
  
  
  
  function GetPlacesToStr(){
    $Filter = array( 
      'Filter' => array( 
        'Id' => explode(",",$this->PlacesIds)
      )
    );
    
    $ar = array();
    foreach( place::Filter( $Filter )->Elements as $iPlace ){
      $ar[] = "place_tree_". $iPlace->Place->Id . "_" . $iPlace->Id;
    }
    return implode(",",$ar);
  }
  
  
  
  
  function GetType(){
    preg_match('/^\{report type=\"place\:(data|info)\" (.*)\}$/' , $this->Tplmail , $m );
    if( !$m ){
      return 0;
    }
    list( $any , $type , $ids ) = $m;
    if( !$ids ) return 0;
    return $type;
  }
  
  
  
  
  
  
  
  /*
    Ссылка на рассылку
    @return String
  */
  function GetLink(){
    return "/mail/{$this->Id}/";
  }
  
  
  public $NeedDoUserLog = true;

  
  
  /*
    Ссылка на редактирование рассылки
    @return String
  */
  function GetLinkEdit(){
    return "{$this->Link}edit/";
  }

  
  
  /*
    Ссылка на удаление рассылки
    @return String
  */
  function GetLinkDelete(){
    return "{$this->Link}delete/";
  }

  
  
  /*
    Название
    @return String
  */
  function GetTitle(){
    return $this->Name == '' ? $this->Id : $this->Name;
  }
  
  
  function GetMessage(){
  
    $Sender 		= Site()->Config('sendmes.mail.autoinformer.email' , 'nagruzka@nag.ru');
    $NameSender = Site()->Config('sendmes.mail.autoinformer.name' , 'Нагрузка');
    
    $arrayMail = array();
    foreach( explode( "\n" , $this->Listmail ) as $MailAddr ){
      $arrayMail[$MailAddr] = '';
    }
    
    $GLOBALS['Self'] = $this->User;
    smarty()->assign(  'template_source' , $this->Tplmail);
    
    $message = Swift_Message::newInstance($this->Name)
    ->setContentType("text/html")
    ->setFrom(array( $Sender => $NameSender))
    ->setTo( $arrayMail )
    ->setBody(smarty()->fetch('mail/example.tpl'))
    ;
    
    return $message;
        
  }
  
  
  
  
  
  /*
    Показ включено или выключено
    @return String
  */
  function GetEnabledTitle(){
    return $this->Enabled ? Site()->Config('ru.sys.yes') : Site()->Config('ru.sys.no');
  }
  
  
  
  
  
  static public function Filter($aParams = null , $etc = array()){
    $t=new mail();
    return TObject2::Filter($t,$aParams);
  }
  
  
  public function UpdateByRequest(){
    if( isset($_REQUEST['Enabled']) && !$_REQUEST['Enabled'] ){
      unset($_REQUEST['Enabled']);
    }
    if( isset( $_REQUEST['not_valid_json']['type'] )  ){
      $_REQUEST['Tplmail'] = "{report type=\"place:{$_REQUEST['not_valid_json']['type']}\" filter=\"id:". implode(",",$_REQUEST['not_valid_json']['ids']) ."\"}";
    }
    TObject2::StaticUpdateByRequest($this);
  }
  public function UpdateByArray($A){
    if( isset($A['enabled']) && !$A['nabled'] ){
      unset($A['Enabled']);
    }
    if( isset( $A['not_valid_json']['type'] )  ){
      $A['Tplmail'] = "{report type=\"place:{$A['not_valid_json']['type']}\" filter=\"id:". implode(",",$A['not_valid_json']['ids']) ."\"}";
    }
    
    TObject2::StaticUpdateByArray($this,$A);
  }

  static public function AddByArray($A){
    $t = mail::Id(0);
    if( !isset( $A['InterpriseId'] ) ){
      $A['InterpriseId'] = Self()->Interprise->Id;
    }
    if( !isset( $A['UserId'] ) ){
      $A['UserId'] = Self()->Id;
    }
    
    if( isset( $A['not_valid_json']['type'] )  ){
      $A['Tplmail'] = "{report type=\"place:{$A['not_valid_json']['type']}\" filter=\"id:". implode(",",$A['not_valid_json']['ids']) ."\"}";
    }
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = mail::Id(0);
    if( isset($_REQUEST['Enabled']) && !$_REQUEST['Enabled'] ){
      unset($_REQUEST['Enabled']);
    }
    if( !isset( $_REQUEST['InterpriseId'] )){
      $_REQUEST['InterpriseId'] = Self()->Interprise->Id;
    }
    if( !isset( $_REQUEST['UserId'] ) ){
      $_REQUEST['UserId'] = Self()->Id;
    }
    
    TObject2::StaticAddByRequest($t);
    return $t;
  }


}
