<?php
/*
Имя класса meter
Имя файла meter.class.php ( metercustom.class.php )
Поля класса:
Id : id
About : text
Converter : object
Type : object
Num485 : string
NumSerial : string
Password : string
Places : multy
Coef : float
Timezone : object
IsExcluded : int
Inuse : ts
IsOk : bool
DateStart : string
DateLast : string
Interprise : object
*/


class meter extends metercustom{
  
  
  
  /*
    Объединение общих типов у cmeter vmeter meter
  */
  use main_meter;

  public function __call($n,$args){return TObject2::_call($this,$n,$args);}



  function GetModel(){
    if( !$this->_F['Model']['ready'] ){
      TObject2::_DataLoadSql($this);
    }
    
    if( !$this->_F['Model']['value'] ){
      // Ищем первую попавшую модель и цепляем ее сюда
      $FilterModel = array(
        'Filter' => array(
          'Type' => $this->Type->Id
        )
      );
      if(  model::Filter($FilterModel)->Count ){
        return model::Filter($FilterModel)->First;
      }
    }
    return model::Id( $this->_F['Model']['value'] );
  }


  function GetModels(){
    $Filter = array(
      'Filter' => array(
        'Mark' => $this->Model->Mark->Id
      )
    );

    return model::Filter($Filter);
  }
  
  
  
  
  /**
   * Получение группировки данных по параметру и диапазону дат
   * 
   * @param parameter $Parameter
   * @param string $date_start
   * @param string $date_stop
   * @return meterdatahour
   */
  function GetMDHGroupByParameterRangeDate( $Parameter , $date_start , $date_stop ){
    
    $start  = new DateTime( $date_start );
    $stop   = new DateTime( $date_stop  );
    
    DB::Query("Drop table if exists mdh_by_meter");
    
    DB::Query(Utils::Strip("
      CREATE TEMPORARY TABLE IF NOT EXISTS mdh_by_meter (
        year int(11) NOT NULL, 
        month int(11), 
        day int(11), 
        meter_id int(11),
        parameter_id int(11)
      )            
    "));
    
    $SQL_A = array();
    
    $limit_trans = 300; // Максимальное кол-во вставок в строке
    
    while( $start->getTimestamp() <= $stop->getTimestamp() ){
      
      $SQL_A[] = "({$start->format('Y,m,d')},{$this->Id},{$Parameter->Id})";
      
      if( count( $SQL_A ) == $limit_trans ){
        $SQL = "INSERT INTO mdh_by_meter (`year`,`month`,`day`,`meter_id`,`parameter_id`) values" . implode( "," , $SQL_A ) . "";
        DB::Query($SQL);
        $SQL_A = array();
      }
      
      $start->modify( "+1 day" );
    }
    
    if( $SQL_A ){
      $SQL = "INSERT INTO mdh_by_meter (`year`,`month`,`day`,`meter_id`,`parameter_id`) values" . implode( "," , $SQL_A ) . "";
      DB::Query($SQL);
    }
    $res = DB::Fetch(DB::Select(Utils::Strip("
      select  id, parameter_id, tarif_id, year, month, day, hour, loginfo_id, add_time, SUM(m.value) as value
      from mdh_by_meter as mdh 
      left join meterdatahour as m on 
      mdh.year = m.year and 
      mdh.month = m.month and 
      mdh.day = m.day and 
      mdh.meter_id = m.meter_id and 
      mdh.parameter_id = m.parameter_id 
    ")));
    
    if( $res ){
      return meterdatahour::SetFieldsFromObject( $res );
    }
    return meterdatahour::Id(0);
  }
  
  
  
  
    
  /*
    Таблица соответствия для работы с JSON
  */
  public $FieldsToJSON = array(
    'Id'                => 'id',
    'About'             => 'about',
    'Converter'         => 'converter',
    'Type'              => 'type',
    'Num485'            => 'num485',
    //'Num485'            => 'num_485',
    'NumSerial'         => 'num_serial',
    'Password'          => 'password',
    'Coef'              => 'coef',
    'Timezone'          => 'timezone',
    'Timezone'          => 'timezone_id',
    'IsExcluded'        => 'is_excluded',
    'Inuse'             => 'in_use',
    'IsOk'              => 'is_ok',
    'Model'             => 'model',
  );  
  
  
  /*
    Флаг логирования
  */
  public $NeedDoUserLog = true;
  
  
  
  
  
  
  function GetIsAction(){
    
    $id = taskstatus::GetByIdent('Running')->Id;
    
    $Filter = array(
      'Filter' => array(
        'Meter' => $this->Id,
        'Taskstatus' => $id
      )
    );
    return task::Filter($Filter)->Count;
  }
  
  
  
  
  
  
  /**
   * Генерация названия эекпорта файла
   * 
   * @return string
   */
  function GetNameReport(){
    
    $name = Utils::str2url($this->Title);
    
    $y = ceil( $this->GetDate()->format("Y") );
    $m = ceil( $this->GetDate()->format("m") );
    $d = ceil( $this->GetDate()->format("d") );
    
    if( ceil($m) < 10 ) $m = "0{$m}";
    if( ceil($d) < 10 ) $d = "0{$d}";
    
    switch( $this->IsGetRangeDate() ){
      case "day"    : return "{$name}_{$this->Id}_{$y}_{$m}";
      case "month"  : return "{$name}_{$this->Id}_{$y}";
    }
    
    if( isset( $_GET['start'] ) ){
      $Date = clone $this->MaxDate();
      $Date->modify("-1 day");
      return "{$name}_{$this->Id}_{$this->MinDate()->format("Y_m_d")}__{$Date->format("Y_m_d")}";
    }
    
    return "{$name}_{$this->Id}_{$y}_{$m}_{$d}";
  }
  
  
  
  /*
    Получение всех заданий на приборе учета
    @return TListGroup
  */
  public function GetTasks(){
     $arParams = Array(
      'Filter' => Array(
        'Meter' => $this->Id,
        'Taskstatus' => array( taskstatus::GetByIdent('Waiting')->Id , taskstatus::GetByIdent('Running')->Id )
      ),
      'Order' => array(
        'Year'  => 'DESC',
        'Month' => 'DESC',
        'Day'  => 'DESC',
        'hour'  => 'DESC',
      ),
    );
    return task::Filter($Filter);
  }
  
  
  
  
  






  /*
  
    Получение сдвига на час от аргумента
    @param Datetime
    @return Array
    * совместимость старой версии
  */
  function MeterlastNextHour( $datetime ){
    return $this->MeterlastThisHour( $datetime->modify( "+1 hour" ) );
  } 
  
  
  
  
  /*
    
    Полученеие массива из даты для фильтрации
    @param Datetime
    @return Array
    * совместимость старой версии
  */
  function MeterlastThisHour( $datetime ){

    $Hour = (int) $datetime->format('H');
    
    if(!$Hour){
      $datetime->modify("-1 hour");
      $Hour = 24;
    }
    
    $Day    = (int) $datetime->format('d');
    $Month  = (int) $datetime->format('m');
    $Year   = (int) $datetime->format('Y');
    
    unset($datetime);
    
    return array(
      'Year'  => $Year,
      'Month' => $Month,
      'Day'   => $Day,
      'Hour'  => $Hour
    );
  }
  
  
  
  
  
  /*
    Получение всех параметров на приборе по его типу
    @return TListGroup
  */
  function GetMeterparameters(){
    $Filter = array( 
      'Filter' => array( 
        'Metertype' => $this->Type->Id,
        'IsUse' => 1
      )
    );
    return metertypeparameter::Filter( $Filter );
  }
  
  
  
  # Приоритеты
  # 1 - самого прибора
  # 2 - пользователя
  # 3 - сервера
  function GetTimezone(){

    if( !$this->_F['Timezone']['ready'] ){
      TObject2::_DataLoadSql($this);
    }

    $timezone_id = $this->_F['Timezone']['value'];

    if( !$timezone_id ){

      if( !Self()->Timezone->Id ){
        $origin_tz = date_default_timezone_get();
        $remote_tz = "UTC";
        $origin_dtz = new DateTimeZone($origin_tz);
        $remote_dtz = new DateTimeZone($remote_tz);
        $origin_dt = new DateTime("now", $origin_dtz);
        $remote_dt = new DateTime("now", $remote_dtz);
        $offset = $origin_dtz->getOffset($origin_dt) - $remote_dtz->getOffset($remote_dt);

        $Filter = array(
          'Filter' => array(
            'Diff' => $offset
          )
        );
        $Timezones = timezone::Filter($Filter);

        if( $Timezones->Count ){
          return $Timezones->First;
        }
        return timezone::Id(0);

      }else{
        $timezone_id = Self()->Timezone->Id;
      }

    }

    return timezone::Id($timezone_id);
  }
  
  
  
  
  /*
    Получение разницы времени между прибором учета и системой опроса
    @return Int
  */
  function GetTimeDiff(){
    
    $Filter = array( 
      'Filter' => array( 
        'Meter' => $this->Id,
        'VarName' => 'DATETIME_DIFF_INT',
      )
    );
    
    if( !metervariable::Filter($Filter)->Count ){
      return 0;
    }
    
    return metervariable::Filter($Filter)->First->Data;
  }
  
  
  
  
  
  
  /*
    Преобразование объекта в элменет дерева
    @return Array
  */
  function GetToJsTree(){
    
    $row_class = $this->IsOk
                  ? 'text-success'
                  : 'text-danger';
    
    if( $this->IsExcluded ){
      $row_class = "text-muted";
    }
    
    return array(
      'text' => htmlspecialchars($this->Title,ENT_QUOTES),
      'id' => "meter_tree_".$this->Id,
      'parent' => "converter_tree_".$this->Converter->Id,
      'icon' => $this->GetIcon() . " {$row_class}"
    );
  }
  
  
  
  /*
    Получение пути до друйвера прибора учета если он есть
    @return String
  */
  function GetDriverPath(){
    
    $path = $_SERVER['DOCUMENT_ROOT'] . "meter/conf/drivers/";
    
    if( $this->Type->IsTkonSys ){
      $path .= "tkon_" . $this->Type->TekonGetNum . ".php";;
    }
    
    
    return $path;
  }
  
  
  
 
  
  
  
  
  /*
    Ссылка на конфигурирование
    @return String
  */
  function GetLinkConf(){
    return $this->Link."conf/";
  }
  
  
  
  
  
  
  /*
    Ссылка на конфигурирование
    @return String
  */
  function GetLinkSysLog(){
    return $this->Link."syslog/";
  }
  
  
  
    
  
  /*
    Создание объекта из массива данных
    @return meterdatahour
  */
  static function SetFieldsFromObject( $aValues = array() ){
    $t = new meter();
    $t = $t->Init($t,$aValues);
    return $t;
  }


  /*
    Название прибора учета
    @return String
  */
  function GetTitle(){
    if( $this->About != "" ){         // Есть описание?
      return $this->About;
    }elseif( $this->NumSerial != "" ){// Есть серийный номер?
      return $this->NumSerial;
    }
    return "----";
  }
  

  
  
  /*
    Тип для учета для дерева
    @retunr String
  */
  function GetJsTreeType(){
    if( $this->IsOk ){
      return "meter_success";
    }
    return "meter_danger";
  }
  
  
  
  
  /*
    Ссылка на прибор учета
    @return String
  */
  function GetLink(){
    if( $this->GetIsLora() ){
      $converter = converter::Id(0);
      $Filter = array(
        'Filter' => array(
          'Meter' => $this->Id
        )
      );
      $metertypeparameterFilter = meterparameter::Filter($Filter);
      if( $metertypeparameterFilter->Count ){
        $converter = $metertypeparameterFilter->First->Converter;
      }
      return "/vconverter/{$converter->Id}/";
    }
    return "/meter/{$this->Id}/";
  }


  /**
   * GetIsLora
   * 
   * Вернет является ли прибор лоровким
   *
   * @return bool
   */
  function GetIsLora(){
    return strpos( strtolower( $this->Type->DllId ) , strtolower( "lora" ) ) !== false;
  }


  
  
  
  /**
   * Ссылка на таб с архивами
   * 
   * @return string
   */
  function GetLinkRangeArchive(){
    return $this->GetLink() . "range/";
  }
  
  
  
  
  
  /*
    Ссылка на прибор учета
    @return String
  */
  function GetLinkArchive(){
    
    $sufix = isset( $_GET['start'] ) && isset( $_GET['stop'] )
             ? "archive/".implode( "-" ,array( $_GET['start'] , $_GET['stop'] ))."/"
             : "archive/";
    
    return $this->Link. $sufix;
  }
  
  
  /**
   * Получение ссылки на архив из табов
   * 
   * @return string
   */
  function GetLinkArchiveTab(){
    $sufix = isset( $_GET['start'] ) && isset( $_GET['stop'] )
             ? "archive/".implode( "-" ,array( $_GET['start'] , $_GET['stop'] ))."/"
             : "";
    return $this->Link. $sufix;
  }
  
  
  
  /*
    Ссылка на редактирование прибора учета
    @return String
  */
  function GetLinkEdit(){
    return "{$this->Link}edit/";
  }
  
  
  /*
    ссылка на удаление прибора учета
    @return String
  */
  function GetLinkDelete(){
    return "{$this->Link}delete/";
  }
  
  
  /*
    ссылка на лог событий
    @return String
  */
  function GetLinkLog(){
    return "{$this->Link}log/";
  }
  
  
  
  /*
    Ссылка на графики
    @return String
  */
  function GetLinkGraph(){
    
    $sufix = isset( $_GET['start'] ) && isset( $_GET['stop'] )
             ? implode( "-" ,array( $_GET['start'] , $_GET['stop'] ))."/"
             : "";
    
    return "{$this->Link}graphs/".$sufix;
  }
  
  
  /*
    Ссылка на последние данные
    @return String
  */
  function GetLinkLastData(){
    return "{$this->Link}lastdata/";
  }
  
  
  /*
    Ссылка на права доступа к прибору
    @return String
  */
  function GetLinkRule(){
    return "{$this->Link}rule/";
  }
  
  
  /*
    Ссылка на пользовательские иконки
    @return String
  */
  function GetLinkIcons(){
    return "{$this->Link}icons/";
  }
  
  
  /*
    Ссылка на экспорт данных
    @return String
  */
  function GetLinkExport(){
    
    $sufix = isset( $_GET['start'] ) && isset( $_GET['stop'] )
             ? implode( "-" ,array( $_GET['start'] , $_GET['stop'] ))."/"
             : "";
    
    return "{$this->Link}exports/".$sufix;
  }
  
  
  /**
   * Ссылка на редактирование прав на прибор учета
   * 
   * @return string
   */
  function GetLinkRules(){
    return $this->Link. "rules/";
  }
  
  
  
  
  /*
    Ссылка на статусы данных
    @return String
  */
  function GetLinkStatuses(){
    return "{$this->Link}statuses/";
  }
  
  
  
    
  
  
  
  /*
    Ссылка на просмотр архивов
    @return String
  */
  function GetLinkReports(){
    
    $sufix = isset( $_GET['start'] ) && isset( $_GET['stop'] )
             ? implode( "-" ,array( $_GET['start'] , $_GET['stop'] ))."/"
             : "";
             
    return $this->Link."reports/".$sufix;
  }
  
  
  
  
  
  /*
    Ссылка на редактирование исключенности прибора учета
    @return String
  */
  function GetLinkExcludedEdit(){
    return "{$this->Link}excluded_edit/";
  }
  
  
  
  /*
    Отдаем пользователю время на приборе
  */
  function GetDateTitle(){
    return "----";
  }
  
  
  /*
    Удобное выражение исключен прибор или нет
    @return String
  */
  function GetIsExcludedTitle(){
    return $this->IsExcluded ? 'Да' : 'Нет';
  }
  
  
  
  /*
    Удобное для пользователя выражение статуса прибора учета
    @return String
  */
  function GetIsOkTitle(){
    return $this->IsOk ? "Исправен" : "Есть проблемы";
  }
  


  function SetIsOk( $v = 0 ){

    // Сначала меняем на самом приборе.
    $p = "IsOk";
    TObject2::_set_bool($this,$this->_F[$p],$v, $p );

    // Ищем все приборы кто берет от этого прибора параметры и говорим им пересчитаться

    $Filter = array(
      'Filter' => array(
        'Meter' => $this->Id
      )
    );
    foreach( meterparameter::Filter( $Filter )->Elements as $iMP ){
      $iMP->Virtualmeter->ReplaceIsOk();
    }
  }
  
  
  
  /*
    Весь лог событий
    @return TListGroup
  */
  function GetLog(){
    $Filter = array(
      'Filter' => array(
        'Object' => 'meter',
        'ObjectId' => $this->Id,
        'Property !=' => 'query'
      ),
      'Order' => array(
        'Its' => 'DESC'
      )
    );
    return userlog::Filter( $Filter );
  }
  
  
  
  /*
    СИстемный лог событий
    @return TListGroup
  */
  function GetLogSysList(){
    $Filter = array(
      'Filter' => array(
        'Object' => 'meter',
        'ObjectId' => $this->Id,
        'Property =' => 'query'
      ),
      'Order' => array(
        'Its' => 'DESC'
      )
    );
    return userlog::Filter( $Filter );
  }
  
  
  
  
  
  
  
  
  
  /*
    Все события по конвертору
    @return TListGroup
  */
  function GetLogList(){
    if( !$this->Log->Count ) return TListGroup::Init();
    $LogQuery = $this->Log->GroupBy( Site()->CountInPage )->Elements;
    return isset($LogQuery[ Site()->Page ])
            ? $LogQuery[ Site()->Page ]
            : $LogQuery[ 0 ];
  }
  
  
  
  /*
    Все события по конвертору
    @return TListGroup
  */
  function GetLogSysListByPages(){
    if( !$this->LogSysList->Count ) return TListGroup::Init();
    $LogQuery = $this->LogSysList->GroupBy( Site()->CountInPage )->Elements;
    return isset($LogQuery[ Site()->Page ])
            ? $LogQuery[ Site()->Page ]
            : $LogQuery[ 0 ];
  }
  
  
  
  
  
  
  /*
    Дата последнего рабочего времени
    @return userlog
  */
  function GetLastOkTime(){
    $Filter = array( 
      'Filter' => array( 
        'Object' => get_class($this),
        'Property' => 'IsOk',
        'ObjectId' => $this->Id
      ),
      'Order' => array(
        'Id' => 'DESC'
      )
    );
    return userlog::Filter( $Filter )->First;
  }
  
  
  
  
  
  
  /*
    Когда был добавлен в систему
    @return userlog
  */
  function GetAddToSys(){
    $Filter = array( 
      'Filter' => array( 
        'Object' => get_class($this),
        'Property' => 'Add',
        'ObjectId' => $this->Id
      ),
      'Order' => array(
        'Id' => 'ASC'
      )
    );
    return userlog::Filter( $Filter )->First;
  }
  
  
  
  
  
  
  
  /*
    Страницы лога
    @return Array
  */
  function GetLogPages(){
    return Utils::Paginator(
      $this->Log->Count,
      Site()->CountInPage
    );
  }
  
  
  /*
    Страницы лога
    @return Array
  */
  function GetLogSysPages(){
    return Utils::Paginator(
      $this->LogSysList->Count,
      Site()->CountInPage
    );
  }
  
  
  
  
  /*
    Виртуальный прибор учета?
    @return Bool
  */
  function GetIsVirtual(){
    return $this->Type->IsVirtual;
  }
  
  
  
  
  
  
  
  
  /*
    Каклькуляционный прибор учета?
    @return Bool
  */
  function GetIsCalc(){
    return $this->Type->IsCalc;
  }
  
  
  
  
  
  
  /**
   * Можно выключать прибор учета этого типа
   * 
   * @return boolean
   */
  function GetIsOnOff(){
    return $this->Type->GetIsOnOff();
  }
  
  
  
  
  
  /**
   * Выключен ли прибор учета
   * 
   * @return boolean
   */
  function GetIsOff(){
    if( !$this->GetIsOnOff() ){
      return false;
    }
    return !boolval( intval( $this->Get_metervariable_OnOff()->Data ) );
  }
  
  
  
  
  
  
  
  /**
   * Буфер для занесения новой переменной прибора
   * Нужна для того чтобы избежать дублирования в БД
   *
   * @var metervariable | null 
   */
  private $NewVarOnOff = null;


  
  
  
  
  
  
  /**
   * Получение признака включения или выключения прибора учета
   * Создание если не существует
   * 
   * @return metervariable
   */
  function Get_metervariable_OnOff(){
    
    // Если уже есть в кеше
    if( $this->NewVarOnOff !== null ){
      return $this->NewVarOnOff;
    }
    
    // Если его нельзя выключать или выключать
    if( !$this->GetIsOnOff() ){
      return metervariable::Id( 0 );
    }
    
    $Filter = array( 
      'Filter' => array( 
        'VarName' => 'IsOn',
        'Meter'   => $this->Id
      )
    );
    $res = metervariable::Filter($Filter);

    if( $res->Count ){
      return $res->First;
    }
    
    
    $this->NewVarOnOff = metervariable::AddByArray(array(
        'Data'    => 1,
        'VarName' => 'IsOn',
        'Meter'   => $this->Id
    ));
    return $this->NewVarOnOff;
  }
  
  
  
  
  
  
  
  
  
  
  /**
   * Включение или выключение прибора
   * 
   * @param ineger $value
   * @return boolean
   */
  function SetOnOff( $value ){
    
    $var = $this->Get_metervariable_OnOff();
    
    $value = intval( boolval( $value ) );
    
    $is_new = $value != $var->Data;
    
    // Данная операция нужна для того чтобы иметь всегда или 0 или 1
    $var->UpdateByArray(array(
        'Data' => $value
    ));
    $var->Data = $value;
    
    if( $is_new ){
      userlog::AddByArray(array(
          'UserId'    => Self()->Id,
          'Object'    => 'meter',
          'Property'  => $value ? 'ON' : 'OFF' ,
          'ObjectId'  => $this->Id,
          'Action'    => 'Прибор был ' . ( $value ? "включен" : "выключен" )
      ));
    }
    return true;
  }
  
  
  
  
  
  
  /*
    Задания которые ожидаеют
    @return TListGroup
  */
  function GetTaskWaiting(){
    $Filter = array( 
      'Filter' => array( 
        'Meter' => $this->Id,
        'Taskstatus' => 1
      )
    );
    return task::Filter( $Filter );
  }
  
  
  
  /*
    Задания которые выполняются
    @return TListGroup
  */
  function GetTaskRunning(){
    $Filter = array( 
      'Filter' => array( 
        'Meter' => $this->Id,
        'Taskstatus' => 2
      )
    );
    return task::Filter( $Filter );
  }
  
  
  
  
  
  
  
  
  /*
    Является ли этот еще не сконфигурированным TEKON
    @return Bool
  */
  function GetIsSysTkon(){
    return $this->Type->IsTkonSys;
  }
  
  
  
  
  
  
  /*
    Получение последних данных
    @return TListGroup
  */
  function GetLastData(){
    
    $Filter = Array(
      'Filter' => Array(
        'Meter' => $this->Id,
      ),
    );
    
    if( $this->IsFilterParameterLast ){
      $Filter['Filter']['Parameter'] = array();
      foreach( $this->FilterParameterLast->Elements as $filterparamis ){
        $Filter['Filter']['Parameter'][] = $filterparamis->Parameter->Id;
      }
    }
    
    return meterlast::Filter($Filter);
  }
  
  
  
  
  /*
    Получение Объекта ролей для места 
    @return objectrule
  */
  function GetObjectrule(){
    $Filter = array( 
      'Filter' => array( 
        'Ident' => 'Meter'
      )
    );
    $ObjectruleFilter = objectrule::Filter( $Filter );
    if( $ObjectruleFilter->Count ){
      return $ObjectruleFilter->first;
    }
    return objectrule::Id(0);
  }
  
  
  
  /**
   * Получение объекта ссылки на объект прав
   * 
   * @return objectrule
   */
  function GetObjectruleObj(){
    $Filter = array(
        'Filter' => array(
            'Ident' => 'Meter'
        )
    );
    $ObjFilter = objectrule::Filter( $Filter );
    if( $ObjFilter->Count ){
      return $ObjFilter->First;
    }
    return objectrule::Id(0);
  }
  
  
  
  
  /*
    Возвращает все виды экспортов для плейсов
    @return TListGroup
  */
  function GetReports(){
    $Filter = array(
      'Filter' => array(
        'Objectrule' => $this->Objectrule->Id,
        'Interprise' => array( 0 , Self()->Interprise->Id )
      )
    );
    return reports::Filter( $Filter );
  }
  
  
  /*
    Получение всех иконок для прибора
    @return Array
  */
  function GetIcons(){
    $Icons = array();
    $Filter = array( 
      'Filter' => array( 
        'Meter' => $this->Id
    ));
    foreach( logicmeterparameter::Filter($Filter)->Elements as $iIcon ){
      $Icons[ $iIcon->Id ] = $iIcon;
    }
    $Filter = array( 
      'Filter' => array( 
        'Metertype' => $this->Type->Id
    ));
    foreach( logicmeterparameter::Filter($Filter)->Elements as $iIcon ){
      $Icons[ $iIcon->Id ] = $iIcon;
    }
    return $Icons;
  }
  
  
  
  
  
  
  
  /**
   * Получение всех прав на этот прибор учета
   * 
   * @return TListGroup
   */
  function GetPermisson(){
    $Filter = array(
        'Filter' => array(
            'Objectrule' => $this->GetObjectruleObj()->Id,
            'Whyid' => $this->Id
        )
    );
    return link::Filter($Filter);
  }
  
  
  
  
  
  /*
    Построение массива из параметров для склеенного вывода
    @return Array
  */
  function GetHeadActiveParametersData( $after = array() , $before = array() ){
    $a = new HeadTableParameters( $after , $before , $this->ActiveParametersData , $this->Coef > 1 );
    return $a->RowCol();
  }
  
  
  /*
    Активные параметры при показе данных
    @return TListGroup
  */
  function GetActiveParametersData(){
    
    /*
      Берем фильтр
      Если его нет то выводм все все есть
      Если есть то выводим данные по фильтру
    */
    
    if( $this->IsFilterParameterData ){

      $T = TListGroup::Init();

      $Parameters = array();

      $IssetsParametersByExtra = array();
      foreach( $this->AllParameters->Elements as $iParameter ){
        $IssetsParametersByExtra[ $iParameter->Id ] = true;
      }

      foreach( $this->FilterParameterData->Elements as $filterparamis ){
        if( !isset( $IssetsParametersByExtra[ $filterparamis->Parameter->Id ] ) ){
          continue;
        }

        $Parameters[ $filterparamis->Parameter->Id ] = $filterparamis->Parameter;
        $T->SetFElements( array_values( $Parameters ) );
      }

      $T->SetFElements( array_values( $Parameters ) );
      return $T;
    }
    return $this->AllParameters;
    
  }
  
  
  
  
  function GetActiveMeterparametersData(){
    return $this->GetActiveParametersData();
  }
  
  
  
  
  
  function OnAfterSqlUpdate(){
    $this->Converter->RewriteStatusMeterOk();


    $FilterMetertypeFilter = array(
      'Filter' => array(
        'Metertype' => $this->Type->Id
      )
    );

    foreach( metertypeparameter::Filter( $FilterMetertypeFilter )->Elements as $iMetertype ){

      $Filter = array(
        'Filter' => array(
          'Meter' => $this->Id,
          'Parameter' => $iMetertype->Parameter->Id,
        )
      );

      if( !meterlast::Filter( $Filter )->Count ){
        meterlast::AddByArray(
          array(
            'MeterId' => $this->Id,
            'ParameterId' => $iMetertype->Parameter->Id,
            'Year' => $this->GetDate()->format("Y"),
            'Month' => $this->GetDate()->format("m"),
            'Day' => $this->GetDate()->format("d"),
            'Hour' => $this->GetDate()->format("H")
          )
        );
      }
    }

  }
  
  
  
  
  
  
  /*
    Удаление прибора учета
  */
  function Delete() {
    
    $Converter = $this->Converter;
    
    $this->UpdateByArray(array(
      'ConverterId' => 0
    ));
    
    # task 10326
    $Converter->RewriteStatusMeterOk();
    return true;
  }


  function DeleteFull(){
    TObject2::StaticDelete($this);
  }
  
  
  
  
  
  /*
    Генерирование названия фильтра для данных
    @return String
  */
  function GetNameFilterFromData(){
    return "{$this->Type->DllId}.{$this->Interprise->Id}.";
  }
  
  
  
  
  /*
    Проверка есть фильтр или нет на приборе по данным
    @return Int
  */
  function GetIsFilterParameterData(){
    $Filter = array( 
      'Filter' => array( 
        'Object' => 'meter',
        'ObjectId' => $this->Id,
        'Interprise' => Self()->Interprise->Id,
        'Sufix' => ''
      )
    );
    return filterparamname::Filter($Filter)->Count;
  }
  
  
  
  
  /*
    Проверка есть фильтр или нет на приборе по данным
    @return Int
  */
  function GetIsFilterParameterLast(){
    $Filter = array( 
      'Filter' => array( 
        'Object' => 'meter',
        'ObjectId' => $this->Id,
        'Interprise' => Self()->Interprise->Id,
        'Sufix' => 'last'
      )
    );
    return filterparamname::Filter($Filter)->Count;
  }
  
  
  
  
  /*
    Кеши фильтра параметров данных
  */
  private $CacheFilterParameterData = null;
  
  
  /*
    Кеши фильтра параметров последних данных
  */
  private $CacheFilterParameterLast = null;
  
  
  /*
    Получение параметров из фильтра
    @return TListGroup
  */
  function GetFilterParameterLast(){
    
    if( $this->CacheFilterParameterLast ){
      return $this->CacheFilterParameterLast->Parameters;
    }
    
    $this->CacheFilterParameterLast = $this->GetFilterParameter('last');
    return $this->CacheFilterParameterLast->Parameters;
  }
  
  
  
  
  /*
    Получение параметров из фильтра
    @return TListGroup
  */
  function GetFilterParameterData(){
    
    if( $this->CacheFilterParameterData ){
      return $this->CacheFilterParameterData->Parameters;
    }
    
    $this->CacheFilterParameterData = $this->GetFilterParameter('');
    return $this->CacheFilterParameterData->Parameters;
  }
  
  
  
  
  
  
  /*
    Получение объекта фильтра параметров
    @return filterparamname
  */
  function GetFilterParameter( $sufix = "" ){
    $Filter = array( 
      'Filter' => array( 
        'Object'      => 'meter',
        'Interprise'  => Self()->Interprise->Id,
        'ObjectId'    => $this->Id,
        'Sufix'       => $sufix
      )
    );
    $F = filterparamname::Filter($Filter);
    if( $F->Count ){
      return $F->First;
    }else{
      return filterparamname::Id(0);
    }
  }
  
  
  
  
  
  /*
    для совместимости со старой версией
  */
  function GetDatetime(){
    return $this->Date;
  }
  
  
  
  /**
   * Получение иконки прибора учета
   * 
   * @return string
   */
  function GetIcon(){
    switch( $this->Type->Meter_extra_type->Ident ){
      case "ElectricityCounter" :
        return "fa fa-flash";
        break;
      case "AquaCounter" :
        return "fa fa-tint";
        break;
      case "HeatCounter" :
        return "fa fa-thermometer-full";
        break;
    }
    return "fa fa-flash";
  }
  
  
  
  
  
  /**
   * Время на приборе учета
   * 
   * @return DateTime
   */
  function GetDate(){
    
    $Date = clone Site()->GetServerTime();
    
    $TZ = $this->Timezone->Ident ? $this->Timezone->Ident : 'Asia/Yekaterinburg';
    
    $Date->setTimeZone( new DateTimeZone( $TZ ) );

    $Year   = isset( $_GET['year'] ) && $_GET['year'] 
                ? (int) $_GET['year'] 
                : $Date->format('Y') ;
                
    $Month  = isset( $_GET['month'] ) && $_GET['month']
                ? (int) $_GET['month'] 
                : $Date->format('m') ;
                
    $Day    = isset( $_GET['day'] ) && $_GET['day']
                ? (int) $_GET['day'] 
                : $Date->format('d') ;
    
    $Date->setDate( $Year , $Month , $Day );

    return $Date;
    
  }
  
  
  
  
  /**
   * Значение на месяц меньше чем текущая дата на приборе учета
   * 
   * @return DateTime
   */
  function GetDateP1M(){
    $date = clone $this->GetDate();
    return $date->sub( new DateInterval("P1M") );
  }
  
  
  
  
  
  /*
    Какой тип данных от прибора хотят получить
    @return String
  */
  function IsGetRangeDate(){
    if( isset( $_GET['start'] ) && isset( $_GET['stop'] ) ) return "range_day";
    if( !isset( $_GET['year']   ) ) return "now" ;
    if( !isset( $_GET['month']  ) ) return "month" ;
    if( !isset( $_GET['day']    ) ) return "day";
    return 'hour';
  }
  
  
  
  /**
   * Получение минимальной даты для вывода данных
   * 
   * @return DateTime
   */
  function MinDate(){
    
    $Date = isset( $_GET['start'] )
            ? new DateTime( preg_replace('/^(\d{4})(\d{2})(\d{2})$/', "$1-$2-$3", $_GET['start']) )
            : clone $this->Date;
            
    
    // при выгрузке по дням или часам за несколько дней то начинать надо с 00
    if( $this->IsGetRangeDate() != "range_day" ){
      $beforeTimezone = $this->Date->getTimezone()->getName();
      ini_set('date.timezone',$this->Date->getTimezone()->getName());
    }
            
    switch( $this->IsGetRangeDate() ){
      case 'now' : 
        $Date->setTime(0,0,0);
      case 'hour' : 
        $Date->setTime(0,0,0);
      break;
      case 'day' : 
        $Date->modify('first day of this month');
      break;
      case 'month' : 
        $Date->setDate( $Date->format('Y') , 1 , $Date->format('d'));
      break;
      case 'range_day' : 
        $Date->setTime(0,0,0);
      break;
    }
    
    if( $this->IsGetRangeDate() != "range_day" ){
      ini_set('date.timezone',$beforeTimezone);
    }

    return $Date;
  }
  
  
  
  
  /**
   * Получение максимальной даты для вывода данных
   * 
   * @return DateTime
   */
  function MaxDate(){
    $Date = isset( $_GET['stop'] )
            ? new DateTime( preg_replace('/^(\d{4})(\d{2})(\d{2})$/', "$1-$2-$3", $_GET['stop']) )
            : clone $this->GetDate();
   
    $Month  = 0;
    $Year   = 0;
    
    if( isset( $_GET['year'] ) ){
      $Year = (int) $_GET['year'];
    }
    if( isset( $_GET['month'] ) ){
      $Month = (int) $_GET['month'];
    }
    $DateServer = new Datetime( 'now' );
    
    $is_this_month  = $Month && $Year && $Month == (int) $DateServer->format('m') && $Year == (int) $DateServer->format('Y');
    $is_this_year   = $Year && $Year == (int) $DateServer->format('Y');
    
    if( isset( $_GET['start'] ) ){
      $Date->modify("+1 day");
    }
    switch( $this->IsGetRangeDate() ){
      case 'now' : 
        $Date->setTime( $Date->format('H')-1 ,0,0);
      break;
      case 'hour' : 
        $Date->setTime(23,0,0);
      break;
      case 'day' :
        if( !$is_this_month ){
          $Date->modify('last day of this month');
        }
      break;
      case 'month' : 
        $Date->setDate( $Date->format('Y') , ( $is_this_year ? $Date->format('m') : 12 ) , $Date->format('d'));
      break;
      case 'range_day' : 
        $Date->setTime(0,0,0);
      break;
    }
    return $Date;
  }
  
  
  
  
  /*
    модификатор для даты
    @return String
  */
  function GetMod(){
    $mod = "+1 hour";
    switch( $this->IsGetRangeDate() ){
      case "range_day" :
      case "day" :
       $mod = "+1 day"; 
      break;
      case "month" :
       $mod = "+1 month"; 
      break;
    }
    return $mod;
  }
  
  
  /*
    В каком формате выводить данные пользователю
    @return date_format
  */
  function GetFormat($Date){
    $format = "H:00";
    switch( $this->IsGetRangeDate() ){
      case "day" :
       $format = "d m"; 
      break;
      case "month" :
       $format = "Y-M"; 
      break;
    }
    return $format;
  }
  
  /*
    В каком формате выводить данные пользователю
    @return date_format
  */
  function GetFormatSmarty(){
    $format = "%custom_hour";
    switch( $this->IsGetRangeDate() ){
      case "range_day" :
      case "day" :
       $format = "%custom_day"; 
      break;
      case "month" :
       $format = "%custom_month"; 
      break;
    }
    return $format;
  }
  
  
  /*
    Список дат для архива
    @return Array
  */
  function GetDateList(){
    
    $MinDate = $this->MinDate();
    
    $ArrayTime = array();
    
    while( $MinDate->getTimestamp() <= $this->MaxDate()->getTimestamp() ){
      $ArrayTime[] = clone $MinDate;
      $MinDate->modify( $this->Mod );
    }
    
    return $ArrayTime;
  }
  
  
  
  function GetDateHoursList(){
    
    $MinDate = $this->MinDate();
    $MaxDate = $this->MaxDate();
    
    $ArrayTime = array();
    
    while( $MinDate->getTimestamp() <= $MaxDate->getTimestamp() ){
      $ArrayTime[] = clone $MinDate;
      $MinDate->modify( "+1 hour" );
    }

    return $ArrayTime;
  }
  
  
  
  
  
  /*
    Кеш всех параметров к прибора
  */
  protected $CacheAllParameters = null;
  
  
  /*
    Создание кеша данных
    @return Bool
  */
  protected function SetCacheAllParameter(){
    $SQL = Utils::Strip("
      SELECT parameter.* 
      FROM metertypeparameter 
      LEFT JOIN parameter 
        ON metertypeparameter.parameter_id = parameter.id
      WHERE metertypeparameter.metertype_id = {$this->Type->Id}
        AND metertypeparameter.is_use = 1
        AND parameter.id IS NOT NULL
      order by parameter.id
    ");
    $t = parameter::Id(0);
    $this->CacheAllParameters = TListGroup::Prepare( $SQL , $t );
    return true;
  }
  
  
  
  
  
  
  /*
    получение ВСЕХ параметров для физических приборов учета
    @return TListGroup
  */
  function GetAllParameters(){
    if( $this->CacheAllParameters === null ){
      $this->SetCacheAllParameter();
    }
    return $this->CacheAllParameters;
  }
  
  
  
  /*
    совместимость со старой версией
    см. GetAllParameters
  */
  function GetParameters(){
    return $this->AllParameters;
  }
  
  
  
  
  
    
  /*
    Получение всех графиков прибора учета
    @return TListGroup
  */
  function GetGraphs( $restart = false ){

    if( $restart ){
      TObject2::CleanAllObjects();
    }

    // Надо ли перезапустить метод.
    // Нужно если нашли много дубликатов. Чистим.
    $is_restart = false;

    $beforeFR = $GLOBALS['FullRules'];

    // Сначала ищем по фильтру самого прибора
    $SQL = Utils::Strip("SELECT  graphics.* FROM `graphics` 
    left join metertypeparameter on metertypeparameter.metertype_id = graphics.metertype_id
    WHERE graphics.`interprise_id` IN ('0',{$this->Interprise->Id}) AND graphics.`metertype_id` = {$this->Type->Id} 
    and metertypeparameter.metertype_id = graphics.metertype_id
    and metertypeparameter.parameter_id = graphics.`parameter_id`
    ORDER BY graphics.`number` DESC");

    $t = graphics::Id(0);
    $GF = TListGroup::Prepare( $SQL , $t );

    if( $GF->Count ){
      if( !$restart ){
        $parameters = array();
        foreach( $GF->Elements as $iGraph ){
          if( isset( $parameters[ $iGraph->Parameter->Id ] ) ){
            $GLOBALS['FullRules'] = true;
            $iGraph->Delete();
            unset($iGraph);
            $is_restart = true;
            $GLOBALS['FullRules'] = $beforeFR;
          }else{
            $parameters[ $iGraph->Parameter->Id ] = true;
          }
        }
        if( $is_restart ){
          return $this->GetGraphs(true);
        }
      }
      return $GF;
    }else{

      $is_restart = false;

      // Ищем по фильтру типа прибора
      $SQL = Utils::Strip("SELECT  graphics.* FROM `graphics` 
      left join metertypeparameter on metertypeparameter.metertype_id = graphics.metertype_id
      WHERE graphics.`interprise_id` IN ('0',{$this->Interprise->Id}) AND graphics.`metertype_id` = {$this->Type->Id} 
      and metertypeparameter.metertype_id = graphics.metertype_id
      and metertypeparameter.parameter_id = graphics.`parameter_id`
      ORDER BY graphics.`number` DESC");

      $t = graphics::Id(0);
      $GF = TListGroup::Prepare( $SQL , $t );

      if( $GF->Count ){
        if( !$restart ){
          $parameters = array();
          foreach( $GF->Elements as $iGraph ){
            if( isset( $parameters[ $iGraph->Parameter->Id ] ) ){
              $GLOBALS['FullRules'] = true;
              $iGraph->Delete();
              unset($iGraph);
              $is_restart = true;
              $GLOBALS['FullRules'] = $beforeFR;
            }else{
              $parameters[ $iGraph->Parameter->Id ] = true;
            }
          }
          if( $is_restart ){
            return $this->GetGraphs(true);
          }
        }
        return $GF;
      }
    }

    foreach ($this->AllParameters->Elements as $iParameter) {
      graphics::AddByArray(array(
        'MetertypeId' => $this->Type->Id,
        'InterpriseId' => $this->Interprise->Id,
        'ParameterId' => $iParameter->Id
      ));
    }

    $Filter = array(
        'Filter' => array(
          'Metertype'   => $this->Type->Id,
          'Interprise'  =>  array(0,Self()->Interprise->Id)
        ),
        'Order' => array(
          'Number' => 'DESC'
        )
      );
      $GF = graphics::Filter( $Filter );

    return $GF;
  }
  
  
  
  /*
    Кол-во данных которое можно запросить снова
  */
  public $CountRetry = 0;
  
  
  /*
    Добавление к кол-ву перезапрашиваемых данных
    @return @Bool
  */
  function GetAddCountRetry(){
    $this->CountRetry++;
  }
  
  
  
  
  /*
    Кеш заданий на приборе учета Array
  */
  protected $_CacheTasks = null;
  
  
  
  /*
    Кол-во заданий ожидает
  */
  protected $CountTaskWaiting = 0;
  
  
  /*
    Получение кол-ва даний которые ожидают
    @return Int
  */
  function Get_CountTaskWaiting(){
    if( $this->CacheTasks === null ){
      // TODO вызов работает ОЧЕНЬ ДОЛГО
      //$this->SetCacheTasks();
    }
    return $this->CountTaskWaiting;
  }
  
  
  /*
    Кол-во заданий выполняется
  */
  protected $CountTaskRunning = 0;
  
  /*
    Получение кол-ва заданий которые выполняются
    @return Int
  */
  function Get_CountTaskRunning(){
    if( $this->CacheTasks === null ){
      // TODO вызов работает ОЧЕНЬ ДОЛГО
      //$this->SetCacheTasks();
    }
    return $this->CountTaskRunning;
  }
  
  
  /*
    Наполнение кеша заданий
    @return Bool
  */
  protected function SetCacheTasks(){
    $Filter = array( 
      'Filter' => array( 
        'Meter' => $this->Id,
        'Taskstatus <' => 3,
      )
    );
    
    $this->_CacheTasks = array();
    
    if( !isset($_GET['report']) ){
      foreach( task::Filter( $Filter )->Elements as $iTask ){
        $this->_CacheTasks[ $iTask->Parameter->Id ][ $iTask->Month ][ $iTask->Day ][ $iTask->Hour ] = 1 ;
      }
    }
    return true;
  }
  
  
  /*
    Получение кеша
    @return CacheTasks
  */
  function GetCacheTasks(){
    if( $this->_CacheTasks === null ){
      $this->SetCacheTasks();
    }
    return $this->_CacheTasks;
  }
  
  
  
  
  
  /*
    Формат вывода данных для пользователя
  */
  protected $DateFormat = "d-m-Y";
  
  
  /*
    Формат вывода даты для ссылки
  */
  protected $DateFormatLink = "Y/m/d/";
  
  
  
  
  /*
    Формирование ссылки назад во времени
    @return String
  */
  function GetPrevDateLink(){
    return $this->GetLinkArchive().$this->PrevDate->format( $this->DateFormatLink );
  }
  
  /*
    Получение предыдущей даты
    @return DateTime
  */
  function GetPrevDate(){
    $date = clone $this->Date;
    $date->modify('-1 day');
    return $date;
  }
  
  
  /*
    Получение удобно читаемой даты для пользователя
    @return String
  */
  function GetPrevDateTitle(){
    return $this->PrevDate->format( $this->DateFormat );
  }
  
  
  /*
    показ текущей даты на месте
    @return String
  */
  function GetDateLink(){
    return $this->Date->format( $this->DateFormat );
  }
  
  
  /*
    Формирование ссылки вперед во времени
    @return String
  */
  function GetNextDateLink(){
    return $this->LinkArchive.$this->NextDate->format( $this->DateFormatLink );
  }
  
  
  /*
    Получение удобно читаемой даты для пользователя
    @return String
  */
  function GetNextDateTitle(){
    return $this->NextDate->format( $this->DateFormat );
  }
  
  
  
  
  /*
    Получение следующей даты
    @return DateTime
  */
  function GetNextDate(){
    $date = clone $this->Date;
    $date->modify('+1 day');
    return $date;
  }
  
  
  
  
  
  
  /*
    Кеш запрашиваемых данных
    @return Bool
  */
  protected $CacheArchive = null;
  
  
  
  /*
    Кеш ресурcа запрашиваемых данных
    @return Bool
  */
  public $CacheArchiveSource = null;
  
  
  
  
  
  public function PreSetCacheArchiveHoursSource(){
    DB::Select("DROP TABLE IF EXISTS mdh_date_range");

    $SQL = Utils::Strip("
      CREATE TEMPORARY TABLE mdh_date_range (
        year          INT,
        month         INT,
        day           INT,
        hour          INT,
        meter_id      INT,
        parameter_id  INT
      )
    ");

    DB::Select( $SQL );

    $SQL = Utils::Strip("INSERT INTO mdh_date_range ( year , month , day , hour , meter_id , parameter_id ) VALUES ");

    $SQLAR = array();

    $counter = 0;
    
    foreach( $this->GetDateHoursList() as $iDate ){
      foreach( $this->ActiveParametersData->Elements as $iParameter ){
        $SQLAR[] = "(" . $iDate->format("Y,m,d,H") .",{$this->Id},{$iParameter->Id})";
        $counter++;

        if( count( $SQLAR ) >= 300 ){
          $_SQL = $SQL . implode(",",$SQLAR);
          DB::Select( $_SQL );
          $SQLAR = array();
        }

      }
    }

    if( $SQLAR ){
      $SQL .= implode(",",$SQLAR);

      DB::Select( $SQL );
    }

    $SQL = Utils::Strip("
      select meterdatahour.* from meterdatahour 
      left join mdh_date_range 
        on mdh_date_range.year = meterdatahour.year
        and mdh_date_range.month = meterdatahour.month
        and mdh_date_range.day = meterdatahour.day
        and mdh_date_range.hour+1 = meterdatahour.hour
        and mdh_date_range.parameter_id = meterdatahour.parameter_id
        and mdh_date_range.meter_id = meterdatahour.meter_id
      where mdh_date_range.year = meterdatahour.year
        and mdh_date_range.month = meterdatahour.month
        and mdh_date_range.day = meterdatahour.day
        and mdh_date_range.hour+1 = meterdatahour.hour
        and mdh_date_range.parameter_id = meterdatahour.parameter_id
        and mdh_date_range.meter_id = meterdatahour.meter_id
    ");
    
    $this->CacheArchiveHoursSource = DB::Select( $SQL );
  }
  
  
  protected function SetCacheArchiveHours(){
  
    $this->PreSetCacheArchiveHoursSource();

    $i = 0;
    
    while( $Row = DB::Fetch( $this->CacheArchiveHoursSource ) ){
      $this->CacheArchiveHours[ $Row['parameter_id'] ][$Row['month']][$Row['day']][$Row['hour']-1] = $i++;
    }
    
    if( !$i ) $this->CacheArchiveHours = array();
    
    
    return true;
  }
  
  
  public $CacheArchiveHoursSource = NULL;
  
  
  protected $CacheArchiveHours = null;
  
  
  
  
  
  
  

  public function PreSetCacheArchive(){
    /*
     *TODO временно убрано
    if( $this->CacheTasks === null ){
      $this->SetCacheTasks();
    }
    */
    
    if( isset( $_GET['start'] ) ){
      
      DB::Select("DROP TABLE IF EXISTS mdh_date_range");
      
      $SQL = Utils::Strip("
        CREATE TEMPORARY TABLE mdh_date_range (
          year          INT,
          month         INT,
          day           INT,
          hour          INT,
          meter_id      INT,
          parameter_id  INT
        )
      ");
      
      DB::Select( $SQL );
      
      $SQL = Utils::Strip("INSERT INTO mdh_date_range ( year , month , day , hour , meter_id , parameter_id ) VALUES ");
      
      $SQLAR = array();
      
      $counter = 0;
      
      foreach( $this->DateList as $iDate ){
        foreach( $this->ActiveParametersData->Elements as $iParameter ){
          $SQLAR[] = "(" . $iDate->format("Y,m,d") .",0,{$this->Id},{$iParameter->Id})";
          $counter++;
          
          if( count( $SQLAR ) >= 300 ){
            $_SQL = $SQL . implode(",",$SQLAR);
            DB::Select( $_SQL );
            $SQLAR = array();
          }
          
        }
      }
      
      if( $SQLAR ){
        $SQL .= implode(",",$SQLAR);
        
        DB::Select( $SQL );
      }
      
      $SQL = Utils::Strip("
        select meterdatahour.* from meterdatahour 
        left join mdh_date_range 
          on mdh_date_range.year = meterdatahour.year
          and mdh_date_range.month = meterdatahour.month
          and mdh_date_range.day = meterdatahour.day
          and mdh_date_range.hour = meterdatahour.hour
          and mdh_date_range.parameter_id = meterdatahour.parameter_id
          and mdh_date_range.meter_id = meterdatahour.meter_id
        where mdh_date_range.year = meterdatahour.year
          and mdh_date_range.month = meterdatahour.month
          and mdh_date_range.day = meterdatahour.day
          and mdh_date_range.hour = meterdatahour.hour
          and mdh_date_range.parameter_id = meterdatahour.parameter_id
          and mdh_date_range.meter_id = meterdatahour.meter_id
      ");
      
    }else{
      
      $Year   = 0;
      $Month  = 0;
      $Day    = 0;
      $Hour   = 0;
      
      if( isset( $_GET['year'] ) ){
        $Year = (int) $_GET['year'];
      }
      if( isset( $_GET['month'] ) ){
        $Month = (int) $_GET['month'];
      }
      if( isset( $_GET['day'] ) ){
        $Day = (int) $_GET['day'];
      }
      
      $DateNow = new DateTime('now');
      
      $is_this_month = $Month && $Year && $Month == (int) $DateNow->format('m') && $Year == (int) $DateNow->format('Y');
      
      switch( $this->IsGetRangeDate() ){
        case 'hour' :
        case 'now' :
          $Filter = array( 
            'Filter' => array( 
              'Meter'       => (int) $this->Id,
              'Year'        => (int) $this->Date->format('Y'),
              'Month'       => (int) $this->Date->format('m'),
              'Day'         => (int) $this->Date->format('d'),
              'Hour'        => range(1, 24)
            )
          );
        break;
        case 'day' :
          $Filter = array( 
            'Filter' => array( 
              'Meter'       => (int) $this->Id,
              'Year'        => (int) $this->Date->format('Y'),
              'Month'       => (int) $this->Date->format('m'),
              'Day'         => range(1, ( $is_this_month ? (int) $this->Date->format('d') : 31 )),
              'Hour'        => 0
            )
          );
        break;
        case 'month' :
          $Filter = array( 
            'Filter' => array( 
              'Meter'       => (int) $this->Id,
              'Year'        => (int) $this->Date->format('Y'),
              'Month'       => range(1, 12),
              'Day'         => 0,
              'Hour'        => 0
            )
          );
        break;
      }
      
      $Filter['Limit'] = count($this->ActiveParametersData->Elements) * 1000;
      
      foreach( $this->ActiveParametersData->Elements as $iParameter ){
        $Filter['Filter']['Parameter'][] = $iParameter->Id;
      }
      
      $SQL = meterdatahour::Filter( $Filter )->Sql;
      
    }
    
    
    $this->CacheArchiveSource = DB::Select( $SQL );
  }


  
  /*
    Наполенение CacheArchive
    @return Bool
  */
  protected function SetCacheArchive(){
    
    $this->PreSetCacheArchive();

    $i = 0;
    
    while( $Row = DB::Fetch( $this->CacheArchiveSource ) ){
      $this->CacheArchive[ $Row['parameter_id'] ][$Row['month']][$Row['day']][$Row['hour']] = $i++;
    }
    
    if( !$i ) $this->CacheArchive = array();
    
    
    return true;
  }
  
  
  private $LastMDHArchive = null;
  

  /**
   * Получение из кеша данных данных по его ключу
   * 
   * @param parameter $oParameter
   * @param DateTime $oDate
   * @return meterdatahour
   */
  function GetMDH( $oParameter , $oDate ){

    if( $this->CacheArchive === null ){
      $this->SetCacheArchive();
    }
    
    if( $this->CacheTasks === null ){
      $this->SetCacheTasks();
    }
    
    if( $this->LastMDHArchive && is_object($this->LastMDHArchive) ){
      $this->LastMDHArchive->__destruct();
    }
    
    set_time_limit(5);
    
    $Month  = $oDate->format('m');
    $Day    = $oDate->format('d');
    $Hour   = $oDate->format('H');
    
    switch( $this->IsGetRangeDate() ){
      case 'range_day' :
      case 'day' :
        $Hour = 0;
      break;
      case 'month' :
        $Hour = 0;
        $Day = 0;
      break;
      default :
        $Hour++;
      break;
    }
    
    
    if( isset( $this->CacheTasks[ $oParameter->Id ][ ceil($Month) ][ ceil($Day) ][ ceil($Hour) ] ) ){
      return Site()->Config('ru.sys.mdh_wait' ,"Ожидает");
    }elseif( isset( $this->CacheArchive[ $oParameter->Id ][ ceil($Month) ][ ceil($Day) ][ ceil($Hour) ] ) ){
      $position = $this->CacheArchive[ $oParameter->Id ][ ceil($Month) ][ ceil($Day) ][ ceil($Hour) ];
      
      DB::DataSeek($this->CacheArchiveSource , $position);
      
      $this->LastMDHArchive = meterdatahour::SetFieldsFromObject(DB::Fetch($this->CacheArchiveSource));
      
      if( !$this->LastMDHArchive->Loginfo->Is ) return meterdatahour::Id(0);
      
      return $this->LastMDHArchive;
      
    }
    return meterdatahour::Id(0);
  }
  
  
  
  
  
  /**
   * Получение данных за определенный час
   * 
   * @param parameter $oParameter
   * @param DateTime $oDate
   * @return meterdatahour
   */
  function GetMDHHours( $oParameter , $oDate ){
  
    if( $this->CacheArchiveHours === null ){
      $this->SetCacheArchiveHours();
    }
    
    if( $this->LastMDHArchive && is_object($this->LastMDHArchive) ){
      $this->LastMDHArchive->__destruct();
    }
    
    set_time_limit(5);
    
    $Month  = $oDate->format('m');
    $Day    = $oDate->format('d');
    $Hour   = $oDate->format('H');
    
    
    if( isset( $this->CacheTasks[ $oParameter->Id ][ ceil($Month) ][ ceil($Day) ][ ceil($Hour) ] ) ){
      return Site()->Config('ru.sys.mdh_wait' ,"Ожидает");
    }elseif( isset( $this->CacheArchiveHours[ $oParameter->Id ][ ceil($Month) ][ ceil($Day) ][ ceil($Hour) ] ) ){
      $position = $this->CacheArchiveHours[ $oParameter->Id ][ ceil($Month) ][ ceil($Day) ][ ceil($Hour) ];
      
      DB::DataSeek($this->CacheArchiveHoursSource , $position);
      
      $this->LastMDHArchive = meterdatahour::SetFieldsFromObject(DB::Fetch($this->CacheArchiveHoursSource));
      
      if( !$this->LastMDHArchive->Loginfo->Is ) return meterdatahour::Id(0);
      
      return $this->LastMDHArchive;
      
    }
    return meterdatahour::Id(0);
  }
  
  
  
  protected $CacheMDHToday = array();




  /**
   * Получение данных за получасовку
   * 
   * @param parameter $iParameter Параметр по которому получаем
   * @param int       $index Индекс получасовки в диапазоне от 0 до 47
   * @param string    $start_date Дата за которую брать данные. Формат YYYY-MM-DD
   * @return meterdatahour
   */
  function GetMDHToday( $iParameter , $index , $start_date ){
    
    // Новый параметр.
    // Начинаем под него собирать данные за сегодня
    if( (int) !$index ){
      $Filter = array(
          'Filter' => array(
            'Hour >'    => 0,
            'Year'      => $start_date->format("Y"),
            'Month'     => $start_date->format("m"),
            'Day'       => $start_date->format("d"),
            'Meter'     => $this->Id,
            'Parameter' => $iParameter->Id
          )
      );
      foreach( meterdatahour::Filter( $Filter )->Elements as $iMDH ){
        $this->CacheMDHToday[ $iMDH->Hour ] = $iMDH;
      }
    }
    
    $MDH = meterdatahour::Id( 0 );
    
    $index_to_H = ceil(($index+1) / 2);
    
    if( isset( $this->CacheMDHToday[ $index_to_H ] ) ){
      $MDH = $this->CacheMDHToday[ $index_to_H ];
    }
    
    // Первая получасовка и парамметр суммируется
    if( !($index%2) && $iParameter->GetUseSum() && $MDH->Value ){
      $value = $MDH->Value / 2;
      
      
      $MDH->Des;
      return meterdatahour::SetFieldsFromObject(array(
          'id'            => $MDH->Id,
          'meter_id'      => $MDH->Meter->Id,
          'parameter_id'  => $MDH->Parameter->Id,
          'tarif_id'      => $MDH->Tarif->Id,
          'year'          => $MDH->Year,
          'month'         => $MDH->Month,
          'day'           => $MDH->Day,
          'hour'          => $MDH->Hour,
          'loginfo_id'    => $MDH->Loginfo->Id,
          'add_time'      => $MDH->AddTime,
          'value'         => $value
      ));
    }else{
      return $MDH;
    }
    
    if( $index == 47 ){
      foreach( $this->CacheMDHToday as $iMDH ){
        $iMDH->Des;
      }
    }
    
    return $MDH;
  }
  
  
  
  
  
  
  
  
  
  
  
  
  
  /**
   * Получение группированных данных по параметру
   * 
   * @param parameter $oParameter
   * @return meterdatahour
   */
  function GetGroupMDH( parameter $oParameter ){
    
    $MDH = meterdatahour::Id(0);
    
    $d = isset( $_GET['day'] ) ? ceil( $_GET['day'] ) : $this->GetDate()->format('d') ;
    $m = isset( $_GET['month'] ) ? ceil( $_GET['month'] ) : $this->GetDate()->format('m') ;
    
    if( isset( $_GET['year'] ) && !isset( $_GET['day'] ) ){
      $d = 0;
    }
    if( isset( $_GET['year'] ) && !isset( $_GET['month'] ) ){
      $m = 0;
    }
    
    $Filter = array(
        'Filter' => array(
            'Meter'     => $this->Id,
            'Parameter' => $oParameter->Id,
            'Year'      => $this->GetDate()->format('Y'),
            'Month'     => $m,
            'Day'       => $d,
            'Hour'      => 0
        )
    );
    
    $Res = meterdatahour::Filter( $Filter );
    
    if( $Res->Count ){
      return $Res->First;
    }
    
    return $MDH;
  }
  
  
  
  
  
  
  
  
  
  /*
    Перед тем как добавлять прибор учета
    Выставим ему предприятие что и пользователю
  */
  static function BeforeAdd( $A ){
    if( isset( $A['TypeId'] ) ){
      if( metertype::Id($A['TypeId'])->IsFilter ){
        $A['IsExcluded'] = 0;
      }
    }
    if( !isset( $A['InterpriseId'] ) ){
      $A['InterpriseId'] = Self()->Interprise->Id;
    }

    if(!isset($A['Inuse']) || !$A['Inuse']){
      $A['Inuse'] = 1;
    }

    if( isset( $A['ModelId'] ) && $A['ModelId'] ){
      $A['TypeId'] = model::Id( $A['ModelId'] )->Type->Id;
    }

    // Тип всегда выставялем 0
    $A['Meter_extra_typeId'] = 0;

    return $A;
  }
  


  function GetFirstVerification(){
    $Filter = array(
      'Filter' => array(
        'Meter' => $this->Id
      )
    );
    $res = verificationmeter::Filter($Filter);
    if( $res->Count ){
      return $res->First->Start;
    }
    return "";
  }


  function GetVerification(){
    $Filter = array(
      'Filter' => array(
        'Meter' => $this->Id
      ),
      'Order' => array(
        'Id' => 'DESC'
      )
    );
    if( verificationmeterlog::Filter($Filter)->Count ){
      return verificationmeterlog::Filter($Filter)->First->Date;
    }

    return "";
  }


  function GetNextVerification(){
     $Filter = array(
      'Filter' => array(
        'Meter' => $this->Id
      )
    );
    $res = verificationmeter::Filter($Filter);
    if( $res->Count && $res->First->Start != "" ){
      $date = new Datetime($res->First->Start);
      return $this->AddInterval($date , $res->First->Interval);
    }
    return "";
  }

  function GetVerificationInterval(){
    $Filter = array(
      'Filter' => array(
        'Meter' => $this->Id
      )
    );
    $res = verificationmeter::Filter($Filter);
    if( $res->Count ){
      return $res->First->Interval;
    }
    return "";
  }

  function AddInterval( $date , $interval){
    $now = new Datetime();
    if( $date->format("Ymd") > $now->format("Ymd") ){
      return $date->format("Y-m-d");
    }
    $date->modify("+{$interval} months");
    return $this->AddInterval($date,$interval);
  }


  function VerificationAdd($A = array()){

    if( isset( $A['not_valid_json'] ) ){
      if( !empty( $A['not_valid_json']['verificationfirst'] ) ){
        $Filter = array(
          'Filter' => array(
            'Meter' => $this->Id
          )
        );
        if( verificationmeter::Filter($Filter)->Count ){
          verificationmeter::Filter($Filter)->First->UpdateByArray(array(
            'MeterId' => $this->Id,
            'Start' => $A['not_valid_json']['verificationfirst'],
            'Interval' => isset($A['not_valid_json']['interval']) ? $A['not_valid_json']['interval'] : 0
          ));
        }else{
          verificationmeter::AddByArray(array(
            'MeterId' => $this->Id,
            'Start' => $A['not_valid_json']['verificationfirst'],
            'Interval' => isset($A['not_valid_json']['interval']) ? $A['not_valid_json']['interval'] : 0
          ));
        }

      }
      if( !empty( $A['not_valid_json']['verification'] ) ){
        verificationmeterlog::AddByArray(array(
          'MeterId' => $this->Id,
          'Date' => isset($A['not_valid_json']['verification']) ? $A['not_valid_json']['verification'] : ""
        ));
      }
    }
  }


  // public function UpdateByRequest(){$this->VerificationAdd($_REQUEST);TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){
    $this->VerificationAdd($A);


    if(empty($A['ModelId'])){
      $A['ModelId'] = 0;
    }

    if( isset( $A['not_valid_json'] ) ){

      if( isset( $A['not_valid_json']['number_plomb'] ) ){
        $this->NumberPlomb = $A['not_valid_json']['number_plomb'];
      }

      $Filter = array(
        'Filter' => array(
          'Meter' => $this->Id
        )
      );

      $Verification = verificationmeter::Id(0);

      $FindVerification = verificationmeter::Filter( $Filter );
      if( $FindVerification->Count ){
        $Verification = $FindVerification->First;
      }else{
        $Verification = verificationmeter::AddByArray(array(
          'MeterId' => $this->Id
        ));
      }

      if( isset( $A['not_valid_json']['first_date_verification'] ) ){
        $Verification->UpdateByArray(array(
          'Start' => (string) $A['not_valid_json']['first_date_verification']
        ));
      }

      if( isset( $A['not_valid_json']['interval_verification'] ) ){
        $Verification->UpdateByArray(array(
          'Interval' => (int) $A['not_valid_json']['interval_verification']
        ));
      }

      $Verification->Save();
    }

    TObject2::StaticUpdateByArray($this,$A);}

  /*
    Добавление используя массив данных
    @param Array
    @return Object
  */
  static public function AddByArray($A){
    $t = new meter();
    
    $A = self::BeforeAdd($A);
    
    if( !isset( $A['Coef'] ) && !isset($_REQUEST['Coef']) ){
      $A['Coef'] = 1;
    }

    TObject2::StaticAddByArray($t,$A);


    $t->VerificationAdd($A);

    /*
      #47078
      Если это каунтер то нужно добавить новый виртуальный узел учета.
      И добавить 8 вирт. приборов на него
    */
    if( preg_match( '/^(.*)COUNTER_([0-9])I$/' , metertype::Id( $A['TypeId'] )->DllId , $m ) ){
      $Vconverter = vconverter::AddByArray(array(
        'About' => $t->Title
      ));

      for( $i = 1; $i <= $m[2] ; $i++ ){
        $vmeter = vmeter::AddByArray(array(
          'ConverterId' => $Vconverter->Id,
          'About' => 'Вход' . $i
        ));


        $Filter = array(
          'Filter' => array(
            'Ident' => "COUNT_" . $i
          )
        );
        $S = parameter::Filter($Filter);

        if( !$S->Count ){
          continue;
        }

        meterparameter::AddByArray(array(
         'MeterId' => $t->Id,
         'ParameterId' => $S->First->Id,
         'VirtualmeterId' => $vmeter->Id,
         'VirtualparameterId' => $S->First->Id,
         'ConverterId' => $Vconverter->Id,
         'Isuse' => 1
        ));
      }

    }elseif( preg_match( '/^LORA_(.*)$/' , metertype::Id( $A['TypeId'] )->DllId , $m ) ){


      $count_imp = 0;
      switch( metertype::Id( $A['TypeId'] )->DllId ){
        case "LORA_CI_11" :
          $count_imp = 4;
        break;
        case "LORA_CI_12" :
          $count_imp = 6;
        break;
        case "LORA_CI_13_MER" :
          $count_imp = 1;
        break;
        case "LORA_TD_11" :
          $count_imp = 1;
        break;
        case "LORA_TP_11" :
          $count_imp = 1;
        break;
        case "LORA_MC_0101" :
          $count_imp = 1;
        break;
        case "LORA_AS_0101" :
          $count_imp = 1;
        break;
        case "LORA_MS_0101" :
          $count_imp = 1;
        break;
        case "LORA_CBE1" :
          $count_imp = 1;
        break;
        case "LORA_SS_0101" :
          $count_imp = 1;
        break;
        case "LORA_CI_21" :
          $count_imp = 4;
        break;
        case "LORA_Electro" :
          $count_imp = 1;
        break;
        case "LORA_GM_2" :
          $count_imp = 1;
        break;
        case "LORA_LM_1" :
          $count_imp = 1;
        break;
      }


      $Vconverter = vconverter::AddByArray(array(
        'About' => $t->Title
      ));

      for( $i = 1; $i <= $count_imp ; $i++ ){
        $vmeter = vmeter::AddByArray(array(
          'ConverterId' => $Vconverter->Id,
          'About' => 'Вход' . $i
        ));


        $Filter = array(
          'Filter' => array(
            'Ident' => "COUNT_" . $i
          )
        );
        $S = parameter::Filter($Filter);

        if( !$S->Count ){
          continue;
        }

        meterparameter::AddByArray(array(
         'MeterId' => $t->Id,
         'ParameterId' => $S->First->Id,
         'VirtualmeterId' => $vmeter->Id,
         'VirtualparameterId' => $S->First->Id,
         'ConverterId' => $Vconverter->Id,
         'Isuse' => 1
        ));
      }

      $vmeter = vmeter::AddByArray(array(
        'ConverterId' => $Vconverter->Id,
        'About' => 'Температура'
      ));

      $Filter = array(
        'Filter' => array(
          'Ident' => "TEMP"
        )
      );
      $S = parameter::Filter($Filter);

      if( $S->Count ){
        meterparameter::AddByArray(array(
         'MeterId' => $t->Id,
         'ParameterId' => $S->First->Id,
         'VirtualmeterId' => $vmeter->Id,
         'VirtualparameterId' => $S->First->Id,
         'ConverterId' => $Vconverter->Id,
         'Isuse' => 1
        ));
      }


    }

    if( isset( $A['not_valid_json'] ) ){
      if( isset( $A['not_valid_json']['number_plomb'] ) ){
        $t->NumberPlomb = $A['not_valid_json']['number_plomb'];
      }
    }

    $t->AfterAdd();

    return $t;
  }
  
  
  
  function OnAfterSqlInsert(){
    $this->Converter->RewriteStatusMeterOk();
  }
  
  
  
  
  /*
    Добавление используя REQUEST массив
    @param Array
    @return Object
  */
  static public function AddByRequest(){
    $t = new meter();
    
    $_REQUEST = self::BeforeAdd($_REQUEST);
    
    if( !isset( $_REQUEST['Coef'] ) or $_REQUEST['Coef'] ) {
      $_REQUEST['Coef'] = 1;
    }

    
    TObject2::StaticAddByRequest($t);
    $t->VerificationAdd($A);

    $t->AfterAdd();
    return $t;
  }
  
  
  
  static public function All( $c=-1 )
  {
    if( !isset( 
      meter::$_R['All']
    )){
      $Filter = array();
      if( !Self()->FullRules ){
        $Filter = array( 
          'Filter' => array( 
            'Interprise' => Self()->Interprise->Id
          )
        );
      }
      meter::$_R['All'] 
      = TObject2::Filter( new meter(),$Filter);
    }
    return meter::$_R['All'];
  }
  
  
  
  static public function Filter($aParams = null , $etc = array()){
    $t=new meter();
    if( !isset( $aParams['Filter']['Interprise'] ) && !Self()->FullRules ){
      $aParams['Filter']['Interprise'] = Self()->Interprise->Id;
    }
    $aParams['Filter']['Converter >'] = 0;
    return TObject2::Filter($t,$aParams);
  }
  


  /*
    Получение всем моделей на уровне с моделью прибора
    @return array model
  */
  function GetModelOneLine(){

    // Если модель не выбрана - берется первая из типа прибора
    if( !$this->Model->Id ){
      return $this->Type->GetModelOneLine();
    }

    return $this->Model;
  }



  function GetModelId(){
    if( !$this->Model->Id ){
      return $this->GetModelOneLine()->First->Id;
    }
    return $this->Model->Id;
  }


  function GetNumberPlomb(){

    $Filter = array( 
      'Filter' => array( 
        'VarName' => 'NumberPlomb',
        'Meter'   => $this->Id
      )
    );
    $res = metervariable::Filter($Filter);

    if( $res->Count ){
      return $res->First;
    }

    $t = new DateTime();
    
    return metervariable::AddByArray(array(
        'Data'    => "",
        'VarName' => 'NumberPlomb',
        'Meter'   => $this->Id,
        'AddTime' => $t->format("Y-m-d H:i:s")
    ));
  }


  function SetNumberPlomb( $value = "" ){
    $Filter = array( 
      'Filter' => array( 
        'VarName' => 'NumberPlomb',
        'Meter'   => $this->Id
      )
    );
    $res = metervariable::Filter($Filter);

    if( $res->Count ){
      return $res->First->UpdateByArray(array(
        'Data' => $value
      ));
    }

    $t = new DateTime();
    
    metervariable::AddByArray(array(
        'Data'    => $value,
        'VarName' => 'NumberPlomb',
        'Meter'   => $this->Id,
        'AddTime' => $t->format("Y-m-d H:i:s")
    ));
  }




  function AfterAdd(){
    $FilterMetertypeFilter = array(
      'Filter' => array(
        'Metertype' => $this->Type->Id
      )
    );

    foreach( metertypeparameter::Filter( $FilterMetertypeFilter )->Elements as $iMetertype ){
      meterlast::AddByArray(
        array(
          'MeterId' => $this->Id,
          'ParameterId' => $iMetertype->Parameter->Id,
          'Year' => $this->GetDate()->format("Y"),
          'Month' => $this->GetDate()->format("m"),
          'Day' => $this->GetDate()->format("d"),
          'Hour' => $this->GetDate()->format("H")
        )
      );
    }
  }
  

}
