<?php
/*
Имя класса meterdatahour
Имя файла meterdatahour.class.php ( meterdatahourcustom.class.php )
Поля класса:
Id : id
Meter : object
Parameter : object
Tarif : object
Year : int
Month : int
Day : int
Hour : int
Value : int
Loginfo : object
AddTime : string
*/
class meterdatahour extends meterdatahourcustom{
  
  
  
  
  public $FieldsToJSON = array(
    'Id'            => 'id',
    'Meter'         => 'meter',
    'Parameter'     => 'parameter',
    'Year'          => 'year',
    'Month'         => 'month',
    'Day'           => 'day',
    'Hour'          => 'hour',
    'Value'         => 'value',
    'ValueConv'     => 'valueconv',
    'Loginfo'       => 'loginfo',
    'AddTime'       => 'addtime',
  );  
  
  
  public $_OtherData = array();
  
  
  function GetValueConv(){
    return self::GetValueConvByParameter( $this->Parameter , $this->Value );
  }
  
  
  
  
  // Хороший ли этот статус у данного
  public function GetIsVeryGoodStatus(){
    return in_array( $this->Loginfo->Logtext , array( "OK" ) );
  }
  
  
  
  // Нормальный ли этот статус у данного
  public function GetIsNormalStatus(){
    return in_array( $this->Loginfo->Logtext , array( "OK_CULC" , 'OK_NOTFULL' ) );
  }
  
  
  /*
    Список значений который meteralst будет считать успешными
    @return Array
  */
  function GetOkStatuses(){
    $ArrayStatuses = Site()->Config( 'Meterlast.ArrayStatuses', 'OK,NODATA,ERROR' );
		return explode(',',$ArrayStatuses);
  }
  
  
  /*
    Это хорошее значение?
    @return Bool
  */
  function GetIsOnOkState() {
    return in_array( $this->Loginfo->Logtext, Array(
       'OK', 'NODATA'
    ) );
  }



  /*
    Это плохое значение?
    @return Bool
  */
  function GetIsNotOnOkState() {
    return in_array( $this->Loginfo->Logtext, Array(
      'TIME_OUT', 'ERROR', 'NO_CONNECTION'
    ) );
  }
  
  
  
  static function NeedCulcJoinDays(){
		$t=new meterdatahour();
		$sql = Utils::Strip("
      SELECT {$t::$SqlFields} , 
        need_culc.meterdatahour_id as ncid 
      FROM 
        need_culc 
      left join 
        meterdatahour on  `meterdatahour`.`id`=need_culc.meterdatahour_id 
      where need_culc.type=1");
		return TListGroup::Prepare( $sql, $t );
	}
	
	static function NeedCulcJoinMonth(){
		$t=new meterdatahour();
		$sql = Utils::Strip("
      SELECT {$t::$SqlFields}, 
        need_culc.meterdatahour_id as ncid 
      FROM need_culc 
      left join meterdatahour on  `meterdatahour`.`id`=need_culc.meterdatahour_id 
      where need_culc.type=2");
		return TListGroup::Prepare( $sql, $t );
	}
  
  
  
  # from task #11377
  # task #11809
  # Последние адекватные данные.
  function GetLastOKMDH(){
    
    $Y = $this->Year  == 0 ? 1 : $this->Year  ;
    $M = $this->Month == 0 ? 1 : $this->Month ;
    $D = $this->Day   == 0 ? 1 : $this->Day   ;
    $H = $this->Hour  == 0 ? 1 : $this->Hour  ;
    
    $Filter = array(
      'Filter' => array(
        'Meter'     => $this->Meter->Id,
        'Parameter' => $this->Parameter->Id,
        'Loginfo'   => loginfo::ByIdent('OK')->Id,
        'Hour >'    => 0,
        'Day >'     => 0,
        'Month >'   => 0,
        'Year >'    => 0
      ),
      'Order' => array(
        'AddTime' => 'DESC',
        'Year'    => 'ASC',
        'Month'   => 'ASC',
        'Day'     => 'ASC',
      ),
      'AddWhere' =>
        " AND DATE( CONCAT(`year`,'-',`month`,'-',`day`,' ',`hour`)) <= '{$Y}-{$M}-{$D} {$H}) ",
    );
    if( meterdatahour::Filter($Filter)->Count ){
      return meterdatahour::Filter($Filter)->First;
    }else{
      return meterdatahour::Id(0);
    }
  }
  
  
  
  

  /**
   * Преобразование значение по его параметру
   * 
   * @param parameter $oParameter
   * @param int $value
   * @return int
   */
  static function GetValueConvByParameter( parameter $oParameter , $value ){
    $Divider = $oParameter->Conversion->Divider 
                  ? $oParameter->Conversion->Divider
                  : 1;
                  
    $Value = $value / $Divider;
                  
    return round( $Value , $oParameter->Conversion->Round );
  }
  
  
  
  /*
    Ссылка на страницу с архивом в приборе учета
    @return String
  */
  function GetLink(){
    return "{$this->Meter->Link}archive/{$this->Year}/{$this->Month}/{$this->Day}/";
  }
  
  
  
  function GetValueUsingCoef(){
    return $this->Value * $this->Meter->Coef;
  }
  
  
  /*
    Выводит информация в аттрибуте title
    @return String
  */
  function GetTitle(){
    return "{$this->AddTime} #{$this->Id}";
  }
  

  /*
    Является ли это последним данным на приборе учета
  */
  public $IS_LAST = false;

  /*
    Деструктор объект
    @return bool
  */
  function GetDestructor(){
    return $this->__destruct();
  }
  
  
  
  /*
    для совместимости со старой версией
    см. GetDestructor
  */
  function GetDes(){
    return $this->Desctruct;
  }
  
  
  
  /*
    Получение из остаточных данных дня
    @return Int
  */
  function GetMDH_Day() {
    if( isset(
      $this->_OtherData['mdh_day_id'], 
      $this->_OtherData['mdh_day_count']
      ) and ( 1 == $this->_OtherData['mdh_day_count'] )
    ) {
      return $this->_OtherData['mdh_day_id'];
    }
    return 0;
  }
  
  
  /*
    Получение из остаточных данных месяца
    @return Int
  */
  function GetMDH_Month() {
    if( isset(
      $this->_OtherData['mdh_month_id'], 
      $this->_OtherData['mdh_month_count']
      ) and ( 1 == $this->_OtherData['mdh_month_count'] )
    ) {
      return $this->_OtherData['mdh_month_id'];
    }
    return 0;
  }
  
  
  
  
  /*
    Получение уникального улюча по паре прибор-параметр
    @return string
  */
  function GetTdId(){
    if( $this->Is ){
      return "meter_{$this->Meter->Id}_parameter_{$this->Parameter->Id}";
    }
    return "";
  }
  
  
  /*
    Проверка по GET параметрам сегодня это было созданно данное или нет
    @return Bool 
  */
  function GetIsNotToday(){
    $Ident = $this->Meter->Timezone->Ident;
    if( !$this->Meter->Timezone->Is ){
      $Ident = "UTC";
    }
    $Date = new DateTime("now" , new DateTimeZone( $Ident ));
    $Date->setDate(
      $this->Year,
      $this->Month,
      $this->Day
    );
    $Date->setTime(
      $this->Hour , 0 , 0
    );
    return $Date->format("Ymd") != $this->Meter->Date->format("Ymd");
  }
  
  
  
  /*
    Создание объекта из массива данных
    @return meterdatahour
  */
  static function SetFieldsFromObject( $aValues = array() ){
	  $t = meterdatahour::Id(0);
    if( empty($aValues) ) return meterdatahour::Id(0);
	  $t = $t->Init($t,$aValues);
	  return $t;
	}
  
  
  /*
    Преобразование полей Year Month Day Hour в timestamp
    @return String
  */
  function GetDateToTs(){
    $Date = new DateTime("{$this->Year}-{$this->Month}-{$this->Day} {$this->Hour}:00:00");
    return $Date->getTimestamp();
  }
  
  
  
  
  /*
    преобразование в обхект DateTime
    @return Datetime
  */
  function GetDateTimeFormat(){
    $Date = clone $this->Meter->Date;
    $Date->setDate( $this->Year , $this->Month , $this->Day );
    $Date->setTime( $this->Hour , 0 , 0 );
    return $Date;
  }



  /*
    Принудительный деструктор
  */
  function GetDesctruct(){
    unset( self::$_O[$this->Id] );
    $this->__destruct();
    return false;
  }



  
  /*
    Проверка есть ли задания на месте значения
    @return Bool
  */
  function GetIsTask(){
    
    $Month  = $this->Month  < 10 ? "0" . $this->Month : $this->Month;
    $Day    = $this->Day    < 10 ? "0" . $this->Day   : $this->Day  ;
    $Hour   = $this->Hour   < 10 ? "0" . $this->Hour  : $this->Hour ;
    
    $key = "{$this->Year}_{$Month}_{$Day}_{$Hour}";
    
    return isset( $this->Meter->CacheTasks[ $this->Parameter->Id ][ $key ] );
    
  }
  
  


}
