<?php
/*
Имя класса metertype
Имя файла metertype.class.php ( metertypecustom.class.php )
Поля класса:
Id : id
Title : string
DllId : string
Interprise : object
*/
class metertype extends metertypecustom{
  
  
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  static public function Filter($aParams = null , $etc = array()){
    $t=new metertype();
    $aParams['Filter']['Interprise'] = 0;
    return TObject2::Filter($t,$aParams);
  }



  function GetIsImpuls(){
    return substr_count($this->DllId, "COUNTER");
  }
  
  
  
  static public function All( $c=-1 )
  {
    if( !isset( 
      metertype::$_R['All']
    )){
      $Filter = array( 
        'Filter' => array( 
          'Interprise' => 0
        ),
        'Order'=>Array('Title'=>'ASC')
      );
      metertype::$_R['All'] 
      = TObject2::Filter( new metertype(), $Filter);
    }
    return metertype::$_R['All'];
  }
  
  
  
  
  function GetHelper(){
    $Filter = array( 
      'Filter' => array( 
        'Metertype' => $this->Id
    ));
    if( meterhelper::Filter( $Filter )->Count ){
      return meterhelper::Filter( $Filter )->First;
    }
    return meterhelper::Id(0);
  }
  
  
  
  
  public $FieldsToJSON = array(
    'Id'                => 'id',
    'Title'             => 'title',
    'DllId'             => 'dllid',
  );  
  
  
  public $NeedDoUserLog = true;
  
  
  
  /**
   * Поиск типа конвертора по его идентификатору
   * @param string $ident
   * @return metertype
   */
  static function FindByIdent( $ident = "" ){
    $Filter = array( 
      'Filter' => array( 
        'DllId' => $ident
      )
    );
    $FilterType = metertype::Filter( $Filter );
    if( $FilterType->Count ){
      return $FilterType->First;
    }
    return metertype::Id(0);
  }
  
  
  
  
  /*
    Проверка является ли тип виртуального прибора учета
    @return Boll
  */
  function GetIsVirtual(){
    return $this->DllId == 'VIRTMETER';
  }
  /*
    Проверка является ли тип виртуального прибора учета
    @return Boll
  */
  function GetIsCalc(){
    return $this->DllId == 'CALCMETER';
  }


    /*
    Проверка является ли тип виртуального прибора учета
    @return Boll
  */
  function GetIsLoRa(){
    return strpos( $this->DllId , "LORA_" ) !== false;
  }
  
  
  /*
    Проверка является ли тип фильтра прибора учета
    @return Boll
  */
  function GetIsFilter(){
    return $this->DllId == 'FILTER';
  }
  
  
  
  
  
  /*
    Проверка что тип прибора системный а не пользовательский
    @return Bool
  */
  function GetIsTkonSys(){
    # Проверка такая потому что была путаница с названием. 
    # Убираем все что хоть как то на это похоже и привязано к пользователю 
    if( preg_match( '/^TEKON19/' , $this->DllId ) ){
      return $this->Interprise->Id == 0 ;
    }
    
    // Если Предыдущее не выполнилось и выполнится это - библиотека написана не верно
    if( preg_match( '/^TEKON/' , $this->DllId ) ){
      return false;
    }
    return false;
  }
  
  
  
  
  
  /*
    Получение модели TEKON
    @return Int
  */
  function GetTekonGetNum(){
    if( preg_match( '/^TEKON([0-9]*)$/' , $this->DllId , $match ) ){
      return $match[1];
    }
    return 0;
  }
  
  
  
  
  
  /**
   * Можно ли включать или выключать этот тип прибора
   * 
   * @return boolean
   */
  function GetIsOnOff(){
    $Filter = array( 
      'Filter' => array( 
        'VarName' => 'IsLimitEnergy',
        'Metertype' => $this->Id,
      )
    );
    $res = metertypevariable::Filter( $Filter );
    return $res->Count && $res->First->Data;
    
  }
  
  
  
  
  
  
  
  function GetIsOff(){
    if( $this->IsOnOff ){
      $Filter = array( 
        'Filter' => array( 
          'VarName' => 'IsLimitEnergy',
          'Metertype' => $this->Id,
        )
      );
      $res = metertypevariable::Filter( $Filter );
      
      return false  == (bool) $res->First->Data;
    }
  }



  /*
    Получение предположительной марки по типу прибора
  */
  function GetMark(){
    $Filter = array(
      'Filter' => array(
        'Type' => $this->DllId
      )
    );

    $ResMark = mark::Filter( $Filter );
    if( !$ResMark->Count ){
      # Нету? Создадим заглушку чтобы была хотя бы одна марка и модель. Производитель не будет
      $Mark = mark::AddByArray(
        array(
          'Title' => $this->DllId,
          'ManufacrturerId' => 0
        )
      );
      model::AddByArray(
        array(
          'Title' => $this->DllId,
          'MarkId' => $Mark->Id
        )
      );

      TObject2::CleanAllObjects();
      return $Mark;
    }
    return $ResMark->First;
  }


  function GetModel(){
    $Filter = array(
      'Filter' => array(
        'Type' => $this->Id
      )
    );
    return model::Filter($Filter)->First;
  }


  function GetModelOneLine(){

    if( $this->Id == 0 ){
      return TListGroup::Init();
    }

    $Mark = $this->GetMark();

    $FilterModels = array(
      'Filter' => array(
        'Mark' => $Mark->Id
      )
    );
    return model::Filter( $FilterModels );

  }
  
  function GetTitle(){
    $ident = strtolower($this->_F['DllId']['value']) . "_metertype";
    $ident = Utils::replace_uncorrect_symbol($ident);
    if(smarty()->get_config_vars($ident)){
      return smarty()->get_config_vars($ident);
    }
    return $this->_F['Title']['value'];
  }
  
}
