<?php
/*
Имя класса parameter
Имя файла parameter.class.php ( parametercustom.class.php )
Поля класса:
Id : id
Title : string
Ident : string
Parameterdatatype : object
Tarif : object
Lvl1 : string
Lvl2 : string
Lvl3 : string
Lvl4 : string
Conversion : object
Enterprise : object
*/
class parameter extends parametercustom{
  
  
  
  public $FieldsToJSON = array(
    'Id'                => 'id',
    'Title'             => 'title',
    'Ident'             => 'ident',
    'Lvl1'              => 'lvl1',
    'Lvl2'              => 'lvl2',
    'Lvl3'              => 'lvl3',
    'Lvl4'              => 'lvl4',
    'Conversion'        => 'conversion',
  );  
  
  
  
  public $NeedDoUserLog = true;
  
  
  /*
    Созданеи объекта из заданных параметров
    @return parameter
  */
  static function SetFieldsFromObject( $aValues = array() ){
    $t = new parameter();
    $t = $t->Init($t,$aValues);
    return $t;
  }
  
  
  /*
    Использует ли данный параметр коэффициент
    @return Bool
  */
  function GetUseCoef(){
    return preg_match('/ENERGY/' , $this->Ident);
  }
  
  
  
  function GetUseFirst() {
		return in_array( $this->Ident, array( 'ENERGY_TARIF1','ENERGY_TARIF2','ENERGY_TARIF_SUM') );
	}
  
  
  function GetUseLast() {
		return false;
	}
  
  
  function GetUseSum(){
    return $this->Parameterdatatype->UseSum;
  }
  
  
  
  function GetUseAverage(){
    return $this->Parameterdatatype->Ident == 'AVERAGE';
  }
  
  
  function GetUseMin(){
    return $this->Parameterdatatype->Ident == 'COUNTER';
  }
  
  
  
  function GetUseMax(){
    return $this->Parameterdatatype->Ident == 'VALUE_MAX';
  }
  
  
  
  
  
  
  function GetIsEventLog(){
    return $this->Parameterdatatype->Ident == 'EVENT';
  }
  
  
  
  function GetIsEvent() {
    return preg_match( '/EVENT(.*)/' , $this->Ident);
  }
  
  

  /*
    Если пустое значение то надо всегда что то показывать
    @return String
   */
  function GetLvl3() {
    if (!$this->_F['Lvl3']['ready']) {
      TObject2::_DataLoadSql($this);
    }
    if ($this->_F['Lvl3']['value']) {
      $ident = strtolower($this->_F['Ident']['value']) . "_lvl3";
      if (smarty()->get_config_vars($ident)) {
        return smarty()->get_config_vars($ident);
      }
      return $this->_F['Lvl3']['value'];
    }
    return $this->Ident;
  }

  /*
    Если пустое значение то надо всегда что то показывать
    @return String
  */
  function GetLvl4(){
    if( !$this->_F['Lvl4']['ready'] ){
      TObject2::_DataLoadSql($this);
    }
    if ($this->_F['Lvl4']['value']) {
      $ident = strtolower($this->_F['Ident']['value']) . "_lvl4";
      if (smarty()->get_config_vars($ident)) {
        return smarty()->get_config_vars($ident);
      }
      return $this->_F['Lvl4']['value'];
    }
    return $this->Ident;
  }

  
  
  
  
  /*
    Если нет описания то показывать Идентификатор
    @return String
  */
  function GetTitle(){
    if( !$this->_F['Title']['ready'] ){
      TObject2::_DataLoadSql($this);
    }
    if( $this->_F['Title']['value'] ){
      $ident = strtolower($this->_F['Ident']['value'])."_title";
      if(smarty()->get_config_vars($ident)){
        return smarty()->get_config_vars($ident);
      }
      return $this->_F['Title']['value'];
    }
    return $this->Ident;
  }
  
  
  
  
  
  
  /*
    Преобразование свойства Lvl исходя из номера
    @return String
  */
  function GetLvl( $num = 0 ){
    $prop = "Lvl" . $num;
    return $this->$prop;
  }
  
  
  
  /*
    Обновление параметра
    @param Array
    @return parameter
  */
  public function UpdateByArray($A){
    
    
    if( isset( $A['not_valid_json'] ) ){
      $not_valid_array = $A['not_valid_json'];
      
      $all_keys_exists = true;
      
      foreach( 
        array('position_filter' , 'ident_filter_position' , 'id_filter_position') as
        $key
      ){
        if( $all_keys_exists ){
          $all_keys_exists = isset( $not_valid_array[ $key ] );
        }
      }
      
      if( $all_keys_exists ){
        $class = $not_valid_array['ident_filter_position'];
        $Object = $class::Id($not_valid_array['id_filter_position']);
        $Filter = array( 
          'Filter' => array( 
            'Filterparamname' => $Object->FilterParameterData->Filterparamname->Id,
            'Param' => $this->Id
          )
        );
        if( filterparamis::Filter($Filter)->Count > 1 ){
          foreach( filterparamis::Filter($Filter)->Elements as $i => $iFilter){
            if(!$i){
              $iFilter->Delete();
            }
          }
        }
        filterparamis::Filter($Filter)->First->Number = $not_valid_array['position_filter'];
      }
      
    }
    
    TObject2::StaticUpdateByArray($this,$A);
    
    if( !$this->Ident ){
      $this->Ident = "USER_" . $this->Id;
    }
    
    if( preg_match('/^USER_/',$this->Ident) || !$this->Lvl4 ){
      $this->Lvl4 = $this->Title;
    }
  }
  
  
  
  
  
  
  /*
    Скрывать или нет виртаульный параметр от пользователя
    при выводе списка параметров для его допустим выбора
    @return Bool
  */
  function GetIsHideVirtualList(){
    return preg_match( '/^TEKON19(.*)/' , $this->Ident );
  }
  
  
  
  
  /*
    Является ли параметр пользовательским
    @return Bool
  */
  function GetIsSys(){
    return $this->Enterprise->Id == 0;
  }
  
  
  
  
  static public function AddByArray($A){
    $t = new parameter();
    if(!empty($A['Ident']) && in_array( $A['Ident'], array( 'INFO','SERIAL','DATETIME' ) ) ){
      return false;
    }
    
    if( !empty($A['Ident']) ){
      $Filter = array(
        'Filter' => array(
          'Ident' => $A['Ident']
        )
      );
      if( parameter::Filter($Filter)->Count ){
        return false;
      }
    }
    
    if( !isset($A['EnterpriseId']) ){
      $A['EnterpriseId'] = Self()->Interprise->Id;
    }
    
    TObject2::StaticAddByArray($t,$A);
    
    if( $t->Enterprise->Id ){
      $t->Ident = "USER_" . $t->Id;
      $t->Save();
    }
    
    if( !$t->IsSys || !$t->Lvl4 ){
      $t->Lvl4 = $t->Title;
    }
    
    return $t;
  }
  
  

  static public function AddByRequest(){
    $t = new parameter();
    $_REQUEST['EnterpriseId'] = Self()->Interprise->Id;
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=parameter::Id(0);
    if( !isset($aParams['Filter']['Enterprise']) ){
      $aParams['Filter']['Enterprise'] = array( 0 , Self()->Interprise->Id );
    }
    return TObject2::Filter($t,$aParams);
  }
  
  
  
  static public function All( $c=-1 )
  {
    if( !isset( 
      parameter::$_R['All']
    )){
      $Filter = array( 
        'Filter' => array( 
          'Enterprise' => Self()->Interprise->Id
        )
      );
      parameter::$_R['All'] 
      = TObject2::Filter( new parameter() , $Filter);
    }
    return parameter::$_R['All'];
  }
  
  
  
  
  
  function Delete() {
	  $Filter = array(
	    'Filter' => array(
	      'Parameter' => $this->Id
	    )
	  );
	  meterparameter::Filter($Filter)->DeleteAll();
	  $Filter = array(
	    'Filter' => array(
	      'Virtualparameter' => $this->Id
	    )
	  );
	  meterparameter::Filter($Filter)->DeleteAll();
	  
	  $Filter = array(
	    'Filter' => array(
	      'Parameter' => $this->Id
	    )
	  );
	  metertypeparameter::Filter($Filter)->DeleteAll();
	  
	  $Filter = array(
	    'Filter' => array(
	      'Param' => $this->Id
	    )
	  );
	  filterparamis::Filter($Filter)->DeleteAll();
	  
	  $Filter = array(
	    'Filter' => array(
	      'Parameter' => $this->Id
	    )
	  );
	  graphics::Filter($Filter)->DeleteAll();
	  
    TObject2::StaticDelete($this);
  }
  
  
  
  
  
  
  /**
   * Получение списка параметров по их идентификаторам
   * 
   * @param array $parameter_idents
   * @return parameter
   */
  static function GetByIdents( $parameter_idents ){
    $Filter = array( 
      'Filter' => array( 
        'Ident' => $parameter_idents,
        'Enterprise' => 0
      ),
      'GroupBy' => array('Ident')
    );
    
    return parameter::Filter( $Filter );
  }
  
  
  
  

}