<?php
/*
Имя класса rule
Имя файла rule.class.php ( rulecustom.class.php )
Поля класса:
Id : id
Name : string
Interprise : object
*/
class rule extends rulecustom{
  
  
  
  public $FieldsToJSON = array(
    'Id'                => 'id',
    'Name'              => 'name'
  ); 
  
  
  
  public $NeedDoUserLog = true;
  
  
  
  
  static public function All( $c=-1 )
  {
    if( !isset( 
      rule::$_R['All']
    )){
      $Filter = array( 
        'Filter' => array( 
          'Interprise' => array( 0 , Self()->Interprise->Id )
        )
      );
      rule::$_R['All'] 
      = TObject2::Filter( new rule() , $Filter);
    }
    return rule::$_R['All'];
  }
  
  
  static public function Filter($aParams = null , $etc = array()){
    $t=new rule();
    $aParams['Filter']['Interprise'] = Self()->Interprise->Id;
    return TObject2::Filter($t,$aParams);
  }
  
  
  static public function AddByArray($A){
    $t = new rule();
    $A['InterperiseId'] = Self()->Interprise->Id;
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new rule();
    $_REQUEST['InterperiseId'] = Self()->Interprise->Id;
    TObject2::StaticAddByRequest($t);
    return $t;
  }
  


  /*
    Название роли
    @return String
  */
  function GetTitle(){
    return $this->Name;
  }
  
  
  

  /*
    Ссылка на роль
    @return String
  */
  function GetLink(){
    return "/rule/{$this->Id}/";
  }
  
  
  
  /*
    Ссылка на удаление роли
    @return String
  */
  function GetLinkDel(){
    return "{$this->Link}delete/";
  }
  
  
  
  /*
    Ссылка на редактирование роли
    @return String
  */
  function GetLinkEdit(){
    return "{$this->Link}edit/";
  }
  
  
  
  /*
    Ссылка на добавление полькаователя к роли
    @return String
  */
  function GetLinkAddUser(){
    return $this->LinkEditUser;
  }
  
  
  
  /*
    Ссылка на добавление группы к роли
    @return String
  */
  function GetLinkAddGroup(){
    return $this->LinkEditGroup;
  }
  
  
  
  /*
    TODO
    Ссылка на редактирование группы к роли
    @return String
  */
  function GetLinkEditGroup(){
    return "{$this->Link}editgroup/";
  }
  
  
  
  /*
    TODO
    Ссылка на редактирование пользователей к роли
    @return String
  */
  function GetLinkEditUser(){
    return "{$this->Link}edituser/";
  }
  
  
  
  
  
  
  
  
  /*
    Кол-во пользователей с этой ролью
    @return TListGroup 
  */
  function GetUsers(){
    $SQL = Utils::Strip("
      SELECT link.* 
      FROM link 
      LEFT JOIN user
        ON user.id = link.user_id
      WHERE user.type = 0
        AND link.rule_id = {$this->Id}
      GROUP BY link.rule_id
    ");
    $t = link::Id(0);
    return TListGroup::Prepare( $SQL , $t );
  }
  
  
  /*
    Получение кол-ва групп которым назначена эта роль
    @return TListGroup
  */
  function GetGroup(){
    $SQL = Utils::Strip("
      SELECT link.* 
      FROM link 
      LEFT JOIN user
        ON user.id = link.user_id
      WHERE user.type = 1
        AND link.rule_id = {$this->Id}
      GROUP BY link.rule_id
    ");
    $t = Link::Id(0);
    return TListGroup::Prepare( $SQL , $t );
  }
  
  
  
  
  
  
  
  
  /*
    Кеширование данных на роль
    Формат  
      [ <Name>_<Action> ] => (0|1|2)
  */
  protected $CacheActionInRule = null;
  
  
  /*
    Наполнение кеша заполненности роли (CacheActionInRule)
    @return Bool
  */
  function SetCacheActionInRule(){
    $SQL = Utils::Strip("
      SELECT 
        CONCAT(a.name,'_',a.action) as f ,IF(p.count_in_rule >= a.count_all , 1 , 
          IF(p.count_in_rule < a.count_all AND p.count_in_rule > 0 , 2 , 0 )
        ) as result 
      FROM (SELECT 
        action.id ,count(*) as count_in_rule
      FROM action 
      left join patern on action.id = patern.action_id 
      where patern.rule_id = {$this->Id} 
      group by action.name,action.action
      ) as p LEFT JOIN (
      SELECT 
        action.id ,action.name,action.action,count(*)  as count_all
      FROM action 
      group by action.name,action.action
      ) as a on p.id = a.id
    ");
    
    $res = DB::Select( $SQL );
    while( $Row = DB::Fetch( $res ) ){
      $this->CacheActionInRule[ $Row['f'] ] = $Row['result'];
    }
    return true;
  }
  
  
  /*
    проверка какие полномочия  уроли
    0 - ничего нельзя
    1 - можно все
    2 - частично
    @return Int
  */
  function GetIsAction( $ActionObject , $ActionAction ){
    
    if( $this->CacheActionInRule === null ){
      $this->SetCacheActionInRule();
    }
    
    $Ident = $ActionObject->Name . "_" . $ActionAction->Action;
    
    if( isset( $this->CacheActionInRule[ $Ident ] ) ){
      return $this->CacheActionInRule[ $Ident ];
    }
    return 0;
    
  }
  
  
  
  

}
