<?php
/*
Имя класса user
Имя файла user.class.php ( usercustom.class.php )
Дата генерации:  28.07.2010
Время генерации: 22.27.02
Поля класса:
Id : id
Fio : string
Login : string
Pass : string
Pass_store : int
Salt : string
EMail : string
Active : bool
Lang : string
*/
class user extends usercustom{
  
  
  
  static $SelfId = null;
  
  
  
  public $FieldsToJSON = array(
    'Id'                => 'id',
    'Login'             => 'login',
    'Fio'               => 'fio',
    'EMail'             => 'email',
    'Active'            => 'active',
    'Type'              => 'type',
    'Timezoneid'        => 'timezone',
  );
  
  
  public $NeedDoUserLog = true;
  
  
  function GetLimitIsExceeded(){
    if( !$this->Interprise->Limitmeters ){
      return false;
    }
    $metertypes = array();

    $SQL = Utils::Strip('select meter.* from meter
    left join converter on meter.converter_id = converter.id
    left join converter_type on converter_type.id = converter.type_id
    where converter_type.dll_id not like "%VIRT%"
    and meter.converter_id > 0
    and converter_type.dll_id not like "%VIRT%"');

    $count = TListGroup::Prepare($SQL , meter::Id(0));

    return $count->Count >= $this->Interprise->Limitmeters;
  }


  
  
  /**
   * Проверяем есть ли другие пользователи кроме гостя
   * 
   * @return boolean
   */
  static function EmptyUsers(){
    $Filter = array(
        'Filter' => array(
            'Id !=' => Site()->GetGuest()->Id
        )
    );
    return !user::Filter( $Filter )->Count;
  }
  
  
  public function UpdateByRequest(){
    if( empty($_REQUEST['Pass'] ) || empty($_REQUEST['Pass2'] )  ){
      unset($_REQUEST['Pass'] );
    }
    if( isset( $_REQUEST['Type'] ) ){
      unset( $_REQUEST['Type'] );
    }
    TObject2::StaticUpdateByRequest($this);
  }




  public function UpdateByArray($A){
    TObject2::StaticUpdateByArray($this,$A);
    if( isset( $A['not_valid_json']['rule_place'] ) ){
      $this->UpdateRulePlace( explode(",",$A['not_valid_json']['rule_place']) );
    }
  }  



  /**
   * Редактирование прав на просмотр мест
   * @param array Список идентификаторов куда возможен доступ
   * @return bool Результат выполнения
   * */
  function UpdateRulePlace( $places_id ){
    // Сначала удалим все так это самый простой способ.
    // Затем все пересоздадим
    $Filter = array(
      'Filter' => array(
        'User' => $this->Id
      )
    );
    ruleplace::Filter( $Filter )->DeleteAll();

    foreach( $places_id as $place_id ){
      if( !$place_id ){
        continue;
      }
      ruleplace::AddByArray(array(
        'PlaceId' => $place_id,
        'UserId' => $this->Id
      ));
    }
    return true;
  }






  /**
   * Получение мест, которые может видеть пользователь
   * @return array
   * */
  function GetRulePlacesArray(){
    $res = array();

    $Filter = array(
      'Filter' => array(
        'User' => $this->Id
      )
    );
    foreach(ruleplace::Filter( $Filter )->Elements as $RulePlace){
      $res[] = (int) $RulePlace->Place->Id;
    }
    return $res;
  }



  /**
   * Получение идентификаторов конвертеров по правам
   * @return array
   * 
   * */
  function GetConvertersByRulePlaceIds(){

    $places = $this->GetRulePlacesArray();
    $res = array();
    if( count( $places ) ){
      foreach( $places as $iplace ){

        $iPlace = place::Id($iplace);

        $SQL = Utils::Strip("select converter.* from converter
        left join meter on meter.converter_id = converter.id
        left join meterplace on meterplace.meter_id = meter.id
        left join place on place.id = meterplace.place_id
        where place.lft >= {$iPlace->Lft} and rgt <= {$iPlace->Rgt}");
        $t = converter::Id(0);
        foreach( TListGroup::Prepare( $SQL , $t )->Elements as $Convertrer ){
          $res[$Convertrer->Id] = $Convertrer->Id;
        }
      }
    }else{
      foreach(converter::All()->Elements as $iConverter){
        $res[$iConverter->Id] = $iConverter->Id;
      }
    }
    return $res;
  }

  
  
  
  /*
    Замаскировался ли пользователь?
    @return Bool
  */
  function GetIsMask(){
    return Site()->Config('root.mask') != "";
  }
  
  
  
  
  /*
    Если да то под кем
    @return user
  */
  function GetMaskUser(){
    $GLOBALS['FullRules'] = true;
    return user::Id(Site()->Config('root.mask'));
  }
  
  
  
  
  
  static public function Filter($aParams = null , $etc = array()){
    $t=new user();
    if( !Self()->FullRules && !isset($aParams['Filter']['Interprise']) ){
      $aParams['Filter']['Interprise'] = Self()->Interprise->Id;
    }
    return TObject2::Filter($t,$aParams);
  }
  
  
  /**
   * Получение пользователя игнорируя предпрятие
   * 
   * @param array $aParams
   * @return user
   */
  static function FilterIgnoreInterprise(&$aParams){
    $t=new user();
    return TObject2::Filter($t,$aParams);
  }


  
  
  const TesterAccessId = 2;
  protected $Rule = array();
  public $_Rules = false;
  protected $_Action = false;
  protected $_Objects = array();
  static public $SqlDelete = 'User';
  public $Allrules = array();
  public $reason = array();
  public $reasonD = false;
  
  
  
  
  
  static public function &AddByArray($A){
    if(!isset($A['InterpriseId'])){
      $A['InterpriseId'] = Self()->Interprise->Id;
    }
    $t = new user();
    $A['Pass'] = user::GenPass(
      isset( $A['Pass'] )
      ? $A['Pass']
      : ""
    );
    if( isset( $A['not_valid_json']['pass'] ) ){
      $A['Pass'] = user::GenPass( $A['not_valid_json']['pass'] );
    }
    var_dump($A['Pass'] );
    TObject2::StaticAddByArray($t,$A);
    if( isset( $A['not_valid_json']['rule_place'] ) ){
      $t->UpdateRulePlace( explode(",",$A['not_valid_json']['rule_place']) );
    }
    return $t;
  }
  
  
  

  static public function &AddByRequest(){
    if(!isset($_REQUEST['InterpriseId'])){
      $_REQUEST['InterpriseId'] = Self()->Interprise->Id;
    }
    $t = new user();
    $_REQUEST['Pass'] = user::GenPass(
      isset($_REQUEST['Pass'])
      ? $_REQUEST['Pass']
      : "");
    TObject2::StaticAddByRequest($t);
    return $t;
  }
  
  
  
  


  /*
    Возвращаем id авторизованного пользователя
    @return int
  */
  function GetSelfId(){
    return $this->Id;
  }
  
  
  
  /*
    Указанный пользователь - ВЫ
    @return Bollean
  */
  function GetIsMy(){
    return $this->Id == Self()->Id;
  }
  
  
  
  
  /*
    Ссылка на удаление
    @return String
  */
  function GetLinkDel(){
    return "{$this->Link}delete/";
  }
  
  /*
    Ссылка на редактирование
    @return String
  */
  function GetLinkEdit(){
    return "{$this->Link}edit/";
  }
  
  
  
  
  
  /*
    Ссылка на добавление пользователей к группе
    @return String
  */
  function GetLinkAddUser(){
    return "{$this->Link}adduser/";
  }
  
  
  
  
  /*
    Ссылка на удаление пользователя из группы
    @return String
  */
  function GetLinkDelUser(){
    return "{$this->Link}deluser/";
  }
  
  
  /*
    Ссылка на редактирование ролей у пользователя1
    @return String
  */
  function GetLinkEditRule(){
    return "{$this->Link}rules/";
  }
  
  
  
  
  
  
  /*
    Роли к которым привязан пользователь
    @return TListGroup
  */
  function GetEnabledRule(){
    $SQL = Utils::Strip("
      select rule.* 
      from link 
      left join rule 
        on link.rule_id = rule.id 
      where 
        link.user_id = {$this->Id} and
        rule.interprise = " . Self()->Interprise->Id . "
      group by 
        rule.id
    ");
    
    $t = rule::Id(0);
    return TListGroup::Prepare( $SQL , $t );
  }
  
  
  
  /*
    Роли к которым НЕ привязан пользователь
    @return TListGroup
  */
  function GetDisabledRule(){
    $SQL = Utils::Strip("
      select * 
      from link 
      right join rule on link.rule_id = rule.id and link.user_id = {$this->Id} 
      where rule.id = " . Self()->Interprise->Id . "
    ");
    
    $t = rule::Id(0);
    return TListGroup::Prepare( $SQL , $t );
  }
  
  
  
  /*
    ССылка на пользователя
    @return String
  */
  function GetLink(){
    return "/user/{$this->Id}/";
  }
  
  
  /*
    ССылка на лог пользователя
    @return String
  */
  function GetLinkLog(){
    return "{$this->Link}log/";
  }





  /*
    Ссылка на добавление пользователя в эту группу
    @param user
    @return String
  */
  function LinkAddToGroup( $oGroup ){
    return "{$oGroup->LinkAddUser}{$this->Id}/";
  }




  /*
    Все уникальные роли пользователя
    @return TListGroup
  */
  function GetRule(){
    $Filter = array( 
      'Filter' => array( 
        'User' => $this->Id,
      ),
      'GroupBy' => array(
        'Rule'
      )
    );
    return link::Filter( $Filter );
  }
    
    
  
  
  /*
    Страницы лога
    @return Array
  */
  function GetLogPages(){
    return Utils::Paginator(
      $this->Log->Count,
      Site()->CountInPage
    );
  }
  
  /*
    Весь лог событий
    @return TListGroup
  */
  function GetLog(){
    $Filter = array(
      'Filter' => array(
        'User' => $this->Id,
      ),
      'Order' => array(
        'Its' => 'DESC'
      )
    );
    return userlog::Filter( $Filter );
  }
  
  /*
    Все события по конвертору
    @return TListGroup
  */
  function GetLogList(){
    $F = $this->Log->GroupBy( Site()->CountInPage )->Elements;
    if( isset( $F[ Site()->Page ] ) ){
     return  $F[ Site()->Page ];
    }
    return TListGroup::Init();
  }




  /*
    Все уникальные группы пользователя
    @return TListGroup
  */
  function GetGroup(){
    $Filter = array( 
      'Filter' => array( 
        'User' => $this->Id,
        'User >' => 0,
        'Group >' => 0
      ),
    );
    return groupusers::Filter( $Filter );
  }
  
  
  
  
  /*
    Получение всех пользователей которые не вхоядт в эту группу
    @return TlistGroup
  */
  function GetNotUsers(){
    $SQL = Utils::Strip("
      select user.* 
      from user 
      left join groupusers 
        on groupusers.id_user = user.id 
      where user.interprise = " . Self()->Interprise->Id . " 
        and groupusers.id IS NULL 
        and type = 0
    ");
    $t = user::Id(0);
    return TListGroup::Prepare( $SQL , $t );
  }
  
  
  
  /*
    Ясная лдя пользователя надпись активности пользователя
    @return String
  */
  function GetIsActiveTitle(){
    return $this->Active ? "Да" : "Нет";
  }
  
  
  
  
  
  
  /*
    Часовой пояс пользователя
    Вынесено вне объекта чтобы можно было работать на стадии формирования
    При формировании узнаем на каком уровне задано время

    0 - Никак
    1 - Самим пользователем
    2 - Его предприятием
    3 - Сервером
    
    return timezone
  */
  function GetTimezone(){
    //~ # Если задано свое
    if( $this->Timezoneid->Is ){
      return $this->Timezoneid;
    }
    # Если задано предприятием
    $Timezone = $this->Interprise->Timezone;
    if( !$Timezone->Is ){
      
      $dateTimeZoneTaipei = new DateTimeZone("UTC");
      $dateTimeZoneJapan = new DateTimeZone( ini_get('date.timezone') );

      // Создание двух объектов DateTime которые будут содержать одинаковые метки времени Unix, но
      // имеющие различные временные зоны.
      $dateTimeTaipei = new DateTime("now", $dateTimeZoneTaipei);
      $dateTimeJapan = new DateTime("now", $dateTimeZoneJapan);
      
      $Filter = array( 
        'Filter' => array( 
          'Diff' => $dateTimeZoneJapan->getOffset($dateTimeTaipei)
        )
      );
      
      $Times = timezone::Filter( $Filter );
      if( $Times->Count ){
        return $Times->First;
      }
      return timezone::Id( 0 );
    }
    return $Timezone;
  }
  
  
  
  
  
  /*
  
    
    0 - Обычный пользователь
    1 - Группа
    100 - Гость
    101 - Рут
    102 - Администратор
  
  
  */  
  
  
  /*
    Является ли пользователь администратором
    @return Bool
  */
  function GetIsAdmin(){
    return ( $this->Type == 102 && $this->Id ) or $this->IsRoot;
  }
  
  
  
  
  
  
  
  
  
  
  /*
    Обычный пользователь?
    @return Bool
  */
  function GetIsUser(){
    return $this->Type == 0 && $this->Id;
  }
  
  
  /*
    Обычная группа?
    @return Bool
  */
  function GetIsGroup(){
    return $this->Type == 1;
  }
  
  
  /*
    Гость?
    @return Bool
  */
  function GetIsGuest(){
    return $this->Type == 100 || !$this->Id;
  }
  
  
  /*
    Root?
    @return Bool
  */
  function GetIsRoot(){
    return $this->Type == 101;
  }
  
  
  
  
  /*
    Ясная лдя пользователя надпись типа пользователя
    @return String
  */
  function GetTypeTitle(){
    switch( $this->Type ){
      case 1    : return 'Группа';
      case 100  : return 'Гость';
      case 101  : return 'Root';
      default   : return 'Пользователь';
    }
  }
  
  
  
  
  /*
    Удобное название для группы или пользователя
    @return String
  */
  function GetTitle(){
    return $this->Fio == '' ? $this->Login : $this->Fio;
  }
  
  
  
  
  static function GenPass( $pass , $salt = '' ){
    return md5(md5($pass).$salt);
  }
  
  
  
  
  
  
  
  
  
  





  // еременная для всех переменных времени
  public $ArrayTimes = array();

  /*
    id текущего фильтра place or meter
  */
  public $ThisFilter = 0;
  public $ReturnAllRules = false;

  function GetReason()
  {
    $Str = '';
    foreach($this->reason as $iReason) {
      $Str .= "<!--$iReason--> \n";
    }
    return $Str;
  }

  # Были ли запрошены уже action
  private $IsQueryAction = false;

  function SetIssetAction()
  {
    if( $this->IsQueryAction ) return 0;
    $Filter = array(
      'Filter' => array(
        'Id >' => 0
      )
    );
    $Rez = DB::Select( action::Filter($Filter)->Sql );
    $this->IsQueryAction = true;
    while( $ROW = DB::Fetch($Rez) ) {
      $this->_Action[strtolower($ROW['name'])][strtolower($ROW['action'])][strtolower($ROW['property'])] = true;
    }
  }

  function IssetAction( $Object = '' , $action = '' , $property = "" )
  {
    if(!$this->_Action) {
      $this->SetIssetAction();
    }

    return isset($this->_Action[$Object][$action][$property]);
  }

  function IssetObject( $Object = '' )
  {
    if(!$this->_Action) {
      $this->SetIssetAction();
    }
    return isset($this->_Action[$Object]);
  }

  protected $bedugRules = false;

  function ReturnIdElem( $object = ""){
    $this->CreateRule();
    if( !isset( $this->_Rules[$object] ) ) return false;
    $Id = array();
    foreach( $this->_Rules[$object] as $key => $arrays){
      foreach($arrays as $k=>$v){
        foreach($v as $_v){
          $Id[$_v] = $_v;
        }
      }
    }
    return $Id;
  }

  function IsIssetRule( $name_object = '' , $action_object = '' ){

    $action = '';
    if( $this->FullRules ) {
        return 1;
      }
    # Если имеются все права

      $name_object = strtolower($name_object);
      $action_object = strtolower($action_object);

    if( !$this->IssetObject($name_object) ) {
      return 1;
    }
    $this->CreateRule();
    $action_object = strtolower($action_object);
    $name_object = strtolower($name_object);
    $property = '';
    if( preg_match( '/(view|edit|delete|add)(.*)/' , $action_object , $_action) ){
      if( isset( $_action[2] ) ){
        $action   = $_action[1];
        $property = $_action[2];
      }
      $action = $_action[1];
    }

    if( !$this->IssetAction( $name_object , $action , $property ) ){
      return 2;
    }

    if( isset($this->_Rules[strtolower($name_object)][strtolower($action)]) ){
      if( array_keys($this->_Rules[strtolower($name_object)][strtolower($action)]) == array("") ) return true;
    }
    return isset($this->_Rules[strtolower($name_object)][strtolower($action)][strtolower($property)]);
  }

  function CreateRule(){
    if( $this->_Rules === false ){

      $Interprise = Self()->IsGuest ? 0 : Self()->_F['Interprise']['value'] ;

      if(Self()->_F['Interprise']['value'] === null){
        $Interprise = 0;
      }

      $IdUser = array(Self()->Id => Self()->Id);
      $SQL_Group = preg_replace( '/[\r\n\t]+/', ' ', "
        SELECT user.id
        FROM groupusers
        LEFT JOIN user ON user.id = groupusers.id_group
        WHERE groupusers.id_user = " . Self()->Id . "
        AND user.interprise = " . $Interprise . "
      ");
      $Rez = DB::Select( $SQL_Group );
      while( $Row = DB::Fetch($Rez) ) {
        $IdUser[$Row['id']] = $Row['id'];
      }

      $this->_Rules = array();

    # Глобальные права "на все"
      $SQL_GLOBAL = preg_replace( '/[\r\n\t]+/', ' ', "
        SELECT link.whyid, LOWER(action.name) as name, LOWER(action.action) as action , LOWER(action.property) as property
        FROM link
        LEFT JOIN objectrule ON objectrule.id = link.objectrule_id
        LEFT JOIN patern ON patern.rule_id = link.rule_id
        LEFT JOIN action ON patern.action_id = action.id
        WHERE link.user_id IN ( " . implode( ',' , $IdUser ) . " )
        AND objectrule.ident = LOWER(action.name)
        AND link.interprise_id = " . $Interprise . "
        AND link.whyid = 0
        GROUP BY link.whyid, action.name, action.action, action.property
      ");
      $Rez = DB::Select( $SQL_GLOBAL );
      while( $Row = DB::Fetch($Rez) ) {
        $Object   = $Row['name'];
        $Action   = $Row['action'];
        $Property = $Row['property'];
        $Id       = $Row['whyid'];
        if( $Object != "" or $Id == 0 ) $this->_Rules[ $Object ][ $Action ][ $Property ][ $Id ] = $Id ;
      }

      Site()->Objectrule('Meter');

      $SQL_GLOBAL = preg_replace( '/[\r\n\t]+/', ' ', "
        SELECT link.whyid, LOWER(action.name) as name, LOWER(action.action) as action , LOWER(action.property) as property
        FROM link
        LEFT JOIN patern ON patern.rule_id = link.rule_id
        LEFT JOIN action ON patern.action_id = action.id
        WHERE link.user_id IN ( " . implode( ',' , $IdUser ) . " )
        AND link.interprise_id = " . $Interprise . "
        AND link.whyid = 0
        AND link.objectrule_id = 0
        GROUP BY link.whyid, action.name, action.action, action.property
      ");
      $Rez = DB::Select( $SQL_GLOBAL );
      while( $Row = DB::Fetch($Rez) ) {
        $Object   = $Row['name'];
        $Action   = $Row['action'];
        $Property = $Row['property'];
        $Id       = $Row['whyid'];
        if( $Object != "" or $Id == 0 ) $this->_Rules[ $Object ][ $Action ][ $Property ][ $Id ] = $Id ;
      }

    # Локальные права "на определенный предмет"
      $SQL_LOCAL = preg_replace( '/[\r\n\t]+/', ' ', "
        SELECT link.whyid, LOWER(action.name) as name, LOWER(action.action) as action , LOWER(action.property) as property
        FROM link
        LEFT JOIN patern ON patern.rule_id = link.rule_id
        LEFT JOIN action ON patern.action_id = action.id
        LEFT JOIN objectrule ON objectrule.id = link.objectrule_id
        WHERE action.name = objectrule.ident
        AND link.user_id IN ( " . implode( ',' , $IdUser ) . " )
        AND link.interprise_id = " . $Interprise . "
        GROUP BY link.whyid, action.name, action.action, action.property
      ");
      $Rez = DB::Select( $SQL_LOCAL );
      while( $Row = DB::Fetch($Rez) ) {
        $Object   = $Row['name'];
        $Action   = $Row['action'];
        $Property = $Row['property'];
        $Id       = $Row['whyid'];
        if( $Object != "" ) $this->_Rules[ $Object ][ $Action ][ $Property ][ $Id ] = $Id ;
      }

    }

    # Должен себя видеть как минимум
      $this->_Rules['user']['view'][''][Self()->Id] = Self()->Id;
      $this->_Rules['user']['edit'][''][Self()->Id] = Self()->Id;

      foreach( user::$FInit as $human_key => $attrs ){
        $this->_Rules['user']['view'][strtolower($human_key)][Self()->Id] = Self()->Id;
        $this->_Rules['user']['edit'][strtolower($human_key)][Self()->Id] = Self()->Id;
      }
  }


  # провеет наличие такого права для объекта
  # В аргументах должны приходить не объекты
  # иначе мы рискуем зациклиться
  function Rules( $name_object = null , $id_object = null , $action_object = null ) {
    if(is_object($name_object)) $name_object = get_class($name_object);
    $name_object = strtolower($name_object);
    $action_object = strtolower($action_object);

    if( !$this->IssetObject( $name_object ) ){
      return 6;
    }

    # Если имеются все права
      if( $this->FullRules ) {
        return 1;
      }

      $property = "";

    # Проверяем входящие данные
    # Видимо не верно спросили
      if( $name_object === null ){
        return 2;
      }

      if( $id_object === null ){
        return 3;
      }

      if( $action_object === null ){
        return 4;
      }

      $name_object    = strtolower($name_object);
      $action_object  = strtolower($action_object);

      if( preg_match( '/(view|edit|delete|add)(.*)/' , $action_object , $_action) ){
        if( isset( $_action[2] ) ){
          $action   = $_action[1];
          $property = $_action[2];
        }
        $action_object = $_action[1];
      }

    # Если запрашивают нулевой объект то надо его вернуть в любом случае
      if( $id_object == 0 ){
        return 5;
      }

    # Если у нас запросили неизвестный объект
      if( !$this->IssetObject( $name_object ) ){
        return 6;
      }

    # Если у нас запросили неизвестное свойство
      if( !$this->IssetAction( $name_object , $action_object , $property ) ){
        return 7;
      }


    # Проверяем на наличие всех таблиц.
    # Если их нет то создаются
    action::Id(1)->Is;
    patern::Id(1)->Is;
    link::Id(1)->Is;
    objectrule::Id(1)->Is;

    # Проверяем на заполнение нашего  массива прав.
      $this->CreateRule();

    if( isset( $this->_Rules[$name_object][$action][$property][0] ) ) {
      return 8;
    }

    # Если есть глобальные права но нет тонких то тонкие тоже есть
    if( isset( $this->_Rules[$name_object][$action][''][0] ) && !isset($this->_Rules[$name_object][$action][$property][$id_object]) ) {
      # Если есть тонкие а глобальных нет
      if( !isset( $this->_Rules[$name_object][$action][$property][0]) ){
        return false;
      }
      return 9;
    }

    return isset( $this->_Rules[$name_object][$action][$property][$id_object] );

  }


  function GetFullRules()
  {
    return isset($GLOBALS['FullRules']) && $GLOBALS['FullRules'];
  }


  static function ChangePass( $pass1 = '' , $pass2 = '' , $salt = '' )
  {
    if($pass1=='' or $pass2=='') return false;
    $post = array();
    if( isset($pass1,$pass2) and strcmp($pass1,$pass2)==0 ) {
      $post['Salt'] = $salt;
      $pass = $pass1;
      $post['Pass'] = md5(md5($pass).$salt);
    }else{
      $post['Salt'] = Self()->Salt;
      $post['Pass'] = Self()->Pass;
    }
    return $post['Pass'];
  }


  //function ReturnSQLRule($t,$aParams)


  function ReturnSQLRuleOld($t,$aParams)
  {
    if( isset($GLOBALS['FullRules']) and $GLOBALS['FullRules'] )
    {
      return $aParams;
    }
    DB::Log('ReturnSQLRule');
    $Filter = array(
      'Filter' => array(
        'Ident' => mb_strtolower(ucfirst(get_class($t)))
      )
    );
    $Filter = array(
      'Filter' => array(
        'Interprise' => array( 0 , Self()->Interprise->Id ),
        'User' => Self()->Id,
        'Objectrule' => array( 0 , objectrule::Filter($Filter)->First->Id )
      )
    );

    $addsql = true;
    $limit = 0;

    $sql = DB::Select(link::Filter($Filter)->SqlOnlyFields);

    while( $a = DB::Fetch($sql))
    {
      if($a['whyid'] == 0) $addsql = false;
      $limit++;
    }

    if($addsql)
    {
      if(isset($aParams['Filter']))
      {
        $aP['AddWhere'] = ' AND `'.$t->FInit['Id']['sql'].'` = ('.link::Filter($Filter)->SqlOnlyFields.")";
      }
      else
      {
        $aP['AddWhere'] = ' AND `'.$t->FInit['Id']['sql'].'` = ('.link::Filter($Filter)->SqlOnlyFields.")";
      }

      if(isset($aParams['AddWhere']))
      {
        /*
          Если уже есть фильтр и доп sql
        */
        if(isset($aParams['Filter'], $aParams['AddWhere']) && substr_count($aParams['AddWhere'], 'WHERE') > 0 ) $aParams['AddWhere'] = str_replace( "WHERE" , "" , $aParams['AddWhere']);

        if(substr_count($aParams['AddWhere'], 'AND', 0, 7) > 0) $aP['AddWhere'] .= $aParams['AddWhere'];
        else
        {
          # проверим на Where
          if(substr_count($aParams['AddWhere'], 'WHERE',0,7) > 0  && substr_count($aP['AddWhere'], 'WHERE',0,7))
          {
            # 2 Where
            $aParams['AddWhere'] = substr_replace( $aParams['AddWhere'] , "" , 0 , 6);
          }
          $aP['AddWhere'] .= ' AND '.$aParams['AddWhere'];
        }
      }
      else
      {
        if(isset($aParams['Filter']))
        {
          $aP['AddWhere'] = ' AND `'.$t->FInit['Id']['sql'].'` = ('.link::Filter($Filter)->SqlOnlyFields.")";
        }
        else
        {
          $aP['AddWhere'] = ' AND `'.$t->FInit['Id']['sql'].'` = ('.link::Filter($Filter)->SqlOnlyFields.")";
        }
      }

      $aParams['AddWhere'] = $aP['AddWhere'];
      return $aParams;

      if(isset($aParams['Limit']))
      {
        if($aParams['Limit'] > $limit) $aParams['Limit'] = $limit;
      }
    }
    return $aParams;
  }

  /*
      Добавление пользователя
  */
  function AddUser( $post = array() , $error )
  {
    $result = array(
      'ref' => '/user/',
      'res' => 'other_error'
    );

    if(isset($post['UserSearch'])) $post['Login'] = $post['UserSearch'];
    if(empty($post['UserSearch']))
    {
      $result = array(
        'ref' => '/user/newuser/',
        'res' => 'empty_login'
      );
      return $result;
    }

    if(empty($post)) {
      $result = array(
        'ref' => '/user/newuser/',
        'res' => 'empty_post'
      );
      return $result;
    }
    if(!Self()->IsIssetRule( 'user' ,'Add')){
      $result = array(
        'ref' => '/user/',
        'res' => 'not_prerogative'
      );
      return $result;
    }

    if(!isset($post['Pass']) or $post['Pass'] == '')
    {
      $result = array(
        'ref' => '/user/newuser/',
        'res' => 'empty_pass'
      );
      return $result;
    }
    if(!isset($post['Pass2']) or $post['Pass2'] == '')
    {
      $result = array(
        'ref' => '/user/newuser/',
        'res' => 'empty_pass2'
      );
      return $result;
    }
    if(isset($post['Pass']) && isset($post['Pass2']) && $post['Pass'] != $post['Pass2'])
    {
      $result = array(
        'ref' => '/user/newuser/',
        'res' => 'pass_ne_pass2'
      );
      return $result;
    }
    if(count($error) == 0)
    {
      $Filter = array( 'Filter' => array( 'Login' => $post['Login'] ) );

      if(!user::Filter($Filter)->Count)
      {
        $post['Active'] = 1;
        $post['Pass'] = user::ChangePass( $post['Pass'] , $post['Pass2'] );
        if(user::AddByArray($post))
        {
          $_add['UserId'] = user::Filter($Filter)->First->Id;
          usersinterprise::AddByArray($_add);
          $result = array(
            'ref' => '/user/',
            'res' => 'succees'
          );
          return $result;
        }
      }
    }
    return $result;
  }

  /*
    Метод для получения групп пользователей
    [id] = true
  */

  /*
  function GetIsUser(){
    return $this->Id > TSession::GUEST_ID();
  }

  */
  //~ function GetIsGuest(){
    //~ return $this->Id == TSession::GUEST_ID();
  //~ }
  function GetIsSystem(){
    return $this->Id < TSession::GUEST_ID();
  }
  function AccessClass($access_text, $write = 0){
    $SuperAccess = $GLOBALS['CONFIG']['ACCESS']['ROOT'];
    if( defined("{$access_text}::AccessId") ) return $this->Access(constant("{$access_text}::AccessId"),$write) or $this->Access($SuperAccess);
    return false;
  }

  function GetLinkToLog(){
    return "/user/{$this->Id}/log/";
  }

  function Access($access_id, $write = 0){
    return $this->IsUser;
    $this->AccessLoad();
    if ($write != 0) $write = 1;
    $SuperAccess = $GLOBALS['config']['Access']['Root'];
    if( !isset($GLOBALS["UserAccess"],$GLOBALS["UserAccess"][$this->Id],$GLOBALS["UserAccess"][$this->Id][$access_id],$GLOBALS["UserAccess"][$this->Id][$access_id][$write])) return false;
    return (bool)($GLOBALS["UserAccess"][$this->Id][$access_id][$write] or $GLOBALS["UserAccess"][$this->Id][$SuperAccess][$write]);
  }

  function InterpriseAll()
  {
    $Filter = array(
      'Filter' => array(
        'User' => Self()->Id
      )
    );
    $I = array();
    foreach(usersinterprise::Filter($Filter)->Elements as $i) $I[$i->Interprise->Id] = $i->Interprise->Name;
    return $I;
  }


  # task 11797
  //~ function GetInterprise(){

    //~ if( isset( $_SERVER['HTTP_ENTERPRISE'] ) && Self()->Type == 99 ){

      //~ $b = false;
      //~ if( !Self()->FullRules ){
        //~ $b = true;
      //~ }

      //~ if( $b ) $GLOBALS['FullRules'] = true;
      //~ $Interprise = interprise::Id( $_SERVER['HTTP_ENTERPRISE'] );
      //~ if( $b ) $GLOBALS['FullRules'] = false;
      //~ return $Interprise;
    //~ }

    //~ return TObject2::_get_object($this,$this->_F['Interprise'],'Interprise');
  //~ }

  function CountLinkAll($id)
  {
    DB::Log( 'CountLinkAll' );
    $Filter = array(
      'Filter' => array(
        'Ident' => array('Converter','Meter')
      )
    );

    $ObjectR = array();

    foreach( objectrule::Filter($Filter)->Elements as $f) $ObjectR[] = $f->Id;

    $Filter = array(
      'Filter' => array(
        'User' => $id,
        'Objectrule' => $ObjectR
      )
    );
    return link::Filter($Filter)->Count;
  }

  function CountRuleId($id)
  {
    $A = array();
    $Filter = array(
      'Filter' => array(
        'User' => $id
      ),
    );
    foreach(link::Filter($Filter)->Elements as $_v) $A[$_v->Rule->Id] = (isset($A[$_v->Rule->Id])) ? $A[$_v->Rule->Id]++ : 0 ;
    return count($A);
  }

  function GetMyRule()
  {
    $Filter = array(
      'Filter' => array(
        'User' => $this->Id,
        'Interprise' => $this->Interprise->Id,
        'Auto' => 0
      ),
      'GroupBy' => array('Rule')
    );
    return link::Filter($Filter);
  }

  /* проверка на содержанием роли управлением над конверторами и счетчиками */

  function RuleConverterMeter( $id = 0 )
  {

    $IdAction = array();

    $Filter = array(
      'Filter' => array(
        'Name' => array('Converter','Meter')
      )
    );

    foreach( action::Filter($Filter)->Elements as $f ) $IdAction[] = $f->Id;

    $Filter = array(
      'Filter' => array(
        'Action' => $IdAction,
        'Rule' => $id,
      )
    );

    return patern::Filter($Filter)->Count;

  }

  function GetCountGroupUser()
  {
    $Filter = array(
      'Filter' => array(
        'User' => $this->Id
      )
    );
    return groupusers::Filter($Filter)->Count;
  }

  /* проверка на содержанием роли управлением над конверторами */

  function RuleConverter( $id = 0 )
  {
    $IdAction = array();

    $Filter = array(
      'Filter' => array(
        'Name' => array('Converter')
      )
    );

    foreach( action::Filter($Filter)->Elements as $f ) $IdAction[] = $f->Id;

    $Filter = array(
      'Filter' => array(
        'Action' => $IdAction,
        'Rule' => $id
      )
    );
    return patern::Filter($Filter)->Count;
  }

  /* проверка на содержанием роли управлением над счетчиками */

  function RuleMeter( $id = 0 )
  {
    $IdAction = array();

    $Filter = array(
      'Filter' => array(
        'Name' => array('Meter')
      )
    );

    foreach( action::Filter($Filter)->Elements as $f ) $IdAction[] = $f->Id;

    $Filter = array(
      'Filter' => array(
        'Action' => $IdAction,
        'Rule' => $id
      )
    );
    return patern::Filter($Filter)->Count;
  }

  /*
    Метод по рекурсивному поиску фильтров родительских плейсов
  */

  function FindFilterParentPlace( $arr = array() )
  {
    DB::Log('FindFilterParentPlace');
    if(!is_object($arr['object'])) return false;

    $Object = $arr['object'];

    $Filter = array(
      'Filter' => array(
        'Objectrule' => $Object->MyTypeObject,
        'Id_object' => $Object->Id
      )
    );

    if(!filterparamobject::Filter($Filter)->Count)
    {
      $arr['object'] = $Object->Place ;
      if($Object->Place->Is) return $this->FindFilterParentPlace( $arr );
    }
    return $arr;
  }




  public $ParentFilter = false;

  /*
    Метод по выводу параметров, которые возможны на этом объекте
  */

  function ReturnFilterAllParam( $arr = array() )
  {
    DB::Log('ReturnFilterAllParam');
    if(!isset( $arr['object'] ) or !is_object($arr['object'])) return array( parameter::Id(0) );

    $Object = $arr['object'];

    /*
      Если это плейс то проверяем есть ли фильтры у него. если нету, то ищем у родителя
    */
    $arr = ($Object->ClassName == 'place') ? $this->FindFilterParentPlace( $arr ) : $arr ;

    if( $Object->ClassName == 'place' && !$arr['object']->Is )
    {
      /*
        Если нету объекта и это плейс, то значит своих то точно нету фильтров. Выдаем ,которые есть у его счетчиков
      */
      $Filter = array(
        'Filter' => array(
          'Place' => $Object->Id
        )
      );

      $arParameters = array();
      foreach( meterplace::Filter($Filter)->Elements as $iMeterplace )
      {
        foreach( $iMeterplace->Meter->ParameterFilter as $iParameter)
        {
          if(isset($arParameters[$iParameter->Id])) continue;
          else $arParameters[$iParameter->Id] = $iParameter;
        }
      }
      return $arParameters;
    }

    $postfix = (isset($arr['postfix'])) ? $arr['postfix'] : '' ;

    $NameFilter = $this->ThisNameFilter( $Object , $postfix );

    $Filter = array(
      'Filter' => array(
        'Name' => $NameFilter
      )
    );
    $NameFilter = filterparamname::Filter($Filter)->First;

    if(!$NameFilter->Is) return Self()->ReturnActualyAllParameter($arr['object']);

    $Filter = array(
      'Filter' => array(
        'Filter' => $NameFilter->Id,
      ),
      'Order' => array(
        'Number'=>'ASC'
      )
    );

    $AllParameter = array();

    foreach(filterparamis::Filter($Filter)->Elements as $iParameter) $AllParameter[$iParameter->Param->Id] = $iParameter->Param;

    return $AllParameter;

  }

  /*
    Создаем имя файла
  */
  function ThisNameFilter( $Object , $postfix = '' , $namefilter = '' )
  {
    if($Object->ClassName == 'meter') {
      if( $Object->IsVirtual ){
        return $Object->Type->Ident . "." .$Object->Id . "." . $Object->Interprise->Id . "." . $postfix;
      }
      return $Object->Type->Ident . "." . $Object->Interprise->Id . "." . $postfix;
    }elseif($Object->ClassName == 'place'){
      $Prefix = !empty($namefilter) ? $namefilter : $Object->ClassName ;
      return $Prefix . "." . $Object->Interprise->Id . "." . $Object->Id;
    }
  }

  /*
   * Возвращение названия фильтра для плейса
   * */
  function ReturnNameFilterPlace( $Object , $post = array() )
  {
    $post['namefilter'] = !isset($post['namefilter']) ? '' : $post['namefilter'] ;

    $Filter = array(
      'Filter' => array(
        'Objectrule'  => $Object->MyTypeObject,
        'Id_object'   => $Object->Id,
        'Interprise'  => $Object->Interprise->Id
      )
    );
    $FilterF = filterparamobject::Filter($Filter);
    $GenerateName = Self()->ThisNameFilter( $Object , '' , $post['namefilter'] );

    if($FilterF->Count) {
      // Берем первый
      $ThisFilter = $FilterF->First;
      if($ThisFilter->Filterparamname->Name == $GenerateName) {
        return $ThisFilter->Filterparamname->Name;
      } else {
        $ThisFilter->Filterparamname->Name = $GenerateName;
        TObject2::CleanAllObjects();
        return $GenerateName;
      }
    }
    else return $GenerateName;
  }

  static public function All( $c=-1 )
  {
    if( !isset(
      user::$_R['All']
    )){
      $Filter = array(
        'Filter' => array(
          'Interprise' => Self()->Interprise->Id
        ),
      );
      user::$_R['All'] = user::Filter( $Filter , true );
    }
    return user::$_R['All'];
  }





  /*
    Возвращение всех параметров для этой сущности
  */
  function ReturnActualyAllParameter( $Object )
  {
    $meterId = $parameterId = $numbePaeamId = array();

    if($Object->ClassName == 'place')
    {
      $Filter = array(
        'Filter' => array(
          'Place' => $Object->Id
        ),
      );
      foreach( meterplace::Filter($Filter)->Elements as $v) $meterId[$v->Meter->Type->Id] = true;
    }
    elseif($Object->ClassName == 'meter') $meterId[$Object->Type->Id] = true;
    elseif($Object->ClassName == 'converter')
    {
      $Filter = array(
        'Filter' => array(
          'Converter' => $Object->Id
        )
      );

      $metersId = array();
      foreach( meter::Filter($Filter)->Elements as $k=>$v ) $meterId[$v->Type->Id] = true;
    }

    $Filter = array(
      'Filter' => array(
        'Metertype' => array_keys( $meterId ),
        'IsUse' => 1
      )
    );

    $idPar = array();

    foreach( metertypeparameter::Filter($Filter)->Elements as $k=>$v ) if(substr_count($v->Parameter->Ident, 'EVENT', 0, 6)==0) $idPar[$v->Parameter->Id] = true;

    $Filter = array(
      'Filter' => array(
        'Id' => array_keys( $idPar )
      )
    );

    return parameter::Filter($Filter)->Elements;
  }


  function GetCountMyRule()
  {
    $Filter = array(
      'Filter' => array(
        'Interprise' => $this->Interprise->Id,
        'User' => $this->Id,
      ),
      'GroupBy' => array('Rule')
    );
    return link::Filter($Filter)->Count;
  }

  /*Показывать только назначенные напрямую*/
  function GetCountMyRuleMain(){
    $Filter = array(
      'Filter' => array(
        'Interprise' => $this->Interprise->Id,
        'User' => $this->Id,
        'Auto' => 0
      ),
      'GroupBy' => array('Rule')
    );
    return link::Filter($Filter)->Count;
  }

  function GetCountMyGroup()
  {
    return $this->MyGroup->Count;
  }

  function GetMyGroup()
  {
    $Filter = array(
      'Filter' => array(
        'User' => $this->Id,
      )
    );
    return groupusers::Filter($Filter);
  }

  function GetCountMyUsers()
  {
    $Filter = array(
      'Filter' => array(
        'Group' => $this->Id,
      )
    );
    $ThisInterprise = $this->Interprise->Id;
    $AllLink = groupusers::Filter($Filter)->Elements;
    foreach($AllLink as $key=>$iUser) if($iUser->Interprise->Id != $ThisInterprise) unset($AllLink[$key]);
    return count($AllLink);
  }

  function GetActiveTitle()
  {
    return ($this->Active == 1) ? 'Да' : 'Нет' ;
  }


  function Delete() {

    if(!Self()->Rules( $this ,'Delete')) return false;

    if( $this->Interprise->Id != Self()->Interprise->Id ) return false;

    $GLOBALS['FullRules'] = true;

    $Filter = array(
      'Filter' => array(
        'Group' => $this->Id
      )
    );

    groupusers::Filter($Filter)->DeleteAll();

    $Filter = array(
      'Filter' => array(
        'User' => $this->Id
      )
    );
    usersinterprise::Filter($Filter)->DeleteAll();
    link::Filter($Filter)->DeleteAll();
    TObject2::StaticDelete($this);
    $GLOBALS['FullRules'] = false;

    return true;
  }


  function RemoveRules($Object = '' , $id = 0 , $action = '' , $interprise = 0 )
  {
    if(!isset($this->Rule[$interprise])) return false;
    if(!isset($this->Rule[$interprise][$Object])) return false;
    if(!isset($this->Rule[$interprise][$Object][$id])) return false;
    unset($this->Rule[$interprise][$Object][$id][$action]);
    return $this->Rule;
  }

  /*
    Уровень на котором определили часовой пояс для пользователя
    0 - системный
    1 - уровень предприятия
    2 - уровень пользователя
  */
  private $LvlTimezone = 0;

  private function SetLvlTimezone( $lvl ){
    $this->LvlTimezone = $lvl;
  }

  function GetLvlTimezone(){
    return $this->LvlTimezone;
  }

  # пользователю выставлен часовой пояс системы
  function GetIsChangeSystemTimezone(){
    return $this->LvlTimezone == 0;
  }

  # пользователю выставлен часовой пояс предприятия
  function GetIsChangeEnterpriseTimezone(){
    return $this->LvlTimezone == 1;
  }

  # пользователю выставлен часовой пояс который он сам себе указал
  function GetIsChangeUserTimezone(){
    return $this->LvlTimezone == 2;
  }

  //~ function GetTimezone()
  //~ {
    //~ return $this->Timezoneid;
    # Если задано свое
    //~ if( $this->Timezoneid->Is ){
      //~ $this->SetLvlTimezone(2);
      //~ return $this->Timezoneid;
    //~ }
    //~ # Если задано предприятием
    //~ $Timezone = $this->Interprise->Timezone;
    //~ $this->SetLvlTimezone($this->Interprise->IsTimezoneInterprise);
    //~ return $Timezone;
  //~ }


  function DateLink( $pos = 'prev' , $year = 0 , $month = 0 , $day = 0 )
  {
    return $pos;
  }

  function GetIsIm(){
    return $this->Id == Self()->Id;
  }

  /*
    Редактирование связей у пользователя
    @param sting принимает строку из ролей перечисленных через запятую
    @return array | bool Возхвращает или ошибки или результат
  */
  function Updatelink( $rulestring = "" ){

    $error = array();

    if( !is_string( $rulestring ) ){
      $error[] = "Не известный формат входных данных";
    }

    if( !$this->Is ){
      $error[] = "Такого пользователя не существует";
    }

    if( $this->Interprise->Id != Self()->Interprise->Id ){
      $error[] = "Вы не можете воздействовать на этого пользователя";
    }

    if( $this->IsIm ){
      $error[] = "Вы не можете назначать себе роли";
    }

    if( !empty($error) ){
      return $error;
    }

    # Сначала все чистим
    $Filter = array(
      'Filter' => array(
        'User'        => $this->Id,
        'Objectrule'  => 0,
        'Whyid'       => 0
      )
    );
    link::Filter($Filter)->DeleteAll();

    # теперь добавляем
    foreach( explode( ',' , $rulestring ) as $iruleId ){
      $iRule = rule::Id( $iruleId );

      # Если роли не существует или она в другом предприятии
      if( !$iRule->Is){
        continue;
      }
      link::AddByArray(
        array(
          'UserId'        => $this->Id,
          'ObjectruleId'  => 0,
          'Whyid'         => 0,
          'RuleId'        => $iRule->Id
        )
      );

    }

    userlog::AddByArray(
      array(
        'Object'   => get_class($this),
        'ObjectId' => $this->Id,
        'Property' => smarty()->get_config_vars('log_edit'),
        'UserId'   => Self()->Id,
        'Action'   => smarty()->get_config_vars('log_rule_edit_user_list'),
      )
    );

    return true;

  }

  /*
    Добавление группы
    @param array  массив POST
    @return array массив ошибок
    @return true возврат успешного выполнения
  */
  function AddGroupByForm( $post = array() ){

    $error = array();

    if( !isset( $post['name'] ) or $post['name'] == "" ){
      $error[] = "Вы не указали название группы";
      return $error;
    }

    $Filter = array(
      'Filter' => array(
        'Fio' => $post['name']
      )
    );

    if( user::Filter($Filter)->Count ){
      $error[] = "Такая группа уже существует";
      return $error;
    }

    $oGroup = user::AddByArray(array(
      'Type'    => 1,
      'Login'   => '',
      'Fio'     => $post['name'],
      'Active'  => isset($post['Active']) ? (int) $post['Active'] : 0
    ));
    //~ smarty()->config_load($_SERVER['DOCUMENT_ROOT'] ."/configs/words.conf", 'LOG');
    userlog::AddByArray(
      array(
        'Object'   => get_class($this),
        'ObjectId' => $oGroup->Id,
        'Property' => smarty()->get_config_vars('log_add'),
        'UserId'   => Self()->Id,
        'Action'   => smarty()->get_config_vars('log_user_add_group'),
      )
    );

    return true;
  }

  // Есть ли пользователь в этой группе
  function InGroup( $oGroup ){
    $Filter = array(
      'Filter' => array(
        'User' => $this->Id,
        'Group' => $oGroup->Id
      )
    );
    return groupusers::Filter($Filter)->Count;
  }


  // Сколько пользователей в этой группе
  function GetCountUser(){
    $Filter = array(
      'Filter' => array(
        'Group' => $this->Id
      )
    );
    return groupusers::Filter($Filter)->Count;
  }


  /*
    Редактирование пользователей в группе
    @param array  массив POST
    @return array массив ошибок
    @return true возврат успешного выполнения
  */
  function EditUserInGroupByForm( $post = array() ){

    $error = array();

    if( !$this->Is ){
      $error[] = "Такой группы не существует";
      return $error;
    }

    $Filter = array(
      'Filter' => array(
        'Group' => $this->Id,
      )
    );
    groupusers::Filter($Filter)->DeleteAll();

    if( !isset($post['arUsers']) ) return true;

    $Users = array_unique( array_diff( explode( ',' , $post['arUsers']) , array('') ) );

    foreach($Users as $iUser) {

      $iUser = user::Id( $iUser );

      if( !$iUser->Is or $iUser->Interprise->Id != Self()->Interprise->Id ){
        continue;
      }
      $Add = array(
        'GroupId'   => $this->Id,
        'UserId'    => $iUser->Id
      );
      groupusers::AddByArray($Add);
    }

    userlog::AddByArray(
      array(
        'Object'   => get_class($this),
        'ObjectId' => $this->Id,
        'Property' => smarty()->get_config_vars('log_add'),
        'UserId'   => Self()->Id,
        'Action'   => smarty()->get_config_vars('log_group_edit_list_users'),
      )
    );

    return true;

  }



  /*
    Возвращает всех пользователей этой группы
  */
  function GetMyUserGroup(){
    $arUsers = array();
    $Filter = array(
      'Filter' => array(
        'Group' => $this->Id
      )
    );
    foreach(groupusers::Filter($Filter)->Elements as $iUser) {
      $arUsers[$iUser->User->Id] = $iUser->User;
    }
    return $arUsers;
  }

  /*
    Возвращает остальных пользхователей вне группы
  */
  function GetNotMyUserGroup(){
    $Filter = array(
      'Filter' => array(
        'Id NOT IN'   => array_keys($this->MyUserGroup),
        'Type'        => 0
      )
    );
    return user::Filter($Filter);
  }

  function DeleteByInGroup( $oGroup = null ){

    # Если не указаена группа из какой удалять
    if( $oGroup === null ) return false;
    # Есил нет прав на редактирование пользователя
    if( !Self()->Rules($this , 'Edit') ) return false;
    # Если нет такой группы или такого пользователя
    if( !$this->Is or !$oGroup->Is ) return false;
    # Если это попытка удаелния из другого интерпрайза
    if( $this->Interprise->Id != $oGroup->Interprise->Id ) return false;
    if( $oGroup->Interprise->Id != Self()->Interprise->Id ) return false;

    return true;
  }

  static function GetListUser(){
    $t = user::Id(0);
    $SQL = "select * from user WHERE interprise = ".Self()->Interprise->Id." AND id > 100 AND type = 0 ORDER BY IF(fio='',login,fio)";
    $res = TListGroup::Prepare( $SQL , $t );
    $res->Elements;
    $res->SortUser();
    return $res;
  }

  static function GetListGroup(){
    $Filter = array(
      'Filter' => array(
        'Type' =>1 ,
      )
    );
    $res = user::Filter($Filter);
    $res->Elements;
    $res->SortUser();
    return $res;
  }

  static function GetAllGroup(){
    $Filter = array(
      'Filter' => array(
        'Type' => 1,
      )
    );
    return user::Filter($Filter);
  }

  //~ function OnAfterSqlInsert()
  //~ {
    //~ $fields = array();
    //~ foreach( $this::$FInit as $ident => $value ){
      //~ if( $value['type'] == 'fltcnt' ) continue;
      //~ if( is_object($this->$ident) ){
        //~ $fields[$ident] = $this->$ident->Id;
      //~ }else{
        //~ $fields[$ident] = $this->$ident;
      //~ }
    //~ }
    //~ userlog::SetLog( '#AddObject' , array(
        //~ 'object'       => get_class($this),
        //~ 'id'           => $this->Id ,
        //~ 'property'     => "Add",
        //~ 'im'           => Self()->Id
    //~ ),  array(
        //~ 'object'  => $this,
        //~ 'get_class_object' => get_class($this),
        //~ 'fields' => $fields
    //~ ));
  //~ }


  function OnAfterSqlUpdate()
  {
    Site()->SetConfig( 'Ajax.Menu.Ts', time() );
  }

  function OnAfterDelete(){
    $Array_set = array(
        'object'         => get_class($this)     ,
        'id'                 => $this->Id    ,
        'property' => 'Delete'        ,
        'im'     => Self()->Id        ,
    );

  }

  function GetMyTypeObject()
  {
    $Filter = array(
      'Filter' => array(
        'Ident' => 'User'
      )
    );
    return objectrule::Filter($Filter)->First->Id;
  }


  # проверяет что на пользователя назначена эта роль
  function IsMyRules($id){
    foreach( $this->MyRule->Elements as $iLink ){
      if( $iLink->Rule->Id == $id ){
        return true;
      }
    }
    return false;
  }

  function IsSelectedRule( $oRule ){
    return $this->IsMyRules( $oRule->Id );
  }

  # Создаем переменную времени как свойство
  function GetDatetime(){
    return $this->GetUserDatetime();
  }

  # Переменная для хранения времени счетчика
  public $UserDateVar = false;


  function GetUserDatetime( $get = array() ){

    # Если мы уже выситывали время для счетчика
    if( $this->UserDateVar ) return $this->UserDateVar;

    if( empty( $get ) ) $get = $_GET;

    $now    = false;
    $Year   = false;
    $Month  = false;
    $Day    = false;
    $Hour   = false;

    $IdentTimeZone = $this->Timezone->Ident ;

    if( $IdentTimeZone == '' ){
      $DeleteT = new DateTime('now' , new DateTimeZone('UTC') );
      $DeleteT->modify("+{$this->Timezone->Diff} seconds");
      $IdentTimeZone = $DeleteT->getTimezone()->getName();
    }

    $Date = new Datetime( 'now' , new DateTimeZone($IdentTimeZone) );

    if( !isset($get['year']) ){
      $now = true;
    }else{

      if( isset( $get['year'] ) ){
        $Year = $this->ArrayTimes['year'] = (int) $get['year'];
      }

      if( isset( $get['month'] ) ){
        $Month = $this->ArrayTimes['month'] = (int) $get['month'];
      }

      if( isset( $get['day'] ) ){
        $Day = $this->ArrayTimes['day'] = (int) $get['day'];
      }

      if( isset( $get['hour'] ) ){
        $Hour = $this->ArrayTimes['hour'] = (int) $get['hour'];
      }

    }

    if(!$now){
      $Date->setDate(
          $Year !== false ? $Year   : $Date->format("Y") ,
          $Month!== false ? $Month  : $Date->format("m")  ,
          $Day  !== false ? $Day    : $Date->format("d")
        );
      if($Hour){
        $Date->setTime(
            $Hour  !== false ? $Hour : $Date->format("H"),
            1
          );
      }
      # Этот хак нужен если мы физическая дата 31 а запрашивают февраль где нету 31 дня
      # До преобразования допустим будет  "2015-03-02 11:00:43.000000"
      # После                             "2015-02-02 11:00:43.000000"
      $Date->setDate(
        $Year !== false ? $Year   : $Date->format("Y") ,
        $Month!== false ? $Month  : $Date->format("m")  ,
        $Day  !== false ? $Day    : $Date->format("d")
      );
    }

    $this->UserDateVar = $Date;

    return $Date;
  }



  function GetRefererPathAterAuth(){

    $IsRefererToAccount = Site()->Config( 'IsRefererToAccount' , 0 );

    $PreRef = $IsRefererToAccount && !isset($_SERVER["HTTP_ENTERPRISE"]) ? "http://u". Self()->Interprise->Id . Site()->Config('domain_url' , '.nagruzka.net')  : '';

    $ref = "";

    if(isset($_GET['ref']) && preg_match( '/([a-z0-9\_\/]*)/' , $_GET['ref'] )){
      return $PreRef.$_GET['ref'];
    }else{
      if( Self()->IsIssetRule( 'Place' , 'View' ) ) {
        return $PreRef."/place/";
      }
      if( Self()->IsIssetRule( 'Converter' , 'View' ) or Self()->IsIssetRule( 'meter' , 'View' ) ) {
        return $PreRef."/converter/";
      }
      return $PreRef."/user/";
    }
    return $ref;
  }



  function SaveRuleByPost( $post ){
    if( isset( $post['Rules'] ) ){
      $arIssetRule = array();
      foreach( $this->MyRule->Elements as $iLink ){
        $arIssetRule[$iLink->Rule->Id] = $iLink->Rule->Id;
      }
      foreach( $post['Rules'] as $id ){
        if( isset( $arIssetRule[ $id ] ) ){
          unset( $arIssetRule[ $id ] );
        }else{
          foreach( objectrule::All()->Elements as $iObjectrule ){
            link::AddByArray(array(
              'RuleId' => rule::Id($id)->Id,
              'UserId' => $this->Id,
              'ObjectruleId' => $iObjectrule->Id,
              'Whyid' => 0
            ));
          }
        }
      }

      $Filter = array(
        'Filter'=> array(
          'Rule' => array_keys( $arIssetRule ),
          'User' => $this->Id
        )
      );
      link::Filter($Filter)->DeleteAll();
    }
  }
  
   /*
   * Установка языка пользователя
   */
  static public function SetUserLang($lang = '') {
    Self()->UpdateByArray(array(
        'Lang' => $lang
    ));
  }

}
