<?php
/*
Имя класса user_session
Имя файла user_session.class.php ( user_sessioncustom.class.php )
Поля класса:
Id : id
User : object
Timestamp : its
Ipint : iip
Sid : string
Url : string
Agent : string
*/

define( "SESSION_LOG" , 0);


class user_session extends user_sessioncustom{
  
  static $LOG = array();
  
  
  static function SetLog( $msg = "" ){
    if( SESSION_LOG ){
      self::$LOG[] = $msg;
    }
  }
  
  
  

  /**
   * Открытие сессии
   * 
   * @param type $save_path
   * @param type $session_name
   * @return type
   */
  static function open($save_path, $session_name){
    return true;
  }

  /**
   * Закрытие сессии
   * 
   * @return boolean
   */
  static function close(){
    
    if( SESSION_LOG ){
      foreach( self::$LOG as $line ){
        echo "{$line}\n";
      }
    }
    return true;
  }
  
  
  
  
  
  /**
   * Получение сессии из базы по идентификатору сессии
   * 
   * @param string $sid
   * @return user_session
   */
  static function get_session_by_sid( $sid ){
    $Session = user_session::Id(0);
    
    self::SetLog( "Ищем пользователя в БД по идентификатору сессии" );
    
    if( self::$New_Session !== null ){
      self::SetLog( "Нашли в кеше как только что добавленную" );
      return self::$New_Session;
    }
    
    // Проверим авторизован ли пользователь по сессии
    
    $Filter = array(
      'Filter' => array(
        'Sid' => $sid
      )
    );
    $UserSessionRes = user_session::Filter($Filter);
    if( $UserSessionRes->Count ){
      self::SetLog( "Нашли" );
      $Session = $UserSessionRes->First;
    }else{
      self::SetLog( "Не нашли" );
    }
    return $Session;
  }
  
  
  
  
  
  /**
   * Получение пользователя по форме авторизации
   * 
   * @return user
   */
  static function get_user_by_request(){
    
    $oUser = user::Id(0);
    
    self::SetLog( "Проверяем пытается ли пользователь авторизоваться" );
    
    $resource = array();
    
    foreach( array( 'login' , 'password' ) as $key ){
      if( isset( $_POST[ $key ] ) ){
        $resource[ $key ] = $_POST[ $key ];
      }elseif( isset( $_REQUEST[ $key ] ) ){
        $resource[ $key ] = $_REQUEST[ $key ];
      }
    }
    
    if( isset( $resource['login'] ) && isset( $resource['password'] ) ){
      
      self::SetLog( "Пытается" );
      
      $Filter = array(
        'Filter' => array(
          'Login' => $resource['login'],
          'Pass' => user::GenPass( $resource['password'] )
        )
      );
      $FindByLogin = user::FilterIgnoreInterprise($Filter);
      if( $FindByLogin->Count ){
        $oUser = $FindByLogin->First;
      }
    }
    return $oUser;
  }
  
  
  
  
  /**
   * Возвращает ip в int
   * 
   * @param string $addr
   * @return int
   */
  static function get_ip2long( $addr = '' ){
    $base_ip = '127.0.0.1';
    
    $ip = ip2long( isset( $_SERVER ) && !empty( $_SERVER['REMOTE_ADDR'] ) ? $_SERVER['REMOTE_ADDR'] : $base_ip );
  
    if( !$ip ){
      $ip = ip2long($base_ip);
    }
    return $ip;
  }

  /**
   * Время жизни сессии
   */
  const SESSION_TIME = 60*60*999999;
  
  
  
  
  /**
   * Получение адрса с которого пришел пользователь
   * 
   * @return string
   */
  static function get_url(){
    if( isset( $_SERVER['SERVER_NAME'] ) &&  isset( $_SERVER['REQUEST_URI'] ) ){
      return Utils::addslashes( "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'] );
    }
    return "";
  }
  
  
  
  
  /**
   * Получение агента пользователя
   * 
   * @return string
   */
  static function get_agent(){
    if( isset( $_SERVER['HTTP_USER_AGENT'] ) ){
      return $_SERVER['HTTP_USER_AGENT'];
    }
    return "none";
  }
  
  
  
  
  
  
  
  
  
  /**
   * Запись в БД гостя
   * 
   * @param string $sid идентификатор сессии
   * @return user_session
   */
  static function init_sess_guest( $sid ){
    
    self::SetLog( "записываем его сессию как ГОСТЯ" );
    
    return user_session::AddByArray(array(
      'UserId'    => Site()->GetGuest()->Id,
      'Ipint'     => self::get_ip2long(),
      'Timestamp' => time(),
      'Sid'       => $sid,
      'Url'       => self::get_url(),
      'Agent'     => self::get_agent()
    ));
  }

  
  
  
  static $New_Session = null;
  
  
  
  
  /**
   * Чтение сессии
   * 
   * @param string $sid
   * @return boolean
   */
  static function read( $sid ){
    
    self::SetLog( "Читаем сессию" );
    
    if( self::$New_Session !== null ){
      $Session = self::$New_Session;
    }else{
      $Session = self::get_session_by_sid($sid);
    }
    
    $before_full_rules = Site()->FullRules;
    
    if( !$before_full_rules ){
      $GLOBALS['FullRules'] = true;
    }
    
    $SessionData = user_session_data::GetBySesId( $Session );
    
    // Есть ли сессия
    if( $Session->Id ){
      
      $oUser = self::get_user_by_request();
      
      $Session->UpdateByArray(array(
        'Timestamp' => time()
      ));
      $Session->Save();
      
      if( $oUser->Is ){
        
        self::SetLog( "Пользователь был гостем и решил авторизоваться" );
        $Session->UpdateByArray(array(
            'UserId'    => $oUser->Id
        ));
        $Session->Save();
        self::SetLog( "Обновляем пользователя сессии на {$oUser->Id}" );
      }
      
      self::SetLog( "Сессия уже есть в БД" );
      
      // Сессия старая - удаляем
      if( $Session->Timestamp < time() - self::SESSION_TIME ){
        self::destroy($sid,true);
        return true;
      }else{
        
        self::SetLog( "Сессия актуальна. Обновляем время" );
        
        $GLOBALS['Self']  = $Session->User;
        user::$SelfId  = $Session->User->Id;
        
        if( user::$SelfId === Site()->GetGuest()->Id ){
          $GLOBALS['Self'] = user::Id(0);
        }else{
          self::SetLog( "Пользователь больше не гость" );
        }
        
        if( !$before_full_rules ){
          $GLOBALS['FullRules'] = false;
        }
        $Session->__destruct();
        return $SessionData->Value;
      }
      
    // сессии еще нет
    }else{
      
      self::SetLog( "Сессии нет в БД" );
      
      $oUser = self::get_user_by_request();
      
      // пытается ли пользователь авторизоваться?
      if( $oUser->Id && $oUser->Id !== Site()->GetGuest()->Id ){
        
        self::SetLog( "пользователь не гость" );
        
        $A = array(
          'UserId'    => $oUser->Id,
          'Ipint'     => self::get_ip2long(),
          'Timestamp' => time(),
          'Sid'       => $sid,
          'Url'       => self::get_url(),
          'Agent'     => self::get_agent()
        );
        $Session = user_session::AddByArray($A);
        userlog::AddByArray(array(
          'UserId'    => $oUser->Id,
          'Object'    => 'user',
          'ObjectId'  => $oUser->Id,
          'Property'  => "In",
          'Action'    => "Вошел через интерфейс"
        ));
        
        user::$SelfId  = $oUser->Id;
        
      // открывает страницу от гостя
      }else{
        
        self::SetLog( "Пользователь - ГОСТЬ" );
        
        $Session = self::init_sess_guest($sid);
        $oUser = $Session->User;
      }
      
      self::$New_Session = $Session;
      
      $GLOBALS['Self'] = $oUser;
      
    }
    
    if( !$before_full_rules ){
      $GLOBALS['FullRules'] = false;
    }
    
    return $SessionData->Value;
  }
  
  
  
  
  
  /**
   * Завершение сессии
   * 
   * @param string $sid
   * @param bollean $is_time
   * @return boolean
   */
  static function destroy($sid,$is_time = false){
    $before_full_rules = Site()->FullRules;
    
    $Session = self::get_session_by_sid($sid);
    if( !$before_full_rules ){
      $GLOBALS['FullRules'] = true;
    }
    
    $SessionData = user_session_data::GetBySesId( $Session );
    $SessionData->Delete();
    $SessionData->Save();
    
    $Session->Delete();
    $Session->Save();
    
    if( $Session->User->Id ){
      userlog::AddByArray(array(
        'UserId' => $Session->User->Id,
        'Object' => 'user',
        'ObjectId' => $Session->User->Id,
        'Property' => "Out",
        'Action' => !$is_time ? "Вышел через интерфейс" : "Закончилось время сессии"
      ));
    }
    if( !$before_full_rules ){
      $GLOBALS['FullRules'] = false;
    }
    return true;
  }
  
  
  
  
  static function gc($maxlifetime){
    return true;
  }
  
  
  
  
  static $SessionDataId = 0;
  
  
  /**
   * 
   * @param type $sid
   * @param type $sess_data
   * @return boolean
   */
  static function write($sid, $sess_data){
    
    $before_full_rules = Site()->FullRules;
    
    if( !$before_full_rules ){
      $GLOBALS['FullRules'] = true;
    }
    
    $Session = self::get_session_by_sid($sid);
    
    if( !$Session->Is ){
      $A = array(
        'UserId'    => Site()->GetGuest()->Id,
        'Ipint'     => self::get_ip2long(),
        'Timestamp' => time(),
        'Sid'       => $sid,
        'Url'       => self::get_url(),
        'Agent'     => self::get_agent()
      );
      $Session = user_session::AddByArray($A);
    }
    
    $SessionData = user_session_data::GetBySesId($Session);
    
    if( $SessionData->Is ){
      $SessionData->UpdateByArray(array(
          'Value' => $sess_data
      ));
    }else{
      if( $Session->Is ){
        $SessionData = user_session_data::AddByArray(array(
            'User_sessionId'  => $Session->Id,
            'Var'             => 'all',
            'Value'           => $sess_data
        ));
      }
    }
    
    self::$SessionDataId = $SessionData->Id;
    
    if( !$before_full_rules ){
      $GLOBALS['FullRules'] = false;
    }
    
    return true;
  }
  
}
