<?php
/*
Имя класса vconverter
Имя файла vconverter.class.php ( vconvertercustom.class.php )
Поля класса:
Id : id
Type : object
About : string
*/
class vconverter extends vconvertercustom{


  /**
   * Часть приборов работает, а часть нет
   */
  const NEITRAL_STATUS = 2;
  
  /**
   * Все приборы не работают
   */
  const NEGATIVE_STATUS = 0;
  
  /**
   * Все приборы работают
   */
  const POSITIVE_STATUS = 1;

  
  /*
    Таблица соответствия для работы с JSON
  */
  public $FieldsToJSON = array(
    'Id'                => 'id',
    'Type'              => 'type',
    'About'             => 'about',
  );
  
  
  /*
    Флаг логирования
  */
  public $NeedDoUserLog = true;
  
  
  /*
    Все события по конвертору
    @return TListGroup
  */
  function GetLog(){
    $Filter = array(
      'Filter' => array(
        'Object' => 'vconverter',
        'ObjectId' => $this->Id
      ),
      'Order' => array(
        'Its' => 'DESC'
      )
    );
    return userlog::Filter( $Filter );
  }
  
  
  
  /*
    Страницы лога
    @return Array
  */
  function GetLogPages(){
    return Utils::Paginator(
      $this->Log->Count,
      Site()->CountInPage
    );
  }
  
  
  
  
  /*
    Все события по конвертору
    @return TListGroup
  */
  function GetLogList(){
    $Log = $this->Log->GroupBy( Site()->CountInPage )->Elements;
    if( !isset( $Log[ Site()->Page ]) ){
      return TListGroup::Init();
    }
    return $Log[ Site()->Page ];
  }
  
  
  
  
  /*
    Преобразование объекта в массив для построение "дерева"
    @return Array
  */
  function GetToJsTree(){
    return array(
      'text' => htmlspecialchars($this->Title , ENT_QUOTES),
      'id' => "vconverter_tree_".$this->Id,
      'children' => (bool)$this->Meters->Count,
      'parent' => "#",
      'icon' => Site()->Config('icon.vconverter') . " text-{$this->RowClass}"
    );
  }
  
  
  
  
  
  
  
  
  
  /*
    Кеш всех параметров к прибора
  */
  protected $CacheAllParameters = null;
  
  
  /*
    Создание кеша данных
    @return Bool
  */
  protected function SetCacheAllParameter(){
    $SQL = Utils::Strip("
    select parameter.*
    from converter
    left join meter 
      on meter.converter_id = converter.id
    left join meterparameter
      on meterparameter.virtual_meter_id = meter.id
    left join parameter
      on parameter.id = meterparameter.virtual_parameter_id
    where converter.id = {$this->Id}
    ");
    $t = parameter::Id(0);
    $this->CacheAllParameters = TListGroup::Prepare( $SQL , $t );
    return true;
  }
  
  



  /*
    Реальные параметры привязанные к виртуальному прибору учета
    @return TListGroup
  */
  function GetAllParameters(){
    if( $this->CacheAllParameters === null ){
      $this->SetCacheAllParameter();
    }
    return $this->CacheAllParameters;
  }
  
  
  
  /*
    Удаление виртуального конвертора
    @return Nulls
  */
  function Delete() {
    if( $this->Interprise->Id != Self()->Interprise->Id ){
      return false;
    }
    TObject2::StaticDelete($this);
  }
  
  
  
  


  /*
    Переопределение стокового метода для выборки всех по назначению 2
    @return TListGroup
  */
  static public function Filter($aParams = null , $etc = array()){
    $ctFilter = array(
      'Filter' => array(
        'DllId' => 'VIRTUAL'
      )
    );
    $ctFilterRes = convertertype::Filter( $ctFilter );
    if( $ctFilterRes->Count ){
      $aParams['Filter']['Type'] = $ctFilterRes->First->Id;
    }
    if( !isset( $aParams['Filter']['Interprise'] ) ){
      $aParams['Filter']['Interprise'] = Self()->Interprise->Id;
    }
    $t=new vconverter();
    return TObject2::Filter($t,$aParams);
  }
  
  
  
  
  
  /*
    Переопределение метода для фильтрации приборов
    @return TListGroup
  */
  static public function &All( $c=-1 )
  {
    if( !isset( 
      vconverter::$_R['All']
    )){
      $Filter = array( 
        'Filter' => array( 
          'Type' => Site()->VirtualConverterType,
          'Interprise' => Self()->Interprise->Id
        ),
        'Limit'=>$c
      );
      vconverter::$_R['All'] 
      = TObject2::Filter( new vconverter(), $Filter);
    }
    return vconverter::$_R['All'];
  }
  
  
  
  
  /*
    Переопределение метода добавление для принудительного задания свойств
    @param Array
    @return vconverter
  */
  static public function &AddByArray($A){
    $A['TypeId'] = convertertype::FindByIdent("VIRTUAL")->Id;
    
    if( !$A['TypeId'] ){
      include( $_SERVER['DOCUMENT_ROOT'] . '/install/converter_type.php');
      $A['TypeId'] = convertertype::FindByIdent("VIRTUAL")->Id;
    }
    
    if( !isset( $A['InterpriseId']  ) ){
      $A['InterpriseId'] = Self()->Interprise->Id;
    }
    $t = new vconverter();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }




  /*
    Переопределение метода добавление для принудительного задания свойств
    @return vconverter
  */
  static public function &AddByRequest(){
    $_REQUEST['TypeId'] = convertertype::FindByIdent("VIRTUAL")->Id;
    
    if( !$_REQUEST['TypeId'] ){
      include( $_SERVER['DOCUMENT_ROOT'] . '/install/converter_type.php');
      $_REQUEST['TypeId'] = convertertype::FindByIdent("VIRTUAL")->Id;
    }
    
    if( !isset( $_REQUEST['InterpriseId'] ) ){
      $_REQUEST['InterpriseId'] = Self()->Interprise->Id;
    }
    $t = new vconverter();
    TObject2::StaticAddByRequest($t);
    return $t;
  }
  
  
  
  
  /*
    Ссылка на лог событий
    @return TListGroup
  */
  function GetLinkLog(){
    return "{$this->Link}log/";
  }
  
  
  
  
  
  
  
  /*
    Получение списка приборов учета с учетом страниц
    @return TListGroup
  */
  function GetMetersByPages(){
    $Meters = $this->Meters->GroupBy( Site()->CountInPage )->Elements;
    if( !isset( $Meters[ Site()->Page ] ) ){
      return TListGroup::Init();
    }
    return $Meters[ Site()->Page ];
  }
  
  
  
  
  
  
  
  /*
    Получение пагинатора для списка приборов учета
    @return Array
  */
  function GetPagesMeters($is_all = false){
    return Utils::Paginator(
      $this->Meters->Count,
      Site()->GetCountInPage(),
      $is_all
    );
  }
  
  
  
  
  /*
    Кол-во приборов учета с ошибками
    @return TListGroup
  */
  function GetMetersError(){
    $Filter = array( 
      'Filter' => array( 
        'Converter' => $this->Id,
        'IsOk'      => 0
      )
    );
    return vmeter::Filter( $Filter );
  }
  
  
  
  
  
  
  
  /*
    Получение всех приборов учета на этом конверторе
    @return TListGroup
  */
  function GetMeters(){

    $FilterMetertype = array(
      'Filter' => array(
        'DllId' => Site()->MetertypeVirtual->DllId
      )
    );

    $metertypes_ids = array();
    foreach( metertype::Filter($FilterMetertype)->Elements as $iMetertype ){
      $metertypes_ids[] = $iMetertype->Id;
    }

    $Filter = array( 
      'Filter' => array( 
        'Converter' => $this->Id,
        'Type' => $metertypes_ids,
        'Interprise' => Self()->Interprise->Id
      )
    );
    return vmeter::Filter($Filter);
  }






  /*
    Вывод класса конвертора исходя из его статуса
    @return String
  */
  function GetRowClass(){
    if( $this->IsExcluded ){
      return "excluded";
    }
    
    if( $this->MeterOk == 2 ){
      return "danger";
    }elseif( $this->MeterOk == 1 ){
      return "success";
    }else{
      return "danger";
    }
  }
  
  
  
  
  
  
  
  
  
  
  
  /*
    Вывод статуса конвертора
    @return String
  */
  function GetRowTitle(){
    if( $this->IsExcluded ){
      return "Исключен";
    }
    
    if( $this->MeterOk == 2 ){
      return "Есть проблемы";
    }elseif( $this->MeterOk == 1 ){
      return "Все работает";
    }else{
      return "Не работает";
    }
  }
  
  
  
  
  
  
  /*
    ССылка на узел учета
    @return String
  */
  function GetLink(){
    return "/vconverter/{$this->Id}/";
  }
  
  
  /*
    Ссылка на удаление конвертора
    @return String
  */
  function GetLinkDelete(){
    return "{$this->Link}delete/";
  }
  
  /*
    Ссылка на редактирование конвертора
    @return String
  */
  function GetLinkEdit(){
    return "{$this->Link}edit/";
  }
  
  
  
  
  /*
    Удобное название для пользователя
    @@return String
  */
  function GetTitle(){
    if( $this->About != ""){
			return $this->About;
		}else{
			return "---";
		}
  }
  
  
  /*
    Ссылка на добавление прибора учета
    @return String
  */
  function GetLinkAddMeter(){
    return "{$this->Link}addmeter/";
  }
  
  
  
  
  /*
    Наследственность от converter
    @return False
  */
  function GetIsExcluded(){
    return false;
  }


  public function UpdateByRequest(){
    if( isset( $_REQUEST['TypeId'] ) ){
      unset($_REQUEST['TypeId']);
    }
    TObject2::StaticUpdateByRequest($this);
  }
  public function UpdateByArray($A){
    if( isset( $A['TypeId'] ) ){
      unset($A['TypeId']);
    }
    TObject2::StaticUpdateByArray($this,$A);
  }




  /**
   * Перерасчет статуса MeterOk исходя из статусов вложенных приборов учета
   * 
   * @return boolean
   */
  function RewriteStatusMeterOk(){
    
    $count_ok = 0;
    $count_not_ok = 0;
    
    $oMeter = meter::Id(0);
    
    $SQL = Utils::Strip("SELECT * FROM {$oMeter::$SqlTable} WHERE {$oMeter::$FInit['Converter']['sql']} = {$this->Id}");

    $res = DB::Select( $SQL );
    
    while( $row = DB::Fetch( $res ) ){
      if( $row[ $oMeter::$FInit['IsOk']['sql'] ] ){
        $count_ok++;
      }else{
        $count_not_ok++;
      }
    }

    $status = self::NEGATIVE_STATUS;
    
    if( $count_ok == 0 && $count_not_ok == 0 ){
      $status = self::NEGATIVE_STATUS;
    }elseif( $count_ok && $count_not_ok ){
      $status = self::NEITRAL_STATUS;
    }elseif( $count_ok && !$count_not_ok ){
      $status = self::POSITIVE_STATUS;
    }else{
      $status = self::NEGATIVE_STATUS;
    }

    $this->UpdateByArray(array(
      'MeterOk' => $status
    ));
    
    return true;
  }
  
  
  
}
