<?php
/*
Имя класса vmeter
Имя файла vmeter.class.php ( vmetercustom.class.php )
Поля класса:
Id : id
Interprise : object
Vconverter : object
Metertype : object
IsOk : string
*/
class vmeter extends vmetercustom{
  
  
  /*
    Таблица соответствия для работы с JSON
  */
  public $FieldsToJSON = array(
    'Id'                => 'id',
    'About'             => 'about',
    'Converter'         => 'converter',
    'Type'              => 'type',
    'NumSerial'         => 'num_serial',
    'IsOk'              => 'is_ok',
    'Timezone'          => 'timezone',
    'Meter_extra_type'  => 'extra_type'
  );  
  
  
  
  
  static function SetFieldsFromObject( $aValues = array() ){
    $t = new vmeter();
    $t = $t->Init($t,$aValues);
    return $t;
  }
  
  
  
  
  /*
    Флаг логирования
  */
  public $NeedDoUserLog = true;
  
  
  
  /*
    Преобразование объекта в элменет дерева
    @return Array
  */
  function GetToJsTree(){
    
    $row_class = $this->IsOk
                  ? 'text-success'
                  : 'text-danger';
    
    return array(
      'text' => htmlspecialchars($this->Title , ENT_QUOTES),
      'id' => "vmeter_tree_".$this->Id,
      'parent' => "vconverter_tree_".$this->Converter->Id,
      'icon' => $this->GetIcon() . " {$row_class}"
    );
    
  }
  
  
  
  
  
  
  
  /*
    Переопределение метода добавление для принудительного задания свойств
    @return vmeter
  */
  static public function &AddByArray($A){
    $t = new vmeter();
    $A['Coef'] = 1;
    $A['TypeId'] = Site()->MetertypeVirtual->Id;
    $A['IsOk'] = 1;
    if( !isset( $A['InterpriseId'] ) ){
      $A['InterpriseId'] = Self()->Interprise->Id;
    }

    TObject2::StaticAddByArray($t,$A);

    if( isset( $A['not_valid_json'] ) ){

      if( isset( $A['not_valid_json']['number_plomb'] ) ){
        $t->NumberPlomb = $A['not_valid_json']['number_plomb'];
      }

    }
    return $t;
  }



  /*
    Переопределение метода добавление для принудительного задания свойств
    @return vmeter
  */
  static public function &AddByRequest(){
    $t = new vmeter();
    $_REQUEST['Coef'] = 1;
    $_REQUEST['TypeId'] = Site()->MetertypeVirtual->Id;
    if( !isset( $_REQUEST['InterpriseId'] ) ){
      $_REQUEST['InterpriseId'] = Self()->Interprise->Id;
    }
    TObject2::StaticAddByRequest($t);

    if( isset( $A['not_valid_json'] ) ){

      if( isset( $A['not_valid_json']['number_plomb'] ) ){
        $t->NumberPlomb = $A['not_valid_json']['number_plomb'];
      }

    }
    return $t;
  }
  
  
  
  
  
  /*
    Переопределение метода для фильтрации приборов
    @return TListGroup
  */
  static public function &All( $c=-1 ){
    if( !isset( 
      vmeter::$_R['All']
    )){

      $FilterMetertype = array(
        'Filter' => array(
          'DllId' => Site()->MetertypeVirtual->DllId
        )
      );

      $metertypes_ids = array();
      foreach( metertype::Filter($FilterMetertype)->Elements as $iMetertype ){
        $metertypes_ids[] = $iMetertype->Id;
      }
      $Filter = array( 
        'Filter' => array( 
          'Type' => $metertypes_ids,
          'Interprise' => Self()->Interprise->Id
        )
      );
      vmeter::$_R['All'] 
      = TObject2::Filter( new vmeter() , $Filter);
    }
    return vmeter::$_R['All'];
  }
  
  
  
  /*
    Переопределение метода для фильтрации приборов
    @return TListGroup
  */
  static public function Filter($aParams = null , $etc = array()){
    $t=new vmeter();
    // $i = Self()->Interprise->Id;
    // $sql = "select meter.* from meter left join meter_type
    // on meter_type.id = meter.type_id
    // where meter_type.dll_id like '%LORA%' OR meter_type.dll_id like '%VIRT%'
    // and meter.interprise = {$i}";
    if( !isset( $aParams['Filter']['Type'] ) ){
      $arrayMeters = array();
      foreach( Site()->MetertypeVirtuals->Elements as $iMetertype ){
        $arrayMeters[] = $iMetertype->Id;
      }
      $aParams['Filter']['Type'] = $arrayMeters;
    }
    if( !isset( $aParams['Interprise'] ) ){
      $aParams['Filter']['Interprise'] = Self()->Interprise->Id;
    }
    // echo Utils::Strip( $sql );
    // return TListGroup::Prepare( Utils::Strip( $sql ) , $t );
    return TObject2::Filter($t,$aParams);
  }
  
  
  
  
  
  
  
  /*
    Ссылка на просмотр архива
    @return String
  */
  function GetLinkArchive(){
    
    $sufix = isset( $_GET['start'] ) && isset( $_GET['stop'] )
             ? implode( "-" ,array( $_GET['start'] , $_GET['stop'] ))."/"
             : "";
    
    return $this->Link . "archive/".$sufix;
  }
  
  
  
  
  
  
  /*
    Построение массива из параметров для склеенного вывода
    @return Array
  */
  function GetHeadActiveParametersData( $after = array() , $before = array() ){
    $a = new HeadTableParameters( $after , $before , $this->AllParameters );
    return $a->RowCol();
  }
  
  
  
  
  
  
  
  
  /*
    Все активные параметры на виртуальном приборе - все параметры
    @return TListGroup
  */
  function GetActiveParametersData(){
    
    if( $this->IsFilterParameterData ){
      $Parameters = array();
      
      
      $Filter = array( 
        'Filter' => array( 
          'Object' => 'vmeter',
          'ObjectId' => $this->Id,
          'Interprise' => Self()->Interprise->Id,
          'Sufix' => ''
        )
      );
      
      $SQL = Utils::Strip("
        SELECT 
        parameter.* 
        FROM `filterparamis` 
        left join meterparameter 
          on meterparameter.virtual_parameter_id = filterparamis.parameter_id
        left join parameter 
          on meterparameter.parameter_id = parameter.id
        WHERE `id_filter` = " . filterparamname::Filter($Filter)->First->Id . " 
        group by filterparamis.order_num
        ORDER BY `order_num` ASC  
      ");
      
      $t = parameter::Id(0);
      return TListGroup::Prepare( $SQL , $t );
    }
    
    return $this->GetAllParameters();
  }
  
  
  
  
  
  
  
  
  /*
    Активные параметры на приборе
    @return TListGroup
  */
  function GetActiveMeterparametersData(){
    if( $this->IsFilterParameterData ){
      
      $Filter = array( 
        'Filter' => array( 
          'Object' => 'vmeter',
          'ObjectId' => $this->Id,
          'Interprise' => Self()->Interprise->Id,
          'Sufix' => ''
        )
      );
      
      $SQL = Utils::Strip("
        SELECT 
        meterparameter.* 
        FROM `filterparamis` 
        left join meterparameter 
          on meterparameter.virtual_parameter_id = filterparamis.parameter_id
        left join parameter 
          on meterparameter.parameter_id = parameter.id
        WHERE `id_filter` = " . filterparamname::Filter($Filter)->First->Id . " 
        group by filterparamis.order_num
        ORDER BY `order_num` ASC  
      ");
      
      $t = meterparameter::Id(0);
      return TListGroup::Prepare( $SQL , $t );
    }
    
    $Filter = array( 
      'Filter' => array( 
        'Virtualmeter' => $this->Id
      )
    );
    return meterparameter::Filter($Filter);
  }
  
  
  
  
  
  /*
    Проверка есть фильтр или нет на приборе по данным
    @return Int
  */
  function GetIsFilterParameterData(){
    $Filter = array( 
      'Filter' => array( 
        'Object' => 'vmeter',
        'ObjectId' => $this->Id,
        'Interprise' => Self()->Interprise->Id,
        'Sufix' => ''
      )
    );
    return filterparamname::Filter($Filter)->Count;
  }
  
  
  
  
  
  
  
  
  
  
  /*
    Кеш всех параметров к прибора
  */
  protected $CacheRealAllParameters = null;
  
  
  /*
    Создание кеша данных
    @return Bool
  */
  protected function SetCacheRealAllParameter(){
    $SQL = Utils::Strip("
      select 
        parameter.* 
      from meterparameter 
      left join parameter on parameter.id = meterparameter.parameter_id 
      where virtual_meter_id = {$this->Id}
    ");
    $t = parameter::Id(0);
    $this->CacheRealAllParameters = TListGroup::Prepare( $SQL , $t );
    return true;
  }
  
  



  /*
    Реальные параметры привязанные к виртуальному прибору учета
    @return TListGroup
  */
  function GetRealActiveParametersData(){
    if( $this->CacheRealAllParameters === null ){
      $this->SetCacheRealAllParameter();
    }
    return $this->CacheRealAllParameters;
  }
  
  
  
  
  
  
  
  
  
  
  
  protected $CacheRealMeters = null;
  
  
  /*
    Все приборы с которых этот прибор учета получает данные
    @return TListGroup
  */
  function GetRealMeters(){
    if( $this->CacheRealMeters !== null ){
      return $this->CacheRealMeters;
    }
    $SQL = Utils::Strip("
      select 
        meter.* 
      from meterparameter 
      left join meter on meter.id = meterparameter.meter_id 
      where virtual_meter_id = {$this->Id}
    ");
    $t = meter::Id(0);
    $this->CacheRealMeters = TListGroup::Prepare( $SQL , $t );
    return $this->CacheRealMeters;
  }
  
  
  
  
  
  
  
  /*
    МАссив с ссылками на meterparameter
  */
  protected $CacheMeterarameterData = null;
  
  

  /**
   * 
   * array(
   *   meter_id (int)
   *     parameter_id (int) => data pos CacheMeterarameterData (int)
   * )
   * 
   * Получение массива данных с указателями на ссылки
   * из таблицы meterparameter для того чтобы знать какой параметр к какому относится
   * 
   * @param meter $RealMeter
   * @param parameter $RealParameter
   * @return meterparameter
   */
  function MeterarameterData( meter $RealMeter , parameter $RealParameter ){
    if( $this->CacheMeterarameterData === null ){
      $Filter = array( 
        'Filter' => array( 
          'Virtualmeter' => $this->Id
        )
      );
      
      $this->CacheMeterarameterData = array();
      
      foreach( meterparameter::Filter($Filter)->Elements as $i => $iMP ){
        $this->CacheMeterarameterData[$iMP->Meter->Id ][ $iMP->Parameter->Id ] = $iMP;
      }
    }
    if( isset( $this->CacheMeterarameterData[ $RealMeter->Id ][ $RealParameter->Id ] ) ){
      return $this->CacheMeterarameterData[ $RealMeter->Id ][ $RealParameter->Id ];
    }
    return meterparameter::Id(0);
  }
  
  
  
  
  
  
  /*
    Кеш запрашиваемых данных
    @return Bool
  */
  protected $CacheArchive = null;
  
  
  
  /*
    Кеш ресурcа запрашиваемых данных
    @return Bool
  */
  protected $CacheArchiveSource = null;
  
  
  
  
  /**
   * Наполенение CacheArchive
   * 
   * @return boolean
   */
  protected function SetCacheArchive(){
    
    /*
     *TODO временно убрано
    if( $this->CacheTasks === null ){
      $this->SetCacheTasks();
    }
    */
    
    
    if( isset( $_GET['start'] ) ){
      
      DB::Select("DROP TABLE IF EXISTS mdh_date_range");
      
      $SQL = Utils::Strip("
        CREATE TEMPORARY TABLE mdh_date_range (
          year          INT,
          month         INT,
          day           INT,
          hour          INT,
          meter_id      INT,
          parameter_id  INT
        )
      ");
      
      DB::Select( $SQL );
      
      $SQL = Utils::Strip("INSERT INTO mdh_date_range ( year , month , day , hour , meter_id , parameter_id ) VALUES ");
      
      $SQLAR = array();
      
      $counter = 0;
      
      foreach( $this->DateList as $iDate ){
        foreach( $this->RealActiveParametersData->Elements as $iParameter ){
          foreach( $this->RealMeters->Elements as $iMeter ){
            $SQLAR[] = "(" . $iDate->format("Y,m,d") .",".($iDate->format("H")+1) . ",{$iMeter->Id},{$iParameter->Id})";
            $counter++;
            
            if( count( $SQLAR ) >= 300 ){
              $_SQL = $SQL . implode(",",$SQLAR);
              DB::Select( $_SQL );
              $SQLAR = array();
            }
          }
          
        }
      }
      
      if( $SQLAR ){
        $SQL .= implode(",",$SQLAR);
        
        DB::Select( $SQL );
      }
      
      $SQL = Utils::Strip("
        select meterdatahour.* from meterdatahour 
        left join mdh_date_range 
          on mdh_date_range.year = meterdatahour.year
          and mdh_date_range.month = meterdatahour.month
          and mdh_date_range.day = meterdatahour.day
          and mdh_date_range.hour = meterdatahour.hour
          and mdh_date_range.parameter_id = meterdatahour.parameter_id
          and mdh_date_range.meter_id = meterdatahour.meter_id
        where mdh_date_range.year = meterdatahour.year
          and mdh_date_range.month = meterdatahour.month
          and mdh_date_range.day = meterdatahour.day
          and mdh_date_range.hour = meterdatahour.hour
          and mdh_date_range.parameter_id = meterdatahour.parameter_id
          and mdh_date_range.meter_id = meterdatahour.meter_id
      ");
      
    }else{
    
      $Year   = 0;
      $Month  = 0;
      $Day    = 0;
      $Hour   = 0;
      
      if( isset( $_GET['year'] ) ){
        $Year = (int) $_GET['year'];
      }
      if( isset( $_GET['month'] ) ){
        $Month = (int) $_GET['month'];
      }
      if( isset( $_GET['day'] ) ){
        $Day = (int) $_GET['day'];
      }
      
      $DateNow = new DateTime('now');
      
      $is_this_month = $Month && $Year && $Month == (int) $DateNow->format('m') && $Year == (int) $DateNow->format('Y');
      
      switch( $this->IsGetRangeDate() ){
        case 'hour' :
        case 'now' :
          $Filter = array( 
            'Filter' => array( 
              'Year'        => (int) $this->Date->format('Y'),
              'Month'       => (int) $this->Date->format('m'),
              'Day'         => (int) $this->Date->format('d'),
              'Hour'        => range(1, 24)
            )
          );
        break;
        case 'day' :
          $Filter = array( 
            'Filter' => array( 
              'Year'        => (int) $this->Date->format('Y'),
              'Month'       => (int) $this->Date->format('m'),
              'Day'         => range(1, ( $is_this_month ? (int) $this->Date->format('d') : 31 )),
              'Hour'        => 0
            )
          );
        break;
        case 'month' :
          $Filter = array( 
            'Filter' => array( 
              'Year'        => (int) $this->Date->format('Y'),
              'Month'       => range(1, 12),
              'Day'         => 0,
              'Hour'        => 0
            )
          );
        break;
      }
      $Filter['Limit'] = count($this->RealActiveParametersData->Elements) * 1000;
      
      foreach( $this->RealActiveParametersData->Elements as $iParameter ){
        $Filter['Filter']['Parameter'][] = $iParameter->Id;
      }
      
      foreach( $this->RealMeters->Elements as $iMeter ){
        $Filter['Filter']['Meter'][] = $iMeter->Id;
      }
      
      
      $SQL = meterdatahour::Filter( $Filter )->Sql;
      
    }
    
    
    $this->CacheArchiveSource = DB::Select( $SQL );
    
    $i = 0;
    
    while( $Row = DB::Fetch( $this->CacheArchiveSource ) ){
      $oMeterparameter = $this->MeterarameterData( meter::Id($Row['meter_id']) , parameter::Id($Row['parameter_id']) );
      $this->CacheArchive[ $oMeterparameter->Parameter->Id ][$Row['month']][$Row['day']][$Row['hour']] = $i++;
    }
    
    if( !$i ) $this->CacheArchive = array();
    
    
    return true;
  }
  
  
  
  private $LastMDHArchive = null;
  
  
  
  
  
  /**
   * Получение из кеша данных данных по его ключу
   * 
   * @param meterparameter $oMeterparameter
   * @param DateTime $oDate
   * @return meterdatahour
   */
  function GetMDH( parameter $oParameter , DateTime $oDate ){

    if( $this->CacheArchive === null ){
      $this->SetCacheArchive();
    }

    if( $this->CacheMeterParameter === null ){
      $this->SetCacheMeterParameter();
    }

    if( $this->LastMDHArchive ){
      $this->LastMDHArchive->__destruct();
    }
    
    $Month  = $oDate->format('m');
    $Day    = $oDate->format('d');
    $Hour   = $oDate->format('H');
    
    
    switch( $this->IsGetRangeDate() ){
      case 'day' :
        $Hour = 0;
      break;
      case 'month' :
        $Hour = 0;
        $Day = 1;
      break;
      default :
        $Hour++;
      break;
    }

    if( isset( $this->CacheMeterParameter[$oParameter->Id] ) ){
      $oParameter = parameter::Id( $this->CacheMeterParameter[$oParameter->Id] );
    }
    
    if( isset( $this->CacheArchive[ $oParameter->Id ][ ceil($Month) ][ ceil($Day) ][ ceil($Hour) ] ) ){
      $position = $this->CacheArchive[ $oParameter->Id ][ ceil($Month) ][ ceil($Day) ][ ceil($Hour) ];
      
      DB::DataSeek($this->CacheArchiveSource , $position);
      
      $row = DB::Fetch($this->CacheArchiveSource);
      
      $this->LastMDHArchive = meterdatahour::SetFieldsFromObject( $row );
      
      return $this->LastMDHArchive;
      
    }
    return meterdatahour::Id(0);
  }
  
  
  
  public $CacheMeterParameter = null;


  function SetCacheMeterParameter(){
    $this->CacheMeterParameter = array();
    $Filter = array(
      'Filter' => array(
        'Virtualmeter' => $this->Id
      )
    );
    foreach( meterparameter::Filter($Filter)->Elements as $iMeterParameter ){
      $this->CacheMeterParameter[ $iMeterParameter->Virtualparameter->Id ] = $iMeterParameter->Parameter->Id;
    }
  }
  
  
  
  
  /*
    Список дат для архива
    @return Array
  */
  function GetDateList(){
    
    $MinDate = $this->MinDate();
    
    $ArrayTime = array();
    
    while( $MinDate->getTimestamp() <= $this->MaxDate()->getTimestamp() ){
      $ArrayTime[] = clone $MinDate;
      $MinDate->modify( $this->Mod );
    }
    
    return $ArrayTime;
  }
  
  
  
  
  
  
  
  
  
  
  
  /**
   * Получение минимальной даты для вывода данных
   * 
   * @return DateTime
   */
  function MinDate(){
    
    $Date = isset( $_GET['start'] )
            ? new DateTime( preg_replace('/^(\d{4})(\d{2})(\d{2})$/', "$1-$2-$3", $_GET['start']) )
            : clone $this->Date;
            
            
    $beforeTimezone = $this->Date->getTimezone()->getName();
    ini_set('date.timezone',$this->Date->getTimezone()->getName());
    
            
    switch( $this->IsGetRangeDate() ){
      case 'now' : 
        $Date->setTime(0,0,0);
      case 'hour' : 
        $Date->setTime(0,0,0);
      break;
      case 'day' : 
        $Date->modify('first day of this month');
      break;
      case 'month' : 
        $Date->setDate( $Date->format('Y') , 1 , $Date->format('d'));
      break;
      case 'range_day' : 
        $Date->setTime(0,0,0);
      break;
    }
    
    ini_set('date.timezone',$beforeTimezone);

    return $Date;
  }
  
  
  
  
  /**
   * Получение максимальной даты для вывода данных
   * 
   * @return DateTime
   */
  function MaxDate(){
    $Date = isset( $_GET['stop'] )
            ? new DateTime( preg_replace('/^(\d{4})(\d{2})(\d{2})$/', "$1-$2-$3", $_GET['stop']) )
            : clone $this->GetDate();
   
    $Month  = 0;
    $Year   = 0;
    
    if( isset( $_GET['year'] ) ){
      $Year = (int) $_GET['year'];
    }
    if( isset( $_GET['month'] ) ){
      $Month = (int) $_GET['month'];
    }
    $DateServer = new Datetime( 'now' );
    
    $is_this_month  = $Month && $Year && $Month == (int) $DateServer->format('m') && $Year == (int) $DateServer->format('Y');
    $is_this_year   = $Year && $Year == (int) $DateServer->format('Y');
    
    if( isset( $_GET['start'] ) ){
      $Date->modify("+1 day");
    }
    switch( $this->IsGetRangeDate() ){
      case 'now' : 
        $Date->setTime( $Date->format('H')-1 ,0,0);
      break;
      case 'hour' : 
        $Date->setTime(23,0,0);
      break;
      case 'day' :
        if( !$is_this_month ){
          $Date->modify('last day of this month');
        }
      break;
      case 'month' : 
        $Date->setDate( $Date->format('Y') , ( $is_this_year ? $Date->format('m') : 12 ) , $Date->format('d'));
      break;
      case 'range_day' : 
        $Date->setTime(0,0,0);
      break;
    }
    return $Date;
  }
  
  
  
  
  
  
  
  
  
  
  
  
  
  /*
    Какой тип данных от прибора хотят получить
    @return String
  */
  function IsGetRangeDate(){
    if( !isset( $_GET['year']   ) ) return "now" ;
    if( !isset( $_GET['month']  ) ) return "month" ;
    if( !isset( $_GET['day']    ) ) return "day";
    return 'hour';
  }
  
  
  
  
  
  
  /*
    Кеш всех параметров к прибора
  */
  protected $CacheAllParameters = null;
  
  
  /*
    Создание кеша данных
    @return Bool
  */
  protected function SetCacheAllParameter(){
    $SQL = Utils::Strip("
      select 
        parameter.* 
      from meterparameter 
      left join parameter on parameter.id = meterparameter.virtual_parameter_id 
      where virtual_meter_id = {$this->Id}
      order by meterparameter.id
    ");
    $t = parameter::Id(0);
    $this->CacheAllParameters = TListGroup::Prepare( $SQL , $t );
    return true;
  }
  
  
  
  
  
  
  
  /*
    Так как виртуальные приборы только получают данные с других приборов то своего коэф у них нет
    каждый коэф берется с оригиналоного прибора учета
    @return 1
  */
  function GetCoef(){
    return 1;
  }
  
  



  /*
    получение ВСЕХ параметров
    @return TListGroup
  */
  function GetAllParameters(){
    if( $this->CacheAllParameters === null ){
      $this->SetCacheAllParameter();
    }
    return $this->CacheAllParameters;
  }
  
  
  
  
  
  
  
  
  
  /*
    модификатор для даты
    @return String
  */
  function GetMod(){
    $mod = "+1 hour";
    switch( $this->IsGetRangeDate() ){
      case "day" :
       $mod = "+1 day"; 
      break;
      case "month" :
       $mod = "+1 month"; 
      break;
    }
    return $mod;
  }
  
  
  
  
  
  
  
  
  /*
    В каком формате выводить данные пользователю
    @return date_format
  */
  function GetFormat($Date){
    $format = "H:00";
    switch( $this->IsGetRangeDate() ){
      case "day" :
       $format = "d m"; 
      break;
      case "month" :
       $format = "Y-M"; 
      break;
    }
    return $format;
  }
  
  /*
    В каком формате выводить данные пользователю
    @return date_format
  */
  function GetFormatSmarty(){
    $format = "%custom_hour";
    switch( $this->IsGetRangeDate() ){
      case "range_day" :
      case "day" :
       $format = "%d %B"; 
      break;
      case "month" :
       $format = "%custom_month"; 
      break;
    }
    return $format;
  }
  
  
  
  
  
  
  /**
   * Получение иконки прибора учета
   * 
   * @return string
   */
  function GetIcon(){
    switch( $this->Meter_extra_type->Ident ){
      case "ElectricityCounter" :
        return "fa fa-flash";
        break;
      case "AquaCounter" :
        return "fa fa-tint";
        break;
      case "HeatCounter" :
        return "fa fa-thermometer-full";
        break;
    }
    return "fa fa-cloud";
  }
  
  
  
  
  
  /*
    Время на приборе учета
    @return Datetime
  */
  function GetDate(){
    
    $Date = clone Site()->GetServerTime();
    
    $TZ = $this->Timezone->Ident ? $this->Timezone->Ident : /*$Date->getTimeZone()->getName()*/ 'Asia/Yekaterinburg';

    $Date->setTimeZone( new DateTimeZone( $TZ ) );

    $Year   = isset( $_GET['year'] ) && $_GET['year'] 
                ? (int) $_GET['year'] 
                : $Date->format('Y') ;
                
    $Month  = isset( $_GET['month'] ) && $_GET['month']
                ? (int) $_GET['month'] 
                : $Date->format('m') ;
                
    $Day    = isset( $_GET['day'] ) && $_GET['day']
                ? (int) $_GET['day'] 
                : $Date->format('d') ;
    
    $Date->setDate( $Year , $Month , $Day );
    
    return $Date;
    
  }
  
  
  
  
  /*
    Формат вывода данных для пользователя
  */
  protected $DateFormat = "d-m-Y";
  
  
  /*
    Формат вывода даты для ссылки
  */
  protected $DateFormatLink = "Y/m/d/";
  
  
  
  
  /*
    Формирование ссылки назад во времени
    @return String
  */
  function GetPrevDateLink(){
    return $this->LinkArchive.$this->PrevDate->format( $this->DateFormatLink );
  }
  
  /*
    Получение предыдущей даты
    @return DateTime
  */
  function GetPrevDate(){
    $date = clone $this->Date;
    $date->modify('-1 day');
    return $date;
  }
  
  
  /*
    Получение удобно читаемой даты для пользователя
    @return String
  */
  function GetPrevDateTitle(){
    return $this->PrevDate->format( $this->DateFormat );
  }
  
  
  /*
    показ текущей даты на месте
    @return String
  */
  function GetDateLink(){
    return $this->Date->format( $this->DateFormat );
  }
  
  
  /*
    Формирование ссылки вперед во времени
    @return String
  */
  function GetNextDateLink(){
    return $this->LinkArchive.$this->NextDate->format( $this->DateFormatLink );
  }
  
  
  /*
    Получение удобно читаемой даты для пользователя
    @return String
  */
  function GetNextDateTitle(){
    return $this->NextDate->format( $this->DateFormat );
  }
  
  
  
  
  /*
    Получение следующей даты
    @return DateTime
  */
  function GetNextDate(){
    $date = clone $this->Date;
    $date->modify('+1 day');
    return $date;
  }
  
  
  
  
  
  
  
  /*
    Виртуальный ли прибор учета
    @return Bool
  */
  function GetIsVirtual(){
    return true;
  }
  
  

  /*
    Название прибора учета
    @return String
  */
  function GetTitle(){
    if( $this->About != "" ){         // Есть описание?
      return $this->About;
    }elseif( $this->NumSerial != "" ){// Есть серийный номер?
      return $this->NumSerial;
    }
    return "----";
  }
  
  
  
  /*
    ссылка на лог событий
    @return String
  */
  function GetLinkLog(){
    return "{$this->Link}log/";
  }
  
  
  
  /*
    ссылка на лог событий
    @return String
  */
  function GetLinkGraphs(){
    
    $sufix = isset( $_GET['start'] ) && isset( $_GET['stop'] )
             ? implode( "-" ,array( $_GET['start'] , $_GET['stop'] ))."/"
             : "";
    
    return "{$this->Link}graphs/" . $sufix;
  }
  
  
  
    
  /*
    Получение всех графиков прибора учета
    @return TListGroup
  */
  function GetGraphs(){
    $Filter = array(
      'Filter' => array(
        'Meter' => $this->Id,
        'Interprise' => Self()->Interprise->Id
      ),
      'Order' => array(
        'Number' => 'DESC'
      )
    );
    
    return graphics::Filter($Filter);
  }
  
  
  
  /*
    ссылка на лог событий
    @return String
  */
  function GetLinkStatuses(){
    return "{$this->Link}statuses/";
  }
  
  
  
  
  /*
    ссылка на лог событий
    @return String
  */
  function GetLinkExport(){
    
    $sufix = isset( $_GET['start'] ) && isset( $_GET['stop'] )
             ? implode( "-" ,array( $_GET['start'] , $_GET['stop'] ))."/"
             : "";
    
    return "{$this->Link}exports/".$sufix;
  }
  
  
  
  
  /*
    ссылка на лог событий
    @return String
  */
  function GetLinkParam(){
    return "{$this->Link}params/";
  }
  
  
  
  
  
  
  
  /*
    Ссылка на прибор учета
    @return String
  */
  function GetLink(){
    return "/vmeter/{$this->Id}/";
  }
  
  
  
  
  
  
  /*
    Удобное для пользователя выражение статуса прибора учета
    @return String
  */
  function GetIsOkTitle(){
    return $this->IsOk ? "Исправен" : "Есть проблемы";
  }
  
  


  function SetIsOk( $v = 0 ){
    $this->UpdateByArray(array(
      'IsOk' => $v
    ));
    $this->Converter->RewriteStatusMeterOk();
  }

  
  
  /*
    Статус прибора учета
    Если нет ссылок то статус будет плохой
    Если есть ссылки
      все плохие - статус будет плохой
      все хорошие - статус хороший
      часть плохих - статус плохой
    
    @return Int
  */
  function GetIsOk(){
    $SQL = Utils::Strip("
      select 
      if( Count(*) = 0 , 0 , 
        if( 
          Count(*) = COUNT(CASE WHEN meter.is_ok = 1 THEN 1 END) , 1 , 
            if( COUNT(CASE WHEN meter.is_ok = 1 THEN 1 END) = 0 , 0 , 0 )
        )
      ) as is_ok
      from meterparameter 
      left join meter 
        on meter.id = meterparameter.meter_id
      where meterparameter.virtual_meter_id = {$this->Id}
    ");
    
    list($is_ok) = DB::FetchArraySelect($SQL);
    return $is_ok;
  }



  /*
    Пересчитываем статус
  */
  function ReplaceIsOk(){

    $is_ok = true;

    $d = $this->GetDate();

    $Filter = array(
      'Filter' => array(
        'Virtualmeter' => $this->Id
      )
    );
    foreach( meterparameter::Filter( $Filter )->Elements as $IMP ){
      $Filter = array(
        'Filter' => array(
          'Meter'     => $IMP->Meter->Id,
          'Parameter' => $IMP->Parameter->Id,
          'Year'      => (int) $d->format("Y"),
          'Month'     => (int) $d->format("m"),
          'Day'       => (int) $d->format("d"),
          'Hour'      => (int) $d->format("H"),
        )
      );
      if( meterdatahour::Filter( $Filter )->Count == 0 ){
        $is_ok = false;
      }      
    }

    $this->UpdateByArray(array(
      'IsOk' => (int) $is_ok
    ));
    $this->Converter->RewriteStatusMeterOk();
  }
  
  
  
  /*
    Ссылка на просмотр архивов
    @return String
  */
  function GetLinkReports(){
    
    $sufix = isset( $_GET['start'] ) && isset( $_GET['stop'] )
             ? implode( "-" ,array( $_GET['start'] , $_GET['stop'] ))."/"
             : "";
    
    return $this->Link."reports/".$sufix;
  }
  
  
  
  
  
  
  /*
    Возвращает все виды экспортов для плейсов
    @return TListGroup
  */
  function GetReports(){
    
    $Filter = array( 
      'Filter' => array( 
        'Ident' => 'Meter'
      )
    );
    
    if( !objectrule::Filter( $Filter )->Count ){
      return TListGroup::Init();
    }
    
    $Filter = array(
      'Filter' => array(
        'Objectrule' => objectrule::Filter( $Filter )->First->Id,
        'Interprise' => array( 0 , Self()->Interprise->Id )
      )
    );
    
    return reports::Filter( $Filter );
  }
  
  
  
  
  
  
  
  /*
    Получение всех ссылок на параметры
    @return TListGroup
  */
  function GetMeterParameter(){
    $t          = new meterparameter();
    $parameter  = new parameter();
    $meter      = new meter();
    $sql = str_replace(array("\n","\t","\r"),"","SELECT 
      {$t::$SqlFields} 
    FROM {$t::$SqlTable},{$parameter::$SqlTable},{$meter::$SqlTable} 
    where {$meter::$SqlTable}.`id` = {$t::$SqlTable}.{$t::$FInit['Meter']['sql']} 
    AND {$parameter::$SqlTable}.`id` = {$t::$SqlTable}.{$t::$FInit['Parameter']['sql']} 
    AND {$t::$SqlTable}.{$t::$FInit['Virtualmeter']['sql']}={$this->Id}");
    return TListGroup::Prepare( $sql, $t );
  }
  
  
  
  /*
    Получение всех ссылок на параметры
    @return TListGroup
  */
  function GetMeterParameterData(){
    
    $t          = meterparameter::Id(0);
    
    $arParam = array();
    foreach( $this->GetActiveParametersData()->Elements as $iParameter ){
      $arParam[ $iParameter->Id ] = $iParameter->Id;
    }
    
    $sql = Utils::Strip("
      select *
      from meterparameter
      where meterparameter.virtual_meter_id = {$this->Id}
      /* and meterparameter.virtual_parameter_id in (" . implode(',',$arParam) .") */
      order by field( meterparameter.virtual_parameter_id," . implode(',',$arParam) ." )
    ");
    
    return TListGroup::Prepare( $sql, $t );
  }
  
  
  
  
  
  
  /*
    ссылка на удаление прибора учета
    @return String
  */
  function GetLinkDelete(){
    return "{$this->Link}delete/";
  }
  


  
  
  
  
  
  /*
    Весь лог событий
    @return TListGroup
  */
  function GetLog(){
    $Filter = array(
      'Filter' => array(
        'Object' => array( 'meter' , 'vmeter' ),
        'ObjectId' => $this->Id
      ),
      'Order' => array(
        'Its' => 'DESC'
      )
    );
    return userlog::Filter( $Filter );
  }
  
  /*
    Все события по конвертору
    @return TListGroup
  */
  function GetLogList(){
    return $this->Log->GroupBy( Site()->CountInPage )->Elements[ Site()->Page ];
  }
  
  
  
  /*
    Страницы лога
    @return Array
  */
  function GetLogPages(){
    return Utils::Paginator(
      $this->Log->Count,
      Site()->CountInPage
    );
  }
  



  /*
    Получение кол-ва знаков после запятой у виртуального прибора по его параметру
    @param parameter
    @return int
  */
  function GetRoundByParameter( $parameter ){
    $Filter = array(
      'Filter' => array(
        'Virtualmeter' => $this->Id,
        'Parameter' => $parameter->Id
      )
    );
    $MPF = meterparameter::Filter( $Filter );
      
    if ( $MPF->Count == 0 ){
      return 0;
    }

    return parameter::Id($MPF->First->Virtualparameter->Id)->Conversion->Round;
  }


  /*
    Получение делителя у виртуального прибора по его параметру
    @param parameter
    @return int
  */
  function GetDividerByParameter( $parameter ){
    $Filter = array(
      'Filter' => array(
        'Virtualmeter' => $this->Id,
        'Parameter' => $parameter->Id
      )
    );
    $MPF = meterparameter::Filter( $Filter );
      
    if ( $MPF->Count == 0 ){
      return 0;
    }

    return parameter::Id($MPF->First->Virtualparameter->Id)->Conversion->Divider;
  }

  function GetNumberPlomb(){

    $Filter = array( 
      'Filter' => array( 
        'VarName' => 'NumberPlomb',
        'Meter'   => $this->Id
      )
    );
    $res = metervariable::Filter($Filter);

    if( $res->Count ){
      return $res->First;
    }

    $t = new DateTime();
    
    return metervariable::AddByArray(array(
        'Data'    => "",
        'VarName' => 'NumberPlomb',
        'Meter'   => $this->Id,
        'AddTime' => $t->format("Y-m-d H:i:s")
    ));
  }


  function SetNumberPlomb( $value = "" ){
    $Filter = array( 
      'Filter' => array( 
        'VarName' => 'NumberPlomb',
        'Meter'   => $this->Id
      )
    );
    $res = metervariable::Filter($Filter);

    if( $res->Count ){
      return $res->First->UpdateByArray(array(
        'Data' => $value
      ));
    }

    $t = new DateTime();
    
    metervariable::AddByArray(array(
        'Data'    => $value,
        'VarName' => 'NumberPlomb',
        'Meter'   => $this->Id,
        'AddTime' => $t->format("Y-m-d H:i:s")
    ));
  }


  public function UpdateByArray($A){
    $A['IsOk'] = $this->IsOk;

    if( isset( $A['not_valid_json'] ) ){

      if( isset( $A['not_valid_json']['number_plomb'] ) ){
        $this->NumberPlomb = $A['not_valid_json']['number_plomb'];
      }

    }

    TObject2::StaticUpdateByArray($this,$A);
  }
  

}
