<?php

//die('service: disabled');

/*
contact email: esuzev@gmail.com
icq : 115635200
*/


if( !defined( '__INC_PHP__' ) ){

  ini_set('date.timezone','UTC');
  ini_set('mysql.connect_timeout', 5);

  if( !defined( '__PHPUNIT_PHAR__' ) ) {
  error_reporting( 0 );
}

$GLOBALS['Report']          = false;    // Не отчет
$GLOBALS['RedData']         = false;    // возможность включения красных данных
$GLOBALS['InputData']       = false;    // возможность запрашивать недостающие данные
$GLOBALS['IsNumberFormat']  = true;     // вывод данных красиво

function check_for_fatal_error()
{
    $error = error_get_last();
//    echo "[FATAL]";
//    var_dump($error);
    if ( $error["type"] == E_ERROR ){
        myErrorHandler( $error["type"], $error["message"], $error["file"], $error["line"] );
    }
}
register_shutdown_function( "check_for_fatal_error" );

if( !function_exists( 'mb_internal_encoding' ) ) {
	echo "NO mbstring module";
	exit;
}


if( !function_exists( 'session_set_save_handler' ) ) {
  echo "NO session module";
  exit;
}
//if( !function_exists( 'mysql_connect' ) ) {
//  echo "NO mysql module";
//  exit;
//}
//if( !function_exists( 'imagecreatetruecolor' ) ) {
//  echo "NO gd module";
//  exit;
//}

if( !function_exists( 'socket_create' ) ) {
  echo "NO sockets module";
  exit;
}

if( !function_exists( 'json_encode' ) ) {
  // for current query
  echo "NO json module";
  exit;
}



function hash_debug_pass( $pass ){
  return md5( $pass . md5("pass") . md5("debug") );
}

/**
 * Пароли доступа
 */
define("PASS_ROOT_DEBUG" , "debugdebug");
define("PASS_ADMIN_DEBUG" , "infoinfo");

if( isset( $_COOKIE['PASS_DEBUG'] )){
  switch( $_COOKIE['PASS_DEBUG'] ){
    case hash_debug_pass( PASS_ROOT_DEBUG ) :
        $GLOBALS['DEBUG'] = 1;
      break;
    case hash_debug_pass( PASS_ADMIN_DEBUG ) :
        $GLOBALS['DEBUG'] = 2;
      break;
  }
}





mb_internal_encoding("UTF-8");
setlocale(LC_TIME, 'ru_RU.UTF-8');
function getmicrotime(){
  list($usec, $sec) = explode(" ", microtime());
  return ((float)$usec + (float)$sec);
}

function ServerFilePath($file){
  return substr(realpath($file),strlen(realpath($_SERVER['DOCUMENT_ROOT'])));
}


spl_autoload_register( function ($class_name) {
  if( preg_match('/^(Smarty|PHPUnit|PHPExcel|job_(.*)|PHPExcel_Shared_XMLWrite|XMLWriter|SNMP)/',$class_name)>0 ){
    return;
  }

  if( preg_match('/Swift\_(.*)/' , $class_name) ){
    return;
  }
  
  $NameOk = preg_match('/([a-zA-Z0-9.])+/',$class_name)>0;
  $inc_path = dirname(__FILE__);
  $ClassFileName = $inc_path."/classes/".$class_name.'.class.php';
  
  if( $NameOk and is_file($ClassFileName) ){
    require($ClassFileName);
  }elseif( !preg_match('/custom$/',$class_name) and !preg_match('|^T|',$class_name) ){
    eval("class {$class_name} extends {$class_name}custom{}");
  }else{
    $e = new Exception();
    echo "<pre>";
    //var_dump($e);
    $arTrace = array_reverse($e->getTrace());
    foreach($arTrace as $trace){
      if( isset($trace['file'],$trace['line'])){
        $file = ServerFilePath($trace['file']);
        $params = '';
        if(isset(  $trace['args'] ) and count($trace['args'])){
          if( is_string($trace['args'][0]) ){
            $params = "'".implode("', '", $trace['args'])."'";
          }elseif( is_object($trace['args'][0]) ){
            $obj = array_shift( $trace['args'] );
            array_unshift($trace['args'], get_class($obj));
            $params = "'class_name!!!'";
          }
        }
        echo "{$file}:{$trace['line']}";
      }
      $t_class = isset($trace['class']) ? $trace['class'] : '';
      $t_type = isset($trace['type']) ? $trace['type'] : '';
      echo " -> {$t_class}{$t_type}{$trace['function']}({$params})";
      echo "\r\n";
    }
    echo "</pre>";
//    return false;
    Die("<br />Красс не найден: ".$class_name);
  }
  
});


/**
 * 
 * @return user
 */
function Self(){
  if( !isset($GLOBALS['Self']) ) $GLOBALS['Self'] = user::Id(0);
  return $GLOBALS['Self'];
}

/**
 * 
 * @return TSite
 */
function Site(){
  if( !isset($GLOBALS['Site']) ) $GLOBALS['Site'] = TSite::Init();
  return $GLOBALS['Site'];
}

// if(!isset($GLOBALS['nocache'])){
//  header("Content-type: text/html; charset=utf-8");
//  // always modified
//  header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
//  // HTTP/1.1
//  header("Cache-Control: no-store, no-cache, must-revalidate");
//  header("Cache-Control: post-check=0, pre-check=0", false);
//  // HTTP/1.0
//  header("Pragma: no-cache");
// }
function month_name ( $num )
{
  $num = intval($num);
  $A = Array(
    '1' => 'январь',
    'февраль',
    'март',
    'апрель',
    'май',
    'июнь',
    'июль',
    'август',
    'сентябрь',
    'октябрь',
    'ноябрь',
    'декабрь',
  );
  return isset($A[$num]) ? $A[$num] : "[$num]";
}

function smarty(){
  if( !isset($GLOBALS, $GLOBALS['smarty'])){
//    if (!class_exists('TSmarty')) die('No Smarty');
    $inc_path = dirname(__FILE__);
    
    define('SMARTY_DIR', $inc_path."/smarty/");
    
    define('ASSET_COMPILE_OUTPUT_DIR',$inc_path.'/../js/cache/');
    define('ASSET_COMPILE_URL_ROOT','/js/cache');

    require_once(SMARTY_DIR . 'SmartyBC.class.php');
    //~ $smarty = new Smarty();
    
    $GLOBALS['smarty'] = new SmartyBC();
    
    
    
    $GLOBALS['smarty']->template_dir = $inc_path.'/../templates/';
    if(is_dir($tc =  $inc_path.'/../templates_c/') and is_writeable($tc)){
      $GLOBALS['smarty']->compile_dir = $tc;
    }else die('Каталог не доступен для записи: '.ServerFilePath($tc));
    //~ $GLOBALS['smarty']->cache_dir = $inc_path.'/cache';
    //~ $GLOBALS['smarty']->cache_lifetime = 60*60;
    $GLOBALS['smarty']->assign('Site', Site());
    $GLOBALS['smarty']->assign('Self', Self());
    $GLOBALS['smarty']->assign('IsStatu', Self());
    
    $GLOBALS['smarty']->force_compile = 1;
    //~ $GLOBALS['smarty']->debugging = 1;
    $GLOBALS['smarty']->assign('PageTitle','');
    ini_set('display_errors','1');
    error_reporting( E_ALL );
    $GLOBALS['smarty']->config_dir = $_SERVER['DOCUMENT_ROOT'] ."/configs";
    $file_local = Self()->Lang."_lang.conf";
    if (file_exists($_SERVER['DOCUMENT_ROOT'] ."/configs" . "/" . $file_local)) {
        $GLOBALS['smarty']->ConfigLoad($file_local); //TODO проверить файл на сущ.
        $GLOBALS['smarty']->ConfigLoad($file_local, 'Parameters'); //TODO проверить файл на сущ.
        $GLOBALS['smarty']->ConfigLoad($file_local, 'PlaceType');
        $GLOBALS['smarty']->ConfigLoad($file_local, 'ConverterType');
        $GLOBALS['smarty']->ConfigLoad($file_local, 'MeterType');
        $GLOBALS['smarty']->ConfigLoad($file_local, 'Mark');
        $GLOBALS['smarty']->ConfigLoad($file_local, 'Model');
      }
    }
  return $GLOBALS['smarty'];
}







function formula_to_bt($params){
  
    
    $string_test = $params;
    
    $str = "";
    
    
    preg_match_all( '/(\+|\-|\/|\*)/' , $string_test , $znaks );
    
    
    preg_match_all( '/([a-z]*)\:([0-9]*)\:([0-9]*)/m' , $string_test , $m );
    
    $count = count( $m[0] );
    
    for( $i = 0 ; $i < $count ; $i++ ){
      $class  = $m[1][$i];
      $id     = $m[2][$i];
      $pid    = $m[3][$i];
      
      
      if( !isset( $znaks[1][$i] ) && $i + 1 != $count ) continue;
      
      $var = "oMeter";
      
      switch( $class ){
        case 'vconverter' : 
        case 'converter' : 
          $var = "oConverter";
        break;
        case 'vmeter' : 
          $var = "oMeter";
        break;
        case 'place' : 
          $var = "oPlace";
        break;
      }
      
      smarty()->assign($var , $class::Id($id));
      smarty()->assign( 'isset_object' , $class::Id($id)->Is );
      smarty()->assign( 'isset_parameter' , parameter::Id($pid)->Is );
      smarty()->assign('oParameter' , parameter::Id($pid));
      smarty()->assign('file' , $class .'/helpers/block_name.tpl');
      smarty()->assign('znak' ,
        isset( $znaks[1][$i] )
        ? $znaks[1][$i]
        : ""
      );
      smarty()->assign('block_formula' , $class.":".$id.":".$pid );
      
      smarty()->assign('add_btn' , 
        $count - 1 == $i
        ? smarty()->fetch('cmeter/formula/add_btn.tpl')
        : ''
       );
      $str .= smarty()->fetch( 'cmeter/formula/block_name_with_znak.tpl');
    }
    
    
    
    return $str;
}









function formula_to_bt_edit($params)
{
  
    
    $string_test = $params;
    
    
    $str = "";
    
    
    preg_match_all( '/(\+|\-|\/|\*)/' , $string_test , $znaks );
    
    
    preg_match_all( '/([a-z]*)\:([0-9]*)\:([0-9]*)/' , $string_test , $m );
    
    
    $count = count( $m[0] );
    
    $length_valid_blocks = 0;
    
    for( $i = 0 ; $i < $count ; $i++ ){
      $class  = $m[1][$i];
      $id     = $m[2][$i];
      $pid    = $m[3][$i];
      
      
      if( !isset( $znaks[1][$i] ) && $i + 1 != $count ) continue;
      
      $var = "oMeter";
      
      switch( $class ){
        case 'vconverter' : 
        case 'converter' : 
          $var = "oConverter";
        break;
        case 'vmeter' : 
          $var = "oMeter";
        break;
        case 'place' : 
          $var = "oPlace";
        break;
      }
      
      smarty()->assign($var , $class::Id($id));
      smarty()->assign( 'isset_object' , $class::Id($id)->Is );
      smarty()->assign( 'isset_parameter' , parameter::Id($pid)->Is );
      smarty()->assign('oParameter' , parameter::Id($pid));
      smarty()->assign('file' , $class .'/helpers/block_name.tpl');
      smarty()->assign('znak' ,
        isset( $znaks[1][$i] )
        ? $znaks[1][$i]
        : ""
      );
      smarty()->assign('block_formula' , $class.":".$id.":".$pid );
      
      $str .= smarty()->fetch( 'cmeter/formula/edit_block_name.tpl');
      
      $length_valid_blocks++;
      
    }
    
    
    
    smarty()->assign( 'isset_view_save' , $length_valid_blocks );
    $str .= smarty()->fetch( 'cmeter/formula/add_btn.tpl');
    $str .= smarty()->fetch( 'cmeter/formula/save_btn.tpl');
    
    
    return $str;
    
}






function formula_to_bt_empty($params)
{
  
    
    $string_test = $params;
    
    $str = "";
    
    
    preg_match_all( '/(\+|\-|\/|\*)/' , $string_test , $znaks );
    
    
    preg_match_all( '/([a-z]*)\:([0-9]*)\:([0-9]*)/m' , $string_test , $m );
    
    $count = count( $m[0] );
    
    for( $i = 0 ; $i < $count ; $i++ ){
      $class  = $m[1][$i];
      $id     = $m[2][$i];
      $pid    = $m[3][$i];
      
      
      if( !isset( $znaks[1][$i] ) && $i + 1 != $count ) continue;
      
      $var = "oMeter";
      
      switch( $class ){
        case 'vconverter' : 
        case 'converter' : 
          $var = "oConverter";
        break;
        case 'vmeter' : 
          $var = "oMeter";
        break;
        case 'place' : 
          $var = "oPlace";
        break;
      }
      
      if( !class_exists($class) ){
        smarty()->assign($var , user::Id($id));
        smarty()->assign( 'isset_object' , false );
      }else{
        smarty()->assign($var , $class::Id($id));
        smarty()->assign( 'isset_object' , $class::Id($id)->Is );
      }
      smarty()->assign( 'isset_parameter' , parameter::Id($pid)->Is );
      smarty()->assign('oParameter' , parameter::Id($pid));
      smarty()->assign('file' , $class .'/helpers/block_name.tpl');
      smarty()->assign('znak' ,
        isset( $znaks[1][$i] )
        ? $znaks[1][$i]
        : ""
      );
      smarty()->assign('block_formula' , $class.":".$id.":".$pid );
      
      smarty()->assign('add_btn' , 
        $count - 1 == $i
        ? smarty()->fetch('cmeter/formula/add_btn.tpl')
        : ''
       );
      $str .= smarty()->fetch( 'cmeter/formula/block_name.tpl');
    }
    
    
    
    return $str;
    
}









function function_init_main_engine()
{
  global $CONFIG;
  $inc_path = dirname(__FILE__).'/..';



  $GLOBALS['PageCreateStart'] = getmicrotime();
  try
  {
    if( !isset( $GLOBALS['CONFIG'] ) and !defined( '__PHPUNIT_PHAR__' ) ) {
      $cfg_file = false;
      if( isset( $_SERVER["HTTP_HOST"] ) and  $_SERVER["HTTP_HOST"]!='' )
      {
        $cfg_file = $inc_path."/include/config.".preg_replace( '/([^.\w])/', "", $_SERVER["HTTP_HOST"]).".inc.php";
      }
      if( $cfg_file and is_file($cfg_file) )
      {
        @require($cfg_file);
      }else{
        $cfg_file = $inc_path."/include/config.inc.php";
        if (is_file($cfg_file)) { @require($cfg_file); }else{
          header("Location: /install/config/");exit();
        };
      }
    }
  }
  catch(Exception $e)
  {
    if ( is_file(smarty()->template_dir.'fatalerror.tpl') ){
      $GLOBALS['smarty']->assign('ERROR', $e->getMessage());
      $GLOBALS['smarty']->display('fatalerror.tpl');
    }else echo $e->getMessage();
    die();
  }


  if( isset( $CONFIG['DEBUG'] ) and $CONFIG['DEBUG'] )
  {
    $GLOBALS['DEBUG'] = 1;
    ini_set('display_errors','1');
    error_reporting( E_ALL );
  }
  $DB = DB::Init();
  
   if( Site()->Config( 'IsRefererToAccount' , 0 ) ) session_set_cookie_params(0, '/', Site()->Config('domain_url' , '.nagruzka.net') ); 
  //TSession::Init();


   $GLOBALS['FullRules'] = true;
   @session_start();

   $Filter = array(
    'Filter' => array(
      'Sid' => session_id()
    )
   );



   $GLOBALS['Self'] = user::Id(0);


   if( user_session::Filter($Filter)->Count ){
    $GLOBALS['Self'] = user::Id( user_session::Filter($Filter)->First->User->Id );
    setcookie(session_name(), session_id(), time() + 3600, "/");
   }elseif( isset($_POST['login']) && isset($_POST['password'])){
    $Filter = array(
      'Filter' => array(
        'Login' => $_POST['login'],
        'Pass' => user::GenPass($_POST['password']),
        'Interprise >' => 0
      )
    );

    // $GLOBALS['FullRules'] = true;


    if( user::Filter($Filter)->Count ){
      $GLOBALS['Self'] = user::Filter($Filter)->First;
      $A = array(
          'UserId'    => $GLOBALS['Self']->Id,
          'Ipint'     => get_ip2long(),
          'Timestamp' => time(),
          'Sid'       => session_id(),
          'Url'       => get_url(),
          'Agent'     => get_agent()
        );
        user_session::AddByArray($A);
      setcookie(session_name(), session_id(), time() + 3600,"/"); 
    }
   }

    $GLOBALS['FullRules'] = false; 

   
  // if( isset( $_SERVER["REMOTE_ADDR"] ) ){
  //   session_set_save_handler(
  //     "user_session::open", 
  //     "user_session::close", 
  //     "user_session::read", 
  //     "user_session::write", 
  //     "user_session::destroy", 
  //     "user_session::gc"
  //   );
  //   try{
  //     session_start();
  //   }catch(Exception $e){
  //     smarty()->display('error/session.tpl');
  //   }
  // }


  $smarty = smarty();
  

  //if(Self()->IsTester); ini_set('display_errors','1');
  if( isset($_REQUEST['form']) and preg_match('|^([a-z]+)$|',$_REQUEST['form'])){
    if( is_file($inc_file = realpath($_SERVER['DOCUMENT_ROOT'])."/include/forms/form.{$_REQUEST['form']}.php")){
      include ( $inc_file );
    }
  }

  //if( isset( $_GET['autotest'] ) ) {
  if( isset($_SERVER["REQUEST_URI"]) and preg_match( '/autotest$/', $_SERVER["REQUEST_URI"] ) ) {
    include( $_SERVER['DOCUMENT_ROOT']."/include/autotest.php" );
    register_shutdown_function( 'GenerateAutoTestByUsedDataset' );
    $GLOBALS['AUTOTEST'] = true;
    ob_start();
  }
}

function get_agent(){
    if( isset( $_SERVER['HTTP_USER_AGENT'] ) ){
      return $_SERVER['HTTP_USER_AGENT'];
    }
    return "none";
  }


function get_url(){
    if( isset( $_SERVER['SERVER_NAME'] ) &&  isset( $_SERVER['REQUEST_URI'] ) ){
      return Utils::addslashes( "http://" . $_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI'] );
    }
    return "";
  }

function get_ip2long( $addr = '' ){
    $base_ip = '127.0.0.1';
    
    $ip = ip2long( isset( $_SERVER ) && !empty( $_SERVER['REMOTE_ADDR'] ) ? $_SERVER['REMOTE_ADDR'] : $base_ip );
  
    if( !$ip ){
      $ip = ip2long($base_ip);
    }
    return $ip;
  }

if( !defined( '__PHPUNIT_PHAR__' ) )
{
  function_init_main_engine();
  $smarty = smarty();
  
}

/* new uri */

if(isset($_SERVER['REQUEST_URI']))
{
  $uri = explode('/',$_SERVER['REQUEST_URI']);
  smarty()->assign('Activemenu',$uri[1]);
}

  define( '__INC_PHP__', 1 );
}



if(isset($_GET['hash']))
{
  $Filter = array(
    'Filter' => array(
      'Hash' => $_GET['hash']
    )
  );
  $GLOBALS['Self'] = hashaccess::Filter($Filter)->First->User;
}

$UriException = array(
  '/back/',
  '/',
  '/?logout',
);


# Для AJAX запросов если пользователь не определен
if(isset($GLOBALS['NotAddToFile']) && !Self()->IsUser && !Self()->FullRules ){
  echo smarty()->get_config_vars("NAT404");
  die();
}

register_shutdown_function( function(){
  DB::Log('END:'. __LINE__ );
  if( isset( $GLOBALS['DEBUG'] ) && $GLOBALS['DEBUG'] ){
    echo DB::Status(); 
  }
} );

if( Self()->Is && Site()->GetRedirectUrl() !== false ){
  header("Location: " . Site()->GetRedirectUrl() );
  exit();
} 


  if ($Self->Lang != "") {
  $lang = $Self->Lang;
} else {
  $lang = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);
  user::SetUserLang($lang);
}
$smarty->assign('user_lang', $lang);

// if( !defined( '__PHPUNIT_PHAR__' ) ){
//   if( Site()->IsMultiPrefixUrl() ){
//     setcookie('PHPSESSID', session_id(), time() + 3600, '/', ".".Site()->Config('main.domain')); 
//   }
// }
