# Используемые файлы куки
# 
# convertrers_in_page - Кол-во конвертеров на странице
# convertrer_page - Текущая страница просмотра
# convertrer_sort_field - По какому полю идет сортировка
# convertrer_sort_ad - в какую сторону идет сортировка
#    asc - нарастание
#    desc - убывание

converter_cookie_path = window.location.pathname

# Резервирование куки если их нет
if !$.cookie('convertrer_sort_ad')
  $.cookie('convertrer_sort_ad' , "asc", { path: converter_cookie_path })
  
if !$.cookie('convertrer_sort_field')
  $.cookie('convertrer_sort_field' , null, { path: converter_cookie_path })
  
if !$.cookie('convertrer_page')
  $.cookie('convertrer_page' , 1, { path: converter_cookie_path })
  
if !$.cookie('convertrers_in_page')
  $.cookie('convertrers_in_page' , 10, { path: converter_cookie_path })
  





CONVERTERS = Backbone.Collection.extend
  model       : CONVERTER
  url         : "/api/converter/"
  sort_field  : $.cookie('convertrer_sort_field') # по какому полю отсортировно
  sort_ad     : $.cookie('convertrer_sort_ad')    # в какую сторону отсортировкано asc | desc


  # Общий сеттер выставления сортировки
  __set_sort : ()->
    $.cookie('convertrer_sort_ad'     , @.sort_ad     , { path: converter_cookie_path })
    $.cookie('convertrer_sort_field'  , @.sort_field  , { path: converter_cookie_path })
  
  
  
  # Общий сеттер для выставления страницы
  __set_page : ( page )->
    $.cookie('convertrer_page' , page , { path: converter_cookie_path })

  
  # Формирование списка страниц
  _pages : ()->
    return [] if !Number $.cookie('convertrers_in_page')
    return _.range(@.length / $.cookie('convertrers_in_page'))
    
  # Формируем кол-во в пределах которых можно ходить
  _counters : ()->
    res = []
    if @.length > 10  then res.push 10
    if @.length > 50  then res.push 100
    if @.length > 100 then res.push 500
    if @.length > 500 then res.push 1000
    res.push 0
    res
  
  
  # Какое кол-во показана на странице у коллекции
  __get_count : ()->
    $.cookie('convertrers_in_page')

  # Адаптация под запрос на сервер
  __get_count_ajax : ()->
    return 0 if $.cookie('convertrers_in_page') == "Infinity"
    return @.__get_count()

  __get_page : ()->
    if typeof $.cookie('convertrer_page') == "undefined" || !Number $.cookie('convertrer_page') then 1 else Number $.cookie('convertrer_page')
  
  # Установка показа кол-ва у коллекции
  __set_count : ( count )->
    $.cookie('convertrers_in_page' , count , { path: converter_cookie_path })
  
  # Сначала сортировка потом показ по страницам
  __sort_and_pages : ()->
    return @.toArray()

    # Закрываем так как эта сортировка очень медленная и надо делать через сервер
    return @.__sort() if !Number $.cookie('convertrers_in_page')
    
    @.__sort().reduce((res,item,index)->

      # Найдем первый индекс
      first_index = $.cookie('convertrers_in_page') * ( $.cookie('convertrer_page') - 1 )
      # Найдем последний индекс
      last_index = ( $.cookie('convertrers_in_page') * $.cookie('convertrer_page') - 1)
      
      if index >= first_index && index <= last_index
        res.push item
      res
    ,[])
  
  
  
  # Сортировка по полю
  __sort : ()->
  
    # Здесь обрабатываются различные вариации со страницами которые могут возникнуть
    if Number $.cookie('convertrer_page') > @._pages().length || !Number $.cookie('convertrer_page')
      count = if !@._pages().length then 1 else @._pages().length
      $.cookie('convertrer_page' , count  , { path: converter_cookie_path } )
      
  
    res = []
    if @.sort_field == "type"
      res = []
      res_group = _.groupBy( @.toArray() , (item)->
        return item.get('type')
      ) 
      res_group_a = Object.keys( res_group )
      if @.sort_ad == "desc"
        res_group_a = res_group_a.reverse()
      res_group_a.map((key)->
        res = res.concat( res_group[ key ] )
      )
      res
    else
      res = _.sortBy( @.toArray() , @.sort_field )
      return res.reverse() if @.sort_ad == "desc"
    res
