
/*
  Класс для добавления удаления у блока. 
  Блокирует блок на пользовательские действия.
*/
const DIS_DIV = "disable_div_mini"


$( document ).ajaxError(function(a,b,c) {
  switch( b.status ){
    case 401 : dialog401(); break;
  }
});

$.fn.dialogWarning = function(s){
  
  var s = s || {}
  
  s.modal = true
  s.closeText = ''
  s.draggable = false
  s.resizable = false
  s.classes = {
      'ui-dialog' : 'panel panel-warning',
      'ui-dialog-titlebar' : 'panel-heading',
      'ui-dialog-titlebar-close' : 'btn btn-default'
  }
  s.close = function(){
      $(this).dialog('destroy')
    }
  
  s.position = {my: "center", at: "center", of: window, collision: "fit"}
  
  return $(this).dialog(s)
}


$.fn.dialogYesNo = function(s){
  var s = s || {}
  
  s.modal = true
  s.closeText = ''
  s.draggable = false
  s.resizable = false
  s.width ='auto'
  s.classes = {
      'ui-dialog' : 'panel panel-primary',
      'ui-dialog-titlebar' : 'panel-heading',
      'ui-dialog-titlebar-close' : 'btn btn-default'
  }
  
  if( typeof s.close == 'undefined' ){
    s.close = function( event, ui ) {
        $(this).dialog('destroy')
    }
  }

  
  s.buttons = [{
   text : 'Отменить',
   click : function(){
     if(typeof s.isFalse != 'undefined') s.isFalse(this)
     else $(this).dialog('destroy')
   },
   class : 'btn btn-default' 
  },{
  text : 'Продолжить',
   click : function(){
     if(typeof s.isOk != 'undefined') s.isOk(this)
     else $(this).dialog('destroy')
   },
   class : 'btn btn-success'
  }]
  
  if( typeof s.addButtons != 'undefined' ){
    s.buttons = s.buttons.concat(s.addButtons)
  }
  
  return $(this).dialog(s)
}



$.fn.serializeObject = function(){
    var o = {};
    var a = this.serializeArray();
    $.each(a, function() {
        if (o[this.name] !== undefined) {
            if (!o[this.name].push) {
                o[this.name] = [o[this.name]];
            }
            o[this.name].push(this.value || '');
        } else {
            o[this.name] = this.value || '';
        }
    });
    return o;
};


$.fn.waitNag = function(){
  
  var div = $('<div/>').uniqueId().addClass('loadNag')
  
  $(this).append(
    div
  ).attr({
    'data-waitNag' : $(div).attr('id')
  })
}

$.fn.stopNag = function(){
  var id = $(this).attr('data-waitNag')
  $(this).removeAttr('data-waitNag')
  $('#' + id).remove()
}


/*
  Получение параметров из адресной строки
  @return Any
*/
function getParameterByName(name, url) {
    if (!url) {
      url = window.location.href;
    }
    name = name.replace(/[\[\]]/g, "\\$&");
    var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
        results = regex.exec(url);
    if (!results) return null;
    if (!results[2]) return '';
    return decodeURIComponent(results[2].replace(/\+/g, " "));
}



/*
  Обработчик ошибок от сервера
*/
function error_handler(a,b,c){
  switch( b.status ){
    case 401 : dialog401(); break;
  }
}


/*
  Диалог для авторизации
*/
function dialog401(){
  $('<div/>').append(
    'Пожалуйста, обновите страницу и авторизуйтесь.'
  ).dialogWarning({
    title : "Вы не авторизованы."
  })
}


/*
  Диалог потери соединения
*/
function dialog0(){
  $('<div/>').append(
    'Возможно у вас нет доступа в интернет. Попрпобуйте позже.'
  ).dialogWarning({
    title : "Ошибка доступа"
  })
}





 $(document).on({
    'shown.bs.modal': function() {
      var zIndex = 1040 + (10 * $('.modal:visible').length);
      $(this).css('z-index', zIndex);
      setTimeout(function() {
        $('.modal-backdrop').not('.modal-stack').css('z-index', zIndex - 1).addClass('modal-stack');
      }, 0);
    },
    'hidden.bs.modal': function() {
      if ($('.modal:visible').length > 0) {
        // restore the modal-open class to the body element, so that scrolling works
        // properly after de-stacking a modal.
        setTimeout(function() {
          $(document.body).addClass('modal-open');
        }, 0);
      }
    },
    'show.bs.modal' : function(){
      $('.modal .modal-body').css('overflow-y', 'auto'); 
    //~ $('.modal .modal-body').css('max-height', $(window).height() * 0.9);
    }
  }, '.modal');
  
$('.modal').on('hidden.bs.modal', function () {
    $(this).data('bs.modal', null);
})