const PREFIX_METER_TREE = "meter_tree_"

require([
	"backbone",
	"jstree",
	"filters",
  "parameters",
  "meters",
  "meter_types",
  "meterparameters",
  "tmpl"
],function(
	Backbone,
	_,
	filters,
  parameters,
  meters,
  meter_types,
  meterparameters,
  tmpl
) {
  
  
  
  
  /*
    Таблица со списком доступных фильтров
  */
  var ListFilter = Backbone.View.extend({
    el : '#listen_filter',
    collection : filters,
    initialize : function(){
      this.listenTo( this.collection , 'sync' , this.render )
      this.listenTo( this.collection , 'delete remove' , this.render )
    },
    template : '#filter_panel_tpl',
    events : {
      'click .drop_filter' : function( e ){
        var id = $(e.target).closest('tr').attr('id').replace('filter_id_' , '')
        this.collection.find({id : Number(id)}).destroy()
        $(e.target).closest('tr').fadeOut()
      },
      
      'click .change_filter' : function( t ){
        $(t.target).closest('table').find('.success').removeClass('success')
        $(t.target).closest('tr').addClass('success')
      },
    },
    render : function(){
      $(this.$el).empty().append(
        $(this.template).tmpl({
          filters : this.collection.toArray()
        })
      )
    }
  })
  new ListFilter()
  
  
  
  
  
  /*
    Список параметров
  */
  var ListParameters = Backbone.View.extend({
    collection : parameters,
    initialize : function( el ){
      this.$el = el
      this.listenTo( this.collection , 'sync' , this.render )
    },
    template : '#parameters_tpl',
    render : function(){
      $(this.$el).empty().append(
        $(this.template).tmpl({
          parameters : this.collection.toArray()
        })
      )
    }
  })
  
  
  
  
  
  
  
  
  
  /*
    Форма для добавления новых фильтров
  */
	var a = Backbone.View.extend({
		el : '.nav-pills',
		events : {
      
			'click #add_filter' : function() {
        
        
        $('<div/>').append(
          $('#modal_filter_add_tpl').tmpl()
				).dialogYesNo({
					title : 'Добавление фильтра',
          isOk : function(t){
            
            if( $('#name_new_filter').val() == "" ){
              $('#name_new_filter').focus();
              $('<div/>').append(
                'Вы не указали название'
              ).dialogWarning({
                title : "Ошибка"
              })
              return false;
            }
            
            if( !$('#modal_filter_tree').jstree(true).get_selected().length ){
              $('<div/>').append(
                'Вы не выбрали ни одного прибора'
              ).dialogWarning({
                title : "Ошибка"
              })
              return false;
            }
            
            
            var select = $(t).find('.jstree').jstree(true).get_selected().shift()  
            
            var id = select.replace( PREFIX_METER_TREE ,'')
            
            var name = $(t).find('input').val()
            
            $(t).dialog('destroy')
            
            
            var div = $('<div/>')
            
            $(div).dialogYesNo({
              title : "Выбор параметра",
              isOk : function(t){
                
                
                if( !$(t).find('.form-control').find(':selected').length ){
                  $('<div/>').append(
                    'Вы не выбрали ни одного прибора'
                  ).dialogWarning({
                    title : "Ошибка"
                  })
                  return false;
                }
                
                
                meter_types.fetch({
                  success : function(m_types){
                    var filter = m_types.where({dllid:"FILTER"}).shift()
                    if( filter ){
                      
                      Backbone.collection_meters.add({
                        about : name,
                        type : filter.get('id')
                      })
                      
                      Backbone.collection_meters.last().save(null,{
                        success : function( _meter ){
                          var _id = _meter.get('id')
                          
                          $(t).find('select').find('option:selected').each(function(i,option){
                            meterparameters.add({
                              meter           : _id,
                              parameter       : $(option).val(),
                              virtmeter       : id,
                              virtparameter   : $(option).val()
                            })
                            meterparameters.last().save()
                          })
                          
                          $(t).dialog('destroy')
                          filters.fetch()
                          
                        }
                      })
                      
                    }else{
                      // TODO
                    }
                  }
                })
               
                //~ Backbone.collection_meters.find({id : 10}).save()
                
              }
            })
            
            new ListParameters( $(div) )
            
            parameters.fetch({
              data : {
                meter : id
              }
            })
            
            
          }
				}).attr({
          id : "append_filter_dialog"
        })
        
        
        $('#modal_filter_tree').jstree({
						core : {
							data : {
								url : function(node){
                  if( node.id == '#' ){
                    return "/api/?object=converter&tree"
                  }else{
                    return "/api/?object=meter&tree&filter=converter:" + node.id.replace("converter_tree_",'');
                  }
                },
							},
							'themes': {
		                        'name': 'proton',
		                        'responsive': true,
              },
              'check_callback' : function(operation, node, node_parent, node_position, more){
                  return true;
              },
						},
            "checkbox": {
                "three_state": false
            },
						plugins : ["ui","checkbox"]
					}).bind('loaded.jstree' ,function(){
            $('#append_filter_dialog').dialog('option','position',{my: "top", at: "top", of: window, collision: "fit"})
          }).bind('load_node.jstree',function(a,b){
            b.node.children.map(function(id){
              if( id.match(/^converter_tree_([0-9]*)$/) ){
                $('#'+id).children().find(' > .jstree-checkbox').remove()
              }
            })
          }).bind('open_node.jstree',function(a,b){
            var  id = b.node.id
            if( id.match(/^converter_tree_([0-9]*)$/) ){
              $('#'+id).children().find(' > .jstree-checkbox').remove()
            }
          }).bind('changed.jstree' , function(a,b){
            
            var b = b
            
            b.selected.map(function(id,i){
              if( i == b.selected.length -1  ){
                
                var id = id
                
                parameters.fetch({
                  data : {
                    meter : id.replace( PREFIX_METER_TREE ,'')
                  },
                  success : function(c){
                    if(!c.length){
                      b.instance.deselect_node(id)
                      b.instance.disable_node(id)
                      $('<div/>').append(
                        'Нет ни одного параметра'
                      ).dialogWarning({
                        title : "Внимание",
                        buttons : [{
                          class : "btn btn-warning",
                          text : "Закрыть",
                          click : function(){
                            $(this).dialog('destroy')
                          }
                        }]
                      })
                    }
                  }
                })
                
                
                return false;
              }
              b.instance.deselect_node(id)
            })
          })
          
			},
      'click #delete_filter' : function(){
        $(selectView.$el).find(':selected').each(function(i,op){
          filters.add({id : Number( $(op).val() )})
          var model = filters.find({id : Number( $(op).val() )}).destroy()
        })
      }
		},
		initialize : function() {
			this.render()
		},
		render : function() {

		}

	})

	new a()
  
  filters.fetch()
  
  
  
  $('#send_filter').on('click',function(){
    if( !$('#listen_filter').find('tr.success').length ){
      $('<div/>').dialogWarning({
        title : "Ошибка",
        
      }).append(
        'Вы не выбрали фильтр.'
      )
    }
  })

})