/**
 * Запущен ли таймер
 * 
 * @type Boolean
 */
window.timer_is_running = false;



/**
 * Сколько секунд идет обработка запроса
 * 
 * @type Number
 */
window.runing_time = 0;



/**
 * Хранит в себе ссылку на интервал
 * 
 * @type Function
 */

window.force_data = {

    stop: function() {
        $('.close').empty().append("x");
        $('#CurData').removeClass(DIS_DIV)
        $('#force_data_modal').find('.progress').remove()
    },

    end: function() {
        this.stop();
    },

    timer: function(time) {
        $('.close').empty().append(time);
    },

    progress: function(progress) {
        $('.modal-header').find('.progress-bar').text(progress + "%").css("width", progress + "%")
    },


    values: function(param, value, status, param_name) {

        var tpl = _.template($('#force_data_value_tpl').html())

        $('#CurData').find('tbody').append(
            tpl({
                row: {
                    param: param || "",
                    value: value || "",
                    status: status || "",
                    param_name: param_name || "",
                }
            })
        )

    },

    getBtnRepeat: function() {
        if ($('.btn.btn-default').prev().text() === 'Попробовать еще раз') {
            return false;
        }
        $('.btn.btn-default').before(
            $('<button/>').addClass('btn btn-info').text('Попробовать еще раз').on('click', function() {
                $('#force_data_modal').modal('hide');
                $('#force_data').trigger('click');
            })
        );
    },


    not_lib: function() {
        $('#CurData').removeClass(DIS_DIV)
        var tpl = _.template($('#not_lib_tpl').html());
        force_data.getBtnRepeat();
        $('#CurData').find('tbody').append(tpl());
        window.force_data.stop();
    },



    please_wait: function() {
        $('#CurData').removeClass(DIS_DIV)
        var tpl = _.template($('#please_wait_tpl').html());
        force_data.getBtnRepeat();
        $('#CurData').find('tbody').append(tpl());
        window.force_data.stop();
    },



    values_not_success: function() {
        $('#CurData').removeClass(DIS_DIV)
        var tpl = _.template($('#force_data_values_not_success_tpl').html())
        force_data.getBtnRepeat();
        $('#CurData').find('tbody').append(tpl())
        window.force_data.stop();
    },


    app_undefined: function() {
        force_data.values("ERROR", "Приложение не запущено", "", "")
        window.force_data.stop();
    },

    start: function() {
        $('.modal-header').find('.progress').css({
            'font-size': '13px',
            'text-align': 'center'
        })
        $('.modal-header').find('.progress').text("Передали приложению запрос.")
    },

    add_to_scenario: function() {
        $('.modal-header').find('.progress').text("Добавлено в список заданий. Ожидаем...")
    },

    connect: function() {
        $('.modal-header').find('.progress').text("")
        $('.modal-header').find('.progress').append('<div class="progress-bar" style="width:0%">0%</div>')
    },

    app_refused: function() {
        force_data.values("END", "Соединение было закрыто", "", "")
        window.force_data.stop();
    },

    error: function(err) {
        switch( err ){
            case "DIAL_TCP":
                force_data.values("ERROR", "Адрес не доступен", "", "")
                break;
            case "TIMEOUT_RESPONSE":
                force_data.values("ERROR", "Слишком долгое ожидание.", "", "")
                break;
            default :
                force_data.values("ERROR", err, "", "")
                break;
        }
        window.force_data.stop();
    },

    // ??
    error_answer: function() {

    },




    error_send: function() {
        $('#CurData').removeClass(DIS_DIV)
        var tpl = _.template($('#force_data_error_send_tpl').html());
        force_data.getBtnRepeat();
        $('#CurData').find('tbody').append(tpl());
        window.force_data.stop();
    },




    get_result: function(st) {
        $('#CurData').removeClass(DIS_DIV)
        switch (st) {
            case "-1":
                //~ OK  
                break;
            default:
                var tpl = _.template($('#force_data_get_result_tpl').html())
                $('#CurData').find('tbody').append(tpl({ result: result }))
                break;
        }
    }
}