if( !DIS_DIV || typeof DIS_DIV !== 'string' ){
  var DIS_DIV = "DIS_DIV_DEF";
}



/**
 * Проверка того что при завершении скрипта он будет завершать итерацию
 */
QUnit.test( "Проверка на остановку таймера", function( assert ) {

	var done = assert.async();

	$(document).ready(function(){
		setTimeout(function(){

			force_data.timer_run();

			force_data.stop();

			assert.equal( $('.close').text().trim() , "x" ,"Passed!" );
			assert.equal( $('.btn.btn-default').length , 1 ,"Passed!" );

			done();
		});
	});
});




QUnit.test( "Проверка на ошибку - идет опрос", function( assert ) {

	var done = assert.async();

	$(document).ready(function(){
		setTimeout(function(){

			force_data.timer_run();
			force_data.please_wait();

			assert.equal( $('.close').text().trim() , "x" ,"Passed!" );
			assert.equal( $('.btn.btn-default').length , 1 ,"Passed!" );

			done();
		});
	});
});



QUnit.test( "Проверка на ошибку - нет бибилиотеки", function( assert ) {

	var done = assert.async();

	$(document).ready(function(){
		setTimeout(function(){

			force_data.timer_run();
			force_data.not_lib();

			assert.equal( $('.close').text().trim() , "x" ,"Passed!" );
			assert.equal( $('.btn.btn-default').length , 1 ,"Passed!" );

			done();
		});
	});
});




QUnit.test( "проверка на ошибку - нет данных", function( assert ) {

	var done = assert.async();

	$(document).ready(function(){
		setTimeout(function(){

			force_data.timer_run();
			force_data.values_not_success();

			assert.equal( $('.close').text().trim() , "x" ,"Passed!" );
			assert.equal( $('.btn.btn-default').length , 1 ,"Passed!" );

			done();
		});
	});
});


QUnit.test( "проверка на ошибку - не был отправлен азапрос", function( assert ) {

	var done = assert.async();

	$(document).ready(function(){
		setTimeout(function(){

			force_data.timer_run();
			force_data.error_send();

			assert.equal( $('.close').text().trim() , "x" ,"Passed!" );
			assert.equal( $('.btn.btn-default').length , 1 ,"Passed!" );

			done();
		});
	});
});






QUnit.test( "проверка на ошибку - был получен мусор", function( assert ) {

	var done = assert.async();

	$(document).ready(function(){
		setTimeout(function(){

			force_data.timer_run();
			force_data.answer = false;
			force_data.error_answer();

			assert.equal( $('.close').text().trim() , "x" ,"Passed!" );
			assert.equal( $('.btn.btn-default').length , 1 ,"Passed!" );

			done();
		});
	});
});








QUnit.test( "проверка на валидные данные", function( assert ) {

	var done = assert.async();

	$(document).ready(function(){
		setTimeout(function(){

			var tpl = _.template( $('#force_data_success_tpl').html() )
			$('#force_data_modal').find('.modal-body').empty().append( tpl() )

			force_data.timer_run();

			force_data.values("OK","OK!@","DKFKDFD","sdsd");

			force_data.values("OK","OK!@","DKFKDFD");
			force_data.values("OK","OK!@");
			force_data.values("OK");

			force_data.stop();

			assert.equal( $('.close').text().trim() , "x" ,"Passed!" );
			assert.equal( $('.btn.btn-default').length , 1 ,"Passed!" );
			assert.equal( $('#CurData').find('tbody').find('tr').length , 4 ,"Passed!" );

			var eq = [
				["OK" , "OK!@" 	, "DKFKDFD" ],
				["OK" , "OK!@" 	, "DKFKDFD"	],
				["OK" , "OK!@" 	, ""		],
				["OK" , "" 		, ""		],
			];

			$('#CurData').find('tbody').find('tr').each(function( i , tr ){

				assert.equal( $(tr).find('td').eq(0).text().trim() , eq[i][0] ,"Passed! 0" );
				assert.equal( $(tr).find('td').eq(1).text().trim() , eq[i][1] ,"Passed! 1" );
				assert.equal( $(tr).find('td').eq(2).text().trim() , eq[i][2] , "Passed! 2" );
				assert.equal( $(tr).find('td').eq(3).text().trim() , "" , "Passed! 3" );
			})

			done();
		});
	});
});