CONVERTER = Backbone.Model.extend
  
  get_error_valid : ()->
    switch this.validate()
      when "EMPTY_TYPE"   then return "Не выбран тип прибора" 
      when "EMPTY_IP"     then return "Не указан ip адрес" 
      when "EMPTY_PORT"   then return "Не указан порт" 
      when "INVALID_PORT" then return "Не верно указан порт" 
      when "RANGE_PORT"   then return "Порт должень быть от 0 до 65535" 
      when "INVALID_IP"   then return "Не верный формат ip адреса" 
      
  url : ()->
    id = if @.get('id') then @.get('id') else 0
    "/api/converter/" + id + "/"


  defaults : 
    id              : null
    about           : null
    title           : null
    port            : 50
    login           : null
    pass            : "public"
    timeoutconnect  : 5000  # Время ожидания установки соединения
    timeoutreceive  : 3000  # Время ожидания ответа от прибора
    portcontrol     : 80    # Порт для Web интерфейса
    ip              : null
    type            : null
    meters_all      : null  # Кол-во всех приборов учета на конвертере
    meters_err      : null  # Кол-во плохих приборов учета на конвертере
    meters_exc      : null  # Кол-во исключеннныйх приборов учета на конвертере
    excluded        : false # исключен или нет из опроса. По умолчанию не исключен
    
  
  # Флаг того что название пустое. Если пустое то работает метод __set_about
  empty_about : true
  
  # Выставление названия если не было выставлено еще своего названия
  __set_about : ( attrs = {} )->
    return false if !@.empty_about
    ip = if @.get('ip') == null then "" else @.get('ip')
    @.set( "about" : ip + ":" + @.get("port") , attrs )
    true

  parse : (a)->
    @.empty_about = a.about == ""
    return a
    
    
  validate : ()->
    return "EMPTY_TYPE"   if !@.get("type")         # Если пустой тип
    return "EMPTY_IP"     if !@.get("ip")           # Если пустой адрес
    return "EMPTY_PORT"   if !@.get("port")         # Если пустой порт
    return "INVALID_PORT" if isNaN @.get("port")    # Если порт это не число
    return "RANGE_PORT"   if @.get('port') > 65535  # Если порт больше допустимого
    return "RANGE_PORT"   if @.get('port') < 1      # Если порт меньше допустимого
    
    # валидация адреса
    return "INVALID_IP"   if @.get("ip").split(".").length != 4
    
    valid_ip = @.get("ip").split(".").reduce( (res,block)->
      if res
        res = Number( block ) >= 0 && Number(block) < 256
      if !block
        res = false
      res
    ,true)
    return "INVALID_IP" if !valid_ip