CHANEL = Backbone.Model.extend
  defaults :
    data_counter  : null # Это показания приборов и вводятся пользователем вручную
    delta_counter : null # Это показания приборов и вводятся пользователем вручную
    delta_imp     : null # Дельта в импульсах
    delta_user_v  : null # Дельта в пользовательских величинах
    divider       : null
    is_edit       : null
    math          : null
    price_imp     : null
    res_imp       : null
    res_user_v    : null # Должно в пользовательских величинах 
    section_imp   : null # Приходим с прибора. Срезы
    section_user_v: null # срезы с прибора  в пользовательских величинах
    value_now     : null


  # Есть ли ошибка при получении данных с канала
  # Если есть задачи на получение данных с канала или со каналов то это еще не ошибка
  is_error  : ()->
    error = false
    counter.get('issues').where( ident : "get_values_chanel" , chanel : ( @.collection.indexOf @ ) + 1 ).map( ( issue )->
      if issue.get('status') == ERROR
        error = true
    ,@)
    error

  # Получение информации что по каналу запрашивается информация
  is_waiting  : ()->
    wait = false
    counter.get('issues').where( ident : "get_values_chanel" , chanel : ( @.collection.indexOf @ ) + 1 ).map( ( issue )->
      if issue.get('status') == WAITING
        wait = true
    ,@)
    wait


  # Получение информации что по каналу запрашивается информация
  is_running  : ()->
    run = false
    counter.get('issues').where( ident : "get_values_chanel" , chanel : ( @.collection.indexOf @ ) + 1 ).map( ( issue )->
      if issue.get('status') == RUNNING
        run = true
    ,@)
    run






  # Расчет результата в пользовательских величинах
  __set_res_user_v : ()->
    v = ( Number(@.get('value_now')) - Number( @.get('delta_counter') * @.get('price_imp') ) ) + Number(@.get('delta_user_v'))
    @.set "res_user_v" : get_format_value( v )
    true
    
 


  # Расчет цены имульса
  __set_price_imp : ()->
    p_i = Number( @.get("math") ) / Number( @.get('divider') )
    @.set "price_imp" , get_format_value( p_i )
    true


  # Расчет дельты в импульсах
  __set_delta_imp : ()->
    v = @.get('delta_user_v') / @.get('price_imp')
    @.set "delta_imp" , get_format_value( v )
    true


  # Расчет результата в импульсах
  __set_res_imp : ()->
    v = @.get('res_user_v') / @.get('price_imp')
    @.set "res_imp" : get_format_value( v )
    true



  # Расчет среза с прибора в пользовательских величинах
  __set_section_user_v : ()->
    v = @.get('price_imp') * @.get('section_imp')
    @.set "section_user_v" , get_format_value( v )
    true
    
    
  __set_delta_user_v : ()->
    v = @.get('data_counter') - @.get('section_user_v')
    @.set "delta_user_v" , get_format_value( v )
    true
