CONNECT_VIEW = Backbone.View.extend
  
  el : "#app",

  template : "#counter"

  model : counter




  initialize : ()->
    @.render()
    @.listenTo this.model , '_change' , this.btn_class
    @.listenTo this.model , 'change' , this.render
    @.listenTo this.model , 'change:is_edit' , this.render
    @.listenTo this.model.get('issues')   , 'change'  , this.render
    @.listenTo this.model.get('chanels')  , 'change'  , this.render
    @.listenTo this.model.get('log')      , 'add'     , this.render
    @



  render : ()->
    tpl_c = _.template( $(@.template).html() )
    $(@.$el).empty().append(
      tpl_c
        model : @.model
    )

    @.validation_form()




  # Переопределяем нативные сеттеры
  # Это надо на случай если туда будут вставлять через всякие сохраненниые пароли
  # или просто CTRL V
  set_ip : ( e )->
    this.model.set 
      ip : $(e.target).val()
    ,
      silent : true

    # так как событие тихое то вызовем кастомное событие
    this.model.trigger "_change"



  set_mac : ( e )->
    this.model.set 
      mac : $(e.target).val()
    ,
      silent : true

    # так как событие тихое то вызовем кастомное событие
    this.model.trigger "_change"



  set_port : ( e )->
    this.model.set 
      port : $(e.target).val()
    ,
      silent : true

    # так как событие тихое то вызовем кастомное событие
    this.model.trigger "_change"



  set_pass : ( e )->
    this.model.set 
      pass : $(e.target).val()
    ,
      silent : true

    # так как событие тихое то вызовем кастомное событие
    this.model.trigger "_change"






  # Првоерка формы редактирования для соединения на валидность.
  # По пути выдаем различные алерты и прочее
  # вернуть должны булев отвечаеющий за валидность
  validation_form : ()->

    valid = true

    if !validator_hex_fields $('#mac').val() , 8 , 8 
      $("#mac").closest('.form-group').addClass 'has-error'
      valid = false
    else
      $("#mac").closest('.form-group').removeClass 'has-error'

    if !validator_hex_fields $('#pass').val() , 10 , 10 
      $("#pass").closest('.form-group').addClass 'has-error'
      valid = false
    else
      $("#pass").closest('.form-group').removeClass 'has-error'

    if $('#ip').val() == ""
      valid = false

    if $('#port').val() == ""
      valid = false

    if valid
      method = 'addClass'
      method_rev = 'removeClass'
    else
      method = 'removeClass'
      method_rev = 'addClass'
    $('#send')[ method ]('btn-success')[ method_rev ]('btn-disabled')

    valid


  
  
  # Этот метод будет очищать все глобальные ошибки и запускать каллбэк
  hide_main_error : ( callback = ()-> )->
    $.when( $('.alert-danger').slideUp( 200 ) ).then(()->
      counter.get('log').where( type : "main" ).map(( log )->
        @.remove log
      ,counter.get('log'))
      callback()
    )



  # События
  events : 


    "keyup #ip" : ( e )->
      this.set_ip e
      @.validation_form() # валидация формы
      
    

    "keyup #mac" : ( e )->
      this.set_mac e
      $(e.target).paste_simbol_hex(e) # вставка двоеточий
      @.validation_form() # валидация формы
    

    "keyup #port" : ( e )->
      this.set_port e
      @.validation_form() # валидация формы

    "keyup #pass" : ( e )->
      this.set_pass e
      $(e.target).paste_simbol_hex(e) # вставка двоеточий
      @.validation_form() # валидация формы

    
    
    # Установка нового пароля
    "click #set_pass" : ()->
      @.model.clear_issues()
      @.hide_main_error( ()->
        new MODAL_PASS()
      )
      
    
    "click #set_time" : ()->
      @.model.clear_issues()
      @.hide_main_error( ()->
        new MODAL_DATE()
      )
      
      

    "click #advanced_mode" : ()->
      @.model.set "advanced_mode" : !@.model.get "advanced_mode"

    "click #reset_value" : ()->
      @.model.clear_issues()
      self = @
      
      # Делаем красоту чтобы логи сначала скрылись потом только показались
      
      @.hide_main_error(()->
        issue_parent = issues.findWhere( ident : "get_values" )
        if issue_parent
          issue = new ISSUE( issue_parent.toJSON() )
          issue.set status : WAITING
          self.model.get('issues').add issue
          # Запускаем выполнение задач
          self.model.start_clear_pull()
      )
      
      $.when( @.hide_main_error() ).then(()->
        counter.get('log').where( type : "main" ).map(( log )->
          @.remove log
        ,counter.get('log'))
      )
      
      
    
    
    # Нажали смотреть лог или скрыть
    'click #view_log' : ()->
      @.model.set "is_view_log" , !@.model.get "is_view_log"


    # Редактирование канала
    "click .edit_chan" : (e)->
      cid = $(e.target).closest('th').attr('data-chanel')
      chanel = @.model.get('chanels').get( cid )
      new MODAL_CHANEL chanel


    # Соединение с прибором
    "click #send" : ( e )->

      if !@.validation_form() then return false

      # тут надо скинуть все у прибора.
      @.model.get('chanels').reset()
      @.model.get('issues').reset()
      @.model.get('log').reset()
      @.model.get('chanels').add([{},{},{},{},{},{},{},{}])
      this.model.set
        serial        : @.model.defaults.serial
        version       : @.model.defaults.version
        time_server   : @.model.defaults.time_server
        time_device   : @.model.defaults.time_device
        advanced_mode : @.model.defaults.advanced_mode
        is_view_log   : @.model.defaults.is_view_log

      # Переводим прибор в режим настройки
      this.model.set 'is_edit' , false

      # забиваем пул задач на прибор
      [ "get_version" , "get_time" , "get_ident" , "get_slice",  "get_values" ].map(( ident )->
        issue_parent = issues.findWhere( ident : ident )
        if issue_parent
          issue = new ISSUE( issue_parent.toJSON() )
          issue.set status : WAITING
          @.add issue
      ,@.model.get("issues"))



      @.model.get('chanels').toArray().map( ( chanel )->
        issue_parent = issues.findWhere( ident : 'get_values_chanel' )
        issue = new ISSUE( issue_parent.toJSON() )
        if issue
          num_chan = @.get('chanels').indexOf(chanel) + 1
          issue.set 
            status : WAITING
            chanel : num_chan
            ta     : intFixLength num_chan, 2
          @.get('issues').add issue
      ,@.model)
      
      hash = [
        "do"
        @.model.get "ip"
        @.model.get "port"
        @.model.get "mac"
        @.model.get "pass"
      ]
      
      location.hash = hash.join("/")
      
      # Запускаем выполнение задач
      @.model.start_clear_pull()


    "click #edit" : ( e )->
      # Переводим прибор в режим настройки
      this.model.set 'is_edit' , true

$(document).ready(()->
  new CONNECT_VIEW()
)