COUNTER = Backbone.Model.extend
  defaults :
    ip            : null # 
    port          : null
    mac           : null
    pass          : null
    serial        : null
    version       : null
    time_server   : null
    time_device   : null
    advanced_mode : false # расширенный режим отображения
    is_connect    : null # получилось или нет подключится
    issues        : new ISSUES() # пул задач которые нужно выполнить на этом приборе
    chanels       : new CHANELS([{},{},{},{},{},{},{},{}]) # каналы
    log           : new LOGS() # лог событий
    is_edit       : true # Флаг отвечающий за то какое окно показывать. Редактирования или нет
    is_view_log   : false # Флаг отвечающий за показ или скрытие лога
    

  # Это проверка что объект валиден для соединения
  is_valid_from_connect  : ()->
    this.get('ip') && this.get('port') && this.get('mac') && this.get('pass')


  # Разбор задач на приборе 
  start_clear_pull : ()->
    # Ищем какие есть задачи 
    issue_for_run = counter.get('issues').where( status : WAITING )
    return false if issue_for_run.length == 0
    issue = issue_for_run.splice(0,1)
    issue[0].run( counter.start_clear_pull )
    
  
  
  # После выполнения всего пула задач будем убирать все задачи на приборе
  clear_issues : ()->
    counter.get('issues').reset()

    
  

  # Получение задач которые или выполняются или будут выполняться
  get_issues_run_w : ()->
    @.get('issues').toArray().reduce(( res, issue )->
      if issue.get('status') == WAITING || issue.get('status') == RUNNING
        res++
      res
    ,0)
    
    
  # аргумент - это индекс канала. Начало с 1
  _get_chanel_by_number : ( number )->
    if @.get('chanels')
      if @.get('chanels').at( number - 1 )
        return @.get('chanels').at( number - 1 )
      else
        false
    else
      false
      
  
      
      
  # Это те прааметры которые гарантированно должны получить чтобы сказать 
  # что доступ к прибору есть
  # Установка версии
  _set_version : ( v )->
    @.set 'version' : v
    @._set_is_connect()
  
  # Установка времени на девайсе
  _set_time_device : ( v )->
    @.set 'time_device' : v
    @._set_is_connect()
    
  # установка времени сервера
  _set_time_server : ( v )->
    @.set 'time_server' : v
    @._set_is_connect()
  
  # установка идентификатора
  _set_ident : ( v )->
    @.set 'ident' : v
    @._set_is_connect()
    
  # Установка параметра соединения
  _set_is_connect : ()->
    false
    


counter = new COUNTER();



# Вешаем события на изменения внутри модели
counter.get('chanels')

# При изменении множителя - пересчитывать ценц импульса
.on('change:math' , (model)->
  model.__set_price_imp()
)
.on('change:divider' , (model)->
  model.__set_price_imp()
)
#.on('change:section_user_v' , (model)->
#  v = model.get('data_counter') - model.get('section_user_v')
#  model.set "delta_user_v" , get_format_value( v )
#)


.on('change:data_counter' , (model)->
  model.__set_delta_user_v()
)
.on('change:section_user_v' , (model)->
  model.__set_delta_user_v()
)



# delta_imp
.on('change:delta_user_v' , (model)->
  model.__set_delta_imp()
)
.on('change:price_imp' , (model)->
  model.__set_delta_imp()
)



# res_imp
.on( 'change:res_user_v' , ( model )->
  model.__set_res_imp()
)
.on( 'change:price_imp' , ( model )->
  model.__set_res_imp()
)



# res_user_v - должно быть в пользовательских величинах
# Все вынесено в метод канала чтобы унифицировать
.on( "change:value_now" , ( model )->
  model.__set_res_user_v()
)
.on( "change:delta_counter" , ( model )->
  model.__set_res_user_v()
)
.on("change:price_imp" , ( model )->
  model.__set_res_user_v()
)
.on("change:delta_user_v" , ( model )->
  model.__set_res_user_v()
)




# section_user_v
.on( 'change:price_imp' ,(model)->
  model.__set_section_user_v()
)
.on( 'change:section_imp' ,(model)->
  model.__set_section_user_v()
)







$(document).ready(()->

    # разбираем урл
    reg = new RegExp /^#do\/([0-9|\.]*)\/([0-9]*)\/([0-9|A-F|\:]*)\/([0-9|A-F||\:]*)/

    if reg.test window.location.hash

        res = reg.exec window.location.hash

        counter.set
            ip      : res[1]
            port    : res[2]
            mac     : res[3]
            pass    : res[4]
    else
        counter.set
            ip      : "172.31.74.21"
            port    : 50
            mac     : "F8:F0:82:02:59:E8:00:00"
            pass    : "01:02:03:04:05:06:07:08:09:10"
)