# Модальное окно установки даты на приборе
MODAL_DATE = Backbone.View.extend

  template : "#set_date_tpl"
  
  initialize : ()->
    @.render()
    
    
  model : counter
    
    
  render : ()->
    tpl_c = _.template $(@.template).html()
    
    self = @
    
    regexp_date         = new RegExp /(\d{4})-(\d{2})-(\d{2})/
    regexp_time         = new RegExp /(\d{2}):(\d{2})/
    regexp_device_time  = new RegExp /(\d{4}).(\d{2}).(\d{2}) (\d{2}):(\d{2}):(\d{2})/
    
    is_my_time = !regexp_device_time.test( counter.get('device_time') )
    
    if  is_my_time
      now         = new Date()
      
      [ day_sys, month_sys, hour_sys, minutes_sys , year ] = 
      [ now.getDate(), now.getMonth(), now.getHours(), now.getMinutes() , now.getFullYear() ]

      day         = if day_sys      < 10 then "0" + day_sys     else day_sys
      month       = if month_sys    < 10 then "0" + month_sys   else month_sys
      hour        = if hour_sys     < 10 then "0" + hour_sys    else hour_sys
      minutes     = if minutes_sys  < 10 then "0" + minutes_sys else minutes_sys
    else
      res_d_t = regexp_device_time.exec( connect_model.get('device_time') ); 
      [ n, year, month, day, hour, minutes ] = res_d_t
    
    modal = $(tpl_c(
      date : year + "-" + month + "-" + day,
      time : hour + ":" + minutes
    )).modal("show")
    
    $(modal).on "hidden.bs.modal" , ()->
      $(modal).remove()
      
    .on "click" , "#save_new_date" , ()->
    
      return false if !regexp_date.test( $('#input_date').val() )
      return false if !regexp_time.test( $('#input_time').val() )
      
      res_date = regexp_date.exec( $('#input_date').val() )
      res_time = regexp_time.exec( $("#input_time").val() )
      
      [n, year, month, day  ] = res_date
      [n, hour, minutes     ] = res_time
      
      d = new Date();
      
      issue_parent = issues.findWhere( ident : "set_time" )
      if issue_parent
        issue = new ISSUE( issue_parent.toJSON() )
        issue.set 
          "status" : WAITING
          "ta" :  
            str_to_hex( Number d.getYear(d.setYear(year)) ) + ':' +
            str_to_hex( Number month    ) + ':' +
            str_to_hex( Number day      ) + ':' +
            str_to_hex( Number hour     ) + ':' +
            str_to_hex( Number minutes  ) + ':' +
            str_to_hex( Number d.getSeconds() )
         
        self.model.get('issues').add issue
        
      # После установки времени надо запросить его
      issue_parent = issues.findWhere( ident : "get_time" )
      if issue_parent
        issue = new ISSUE( issue_parent.toJSON() )
        issue.set 
          "status" : WAITING
          
        self.model.get('issues').add issue
        
      # Запускаем выполнение задач
      self.model.start_clear_pull()

      $(modal).modal("hide")