define([
  "backbone",
  "archive_add_modal",
  "archives",
  "daterangepicker",
  "validator"
],function(
  Backbone,
  archive_add_modal,
  archives,
  daterangepicker
){
  
  
  return Backbone.View.extend({
    
    
    tagName : 'div',
    
    initialize :function( id ){
      
      var id = id || 0
      
      var trigger = id ? 'change_model' : 'add_model'
      
      var data = { data : [ id ] }
      
      var self = this
      
      $.get(
        '/tpl/?tpl=archive_form',
        data,
        function( tpl ){
          
          var tpl = $(tpl)
          
          $(tpl).find('[type="submit"]').remove()
          
          $( tpl ).modal('show').on('click' , '#save_archive' , function(){
            if( $(this).closest('.modal-dialog').isValid() ){
              var archive = new archives.model({
                id : id,
                name            : $(tpl).find('[name="Name"]').val(),
                year_st         : $(tpl).find('[name="YearSt"]').val(),
                month_st        : $(tpl).find('[name="MonthSt"]').val(),
                day_st          : $(tpl).find('[name="DaySt"]').val(),
                year_sp         : $(tpl).find('[name="YearSp"]').val(),
                month_sp        : $(tpl).find('[name="MonthSp"]').val(),
                day_sp          : $(tpl).find('[name="DaySp"]').val(),
                is_drop         : $(tpl).find('[name="IsDrop"]').is(':checked'),
                text            : $(tpl).find('[name="Text"]').val(),
              })
              archive.save().then(function(){
                $(tpl).modal('hide')
                archives.trigger( trigger , archive)
              })
            }
          }).on('hidden.bs.modal' , function(){
            $(tpl).remove()
            $('.daterangepicker').remove()
          }).on('shown.bs.modal' , function(){
            
            var sp_s = $('#date_stop').val().split('-')
            
            $('[name="DaySp"]').val( sp_s[0] || 0 )
            $('[name="MonthSp"]').val( sp_s[1] || 0 )
            $('[name="YearSp"]').val( sp_s[2] || 0 )
            
            var locale = {
              format: 'DD-MM-YYYY'
            }
            
            $('#date_start').daterangepicker({
                "singleDatePicker": true,
                "showDropdowns": true,
                locale: locale,
            }, function(start, end, label) {
              $('[name="DaySt"]').val( start._d.getDate() )
              $('[name="MonthSt"]').val( start._d.getMonth()+1 )
              $('[name="YearSt"]').val( start._d.getFullYear() )
            }).on('show.daterangepicker' , function(){
              var st_s = $('#date_start').val().split('-')
              $('[name="DaySt"]').val( st_s[0] || 0 )
              $('[name="MonthSt"]').val( st_s[1] || 0 )
              $('[name="YearSt"]').val( st_s[2] || 0)
            })
            
            
            $('#date_stop').daterangepicker({
                "singleDatePicker": true,
                "showDropdowns": true,
                locale: locale,
            }, function(start, end, label) {
              $('[name="DaySp"]').val( start._d.getDate() )
              $('[name="MonthSp"]').val( start._d.getMonth()+1 )
              $('[name="YearSp"]').val( start._d.getFullYear() )
            })
              
            
          })
          
          
          $.validate()
          
        }
      )
    },
    
    
    
    
    
  })
  
})