define([
  "backbone",
  "archives",
  "converters",
  "meters",
  "archivemeters",
  "jstree"
],function(
  Backbone,
  archives,
  converters,
  meters,
  archivemeters
){

  return Backbone.View.extend({
  
  
    initialize : function( id ){
      
      var id = id
      
      if( typeof $('#meter_list').data('jstree') != 'undefined' ){
        $('#meter_list').jstree(true).destroy()
      }
      var data = { data : [ id ] }
      $.get(
        '/tpl/?tpl=archive_meter_modal',
        data , 
        function( tpl ){
          
          var open_converters = false
          var checked_meter   = false
          
          archivemeters.fetch({
            data : {
              filter : "archive:" + id + ";",
              converter_open : true
            },
            success : function( data , res ){
              open_converters = []
              res.reduce(function( res , item ){
                res.push( "converter_tree_" + item.id )
                return res;
              },open_converters);
            }
          })
          archivemeters.fetch({
            data : {
              filter : "archive:" + id + ";"
            },
            success : function( data , res ){
              checked_meter = []
              data.toArray().reduce(function( res , item ){
                res.push( "meter_tree_" + item.get('meter') )
                return res;
              },checked_meter);
            }
          })
          
          
          var tpl = $(tpl)
          
          $(tpl).modal('show').on('shown.bs.modal' , function(){
            
            $('#meter_list').jstree({
              "core" : {
                "check_callback" : function () {
                  return true;
                },
                'themes': {
                    'name': 'proton',
                    'responsive': true
                },
                'data' : {
                  'url' : function (node) {
                    if( node.id == '#' ){
                      return '/api/?object=converter&tree=true';
                    }else{
                      return '/api/?object=meter&tree=true&filter=converter:' + node.id.replace('converter_tree_','');
                    }
                  },
                }
              },
              "checkbox": {
                  "three_state": false
              },
              "plugins" : [
                "json","types","checkbox"
              ]
              
            }).bind('open_node.jstree' , function( e,core ){
              core.instance.select_node(checked_meter)
            }).bind('load_node.jstree' , function(e,core){
              
              if( open_converters !== false ){
                core.instance.open_node( open_converters )
              }
              
            }).bind('select_node.jstree' , function(e,core){
              if( core.node.id.match(/meter_tree_(.*)/) ){
                var archivemeter = new archivemeters.model({
                  archive : id,
                  meter : core.node.id.replace('meter_tree_','')
                })
                
                archivemeter.save()
              }
            }).bind('deselect_node.jstree' , function(e,core){
              if( core.node.id.match(/meter_tree_(.*)/) ){
                
                archivemeters.fetch({
                  data : {
                    filter : "archive:" + id + ";meter:" + core.node.id.replace('meter_tree_','')
                  },
                  success : function( data ){
                    data.first().destroy()
                  }
                })
                
                
              }
            })
            
          }).on('hidden.bs.modal', function(){
            $(tpl).remove()
          })
          
          
          
        }
      )
      
    },
  
    events : {
  
    },
  
    el : 'div',
  
  
  
  });

});