define([
  "backbone",
  "cconverter_modal_add",
  "cconverter_modal_delete",
  "cconverter_modal_edit",
  "cconverters"
],function(
  Backbone,
  cconverter_modal_add,
  cconverter_modal_delete,
  cconverter_modal_edit,
  cconverters
){

  return Backbone.View.extend({
    
    
    initialize : function(){
      this.listenTo( cconverters , 'add_model' , function( add_model ){
        
        var data = { data : [ add_model.get('id') ] }
        
        var self = this
        
        $.get(
          "/tpl/?tpl=cconverter_list_item",
          data,
          function( data ){
            $( self.$el ).find('tbody').append( $(data) )
          }
        )
      })
      
      
      
      this.listenTo( cconverters , 'drop_model' , function( drop_model ){
        $('#cconverter_item_' + drop_model.get('id')).fadeOut(300)
      })
      
      
      
      this.listenTo( cconverters , 'change_model' , function( change_model ){
        
        var data = { data : [ change_model.get('id') ] }
        
        var self = this
        
        $.get(
          "/tpl/?tpl=cconverter_list_item",
          data,
          function( data ){
            $( '#' + $(data).attr('id') ).replaceWith( $(data) )
          }
        )
      })
      
      
    },
  
  
  
    events : {
      'click #add_converter_modal' : function( e ){
        
        $( e.target ).closest('td').addClass( DIS_DIV )
        
        new cconverter_modal_add( e.target )
        return false;
      },
      
      
      
      'click .delete_cconverter' : function( e ){
        
        $( e.target ).closest('td').addClass( DIS_DIV )
        
        new cconverter_modal_delete( e.target )
        return false;
      },
      
      
      
      'click .edit_cconverter' : function( e ){
        
        $( e.target ).closest('td').addClass( DIS_DIV )
        
        new cconverter_modal_edit( e.target , function(){
          $( e.target ).closest('td').removeClass( DIS_DIV )
        })
        return false;
      }
    },
    
    
    
  
    el : '.container_converter_meters',
  
  
  });

});