define([
  "backbone",
  "cmeter_modal_add",
  "cmeter_modal_edit",
  "cmeter_modal_delete",
  "cconverters",
  "cmeters"
],function(
  Backbone,
  cmeter_modal_add,
  cmeter_modal_edit,
  cmeter_modal_delete,
  cconverters,
  cmeters
){

  return Backbone.View.extend({
  
  
    initialize : function( model ){
      this.model = model
      
      var self = this
      
      this.listenTo( cconverters , 'add_model' , function( add_model ){
        
        var data = { data: [ add_model.get('id') ] }
        
        $.get(
          '/tpl/?tpl=cmeter_list_item',
          data,
          function( data ){
            $(self.$el).find('tbody').append( $(data) )
          }
        )
      })
      
      
      this.listenTo( cmeters , 'change_model' , function( change_model ){
        var data = { data: [ change_model.get('id') ] }
        
        $.get(
          '/tpl/?tpl=cmeter_list_item',
          data,
          function( data ){
            $('#' + $(data).attr('id')).replaceWith( $(data) )
          }
        )
      })
      
      
      this.listenTo( cmeters , 'drop_model' , function( drop_model ){
        $('#converter_meter_item_' + drop_model.get('id')).fadeOut(300)
      })
      
      
    },
  
  
    render : function(){
  
    },
  
  
    events : {
      'click #add_meter' : function( e ){
        
        $(e.target).closest('td').addClass( DIS_DIV )
        new cmeter_modal_add( this.model , function(){
          $(e.target).closest('td').removeClass( DIS_DIV )
        })
        return false;
      },
      
      
      
      
      'click .converter_meter_delete' : function( e ){
        $(e.target).closest('td').addClass( DIS_DIV )
        var id = $(e.target).closest( 'tr' ).attr('id').replace('converter_meter_item_','')
        new cmeter_modal_delete( id , function(){
          $(e.target).closest('td').removeClass( DIS_DIV )
        })
        return false;
      },
      
      
      'click .converter_meter_edit' : function( e ){
        
        $(e.target).closest('td').addClass( DIS_DIV )
        
        var id = $(e.target).closest('tr').attr('id').replace('converter_meter_item_','')
        
        cmeters.fetch({
          data : {
            filter : "id:" + id
          },
          success : function( data ){
            new cmeter_modal_edit( data.last() , function(){
              $(e.target).closest('td').removeClass( DIS_DIV )
            } )
          }
        })
        
        return false;
        
      }
    },
  
    el : '.container_converter_meters',
  
  
  });

});