define([
  "backbone",
  "places",
  "parameters",
  "cmeter_formula_add_btn",
  "cmeter_block_formula",
  "meterformuls"
],function(
  Backbone,
  places,
  parameters,
  cmeter_formula_add_btn,
  cmeter_block_formula,
  meterformuls
){
  
  
  
  return Backbone.View.extend({
  
  
    initialize : function( id ){
      this.$el = $('#formula_' + id)
      $(this.$el).addClass( DIS_DIV )
    },
    
    
    render : function( model ){
      $(this.$el).removeClass( DIS_DIV )
      
      new cmeter_formula_add_btn()
      
      $(this.$el).find('.row[data-var]').each(function(i,row){
        new cmeter_block_formula( $(row) )
      })
      
      //~ new cmeter_block_formula( $(data) )
      
    },
  
  
  
    events : {
      'click #save_formula' : function(){
        
        var self = this
        
        var output = []
        
        var rows = $( this.$el ).find('.row[data-var]')
        
        $( rows ).each(function(i,tr){
          
          if( 
              $(tr).attr('data-var').match(/^([a-z]*):([0-9]*):([0-9]*)$/) &&
              $(tr).attr('data-var').split(":").reduce(function(res,item){
                if( !res ) return res;
                res = isNaN(item) ? item : Number(item)
                return res;
              },true)
          ){
            output.push( $(tr).attr('data-var') )
            output.push( $(tr).attr('data-znak') )
          }
          
        })
        
        output = output.reduce(function(res,item,i,orig){
          if(i == orig.length - 1 && item.match(/^(\/|\+|\-|\*)$/) ) return res;
          res.push(item)
          return res;
        },[]).join(" ")
        
        if( output ){
          
          var id = $( this.$el ).attr('id').replace('formula_','')
          
          
          meterformuls.fetch({
            data : {
              filter : "id:" + id
            },
            success : function( data ){
              var formula = data.last()
              formula.set({
                formula : output
              }).save().then(function(res){
                if( res ){
                  $( self.$el ).removeClass( DIS_DIV )
                  
                  let data = {
                    data : [formula.get('id')],
                  }
                  
                  $.get(
                    '/tpl/?tpl=cmeter_formula_result',
                    data,
                    function( data ){
                      $( self.$el ).empty().append( $(data) )
                  })
                }
              })
            }
          })
          
        }
        
        return false;
      }
    },
  
  
  });
  

});