define([
  "backbone",
  "cmeter_remove_formula",
  "cmeter_edit_formula",
  "meterformuls",
  "validator"
],function(
  Backbone,
  cmeter_remove_formula,
  cmeter_edit_formula,
  meterformuls
){
  
  
  
  
  
  
  /*
    Общий вид управления
    
    Добавление
    Удаление
    Редактирование
    
  */
  
  
  return Backbone.View.extend({
  
  
    initialize : function( model ){
      $(this.$el).addClass( DIS_DIV )
      
      $(document).on('formula_changed' , function( e, row ){
        
        var is_view = 0;
        $(row).closest('tr').find('[data-var]').each(function(i,block){
          if(
              $(block).attr('data-var').match(/^([a-z]*):([0-9]*):([0-9]*)$/) &&
              $(block).attr('data-var').split(":").reduce(function(res,item){
                if( !res ) return res;
                res = isNaN(item) ? item : Number(item)
                return res;
              },true)
            ){
            is_view++
          }
        })
        
        $('#save_formula')[
          is_view > 1
          ? 'removeClass'
          : 'addClass'
        ]('hide')
      })
      
    },
    
    
    setmodel : function( model ){
      this.model = model
      $(this.$el).removeClass( DIS_DIV )
    },
  
    events : {
      
      
      'click .edit_forula' : function( e ){
        
        
        let id = $(e.target).closest('tr').attr('id').replace('formula_container_','')
        
        let edit = new cmeter_edit_formula( id )
        
        
        let data = { data : [ id ] }
        
        $.get(
          '/tpl/?tpl=cmeter_formula_edit',
          data , 
          function(data){
           $('#formula_' + id).empty().append(
            $(data)
           )
           
           edit.render()
        })
        
        return false;
      },
      
      
      
      
      
      'click .drop_forula' : function( e ){
        
        let id = $(e.target).closest('tr').attr('id').replace('formula_container_','')
        
        $(e.target).closest('tr').addClass( DIS_DIV )
        
        let data = { data : [ id ] }
        
        $.get(
          '/tpl/?tpl=cmeter_modal_delete_formula',
          data ,
          function( data ){ 
            $(e.target).closest('tr').removeClass( DIS_DIV )
            
            var data = $(data)
            
            $(data).find('[type="submit"]').remove()
           
            $(data).modal('show').on('click' , '#run_drop_formula' , function(){
              
              var formula = new meterformuls.model({
                id : id
              })
              
              formula.destroy({ dataType : "text" , success: function( model , res){
                if( res == "droped" ){
                  $(e.target).closest('tr').remove()
                  $(data).modal('hide')
                }
              }})
              
            }).on('hidden.bs.modal', function() {
                $(data).remove()
            })
            
        })
        
        return false;
      },
      
      
      
      
      
      'click #block_add_meterformula' : function( e ){
        
        let data = { data : [ this.model.get('id') ] }
        
        var self = this
        
        $.get(
          '/tpl/?tpl=cmeter_modal_add_formula',
          data , 
          function(data){
            
            var data = $(data)
            
            $(data).find('[type="submit"]').remove()
           
            $(data).modal('show').on('click' , '#add_formula',function(){
              
              $(this).closest('.modal').addClass( DIS_DIV )
              
              var formula = new meterformuls.model({
                meter : self.model.get('id'),
                parameter : $(data).find('[name="ParameterId"]').val()
              })
              
              formula.save().then(function(){
                $(data).modal('hide')
                
                let _data = { data : [ formula.get('id') ] }
                
                $.get(
                  '/tpl/?tpl=cmeter_formula_list_item',
                  _data , 
                  function(data){
                    $(e.target).closest('table').find('tbody').append( $(data) )
                })
              })
              
            }).on('hidden.bs.modal', function() {
                $(data).remove()
            })
           
        })
        
        return false;
      },
      
      
      
      
      
      
    },
  
    el : '#formula_list',
  
  });
  

});