define([
  "backbone",
  "places",
  "parameters",
  "meters"
],function(
  Backbone,
  places,
  parameters,
  meters
){
  
  
  
  /*
    Модальное окно редактирования блока формулы
  */


  return Backbone.View.extend({
    
    
    
    
    /*
      рисуем дерево мест
    */
    renderPlaceTree : function(){
      
      var self = this
      
      $('#content_formula').jstree({
        "core" : {
          "check_callback" : function () {
            return true;
          },
          'themes': {
              'name': 'proton',
              'responsive': true
          },
          'data' : {
            'url' : function (node) {
              return '/api/?object=place&tree=true&filter=place:' + (node.id === '#' ? 0 : node.id.replace(/(.*)_([0-9]*)$/g, function(_,_,_id){
                return _id
              }));
            },
            'cache':true,
          }
        },
        "checkbox": {
            "three_state": false
        },
        "plugins" : [
          "json","types","checkbox"
        ]
      }).bind('select_node.jstree',function(e,core){
        core.instance.get_selected().reverse().map(function(item , i){
          if( !i ) return true;
          this.deselect_node(item)
        },core.instance)
        
        self.model.set({
          object : 'place',
          id : Number(
                      core.node.id.replace(
                                            /(.*)_([0-9]*)$/g, 
                                            function(_,_,_id){
                                              return _id
                                            }
                                          )
                    )
        })
      }).bind('deselect_node.jstree',function(e,core){
        if( !core.selected.length ){
          self.model.set( self.model.defaults )
        }
      }).bind('load_node.jstree',function(e,core){
        
        if( self.model.get('id') ){
          places.fetch({
            data : {
              all_parent : 1,
              tree : 1,
              filter : "id:" + self.model.get('id')
            },
            success : function( data , res ){
              res.map(function(item){
                core.instance.open_node( item )
              })
            }
          })
          let id = core.node.id == "#"
                    ? 0
                    : core.node.id.replace(/(.*)_([0-9]*)$/g, function(_,_,_id){return _id})
          
          core.instance.select_node( "place_tree_" + id +"_"+ self.model.get('id') )
        }
        
        
      })
    },
    
    
    
    
    
    /*
      рисуем дерево приборов учета
    */
    renderConvTree : function(){
      
      var self = this
      
      
      $('#content_formula').jstree({
        "core" : {
          "check_callback" : function () {
            return true;
          },
          'themes': {
              'name': 'proton',
              'responsive': true
          },
          'data' : {
            'url' : function (node) {
              if( node.id == '#' ){
                return '/api/?object=converter&tree=true';
              }else{
                return '/api/?object=meter&tree=true&filter=converter:' + node.id.replace('converter_tree_','');
              }
            },
          }
        },
        "checkbox": {
            "three_state": false
        },
        "plugins" : [
          "json","types","checkbox"
        ]
      }).bind('select_node.jstree',function(e,core){
        core.instance.get_selected().reverse().map(function(item , i){
          if( !i ) return true;
          this.deselect_node(item)
        },core.instance)
        
        
        self.model.set({
          object : core.node.id.replace(/^([a-z]*)(.*)/,function(_,i){return i}),
          id : Number(
                      core.node.id.replace(
                                            /(.*)_([0-9]*)$/g, 
                                            function(_,_,_id){
                                              return _id
                                            }
                                          )
                    )
        })
      }).bind('deselect_node.jstree',function(e,core){
        if( !core.selected.length ){
          self.model.set( self.model.defaults )
        }
      }).bind('load_node.jstree',function(e,core){
        if( 
          self.model.get('id') && 
          core.node.id == "#"
        ){
          switch( self.model.get('object') ){
            case "meter" : 
              meters.fetch({
                data : {
                  filter : "id:" + self.model.get('id')
                },
                success : function( data ){
                  let meter = data.last()
                  core.instance.open_node( "converter_tree_" + meter.get('converter') )
                }
              })
            break;
            case "converter" : 
              core.instance.select_node( "converter_tree_" + self.model.get('id') )
            break;
          }
        }
      }).bind('open_node.jstree' , function(e,core){
        if( self.model.get('id') && self.model.get('object') == 'meter' ){
          core.instance.select_node( "meter_tree_" + self.model.get('id') )
        }
      })
    },
    
    
    
    /*
      рисуем дерево вирт узлов учета
    */
    renderVirtConvTree : function(){
      
      var self = this
      
      $('#content_formula').jstree({
        "core" : {
          "check_callback" : function () {
            return true;
          },
          'themes': {
              'name': 'proton',
              'responsive': true
          },
          'data' : {
            'url' : function (node) {
              if( node.id == '#' ){
                return '/api/?object=vconverter&tree=true';
              }else{
                return '/api/?object=vmeter&tree=true&filter=converter:' + node.id.replace('vconverter_tree_','');
              }
            },
          }
        },
        "checkbox": {
            "three_state": false
        },
        "plugins" : [
          "json","types","checkbox"
        ]
      }).bind('select_node.jstree',function(e,core){
        core.instance.get_selected().reverse().map(function(item , i){
          if( !i ) return true;
          this.deselect_node(item)
        },core.instance)
        
        self.model.set({
          object : core.node.id.replace(/^([a-z]*)(.*)/,function(_,i){return i}),
          id : Number(
                      core.node.id.replace(
                                            /(.*)_([0-9]*)$/g, 
                                            function(_,_,_id){
                                              return _id
                                            }
                                          )
                    )
        })
      }).bind('deselect_node.jstree',function(e,core){
        if( !core.selected.length ){
          self.model.set( self.model.defaults )
        }
      }).bind('load_node.jstree',function(e,core){
        if( 
          self.model.get('id') && 
          core.node.id == "#"
        ){
          switch( self.model.get('object') ){
            case "vmeter" : 
              meters.fetch({
                data : {
                  filter : "id:" + self.model.get('id')
                },
                success : function( data ){
                  let meter = data.last()
                  core.instance.open_node( "vconverter_tree_" + meter.get('converter') )
                }
              })
            break;
            case "vconverter" : 
              core.instance.select_node( "vconverter_tree_" + self.model.get('id') )
            break;
          }
        }
      }).bind('open_node.jstree' , function(e,core){
        if( self.model.get('id') && self.model.get('object') == 'vmeter' ){
          core.instance.select_node( "vmeter_tree_" + self.model.get('id') )
        }
      })
    },
    
    
    
    
    
    
    
    /*
      список параметров
    */
    renderParameterList : function(){
      
      var modal = $('#content_formula').closest('.modal')
      
      if( typeof $('#content_formula').data('jstree') != 'undefined' ){
        $('#content_formula').jstree(true).destroy();
      }
      
      $('#content_formula').empty()
      
      $(modal).find('.formula_first_step').addClass('hide')
      $(modal).find('.formula_last_step').removeClass('hide')
      
      $(modal).find('.nav-tabs').addClass('hide')
      
      var self = this
      
      $(modal).find('.modal-body').addClass( DIS_DIV )
    
      parameters.fetch({
        data : {
          [self.model.get('object')] : self.model.get('id')
        },
        success : function( data ){
          
          $('.modal-body').removeClass( DIS_DIV )
          
          $('#content_formula').empty()
          
          $.get('/tpl/?tpl=parameter_list_group',{
            ids : data.toArray().reduce(function(res,item){
              res.push(item.get('id'))
              return res;
            },[]),
            data : [0]
          },function(tpl){
            
            var tpl = $(tpl)
            
            $('#content_formula').append( $(tpl) ).on('click','.list-group-item',function(){
              $('#content_formula').find('.list-group-item').removeClass('active')
              $(this).addClass('active')
              self.model.set('pid',$(this).closest('a').attr('id').replace('parameter_',''))
            })
            
            $('#parameter_' + self.model.get('pid')).addClass('active')
            
          })
        }
      })
    },
    
    
    
    
    
    
    
    
    openTabByObject : function( e ){
      switch( this.model.get('object') ){
        case 'converter':
        case 'meter':
          $(this.$el).find('.nav-tabs li').eq(1).trigger('click' , [true])
          this.renderConvTree();
        break;
        case 'vconverter':
        case 'vmeter':
          $(this.$el).find('.nav-tabs li').eq(2).trigger('click' , [true])
          this.renderVirtConvTree();
        break;
        default :
          $(this.$el).find('.nav-tabs li').eq(0).trigger('click' , [true])
          this.renderPlaceTree()
        break;
      }
    },
    
    
  
  
    initialize : function( el , model ){
      this.$el = $(el)
      
      var self = this
      
      this.model = model
      
      if( typeof $('#content_formula').data('jstree') != 'undefined' ){
        $('#content_formula').jstree(true).destroy();
      }
      
      $(this.$el).modal('show').on('shown.bs.modal', function() {
        self.openTabByObject()
      }).on('hidden.bs.modal', function() {
          self.remove()
      }).on('click' , '#go_to_parameter' , function(){
        self.renderParameterList()
      }).on('click' , '#back_to_select_object' , function(){
        $('.formula_first_step').removeClass('hide')
        $('.formula_last_step').addClass('hide')
        $('.nav-tabs').removeClass('hide')
        $('#content_formula').empty()
        self.openTabByObject()
      })
      
      
      this.listenTo( this.model , 'change' , function(mod){
        
        if(
          mod.get('object') != mod.previous('object') ||
          mod.get('id') != mod.previous('id')
        ){
          mod.set('pid' , mod.defaults.pid )
        }
        
        $('#go_to_parameter')[
          this.model.get('id') && 
          this.model.get('object')
          ? 'removeClass'
          : 'addClass'
        ]('hide')
        
        
        $('#save_block_formula')[
          this.model.get('pid')
          ? 'removeClass'
          : 'addClass'
        ]('hide')
      })
      
    },
  
  
    events : {
      
      'click .nav-tabs li' : function( e , is_scip_render , f ){
        
        var is_scip_render = is_scip_render || false
        
        
        if( $( e.target ).closest('li').hasClass('active') ){
          return false;
        }
        
        
        
        $('.nav-tabs li').removeClass('active')
        $(e.target).closest('li').addClass('active')
        
        
        if( typeof $('#content_formula').data('jstree') != 'undefined' ){
          $('#content_formula').jstree(true).destroy();
        }
        
        $('#content_formula').empty()
        
        if( is_scip_render === false ){
          switch( $(e.target).closest('li').index() ){
            case 0 : 
              this.renderPlaceTree()
            break;
            case 1 :
              this.renderConvTree()
            break;
            case 2 :
              this.renderVirtConvTree()
            break;
          }
        }
      }
      
    },
  
  
  
  });

});