define([
  "backbone",
  "conversions",
  "conversion_modal_delete",
  "conversion_modal_edit"
],function(
  Backbone,
  conversions,
  conversion_modal_delete,
  conversion_modal_edit
){
  
  const CONVERSION_PREFIX_DELETE  = "conversion_delete_item_"
  const CONVERSION_PREFIX_EDIT    = "conversion_edit_item_"
  const CONVERSION_PREFIX         = "container_conversion_list_item_"

  return Backbone.View.extend({
  
  
    collection : conversions,
  
  
    initialize : function(){
      this.listenTo( this.collection , 'edit_model' , function( change_model ){
        
        let data = { data : [ change_model.get('id') ] }
        
        let self = this
        
        $.get(
        '/tpl/?tpl=conversion_list_item' , 
        data , 
        function(data){
          
          if( !$('#' + $(data).attr('id')).length ){
            $(self.$el).find('tr').last().after( $(data) )
            return true;
          }
          
          $('#' + $(data).attr('id')).replaceWith( $(data) )
        })
        
      })
      
      
      this.listenTo( this.collection , 'remove' , function( drop_model ){
        $('#' + CONVERSION_PREFIX + drop_model.get('id')).fadeOut(300)
      })
      
    },
  
    events : {
      
      
      
      'click .conversion_delete_item' : function( e ){
        
        let id = $(e.target).closest('td').attr('id').replace(CONVERSION_PREFIX_DELETE,'')
        
        $(e.target).closest('td').addClass( DIS_DIV )
        
        var e = e
        
        conversions.fetch({
          data : {
            filter : "id:" + id
          },
          success : function( data ){
            new conversion_modal_delete( data.last() , function(){
              $(e.target).removeClass( DIS_DIV )
            } )
          }
        })
        
        return false;
        
      },
      
      
      
      
      
      
      'click .conversion_edit_item' : function( e ){
        
        let id = $(e.target).closest('td').attr('id').replace(CONVERSION_PREFIX_EDIT,'')
        
        $(e.target).closest('td').addClass( DIS_DIV )
        
        var e = e
        
        conversions.fetch({
          data : {
            filter : "id:" + id
          },
          success : function( data ){
            new conversion_modal_edit( data.last() , function(){
              $(e.target).closest('td').removeClass( DIS_DIV )
            } )
          }
        })
        
        return false;
        
      },
      
      
      'click #block_add_conversion'  :function( e ){
        
        $(e.target).closest('td').addClass( DIS_DIV )
        
        new conversion_modal_edit( new conversions.model , function(){
              $(e.target).closest('td').removeClass( DIS_DIV )
            } )
        return false;
      }
      
      
    },
  
    el : '#conversion_list',
  
  
  
  });
  
});