define([
  "backbone",
  "conversions",
  "validator"
],function(
  Backbone,
  conversions
){

  return Backbone.View.extend({
  
  
    initialize : function( model ,callback ){
      this.model = model
      this.render( callback )
    },
  
  
    tagName : 'div',
  
  
    render : function( callback ){
      
      let data = { data : [ this.model.get('id') ] }
      
      let self = this
        
      $.get(
      '/tpl/?tpl=conversion_edit' , 
      data , 
      function(data){
        
        if( callback ) callback()
        
        var data = $(data)
        
        $(data).find('[type="submit"]').remove()
        
        $(data).modal('show').on('click','#run_conversion' , function(){
          if( $(data).isValid() ){
            self.model.set({
              title   : $('[name="Title"]').val(),
              divider : $('[name="Divider"]').val(),
              round   : $('[name="Round"]').val(),
            })
            
            self.model.save().then(function(){
              $(data).modal('hide')
              conversions.trigger('edit_model' , self.model)
            })
          }
        }).on('hidden.bs.modal' , function(){
          $(data).remove()
        })
        
        $.validate()
        
      })
      
    },
  
  
  
  });

});