define([
  "backbone",
  "converters",
  "converter",
  "meter_modal_add",
  "converter_modal_edit",
  "converter_modal_delete",
  "meters",
  "validator"
],function(
  Backbone,
  converters,
  converter,
  meter_modal_add,
  converter_modal_edit,
  converter_modal_delete,
  meters
){
  
  
  /*
    Вид с выводом списка конверторов
  */
  
  
  
  
  /*
    Префикс идентификаторов узлов учета
  */
  const CONVERTER_PREFIX = 'converter_'
  
  
  
  
  
  
  /*
    Перезапись строки при ее изменеии
  */
  const replace_tr_converter = function( _converter ){
    
    if( !_converter.get('id') ) return false;
    
    let object = { data : [ _converter.get('id') ] }
        
    $.get(
    '/tpl/?tpl=converter_list_item' , 
    object , 
    function(data){
      
      if( !$( '#'+$(data).attr('id') ).length ){
        $( '#converter_list' ).find('tbody').find('tr[id]').last().after(
          $( '<tr/>' ).attr({
            id : $(data).attr('id')
          })
        )
      }
      
      $( '#'+$(data).attr('id') ).replaceWith( $(data) )
    })
  }
  
  
  
  
  /*
    Удаление конвертора
  */
  const remove_converter = Backbone.View.extend({
    
    el : '#converter_list',
    
    /*
      @param object convereter
    */
    set_model : function( model ){
      
      this.model = model
      
      let self = this
      
      this.listenTo( this.model , 'destroy' , function( drop_model ){
        $( '#' + CONVERTER_PREFIX + drop_model.get('id')).remove()
      })
      
    },
    
    
    events : {
      'click .converter_is_delete' : function( e ){
        
        $( e.target ).closest('td').addClass( DIS_DIV )
        
        let id = $(e.target).closest('tr').attr('id').replace( CONVERTER_PREFIX ,'')
        
        let conv = new converter({ id : id })
        
        let self = this
        
        conv.fetch({
          success : function(a,b){
            self.set_model( new converter(b[0]) )
            new converter_modal_delete( self.model , function(){
              $( e.target ).closest('td').removeClass( DIS_DIV )
            })
          }
        })
        
        return false;
        
      }
    }
    
    
  })
  
  
  
  
  
  
  
  
  
  /*
    Редактирвоание конверторов
  */
  const edit_converter = Backbone.View.extend({
    
    
    el : '#converter_list',
    
    
    /*
      @param object convereter
    */
    set_model : function( model ){
      
      this.model = model
      
      let self = this
      
      this.listenTo( this.model , 'change' , function( edit_model ){
        replace_tr_converter( edit_model )
      })
      
    },
    
    
    events : {
      'click .converter_edit_item' : function( e ){
        
        $(e.target).closest('td').addClass( DIS_DIV )
        
        let id = $(e.target).closest('tr').attr('id').replace( CONVERTER_PREFIX ,'')
        
        let conv = new converter({ id : id })
        
        let self = this
        
        conv.fetch({
          success : function(a,b){
            self.set_model( new converter(b[0]) )
            new converter_modal_edit( self.model , function(){
              $(e.target).closest('td').removeClass( DIS_DIV )
            })
          }
        })
        
        return false;
        
      }
    }
  
  })
  
  
  
  
  
  
  
  
  
  
  
  
  /*
    Добавление конвертора
  */
  const add_converter = Backbone.View.extend({
    
    el : '#converter_list',
    
    
    set_model : function( model ){
      this.model = model
      
      this.listenTo( this.model , 'sync' , function( add_converter ){
      
          replace_tr_converter( add_converter )
        
      })
      
    },
    
    events : {
      
      'click #add_converter_modal' : function( e ){
        
        this.set_model( new converters.model )
        
        $( e.target ).closest('td').addClass( DIS_DIV )
        
        new converter_modal_edit( this.model , function(){
          $( e.target ).closest('td').removeClass( DIS_DIV )
        })
        return false;
      }
      
    }
    
    
  })
  
  
  
  
  
  /*
    Основной вид вывода списка конверторов
  */
  return Backbone.View.extend({
    
    
    collection : converters,
    
    
    initialize : function(){
      
      new remove_converter()
      new edit_converter()
      new add_converter()
      
    },
    
    
    
    el : '#converter_list'
    
  })
  
})