define([
  'backbone',
  'converters',
  'meters',
  'meter',
  'meter_modal_edit',
  'meter_modal_delete',
  'meter_modal_add'
],function(
  Backbone,
  converters,
  meters,
  meter,
  meter_modal_edit,
  meter_modal_delete,
  meter_modal_add
){
  
  
  /*
    Модуль отвечающий за отображение приборов учета в списке конвертора
  */
  
  
  
  const METER_PREFIX_ITEM_TABLE = 'converter_meter_item_'
  
  
  
  /*
    Общий вид таблицы с дочерними элементами
  */
  return Backbone.View.extend({
    el : '.container_converter_meters',
    
    /*
      Назначение модели на вид
      @param model converter
    */
    setmodel : function( model ){
      this.model = model
      $(this.$el).removeClass( DIS_DIV )
    },
    
    
    
    
    initialize : function(){
      
      /*
        Пока не получили модель блокируем $el
      */
      $(this.$el).addClass( DIS_DIV )
      
      
      var self = this
      
      
      /*
        Удаление прибора учета
      */
      this.listenTo( converters , 'delete_meter' , function( drop_model ){
        $('#' + METER_PREFIX_ITEM_TABLE + drop_model.get('id')).fadeOut(300)
        
        let data_j = { data : [ drop_model.get('converter') ] }

        $.get(
          '/tpl/?tpl=converter_children_head' , 
          data_j , 
          function(s){
            $( self.$el ).find('thead').replaceWith( $(s) )
          }
        )
        
      })
      
      
      
      /*
        Добавление прибора учета
      */
      this.listenTo( converters , 'add_meter' , function( add_model ){
        
        var self = this
        
        let data_j = { data : [ add_model.get('id') ] }
        
        $.get(
          '/tpl/?tpl=converter_children_item' , 
          data_j , 
          function(data){
            
            $(data).hide();
            
            $.when( $( self.$el ).find('tbody').append( $(data) ) ).then(function(){
              
              let data_j = { data : [ add_model.get('converter') ] }
              
              $.get(
                '/tpl/?tpl=converter_children_head' , 
                data_j , 
                function(s){
                  $( self.$el ).find('thead').replaceWith( $(s) )
                }
              )
      
            })
            $(data).fadeIn(300)
          
          })
        
        })
      
      
      
      /*
        Добавление прибора учета
      */
      this.listenTo( meters , 'change_model' , function( change_model ){
        
        var self = this
        
        let data = { data : [ change_model.get('id') ] }
        
        $.get(
          '/tpl/?tpl=converter_children_item' , 
          data , 
          function(data){
            
            $(data).hide();
            
            $( '#' +  $(data).attr('id') ).replaceWith( $(data) )
          
        })
        
      })
      
      
      
      
      
           
    },
    
    
    
    
    
    events : {
      
      
      /*
        Деактивирование прибора учета
        @param Event
      */
      'click #converter_add_meter' : function( e ){
        $( e.target ).closest('td').addClass( DIS_DIV )
        new meter_modal_add( this.model , function(){
          $( e.target ).closest('td').removeClass( DIS_DIV )
        })
        return false;
      },
      
      
      
      
      'click .converter_meter_edit' : function( e ){
        
        $( e.target ).closest('td').addClass( DIS_DIV )
        
        var id = $(e.target).closest('tr').attr('id').replace(METER_PREFIX_ITEM_TABLE,'')
        
        meters.fetch({
          data : {
            filter : "id:" + id
          },
          success : function( data ){
            new meter_modal_edit( data.last() ,function(){
              $( e.target ).closest('td').removeClass( DIS_DIV )
            })
          }
        })
        return false;
      },
      
      
      
      'click .converter_meter_delete' : function( e ){
        
        $( e.target ).closest('td').addClass( DIS_DIV )
        
        var id = $(e.target).closest('tr').attr('id').replace(METER_PREFIX_ITEM_TABLE,'')
        
        meters.fetch({
          data : {
            filter : "id:" + id
          },
          success : function( data ){
            new meter_modal_delete( data.last() , function(){
              $( e.target ).closest('td').removeClass( DIS_DIV )
            })
          }
        })
        return false;
      },
      
      
      
      
    }
    
    
  })
  
  
})