// Generated by CoffeeScript 1.12.7
var CONVERTER, CONVERTERS, CONVERTER_COUNTERS, CONVERTER_LIST, CONVERTER_MODAL_BODY, CONVERTER_PAGES, CONVERTER_TYPE, CONVERTER_TYPES, MODAL_CONVERTER_ADD, MODAL_CONVERTER_DELETE, converter_cookie_path, converter_types, converters;

CONVERTER_TYPE = Backbone.Model.extend({
  defaults: {
    id: null,
    title: null,
    ident: null
  }
});

CONVERTER_TYPES = Backbone.Collection.extend({
  model: CONVERTER_TYPE,
  url: "/api/converter_type/"
});

CONVERTER = Backbone.Model.extend({
  get_error_valid: function() {
    switch (this.validate()) {
      case "EMPTY_TYPE":
        return "Не выбран тип прибора";
      case "EMPTY_IP":
        return "Не указан ip адрес";
      case "EMPTY_PORT":
        return "Не указан порт";
      case "INVALID_PORT":
        return "Не верно указан порт";
      case "RANGE_PORT":
        return "Порт должень быть от 0 до 65535";
      case "INVALID_IP":
        return "Не верный формат ip адреса";
    }
  },
  url: function() {
    var id;
    id = this.get('id') ? this.get('id') : 0;
    return "/api/converter/" + id + "/";
  },
  defaults: {
    id: null,
    about: null,
    title: null,
    port: 50,
    login: null,
    pass: "public",
    timeoutconnect: 5000,
    timeoutreceive: 3000,
    portcontrol: 80,
    ip: null,
    type: null,
    meters_all: null,
    meters_err: null,
    meters_exc: null,
    excluded: false
  },
  empty_about: true,
  __set_about: function(attrs) {
    var ip;
    if (attrs == null) {
      attrs = {};
    }
    if (!this.empty_about) {
      return false;
    }
    ip = this.get('ip') === null ? "" : this.get('ip');
    this.set({
      "about": ip + ":" + this.get("port")
    }, attrs);
    return true;
  },
  parse: function(a) {
    this.empty_about = a.about === "";
    return a;
  },
  validate: function() {   
    
    if( !this.valide_ip() ){      
      return  'invalid ip'      
    } 
    
    if( !this.valide_port() ){
      return 'invalid port'
    }
  },
  
  valide_ip : function(){
    var RegE = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/
    return RegE.test(this.get('ip'))
  },
  valide_port : function(){
    var port = this.get('port')
    return parseInt(port) > 0 && parseInt(port) < 65535
  }

});

converter_cookie_path = window.location.pathname;

if (!$.cookie('convertrer_sort_ad')) {
  $.cookie('convertrer_sort_ad', "asc", {
    path: converter_cookie_path
  });
}

if (!$.cookie('convertrer_sort_field')) {
  $.cookie('convertrer_sort_field', null, {
    path: converter_cookie_path
  });
}

if (!$.cookie('convertrer_page')) {
  $.cookie('convertrer_page', 1, {
    path: converter_cookie_path
  });
}

if (!$.cookie('convertrers_in_page')) {
  $.cookie('convertrers_in_page', 10, {
    path: converter_cookie_path
  });
}

CONVERTERS = Backbone.Collection.extend({
  model: CONVERTER,
  url: "/api/converter/",
  sort_field: $.cookie('convertrer_sort_field'),
  sort_ad: $.cookie('convertrer_sort_ad'),
  __set_sort: function() {
    $.cookie('convertrer_sort_ad', this.sort_ad, {
      path: converter_cookie_path
    });
    return $.cookie('convertrer_sort_field', this.sort_field, {
      path: converter_cookie_path
    });
  },
  __set_page: function(page) {
    return $.cookie('convertrer_page', page, {
      path: converter_cookie_path
    });
  },
  _pages: function() {
    if (!Number($.cookie('convertrers_in_page'))) {
      return [];
    }
    return _.range(this.length / $.cookie('convertrers_in_page'));
  },
  _counters: function() {
    var res;
    res = [];
    if (this.length > 10) {
      res.push(10);
    }
    if (this.length > 50) {
      res.push(100);
    }
    if (this.length > 100) {
      res.push(500);
    }
    if (this.length > 500) {
      res.push(1000);
    }
    res.push(0);
    return res;
  },
  __get_count: function() {
    return $.cookie('convertrers_in_page');
  },
  __get_count_ajax: function() {
    if ($.cookie('convertrers_in_page') === "Infinity") {
      return 0;
    }
    return this.__get_count();
  },
  __get_page: function() {
    if (typeof $.cookie('convertrer_page') === "undefined" || !Number($.cookie('convertrer_page'))) {
      return 1;
    } else {
      return Number($.cookie('convertrer_page'));
    }
  },
  __set_count: function(count) {
    return $.cookie('convertrers_in_page', count, {
      path: converter_cookie_path
    });
  },
  __sort_and_pages: function() {
    return this.toArray();
    if (!Number($.cookie('convertrers_in_page'))) {
      return this.__sort();
    }
    return this.__sort().reduce(function(res, item, index) {
      var first_index, last_index;
      first_index = $.cookie('convertrers_in_page') * ($.cookie('convertrer_page') - 1);
      last_index = $.cookie('convertrers_in_page') * $.cookie('convertrer_page') - 1;
      if (index >= first_index && index <= last_index) {
        res.push(item);
      }
      return res;
    }, []);
  },
  __sort: function() {
    var count, res, res_group, res_group_a;
    if (Number($.cookie('convertrer_page') > this._pages().length || !Number($.cookie('convertrer_page')))) {
      count = !this._pages().length ? 1 : this._pages().length;
      $.cookie('convertrer_page', count, {
        path: converter_cookie_path
      });
    }
    res = [];
    if (this.sort_field === "type") {
      res = [];
      res_group = _.groupBy(this.toArray(), function(item) {
        return item.get('type');
      });
      res_group_a = Object.keys(res_group);
      if (this.sort_ad === "desc") {
        res_group_a = res_group_a.reverse();
      }
      res_group_a.map(function(key) {
        return res = res.concat(res_group[key]);
      });
      res;
    } else {
      res = _.sortBy(this.toArray(), this.sort_field);
      if (this.sort_ad === "desc") {
        return res.reverse();
      }
    }
    return res;
  }

});

CONVERTER_MODAL_BODY = Backbone.View.extend({
  el: "#converter_modal_body",
  template: "#converter_modal_body_main_tpl",
  model: new CONVERTER,
  parent_view: null,
  __set_btn_save_parent_view: function() {
    if (this.model.isValid()) {
      return this.parent_view.enabled_save();
    } else {
      return this.parent_view.disabled_save();
    }
  },
  initialize: function(converter, parent_view) {
    this.model = converter;
    this.parent_view = parent_view;
    return this.render();
  },
  render: function() {
    var f_converter_types, tpl_c;
    tpl_c = _.template($(this.template).html());
    $(this.$el).empty().append(tpl_c({
      converter: this.model
    }));
    f_converter_types = converter_types.first();
    if (typeof f_converter_types === "undefined") {
      return;
    }
    return this.model.set("type", f_converter_types.get('id'));
  },
  __set_port: function(e) {
    this.model.set("port", Number($(e.target).val()));
    if (this.model.__set_about()) {
      $('#about').val(this.model.get('about'));
    }
    return this.__set_btn_save_parent_view();
  },
  events: {
    "keyup #ip": function(e) {
      this.model.set("ip", $(e.target).val());
      if (this.model.__set_about()) {
        $('#about').val(this.model.get('about'));
      }
      return this.__set_btn_save_parent_view();
    },
    "keyup #port": function(e) {
      return this.__set_port(e);
    },
    "click #ping": function(e) {
      $.get("/api/ping/?ip=" + this.model.get('ip') + "&port=" + this.model.get('port') + "&type=" + this.model.get('type') ,function( data){
        if( !Number(data) ){
           $('#ping_res').removeClass('text-success tex-muted').addClass('text-danger');
        }else{
          $('#ping_res').removeClass('text-danger tex-muted').addClass('text-success');
        }
      })
    },
    "mouseup #port": function(e) {
      return this.__set_port(e);
    },
    "change #type": function(e) {
      var id;
      id = $(e.target).find(':selected').val();
      this.model.set("type", id);
      return this.__set_btn_save_parent_view();
    },
    "keyup #login": function(e) {
      this.model.set("login", $(e.target).val());
      return this.__set_btn_save_parent_view();
    },
    "keyup #pass": function(e) {
      this.model.set("pass", $(e.target).val());
      return this.__set_btn_save_parent_view();
    },
    "keyup #about": function(e) {
      this.model.set("about", $(e.target).val());
      this.model.empty_about = !$(e.target).val();
      return this.__set_btn_save_parent_view();
    },
    "keyup #timeoutconnect": function(e) {
      this.model.set("timeoutconnect", Number($(e.target).val()));
      this._setter_class_action_btn();
      return this.__set_btn_save_parent_view();
    },
    "keyup #timeoutreceive": function(e) {
      this.model.set("timeoutreceive", Number($(e.target).val()));
      this._setter_class_action_btn();
      return this.__set_btn_save_parent_view();
    },
    "keyup #portcontrol": function(e) {
      this.model.set("portcontrol", Number($(e.target).val()));
      return this.__set_btn_save_parent_view();
    },
    "change #IsExcluded": function(e) {
      this.model.set("excluded", $('#IsExcluded').prop('checked') ? true : false);
      $('#excluded_alert')[this.model.get('excluded') ? "slideDown" : "slideUp"](300);
      return this.__set_btn_save_parent_view();
    }
  }
});

MODAL_CONVERTER_ADD = Backbone.View.extend({
  template: '#converter_add_modal',
  initialize: function(converter, collection) {
    this.model = converter.clone();
    if (collection) {
      this.collection = collection;
    }
    this.render();
    return this;
  },
  _fields_en_dis: ["type", "ip", "port", "login", "pass", "ping", "save", "about", "timeoutconnect", "timeoutreceive", "portcontrol", "IsExcluded"],
  _disabled_all_fields: function() {
    this._fields_en_dis.map(function(f) {
      return $('#' + f).prop('disabled', true);
    });
    $('#ping_res').removeClass('text-success text-danger').addClass('text-muted');
    return $('#danger_ping').slideUp(300);
  },
  _enabled_all_fields: function() {
    return this._fields_en_dis.map(function(f) {
      return $('#' + f).prop('disabled', null);
    });
  },
  disabled_save: function() {
    $('#save').addClass('btn-disabled').removeClass('btn-success');
    return $('#ping').addClass('btn-disabled').removeClass('btn-info');
  },
  enabled_save: function() {
    $('#save').removeClass('btn-disabled').addClass('btn-success');
    return $('#ping').removeClass('btn-disabled').addClass('btn-info');
  },
  render: function() {
    var modal, self, tpl_c;
    tpl_c = _.template($(this.template).html());
    modal = $(tpl_c({
      converter: this.model,
      converter_types: converter_types
    })).modal("show");
    self = this;
    return $(modal).on("click", ".more_settings_controller", function(e) {
      var i;
      i = $(e.target).find('i');
      if ($(i).hasClass(self.down_icon)) {
        return self.__slideDown(modal);
      } else {
        return self.__slideUp(modal);
      }
    }).on("click", "#save", function() {

      if( !self.model.isValid() ){
        return false;
      }

      var data, model;
      data = self.model.toJSON();
      if (!self.model.get('id')) {
        self.collection.create(data, {
          success: function(resp) {
            if (resp && resp.get('id')) {
              $(modal).modal('hide');
              return swal({
                title: "Добавлено",
                text: "",
                timer: 800,
                type: "success",
                showConfirmButton: false
              });
            }
          }
        });
      } else {
        model = self.collection.findWhere({
          id: Number(data.id)
        });
        model.save(data, {
          success: function(_model) {
            $(modal).modal('hide');
            return swal({
              title: "Изменено",
              text: "",
              timer: 800,
              type: "success",
              showConfirmButton: false
            });
          }
        });
      }
      return self.collection.trigger('change');
    }).on("shown.bs.modal", function() {
      var id;
      id = $(modal).find('#type').find(':selected').val();
      self.model.set("type", id, {
        silent: true
      });
      return new CONVERTER_MODAL_BODY(self.model, self);
    }).on("hidden.bs.modal", function() {
      self.collection.fetch()
      return $(modal).remove();
    });
  },
  up_icon: "fa-chevron-circle-up",
  down_icon: "fa-chevron-circle-down",
  __slideUp: function(modal) {
    modal = modal;
    $('.' + this.up_icon).removeClass(this.up_icon).addClass(this.down_icon);
    $(modal).find('.more_settings').slideUp(500);
    return this;
  },
  __slideDown: function(modal) {
    $('.' + this.down_icon).removeClass(this.down_icon).addClass(this.up_icon);
    $(modal).find('.more_settings').hide().removeClass('hide').slideDown(500);
    return this;
  }
});

MODAL_CONVERTER_DELETE = Backbone.View.extend({
  template: "#converter_delete_modal",
  initialize: function(converter, collection) {
    this.model = converter;
    this.collection = collection;
    return this.render();
  },
  render: function() {
    var modal, self, tpl_c;
    tpl_c = _.template($(this.template).html());
    self = this;
    modal = $(tpl_c({
      converter: this.model
    })).modal('show');
    $(modal).on("click", "#delete", function() {
      self.collection.remove(self.model);
      return self.model.destroy({
        dataType: "text",
        success: function(r, res) {
          if (res === "droped") {
            $(modal).modal('hide');
            swal({
              title: "Удалено",
              text: "",
              timer: 800,
              type: "success",
              showConfirmButton: false
            });
            return $(modal).modal('hide');
          }
        }
      });
    }).on("hidden.bs.modal", function() {
      self.collection.fetch()
      return $(modal).remove();
    });
    return this;
  }
});

converters = new CONVERTERS();

converter_types = new CONVERTER_TYPES();

converter_types.load = false;

converter_types.fetch({
  success: function() {
    return converter_types.load = true;
  }
});

$(document).ready(function() {
  return new CONVERTER_LIST();
});

CONVERTER_LIST = Backbone.View.extend({
  el: '#converter_list',
  collection: converters,
  template: "#converter_list_tpl",
  initialize: function() {
    var self, tpl_c;
    self = this;
    tpl_c = _.template($("#converter_list_sample_tpl").html());
    $(self.$el).empty().append(tpl_c());
    this.listenTo(this.collection, 'change', this.render);
    this.collection.fetch({
      success: function() {
        new CONVERTER_PAGES(self.collection);
        self.render();
        self.listenTo(self.collection, "sync add delete change", self.render);
        return self.listenTo(self.collection, "reconstruct", self.render);
      },
      data: {
        page: $.cookie('convertrer_page'),
        sort: self.collection.sort_ad,
        field: self.collection.sort_field,
        count: this.collection.__get_count_ajax()
      },
      async: true
    });
    return this;
  },
  render: function() {
    var tpl_c;
    tpl_c = _.template($(this.template).html());
    $(this.$el).empty().append(tpl_c({
      converters: this.collection,
      converter_types: converter_types
    }));
    return this;
  },
  lock: function() {
    return $(this.el).append($('#converter_list_sample_tpl').html());
  },
  _sortable_click: function(e) {
    var c, self;
    this.lock();
    this.collection.sort_field = $(e.target).attr('data-sort');
    switch (this.collection.sort_ad) {
      case null:
        this.collection.sort_ad = "desc";
        break;
      case "asc":
        this.collection.sort_ad = "desc";
        break;
      case "desc":
        this.collection.sort_ad = "asc";
    }
    this.collection.__set_sort();
    c = this.collection.clone().reset();
    self = this;
    return c.fetch({
      success: function() {
        self.collection.reset().add(c.toArray());
        return c = null;
      },
      data: {
        page: $.cookie('convertrer_page'),
        sort: this.collection.sort_ad,
        field: this.collection.sort_field,
        count: this.collection.__get_count_ajax()
      }
    });
  },
  events: {
    "click th.sortable": function(e) {
      this._sortable_click(e);
      return false;
    },
    "click th.sortable-asc": function(e) {
      this._sortable_click(e);
      return false;
    },
    "click th.sortable-desc": function(e) {
      this._sortable_click(e);
      return false;
    },
    "click .converter_edit_item": function() {
      return false;
    },
    "click .converter_is_delete": function() {
      return false;
    },
    "click #add_converter_modal": function() {
      new MODAL_CONVERTER_ADD(new CONVERTER, this.collection);
      return false;
    },
    "click .converter_edit_item": function(e) {
      var cid;
      cid = $(e.target).closest('tr').attr('data-cid');
      new MODAL_CONVERTER_ADD(this.collection.get(cid).clone(), this.collection);
      return false;
    },
    "click .converter_delete_item": function(e) {
      var cid;
      cid = $(e.target).closest('tr').attr('data-cid');
      new MODAL_CONVERTER_DELETE(this.collection.get(cid), this.collection);
      return false;
    }
  }
});

CONVERTER_COUNTERS = Backbone.View.extend({
  el: "#converter_counters",
  template: "#counters_tpl",
  initialize: function(collection) {
    this.collection = collection;
    this.render();
    return this.listenTo(this.collection, 'change', this.render);
  },
  render: function() {
    var tpl_c;
    tpl_c = _.template($(this.template).html());
    return $(this.$el).empty().append(tpl_c({
      by_count: this.collection.__get_count(),
      counters: this.collection._counters()
    }));
  },
  events: {
    "click a": function(e) {
      this.collection.__set_count($(e.target).attr('data-count'));
      this.collection.trigger('change');
      return false;
    }
  }
});

CONVERTER_PAGES = Backbone.View.extend({
  el: "#pagination",
  collection: converters,
  initialize: function(collection) {
    this.collection = collection;
    this.listenTo(this.collection, 'reconstruct', this.render);
    this.listenTo(this.collection, 'lock', this.lock);
    return this.render();
  },
  render: function() {
    var data, self;
    self = this;
    this.lock();
    data = {
      page: self.collection.__get_page(),
      data: [0],
      tpl: 'converter_list_pages',
      count: self.collection.__get_count_ajax()
    };
    return $.get('/tpl/', data, function(tpl) {
      return $(self.el).empty().append(tpl);
    });
  },
  lock: function() {
    return $(this.el).prepend($('#converter_list_sample_tpl').html());
  },
  events: {
    "click a": function(e) {
      var c, self, text;
      if ($(e.target).closest('li').hasClass('active')) {
        return false;
      }
      text = $(e.target).closest('a').text().trim();
      if (text !== "Все") {
        if (isNaN($(e.target).closest('a').text().trim())) {
          return false;
        }
      } else {
        text = Number.POSITIVE_INFINITY;
      }
      this.collection.trigger('lock');
      if ($(e.target).closest('ul').hasClass('paginator_pages')) {
        this.collection.__set_page(Number(text));
      } else {
        this.collection.__set_count(Number(text));
      }
      c = this.collection.clone().reset();
      self = this;
      c.fetch({
        success: function() {
          self.collection.reset().add(c.toArray());
          self.collection.trigger('reconstruct');
          return c = null;
        },
        async: true,
        data: {
          page: $.cookie('convertrer_page'),
          sort: this.collection.sort_ad,
          field: this.collection.sort_field,
          count: this.collection.__get_count_ajax()
        }
      });
      return false;
    }
  }
});
