define([
  'backbone',
  'converters',
  'converter_modal_edit',
  'converterhelpers'
],function(
  Backbone,
  converters,
  converter_modal_edit,
  converterhelpers
){
  
  
  
  /*
    Пинг конвертора
  */
  const ping = function( model , type_e ){
    
    
    /*
      какой тип выбрать следующим
    */
    let get_next_type = function( type_e ){
      switch( type_e ){
        case undefined  : return 'ping_tcp';
        //~ case 'ping_tcp' : return 'ping_udp';
        //~ case 'ping_udp' : return 'ping';
        default         : return 'stop';
      }
    }
    
    
    /*
      Преобразование типа для понимания пользователя
    */
    let get_type_e_to_str = function( type_e ){
      switch( type_e ){
        case 'ping_tcp' : return 'TCP';
        case 'ping_udp' : return 'UDP';
        case 'ping'     : return 'ICMP';
      }
    }

    var type_e = type_e || get_next_type();
    
    
    // Окончание срипта
    if( type_e == 'stop' ){
      $('.ui-dialog button').button('enable');
      return false;
    }
    
    let json = model.toJSON()
    
    json[ type_e ] = true
    
    
    
    /*
      Проверка соединения
      Отдача пользователю ответа
      Рекурсивынй проход по другим типам соединения
    */
    $('.container_error').slideUp(300).empty()
    model.fetch({
      data : json,
      success : function(a,b,c){
        
        $('.container_error').slideDown(300).append(
          $('<div/>').addClass('alert alert-success').text(
            b.responseText
          )
        )
        ping( model , get_next_type( type_e ) )
      },
      error : function(a,b,c){
        $('.container_error').slideDown(300).append(
          $('<div/>').addClass('alert alert-danger').text(
            b.responseText
          )
        )
        ping( model , get_next_type( type_e ) )
      }
    })
    
  }
  
  
  
  
  return Backbone.View.extend({
    
    tagName : 'div',
    
    initialize : function( model , callback ){
      
      
      let self = this
      
      setter_model = function(){
        var o = {
          about           : $('[name="About"]').val(),
          type            : $('[name="TypeId"]').find(':selected').val(),
          ip              : $('[name="Ip"]').val(),
          port            : $('[name="Port"]').val(),
          login           : $('[name="Login"]').val(),
          password        : $('[name="Password"]').val(),
          timeoutconnect  : $('[name="Timeoutconnect"]').val(),
          timeoutreceive  : $('[name="Timeoutreceive"]').val(),
          portcontrol     : $('[name="Portcontrol"]').val(),
          is_excluded     : $('#IsExcluded').prop('checked')
        }
        self.model.set( o )
      }
      
      
      
      this.model = model
      
      
      let data = {data : [ this.model.get('id') ] }
      
      
      $('#myModal').remove()
      
      $.get(
      '/tpl/?tpl=converter_edit_form' , 
      data , 
      function(data){
        
        var data = $(data)
        
        $(data).find('[type="submit"]').remove()
        
        $(data).appendTo('body')
        
        $('#myModal').modal('show').on('hidden.bs.modal', function () {
          $('#myModal').remove()
        }).on('click' , '.more_settings_controller' , function(){
          $('.more_settings').toggleClass('hide')
          $(this).find('i').toggleClass('fa-chevron-circle-down')
          $(this).find('i').toggleClass('fa-chevron-circle-up')
        }).on('click' , '#ping' , function(){
          setter_model()
          ping( self.model , 'ping_tcp' )
        }).on('change' , 'select[name="TypeId"]' , function( e ){
          if( $(e.target).val() ){
            converterhelpers.fetch({
              data : {
                filter : "convertertype:" + $(e.target).val()
              },
              success : function( data ){
                
                var i = data.first()
                
                $('#helper_add_converter')[ i ? 'show' : 'hide' ]().html( i ? i.get('text') : '' )
                
                var f_1 = i && $(e.target).val() ? 'addClass' : 'removeClass'
                var f_2 = i && $(e.target).val() ? 'removeClass' : 'addClass'
                $('#main_converter_set')[f_1]('col-lg-6')[f_2]('col-lg-12')
                
                
              }
            })
          }
        })
        
        
        if( callback ) callback()
        
        
        
        $('#save_vconverter').click(function(){
            if( $(data).isValid() ){
              
              var t = '#myModal';
              
              setter_model()

              if( !$(data).find('[name="IsExcluded"]').is(':checked') ){
                delete self.model.is_excluded
                self.model.unset('is_excluded',{ silent: true })
              }
              
              self.model.save()
              
              $(data).modal('hide')
              
            }
        })
        
        $.validate()
        
      })
      
      
      
    },
    
    
    events : {
      
      'keyup [name="Port"]' : function( e ){
      
          this.model.set({
            port : $(e.target).val()
          })
        
      },
      
      
      
      'keyup [name="Ip"]' : function( e ){
      
          this.model.set({
            ip : $(e.target).val()
          })
        
      },
      
    }
    
    
  })
  
  
})