define([
  "backbone",
  'text!/js/tpl/converter/add.tpl',
  'converter_types',
  'converter_add',
  'converters'
],function(
  Backbone , 
  tpl,
  converter_types,
  converter_add,
  converters
){
  
  $('body').append( $(tpl) )
  
  
  return Backbone.View.extend({
    tagName : 'div',
    id : 'converter_add_modal',
    template : '#add_converter_tpl',
    initialize : function( oConverter ){
      
      this.model = oConverter || new converters.model
      
      this.render()
      
      this.listenTo( converter_types , 'sync' , this.render)
      
      var self = this
      
      converter_types.fetch()
      
      $.validate()
      
      this.on('change:model' , function(){
        console.log('change nodelk')
      })
      
      
    },
    render : function(){
      
      
      var self = this
      
      $(this.$el).empty().append(
        $(this.template).tmpl({
          converter_types : converter_types.toArray(),
          oConverter : self.model
        })
      ).dialogYesNo({
        close : function(){
          $(this).dialog('destroy')
            self.remove()
        },
        title : function(){
          if( self.model.get('id') ){
            return "Редактирование " + self.model.title();
          }
          return "Добавление";
        },
        isOk : function(t){
          if( $(t).isValid() ){
            
            if( !self.model.get('id') ){
            
              converters.create( $(t).find('form').serializeObject() , {
                success : function(d){
                  converters.trigger('converters_add')
                }
              })
            }else{
              self.model.set($(t).find('form').serializeObject()).save()
            }
            
            $(t).dialog('destroy')
            self.remove()
            
          }
        }
      })
      
    }
  })
})