define([
  "backbone",
  "groups",
  "group_modal_edit",
  "group_modal_delete",
  "group_add_to_group"
],function(
  Backbone,
  groups,
  group_modal_edit,
  group_modal_delete,
  group_add_to_group
){
  
  
  const PREFIX_USER_EDIT = "container_group_item_";
  
  return Backbone.View.extend({
  
  
    collection : groups,
  
    initialize : function(){
      
      var self = this
      
      this.listenTo( this.collection , 'change_model' , function( change_model){
        
        let data = { data : [ change_model.get('id') ] }
        
        $.get(
        '/tpl/?tpl=group_list_item' , 
        data, 
        function(data){
          $( self.$el ).find( '#' +$(data).attr('id') ).replaceWith( $(data) )
        })
        
      })
      
      
      this.listenTo( this.collection , 'drop_model' , function( drop_model ){
        $( self.$el ).find( '#' + PREFIX_USER_EDIT + drop_model.get('id') ).remove()
      })
      this.listenTo( this.collection , 'add_model' , function( add_model ){
        let data = { data : [ add_model.get('id') ] }
        $.get(
        '/tpl/?tpl=group_list_item' , 
        data, 
        function(data){
          
          var data = $( data )
          
          $(data).hide()
          
          $.when( $( self.$el ).find( 'tbody' ).append( $(data) ) ).then(function( e ){
            $( data ).slideDown(300)
          })
        })
      })
      
    },
  
  
  
  
  
  
  
  
    events : {
      'click .group_edit' : function( e ){
          
        let id = $(e.target).closest('tr').attr('id').replace(PREFIX_USER_EDIT,'')
        
        $(e.target).closest('td').addClass( DIS_DIV )
        
        
        groups.fetch({
          data : {
            filter : "id:" + id
          },
          success : function( models ){
            new group_modal_edit( models.last() , function(){
              $(e.target).closest('td').removeClass( DIS_DIV )
            })
          }
        })
        
        return false;
        
      },
      
      
      
      'click .group_delete' : function( e ){
        
        let id = $(e.target).closest('tr').attr('id').replace(PREFIX_USER_EDIT,'')
        
        $(e.target).closest('td').addClass( DIS_DIV )
        
        groups.fetch({
          data : {
            filter : "id:" + id
          },
          success : function( models ){
            new group_modal_delete( models.last() , function(){
              $(e.target).closest('td').removeClass( DIS_DIV )
            })
          }
        })
        
        
        return false;
        
      },
      
      'click #add_group' : function( e ){
        
        $(e.target).closest('td').addClass( DIS_DIV )
        
        new group_modal_edit( new groups.model , function(){
          $(e.target).closest('td').removeClass( DIS_DIV )
        })
        
        
        return false;
        
      },
      
      
      
      
      
    },
  
    el : '#container_group_list',
  
  
  });

});