define([
  "backbone",
  "mail_edit",
  "mail_delete",
  "mails"
],function(
  Backbone,
  mail_edit,
  mail_delete,
  mails
){

  return Backbone.View.extend({
    
    initialize : function(){
      this.listenTo( mails , 'change_model' , function( change_model ){
        this.render( change_model , false );
      })
      
      
      
      this.listenTo( mails , 'add_model' , function( add_model ){
        this.render( add_model , true );
      })
      
      
      
      
      this.listenTo( mails , 'add_model drop_model' , function( drop_model ){
        var self = this;
        $('#mail_' + drop_model.get('id')).fadeOut(300,function(){
          self.render_head();
        })
      })
      
    },
    
    
    render_head : function(){
      $.get(
        '/tpl/?tpl=mail_list_head',
        {data : [0]},
        function( tpl ){
          $('#mail_list').find('thead').replaceWith( $('<thead/>').append( $(tpl) ) )
        }
      )
    },
    
    
    render : function( model , is_new ){
      var data = { data : [ model.get('id') ] }
      
      var is_new = is_new;
      var model = model;
      
      if( is_new ){
        $('#mail_' + model.get('id')).addClass( DIS_DIV )
      }
      
      var self = this;
      
      $.get(
        '/tpl/?tpl=mail_list_item',
        data,
        function( tpl ){
          if( !is_new ){
            $('#mail_' + model.get('id')).replaceWith( $(tpl) )
          }else{
            $(self.$el).find('tbody').append( $(tpl) )
          }
          
          self.render_head()
        }
      )
    },
  
  
    events : {
      
      'click .edit_mail' : function( e ){
        
        $( e.target ).closest('td').addClass( DIS_DIV )
        
        new mail_edit( $(e.target).closest('tr').attr('id').replace('mail_','') ,function(){
          $( e.target ).closest('td').removeClass( DIS_DIV )
        })
        
        return false;
      },
      
      
      
      'click #add_mail_modal' : function( e ){
        $( e.target ).closest('td').addClass( DIS_DIV )
        
        new mail_edit( 0 ,function(){
          $( e.target ).closest('td').removeClass( DIS_DIV )
        })
        return false;
      },
      
      
      
      'click .delete_mail' : function( e ){
        $( e.target ).closest('td').addClass( DIS_DIV )
        
        new mail_delete( $(e.target).closest('tr').attr('id').replace('mail_','') ,function(){
          $( e.target ).closest('td').removeClass( DIS_DIV )
        })
        return false;
      }
      
    },
  
    el : '#mail_list',
  
  
  });

});