define([
  "backbone",
  "meter",
  "meters",
  "converters",
  "meterhelpers",
  "validator"
],function(
  Backbone,
  meter,
  meters,
  converters,
  meterhelpers
){
  
  
  return Backbone.View.extend({
    
    
    /*
      @param model converter
    */
    initialize : function( model , callback ){
      this.model = model
      this.render( callback )
      
    },
    
    
    tagName : 'div',
    
    
    render : function( callback ){
      
      
      let self = this
      
      let data = {data : [ 0 ] , converter : this.model.get('id') }
      
      
      $('#myModal').remove()
      
      $.get(
      '/tpl/?tpl=meter_edit_form' , 
      data , 
      function(data){
        
        var data = $(data)
        
        $(data).find('[type="submit"]').remove()
        
        $(data).appendTo('body')
        
        $(data).modal('show').on('change','[name="TypeId"]',function(e){
          $('[name="Model"]').find('option').remove()
          $.get("/api/?object=model&filter=mark:" + $(e.target).val() , function( json_collection ){
            for(var i = 0, length1 = json_collection.length; i < length1; i++){
              $('[name="Model"]').append( $('<option></option>').text(json_collection[i].title).attr('value',json_collection[i].id) )
            }
          }, "JSON")

          if( $(this).find(":selected").text().match(/^(.*)-([0-9])I$/) ){
            if( $('#counter').length ){
              return false;
            }
            $(this).after(
                $('<div/>').attr("id" , "counter").append(
                    '<br>'
                  ).append(
                    $('<div/>').addClass('alert alert-warning').append(
                      $('<b/>').text('Внимание!')
                    ).append(
                      $('<p/>').text("После добавления прибора, будет добавлен виртуальный узел учета с виртуальными приборами.")
                    ).append(
                      $('<p/>').text("Узел учета бедет равнозначет, этому прибору, а вложенные виртуальные приборы - входам на приборе.")
                    ).append(
                    '<br>'
                    ).append(
                      $('<b/>').text("Вам останется только привязать эти приборы к реальным приборам и их параметрам.")
                    )
                  )
              )
          }else{
            $('#counter').remove()
          }

        }).on('hidden.bs.modal', function () {
          $(data).remove()
        }).on('click' , '.more_settings_controller' , function(){
          $('.more_settings').toggleClass('hide')
          $(this).find('i').toggleClass('fa-chevron-circle-down')
          $(this).find('i').toggleClass('fa-chevron-circle-up')
        }).on('click' , '#save_meter' , function(){
          if( $('#myModal').isValid() ){
              
            var o = {
              type                : $(data).find('[name="TypeId"]').find(':selected').val(),
              num_serial          : $(data).find('[name="NumSerial"]').val(),
              num485              : $(data).find('[name="Num485"]').val(),
              about               : $(data).find('[name="About"]').val(),
              coef                : $(data).find('[name="Coef"]').val(),
              timezone_id         : $(data).find('[name="TimezoneId"]').val(),
              is_excluded         : $(data).find('[name="IsExcluded"]').is(':checked'),
              password            : $(data).find('[name="Password"]').val(),
              converter           : $(data).find('[name="ConverterId"]').val(),
              number_plomb        : $(data).find('[name="NumberPlomb"]').val(),
              model               : $(data).find('[name="Model"]').val(),
              verificationfirst   : $(data).find('[name="DateFirstVerification"]').val(),
              verification        : $(data).find('[name="DateVerification"]').val(),
              interval            : $(data).find('[name="DateVerificationInterval"]').val()
            }

            var meter = new meters.model( o )
            
            meter.save().then(function(){
              converters.trigger('add_meter' , meter)
            })
            
            $(data).modal('hide')
            
          }
        }).on('change' , 'select[name="TypeId"]' , function( e ){
          if( $(e.target).val() ){
            meterhelpers.fetch({
              data : {
                filter : "metertype:" + $(e.target).val()
              },
              success : function( data ){
                
                var i = data.first()
                
                $('#helper_add_meter')[ i ? 'show' : 'hide' ]().html( i ? i.get('text') : '' )
                
                var f_1 = i && $(e.target).val() ? 'addClass' : 'removeClass'
                var f_2 = i && $(e.target).val() ? 'removeClass' : 'addClass'
                $('#main_meter_set')[f_1]('col-lg-6')[f_2]('col-lg-12')
                
                
              }
            })
          }
        })
        
        if( callback ) callback()
        
        
        $.validate()
        
        
      })
      
      return false;
      
    },
    
    
    events : {
      
      'click .more_settings_controller' : function( e ){
        $('.more_settings').toggleClass('hide')
        $(e.target).find('i').toggleClass('fa-chevron-circle-down')
        $(e.target).find('i').toggleClass('fa-chevron-circle-up')
      },
    
      
    }
    
    
  })
  
})