define([
  "backbone",
  "meterdatahours",
  "hightstock",
  "exporting"
],function(
  Backbone,
  meterdatahours,
  Highcharts
){
  
  Array.prototype.min = function() {
    return Math.min.apply(null, this);
  };
  
  
  var Chart = Highcharts.stockChart( 'container_meter_graph' , {
      colors: ['#7cb57c', '#a8b4bd', '#2677b5'],
      chart: {
          type: 'areaspline'
      },
      title: {
          text: ''
      },
      subtitle: {
          text: ''
      },
      xAxis: {
          //~ allowDecimals: false,
          //~ labels: {
              //~ formatter: function () {
                  //~ return this.value; // clean, unformatted number for year
              //~ }
          //~ }
      },
      yAxis: {
          //~ title: {
              //~ text: 'Nuclear weapon states'
          //~ },
          //~ labels: {
              //~ formatter: function () {
                  //~ return this.value / 1000 + 'k';
              //~ }
          //~ }
      },
      tooltip: {
          pointFormat: '{series.name} produced <b>{point.y:,.0f}</b><br/>warheads in {point.x}'
      },
      plotOptions: {

          areaspline: {
            stacking: 'normal',
            lineColor: '#666666',
            lineWidth: 1,
            pointStart: 2010,
            pointInterval: 0.3, // hourly data
            marker: {
              enabled: true,
              symbol: 'circle',
              radius: 3,
              states: {
                hover: {
                  enabled: true
                }
              }
            }
          }
      },
  });
  

  return Backbone.View.extend({
    
    
    setParameter : function( pid ){
      
      var self = this
      
      
      var regexpArchive = new RegExp(/\graphs\/(\d{4})(\d{2})(\d{2})-(\d{4})(\d{2})(\d{2})\/$/);
      var regexpArchiveDays = new RegExp(/\graphs\/(\d{4})(\d{2})(\d{2})-(\d{4})(\d{2})(\d{2})\/days/);
      if( window.location.pathname.match( regexpArchive ) ){
        
        var serries = meterdatahours.clone()
        
        
        window.location.pathname.replace( regexpArchive ,function(_,start_y,start_m,start_d,stop_y,stop_m,stop_d){
          
          var startDate = new Date( start_y , start_m , start_d );
          var stopDate  = new Date( stop_y , stop_m , stop_d );
          var diffDays  = Math.abs( startDate - stopDate ) / 1000 / 60 / 60 / 24;
          
          startDate.setDate(startDate.getDate() -1)
          
          var parameters = [
            "meter:" + self.get_id,
            "parameter:" + pid,
            "start_year:" + startDate.getFullYear(),
            "start_month:" + startDate.getMonth(),
            "start_day:" + startDate.getDate(),
            "stop_year:" + stopDate.getFullYear(),
            "stop_month:" + stopDate.getMonth(),
            "stop_day:" + stopDate.getDate(),
            "range:hours"
          ];
          
          serries.fetch({
            
            data : {
              filter : parameters.join(";")
            },
            
            url : "/api/meter/graphs/",
            
              reset:false,
              remove : false,
              add:true,
              silent: true,
              success : function( data ){
                
                self.collection = serries
                                              
                
                var data_first = self.collection.where({ parameter : Number(pid) })
                while(Chart.series.length > 0){
                  Chart.series[0].remove(true);
                }
                
                Chart.addSeries({
                    name: $('#parameter_'+pid).text(),
                    data: data_first.sort(function(a,b){
                      
                      var a_Date = new Date( a.get('year') , a.get('month') , a.get('day') );
                      var b_Date = new Date( b.get('year') , b.get('month') , b.get('day') );
                      
                      if( a_Date.getTime() == b_Date.getTime() ) return 0;
                      return a_Date.getTime() < b_Date.getTime() ? -1 : 1;
                    }).reduce( function( res , item){
                      var a_Date = new Date( item.get('year') , item.get('month') , item.get('day') );
                      a_Date.setHours( item.get('hours') );
                      res.push([a_Date.getTime() , item.get('valueconv')]);
                      console.log([a_Date.getTime() , item.get('valueconv')]);
                      return res;
                    }, [])
                }, false);
                
                
                Chart.yAxis[0].update({
                    min: data_first.reduce(function(res , item){
                      res.push(item.get('valueconv'))
                      return res;
                    } , []).min()
                }); 
                
                Chart.redraw();
              }
          })
          
          
        })
      }else if( window.location.pathname.match( regexpArchiveDays ) ){
        
        var serries = meterdatahours.clone()
        
        window.location.pathname.replace( regexpArchiveDays ,function(_,start_y,start_m,start_d,stop_y,stop_m,stop_d){
          
          var startDate = new Date( start_y , start_m , start_d );
          var stopDate  = new Date( stop_y , stop_m , stop_d );
          var diffDays  = Math.abs( startDate - stopDate ) / 1000 / 60 / 60 / 24;
          
          startDate.setDate(startDate.getDate() -1)
          
          var parameters = [
            "meter:" + self.get_id,
            "parameter:" + pid,
            "start_year:" + startDate.getFullYear(),
            "start_month:" + startDate.getMonth(),
            "start_day:" + startDate.getDate(),
            "stop_year:" + stopDate.getFullYear(),
            "stop_month:" + stopDate.getMonth(),
            "stop_day:" + stopDate.getDate(),
            "range:days"
          ];
          
          serries.fetch({
            
            data : {
              filter : parameters.join(";")
            },
            
            url : "/api/meter/graphs/",
            
              reset:false,
              remove : false,
              add:true,
              silent: true,
              success : function( data ){
                
                self.collection = serries
                                              
                
                var data_first = self.collection.where({ parameter : Number(pid) })
                while(Chart.series.length > 0){
                  Chart.series[0].remove(true);
                }
                
                Chart.addSeries({
                    name: $('#parameter_'+pid).text(),
                    data: data_first.sort(function(a,b){
                      
                      var a_Date = new Date( a.get('year') , a.get('month') , a.get('day') );
                      var b_Date = new Date( b.get('year') , b.get('month') , b.get('day') );
                      
                      if( a_Date.getTime() == b_Date.getTime() ) return 0;
                      return a_Date.getTime() < b_Date.getTime() ? -1 : 1;
                    }).reduce( function( res , item){
                      var a_Date = new Date( item.get('year') , item.get('month') , item.get('day') , item.get('hour') );
                      res.push([Number(a_Date.getTime()) , item.get('valueconv')]);
                      return res;
                    }, [])
                }, false);
                
                
                Chart.yAxis[0].update({
                    min: data_first.reduce(function(res , item){
                      res.push(item.get('valueconv'))
                      return res;
                    } , []).min()
                }); 
                
                Chart.redraw();
              }
          })
          
          
        })
      }else{
        
        meterdatahours.fetch({
          data : {
            filter : "meter:" + this.get_id + ";parameter:" + pid
          },
          success : function( data ){
            self.collection = data
                                          
            
            var data_first = self.collection.where({ parameter : Number(pid) })
            while(Chart.series.length > 0){
              Chart.series[0].remove(true);
            }
            
            Chart.addSeries({
                name: $('#parameter_'+pid).text(),
                data: data_first.sort(function(a,b){
                  if( a.get('hour') == b.get('hour') ) return 0;
                  return a.get('hour') < b.get('hour') ? -1 : 1;
                }).reduce( function( res , item){
                  res.push( item.get('valueconv') )
                  return res;
                }, [])
            }, false);
            
            
            Chart.yAxis[0].update({
                min: data_first.reduce(function(res , item){
                  res.push(item.get('valueconv'))
                  return res;
                } , []).min()
            }); 
            
            Chart.redraw();
            
          }
        })
      }
      
      
    },
  
  
    initialize : function(id , year , month , day){
      
      $('.change_parameter').removeClass('active')
      
      this.get_id = id
      
      var first_patameter_el = $('#block_parameters').find('a')
                                        .first()
      $(first_patameter_el).addClass('active')
      
      if( !$(first_patameter_el).length ) return false;
      
      var pid = $(first_patameter_el).attr('id').replace('parameter_','')
      
      this.setParameter( pid )
      
    },
  
  
  
    render : function(){
  
    },
  
  
    events : {
      'click .change_parameter' : function( e ){
        
        $('.change_parameter').removeClass('active')
        
        var first_patameter_el = $(e.target).closest('.change_parameter')
        
        $(first_patameter_el).addClass('active')
        
        var pid = $(first_patameter_el).attr('id').replace('parameter_','')
        
        this.setParameter( pid )
      }
    },
  
    el : '#main_block_graphs',
  
  
  
  });


});