define([
  "backbone",
  "meters",
  "parameter_filter",
  "parameters",
  "parameters_correction_table"
],function(
  Backbone,
  meters,
  parameter_filter,
  parameters,
  parameters_correction_table
){
  return Backbone.View.extend({
    el : '#meter_data',
    initialize : function( id ){
      this.get_id = id
      
      var enabled   = parameters.clone().reset()
      
      var self = this
      
      meters.fetch({
        data : {
          filter : "id:" + this.get_id
        },
        success : function( data ){
          self.model = data.last()
          
          new parameters_correction_table( $(this.$el).find('table') , self.model )
          
        },
        error : error_handler
      })
      
    },
    events : {
      'click .container_data_table_edit_parameters' : function( e ){
        
        if( !this.model ) return false;
        
         new parameter_filter( this.model , 'meter' )
        
        return false;
      }
    }
  })
})