define([
  "backbone",
  "meters"
],function(
  Backbone,
  meters
){
  
  
  return Backbone.View.extend({
    tagName : 'div',
    initialize : function( model , callback ){
    
      this.model = model
      this.render( callback )
      
    },
    render : function( callback ){
      
      let self = this
      
      let data = {data : [ this.model.get('id') ] }
      
      
      $('#myModal').remove()
      
      $.get(
      '/tpl/?tpl=meter_edit_form' , 
      data , 
      function(data){
        
        var data = $(data)
        
        $(data).find('[type="submit"]').remove()
        
        $(data).appendTo('body')
        
        $(data).modal('show').on('hidden.bs.modal', function () {
          $(data).remove()
        }).on('click' , '.more_settings_controller' , function(){
          $('.more_settings').toggleClass('hide')
          $(this).find('i').toggleClass('fa-chevron-circle-down')
          $(this).find('i').toggleClass('fa-chevron-circle-up')
        }).on('click' , '#save_meter' , function(){
          if( $('#myModal').isValid() ){
              
            var o = {
              type                : $(data).find('[name="TypeId"]').find(':selected').val(),
              num_serial          : $(data).find('[name="NumSerial"]').val(),
              num485              : $(data).find('[name="Num485"]').val(),
              about               : $(data).find('[name="About"]').val(),
              coef                : $(data).find('[name="Coef"]').val(),
              timezone_id         : $(data).find('[name="TimezoneId"]').val(),
              is_excluded         : $(data).find('[name="IsExcluded"]').is(':checked'),
              password            : $(data).find('[name="Password"]').val(),
              number_plomb        : $(data).find('[name="NumberPlomb"]').val(),
              model               : Number( $(data).find('[name="Model"]').val() ),
              verificationfirst   : $(data).find('[name="DateFirstVerification"]').val(),
              verification        : $(data).find('[name="DateVerification"]').val(),
              interval            : $(data).find('[name="DateVerificationInterval"]').val()
            }

            self.model.set( o )
            
            self.model.save().then(function(){
              meters.trigger('change_model' , self.model)
            })
            
            
            $(data).modal('hide')
            
          }
        }).on('click' , '#add_model' , function(){
          $('#panel_add_model').removeClass('hide')
        })
        
        if( callback ) callback() 
        
        
        $.validate()
        
        
      })
      
      
    }
  })
  
})