define([
  "backbone",
  "meterparameters",
  "meterparameter_modal_edit",
  "meterparameter_modal_delete"
],function(
  Backbone,
  meterparameters,
  meterparameter_modal_edit,
  meterparameter_modal_delete
){

  return Backbone.View.extend({
  
  
    /*
      @param vmeter
    */
    initialize : function( model ){
      this.model = model
      var self = this
      
      this.listenTo( meterparameters , 'drop_model' , function( drop_model ){
        $('#meterparameter_' + drop_model.get('id')).fadeOut(500)
      })
      
      this.listenTo( meterparameters , 'add_model' , function(){
        var d = { data : [ self.model.get('id') ] }
        $.get(
          "/tpl/?tpl=vmeter_list_parameters",
          d,
          function( data ){
            $( self.$el ).find('.panel-body').replaceWith( $(data).find('.panel-body') )
          }
        )
      })
      
    },
  
  
    events : {
      
      
      'click #block_add_meterparameter' : function( e ){
        new meterparameter_modal_edit( this.model )
        return false;
      },
      
      
      
      'click .converter_delete_item' : function( e ){
        var id = $(e.target).closest('tr').attr('id').replace('meterparameter_','')
        new meterparameter_modal_delete( id );
        return false;
      },
      
      
      
      
      'click .converter_edit_item' : function( e ){
        
        var id = $(e.target).closest('tr').attr('id').replace('meterparameter_','')
        
        var model = new meterparameters.model({ id : id })
        
        var self = this
        
        meterparameters.fetch({
          data : {
            filter : "id:" + id
          },
          success : function( data ){
            new meterparameter_modal_edit( self.model , data.last() )
          }
        })
        
        return false;
      },
      
    },
  
    el : '#meterparameter_list',
  
  
  });

});