define([
  "backbone",
  "converters",
  "parameters",
  "meters",
  "meterparameters",
  "parameter_modal_edit",
  "jstree"
],function(
  Backbone,
  converters,
  parameters,
  meters,
  meterparameters,
  parameter_modal_edit
){
  
  
  /*
    Построение дерева
  */
  function ready_tree(){
    
    
    if( !m.get('converter') && m.get('meter') ){
      
      meters.fetch({
        data : {
          filter : "id:" + m.get('meter').replace('meter_tree_','')
        },
        success : function( data ){
          m.set('converter' , 'converter_tree_' + data.last().get('converter'))
          ready_tree()
        }
      })
      return false;
    }
    
    
    if(
      typeof $('.modal-body').data('jstree') != 'undefined'
    ){
      return false;
    }
        
    $('.modal-body').jstree({
      "core" : {
        "check_callback" : function (operation, node, node_parent, node_position, more) {
          return true;
        },
        'themes': {
            'name': 'proton',
            'responsive': true
        },
        'data' : {
          'url' : function (node) {
            return node.id === '#' 
              ? '/api/?object=converter&tree=true' 
              : '/api/?object=meter&tree=true&filter=converter:' + node.id.replace('converter_tree_','');
          },
          'data' : function (node) {
            return { 'id' : node.id };
          }
        }
      },
      "checkbox": {
          "three_state": false
      },
      "plugins" : [
        "json","types","checkbox"
      ]
    }).bind('load_node.jstree',function(node,status){
      status.node.children.map(function(id){
        $('#' + id + ' > a > .jstree-checkbox').remove()
      })
      
      status.instance.open_node( m.get('converter') )
    }).bind('open_node.jstree',function(node,status){
      $('#' + status.node.id + ' > a > .jstree-checkbox').remove()
      status.instance.select_node( m.get('meter') )
    }).bind('select_node.jstree' , function(node,action,selected,event){
      action.instance.get_selected().map(function(id){
        if( action.node.id != id ){
          this.deselect_node(id)
        }
      },action.instance)
      if( action.node.id.match(/^meter(.*)/) ){
        m.set('meter' , action.node.id)
        m.set('converter' , action.node.parent)
      }
    }).bind('deselect_node.jstree' , function(node,action,event){
      if( action.node.id == m.get('meter') ){
        m.set('meter' , m.defaults.meter)
        m.set('converter' , m.defaults.converter)
      }
    })
    
  }
  
  
  
  
  
  
  
  
  
  
  
  function ready_parameters( m ){
    let data = { data : [ 
      m.get('meter').replace('meter_tree_','')
    ]}
    
    var m = m;
    
    $.get(
    '/tpl/?tpl=meter_parameter_all' , 
    data , 
    function(data){
      if( !$(data).find('.list-group-item').length ){
        $('.modal-body').empty().append(
          $('<div/>').addClass('alert alert-danger').text(
            'Нет параметров. Попробуйте выбрать что-то другое.'
          )
        )
        return false;
      }
      $('.modal-body').empty().append( $(data) )
      
      if( m.get('parameter') ){
        $('.modal-body').find('#' + m.get('parameter'))
                              .addClass('active')
      }
      new ParameterController()
    })
  }
  
  
  
  
  
  
  
  function ready_virtual_parameter(m , id){
    
    let data = { data : [ 
      0
    ]}
    
    $.get(
    '/tpl/?tpl=parameter_users' , 
    data , 
    function(data){
      $('.modal-body').empty().append(
        $('<button/>').addClass('btn btn-success')
                      .text('Создать новый')
                      .attr({
                        id : "new_parameter"
                      })
      ).append(
        $('<br/>')
      ).append(
        $('<br/>')
      ).append( $(data) )
      
      
      
      if( m.get('vparameter') ){
        $('.modal-body').find('#' + m.get('vparameter'))
                              .addClass('active')
      }
      
      if( id ){
        $('#parameter_filter_' + id).addClass('active')
        m.set('vparameter','parameter_filter_' + id )
      }
      
      
      new VParameterController()
      new BtnAddParameter()
    })
  }
  
  

// TODO 
// Если пройти весь цикл по кнопкам дальше и вернутся назад. 
// затем вперед то кнопка СОЗДАТЬ НОВЫЙ бет видна при любых вариантах
  
  
  
  
  
  const BtnAddParameter = Backbone.View.extend({
  
  
    initialize : function(){
      this.listenTo( m  , 'change:vparameter' , function(){
        $( this.$el )[
          m.get('vparameter')
          ? 'addClass'
          : 'removeClass'
        ]('hide')
      })
      
      m.trigger('change:vparameter')
      
    },
  
    el : '#new_parameter',
  
  
  });
  
  
  
  
  
  
  
  /*
    Модель конфигурации будущего параметра
  */
  const ModalModel  = Backbone.Model.extend({
    defaults : {
      converter       : "",
      meter           : "",
      parameter       : "",
      vparameter      : "",
      id              : 0,
      
      active_window   : 0,
    }
  });
  
  var m = new ModalModel()
  
  
  
  
  
  const ParameterController = Backbone.View.extend({
  
    events : {
      'click .list-group-item' : function( e ){
        $(e.target).toggleClass('active')
        $( this.$el ).find('.list-group-item').each(function(i,param_div){
          if( $(param_div).attr('id') != $(e.target).attr('id') ){
            $(param_div).removeClass('active')
          }
        })
        m.set('ready_to_3' , $( this.$el ).find('.list-group-item.active').length == 1)
        
        m.set('parameter' , m.get('ready_to_3')
                            ? $( this.$el ).find('.list-group-item.active').attr('id')
                            : m.defaults.parameter)
        
      }
    },
  
    el : '.list-group',
  
  });
  
  
  
  
  
  const VParameterController = Backbone.View.extend({
  
  
    events : {
      'click .list-group-item' : function( e ){
        $(e.target).toggleClass('active')
        $( this.$el ).find('.list-group-item').each(function(i,param_div){
          if( $(param_div).attr('id') != $(e.target).attr('id') ){
            $(param_div).removeClass('active')
          }
        })
        m.set('ready_to_4' , $( this.$el ).find('.list-group-item.active').length == 1)
        
        m.set('vparameter' , m.get('ready_to_4')
                            ? $( this.$el ).find('.list-group-item.active').attr('id')
                            : m.defaults.parameter)
        
      }
    },
  
    el : '.list-group',
  
  });
  
  
  
  
  
  /*
    Вид отвечающий за прогресс бар
  */
  const ProgressBarView = Backbone.View.extend({
    
    model : m,
  
  
    initialize : function(){
      
      this.listenTo( this.model , 'change:meter' , function(){
        $( this.$el ).css({
          width : this.model.get('meter') ? "30%" : "0"
        })
      })
      
      
      this.listenTo( this.model , 'change:parameter' , function(){
        $( this.$el ).css({
          width : this.model.get('parameter') ? "60%" : "30%"
        })
      })
      
      
      this.listenTo( this.model , 'change:vparameter' , function(){
        $( this.$el ).css({
          width : this.model.get('vparameter') ? "100%" : "60%"
        })
      })
      
    },
  
    el : '#myModal .progress-bar',
  
  });
  
  
  
  
  
  
  
  /*
    Вид отвечающий за кнопку ДАЛЕЕ
  */
  const BtnNext = Backbone.View.extend({
  
    model : m,
    
    
  
    initialize : function(){
  
      this.listenTo( this.model , 'change:meter' , function(){
        $( this.$el )[
          this.model.get('meter')
          ? 'removeClass'
          : 'addClass'
        ]('hide')
      })
      
      
      
      this.listenTo( this.model , 'change:parameter' , function(){
        $( this.$el )[
          this.model.get('parameter')
          ? 'removeClass'
          : 'addClass'
        ]('hide')
      })
      
      
      this.listenTo( this.model , 'change:vparameter' , function(){
        $( this.$el )[
          this.model.get('vparameter')
          ? 'removeClass'
          : 'addClass'
        ]('hide')
      })
      
      this.listenTo( this.model , 'change:active_window' , function(){
        switch( this.model.get('active_window') ){
          case 3 :
            $(this.$el).text('Сохранить').removeClass('btn-primary')
                                          .addClass('btn-success')
          break;
          default : 
            $(this.$el).text('Продолжить').removeClass('btn-success')
                                          .addClass('btn-primary')
          break;
        }
      })
      
      
      
    },
    
    
    events : {
      'click'  : function(){
        
        var self = this
        
        if( this.model.get('active_window') == 3 ){
          
          if( m.get('id') ){
            var res = new meterparameters.model({
              id : m.get('id'),
              meter : m.get('meter').replace('meter_tree_',''),
              parameter : m.get('parameter').replace('parameter_filter_',''),
              virtparameter : m.get('vparameter').replace('parameter_filter_',''),
              virtmeter : m.get('vmeter')
            })
            res.save().then(function(){
              $('#myModal').modal('hide')
              meterparameters.trigger('add_model')
            })
            
            
            
          }else{
          
            $.get(
              '/vmeter/ap/',
              {
                meter : m.get('meter').replace('meter_tree_',''),
                parameter : m.get('parameter').replace('parameter_filter_',''),
                vparameter : m.get('vparameter').replace('parameter_filter_',''),
                vmeter : m.get('vmeter')
              },function( res ){
                if( res ){
                  meterparameters.trigger('add_model')
                  $('#myModal').modal('hide')
                }
              }
            )
          }
        }


        this.model.set('active_window' , this.model.get('active_window')+1 )
        return false;
      }
    },
  

  
    el : '#myModal #next',
  
  
  });
  
  
  
  
  
  
  
  
  
  
  
  /*
    Вид отвечающий за кнопку назад
  */
  const BtnBack = Backbone.View.extend({
  
    
    model : m,
  
  
    initialize : function(){
      
      this.listenTo( this.model , 'change:active_window' , function(){
        $( this.$el )[
          this.model.get('active_window') > 1
          ? 'removeClass'
          : 'addClass'
        ]('hide')
      })
  
    },
    
    
    events : {
      'click'  : function(){
        this.model.set('active_window' , this.model.get('active_window')-1 )
        return false;
      }
    },
    
  
  
    el : '#myModal #back',
  
  
  });
  
  
  
  
  
  return Backbone.View.extend({
    
    
    /*
      @param vmeter
      @param meterparameter || null
    */
    initialize : function( model , meterparameter_model ){
      
      
      if( meterparameter_model instanceof Backbone.Model ){
        m.set({
          meter       : "meter_tree_"+meterparameter_model.get('meter'),
          parameter   : "parameter_filter_"+meterparameter_model.get('parameter'),
          vparameter  : "parameter_filter_"+meterparameter_model.get('virtparameter'),
          id          : meterparameter_model.get('id'),
        })
      }
      
      
      this.model = model
      this.render()
      
      var self = this
      
      m.set('vmeter' , model.get('id'))
      
      
      this.listenTo( m , 'change:active_window' , function(){
        switch( m.get('active_window') ){
          case 1 :
            ready_tree()
            m.trigger('change:meter');
          break;
          case 2 :
            ready_parameters(m)
            $('.modal-body').jstree('destroy')
            m.trigger('change:parameter');
          break;
          case 3 :
            ready_virtual_parameter(m)
            m.trigger('change:vparameter');
          break;
        }
        
      })
      
      this.listenTo( parameters , 'add' , function( add ){
        ready_virtual_parameter(m , add.get('id'))
      })
      
    },
  
  
  
  
    render : function(){
      
      let self = this
      
      let data = { data : [ this.model.get('id') ] }
      
      $.get(
      '/tpl/?tpl=vmeter_select_meter' , 
      data , 
      function(data){
        
        $('#myModal').replaceWith($(data))
        
        
        $(data).modal('show').on('hidden.bs.modal', function () {
          $('#myModal').remove()
        }).on('hidden.bs.modal', function () {
          $('#myModal').remove()
          m.set(m.defaults,{silence:true})
        }).on('shown.bs.modal', function() {
          new ProgressBarView();
          new BtnNext();
          new BtnBack();
          m.set('active_window' , 1)
        }).on('click' , '#new_parameter' , function(){
          new parameter_modal_edit( new parameters.model )
        })
        
        
      })
      
    },
  
  
  });

});
