define([
  "backbone",
  "page_errors",
  'text!/js/tpl/page_error.tpl'
] , function(
  Backbone,
  page_errors,
  tpl
){
  
  $('body').append( $(tpl) )
  
  return Backbone.View.extend({
    el : '#page_error',
    collection :page_errors,
    template : '#page_error_tpl',
    initialize : function(){
      this.render()
      this.listenTo( this.collection , 'all' , this.render )
    },
    events : {
      'click button' : function( e ){
        var id = $( e.target ).parent().attr('id').replace('page_error_','')
        var err = this.collection.get(id)
        
        console.log(err)
        
      }
    },
    render : function(){
      $(this.$el).empty().append(
        $(this.template).tmpl({
          errors : this.collection.toArray()
        })
      )
    }
  })
  
})
