define([
  "backbone",
  "parameters",
  'jtouch'
],function(
  Backbone,
  parameters
){
  
  
  
  
  return Backbone.View.extend({
  
  
    initialize : function( model , ident , callback ){
      var self = this
      
      this._ident = ident
      this.model = model
      
      var enabled   = parameters.clone().reset()
      var disabled  = parameters.clone().reset()
      
      enabled.fetch({
        data : {
          [ident] : model.get('id'),
          is_active : true,
          type : 'data'
        },
        success : function( enabled_data ){
          
          disabled.fetch({
            data : {
              [ident] : model.get('id')
            },
            success : function( disabled_data , f , d ){
              
              self.all      = disabled.clone()
              
              self.collection = self.all
              
              enabled.toArray().map(function( item ){
                disabled.remove({ id : item.get('id') } , {silent : true})
              })
              
              self.all.toArray().map(function( item , i ){
                
                item.index = i
                
                if( this.findWhere({ id : item.get('id') }) ){
                  item.disabled = false
                  return false;
                }
                item.disabled = true
              },enabled)
              
              self.enabled   = enabled
              self.disabled = disabled
              
              self.render()
              
            },
            error : error_handler
          })
        },
        error : error_handler
      })
      
      
      this.render( callback )
    },
    
    
    
    events : {
      'click .list-group-item' : function( e ){
      
        id = $(e.target).closest('a').attr('id').replace('pid_','')
        
        let param = this.collection.find({ id : Number(id) })
        
        if( !param ) return false;
        
        param.disabled = !param.disabled
        
        this.render()
        
        return false;
        
      },
      
      
      'click #selected_all' : function(){
       
        this.collection.toArray().map(function(item){
          item.disabled = false
        })
        
        this.render()
        
      },
      
      'click #deselected_all' : function(){
       
        this.collection.toArray().map(function(item){
          item.disabled = true
        })
        
        this.render()
        
      },
      
      
    },
  
  
  
    render : function( callback ){
      
      if( !$(this.template).length ){
        console.log('pleace initialize template #list_parameters_edit in html')
      }
      
      var tmpl = _.template( $(this.template).html() )
      
      
      if( !this.all ) return false;
      
      $(this.$el).find('.modal-body').empty().append(
        tmpl({
          parameters : this.collection.toArray().sort(function(a,b){
            if( a.index == b.index ) return 0;
            return a.index > b.index ? 1 : -1 ;
          })
        })
      )
      
      if( callback ) callback()
      
      
      $(this.$el).modal('show')
      
      var self = this;
      
      $(this.$el).find('.modal-body').sortable({
        /*
        update: function(event, ui) {
          let id = $(ui.item).attr('id').replace('pid_','')
          let update_parameter = self.collection.find({ id : id })
          
          let oldindex = $(ui.item).attr('data-oldindex')
          let newindex = ui.item.index()
          
          update_parameter.index = newindex
          
          //~ this.collection.toArray().map(function( _parameter ){
            
          //~ })
          
        },
        start: function(event, ui) { 
           $(ui.item).attr('data-oldindex' , ui.item.index())
        }
        */
      })
    },
  
  
    el : '#parameter_edit',
  
  
    template : '#list_parameters_edit'
  
  
  });
  
  
  
  
})