define([
  "backbone",
  "parameter",
  "parameters",
  "parameter_modal_edit",
  "parameter_modal_delete"
],function(
  Backbone,
  PARAMETER,
  parameters,
  parameter_modal_edit,
  parameter_modal_delete
){
  
  
  
  const PARAMETER_PREFIX = "parameter_item_"

  return Backbone.View.extend({
  
  
    collection : parameters,
    
  
    initialize : function(){


      // получим все параметры потом будем давать выполнять какие то функции

      let self = this
      
      this.listenTo( this.collection , 'update' , function( change_model ){
        
        let data = { data : [ change_model.get('id') ] }
        
        $.get(
        '/tpl/?tpl=parameter_list_item' , 
        data , 
        function(data){
          
          if( !$('#' + $(data).attr('id')).length ){
            $(self.$el).find('tr').last().after( $(data) )
            return true;
          }
          
          $('#'+$(data).attr('id')).replaceWith( $(data) )
        })
      })
      
      this.listenTo( this.collection , 'remove' , function( drop_model ){
        
        $('#' + PARAMETER_PREFIX + drop_model.get('id')).fadeOut(500)
      })
      
    },
  
  
    events : {
      
      'click .parameter_edit_item' : function( e ){

        var self = this;

        let id = $(e.target).closest('tr').attr('id').replace(PARAMETER_PREFIX,'');

        console.log( this.collection );

        var data = { data : [ id ] };

        var url = '/tpl/?tpl=parameter_add';

        $.get( url , data , function( resp ){
          
          var resp = $( resp );

          $(resp).find('[type="submit"]').remove();

          var modal = $(resp).modal('show');

          $(modal).on('hidden.bs.modal', function () {
            $(modal).remove();
          }).on( 'click' , '#modal_add_param' , function(){
            var parameter = new PARAMETER({
              id          : id,
              title       : $('[name="Title"]').val(),
              conversion  : $('[name="ConversionId"]').val()
            })
            parameter.save().then(function(){
              $(modal).modal('hide');
            })
          })
          
          // $('#add_parameter').replaceWith($(data))
            
            
            // $(data).modal('show').on('hidden.bs.modal', function () {
            //   $('#add_parameter').remove()
            // }).on('hidden.bs.modal', function () {
            //   $('#add_parameter').remove()
            // }).on('click' , '#modal_add_param' , function(){
            //   if( $(data).isValid() ){
              
            //     self.model.set({
            //       title : $('[name="Title"]').val(),
            //       conversion : $('[name="ConversionId"]').val(),
            //     })
                
            //     self.model.save().then(function(model){
            //       $(data).modal('hide')
            //       parameters.trigger(
            //         self.model.get('id')
            //         ? 'add'
            //         : 'update' , self.model)
            //     })
            //   }
            // }).on('show.bs.modal', function () {
            //     $('.modal .modal-body').css('overflow-y', 'auto'); 
            //     $('.modal .modal-body').css('max-height', $(window).height() * 0.7);
            // });
            
            $.validate()
        })

        
        // parameters.fetch({
        //   data : {
        //     filter : "id:"+id
        //   },
        //   success : function( data ){
        //     new parameter_modal_edit( data.last() ,function(){
        //       $( e.target ).closest('td').removeClass( DIS_DIV )
        //     })
        //   }
        // })
        
        return false;
      },
      
      
      
      'click .parameter_delete_item'  :function( e ){
        
        $( e.target ).closest('td').addClass( DIS_DIV )
        
        
        let id = $(e.target).closest('tr').attr('id').replace(PARAMETER_PREFIX,'')
        
        parameters.fetch({
          data : {
            filter : "id:"+id
          },
          success : function( data ){
            new parameter_modal_delete( data.last() ,function(){
              $( e.target ).closest('td').removeClass( DIS_DIV )
            })
          }
        })
        
      },
      
      
      
      'click #block_add_parameter' : function(){
        new parameter_modal_edit( new parameters.model )
      }
      
      
    },
  
    el : '#parameter_list',
  
  
  
  });


});