define([
  "backbone",
  "parameters",
  "validator"
],function(
  Backbone,
  parameters
){

  return Backbone.View.extend({
  
  
    initialize : function( model , callback ){
      this.model = model
      this.render( callback )
    },
  
  
    tagName : 'div',
  
  
    render : function( callback ){
      
      let data = { data : [ this.model.get('id') ] }
      
      let self = this
      
      $.get(
        '/tpl/?tpl=parameter_add' , 
        data , 
        function(data){
          
          if( callback ) callback()
          
          var data = $(data)

          $(data).find('[type="submit"]').remove()
          
          $('#add_parameter').replaceWith($(data))
          
          
          $(data).modal('show').on('hidden.bs.modal', function () {
            $('#add_parameter').remove()
          }).on('hidden.bs.modal', function () {
            $('#add_parameter').remove()
          }).on('click' , '#modal_add_param' , function(){
            if( $(data).isValid() ){
            
              self.model.set({
                title : $('[name="Title"]').val(),
                conversion : $('[name="ConversionId"]').val(),
              })
              
              self.model.save().then(function(model){
                $(data).modal('hide')
                parameters.trigger(
                  self.model.get('id')
                  ? 'add'
                  : 'update' , self.model)
              })
            }
          }).on('show.bs.modal', function () {
              $('.modal .modal-body').css('overflow-y', 'auto'); 
              $('.modal .modal-body').css('max-height', $(window).height() * 0.7);
          });
          
          $.validate()
      })
      
    },
  
  
  });

});