define([
  "backbone",
  'upload',
  'iframe'
],function(
  Backbone,
  upload,
  iframe
){

  function load_files( id ){
    var url = window.location.pathname;
    var res = $('#fileupload').fileupload({
        url: url,
        dataType: 'json',
        done: function (e, data) {
            $('#progress').addClass('hide')
        },
        progressall: function (e, data) {
          $('#progress').removeClass('hide')
            var progress = parseInt(data.loaded / data.total * 100, 10);
            $('#progress .progress-bar').css(
                'width',
                progress + '%'
            );
            
        },
        error : function (jqXHR, textStatus, errorThrown) {
          
          $('#progress').addClass('hide')
          
          
          switch( jqXHR.responseText ){
            case 'invalid_format' :
              var tmpl = _.template($('#item_danger_files').html())
              
              $('#results').append(
                tmpl({
                  why : "Не верный формат файла"
                })
              )
              
              $('.progress-bar').attr('class','progress-bar progress-bar-danger')
              
            break;
            case 'not_load' :
              var tmpl = _.template($('#item_danger_files').html())
              
              $('#results').append(
                tmpl({
                  why : "Не получилось загрузить"
                })
              )
              
              $('.progress-bar').attr('class','progress-bar progress-bar-danger')
              
            break;
            default:
              var tmpl = _.template($('#item_success_files').html())
              
              $('#results').append(
                tmpl({
                  namefile : jqXHR.responseText
                })
              )
              
              $('.progress-bar').attr('class','progress-bar progress-bar-success')
              
              
              let data = { data : [ id ] }
              
              $.get(
              '/tpl/?tpl=place_files_list' , 
              data , 
              function(tpl){
                
                $('#list_files_container').empty().append(
                  $(tpl)
                )
                
              })
              
            break;
          }
        }
    })
  }
  
  
  return Backbone.View.extend({
  
  
    initialize : function( model ){
      this.GETID = model.get('id')
      load_files(model.get('id'))
    },
    
    el : '#list_files_container',
    
    events : {
      'click .btn-danger' : function( e ){
        
        var self = this
        
        $('<div/>').append(
          'Вы уверены что хотите удалить ?'
        ).dialogYesNo({
          title : "Удалить?",
          isOk : function(t){
          
            $.get( $(e.target).closest('a').attr('href').replace('delete_file','delete_file_apply') , null , function(a,b,c){
              if( b == 'success' ){
                $(t).dialog('destroy')
                
                let data = { data : [ self.GETID ] }
              
                $.get(
                '/tpl/?tpl=place_files_list' , 
                data , 
                function(tpl){
                  
                  $('#list_files_container').empty().append(
                    $(tpl)
                  )
                  
                })
                
              }
            })
            
          }
        })
        
        
        return false;
      }
    }
  
  });

});