define([
  "backbone",
  "places",
  "validator"
],function(
  Backbone,
  places
){


  return Backbone.View.extend({
  
  
    initialize : function( place_page ){
      this.model = place_page
      this.render()
      
      
      this.listenTo( places , 'change_model' , function(change_model){
        let data = {
          data : [ change_model.get('id') ]
        }
        
        $.get(
          '/tpl/?tpl=place_children_item',
          data ,
          function( data ){
            $( '#' + $(data).attr('id') ).replaceWith( $(data) )
          }
        )
      })
      
      
      
      
      
      
      this.listenTo( places , 'add_model' , function(change_model){
        let data = {
          data : [ change_model.get('id') ]
        }
        
        var self = this
        
        $.get(
          '/tpl/?tpl=place_children_item',
          data ,
          function( data ){
            
            var data = $(data)
            
            $(data).hide()
            
            
            let data_j = {
              data : [ change_model.get('place') ]
            }
            
            $.get(
              '/tpl/?tpl=place_children_thead',
              data_j ,
              function( data ){
                $(self.$el).find('thead').replaceWith(
                  $(data)
                )
              }
            )
            
            $(self.$el).find('tbody').append(
              $(data)
            )
            
            $(data).fadeIn(300)
          }
        )
      })
      
    },
  
  








  
    events : {
      
      
      
      'click .add_child' : function( e ){
        
        $( e.target ).closest('td').addClass( DIS_DIV )
        
        
        let data = {
          data : [ 0 ],
          parent : this.model.get('id')
        }
        
        var self = this
        
        $.get(
          '/tpl/?tpl=place_edit_form',
          data,
          function( tpl ){
            
            $( e.target ).closest('td').removeClass( DIS_DIV )
            
            var tpl = $(tpl)
            
            $(tpl).find('[type="submit"]').remove()
            
            $(tpl).modal('show').on('click','#add_children' , function(){
              if( $(tpl).isValid() ){
                var place = new places.model({
                  id : 0,
                  title : $('[name="Title"]').val(),
                  bankbook : $('[name="BankBook"]').val(),
                  type : $('[name="PlacetypeId"]').val(),
                  place : self.model.get('id'),
                })

                place.save().then(function(){
                  places.trigger('add_model' , place)
                  $(tpl).modal('hide')
                })
              }
              
            }).on('hidden.bs.modal' , function(){
              $(tpl).remove()
            })
            
            
          }
        )
        
        return false;
      },
      
      
      
      
      
      
      
      'click .children_delete' : function( e ){
        
        let id = $(e.target).closest('tr').attr('id').replace('children_place_','')
        
        $( e.target ).closest('td').addClass( DIS_DIV )
        
        let data = {
          data : [ id ]
        }
        
        $.get(
          '/tpl/?tpl=place_modal_delete',
          data,
          function( tpl ){
            
            var tpl = $(tpl)
            
            $( e.target ).closest('td').removeClass( DIS_DIV )
            
            $(tpl).find('[type="submit"]').remove()
            
            $(tpl).modal('show').on('click','#delete_place' , function(){
              var place = new places.model({
                id : id,
              })
              
              place.destroy({ dataType : "text" , success : function( model , res){
                if( res == 'droped' ){
                  $(e.target).closest('tr').fadeOut(300)
                }
                $(tpl).modal('hide')
              }})
              
              
            }).on('hidden.bs.modal' , function(){
              $(tpl).remove()
            })
            
            
          }
        )
        
        
        return false;
      },
      
      
      
      
      
      
      
      
      'click .children_edit' : function( e ){
        
        let id = $(e.target).closest('tr').attr('id').replace('children_place_','')
        
        $( e.target ).closest('td').addClass( DIS_DIV )
        
        var e = e
        
        /*
          Загружаем модальное окно
        */
        let data = {
          data : [ id ],
          parent : this.model.get('id')
        }
        
        $.get(
          '/tpl/?tpl=place_edit_form',
          data,
          function( tpl ){
            
            var tpl = $(tpl)
            
            $(tpl).find('[type="submit"]').remove()
            
            $(tpl).modal('show').on('click','#edit_place' , function(e){
              
              var place = new places.model({
                id : id,
                title : $('[name="Title"]').val(),
                bankbook : $('[name="BankBook"]').val(),
                type : $('[name="PlacetypeId"]').val(),
              })
              
              place.save().then(function(){
                places.trigger('change_model' , place)
                $(tpl).modal('hide')
              })
              
            }).on('hidden.bs.modal' , function(){
              $(tpl).remove()
            }).on('shown.bs.modal' , function(){
              $( e.target ).closest('td').removeClass( DIS_DIV )
            })
            
            
          }
        )
        
        return false;
      },
      
      
      
      
    },
    
    
    
    
  
    el : '#place_children_table',
  
  
  
  });

});