define([
  "backbone",
  "places",
  "meter_places",
  "jstree"
],function(
  Backbone,
  places,
  meter_places
){
  
  
  
  
  var mp_isset = null;
  
  
  
  
  
  
  function bind_load( e,core ){
    
    s = core.instance.settings.s
    
    if( !core.node.children.length && core.node.id == "#" ){
      
      var a = "#"
      
      switch( $(e.target).prev().find('.active').index() ){
        case 0 :
          a = "/converter/";
        break;
        case 1 :
          a = "/vconverter/";
        break;
        case 2 :
          a = "/cconverter/";
        break;
      }
      
      $(e.target).prev().find('.active').index()
      
      $(core.instance.element).append(
        $('<div/>').addClass('alert alert-warning')
          .append(
            $('<p/>').text(
              'Нет элементов '
            )
          ).append(
            $('<a/>').addClass('alert-link')
                      .text('Перейти к добавлению')
                      .attr('href' , a)
          )
      )
    }

    // Удаляем лишние чекбоксы
    core.node.children.map(function(item){
      if( item.match(s.regexp_parent) ){
        $('#'+item + ' > a > .jstree-checkbox').remove()
      }
      
      mp_isset.toArray().map(function( item ){
        core.instance.open_node( s.prefix_id_parent + item.get('converter') )
      })
      
    })
  }
  
  
  /**
   * Встплывающая подсказка о удачно выполненном действии
   * 
   * @param {String} type success || danger
   * @returns {Boolean}
   */
  function alert_helper( type ){
    
    var text = type === 'success' ? 'Добавлено' : 'Удалено';
    
    $('.modal-footer').prepend(
      $('<div/>').addClass('alert alert-' + type).css('text-align', 'center').append("&nbsp;" + text).prepend(
        $('<i/>').addClass('glyphicon glyphicon-ok')
      )
    )
    $('.alert-'+type).hide().slideDown(300)
    setTimeout( function(){ $.when( $('.alert-'+type).slideUp(300) ).then(function(c){ $(c).remove(); }) } , 1000 )
    return true
  }
  
  
  
  
  function bind_open_node( e,core ){
    
    s = core.instance.settings.s
    
    if( core.node.id.match(s.regexp_parent) ){
      $('#'+core.node.id + ' > a > .jstree-checkbox').remove()
    }
    
    if( mp_isset ){
      mp_isset.toArray().map(function( item ){
        core.instance.select_node( s.prefix_id_child + item.get('meter') )
      })
    }
  }
  
  
  
  
  
  
  function bind_select_node( e,core ){
    
    s = core.instance.settings.s
    view = core.instance.settings.view
    
    if( typeof core.event == 'undefined' ){
      //~ mp_isset.remove( new meter_places.model({
        //~ id : core.node.id.replace( s.regexp_child ,function(_,id){
          //~ return id
        //~ })
      //~ }) )
      return true;
    }
    
    if( !core.node.id.match( s.regexp_parent ) ){
      var id = core.node.id.replace( s.regexp_child ,function(_,id){
        return id
      })
      var mp = new meter_places.model({
        place : view.model.get('id'),
        meter : id
      })
      
      $('#' + core.node.id).addClass('jstree-loading')
      mp_isset.add( mp , { merge : true } )
      mp.save().then(function(){
        $('#' + core.node.id).removeClass('jstree-loading')
        alert_helper('success')
      })
    }
  }
  
  
  
  
  
  
  
  function bind_deselect_node( e,core ){
    
    s = core.instance.settings.s
    view = core.instance.settings.view
    
    if( typeof core.event == 'undefined' ) {
      return true;
    }
    
    var core = core
    
    if( !core.node.id.match( s.regexp_parent ) ){
      var id = core.node.id.replace( s.regexp_child ,function(_,id){
        return id
      })
      
      $('#' + core.node.id).addClass('jstree-loading')
      
      var meter_places_c = meter_places.clone()
      
      meter_places_c.fetch({
        data : {
          filter : "place:" + view.model.get('id') + ";meter:"+id
        },
        success : function( data ){
          var mp = data.last()
          mp_isset.remove( mp , { silent : true } )
          mp.destroy({ dataType : "text" , success : function( model , res){
            if( res == "droped" ){
              $('#' + core.node.id).removeClass('jstree-loading')
              alert_helper('danger')
            }
          }})
        }
      })
      
    }
  }
  
  
  
  
  







  function main( view , s , callback ){
    var s = s || {
      regexp_parent : /^$/,                 // регуляка по которой получить id родитея
      regexp_child  : /^$/,                 // регуляка по которой получить id дочернего
      prefix_id_parent : 'converter_tree_', // перфикс родителя
      prefix_id_child : 'meter_tree_',      // префикс дочернего
      ident_parent : 'converter',      // префикс дочернего
      ident_child : 'meter',      // префикс дочернего
    }
    
    $('.meter_place_changed').jstree({
      "core" : {
        "check_callback" : function () {
          return true;
        },
        'themes': {
            'name': 'proton',
            'responsive': true
        },
        'data' : {
          'url' : function (node) {
            if( node.id == '#' ){
              return '/api/?object='+s.ident_parent+'&tree=true';
            }else{
              return '/api/?object='+s.ident_child+'&tree=true&filter=converter:' + node.id.replace(s.prefix_id_parent,'');
            }
          },
        }
      },
      s : s,
      view : view,
      "checkbox": {
          "three_state": false
      },
      "plugins" : [
        "json","types","checkbox","sort"
      ],
      "sort" : function(a, b) {
        a1 = this.get_node(a);
        b1 = this.get_node(b);
        if(a1.text == b1.text){
          return 0;
        }
        return (a1.text > b1.text) ? 1 : -1;
      }
    })
    .bind('load_node.jstree'      , bind_load           )
    .bind('open_node.jstree'      , bind_open_node      )
    .bind('select_node.jstree'    , bind_select_node    )
    .bind('deselect_node.jstree'  , bind_deselect_node  )
    .bind('destroy.jstree.jstree' , callback            )
  }
  
  
  
  
  function  ConverterTree( view , callback ){
    main(view , {
      regexp_parent : /^converter(.*)/,
      regexp_child : /^meter_tree_([0-9]*)$/,
      prefix_id_parent : 'converter_tree_',
      prefix_id_child : 'meter_tree_',
      ident_parent : 'converter',
      ident_child : 'meter',
    } , callback || function(){})
  }
  
  
  
  
  
  function  VconverterTree( view , callback ){
    main(view , {
      regexp_parent : /^vconverter(.*)/,
      regexp_child : /^vmeter_tree_([0-9]*)$/,
      prefix_id_parent : 'vconverter_tree_',
      prefix_id_child : 'vmeter_tree_',
      ident_parent : 'vconverter',
      ident_child : 'vmeter',
    } , callback || function(){})
  }
  
  
  
  function  CconverterTree( view ){
    main(view , {
      regexp_parent : /^cconverter(.*)/,
      regexp_child : /^cmeter_tree_([0-9]*)$/,
      prefix_id_parent : 'cconverter_tree_',
      prefix_id_child : 'cmeter_tree_',
      ident_parent : 'cconverter',
      ident_child : 'cmeter',
    })
  }
  
  
  
  
  

  return Backbone.View.extend({
  
  
    initialize : function( place ){
      place = place || new places.model
      this.model = place
    },
  
  
    events : {
      'click #edit_meters' : function(){
        
        let data = { data : [ 
          typeof this.model == 'undefined'
          ? 0
          : this.model.get('id')
        ] }
        
        var self = this
        
        $.get(
          '/tpl/?tpl=place_modal_edit_meters',
          data,
          function( tpl ){
            
            var tpl = $(tpl)
            
            $(tpl).modal('show').on('click' , '#cconverter_tab' , function(){
              if( typeof $('.meter_place_changed').data('jstree') != 'undefined' ){
                $('.meter_place_changed').jstree(true).destroy()
              }
                CconverterTree( self )
            }).on('click', '#converter_tab' , function(){
              if( typeof $('.meter_place_changed').data('jstree') != 'undefined' ){
                $('.meter_place_changed').jstree(true).destroy()
              }
                ConverterTree( self )
            }).on('click', '#vconverter_tab' , function(){
              if( typeof $('.meter_place_changed').data('jstree') != 'undefined' ){
                $('.meter_place_changed').jstree(true).destroy()
              }
                VconverterTree( self )
            }).on('shown.bs.modal', function() {
              meter_places.fetch({
                data : {
                  filter : "place:" + self.model.get('id')
                },
                success : function( data ){
                  mp_isset = data
                  ConverterTree( self )
                }
              })
            }).on('hidden.bs.modal' , function(){
              window.location.pathname = window.location.pathname
              if( typeof $('.meter_place_changed').data('jstree') != 'undefined' ){
                $('.meter_place_changed').jstree(true).destroy();
              }
              $(tpl).remove()
            })
            
          }
        )
        
        return false;
      }
    },
  
    el : '#block_action_place',
  
  
  });

});

