define([
  "backbone",
  "places",
  "place_add_child",
  "validator"
],function(
  Backbone,
  places,
  place_add_child
){
  
  
  var places = places;
  
  var last_add_id = 0;
  
  
  $('#add_children').click(function(){
    
    if( $('.modal-body').isValid() ){
      var placeid = $('#add_children').attr('data-placeid')
          
          
      var a = new places.model({ 
        title : $('#modal_add_children').find('input[name="Title"]').val(),
        type  : $('#modal_add_children').find('select[name="PlacetypeId"]').val(),
        place : placeid
      })
      
      if( $('#modal_add_children').find('input[name="BankBook"]').length ){
        a.set({
          bankbook : $('#modal_add_children').find('input[name="BankBook"]').val()
        })
      }

      a.save().then(function(_a){
        places.trigger('add_model' , a )
        $('#modal_add_children').modal('hide')
      })
    }
    
  })
  
  
  $('#modal_add_children').find('[type="submit"]').remove()
  

  return Backbone.View.extend({
  
  
    initialize : function( model ){
      this.model = model
      this.render()
      
      var self = this
      
      this.listenTo( places , 'change_model' , function(changed){
        $('#place_tree_item_' + changed.get('id') ).find('.tree').remove()
        self.renderChildren( changed )
      })
      
      this.listenTo( places , 'add' , function(added){
        
        var children_places = places.clone().reset()
        
        console.log(added.toJSON())
      
        var self = this
        
        places.fetch({
          data : {
            filter : "id:" + added.get('place')
          },
          success : function( data ){
            if( data.length ){
               self.renderChildren( data.last() )
            }
          }
        })
        
      })
      
    },
    
    
    
    render : function(){
      $(this.el).modal('show')
      
      $(this.$el).find('.modal-body').empty()
      
      if( !this.model.get('id') || this.model.get('places_count') ){
        this.renderChildren( this.model )
      }
      
    },
    
    
    renderChildren : function( model ){
      
      if( !(model instanceof Backbone.Model) ){
        console.group('invalid parameter function apply')
        console.error( model )
        console.groupEnd('invalid parameter function apply')
        return false;
      }
      
      var self = this
      
      $("#modal_children .modal-content" ).addClass(DIS_DIV)
      
      var children_places = places.clone().reset()
      
      
      children_places.fetch({
        data : {
          filter : "place:" + model.get('id')
        },
        success : function( data ){
          
          var tmpl = _.template( $(self.template).html() )
          
          var el = model.get('id') != self.model.get('id')
                    ? "#place_tree_item_" + data.at(0).get('place')
                    : $(self.$el).find('.modal-body')
          
          $(el).append(
            tmpl({
              children : data.toArray(),
              view : self
            })
          )

          $("#modal_children .modal-content" ).removeClass(DIS_DIV)
          
        }
      })
    },
  
  
  
  
  
  
  
  
  
  
  
    events : {
      
      
      
      
      
      
      
      
      
      
      /*
        Добавление доернего элемента
      */
      'click .controller_add_child' : function( e ){
        
        var parent = $(e.target).closest('.tree_child')
        let id = Number( parent.attr('id').replace('place_tree_item_','') )
        
        places.fetch({
          data :{
            filter : "id:" + id
          },
          success : function( data ){
            new place_add_child( data.last() );
          }
        })
        
                        
        return false;
      },
      
      
      
      'click .controller_edit_child' : function( e ){
        
        
        var children_places = places.clone().reset()
        
        var parent = $(e.target).closest('.tree_child')
        
        let id = Number( parent.attr('id').replace('place_tree_item_','') )
        
        
        let data = { data : [ id ] }
        
        $.get(
        '/tpl/?tpl=place_edit_form' , 
        data , 
        function(tpl){
          
          
          $('#modal_add_children').find('.modal-body').empty().append(
            $(tpl)
          )
          
          $('#modal_add_children').modal('show');
          
          $.validate()
          
        })
        
        
      },
      



      
      'click #add_child' : function(){

        let data = { data : [ 0 ] }
        
        $.get(
        '/tpl/?tpl=place_edit_form' , 
        data , 
        function(tpl){
          
          
          $('#modal_add_children').find('.modal-body').empty().append(
            $(tpl)
          )
          
          $('#modal_add_children').modal('show');
          
          $.validate()
          
        })
        
        $('#add_children').attr({
          'data-placeid' : this.model.get('id')
        })
      
      },
      



      
      'click .controller_delete' : function( e ){
        var parent = $(e.target).closest('.tree_child')
        
        let id = Number( parent.attr('id').replace('place_tree_item_','') )
        
        var model = places.model
        
        var place = new model({id : id})
        
        var self = this
        
        place.destroy({dataType : "text" , success : function(model , res){
          if( res == 'droped' ){
            $(parent).fadeOut(300)
          }
        }}) 
        
        return false;
      }
      
      
      
      
      
    },
    
    
    
    
    
    template : '#block_children_item_place',
  
  
    el : '#modal_children'
  
  
  });
  
  
  

});