define([
  "backbone",
  "places"
],function(
  Backbone,
  places
){

  return Backbone.View.extend({
  
  
    initialize : function( model ){
      this.model = model
      this.render()
    },
    
    
    setmodel : function( model ){
      this.model = model
      this.render()
    },
    
    collection : places.reset().clone(),
  
  
    render : function(){
      
      let data = { data : [ this.model.get('id') ] }
      
      var self = this;
      
      $.get(
        '/tpl/?tpl=place_modal_to_tree_empty',
        data,
        function( data ){
          
          var data = $(data)
          
          $(data).modal('show').on('shown.bs.modal', function() {
            
            $( data ).find('.modal-body').empty().jstree({
            "core" : {
              "check_callback" : function () {
                return true;
              },
              'themes': {
                  'name': 'proton',
                  'responsive': true
              },
              'data' : {
                'url' : function (node) {
                  if( node.id === '#' ){
                    return '/api/place/?jstree&all';
                  }else{
                    return '/api/place/?jstree&all&place=' + node.id;
                  }
                }
              }
            },
            "checkbox": {
                "three_state": false
            },
            "plugins" : [
              "json","types"
            ]

          }).bind('select_node.jstree' , function( e,core ){
            if( core.node.original.a_attr.href === window.location.pathname ){
              return false;
            }
            window.location.pathname = core.node.original.a_attr.href;
            return false;
          }).bind('load_node.jstree' , function( e , core ){
      
      var core = core;
      
      self.collection.fetch({
        data : {
          id : self.model.get('id'),
          parents : true
        },
        success : function( collection ){
          collection.add( self.model )
          collection.toArray().map(function( place ){
            core.instance.open_node(place.get('id'));
          })
        }
      });
      
      return false;
    }).bind( 'open_node.jstree' , function( e,core ){
      
      if( core.node.id == self.model.get('id') ){
        core.instance.select_node( core.node.id );
        core.instance.deselect_node( "0" );
      }
      
      core.node.children.map(function( id ){
        if( id == self.model.get('id') ){
          core.instance.select_node( id );
          core.instance.deselect_node( "0" );
        }
      });
      
    });
            
          }).on('hidden.bs.modal' , function(){
            $(data).remove()
          })
          
          
        }
      )
    },
  
  
    events : {
  
    },
  
  
  });

});