define([
  "backbone"
],function(
  Backbone
){
  
  
  return Backbone.View.extend({
  
  
    setmodel : function( model ){
      this.model = model
      $( this.$el ).removeClass( DIS_DIV )
    },
    
    initialize : function(){
      $( this.$el ).addClass( DIS_DIV )
    },
  
  
    render : function(){
      
    },
  
  
    events : {
      'click' : function(){

        var Regexp_Water = new RegExp(/(.*)\/water\//)
        var Regexp_Heat = new RegExp(/(.*)\/heat\//)

        url = window.location.pathname

        if( Regexp_Water.test( url ) ){
          change_filter_ht = "AquaCounter"
        }else if( Regexp_Heat.test( url ) ){
          change_filter_ht = "HeatCounter"
        }else{
          change_filter_ht = "ElectricityCounter"
        }
        
        var data = { data : [ this.model.get('id') ] , change_filter_ht : change_filter_ht  }
        
        var self = this
        
        if( !$('#filterParameterData').length ){
        
          $.get(
            '/tpl/?tpl=place_parameter_data' , 
            data , 
            function(data){
              
            $('body').append( $(data).html() )
            
            $('#filterParameterData').modal('show')
            
            
            
            
            $('#filterParameterData').on('click' , '.list-group-item',function(){
              $(this).toggleClass('active')
            }).on('click' , '#save_filter',function(){
              
              $('#filterParameterData').find('.progress').removeClass('hide')
              
              $('#filterParameterData').find('.list-group-item').addClass('hide')
              $('#filterParameterData').find('#deselect_all, #select_all').addClass('hide')
              
              $('#filterParameterData').find('.list-group-item').each(function(i,item){
                $.get( '/place/fp/' , {
                  id : self.model.get('id'),
                  pid : $(item).attr('id').replace('parameter_filter_',''),
                  i : i,
                  a : $(item).hasClass('active') ? 'e' : 'd',
                  s : '',
                  change_filter_ht : change_filter_ht
                },function(){
                  
                  var proc = Math.ceil(
                      100 / 
                      $('#filterParameterData').find('.list-group-item').length * (Number(i)+1)
                                        )
                  
                  $('#filterParameterData').find('.progress-bar').animate({
                    width : proc + "%"
                  },50)
                  
                  if( proc == 100 ){
                    $('#filterParameterData').find('.progress-bar').animate({
                      width : "100%"
                    },200,'swing' , function(){
                      $('#filterParameterData').modal('hide')
                      $('.data_not_actual').removeClass('hide').effect( 'bounce' )
                    })
                    
                  }
                  
                })
                
              })
              
              // $('#filterParameterData').modal('hide')
            }).on('hidden.bs.modal', function () {
              $('#filterParameterData').remove()
            }).on('click' , '#select_all' , function(){
              $('#filterParameterData').find('.list-group-item').each(function(i,item){
                $(item).addClass('active')
              })
            }).on('click' , '#deselect_all' , function(){
              $('#filterParameterData').find('.list-group-item').each(function(i,item){
                $(item).removeClass('active')
              })
            })
            
              
          })
        }
        
        $('#filterParameterData').modal('show')
        
        return false;
      }
    },
  
    el : '#place_edit_parameter',
  
  
  });

});