define([
  "backbone",
  "place_modal_edit",
  "places"
],function(
  Backbone,
  place_modal_edit,
  places
){
  
  return Backbone.View.extend({
    el : '#short_edit_place',
    collection : places,
    initialize : function( model ){
      
      var self = this
      
      this.model = model
      
      this.listenTo( this.collection , 'change_model' , function(change_model){
        
        if( change_model.get('id') != self.model.get('id') ) return false
        
        let data = { data : [change_model.get('id')] }
        
        $.get( '/tpl/?tpl=place_one_info' , 
          data , 
          function(data){
            
            console.log(111111)
            
            $('#place_item_info').find('tbody').replaceWith(
              $(data).find('tbody')
            )
            
          }
        )
        
      })
      
    },
    
    events : {
      'click' : function( e ){
        
        if( typeof this.model == 'undefined' ){
          return false;
        }
        
        new place_modal_edit( this.model )
        
        return false;
      }
    }
  })
  
})