define([
  "backbone",
  "places",
  "place_modal_edit"
],function(
  Backbone,
  places,
  place_modal_edit
){
  
  
  
  return Backbone.View.extend({
  
    template : '#settings_place',
    
    
    target : undefined,
    
    
    render : function(){
      
      var revert = false;
      
      if( $(this.$el).height() < $(this.$el)[0].scrollHeight ){
        revert = true
      }
      
      var tmpl = _.template( $(this.template).html() )
      
      $(this.target).append(
        tmpl({
          revert : revert,
          height : $(this.template).height()
        })
      )
      
    },
    
    
    initialize : function(){
      this.listenTo( places , 'change_model' , function( changed_model ){
          
          $('[data-place_id="' + changed_model.get('id') + '"]').find('span').text(
            changed_model.get('title')
          )
        
      })
    },
    
  
    events : {
      'click .edit_place' : function( e ){
        
        var id = $(e.target).closest('li[data-place_id]').attr('data-place_id')
        
        if( !id ) return false;
        
        if( $(e.target).closest('.modal_tree').length ) return false;

        $('.modal_tree').remove();
        
        let self = this
        
        self.target = $(e.target);
        
        places.fetch({
          data : {
            filter : "id:" + id
          },
          success : function( data ){
            self.model = data.last()
            self.render()
          }
        })
        
        return false;
      },
      
      
      'click #edit_name_place' : function(){
        if( !this.model ) return false;
        new place_modal_edit( this.model )
      }
    },
  
    el : '#container_place_tree',
  
  
  });
  
});