define([
  'backbone' ,
  'places',
  'text!/js/tpl/place/children.tpl',
  'text!/js/tpl/place/add_place.tpl',
  'text!/js/tpl/meter/add.tpl',
  'timezones',
  'meter_types',
  'converters',
  'meter_places'
],function(
  Backbone ,
  places, 
  tpl,
  add_place_tpl,
  tpl_meter,
  timezones,
  meter_types,
  converters,
  meter_places
){
  
  /*
    TODO
    
    сделать одной функцией запрос с базам данных при добавлении или удалении
    или переопределдить Backbone.sync
    
  */
  
  
  $('body').append( $(tpl) )
  $('body').append( $(add_place_tpl) )
  $('body').append( $(tpl_meter) )
  
  places.url = places.url + window.location.search
  
  
  return Backbone.View.extend({
    collection : places,
    template : '#place_children_tpl',
    el : '#place_children_table',
    events : {
      
      
      
      // Быстрое добавление приборов учета
      'click .short_add_meter_to_place'  : function(e){
        
        var self = this
        
        var id = $(e.target).closest('tr').attr('id').replace('children_place_','')
        
        var Modal = Backbone.View.extend({
          tagName : 'div',
          initialize : function(){
            this.render( this )
          },
          render : function( ){
            
            $(this.$el).attr({
              id : 'Append_meter_modal'
            }).empty().dialogYesNo({
              close : function(){
                modal_init.remove()
              },
              title : 'Добавление прибора учета',
              isOk  : function(){
                
                var res = $('#Append_meter_modal').jstree(true).get_checked().reduce(function(res,item){
                  if( item.match(/converter/) ){
                    return res;
                  }
                  res.push( item.replace('meter_tree_','') )
                  return res;
                },[])
                
                Backbone.sync( 'update' , meter_places , {
                  data : {
                    PlaceId : id,
                    MeterId : res
                  },
                    
                  success : function(){
                    self.collection.fetch({
                      data : {
                        id : self._ID
                      }
                    })
                    $('#place_children_table').find('table').removeClass('disabled')
                  }
                })

                modal_init.remove()
              },
              isFalse  : function(){
                modal_init.remove()
              }
              
              // Serato Scratch Live
              
            }).jstree({
              'core' : {
                    'themes': {
                        'name': 'proton',
                        'responsive': true,
                    },
                  'check_callback' : function(operation, node, node_parent, node_position, more){
                    return true;
                  },
                  data : {
                    url : function(a){
                      if( a.id == '#' ){
                        return '/api/converter/'
                      }else{
                        return '/api/meter/?converter='+ a.id.replace('converter_tree_','')+'&tree=1'
                      }
                    },
                    'data' : function (node) {
                      return { 
                        id : node.id.replace('converter_tree_','')
                      };
                    }
                  },
                  //~ "load_open" : true
              } ,
              
              "plugins": [ "themes" , "json_data" , "ui" , "checkbox" ]
            }).bind('changed.jstree',function(a,b){
              if( b.node.id.match(/converter/) ){
                
                if( b.action == 'deselect_node' ){
                  Backbone.sync('delete' , meter_places , {
                    data: {
                      meter : b.node.children.reduce(function(res,item){
                        res.push( item.replace('meter_tree_','') )
                        return res;
                      },[]),
                      place: id
                    }
                  })
                  
                }
                
                b.instance.open_node(b.node.id)
              }
            }).bind('loaded.jstree' , function(a,b){
              Backbone.sync('read' , meter_places , {
                replace : false,
                reset : false,
                merge : false,
                data : {
                  converter : true,
                  id : id
                },
                success : function( ar ){
                  ar.map(function(item){
                    $(modal_init.$el).jstree(true).open_node( 'converter_tree_' + item.id )
                  })
                }
              })
            }).bind('open_node.jstree' , function(a,b){
              
              var cid = b.node.id.replace('converter_tree_','')
              
              Backbone.sync('read' , meter_places , {
                replace : false,
                reset : false,
                merge : false,
                data : {
                  by_converter : cid,
                  id : id
                },
                success : function(ar){
                  ar.map(function(item){
                    $(modal_init.$el).jstree(true).select_node( 'meter_tree_' + item.id )
                  })
                }
              })
            }).bind("deselect_node.jstree", function (event, data) {
              Backbone.sync('delete' , meter_places , {
                data: {
                  id : data.node.id.replace('meter_tree_','')
                }
              })
              
            })
          }
        })
        
        var modal_init = new Modal
        
      },
      
      'click .edit_children_place' : function(e){
        var id = $(e.target).closest('tr').attr('id').replace('children_place_','')
        
        var self = this
              
         $('<div/>').attr({
            id : 'Append_place_modal'
          }).append(
            $('#add_place_tpl').tmpl({
              Place : places.find({ id : id })
            })
          ).dialogYesNo({
            title : 'Добавление места',
            isOk : function(t){
              
              Backbone.sync('update' , places , {
                data : {
                  Title : $('#Title_modal').val(),
                  id : id
                },
                success : function(){
                  places.fetch({
                    data : {
                      id : self._ID
                    }
                  })
                  $('#place_children_table').find('table').removeClass('disabled')
                }
              })
              $('#place_children_table').find('table').addClass('disabled')
              $(t).dialog('destroy')
            }
          })
        
      },
      
      'click .short_add_place' : function(e){
        
        var id = $(e.target).closest('tr').attr('id').replace('children_place_','')
        
        var self = this
              
         $('<div/>').attr({
            id : 'Append_place_modal'
          }).append(
            $('#add_place_tpl').tmpl({})
          ).dialogYesNo({
            title : 'Добавление места',
            isOk : function(t){
              Backbone.sync('update' , places , {
                data : {
                  Title : $('#Title_modal').val(),
                  PlaceId : id
                },
                success : function(){
                  places.fetch({
                    data : {
                      id : self._ID
                    }
                  })
                  $('#place_children_table').find('table').removeClass('disabled')
                }
              })
              $('#place_children_table').find('table').addClass('disabled')
              $(t).dialog('destroy')
            }
          })
      },
      'click #add_place_modal' : function(){
        
        var self = this
        
         $('<div/>').attr({
            id : 'Append_place_modal'
          }).append(
            $('#add_place_tpl').tmpl({})
          ).dialogYesNo({
            title : 'Добавление места',
            isOk : function(t){
              Backbone.sync('update' , places , {
                data : {
                  Title : $('#Title_modal').val(),
                  PlaceId : self._ID
                },
                success : function(){
                  places.fetch({
                    data : {
                      id : self._ID
                    }
                  })
                  $('#place_children_table').find('table').removeClass('disabled')
                }
              })
              $('#place_children_table').find('table').addClass('disabled')
              $(t).dialog('destroy')
            }
          })
      },
      'click .delete_children_place' : function(e){
        
        var id = $(e.target).closest('tr').attr('id').replace('children_place_','')
        
        var self = this
        
        var Place = self.collection.find( { id : id } )
        
        if( 
          typeof $(e.target).data('href') == 'undefined' && 
          typeof $(e.target).parent().data('href') == 'undefined'
        ){
          $('<div/>').text(
            'Нельзя удалить! Есть вложенные элементы.'
          ).dialogWarning({
            title : 'Внимание'
          })
        }else{
          $('<div/>').text(
            'Вы уверены что хотите удалить это место?'
          ).dialogYesNo({
            title : 'Внимание',
            isOk : function( t ){
              
              Backbone.sync('delete' , self.collection , {
                success : function( res ){
                  
                  $('#place_children_table').find('table').addClass('disabled')
                  
                  if( !res ){
                    page_errors.add({
                      text : 'Не удалось удалить место.'
                    })
                  }
                  
                  self.collection.fetch({
                    reset : true,
                    data : {
                      id : self._ID
                    },
                    success : function(){
                      $('#place_children_table').find('table').removeClass('disabled')
                    }
                  })
                },
                data : {
                  id : id
                }
              })
              $(t).dialog('destroy')
            }
          })
        }
        return false;
      }
    },
    initialize : function( el , id ){
      
      var id = id || 0
      
      this._ID = id
      
      this.$el = $(el)
      
      $(this.$el).find('.disable_a').removeClass('disable_a')
      
      $(this.$el).find('table').addClass('disabled')
      
      this.collection.fetch({
        data : {
          id : this._ID
        },
        success : function(){
          $(this.$el).find('table').removeClass('disabled')
        }
      })
      
      this.listenTo(this.collection , 'all' , this.render)
    },
    render : function(){
      
      var c = this.collection
      
      $(this.$el).empty().append(
        $(this.template).tmpl({
          places : c.toArray()
        })
      )
      
      $(this.$el).find('.action').find('a').each(function( i , a ){
        $(a).parent().attr('data-href' , $(a).attr('href'))
        $(a).removeAttr('href')
      })
      
      $(this.$el).find('.short_add_place').removeAttr('href')
      
    }
  })
})
