define([
  "backbone",
  "rules",
  "rule_modal_edit",
  "rule_modal_delete"
],function(
  Backbone,
  rules,
  rule_modal_edit,
  rule_modal_delete
){

  return Backbone.View.extend({
  
  
    initialize : function(){
      
      this.listenTo( rules , 'change_model' , function( change_model ){
        
        var data = { data : [ change_model.get('id') ] }
        
        $.get(
          '/tpl/?tpl=rule_list_item',
          data,
          function( tpl ){
            $('#' + $(tpl).attr('id')).replaceWith($(tpl))
          }
        )
      })
      
      
      
      this.listenTo( rules , 'drop_model' , function( drop_model ){
        $('#rule_' + drop_model.get('id')).fadeOut(300)
      })
      
    },
  
  
    render : function(){
  
    },
  
  
    events : {
      
      'click .edit_rule' : function( e ){
        
        let id = $(e.target).closest('tr').attr('id').replace('rule_','')
        
        rules.fetch({
          data : {
            filter : "id:" + id
          },
          success : function( data ){
            new rule_modal_edit( data.last() )
          }
        })
        
        return false;
      },
      
      
      
      
      
      
      
      
      'click .delete_rule' : function( e ){
        
        let id = $(e.target).closest('tr').attr('id').replace('rule_','')
        
        rules.fetch({
          data : {
            filter : "id:" + id
          },
          success : function( data ){
            new rule_modal_delete( data.last() )
          }
        })
        
        return false;
      },
      
      
      
      
      'click #add_rule' : function( e ){
        new rule_modal_edit( new rules.model )
        return false;
      },
      
    },
  
    el : '#rule_list',
  
  
  
  });

});