define([
  "backbone",
  "users",
  "user_modal_edit",
  "user_modal_delete",
  "user_add_to_group"
],function(
  Backbone,
  users,
  user_modal_edit,
  user_modal_delete,
  user_add_to_group
){
  
  
  const PREFIX_USER_EDIT = "container_user_item_";
  
  return Backbone.View.extend({
  
  
    collection : users,
  
    initialize : function(){
      
      var self = this
      
      this.listenTo( this.collection , 'change_model' , function( change_model){
        
        let data = { data : [ change_model.get('id') ] }
        
        $.get(
        '/tpl/?tpl=user_list_item' , 
        data, 
        function(data){
          $( self.$el ).find( '#' +$(data).attr('id') ).replaceWith( $(data) )
        })
        
      })
      this.listenTo( this.collection , 'add_model' , function( add_model){
        
        let data = { data : [ add_model.get('id') ] }
        
        $.get(
        '/tpl/?tpl=user_list_item' , 
        data, 
        function(data){
          $( self.$el ).find('tbody').append( $(data) )
        })
        
      })
      
      
      this.listenTo( this.collection , 'drop_model' , function( drop_model ){
        $( self.$el ).find( '#' + PREFIX_USER_EDIT + drop_model.get('id') ).remove()
      })
      
    },
  
  
  
  
  
  
  
  
    events : {
      'click .user_edit' : function( e ){
          
        let id = $(e.target).closest('tr').attr('id').replace(PREFIX_USER_EDIT,'')
        
        $(e.target).closest('td').addClass( DIS_DIV )
        
        
        users.fetch({
          data : {
            filter : "id:" + id
          },
          success : function( models ){
            new user_modal_edit( models.last() , function(){
              $(e.target).closest('td').removeClass( DIS_DIV )
            })
          }
        })
        
        return false;
        
      },
      
      
      
      'click .user_delete' : function( e ){
        
        let id = $(e.target).closest('tr').attr('id').replace(PREFIX_USER_EDIT,'')
        
        $(e.target).closest('td').addClass( DIS_DIV )
        
        users.fetch({
          data : {
            filter : "id:" + id
          },
          success : function( models ){
            new user_modal_delete( models.last() , function(){
              $(e.target).closest('td').removeClass( DIS_DIV )
            })
          }
        })
        
        
        return false;
        
      },
      
      'click #add_user' : function( e ){
        
        $(e.target).closest('td').addClass( DIS_DIV )
        
        new user_modal_edit( new users.model , function(){
              $(e.target).closest('td').removeClass( DIS_DIV )
            })
        
        
        return false;
        
      },
      
      
      
      
      
    },
  
    el : '#container_user_list',
  
  
  });

});