define([
  "backbone",
  "users"
],function(
  Backbone,
  users
){

  return Backbone.View.extend({
  
  
    initialize : function( model , callback ){
      this.model = model
      var data = {data : [ this.model.get('id') ] } 
      
      let self = this
      
      $.get(
        '/tpl/?tpl=user_edit_form' , 
        data, 
        function(data){

          
          
          var data = $(data)
          
          $(data).find('[type="submit"]').remove()

          var modal = $(data).modal('show')
          
          $(modal).on('click' , '#save_user' , function(){
            if( $(data).isValid() ){
              
              var method = self.model.get('id') ? 'change_model' : 'add_model'
                
                self.model.set({
                  fio : $('[name="Fio"]').val(),
                  login : $('[name="Login"]').val(),
                  email : $('[name="EMail"]').val(),
                  pass : $('[name="Pass"]').val(),
                  pass2 : $('[name="Pass2"]').val(),
                  active : $('[name="Active"]').prop('checked'),
                  type  : $('[name="Type"]').val(),
                  rule_place : $('[name="Type"]').val() == 0 ? $('#selected_place').val() : ""
                })
                
                self.model.save().then(function(){
                  
                  users.trigger(  method , self.model)
                  $(data).modal('hide')
                })
                
                
              }
          }).on('hidden.bs.modal', function() {
              $(modal).remove()
          }).on('shown.bs.modal' , function(){
            $('#select_place').jstree({
              "core" : {
                "check_callback" : function () {
                  return true;
                },
                'themes': {
                    'name': 'proton',
                    'responsive': true
                },
                'data' : {
                  'url' : function (node) {
                    if( node.id === '#' ){
                      return '/api/place/?jstree&all';
                    }else{
                      return '/api/place/?jstree&all&place=' + node.id;
                    }
                  }
                }
              },
              "checkbox": {
                  "three_state": false
              },
              "plugins" : [
                "json","types","checkbox"
              ]

            }).bind('select_node.jstree' , function( e,core ){
              $('#selected_place').val( core.selected.join(",") ) 
              return false;
            }).bind('deselect_node.jstree' , function( e,core ){
              $('#selected_place').val( core.selected.join(",") ) 
              return false;
            }).bind("ready.jstree" , function(e,core){
              var places = self.model.get('ruleplace');
              if( typeof places == 'undefined' ){
                return true;
              }
              if( places.length ){
                core.instance.deselect_all()
              }
              places.map(function( place_id ){
                this.instance.check_node(place_id)
              },core)
            })

            $('[name="Type"]').on('change' , function(e){
              $('.selected_place')[ $(e.target).closest('select').val() == 0 ? "show" : "hide" ]()
            })
          
          })
          if( callback )  callback(this)
          
        
        $.validate()
        
      })
    },
  
  
    tagName : 'div',
  
  });

});