define([
  'backbone',
  'converters',
  'vmeters',
  'vmeter',
  'vmeter_modal_edit',
  'vmeter_modal_delete',
  'vmeter_modal_add'
],function(
  Backbone,
  converters,
  meters,
  meter,
  vmeter_modal_edit,
  vmeter_modal_delete,
  vmeter_modal_add
){
  
  
  const METER_PREFIX_ITEM_TABLE = 'converter_meter_item_';


  var converter_id = window.location.pathname.replace(/(.*)\/([0-9]*)\/$/ , "$2" );



  return Backbone.View.extend({


    el : "#converter_meters",



    setmodel : function( converter ){
      this.model = converter;
      this.initialize();
    },


    initialize : function(){
      if( typeof this.model == 'undefined' ){
        return false;
      }
    },




    events : {



      'click .converter_meter_edit' : function( e ){
        var e = e;
        var id = $( e.target ).closest('tr').attr('id').replace( METER_PREFIX_ITEM_TABLE , '' );
        new vmeter_modal_edit( id , function( attrs ){

          var METER = new meter( attrs );

          METER.save().then(function(){
            var url = '/tpl/?tpl=vconverter_children_item';

            var data = { data : [ id ] }

            $.get( url , data , function( resp ){
              $( e.target ).closest('tr').replaceWith( resp )
            })
          })

          
        });
        return false;
      },



      'click .converter_meter_delete' : function( e ){
        var e = e;
        var self = this;
        var id = $( e.target ).closest('tr').attr('id').replace( METER_PREFIX_ITEM_TABLE , '' );
        new vmeter_modal_delete( id , function( ){

          var METER = new meter({ id : id });

          METER.destroy({
            dataType : "text",
            success : function( m , resp ){
              if( resp == 'droped' ){
                $(e.target).closest('tr').remove();

                var url = '/tpl/?tpl=vconverter_children_head';

                var data = { data : [ converter_id ] }

                $.get( url , data , function( resp ){
                  $( self.$el ).find('thead').replaceWith( $(resp) )
                })
              }
            }
          })
        });
        return false;
      },



      'click #add_converter_modal' : function( e ){
        var e = e;
        new vmeter_modal_add( window.location.pathname.replace(/(.*)\/([0-9]*)\/$/ , "$2" ) , function( attrs ){

          var METER = new meter( attrs );

          METER.save().then(function(){

            var url = '/tpl/?tpl=vconverter_children_head';

            var data = { data : [ converter_id ] }

            $.get( url , data , function( resp ){
              $( e.target ).closest('table').find('thead').replaceWith( $(resp) )
            })

            var url = '/tpl/?tpl=vconverter_children_item';

            var data = { data : [ METER.get('id') ] }

            $.get( url , data , function( resp ){
              $( e.target ).closest('table').find('tbody').append( resp )
            })
          })
        });
        return false;
      }

    }


  });
  

  
})