CONVERTER_LIST = Backbone.View.extend
  
  el : '#converter_list'
  
  collection : converters
  
  template : "#converter_list_tpl"
  
  initialize : ()->
    self = @
    
    # Включаем заглушку на таблицу
    tpl_c = _.template $("#converter_list_sample_tpl").html()
    $(self.$el).empty().append( tpl_c() )
    
    # Загружаем из БД значения и рисуем

    @.listenTo @.collection , 'change' , @.render

    # @.listenTo @.collection , 'lock' , @.lock
    
    @.collection.fetch
      success : ()->
        new CONVERTER_PAGES(self.collection)
        # new CONVERTER_COUNTERS(self.collection)
        self.render()
        self.listenTo self.collection , "sync add delete change" , self.render
        self.listenTo self.collection , "reconstruct" , self.render
      data :
        page : $.cookie('convertrer_page')
        sort : self.collection.sort_ad
        field : self.collection.sort_field
        count : @.collection.__get_count_ajax()
      async : true
    @
    

  render : ()->
    tpl_c = _.template $(@.template).html()
    $(@.$el).empty().append(
      tpl_c(
        converters      : @.collection
        converter_types : converter_types
      )
    )
    @


  lock : ()->
    # Пока нажимается - заблокируем таблицу чтобы ничего не сломали
    $(@.el).append(
      $('#converter_list_sample_tpl').html()
    )

  
  
  # Общее событие на клик
  _sortable_click : ( e )->

    @.lock()
    # Указываем какое поле для сортировки используется
    @.collection.sort_field = $(e.target).attr('data-sort')

    # Если поле для сортировки еще не выставлено то сортируем на возрастание
    switch @.collection.sort_ad
      when null
        @.collection.sort_ad = "desc"
      when "asc"
        @.collection.sort_ad = "desc"
      when "desc"
        @.collection.sort_ad = "asc"

    # выставляем значения для сортировки
    @.collection.__set_sort()
      

    # Небольшой хак чтобы не сбросить модель
    # Мы будем запрашивать через другу модель и менять значения  
    c = @.collection.clone().reset()

    self = @


    # Затем переспрашиваем сервер данные
    c.fetch
      success : ()->
        self.collection.reset().add( c.toArray() )
        c = null
      data :
        page : $.cookie('convertrer_page')
        sort : @.collection.sort_ad
        field : @.collection.sort_field
        count : @.collection.__get_count_ajax()
    
  
  
  
  
  
  
  # Стандартные обработчики
  events : 
    
    # Сортировка
    "click th.sortable" : ( e )->
      @._sortable_click( e )
      false
  
    "click th.sortable-asc" : ( e )->
      @._sortable_click( e )
      false
  
    "click th.sortable-desc" : ( e )->
      @._sortable_click( e )
      false
      
      
    
    # Редактирование конвертера
    "click .converter_edit_item" : ()->
      false
      
    # Удаление конверетера
    "click .converter_is_delete" : ()->
      false
    
    # Добавление конвертера
    "click #add_converter_modal" : ()->
      new MODAL_CONVERTER_ADD( new CONVERTER , @.collection )
      false
      
    # Редактирование конвертера
    "click .converter_edit_item" : ( e )->
      cid = $(e.target).closest('tr').attr('data-cid')
      new MODAL_CONVERTER_ADD( @.collection.get( cid ) , @.collection )
      false
      
    
    # Удаление конвертера
    "click .converter_delete_item" : ( e )->
      cid = $(e.target).closest('tr').attr('data-cid')
      new MODAL_CONVERTER_DELETE( @.collection.get( cid ) , @.collection )
      false