MODAL_CONVERTER_ADD = Backbone.View.extend
  
  template : '#converter_add_modal'
  
  initialize : ( converter , collection )->
    @.model = converter
    if collection 
      @.collection = collection
    @.render()
    @
    
    
  
  _fields_en_dis : [ "type", "ip", "port", "login", "pass", "ping", "save",
    "about" , "timeoutconnect", "timeoutreceive", "portcontrol", "IsExcluded"]
  
  
  
  _disabled_all_fields : ()->
    @._fields_en_dis.map((f)->
      $('#' + f).prop('disabled' , true)
    )
    $('#ping_res').removeClass('text-success text-danger').addClass('text-muted')
    $('#danger_ping').slideUp(300)
    
  _enabled_all_fields : ()->
    @._fields_en_dis.map((f)->
      $('#' + f).prop('disabled' , null)
    )



  # Убираем активность сохранения
  disabled_save : ()->
    $('#save').addClass('btn-disabled').removeClass('btn-success')
    $('#ping').addClass('btn-disabled').removeClass('btn-info')
  
  # Включаем возможность сохранения
  enabled_save : ()->
    $('#save').removeClass('btn-disabled').addClass('btn-success')
    $('#ping').removeClass('btn-disabled').addClass('btn-info')
  
  
    
  render : ()->
    
    tpl_c = _.template $(@.template).html()
    
    modal = $(tpl_c({
      converter : @.model,
      converter_types : converter_types
    })).modal("show")
    
    
    self = @
    
    $(modal).on "click" , ".more_settings_controller" , ( e )->
      i = $(e.target).find('i')
      if $(i).hasClass(self.down_icon)
        self.__slideDown( modal )
      else
        self.__slideUp( modal )
        
    .on "click" , "#save" , ()->

      data = self.model.toJSON()
      
      # Если новый
      if !self.model.get('id')
        self.collection.create( data ,
          success : (resp)->
            if resp && resp.get('id')
              $(modal).modal('hide')
              swal
                title: "Добавлено",
                text: "",
                timer: 800,
                type: "success",
                showConfirmButton: false
        )
      else
        model = self.collection.findWhere( id : Number data.id )
        model.save(
          data
        ,
          success : ( _model )->
            $(modal).modal('hide')
            swal
              title: "Изменено",
              text: "",
              timer: 800,
              type: "success",
              showConfirmButton: false
        )
      
      self.collection.trigger('change')
      
    .on "shown.bs.modal" , ()->
      id = $(modal).find('#type').find(':selected').val()
      self.model.set( "type" , id  , silent : true  )

      new CONVERTER_MODAL_BODY( self.model , self )
      # пока оставлю вдруг надо будет
      # if self.model.__set_about( silent : true )
      #   $('#about').val( self.model.get('about') )
      # console.log self.model.toJSON()
    .on "hidden.bs.modal" , ()->
      $(modal).remove()
      
  # Иконки для расширенных настроек
  up_icon   : "fa-chevron-circle-up"
  down_icon : "fa-chevron-circle-down"
  
  
  # сворачивание дополнительных настроек
  __slideUp : ( modal )->
    modal = modal
    $('.' + @.up_icon).removeClass( @.up_icon ).addClass( @.down_icon )
    $(modal).find('.more_settings').slideUp(500)
    @
    
  
  # разворачивание дополнительных настроек
  __slideDown : ( modal )->
    $('.' + @.down_icon).removeClass( @.down_icon ).addClass( @.up_icon )
    $(modal).find('.more_settings').hide().removeClass('hide').slideDown(500)
    @
        
  
  