// Generated by CoffeeScript 1.9.3
var LORATYPE_COLLECT, LORATYPE_MODEL, LORA_ADD_VIEW, LORA_COLECT, LORA_DELETE_VIEW, LORA_LIST_VIEW, LORA_MODEL, lora_collect_gl, loratype_collect_gl;

LORA_MODEL = Backbone.Model.extend({
  defaults: {
    id: 0,
    about: "",
    ip: "",
    port: 0,
    type: 0,
    login: "",
    pass: ""
  },
  url: function() {
    return "/api/lora/" + this.get('id') + "/";
  }
});

LORA_COLECT = Backbone.Collection.extend({
  model: LORA_MODEL,
  url: "/api/lora/"
});

LORATYPE_MODEL = Backbone.Model.extend({
  defaults: {
    id: 0,
    title: ""
  }
});

LORATYPE_COLLECT = Backbone.Collection.extend({
  model: LORATYPE_MODEL,
  url: "/api/loratype/"
});

lora_collect_gl = new LORA_COLECT;

loratype_collect_gl = new LORATYPE_COLLECT;

LORA_LIST_VIEW = Backbone.View.extend({
  el: "#lora_list",
  template: "#lora_list_tpl",
  collection: lora_collect_gl,
  collection_types: loratype_collect_gl,
  initialize: function() {
    this.listenTo(this.collection, "add_model", function(add_model) {
      this.collection.add(add_model);
      return this.render();
    });
    this.listenTo(this.collection, "up_model", function() {
      return this.render();
    });
    this.listenTo(this.collection, "del_model", function(del_model) {
      this.collection.remove(del_model);
      return this.render();
    });
    return this.render();
  },
  render: function() {
    var tpl_c;
    tpl_c = _.template($(this.template).html());
    return $(this.$el).empty().append(tpl_c({
      lora_collection: this.collection.toArray(),
      loratype_collection: this.collection_types
    }));
  },
  events: {
    "click #add_converter_modal": function(e) {
      new LORA_ADD_VIEW(new LORA_MODEL, this.collection);
      return false;
    },
    "click .lora_edit_item": function(e) {
      var cid;
      cid = $(e.target).closest("tr").attr('id');
      new LORA_ADD_VIEW(this.collection.get(cid), this.collection);
      return false;
    },
    "click .lora_delete_item": function(e) {
      var cid;
      cid = $(e.target).closest("tr").attr('id');
      new LORA_DELETE_VIEW(this.collection.get(cid), this.collection);
      return false;
    }
  }
});

LORA_ADD_VIEW = Backbone.View.extend({
  template: "#lora_add_tpl",
  render: function() {
    var self, tpl_c;
    self = this;
    tpl_c = _.template($(this.template).html());
    return this.$el = $(tpl_c({
      lora_model: this.model
    })).modal('show');
  },
  initialize: function(_model, _collection) {
    this.model = _model;
    this.collection = _collection;
    return this.render();
  },
  events: {
    "keyup #about_lora": function(e) {
      return this.model.set('about', $(e.target).closest('#about_lora').val());
    },
    "keyup #ip_lora": function(e) {
      return this.model.set('ip', $(e.target).closest('#ip_lora').val());
    },
    "keyup #port_lora": function(e) {
      var val;
      val = $(e.target).closest('#port_lora').val();
      return this.model.set('port', Number(val));
    },
    "keyup #login_lora": function(e) {
      return this.model.set('login', $(e.target).closest('#login_lora').val());
    },
    "keyup #pass_lora": function(e) {
      return this.model.set('pass', $(e.target).closest('#pass_lora').val());
    },
    "click #save": function() {
      var self, trigger;
      self = this;
      trigger = this.model.get('id') ? "up_model" : "add_model";
      return this.model.save(null, {
        success: function(m) {
          self.collection.trigger(trigger, m);
          return $(self.$el).modal('hide');
        },
        error: function() {
          return $(self.$el).modal('hide');
        }
      });
    }
  }
});

LORA_DELETE_VIEW = Backbone.View.extend({
  template: "#lora_delete_tpl",
  initialize: function(_model, _collection) {
    this.model = _model;
    this.collection = _collection;
    return this.render();
  },
  render: function() {
    var self, tpl_c;
    self = this;
    tpl_c = _.template($(this.template).html());
    return this.$el = $(tpl_c({
      lora_model: this.model
    })).modal('show');
  },
  events: {
    "click #delete": function() {
      var self;
      self = this;
      return this.model.destroy({
        dataType: "text",
        success: function(model, req) {
          if (req === "droped") {
            self.collection.trigger('del_model', model);
            return $(self.$el).modal('hide');
          }
        }
      });
    }
  }
});

$(document).ready(function() {
  return lora_collect_gl.fetch({
    success: function() {
      return loratype_collect_gl.fetch({
        success: function() {
          return new LORA_LIST_VIEW;
        },
        error: function() {
          return console.log("error type");
        }
      });
    },
    error: function() {
      return console.log("error");
    }
  });
});
