// Generated by CoffeeScript 1.9.3
var ABR_MODEL, CNANELMASK_MODEL, ConverterType, ConverterTypes, FREQUENCYPLAN_MODEL, LORA_ADD_VIEW, LORA_BREADS_VIEW, LORA_CHILD_VIEW, LORA_COUNTER_ADD_EDIT_MODAL, LORA_COUNTER_ADD_EDIT_MODAL_ACTIVATION_PRES, LORA_COUNTER_ADD_EDIT_MODAL_MAIN_SETTINGS, LORA_COUNTER_ADD_EDIT_MODAL_OVER_THE_AIR, LORA_DELETE_VIEW, LORA_DEVICE_COLLECTION, LORA_DEVICE_MODEL, LORA_H1_VIEW, LORA_MODEL, LORA_PROPERTIES_VIEW, Meter, MeterType, MeterTypes, Meters, OTAA_MODEL, POSITION_MODEL, SETTINGSAPPLYSTATUS_MODEL, converter_types, deviceTypes, lora_device_collection, lora_model_gl, meter_types, meters_collect;

deviceTypes = [
  {
    id: 1,
    name: 'СИ-11',
    count_channels: 4
  }, {
    id: 3,
    name: 'СИ-13 Меркурий',
    count_channels: 6
  }, {
    id: 4,
    name: 'ТД-11',
    count_channels: 1
  }, {
    id: 5,
    name: 'ТП-11',
    count_channels: 1
  }, {
    id: 6,
    name: 'MC-0101',
    count_channels: 1
  }, {
    id: 7,
    name: 'AS-0101',
    count_channels: 1
  }, {
    id: 8,
    name: 'MS-0101',
    count_channels: 1
  }, {
    id: 9,
    name: 'СВЭ1',
    count_channels: 1
  }, {
    id: 10,
    name: 'SS-0101',
    count_channels: 1
  }, {
    id: 11,
    name: 'СИ-21',
    count_channels: 4
  }, {
    id: 12,
    name: 'Электросчетчик',
    count_channels: 1
  }, {
    id: 13,
    name: 'GM-2',
    count_channels: 1
  }, {
    id: 14,
    name: 'LM-1',
    count_channels: 1
  }
];

LORA_MODEL = Backbone.Model.extend({
  is_socket_connect: false,
  is_socket_auth: false,
  token: "",
  socket: null,
  active: false,
  defaults: {
    id: 0,
    about: "",
    ip: "",
    port: 0,
    type: 0,
    login: "",
    pass: "",
    device_type: _.first(deviceTypes)
  },
  url: function() {
    return "/api/lora/" + this.get('id') + "/";
  },
  __get_devices: function() {
    return this.socket.send(JSON.stringify({
      "cmd": "get_devices_req",
      "token": this.token
    }));
  },
  __get_gataways: function() {
    return this.socket.send(JSON.stringify({
      "cmd": "get_gateways_req",
      "token": this.token
    }));
  },
  __get_coverage_map_req: function(callback) {
    return this.socket.send(JSON.stringify({
      "cmd": "get_device_appdata_req",
      "token": this.token
    }));
  },
  __delete_model: function(model) {
    return this.socket.send(JSON.stringify({
      "cmd": "delete_device_appdata_req",
      "data_list": [
        {
          "devEui": model.get('lora_model').get('devEui')
        }
      ],
      "token": this.token
    }));
  },
  __save_app_devices: function(model) {
    return this.socket.send(JSON.stringify({
      "cmd": "manage_device_appdata_req",
      "data_list": [
        {
          "devEui": model.get('lora_model').get('devEui'),
          "device_type": String(model.get('lora_model').get('device_type'))
        }
      ],
      "token": this.token
    }));
  },
  __save_counter: function(model) {
    if (model.get('id') === 0 || model.get('lora_model').get('devEui') === "") {
      return this.socket.send(JSON.stringify({
        "cmd": "manage_devices_req",
        "devices_list": [model.get('lora_model').toJSON()],
        "token": this.token
      }));
    } else {
      return this.socket.send(JSON.stringify({
        "cmd": "manage_devices_req",
        "devices_list": [
          {
            "devEui": model.get('lora_model').get('devEui'),
            "devName": model.get('lora_model').get('devName'),
            "class": model.get('lora_model').get('class')
          }
        ],
        "token": this.token
      }));
    }
  }
});

ConverterType = Backbone.Model.extend({
  defaults: {
    id: 0,
    title: 0,
    use: 0
  }
});

ConverterTypes = Backbone.Collection.extend({
  model: ConverterType,
  url: "/api/lora_converter_type/"
});

converter_types = new ConverterTypes;

MeterType = Backbone.Model.extend({
  defaults: {
    id: 0,
    title: 0,
    use: 0
  }
});

MeterTypes = Backbone.Collection.extend({
  model: MeterType,
  url: "/api/lora_meter_type/"
});

meter_types = new MeterTypes;

ABR_MODEL = Backbone.Model.extend({
  defaults: {
    appsKey: "",
    devAddress: null,
    nwksKey: ""
  }
});

OTAA_MODEL = Backbone.Model.extend({
  defaults: {
    appEui: "",
    appKey: "",
    last_join_ts: 0
  }
});

CNANELMASK_MODEL = Backbone.Model.extend({
  defaults: {
    channel1En: true,
    channel2En: true,
    channel3En: true,
    channel4En: true,
    channel5En: true,
    channel6En: true,
    channel7En: true,
    channel8En: true,
    channel9En: false,
    channel10En: false,
    channel11En: false,
    channel12En: false,
    channel13En: false,
    channel14En: false,
    channel15En: false,
    channel16En: false
  }
});

FREQUENCYPLAN_MODEL = Backbone.Model.extend({
  defaults: {
    freq4: 867100000,
    freq5: 867300000,
    freq6: 867500000,
    freq7: 867700000,
    freq8: 867900000
  }
});

POSITION_MODEL = Backbone.Model.extend({
  defaults: {
    altitude: 0,
    latitude: 0,
    longitude: 0
  }
});

SETTINGSAPPLYSTATUS_MODEL = Backbone.Model.extend({
  defaults: {
    channelMaskApllied: true,
    delayRx1Applied: true,
    drRx2Applied: true,
    freq4Applied: true,
    freq5Applied: true,
    freq6Applied: true,
    freq7Applied: true,
    freq8Applied: true,
    freqRx2Applied: true
  }
});

LORA_DEVICE_MODEL = Backbone.Model.extend({
  defaults: {
    ABP: new ABR_MODEL,
    OTAA: new OTAA_MODEL,
    adr: false,
    channelMask: new CNANELMASK_MODEL,
    "class": "CLASS_A",
    delayJoin1: 5,
    delayJoin2: 0,
    delayRx1: 1,
    delayRx2: 0,
    devEui: "",
    devName: "",
    drRx2: 0,
    fcnt_down: 0,
    fcnt_up: 0,
    freqRx2: 869525000,
    frequencyPlan: new FREQUENCYPLAN_MODEL,
    lastRssi: 0,
    lastSnr: 0,
    last_data_ts: 0,
    position: new POSITION_MODEL,
    preferDr: 5,
    preferPower: 14,
    reactionTime: 1000,
    rxWindow: 2,
    serverAdrEnable: true,
    settingsApplyStatus: new SETTINGSAPPLYSTATUS_MODEL,
    useDownlinkQueueClassC: false
  },
  __set: function(data) {
    this.set('ABP', new ABR_MODEL(data.ABP));
    this.set('OTAA', new OTAA_MODEL(data.OTAA));
    this.set('channelMask', new CNANELMASK_MODEL(data.channelMask));
    this.set('frequencyPlan', new FREQUENCYPLAN_MODEL(data.frequencyPlan));
    this.set('position', new POSITION_MODEL(data.position));
    return this.set('settingsApplyStatus', new SETTINGSAPPLYSTATUS_MODEL(data.settingsApplyStatus));
  }
});

LORA_DEVICE_COLLECTION = Backbone.Collection.extend({
  model: LORA_DEVICE_MODEL,
  __add: function(data) {
    var d, device, j, len, results;
    results = [];
    for (j = 0, len = data.length; j < len; j++) {
      device = data[j];
      d = new LORA_DEVICE_MODEL(device);
      d.__set(device);
      results.push(this.add(d));
    }
    return results;
  }
});

Meter = Backbone.Model.extend({
  defaults: {
    id: 0,
    about: "",
    meter_type_title: "",
    type: 0,
    converter: 0,
    converter_about: "",
    num_serial: "",
    password: "",
    timezone_id: 0,
    num485: 0,
    model: "",
    number_plomb: "",
    mark: "",
    status: 0,
    checked: false,
    first_date_verification: "",
    date_verification: "",
    interval_verification: 60,
    lora_model: new LORA_DEVICE_MODEL
  },
  url: function() {
    return "/api/?object=meter&filter=id:" + this.get('id');
  }
});

Meters = Backbone.Collection.extend({
  model: Meter,
  url: function() {
    return "/api/?object=meter&filter=converter:" + lora_id;
  },
  user_fetch: function() {
    $('#meters').prepend($('<div>').attr({
      id: 'CAPNAG'
    }).css({
      width: '50px',
      height: '50px',
      zIndex: 1002
    }).append($('<div/>').addClass('page-preloader-cover').append(function() {
      return [1, 2, 4, 3].map(function(item) {
        return $(this).append($('<div/>').addClass('page-preloader__cube page-preloader--cube' + item));
      }, this);
    })));
    meters.fetch({
      success: function(r) {
        $('#CAPNAG').remove();
        $('.page-preloader-cover').remove();
      },
      error: function() {
        $('#CAPNAG').remove();
        return $('.page-preloader-cover').remove();
      }
    });
    return false;
  }
});

meters_collect = new Meters;

lora_device_collection = new LORA_DEVICE_COLLECTION;

lora_model_gl = new LORA_MODEL({
  id: lora_id
});

lora_model_gl.on("change:ip change:port", function() {
  var self;
  self = this;
  if (this.get('ip') !== "" && this.get('port') !== 0) {
    if (this.socket !== null) {
      this.socket.close();
    }
    this.socket = new WebSocket("ws://" + this.get('ip') + ":" + this.get('port') + "/");
    this.socket.onopen = function() {
      console.log("Соединение установлено.");
      self.is_socket_connect = true;
      self.trigger('is_socket_connect_change');
      return self.socket.send(JSON.stringify({
        "cmd": "auth_req",
        "login": self.get('login'),
        "password": self.get('pass')
      }));
    };
    this.socket.onclose = function(event) {
      if (event.wasClean) {
        console.log('Соединение закрыто чисто');
      } else {
        console.log('Обрыв соединения');
      }
      return console.log('Код: ' + event.code + ' причина: ' + event.reason);
    };
    this.socket.onmessage = function(event) {
      var _device, _meter, _remove_meter, data, device_type, findDevice, findRes, find_meter, i, j, k, l, len, len1, len2, len3, len4, len5, len6, m_, meters_sucess, n, new_meter, o, p, q, ref, ref1, ref2, ref3, ref4, ref5, results;
      data = JSON.parse(event.data);
      if (data.cmd === "auth_resp") {
        if (data.status) {
          self.is_socket_auth = true;
          self.token = data.token;
          self.trigger('is_socket_auth_change');
          self.__get_gataways();
          self.__get_devices();
          return self.__get_coverage_map_req();
        }
      } else if (data.cmd === "manage_devices_resp") {
        ref = data.device_add_status;
        results = [];
        for (j = 0, len = ref.length; j < len; j++) {
          _device = ref[j];
          _meter = meters_collect.findWhere({
            num_serial: _device.devEui
          });
          if (_device.status === "updated" || _device.status === "added" || _device.status === "nothingToUpdate") {
            if (typeof _meter !== "undefined") {
              _meter.save();
              results.push(self.__save_app_devices(_meter));
            } else {
              results.push(void 0);
            }
          } else {
            results.push(void 0);
          }
        }
        return results;
      } else if (data.cmd === "get_devices_resp") {
        lora_device_collection.__add(data.devices_list);
        ref1 = lora_device_collection.toArray();
        for (k = 0, len1 = ref1.length; k < len1; k++) {
          _device = ref1[k];
          m_ = meters_collect.findWhere({
            num_serial: _device.get('devEui')
          });
          if (typeof m_ !== "undefined") {
            m_.set('lora_model', _device);
          }
        }
        return;
        meters_collect.trigger("custom_sync", true);
        meters_sucess = new Meters;
        ref2 = lora_device_collection.toArray();
        for (l = 0, len2 = ref2.length; l < len2; l++) {
          _device = ref2[l];
          findRes = meters_collect.where({
            num_serial: _device.get('devEui')
          });
          for (i = n = 0, len3 = findRes.length; n < len3; i = ++n) {
            _remove_meter = findRes[i];
            if (!i) {
              meters_sucess.add(_remove_meter);
            } else {
              _remove_meter.destroy();
            }
            meters_collect.remove(_remove_meter);
          }
        }
        ref3 = meters_collect.toArray();
        for (o = 0, len4 = ref3.length; o < len4; o++) {
          _meter = ref3[o];
          _meter.destroy();
        }
        ref4 = lora_device_collection.toArray();
        for (p = 0, len5 = ref4.length; p < len5; p++) {
          _device = ref4[p];
          find_meter = meters_sucess.where({
            num_serial: _device.get('devEui')
          });
          if (find_meter.length) {
            continue;
          }
          new_meter = new Meter({
            num_serial: _device.get('devEui'),
            converter: lora_id,
            about: _device.get('devName'),
            type_id: meter_types.at(0).get('id')
          });
          new_meter.save(null, {
            success: function(new_model) {
              meters_collect.add(new_meter);
              return meters_collect.trigger("add");
            }
          });
          meters_collect.add(new_meter);
        }
        meters_collect.add(meters_sucess.toArray());
        meters_collect.trigger("custom_sync", false);
        return meters_collect.trigger("add");
      } else if (data.cmd === "get_gateways_resp") {
        if (data.gateway_list.length > 0) {
          self.active = data.gateway_list[0].active;
          return self.trigger('active_change');
        }
      } else if (data.cmd === "get_device_appdata_resp") {
        ref5 = data.devices_list;
        for (q = 0, len6 = ref5.length; q < len6; q++) {
          _device = ref5[q];
          findDevice = meters_collect.findWhere({
            num_serial: _device.devEui
          });
          if (typeof findDevice !== "undefined") {
            device_type = _.find(deviceTypes, {
              id: Number(_device.device_type)
            });
            if (typeof device_type === "undefined") {
              device_type = _.first(deviceTypes);
            }
            findDevice.set('device_type', device_type);
            meters_collect.trigger('add');
          }
        }
        return self.__get_gataways();
      }
    };
    return this.socket.onerror = function(error) {
      return console.log("Ошибка " + error.message);
    };
  }
});

LORA_H1_VIEW = Backbone.View.extend({
  el: "#lora_h1",
  model: lora_model_gl,
  initialize: function() {
    this.render();
    return this.listenTo(this.model, "sync", this.render);
  },
  render: function() {
    return $(this.$el).text(this.model.escape('about'));
  }
});

LORA_BREADS_VIEW = Backbone.View.extend({
  el: "#lora_brads",
  model: lora_model_gl,
  initialize: function() {
    this.render();
    return this.listenTo(this.model, "sync", this.render);
  },
  render: function() {
    return $(this.$el).text(this.model.escape('about'));
  }
});

LORA_PROPERTIES_VIEW = Backbone.View.extend({
  el: "#lora_properties",
  template: "#lora_properties_tpl",
  model: lora_model_gl,
  collection: converter_types,
  socket_status: false,
  initialize: function() {
    this.render();
    this.listenTo(this.model, "sync", this.render);
    this.listenTo(this.model, "is_socket_connect_change", this.render);
    this.listenTo(this.model, "is_socket_auth_change", this.render);
    this.listenTo(this.model, "active_change", this.render);
    return this.listenTo(this.collection, "sync", this.render);
  },
  render: function() {
    var tpl_c;
    tpl_c = _.template($(this.template).html());
    return $(this.$el).empty().append(tpl_c({
      lora_model: this.model,
      types: this.collection.toArray()
    }));
  },
  events: {
    "click #converter_edit_modal": function() {
      new LORA_ADD_VIEW(this.model, null);
      return false;
    }
  }
});

LORA_ADD_VIEW = Backbone.View.extend({
  template: "#lora_add_tpl",
  render: function() {
    var self, tpl_c;
    self = this;
    tpl_c = _.template($(this.template).html());
    return this.$el = $(tpl_c({
      lora_model: this.model
    })).modal('show');
  },
  initialize: function(_model, _collection) {
    this.model = _model;
    this.collection = _collection;
    return this.render();
  },
  events: {
    "keyup #about_lora": function(e) {
      return this.model.set('about', $(e.target).closest('#about_lora').val());
    },
    "keyup #ip_lora": function(e) {
      return this.model.set('ip', $(e.target).closest('#ip_lora').val());
    },
    "keyup #port_lora": function(e) {
      var val;
      val = $(e.target).closest('#port_lora').val();
      return this.model.set('port', Number(val));
    },
    "keyup #login_lora": function(e) {
      return this.model.set('login', $(e.target).closest('#login_lora').val());
    },
    "keyup #pass_lora": function(e) {
      return this.model.set('pass', $(e.target).closest('#pass_lora').val());
    },
    "click #save": function() {
      var self, trigger;
      self = this;
      trigger = this.model.get('id') ? "up_model" : "add_model";
      return this.model.save(null, {
        success: function(m) {
          return $(self.$el).modal('hide');
        },
        error: function() {
          return $(self.$el).modal('hide');
        }
      });
    }
  }
});

LORA_DELETE_VIEW = Backbone.View.extend({
  template: "#delete_counter_tpl",
  initialize: function(_model, _collection) {
    this.model = _model;
    this.collection = _collection;
    return this.render();
  },
  render: function() {
    var self, tpl_c;
    self = this;
    tpl_c = _.template($(this.template).html());
    this.$el = $(tpl_c({
      lora_model: this.model
    })).modal('show');
    return $(this.$el).on('hidden.bs.modal', function() {
      $(this).remove();
      return self.collection.trigger('sync');
    });
  },
  events: {
    "click #delete_counter": function() {
      var self;
      self = this;
      lora_model_gl.__delete_model(this.model);
      return this.model.destroy({
        dataType: "text",
        success: function() {
          self.collection.remove(self.model);
          return $(self.$el).modal('hide');
        }
      });
    }
  }
});

LORA_CHILD_VIEW = Backbone.View.extend({
  el: "#lora_meters",
  collection: meters_collect,
  sync: false,
  template: "#lora_meters_tpl",
  initialize: function() {
    this.render();
    this.listenTo(this.collection, "sync", this.render);
    this.listenTo(this.collection, "add", this.render);
    this.listenTo(meter_types, "sync", this.render);
    return this.listenTo(this.collection, "custom_sync", function(stat_sync) {
      this.sync = stat_sync;
      return this.render();
    });
  },
  render: function() {
    var tpl_c;
    tpl_c = _.template($(this.template).html());
    return $(this.$el).empty().append(tpl_c({
      devices: this.collection.toArray(),
      sync: this.sync,
      types: meter_types
    }));
  },
  events: {
    "click #lora_add_meter": function(e) {
      new LORA_COUNTER_ADD_EDIT_MODAL(new Meter({
        converter: lora_id
      }));
      return false;
    },
    "click .converter_meter_edit": function(e) {
      var cid;
      cid = $(e.target).closest('tr').attr('id');
      new LORA_COUNTER_ADD_EDIT_MODAL(meters_collect.get(cid));
      return false;
    },
    "click .converter_meter_delete": function(e) {
      var cid;
      cid = $(e.target).closest('tr').attr('id');
      new LORA_DELETE_VIEW(meters_collect.get(cid), meters_collect);
      return false;
    }
  }
});

LORA_COUNTER_ADD_EDIT_MODAL_ACTIVATION_PRES = Backbone.View.extend({
  el: "#activation_by_pers",
  template: "#activation_by_pers_tpl",
  initialize: function(model) {
    this.model = model;
    this.model.get('lora_model').get('ABP').on('change:devAddr', function() {
      var _action, r, valid;
      valid = false;
      r = new RegExp('([A-F|a-f|0-9]{8})');
      if (r.test(this.get('devAddr'))) {
        valid = true;
      }
      _action = valid ? "removeClass" : "addClass";
      return $('#devAddr_label')[_action]('text-danger');
    });
    this.model.get('lora_model').get('ABP').on('change:appsKey', function() {
      var _action, r, valid;
      valid = false;
      r = new RegExp('([A-F|a-f|0-9]{32})');
      if (r.test(this.get('appsKey'))) {
        valid = true;
      }
      _action = valid ? "removeClass" : "addClass";
      return $('#appsKey_label')[_action]('text-danger');
    });
    this.model.get('lora_model').get('ABP').on('change:nwksKey', function() {
      var _action, r, valid;
      valid = false;
      r = new RegExp('([A-F|a-f|0-9]{32})');
      if (r.test(this.get('nwksKey'))) {
        valid = true;
      }
      _action = valid ? "removeClass" : "addClass";
      return $('#nwksKey_label')[_action]('text-danger');
    });
    return this.render();
  },
  events: {
    "keyup #devAddr_input": function(e) {
      return this.model.get('lora_model').get('ABP').set('devAddress', parseInt(Number($(e.target).val()).toString(10), 16));
    },
    "keyup #appsKey_input": function(e) {
      return this.model.get('lora_model').get('ABP').set('appsKey', $(e.target).val());
    },
    "keyup #nwksKey_input": function(e) {
      return this.model.get('lora_model').get('ABP').set('nwksKey', $(e.target).val());
    }
  },
  render: function() {
    var activation_by_pers_c;
    activation_by_pers_c = _.template($(this.template).html());
    return $(this.$el).empty().append(activation_by_pers_c({
      lora_model: this.model
    }));
  }
});

LORA_COUNTER_ADD_EDIT_MODAL_OVER_THE_AIR = Backbone.View.extend({
  el: "#over_the_air",
  template: "#over_the_air_tpl",
  initialize: function(model) {
    this.model = model;
    this.render();
    this.model.get('lora_model').get('OTAA').on('change:appEui', function() {
      var _action, r, valid;
      valid = false;
      r = new RegExp('([A-F|a-f|0-9]{16})');
      if (r.test(this.get('appEui'))) {
        valid = true;
      }
      _action = valid ? "removeClass" : "addClass";
      return $('#AppEUI_label')[_action]('text-danger');
    });
    return this.model.get('lora_model').get('OTAA').on('change:appKey', function() {
      var _action, r, valid;
      valid = false;
      r = new RegExp('([A-F|a-f|0-9]{32})');
      if (r.test(this.get('appKey'))) {
        valid = true;
      }
      _action = valid ? "removeClass" : "addClass";
      return $('#AppKey_label')[_action]('text-danger');
    });
  },
  render: function() {
    var over_the_air_c;
    over_the_air_c = _.template($(this.template).html());
    return $(this.$el).empty().append(over_the_air_c({
      lora_model: this.model
    }));
  },
  events: {
    "keyup #AppEUI_input": function(e) {
      return this.model.get('lora_model').get('OTAA').set('appEui', $(e.target).val());
    },
    "keyup #AppKey_input": function(e) {
      return this.model.get('lora_model').get('OTAA').set('appKey', $(e.target).val());
    }
  }
});

LORA_COUNTER_ADD_EDIT_MODAL_MAIN_SETTINGS = Backbone.View.extend({
  el: "#main_settings",
  template: "#main_settings_tpl",
  initialize: function(model) {
    this.model = model;
    this.render();
    return this.model.get('lora_model').on('change:devEui', function() {
      var _action, r, valid;
      valid = false;
      r = new RegExp('([A-Z|a-z|0-9]{16})');
      if (r.test(this.get('appKey'))) {
        valid = true;
      }
      _action = valid ? "removeClass" : "addClass";
      return $('#DevEUI_label')[_action]('text-danger');
    });
  },
  render: function() {
    var over_the_air_c;
    over_the_air_c = _.template($(this.template).html());
    return $(this.$el).empty().append(over_the_air_c({
      lora_model: this.model
    }));
  },
  events: {
    "keyup #DevEUI_input": function(e) {
      this.model.get('lora_model').set('devEui', $(e.target).val());
      return this.model.set('num_serial', $(e.target).val());
    },
    "change #changedClass": function(e) {
      this.model.get('lora_model').set('class', $(e.target).val());
      return console.log(this.model.get('lora_model').get('class'));
    },
    "keyup #DevName_input": function(e) {
      this.model.get('lora_model').set('devName', $(e.target).val());
      return this.model.set('about', $(e.target).val());
    },
    "change #changedType": function(e) {
      var _device_type, _meter_type;
      _device_type = _.find(deviceTypes, {
        id: Number($(e.target).val())
      });
      if (typeof _device_type === "undefined") {
        _device_type = _.first(deviceTypes);
      }
      _meter_type = meter_types.findWhere({
        title: _device_type.name
      });
      this.model.get('lora_model').set('device_type', _device_type.id);
      this.model.set('type', _meter_type.get('id'));
      return this.model.set('device_type', _device_type);
    }
  }
});

LORA_COUNTER_ADD_EDIT_MODAL = Backbone.View.extend({
  template: "#lora_counter_add_edit",
  initialize: function(model) {
    this.model = model;
    this.render();
    return this.listenTo(this.model, "sync", function() {
      return $(this.$el).modal('hide');
    });
  },
  render: function() {
    var self, tpl_c;
    self = this;
    tpl_c = _.template($(this.template).html());
    this.$el = $(tpl_c({
      lora_model: this.model
    })).modal('show');
    return $(this.$el).on('shown.bs.modal', function() {
      new LORA_COUNTER_ADD_EDIT_MODAL_ACTIVATION_PRES(self.model);
      new LORA_COUNTER_ADD_EDIT_MODAL_OVER_THE_AIR(self.model);
      return new LORA_COUNTER_ADD_EDIT_MODAL_MAIN_SETTINGS(self.model);
    }).on('hidden.bs.modal', function() {
      return $(this).remove();
    });
  },
  events: {
    "click #expert_sessings_contoller": function(e) {
      var action;
      action = $(e.target).find('i').hasClass('fa-chevron-circle-down') ? "removeClass" : "addClass";
      $('#expert_sessings')[action]('hide');
      if ($(e.target).find('i').hasClass('fa-chevron-circle-down')) {
        $(e.target).find('i').removeClass('fa-chevron-circle-down').addClass("fa-chevron-circle-up");
      } else {
        $(e.target).find('i').removeClass('fa-chevron-circle-up').addClass("fa-chevron-circle-down");
      }
      return false;
    },
    "change #changedClass": function(e) {
      var action;
      action = $(e.target).val() === "CLASS_C" ? "removeClass" : "addClass";
      return $('#classCsettings')[action]('hide');
    },
    "click #save": function() {
      if (!this.model.get('id')) {
        console.log(this.model.toJSON());
        meters_collect.add(this.model);
      }
      lora_model_gl.__save_counter(this.model);
      return false;
    }
  }
});

$(document).ready(function() {
  converter_types.fetch();
  meter_types.fetch({
    success: function() {
      meters_collect.fetch();
      lora_model_gl.fetch();
      return new LORA_CHILD_VIEW;
    }
  });
  new LORA_H1_VIEW;
  new LORA_BREADS_VIEW;
  return new LORA_PROPERTIES_VIEW;
});
