// Generated by CoffeeScript 1.9.3
var Actions, Filter, IsOk, Meter, MeterDelete, MeterEditAdd, MeterType, MeterTypes, MeterTypesChanged, MeterTypesTrash, Meters, MetersList, Pagination, count, filter, meters, metertypes, page, pages, pagination, replacePagination;

page = 1;

count = "10";

pages = [];

Filter = Backbone.Model.extend({
  defaults: {
    types: [],
    is_ok: [0, 1],
    is_excluded: [0,1],
    count: count,
    page: page
  }
});

filter = new Filter;

IsOk = Backbone.View.extend({
  el: "#is_ok_container",
  events: {
    "click input": function(e) {
      var filter_checked;
      filter_checked = [];
      $(this.$el).find(':checked').each(function(i, e) {
        return filter_checked.push(Number($(e).val()));
      });
      return filter.set('is_ok', filter_checked);
    }
  }
});

new IsOk;

IsExcluded = Backbone.View.extend({
  el: "#is_excluded_container",
  events: {
    "click input": function(e) {
      var filter_checked;
      filter_checked = [];
      console.log($(this.$el).find(':checked'))
      $(this.$el).find(':checked').each(function(i, e) {
        return filter_checked.push(Number($(e).val()));
      });
      return filter.set('is_excluded', filter_checked);
    }
  }
});

new IsExcluded;

Meter = Backbone.Model.extend({
  defaults: {
    id: 0,
    about: "",
    meter_type_title: "",
    type: 0,
    converter: 0,
    converter_about: "",
    num_serial: "",
    password: "",
    timezone_id: 0,
    num485: 0,
    model: 0,
    number_plomb: "",
    mark: "",
    status: 0,
    checked: false,
    first_date_verification: "",
    date_verification: "",
    interval_verification: 60
  },
  url: function() {
    return "/api/?object=meter&filter=id:" + this.get('id');
  },
  parse: function(a) {
    a.id = Number(a.id);
    return a;
  }
});

Meters = Backbone.Collection.extend({
  model: Meter,
  url: function() {
    return "/api/meters/?" + $.param(filter.toJSON());
  },
  user_fetch: function() {

    /*
    		$('#meters').before(
    			$('<div></div>')
    			.addClass 'loader_circle_bg'
    			.append(
    				$('<div></div>')
    				.addClass 'loader_circle' 
    			)
    		)
     */
    $('#meters').prepend($('<div>').attr({
      id: 'CAPNAG'
    }).css({
      width: '50px',
      height: '50px',
      zIndex: 1002
    }).append($('<div/>').addClass('page-preloader-cover').append(function() {
      return [1, 2, 4, 3].map(function(item) {
        return $(this).append($('<div/>').addClass('page-preloader__cube page-preloader--cube' + item));
      }, this);
    })));
    meters.fetch({
      success: function(r) {
        $('#CAPNAG').remove();
        $('.page-preloader-cover').remove();
      },
      error: function() {
        $('#CAPNAG').remove();
        return $('.page-preloader-cover').remove();
      }
    });
    return false;
  }
});

meters = new Meters;

filter.on("change", meters.user_fetch);

MetersList = Backbone.View.extend({
  template: "#meters_tpl",
  el: "#meters",
  collection: meters,
  initialize: function() {
    this.listenTo(this.collection, "sync", this.render);
    this.listenTo(this.collection, "remove", this.render);
    return this.render();
  },
  render: function() {
    var tpl, tpl_c;
    tpl = _.template($(this.template).html());
    tpl_c = tpl({
      meters: this.collection.toArray()
    });
    return $(this.$el).find('tbody').empty().append(tpl_c);
  },
  events: {
    "click #converter_add_meter": function() {
      new MeterEditAdd(new Meter({
        id: 0
      }));
      return false;
    },
    "click .fa-copy": function(e) {
      return new MeterEditAdd(meters.get($(e.target).closest('tr').attr('id')).clone().set('id', 0));
    },
    "click .fa-pencil": function(e) {
      return new MeterEditAdd(meters.get($(e.target).closest('tr').attr('id')));
    },
    "click .fa-times": function(e) {
      return new MeterDelete(meters.get($(e.target).closest('tr').attr('id')));
    }
  }
});

new MetersList;

meters.user_fetch();

MeterType = Backbone.Model.extend({
  defaults: {
    id: 0,
    title: 0,
    use: 0
  }
});

MeterTypes = Backbone.Collection.extend({
  model: MeterType
});

metertypes = new MeterTypes;

metertypes.on("change", function() {
  var e, filter_types, i, j, len, ref;
  filter_types = [];
  ref = metertypes.where({
    use: 1
  });
  for (e = j = 0, len = ref.length; j < len; e = ++j) {
    i = ref[e];
    filter_types.push(i.get('id'));
  }
  return filter.set('types', filter_types);
});

$(document).ready(function() {
  return $('#metertype_container').find('option').each(function(i, op) {
    var m;
    m = new MeterType({
      id: Number($(op).val()),
      title: $(op).text(),
      use: 0
    });
    return metertypes.add(m);
  });
});

MeterTypesTrash = Backbone.View.extend({
  el: "#metertype_container",
  template: "#metertype_container_tpl",
  collection: metertypes,
  initialize: function() {
    this.listenTo(this.collection, "change", this.render);
    return this.render();
  },
  events: {
    "change": function(e) {
      this.collection.find({
        id: Number($(e.target).val())
      }).set({
        use: 1
      });
      return false;
    }
  },
  render: function() {
    var tpl;
    tpl = _.template($(this.template).html());
    return $(this.$el).empty().append(tpl({
      selected: this.collection.where({
        use: 0
      })
    }));
  }
});

$(document).ready(function() {
  return new MeterTypesTrash;
});

MeterTypesChanged = Backbone.View.extend({
  el: "#metertypes_change_container",
  collection: metertypes,
  template: "#metertypes_change_container_tpl",
  initialize: function() {
    this.listenTo(this.collection, "change", this.render);
    return this.render();
  },
  render: function() {
    var tpl;
    tpl = _.template($(this.template).html());
    return $(this.$el).empty().append(tpl({
      selected: this.collection.where({
        use: 1
      })
    }));
  },
  events: {
    "click a": function(e) {
      var id;
      id = Number($(e.target).closest('span').attr('data-id'));
      this.collection.find({
        id: id
      }).set({
        use: 0
      });
      return false;
    }
  }
});

new MeterTypesChanged;

$('#check_all').on('change', function(e) {
  var check;
  check = $(e.target).prop('checked');
  return $('#meters').find('input[type="checkbox"]').each(function(i, el) {
    if ($(el).attr('id') !== "check_all") {
      $(el).prop('checked', check);
      return meters.find({
        id: Number($(el).val())
      }).set({
        checked: $(el).prop('checked')
      });
    }
  });
});

$('#meters').on('change', 'input[type="checkbox"]', function(e) {
  var m;
  if ($(e.target).attr('id') !== "check_all") {
    m = meters.find({
      id: Number($(e.target).val())
    });
    if (typeof m !== "undefined") {
      return m.set({
        checked: $(e.target).prop('checked')
      });
    }
  }
});

Actions = Backbone.View.extend({
  el: "#actions_meters",
  template: "#actions_meters_tpl",
  collection: meters,
  initialize: function() {
    this.listenTo(this.collection, "change", this.render);
    return this.render();
  },
  render: function() {
    var tpl;
    tpl = _.template($(this.template).html());
    return $(this.$el).empty().append(tpl({
      meters: this.collection.where({
        checked: true
      })
    }));
  },
  events: {
    "click #delete_meters": function(e) {
      if ($(e.target).hasClass('disabled')) {
        return false;
      }
      new MeterDelete;
      return false;
    },
    "click #excluded_meters": function(e) {
      var j, len, meter, ref;
      ref = this.collection.where({
        checked: true
      });
      for (j = 0, len = ref.length; j < len; j++) {
        meter = ref[j];
        if (Number(meter.get("is_excluded")) === 0 || !meter.get("is_excluded")) {
          meter.set({
            "is_excluded": 1
          });
        } else {
          meter.set({
            "is_excluded": 0
          });
        }
        meter.set({
          checked: false
        });
        meter.save();
      }
      this.collection.trigger("sync");
      return false;
    }
  }
});

new Actions;

MeterDelete = Backbone.View.extend({
  template: "#device_delete_modal",
  collection: meters,
  modal: null,
  initialize: function(model) {
    if (model == null) {
      model = null;
    }
    this.model = model;
    return this.render();
  },
  render: function() {
    var self, tpl;
    tpl = _.template($(this.template).html());
    this.modal = $(tpl()).modal('show');
    self = this;
    return this.modal.on("click", "#delete", function() {
      var el, i, j, len, ref;
      if (self.model !== null) {
        self.model.destroy({
          dataType: "text"
        }, {
          success: function() {
            return self.collection.remove(self.model);
          }
        });
      }
      ref = self.collection.where({
        checked: true
      });
      for (i = j = 0, len = ref.length; j < len; i = ++j) {
        el = ref[i];
        el.destroy({
          dataType: "text",
          success: function(res, r) {
            if (r === "droped") {
              return self.collection.remove(el);
            }
          }
        });
      }
      return $(self.modal).modal('hide');
    });
  }
});

MeterEditAdd = Backbone.View.extend({
  template: "#meter_edit_add",
  model: new Meter({
    id: 0
  }),
  initialize: function(model) {
    this.model = model;
    return this.render();
  },
  render: function() {
    var self, tpl_c;
    tpl_c = _.template($(this.template).html());
    this.modal = $(tpl_c({
      meter: this.model
    })).modal('show');
    self = this;
    return $(this.modal).on("click", ".more_settings_controller", function() {
      $('.more_settings').toggleClass('hide');
      $(this).find('i').toggleClass('fa-chevron-circle-down');
      return $(this).find('i').toggleClass('fa-chevron-circle-up');
    }).on("change", "#converter_select", function(e) {
      self.model.set({
        converter_about: $("#converter_select").find(":selected").text().trim()
      });
      return self.model.set({
        converter: Number($(e.target).val())
      });
    }).on("change", '[name="TypeId"]', function(e) {
      self.model.set({
        type: Number($(e.target).val())
      });
      return self.model.set({
        meter_type_title: $(e.target).closest('select').find(":selected").text().trim()
      });
    }).on("keyup", '[name="About"]', function(e) {
      return self.model.set({
        about: $(e.target).val()
      });
    }).on("keyup", '[name="NumSerial"]', function(e) {
      return self.model.set({
        num_serial: $(e.target).val()
      });
    }).on("keyup", '[name="Num485"]', function(e) {
      return self.model.set({
        num485: Number($(e.target).val())
      });
    }).on("keyup", '[name="Password"]', function(e) {
      return self.model.set({
        password: $(e.target).val()
      });
    }).on("keyup", '[name="Coef"]', function(e) {
      return self.model.set({
        coef: Number($(e.target).val())
      });
    }).on("change", '[name="TimezoneId"]', function(e) {
      return self.model.set({
        timezone_id: Number($(e.target).val())
      });
    }).on("change", '[name="DateFirstVerification"]', function(e) {
      return self.model.set({
        first_date_verification: $(e.target).val()
      });
    }).on("keyup", '[name="DateVerificationInterval"]', function(e) {
      return self.model.set({
        interval_verification: $(e.target).val()
      });
    }).on("change", '[name="DateVerificationInterval"]', function(e) {
      return self.model.set({
        interval_verification: $(e.target).val()
      });
    }).on("change", '[name="Model"]', function(e) {
      return self.model.set({
        model: $(e.target).val()
      });
    }).on("keyup", '[name="NumberPlomb"]', function(e) {
      return self.model.set({
        number_plomb: $(e.target).val()
      });
    }).on("click", '#save_meter', function() {
      return self.model.save(null, {
        success: function(res) {
          res.set('id', res.get('id') + "");
          meters.add(res);
          return $(self.modal).modal('hide');
        }
      });
    }).on("hidden.bs.modal", function() {
      return $(self.modal).remove();
    }).on("shown.bs.modal", function() {
      self.model.set({
        model : $("#model").val()
      })
    });
  }
});

Pagination = Backbone.View.extend({
  el: "#pagination",
  template: "#pagination_tpl",
  initialize: function() {
    return this.render();
  },
  render: function() {
    var tpl_c;
    tpl_c = _.template($(this.template).html());
    return $(this.$el).empty().append(tpl_c({
      pages: pages,
      active_count: count,
      active_page: page
    }));
  },
  events: {
    "click .paginator_pages a": function(e) {
      page = Number($(e.target).text());
      filter.set({
        page: page
      });
      this.render();
      return false;
    },
    "click .paginator_counter a": function(e) {
      count = $(e.target).text();
      if (isNaN(count)) {
        count = "all";
      }
      filter.set({
        count: count
      });
      meters.user_fetch();
      replacePagination();
      this.render();
      return false;
    }
  }
});

pagination = new Pagination;

meters.on('sync', function() {
  return replacePagination();
});

replacePagination = function() {
  return $.get('/api/meters/?get_pages=' + count + "&" + $.param(filter.toJSON()), function(data) {
    var all, i, is_after, is_before, j, k, l, len, magnet, n, o, p, q, ref, ref1, ref10, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9, results, results1, v;
    magnet = 2;
    all = Number(data);
    pages = [];
    if (page > magnet) {
      for (i = j = 1, ref = magnet; 1 <= ref ? j <= ref : j >= ref; i = 1 <= ref ? ++j : --j) {
        if (i <= 0) {
          continue;
        }
        if (pages.indexOf(i) === -1) {
          pages.push(i);
        }
      }
    }
    if (page < all - magnet) {
      for (i = k = ref1 = all - magnet + 1, ref2 = all; ref1 <= ref2 ? k <= ref2 : k >= ref2; i = ref1 <= ref2 ? ++k : --k) {
        if (i > all) {
          continue;
        }
        if (pages.indexOf(i) === -1) {
          pages.push(i);
        }
      }
    }
    is_before = (function() {
      results = [];
      for (var l = ref3 = Math.ceil(all / 2 - magnet), ref4 = Math.ceil(all / 2 + magnet); ref3 <= ref4 ? l <= ref4 : l >= ref4; ref3 <= ref4 ? l++ : l--){ results.push(l); }
      return results;
    }).apply(this).indexOf(page - magnet - 1) === -1;
    is_after = (function() {
      results1 = [];
      for (var n = ref5 = Math.ceil(all / 2 - magnet), ref6 = Math.ceil(all / 2 + magnet); ref5 <= ref6 ? n <= ref6 : n >= ref6; ref5 <= ref6 ? n++ : n--){ results1.push(n); }
      return results1;
    }).apply(this).indexOf(page + magnet + 1) === -1;
    if (is_before && is_after) {
      for (i = o = ref7 = Math.ceil(all / 2 - magnet), ref8 = Math.ceil(all / 2 + magnet); ref7 <= ref8 ? o <= ref8 : o >= ref8; i = ref7 <= ref8 ? ++o : --o) {
        if (i <= 0) {
          continue;
        }
        if (i > all) {
          continue;
        }
        if (pages.indexOf(i) === -1) {
          pages.push(i);
        }
      }
    }
    for (i = p = ref9 = page - magnet, ref10 = page + magnet; ref9 <= ref10 ? p <= ref10 : p >= ref10; i = ref9 <= ref10 ? ++p : --p) {
      if (i <= 0) {
        continue;
      }
      if (i > all) {
        continue;
      }
      if (pages.indexOf(i) === -1) {
        pages.push(i);
      }
    }
    pages = pages.sort(function(a, b) {
      return a - b;
    });
    for (i = q = 0, len = pages.length; q < len; i = ++q) {
      v = pages[i];
      if (v === "...") {
        continue;
      }
      if (v >= all) {
        continue;
      }
      if (v + 1 !== pages[i + 1]) {
        pages.splice(i + 1, 0, "...");
      }
    }
    return pagination.render();
  }, "JSON");
};
