/* global Backbone */

/**
 * Модель места
 * 
 * @type Backbone.Model
 */

var PLACE = Backbone.Model.extend({

  defaults : {
    id        : 0,
    title     : '',
    place     : 0,
    type      : 1,
    bankbook  : ""
  },


  /**
   * Адрес API
   * 
   * @returns {String}
   */
  url : function(){
    return '/api/place/' + this.get('id') + "/";
  },


  /**
   * Проверка на вилидацию модели
   * 
   * @returns {String|undefined}
   */
  validate : function(){

    if( this.get('title') === this.defaults.title ){
      return "empty_title";
    }

  }
});