// Generated by CoffeeScript 1.9.3
var METERPLACE, METERPLACES, MODAL_SUCCESS, PALCE_EDIT_METERS, PLACE, PLACES, PLACE_BREADS, PLACE_CHILDREN, PLACE_CHILDREN_ACTION, PLACE_CHILD_COUNT, PLACE_CHILD_PAGE, PLACE_DELETE, PLACE_EDIT, PLACE_EDIT_CHILDREN, PLACE_EDIT_MAIN, PLACE_EDIT_MAIN_TITLE, PLACE_EDIT_NEW_VIEW, PLACE_EDIT_PARAM, PLACE_H1, PLACE_INFO_TABLE, PLACE_VIEW_TO_TREE, place, places;

PLACE_CHILD_COUNT = 10;

PLACE_CHILD_PAGE = 1;

MODAL_SUCCESS = Backbone.View.extend({
  template: '#modal_success_tpl',
  initialize: function(msg) {
    this.render(msg);
    return this;
  },
  render: function(msg) {
    return swal({
      title: msg,
      text: "",
      timer: 800,
      type: "success",
      showConfirmButton: false
    });
  }
});

PLACE = Backbone.Model.extend({
  defaults: {
    id: 0,
    title: '',
    place: 0,
    type: 1,
    bankbook: "",
    meter_all: 0,
    meter_error: 0,
    meter_excluded: 0,
    places: 0
  },
  url: function() {
    return '/api/place/' + this.get('id') + "/";
  },
  validate: function() {
    if (this.get('title') === this.defaults.title) {
      return "empty_title";
    }
  },
  __is_delete: function() {
    return this.get('meter_all') === 0 && this.get('places') === 0;
  }
});

PLACES = Backbone.Collection.extend({
  model: PLACE,
  url: function() {
    var count, page;
    count = PLACE_CHILD_COUNT || 10;
    page = PLACE_CHILD_PAGE || 1;
    return '/api/place/?place=' + place.get('id') + '&page=' + page + '&count=' + count;
  }
});

place = new PLACE({
  id: id
});

places = new PLACES;

places.on('sync', function() {
  return $.get("/tpl/", {
    data: {
      id: place.get('id')
    },
    tpl: "place_children_pagination",
    count: 10,
    page: PLACE_CHILD_PAGE
  }, function(data) {
    return $('#pagination_children_place').empty().append($(data).html()).on('click', 'a', function(e) {
      var page;
      page = Number($(e.target).text());
      if (page !== PLACE_CHILD_PAGE) {
        PLACE_CHILD_PAGE = page;
        places.fetch();
      }
      return false;
    });
  });
});

PLACE_EDIT_NEW_VIEW = Backbone.View.extend({
  action: null,
  template: "#place_modal_children_tpl",
  model: null,
  new_place: null,
  modal: null,
  initialize: function(place) {
    var tpl;
    if (place == null) {
      return false;
    }
    this.model = place;
    tpl = _.template($(this.template).html());
    if (this.model.get('id') === 0) {
      this.model.set('title', $('.page-header').text().trim());
    }
    this.new_place = this.action === "edit" ? this.model : new PLACE({
      place: this.model.get('id')
    });
    this.modal = tpl({
      place: this.new_place,
      place_parent: this.model
    });
    this.$el = $(this.modal);
    return this.render();
  },
  render: function() {
    return $(this.$el).modal('show').on("hide.bs.modal", function() {
      return $("#place_modal_children").remove();
    });
  },
  update: function(e) {
    var ident, type;
    type = Number($("#place_change_type").val());
    ident = '#place_kvartira_fields, #place_form_title';
    $(ident)[type === 4 ? "show" : "hide"]();
    ident = '#place_bankbook';
    $(ident)[type === 2 ? "show" : "hide"]();
    ident = '[name="Title"]';
    $(ident).closest('.form-group')[type === 4 ? "hide" : "show"]();
    if (type === 4) {
      return $("#template_place_view").html(function() {
        var i, j, res;
        res = "";
        for (i = j = 0; j < 4; i = ++j) {
          res += "<small>" + $('[name="template"]').val() + (i + 1) + "</small><br>";
        }
        res += "<small>...</small>";
        return res;
      });
    }
  },
  message_success: "",
  progress_added_children: 0,
  replaceProgress: function() {
    $('.progress')[this.progress_added_children % 100 === 0 ? "addClass" : "removeClass"]('hide');
    $('.progress-bar').text(this.progress_added_children + "%");
    return $('.progress-bar').css("width", this.progress_added_children + "%");
  },
  events: {
    "change #place_change_type": function(e) {
      this.new_place.set('type', Number($(e.target).val()));
      this.update(e);
      return false;
    },
    "keyup [name='template']": function(e) {
      this.update(e);
    },
    "keyup [name='count_places']": function(e) {
      this.update(e);
    },
    "keyup #place_form_title input[type='title']": function(e) {
      return this.new_place.set('title', $(e.target).val().trim());
    },
    "keyup #place_bankbook input[type='BankBook']": function(e) {
      return this.new_place.set('bankbook', $(e.target).val().trim());
    },
    "click #add_children": function() {
      var self;
      this.progress_added_children = 0;
      this.replaceProgress();
      self = this;
      if (Number(this.new_place.get('type')) === 4) {
        this.new_place.set("title", "~");
      } else {
        this.new_place.set("title", $('[name="Title"]').val());
      }
      $('#place_children_container').append($('<div/>').attr('id', 'place_add_prev').append($('<div/>').addClass('loader').append($('<div/>').addClass('page-preloader-cover').append($('<div/>').addClass('page-preloader__cube page-preloader--cube1')).append($('<div/>').addClass('page-preloader__cube page-preloader--cube2')).append($('<div/>').addClass('page-preloader__cube page-preloader--cube4')).append($('<div/>').addClass('page-preloader__cube page-preloader--cube3')).append($('<div/>').css("clear", "both")))).append($('<div/>').addClass('loader_back')));
      return this.new_place.save(null, {
        success: function() {
          var add_child;
          $("#place_add_prev").remove();
          add_child = function(prefix, point, ost, place_id) {
            var place_m;
            console.log("ad_child");
            place_m = new PLACE({
              place: place_id,
              title: prefix + point,
              type: 4
            });
            return place_m.save(null, {
              success: function() {
                self.progress_added_children = 100 / ost * point;
                self.replaceProgress();
                if (point !== ost) {
                  add_child(prefix, ++point, ost, place_id);
                  return console.log("sasasa2");
                } else {
                  self.new_place.destroy();
                  $("#place_modal_children").modal('hide');
                  return places.fetch();
                }
              }
            });
          };
          if (Number(self.new_place.get('type')) === 4) {
            if (Number($('[name="count_places"]').val()) !== 0) {
              add_child($('[name="template"').val(), 1, Number($('[name="count_places"]').val()), Number(place.get('id')));
            }
          } else {
            $("#place_modal_children").modal('hide');
          }
          if (Number(self.new_place.get('type')) !== 4) {
            return places.trigger("add_place");
          }
        }
      });
    }
  }
});

PLACE_EDIT = PLACE_EDIT_NEW_VIEW.extend({
  message_success: "Изменено!",
  action: "edit"
});

PLACE_CHILDREN_ACTION = PLACE_EDIT_NEW_VIEW.extend({
  message_success: "Добавлено!",
  action: "add"
});

PLACE_DELETE = Backbone.View.extend({
  template: '#modal_delete_tpl',
  modal: null,
  initialize: function(place) {
    if (place == null) {
      return false;
    }
    this.model = place;
    return this.render();
  },
  render: function() {
    var self, tpl;
    self = this;
    tpl = _.template($(this.template).html());
    this.modal = tpl({
      place: this.model
    });
    return $(this.modal).modal('show').on("click", "#delete_object", function() {
      var collection;
      collection = self.model.collection;
      return self.model.destroy({
        success: function() {
          collection.trigger("delete_place");
          return $("#modal_delete").modal('hide');
        }
      });
    }).on("hide.bs.modal", function() {
      return $("#modal_delete").remove();
    });
  }
});

PLACE_EDIT_CHILDREN = Backbone.View.extend({
  el: "#controller_edit_place",
  initialize: function(place) {
    if (place == null) {
      return false;
    }
    return new PLACE_EDIT(place);
  }
});

PLACE_EDIT_MAIN = Backbone.View.extend({
  el: "#controller_edit_place",
  events: {
    "click": function() {
      new PLACE_EDIT(place);
      return false;
    }
  }
});

PLACE_H1 = Backbone.View.extend({
  el: ".container_h1_place",
  model: place,
  initialize: function() {
    return this.listenTo(this.model, "change:title", this.render);
  },
  render: function() {
    return $(this.$el).text(this.model.get('title'));
  }
});

PLACE_BREADS = PLACE_H1.extend({
  el: ".breadcrumb .active"
});

PLACE_INFO_TABLE = PLACE_H1.extend({
  el: ".container_place_name"
});

PLACE_EDIT_PARAM = Backbone.View.extend({
  el: "#place_edit_parameter",
  model: place,
  events: {
    "click": function() {
      this.modal();
      return false;
    }
  },
  modal: function() {
    var self;
    self = this;
    return $.get("/tpl/", {
      tpl: "place_parameter_data",
      data: [id],
      change_filter_ht: (function() {
        var Regexp_Heat, Regexp_Water, url;
        Regexp_Water = new RegExp(/(.*)\/water\//);
        Regexp_Heat = new RegExp(/(.*)\/heat\//);
        url = window.location.pathname;
        if (Regexp_Water.test(url)) {
          return "AquaCounter";
        }
        if (Regexp_Heat.test(url)) {
          return "HeatCounter";
        }
        return "ElectricityCounter";
      })
    }, function(data) {
      var modal;
      $('body').append($(data).html());
      modal = $('#filterParameterData').modal('show').on("click", ".list-group-item", function(e) {
        return $(e.target).closest('a').toggleClass('active');
      }).on("click", "#deselect_all", function() {
        return $('#sortable').find('.list-group-item').removeClass("active");
      }).on("click", "#select_all", function() {
        return $('#sortable').find('.list-group-item').addClass("active");
      }).on("click", "#save_filter", function() {
        var Regexp_Heat, Regexp_Water, change_filter_ht, countget, url;
        Regexp_Water = new RegExp(/(.*)\/water\//);
        Regexp_Heat = new RegExp(/(.*)\/heat\//);
        countget = 0;
        url = window.location.pathname;
        if (Regexp_Water.test(url)) {
          change_filter_ht = "AquaCounter";
        } else if (Regexp_Heat.test(url)) {
          change_filter_ht = "HeatCounter";
        } else {
          change_filter_ht = "ElectricityCounter";
        }
        return $("#sortable").find(".list-group-item").each(function(i, el) {
          var a, id, pid;
          countget += 1;
          pid = $(el).attr('id').replace("parameter_filter_", "");
          id = self.model.get('id');
          a = $(el).hasClass("active") ? "e" : "d";
          url = "/place/fp/?id=" + id + "&pid=" + pid + "&i=" + (i + 1) + "&a=" + a + "&s=&change_filter_ht=" + change_filter_ht;
          return $.get(url, function() {
            countget -= 1;
            if (countget === 0) {
              swal({
                title: "",
                text: "",
                timer: 800,
                type: "success",
                showConfirmButton: false
              });
              $(modal).modal("hide");
              return location.reload();
            }
          });
        });
      }).on('hidden.bs.modal', function() {
        return $("#filterParameterData").remove();
      });
      $("#sortable").sortable();
      return $("#sortable").disableSelection();
    });
  }
});

METERPLACE = Backbone.Model.extend({
  defaults: {
    id: 0,
    meter: 0,
    place: 0,
    converter: 0
  },
  url: function() {
    return "/api/?object=meterplace&filter=id:" + this.get('id');
  }
});

METERPLACES = Backbone.Collection.extend({
  model: METERPLACE,
  url: function() {
    return "/api/?object=meterplace&filter=place:" + place.get('id');
  }
});

PALCE_EDIT_METERS = Backbone.View.extend({
  el: "#edit_meters",
  collection: new METERPLACES,
  model: place,
  initialize: function() {
    return this.listenTo(this.collection, "append cut", this.updateTree);
  },
  updateTree: function(node, core) {
    var meter, meterplace, self;
    if ((core.event == null) || typeof core.event === "undefined") {
      return false;
    }
    self = this;
    core = core;
    $(core.event.target).closest('li').addClass("jstree-loading");
    meter = Number(node.id.replace(/([^0-9]*)([0-9]*)/g, function(_, f, id) {
      return id;
    }));
    if (node.state.selected) {
      if (typeof self.collection.findWhere({
        meter: meter
      }) !== "undefined") {
        return false;
      }
      meterplace = new METERPLACE({
        meter: meter,
        place: Number(this.model.get('id')),
        converter: Number(node.parent.replace(/([^0-9]*)([0-9]*)/g, function(_, f, id) {
          return id;
        }))
      });
      return meterplace.save(null, {
        success: function() {
          self.collection.add(meterplace);
          return $(core.event.target).closest('li').removeClass("jstree-loading");
        }
      });
    } else {
      return self.collection.findWhere({
        meter: meter
      }).destroy({
        dataType: 'text',
        success: function(res) {
          return $(core.event.target).closest('li').removeClass("jstree-loading");
        }
      });
    }
  },
  events: {
    "click": function() {
      var self;
      self = this;
      return $.get("/tpl/", {
        tpl: "place_modal_edit_meters",
        data: [id]
      }, function(data) {
        return $(data).modal('show').on('shown.bs.modal', function() {
          return self.tree("converter");
        }).on("click", "#vconverter_tab", function() {
          return self.tree("vconverter");
        }).on("click", "#converter_tab", function() {
          return self.tree("converter");
        }).on("click", "#cconverter_tab", function() {
          return self.tree("cconverter");
        }).on('hidden.bs.modal', function() {
          return location.reload();
        });
      });
    }
  },
  tree: function(type) {
    var checked_node, opened_nodes, self, tree;
    opened_nodes = [];
    checked_node = [];
    this.collection.fetch({
      success: function(collect) {
        var i, ident, j, k, len, len1, model, ref, ref1;
        ref = collect.toArray();
        for (j = 0, len = ref.length; j < len; j++) {
          model = ref[j];
          opened_nodes.push(type + "_tree_" + model.get('converter'));
          ref1 = ["meter_tree_", "cmeter_tree_", "vmeter_tree_"];
          for (i = k = 0, len1 = ref1.length; k < len1; i = ++k) {
            ident = ref1[i];
            checked_node.push(ident + model.get('meter'));
          }
        }
      }
    });
    self = this;
    tree = $('.meter_place_changed').data('jstree');
    if (typeof tree !== "undefined" && (tree != null)) {
      $('.meter_place_changed').jstree(true).destroy();
    }
    return $('.meter_place_changed').jstree({
      "core": {
        "check_callback": function() {
          return true;
        },
        'themes': {
          'name': 'proton',
          'responsive': true
        },
        'data': {
          'url': function(node) {
            if (node.id !== '#') {
              return "/api/?object=" + type.replace(/(.?)converter_tree_([0-9]*)/g, function(_, p) {
                return p;
              }).replace('converter', '') + "meter&tree=true&filter=converter:" + node.id.replace(type + "_tree_", '');
            }
            return '/api/?object=' + type + '&tree=true';
          }
        }
      },
      view: self,
      "checkbox": {
        "three_state": false
      },
      "plugins": ["json", "types", "checkbox", "sort"],
      "sort": function(a, b) {
        var a1, b1;
        a1 = this.get_node(a);
        b1 = this.get_node(b);
        if (a1.text === b1.text) {
          return 0;
        }
        if (a1.text > b1.text) {
          return 1;
        } else {
          return -1;
        }
      }
    }).bind('load_node.jstree', function(e, core) {
      core.node.children.map(function(ee) {
        if (ee.match(/(.?)converter(.*)/)) {
          return $("#" + ee + ' > a > .jstree-checkbox').remove();
        }
      });
      return core.instance.open_node(opened_nodes);
    }).bind('open_node.jstree', function(e, core) {
      if (core.node.id.match(/(.?)converter(.*)/)) {
        $("#" + core.node.id + ' > a > .jstree-checkbox').remove();
      }
      return core.instance.select_node(checked_node);
    }).bind('select_node.jstree', function(e, core) {
      return self.collection.trigger("append", core.node, core);
    }).bind('deselect_node.jstree', function(e, core) {
      self.collection.trigger("cut", core.node, core);
      return false;
    });
  }
});


PLACE_EDIT_MAIN_TITLE = Backbone.View.extend({
  el: ".page-header",
  events: {
    "click #edit_main_name": function(e) {
      $("#title_view").hide();
      $("#title_edit").show();
      return false;
    },
    "click #main_title": function() {
      $.post('/interprise/my/edit/', {
        name: $('#name_interprise').val()
      }, function(new_name) {
        $('#span_name_interprise').text(new_name);
        $('.breadcrumb').find('.active').text(new_name);
        return $('.container_place_name').text(new_name);
      });
      $("#title_view").show();
      $("#title_edit").hide();
      return false;
    }
  }
});

PLACE_CHILDREN = Backbone.View.extend({
  el: "#place_children_table",
  template: "#list_children_tpl",
  collection: places,
  model: place,
  initialize: function() {
    var self;
    self = this;
    this.listenTo(this.collection, 'sync', this.render);
    this.listenTo(this.collection, 'delete_place', function() {
      return self.collection.fetch({
        success: function() {
          return self.render();
        }
      });
    });
    this.listenTo(this.collection, 'add_place', function() {
      return self.collection.fetch({
        success: function() {
          return self.render();
        }
      });
    });
    return this.render();
  },
  render: function() {
    var tpl;
    tpl = _.template($(this.template).html());
    $(this.$el).empty().append(tpl({
      places: this.collection.toArray()
    }));
    return false;
  },
  events: {
    "click .children_edit": function(e) {
      var cid;
      cid = $(e.target).closest('tr').attr('id');
      new PLACE_EDIT_CHILDREN(this.collection.get(cid));
      return false;
    },
    "click .children_delete": function(e) {
      var cid;
      cid = $(e.target).closest('tr').attr('id');
      if (!this.collection.get(cid).__is_delete()) {
        return false;
      }
      new PLACE_DELETE(this.collection.get(cid));
      return false;
    },
    "click .add_child": function(e) {
      new PLACE_CHILDREN_ACTION(this.model);
      return false;
    }
  }
});

$(document).ready(function() {
  place.fetch();
  places.fetch({
    success: function() {
      new PLACE_CHILDREN;
      return false;
    }
  });
  new PLACE_EDIT_MAIN;
  new PLACE_H1;
  new PLACE_BREADS;
  new PLACE_INFO_TABLE;
  new PLACE_EDIT_PARAM;
  new PALCE_EDIT_METERS;
  // new PLACE_VIEW_TO_TREE;
  new PLACE_EDIT_MAIN_TITLE;

  return false;
});
