/* global Backbone, _ */

var MODAL_DELETE_USER_GROUP = Backbone.View.extend({
  
  template : "#modal_delete_group_user_tpl",
  
  /**
   * 
   * @param {GROUPUSER} groupuser
   * @param {GROUP} group
   * @returns {Backbone.View}
   */
  initialize : function( groupuser , group ){
    
    var self = this;
    
    if( group ){
      this.group = group;
    }
    
    this.model = groupuser;
    
    this.model.fetch({
      success : function(){
        self.render();
      }
    });
    return this;
  },
  
  
  render : function(){
    
    var tpl_c = _.template( $(this.template).html() );
    
    var self = this;
    
    var modal = $( tpl_c({
      groupuser : this.model
    }) ).modal('show');
    
    $(modal).on('click' ,'#delete_object' , function(){
      self.model.destroy({
        success  :function(){
          $(modal).modal('hide');
        }
      });
    }).on('hidden.bs.modal' , function(){
      $(modal).remove();
      if( typeof self.group !== 'undefined' ){
        self.group.trigger('change');
      }
    });
    
    return this;
  }
  
  
});