/**
 * Вид отвечающий за действия над прибором учета
 * 
 * @type Backbone.View
 */
var ACTION_VIEW = Backbone.View.extend({



  el : "#action_meter",



  model : meter,



  events : {


    /**
     * Опрос прибора учета
     * @return {Boolean}
     */
    "click #force_data" : function(){

      var url = "/tpl/?tpl=meter_force_data";

      var data = {data : [ this.model.get('id') ] };

      var self = this;

      /**
       * Запрашиваем шаблон
       * @param  {String} 
       * @param  {Object} 
       * @return {Function} 
       */
      $.get( url, data , function( template ){

        var modal = $( template ).modal('show')

        $(modal).on('shown.bs.modal' , function(){
          var tpl = _.template( $('#force_data_success_tpl').html() );
          $('#force_data_modal').find('.modal-body').empty().append( tpl() );

          window.force_data.timer_run();

          /**
           * Следим за поступающей информацией
           */
          $.ajax('/meter/' + self.model.get('id') + '/force_data.js', {
              xhrFields: {
                onprogress: function(e){
                  var thisres, res = e.currentTarget.response;
                  $("#CurData").find('tbody').empty();
                  eval( res );
                }
            },
            success : function(data){
              window.force_data.error_answer();
            }
          });

        }).on('hidden.bs.modal' , function(){
          $(modal).remove();
        });
      });
      return false;
    }
  },



    'click #meter_on_off' : function( e ){


      var self = this


      $('#meter_on_off').addClass( DIS_DIV )


      var url = window.location.pathname.replace(
                  /\/meter\/([0-9]*)\/(.*)/g,
                  function(_,id){
                    return "/meter/"+id+"/"
                  }
                ) + "action/"

      var d = {
          onoff : Number( !$(e.target).hasClass('btn-danger') )
        }

        var e = e

      $.get( url , d ,
        function( data ){

          var is_danger = true

          $('#meter_on_off').removeClass( DIS_DIV )

          var span = $('<span/>');

          if( typeof data['Execute error'] != 'undefined' ){
            $( span ).text('Ошибка выполнения')
            $(e.target).effect('bounce' , 500)
          }else if( typeof data['TIMEOUT'] != 'undefined' ){
            $( span ).text('Слишком долгий ответ. Операция прервана.')
            $(e.target).effect('bounce' , 500)
          }else if( typeof data['ERROR'] != 'undefined' ){

            var text = '';
            if( data['ERROR'] == 'empty_output' ){
              text = "Пустой ответ. Завершено с ошибкой."
            }

            $( span ).text( text )
            $(e.target).effect('bounce' , 500)
          }else if( typeof data['ACTION'] != 'undefined' ){
            if( !data['ACTION'] ){
              $( span ).text('Причина отклонения запроса не ясна.')
              $(e.target).effect('bounce' , 500)
            }else{

              $( span ).text('Удачно')
              $(e.target).effect('bounce' , 500)

              is_danger = false

              var e_darta = { data : [ self.model.get('id') ] }

              $.get(
                "/tpl/?tpl=meter_action",
                e_darta,
                function(data){
                  $.when( $(self.$el).find('.panel-body')
                  .replaceWith( $(data).find('.panel-body') ) ).then(function(){
                    $(span).attr('class' , 'pull-right small').addClass( is_danger ? 'text-danger' : 'text-success'  )
                    $('#meter_on_off').after( $(span)  )
                  })
                }
              )
            }
          }
        } , "JSON" )

      return false;
  }


});


$(document).ready(function(){
  new ACTION_VIEW();
})