if(typeof graph_data == 'undefined')
  var graph_data = "График потребления энергии за ";

if(typeof no_graph_data == 'undefined')
  var no_graph_data = "Нет данных для построения графика";

if(typeof graph_in == 'undefined')
  var graph_in = "За";

if(typeof graph_hour == 'undefined')
  var graph_hour = "час";

/**
 * МИнимальное из массива
 * @return {Number}
 */
Array.prototype.min = function() {
  return Math.min.apply(null, this);
};


/**
 * Это сам график
 * @param  {METER} meter
 * @return {NULL}
 */
var GRAPH = Backbone.View.extend({

  el : "#container_meter_graph",

  collection : new METERDATAHOURS(),

  model : null,

  chart : null,

  initialize : function( meter ){

    this.model = meter;

    this.chart = Highcharts.stockChart( 'container_meter_graph' , {
      colors: ['#7cb57c', '#a8b4bd', '#2677b5'],
      chart: {
        type: 'areaspline'
      },
      title: {
        text: ''
      },
      subtitle: {
        text: ''
      },
      rangeSelector : {
        enabled : false
      },
      navigator : {
        enabled : false
      },
      tooltip: {
        pointFormat: '{point.y:,.0f}'
      },
      scrollbar : {
        enabled : false
      },
      plotOptions: {

        areaspline: {
          stacking: 'normal',
          lineColor: '#666666',
          lineWidth: 1,
          pointStart: 2010,
          pointInterval: 0.3,
          marker: {
            enabled: true,
            symbol: 'circle',
            radius: 3,
            states: {
              hover: {
                enabled: true
              }
            }
          }
        }
      },
      series: [{
          name: '',
          data: []
      }]
    });

    var self = this;


    var rg = new RegExp( /(\d{4})(\d{2})(\d{2})-(\d{4})(\d{2})(\d{2})\/(.*)/ );

    var res = rg.exec( window.location.pathname );

    var data = [
      "meter:" + self.model.get('id')
    ];

    if(res){

      data.push("start_year:"  + res[1] );
      data.push("start_month:" + res[2] );
      data.push("start_day:"   + res[3] );
      data.push("stop_year:"   + res[4] );
      data.push("stop_month:"  + res[5] );
      data.push("stop_day:"    + res[6] );

      if( res[7] ){
        data.push("range:days")
      }else{
        data.push("range:hours")
      }

    }

    this.collection.reset();

    this.collection.fetch({
      url : "/api/meter/graphs/",
      data : {
        filter : data.join(";")
      },
      success : function(){
        self.render();
        $('#block_parameters').find('a').first().trigger('click');
      }
    })

    this.render();
  },



  render : function( id_parameter ){

    if( this.chart ){

      if( this.collection.length ){
        var where = this.collection.where({ parameter : id_parameter });
        if( where ){
          this.chart.series[0].remove(true);

          var data = where.reduce(function( res , item ){
            res.push([ (new Date( Number(item.get('year')), Number(item.get('month'))-1, item.get('day') , Number( item.get('hour'))+5 , 0 , 0 )).getTime() , item.get('valueconv') ])
            return res;
          },[]);

          if( data.length ){
            this.chart.title.textSetter( $('#parameter_'+id_parameter).text() );
          }else{
            this.chart.title.textSetter( no_graph_data );
          }

          this.chart.addSeries({
              name: $('#parameter_'+id_parameter).text(),
              data: data
          },false);

          this.chart.yAxis[0].update({
            min: where.reduce(function(res , item){
              res.push(item.get('valueconv'))
              return res;
            } , []).min()
          }); 
        }
      }else{
        this.chart.title.textSetter( no_graph_data );
      }

      this.chart.redraw();
    }
    
  }
});





var PARAMETERS_VIEW = Backbone.View.extend({

  el : "#block_parameters" , 


  initialize : function(){
    chart.render(Number( $(this.$el).find('a').first().attr('id').replace('parameter_','') ));
  },

  events : {
    'click a' : function( e ){
      $(this.$el).find('a').each(function( i ,el ){
        if( $(el).index() != $(e.target).index() ){
          $(el).removeClass('active');
        }
      });
      $(e.target).addClass('active');


      chart.render(Number( $(e.target).attr('id').replace('parameter_','') ));
    }
  }

})

var PARAMETER = Backbone.Model.extend({
  defaults : {
    id : 0,
    title : "",
    ident  : ""
  }
})

var ACTIVE_PARAMETERS = Backbone.Collection.extend({
  model : PARAMETER,
  url : function(){
    return "/api/meter/" + meter.get('id') + "/graphs_parameters/active"
  }
})

var ALL_PARAMETERS = Backbone.Collection.extend({
  model : PARAMETER,
  url : function(){
    return "/api/meter/" + meter.get('id') + "/graphs_parameters/all"
  }
})

var active_parameters = new ACTIVE_PARAMETERS
var all_parameters = new ALL_PARAMETERS


var CHANGE_PARAMETER_VIEW = Backbone.View.extend({

  template : "#change_graph_meter",

  initialize : function(){
    this.render()
  },

  render : function(){
    var tpl_c = _.template( $(this.template).html() )
    this.$el = $( tpl_c({
    }) ).modal('show')
    $(this.$el).on('hidden.bs.modal' , function(){
      $(this).remove()
      window.location.reload()
    }).on('shown.bs.modal' , function(){
      new CHANGE_PARAMETER_BODY_VIEW()
    })
  },

  events : {
    "click #save" : function(){
      var self = this
      var ids = []
      _.each( active_parameters.toArray() , function( parameter ){
        ids.push( parameter.get("id") )
      })
      $.post("/api/meter/" + meter.get('id') + "/graphs_parameters/save"  ,
        { data : ids } , function(){
          $(self.$el).modal('hide')
        })
    }
  }

})

var CHANGE_PARAMETER_BODY_VIEW = Backbone.View.extend({

  template : "#change_graph_meter_body_tpl",

  el : "#change_graph_meter_body",

  initialize : function(){
    this.listenTo(active_parameters , "all" , this.render)
    this.render()
  },

  render : function(){
    var tpl_c = _.template( $(this.template).html() )
    $(this.$el).empty().append( tpl_c() )
  },

  events : {
    "click .list-group-item" : function( e ){
      var cid = $(e.target).closest('a').attr('id')
      var is_active = $(e.target).closest('a').hasClass('active')


      if( is_active ){
        var mod = all_parameters.get(cid)
        var fmod = active_parameters.findWhere({ id : mod.get('id')})
        active_parameters.remove( fmod )
      }else{
        active_parameters.add( all_parameters.get(cid) )
      }

      return false
    }
  }

})

active_parameters.fetch()
all_parameters.fetch()





var chart = null;

$(document).ready(function(){
  chart = new GRAPH( typeof meter !== 'undefined' ? meter : new METER_MODEL() );
  new PARAMETERS_VIEW();

  $("#action_setting_graphs").on("click" , function(){
    new CHANGE_PARAMETER_VIEW()
    return false
  })

})