/* global Backbone, PLACES */

/**
 * Постраничная навигация дочерних элементов мест
 * 
 * @type Backbone.View
 */
var PLACE_CHILDREN_LIST_PAGINATION = Backbone.View.extend({
  
  el : ".children_pagination",
  
  
  /**
   * 
   * @param {PLACES} places
   * @returns {this}
   */
  initialize : function( places ){
  
    if(  typeof PLACES === 'undefined' ){
      return false;
    }
    
    if( !( places instanceof PLACES ) ){
      return false;
    }
    
    this.collection = places;
    
    this.render();
  
    return this;
  },
  
  
  /**
   * 
   * @returns {this}
   */
  render : function(){
    
    var self = this;
    
    $.get( "/tpl/" , {
      data  : [0],
      tpl   : "place_children_pagination",
      page  : getParameterByName('page') || 1,
      count : getParameterByName('count') || 10
    } , function( data ){
      $( self.$el ).replaceWith( $( data ) );
    });
    
    return this;
  }
  
});