/* global Backbone, PLACE, PLACES */

/**
 * Вид списка дочерних элементов
 * 
 * @type Backbone.View
 */
var PLACE_CHILDREN_LIST = Backbone.View.extend({
  
  el : "#place_children_table",
  
  
  /**
   * 
   * @param {PLACES} places
   * @returns {Backbone.View}
   */
  initialize : function( places ){
    
    if( typeof PLACES === 'undefined' ){
      console.log( "Не подключена коллекция PLACES" );
      return this;
    }
    
    if( !( places instanceof PLACES ) ){
      console.log( "Не верный аргумент" );
      return this;
    }
    
    if( !$( this.$el ).length ){
      console.log("Нет контейнера для рендера");
      return this;
    }
    
    var self = this;
    
    this.collection = places;
    
    places.fetch({ silent : true , success : function(){
                                      self.render();
                                    }
    });
    
    return this;
  },
  
  
  render : function(){

    var self = this;
    
    var _id = window.location.pathname.replace( /\/place\/([0-9]*)\/(.*)/g , function( _ , b ){
      return b;
    });
    
    $.get( '/tpl/' , {
      data : {
        id  : _id ? _id : 0
      },
      tpl : 'place_children_table',
      page : getParameterByName('page') || 1,
      count : getParameterByName('count') || 10
    },function( data ){
      $( self.$el ).find('table').replaceWith( $( data ).find( 'table' ) );
    });
  
    
  }
  
  
  
});