/* global Backbone, _, MODAL_SUCCESS, PLACES, PLACE */

/**
 * Модальное окно удаления места
 * 
 * @type Backbone.View
 */
var PLACE_MODAL_DELETE = Backbone.View.extend({
  
  template : '#modal_delete_tpl',
  
  /**
   * 
   * @param {PLACE} model
   * @param {PLACES} places
   * @returns {Backbone.View}
   */
  initialize : function( model , places ){
    
    if( !( model instanceof PLACE ) ){
      return false;
    }
    
    if( !( places instanceof PLACES ) ){
      return false;
    }
    
    
    
    this.model = model;
    
    this.collection = places;
    
    var tpl_c = _.template( $( this.template ).html() );
    var modal_tpl = tpl_c({
                      place         : this.model
                    });
    
    this.$el = $( modal_tpl );
    
    $(this.$el).on('hidden.bs.modal', function (e) {
      $('#modal_delete').remove();
      return true;
    });
    
    this.render();
    
    return this;
  },
  
  
  
  
  preloader : function(){
    $( this.$el ).find( '.main_buttons' ).slideUp( 300 );
    $( this.$el ).find( '.preloader' ).slideDown( 300 );
  },
  
  
  
  events : {
    
    'click #delete_object' : function(){
      
      var self = this;
      
      this.preloader();
      
      this.model.destroy({
        success : function( cache_model , result_model ){
          $( self.$el ).modal('hide');
          if( typeof MODAL_SUCCESS !== "undefined" ){
            new MODAL_SUCCESS("Удалено.");
          }else{
            console.log("Не подключен модуль MODAL_SUCCESS");
          }
          self.collection.trigger('remove');
        },error : function(){
          $( self.$el ).modal('hide');
          if( typeof MODAL_ERROR !== "undefined" ){
            new MODAL_ERROR("Удаление было прервано. Попрпобуйте позже.");
          }else{
            console.log("Не подключен модуль MODAL_ERROR");
          }
        }
      });
      
    }
    
  },
  
  
  
  /**
   * 
   * @returns {Backbone.View}
   */
  render : function(){
    $( this.$el ).modal('show');
    return this;
  }
  
});