/* global _ */

/**
 * Модальное окно для редактирования приборов учета на этом месте
 *
 * @type Backbone.View
 */
var PLACE_MODAL_METERS = Backbone.View.extend({



  template : "#meter_modal_tpl",


  /**
   *
   * @param {PLACE} place
   * @returns {PLACE_MODAL_METERS}
   */
  initialize : function( place ){
    this.render();
    return this;
  },
  
  
  
  
  


  render : function(){
    
    var tpl_c = _.template( $( this.template ).html() );
    
    $( tpl_c() ).modal('show').find('.modal-body').jstree({
      "core" : {
        "check_callback" : function () {
          return true;
        },
        'themes': {
            'name': 'proton',
            'responsive': true
        },
        'data' : {
          'url' : function (node) {
            if( node.id === '#' ){
              return '/api/converter/?jstree&all';
            }else{
              return '/api/converter/?jstree&converter=' + node.id.replace("c_","");
            }
          }
        }
      },
      "checkbox": {
          "three_state": false
      },
      "plugins" : [
        "json","types","checkbox"
      ]

    }).bind('create_node' , function( e, core){
      
    })
    
    return this;
  }
  
  
  

});
