/* global Backbone, _, rule */


var paterns = new PATERNS();


var compareJSON = function(obj1, obj2) {
  var ret = {};
  for(var i in obj2) {
    if(!obj1.hasOwnProperty(i) || obj2[i] !== obj1[i]) {
      ret[i] = obj2[i];
    }
  }
  return ret;
};


var CHECKED_RULE = Backbone.View.extend({
  
  el : "#res_table",
  
  template : "#table_changed_tpl",
  
  collection : new ACTIONS(),
  
  
  actions : new ACTIONS(),
  
  
  origin_patern : new ACTIONS(),
  
  
  initialize : function(){
    this.listenTo( this.collection , 'all' , this.render );
    
    var self = this;
    
    this.actions.fetch({
      success : function(){
        self.collection.fetch({
          data : {
            rule : rule.get('id')
          },
          success : function(c){
            self.origin_patern = self.collection.clone();
            self.render();
          }
        });
      }
    });
  },
  
  
  render : function(){
    
    var self = this;
    
    var tpl_c = _.template( $(this.template).html() );
    
    $(this.$el).empty().append(tpl_c({
      actions : this.actions,
      paterns : this.collection,
      origin : this.origin_patern,
      is_btn : this.ar_drop().length || this.collection.toArray().reduce(function( res, o ){
                                          if( !self.origin_patern.findWhere({ id : o.id }) ){
                                            res++;
                                          }
                                          return res;
                                        },0)
    }));
    
  },
  
  
  
  ar_drop : function(){
    
    var added   = _.difference( this.collection.toJSON() , this.origin_patern.toJSON() );
    
    return this.origin_patern.toArray().reduce(function( res , item ){
        
        var isset = false;
        
        
        added.map(function( ad ){
          if( Number( ad.id ) === Number( item.get('id') ) ){
            isset = true;
          }
        });
        
        if( isset === false ){
          res.push( item );
        }
        
        return res;
      },[]);
  },
  
  
  events : {
    
    
    
    "click .clicable" : function( e ){
      
      var cid = $(e.target).closest('.btn-group').attr('id');
      
      var is_yes = $(e.target).hasClass('yes');
      
      if( cid ){
        var action = this.actions.get( cid );
        this.collection[ is_yes ? 'add' : 'remove' ]( action );
      }
      
    },
    
    
    
    "click #save_rule" : function(){
      
      var drop = this.drop();
      
      
      rule.save({
        data : {
          add : _.difference( this.collection.toJSON() , this.origin_patern.toJSON() ).reduce(function( res , item ){
            res.push( item.id );
            return res;
          },[]),
          drop : drop.reduce(function( res , item ){
            res.push( item.id );
            return res;
          },[])
        },
        success : function(){
          
        }
      });
      
      return false;
    }
    
  }
  
});

$(document).ready(function(){
  new CHECKED_RULE();
});