<?php

/**
 * Включение или выключение приборов учета
 */

header('Content-Type: application/json; charset=utf-8');

if( !function_exists( 'parse_string' ) ){
  function parse_string( $content_grabbed ){
    
    if( empty( $content_grabbed ) ){
      return array(
          'ERROR' => 'empty_output'
      );
    }
    
    $ArLines = explode( "\n", $content_grabbed );
    $Printed = false;
    foreach( $ArLines as $iLine ){
      $RegExp = '/^ACTION\:(OFF|ON)\t([0-9]*)\t([a-z|\_]*)$/i';
      $RegExpInfo = '/^INFO([\W]*)([0-9]*)([\W]*)TIME_OUT$/i';
      if( preg_match( $RegExp , $iLine )){
        preg_match( $RegExp , $iLine , $m );
        list( $source , $res , $resInt , $resString ) = $m;

        $Printed = true;
        if( $resString == "OK" ){
          return array(
              'ACTION'  => true,
              'RES'     => $res
          );
        }else{
          return array(
              'ACTION' => false
          );
        }

      }elseif( preg_match( $RegExpInfo , $iLine ) ){
        $Printed = true;
        return array(
            'TIMEOUT' => true
        );
      }
    }

    if( !$Printed ){
      return array(
          'ERROR' => 'invalid_output'
      );
    }
  }
}

/**
 * Если это эмуляция запроса то прекращаем
 */
if( defined( "__PHPUNIT_PHAR__" ) && defined("EMULATE") && EMULATE === true ){
  return false;
}


$Ip       = $oMeter->Converter->Ip;
$Port     = $oMeter->Converter->Port;
$MDLL     = $oMeter->Converter->Type->DllId;
$CLogin   = $oMeter->Converter->Login;
$CPass    = $oMeter->Converter->Password;
$CDLL     = $oMeter->Type->DllId;
$MSerial  = $oMeter->NumSerial;
$MPass    = $oMeter->Password;
$MNum485  = $oMeter->Num485;
$Console  = '-console ';
$Console  = '';

$ONOFF = $_REQUEST['onoff'] ? 'ON' : 'OFF';

$Path_toLsaup = Site()->GetPathToLsaup();

$maincmd = "cd {$Path_toLsaup} && {$Path_toLsaup}lsaup {$Console} -host '{$Ip}' -port '{$Port}' -cdev '{$MDLL}' -clogin '{$CLogin}' -cpass '{$CPass}' -mdev '{$CDLL}' -serial '{$MSerial}' -mnum '{$MNum485}' -mpass '{$MPass}' ACTION:{$ONOFF}";

$MODE = isset( $_GET['mode'] ) ? $_GET['mode'] : 'run';

if( $MODE == 'show' ) {
  echo "$maincmd -console";
  exit;
}

$cmd = "/usr/bin/killall lsaup";
$ret = shell_exec( $cmd );
$cmd = "/bin/ps ax | grep lsaup | grep -v grep | wc -l";
$ret = shell_exec( $cmd );
$ret = 0;


$Filter = array(
  'Filter' => array(
    'Taskstatus' => 2
  )
);
foreach( task::Filter( $Filter )->Elements as $iTask ){
  $iTask->Taskstatus = taskstatus::Id(1);
}

ob_start(); 
if( $ret > 0 ){
  $unix_error = 0;
}else{
  passthru( $maincmd, $unix_error );
}
$content_grabbed = ob_get_contents();


ob_end_clean();
ob_start();


/**
 * Перебор строк ответа
 * 
 * @param string $content_grabbed
 * @return array
 */


if( !$unix_error and !$Console){
  $output = parse_string( $content_grabbed );
  if( isset( $output['ACTION'] ) && $output['ACTION'] ){
    $oMeter->SetOnOff( $output['RES'] == "ON" ? 1 : 0 );
  }
  echo json_encode( $output );
}else{
  echo "{\"Execute error\": {$unix_error} , \"Content\": \"{$content_grabbed}\" }";
}

$Output = ob_get_clean();

echo $Output;