<?php
include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );

$file_local = Self()->Lang . "_lang.conf";
if (file_exists($_SERVER['DOCUMENT_ROOT'] . "/configs" . "/" . $file_local)) {
  $GLOBALS['smarty']->ConfigLoad($file_local, 'Reports');
}

$smarty->register_function("start_hour", "start_hour");
$smarty->register_function("stop_hour", "stop_hour");


/**
 * Начальная дата отчета
 * 
 * @param int $H
 * @return string
 */
function start_hour( $H ){
  
  if( !$H ){
    $hour = 1;
  }
  
  $hour = $H/2;
  
  $mins = $hour - intval($hour) && $hour ? 30 : 0;

  if( !$H ){
    $mins = 0;
  }
  
  return str_pad(intval($hour),  2, "0", STR_PAD_LEFT) . str_pad($mins,  2, "0", STR_PAD_LEFT);
}


/**
 * Конечная дата отчета
 * 
 * @param int $H
 * @return string
 */
function stop_hour( $H ) {
  if( !$H ){
    $hour = 1;
  }
  
  $hour = $H/2;
  
  if( $hour - intval($hour) ){
    if( ceil($hour) == 24 ){
      $hour = 0;
    }
    return str_pad(ceil($hour),  2, "0", STR_PAD_LEFT)."00";
  }else{
    return start_hour( $H+1 );
  }
}


if( !function_exists( 'valid_form' ) ){
  
  /**
   * Проверка валидации входящих данных
   * 
   * @return bool
   */
  function valid_form(){
    return !empty( $_REQUEST['start_date'] ) &&
    !empty( $_REQUEST['object'] ) && 
    !empty( $_REQUEST['ids'] ) &&
    valid_date_report( $_REQUEST['start_date'] );
  }
}

if( !function_exists( 'valid_date_report' ) ){
  
  /**
   * Проверка валидности входных дат
   * 
   * @param string $date
   * @return boolean
   */
  function valid_date_report( $date ){
    return preg_match( '/^([0-9]*)-([0-9]*)-([0-9]*)$/' , $date);
  }
}

if( valid_form() ){
  $GLOBALS['NotAddToFile'] = true;
  header("Cache-Control: ");
  
  
  header( "Content-Type:text/xml ;" );
  header( 'Content-Disposition: attachment;filename="80020.xml"' );
  
  // Получение всех активных параметров у этих приборов учета
  $parameters = array();
  
  $Groups = array();
  
  
  $ids = explode( "," , $_REQUEST['ids'] );
  $Filter = array(
      'Filter' => array(
          'Id IN' => $ids
      )
  );
  
  $start_date =  $_REQUEST['start_date'];
  
  switch( $_REQUEST['object'] ){
    case 'meter' :
      foreach( meter::Filter( $Filter )->Elements as $iMeter ){
        foreach( $iMeter->GetActiveParametersData()->Elements as $iParameter ){
          if( !isset( $parameters[ $iParameter->Id ] ) ){
            $parameters[ $iParameter->Id ] = $iParameter;
          }
        }
      }
      $Meters = meter::Filter( $Filter );
      smarty()->assign( 'Meters' , $Meters );
      break;
    case 'place' :
      
      $meter = meter::Id(0);
      $SQL = Utils::Strip("
        select meter.* 
        from place
        left join place as p
          on p.lft <= place.lft and p.rgt >= place.rgt
        left join meterplace
          on meterplace.place_id = p.id
        left join meter
          on meter.id = meterplace.meter_id
        where place.id in (" . implode( "," , array_map( "ceil" , $ids ) ) . ")
        and meter.id is not null
        group by meter.id  
      ");
      $Meters = TListGroup::Prepare($SQL, $meter);
      smarty()->assign( 'Meters' , $Meters );
      
      foreach( place::Filter( $Filter )->Elements as $iPlace ){
        foreach( $iPlace->GetActiveParametersData()->Elements as $iParameter ){
          if( !isset( $parameters[ $iParameter->Id ] ) ){
            $parameters[ $iParameter->Id ] = $iParameter;
          }
        }
      }
      break;
      
  }
  
  $T = TListGroup::Init();
  $T->SetFElements($parameters);
  $parameters = $T;
  
  smarty()->assign( 'Parameters' , $parameters );
  smarty()->assign( 'start_date' , new DateTime($_REQUEST['start_date']) );
  smarty()->assign( 'Groups' , $Groups );
  smarty()->display('reports/80020.xml.tpl');
  
  die();
}