<?php
include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );

$file_local = Self()->Lang . "_lang.conf";
if (file_exists($_SERVER['DOCUMENT_ROOT'] . "/configs" . "/" . $file_local)) {
  $GLOBALS['smarty']->ConfigLoad($file_local, 'Reports');
}

if( !function_exists( 'valid_form' ) ){
  
  /**
   * Проверка валидации входящих данных
   * 
   * @return bool
   */
  function valid_form(){
    return !empty( $_REQUEST['start_date'] ) &&
    !empty( $_REQUEST['stop_date'] ) &&
    !empty( $_REQUEST['type_data'] ) &&
    !empty( $_REQUEST['extension'] ) && 
    !empty( $_REQUEST['object'] ) && 
    isset( $_REQUEST['ids'] ) &&
    valid_date_report( $_REQUEST['start_date'] ) && 
    valid_date_report( $_REQUEST['stop_date'] );
  }
}

if( !function_exists( 'valid_date_report' ) ){
  
  /**
   * Проверка валидности входных дат
   * 
   * @param string $date
   * @return boolean
   */
  function valid_date_report( $date ){
    return preg_match( '/^([0-9]*)-([0-9]*)-([0-9]*)$/' , $date);
  }
}

if( valid_form() ){
  $GLOBALS['NotAddToFile'] = true;
  header("Cache-Control: ");


   switch( $_REQUEST['extension'] ){
   case 'csv' :
     header( "Content-Type: text/csv;" );
     break;
   case 'xls' :
     header( "Content-Type: application/vnd.ms-excel" );
     break;
   case 'html' :
     header( "Content-Type:text/html ;" );
     break;
   case 'xml' :
     header( "Content-Type:text/xml ;" );
     break;
 }
 $d = new DateTime();
 header( 'Content-Disposition: attachment;filename="'. Utils::str2url(Self()->Interprise->Title) . "_" . $d->format("Y-m-d") .".". $_REQUEST['extension'] .'"' );
  // Получение всех активных параметров у этих приборов учета
  $parameters = array();
  
  $Groups = array();
  
  
  $ids = explode( "," , $_REQUEST['ids'] );
  $Filter = array(
      'Filter' => array(
          'Id IN' => $ids
      )
  );
  
  if( $ids == array(0) ){
    $Filter = array();
  }


$_GET['count'] = 0;
$_GET['page'] = 1;
  
  $start_date =  $_REQUEST['start_date'];
  $stop_date =  $_REQUEST['stop_date'];
 
  
  switch( $_REQUEST['object'] ){
    case 'meter' :
      foreach( meter::Filter( $Filter )->Elements as $iMeter ){
        foreach( $iMeter->GetActiveParametersData()->Elements as $iParameter ){
          if( !isset( $parameters[ $iParameter->Id ] ) ){
            $parameters[ $iParameter->Id ] = $iParameter;
            $Groups[ $iParameter->Id ] = null;
          }
        }
      }
      $Meters = meter::Filter( $Filter );
      smarty()->assign( 'Meters' , $Meters );
      break;
    case 'place' :
      foreach( place::Filter( $Filter )->Elements as $iPlace ){
        foreach( $iPlace->GetActiveParametersData()->Elements as $iParameter ){
          if( !isset( $parameters[ $iParameter->Id ] ) ){
            $parameters[ $iParameter->Id ] = $iParameter;
            $Groups[ $iParameter->Id ] = null;
          }
        }
      }
      $Places = place::Filter( $Filter );
      smarty()->assign( 'Places' , $Places);
      break;
      
  }
  
  $T = TListGroup::Init();
  $T->SetFElements($parameters);
  $parameters = $T;
  
  smarty()->assign( 'Parameters' , $parameters );
  smarty()->assign( 'start_date' , $_REQUEST['start_date'] );
  smarty()->assign( 'stop_date' , $_REQUEST['stop_date'] );
  smarty()->assign( 'Groups' , $Groups );
  switch( $_REQUEST['extension'] ){
    case 'csv' :
      smarty()->display('reports/'.$_REQUEST['object'].'.multi.csv.tpl');
      break;
    case 'xls' :
      include( smarty()->template_dir[0].'reports/'.$_REQUEST['object'].'.multi.xls.php' );
      break;
    case 'html' :
      switch( $_REQUEST['object'] ){
        case 'meter' :
          $before = array(
              smarty()->get_config_vars('title'),
              smarty()->get_config_vars('serial_number'),
              smarty()->get_config_vars('rate_coef')
          );
          break;
        case 'place' :
          $before = array(
              smarty()->get_config_vars('title'),
              smarty()->get_config_vars('location'),
          );
          break;
      }
      smarty()->assign( 'ParameterHead' , (new HeadTableParameters( $before , array() , $parameters , true) )->RowCol() );
      smarty()->display('reports/'.$_REQUEST['object'].'.multi.html.tpl');
      break;
    case 'xml' :
      smarty()->display('reports/'.$_REQUEST['object'].'.multi.xml.tpl');
      break;
  }
  
  die();
}

//smarty()->display('reports/index.tpl');