<?php

//error_reporting( E_ALL );
//echo str_repeat( " ", 2*1024 ); flush();
ini_set( 'display_errors', '0' );

include($_SERVER['DOCUMENT_ROOT']."/include/inc.php");

date_default_timezone_set( Self()->Timezone->Ident );

set_time_limit(10);

ob_start();

$lastPrintInterval = 0;

function DoLog( $text, $mode='DEBUG', $id='' ) {
//	echo "{$mode}:{$text}<br>\n";
	echo sprintf ("DoLog( '%s', %s, %s );\n", $mode, json_encode($text), json_encode($id) );
	
//	get_ident
	ob_flush();
	flush();
}

function WaitForAnswer( &$buf, &$ms_need, $funcTestPacketReady = false ) {
	global $use_tcp;
	if( $use_tcp ) {
		return WaitForAnswer_TCP( $buf, $ms_need, $funcTestPacketReady );
	} else {
		return WaitForAnswer_UDP( $buf, $ms_need, $funcTestPacketReady );
	}
}

function WaitForAnswer_TCP( &$buf, &$ms_need, $funcTestPacketReady = false ) {
	global $_socket, $lastPrintInterval;

	$lastAccess = microtime(true);
	$lastPrint = microtime(true);
	$sockets_all = array( $_socket );
	$packet = '';
	$Length = 0;
	$ReadTimeOut = min(10, $ms_need/1000); // min 2sec
	$WaitStep = 0;
	DoLog( "0", 'PROGRESS' );
	while( microtime(true)-$lastAccess < $ReadTimeOut )
	{
		$r = $sockets_all;
		$w = NULL; //$sockets_all;
		$f = $sockets_all;
		if( socket_select( $r,$w, $f , 
				$time_out_sec = 0, 
				$time_out_usec = 50 * 1000
			) !== FALSE )
		{
			if( microtime(true)-$lastPrint > $lastPrintInterval  ) 
			{
				$lastPrint = microtime(true);
				DoLog( sprintf ( "%d",	100*(microtime(true)-$lastAccess)/$ReadTimeOut ), 'PROGRESS' ); 
			}
			
			$TmpData = '';
			if ( $InLength = socket_recv( $_socket, $TmpData, 1024, 0 ) ) {
				$packet .= $TmpData;
				$Length += $InLength;
				NetBytesDebug( $TmpData, $InLength );
				if( call_user_func( $funcTestPacketReady, $packet, $Length ) )
				{
					$ms_need = microtime(true)-$lastAccess;
					break;
				}
			}
			if( microtime(true)-$lastAccess > $ReadTimeOut )
			{
				DoLog( "Read TimeOut" ,'ERROR' );
				break;
			}
		}
	}
	DoLog( "100", 'PROGRESS' );
//	DoLog( 'Done wait '. ++$WaitStep ); 
	$buf = $packet;
	return $Length;
}

function WaitForAnswer_UDP( &$buf, &$ms_need, $funcTestPacketReady = false ) {
	global $_ip, $_port, $_socket, $use_tcp;
	DoLog( "WaitForAnswer $ms_need ms", 'DEBUG' ); 
	
	$ms = $ms_need;
	while( $ms-- ) {
		if( $len = socket_recvfrom( $socket, $buf, 1500, MSG_DONTWAIT, $from, $port) ) {
			$ms_need = $ms_need - $ms;
			return $len;
		}
		if( -1 == $len ) {
			return 0;
		} else {
			usleep(1000);
		}
	}
	return 0;
}

function Connect( $ip, $port )
{
	global $_ip, $_port, $_socket, $use_tcp;
	global $lastPrintInterval;
	$_ip = $ip;
	$_port = $port;
	if( $use_tcp ) {
		if( !$_socket ) {
			$_socket = socket_create( AF_INET, SOCK_STREAM, SOL_TCP );
		}
		if ( $_socket === false ) {
			DoLog( "ERROR_SOCKET_CREATE", 'ERROR' );
			return false;
		}

		socket_set_nonblock( $_socket );

		DoLog( "Содение c {$ip}:{$port} .." );
		$rez = @socket_connect( $_socket, $ip, $port );

		$sockets_all = array( $_socket );
		$ConnectTimeOut = 5;
		$lastAccess = microtime(true);
		$lastPrint = microtime(true);
		DoLog( "0", 'PROGRESS' );
		while( microtime(true)-$lastAccess < $ConnectTimeOut )
		{
			$r = array( $_socket ); 
			$w = array( $_socket );
			$f = array( $_socket );
			$ret = socket_select( $r, $w, $f , $ConnectTimeOut, $time_out_usec = 100 * 1000 );
			if( $ret == 2 )
			{
				if( microtime(true)-$lastPrint > $lastPrintInterval  ) 
				{
					$lastPrint = microtime(true);
					DoLog( sprintf ( "%d",	100*(microtime(true)-$lastAccess)/$ConnectTimeOut ), 'PROGRESS' ); 
				}
				usleep( 50 * 1000 );
			}
			else if( $ret !== FALSE )
			{
//				DoLog( 'ret= '.var_export($ret,1) );
//			var_dump( $r);
//			var_dump( $w );
//			var_dump(  $f );
//				var_dump( $ret, $ret>0 );
				if (in_array($_socket, $f)) {
					DoLog( "Connected Fail" );
					DoLog( "100", 'PROGRESS' );
					return false;
				}
				if (in_array($_socket, $r)) {
					DoLog( "Connected Unknown" );
					DoLog( "100", 'PROGRESS' );
					return false;
				}
				if (in_array($_socket, $w)) {
					DoLog( "100", 'PROGRESS' );
					DoLog( "Connected " );
					//socket_write( $w[0], "1",1 );
//					var_dump( $_socket,  $r, $w, $f  );
//					DoLog( "Ok" );
					return true;
				}
			} else {
				DoLog( "FALSE ??" );
			}
		}
		DoLog( "100", 'PROGRESS' );
		DoLog( "Таймаут соединения {$ConnectTimeOut} сек", 'ERROR' );
		return false;

/*
		$sockets_all = array( $_socket );
		$r = $sockets_all; $w = $sockets_all; $f = $sockets_all;
		switch( socket_select( $r, $w, $f, $time_out_sec = 3  ) )
		{
			case 2:
				DoLog( "Отказ ERROR_CONNECT_REFUSED", 'ERROR' );
				CloseSocket();
			return false;
			break;
			case 1:
				$_IsConnected = true;
				DoLog( "Ok" );
			break;
			case 0:
				DoLog( "Таймаут соединения {$time_out_sec} сек", 'ERROR' );
			return false;
			break;
		}*/
		return true;
	} else {
		$socket = socket_create( AF_INET, SOCK_DGRAM, SOL_UDP );
		if( !socket_bind( $socket, '0.0.0.0', $port ) ) {
		}
	}

}

function CloseSocket()
{
	global $_ip, $_port, $_socket, $use_tcp;
	if( $use_tcp ) {
	
	} else {
		
	}
	socket_close($_socket);
}

register_shutdown_function('CloseSocket');

function SendData( $packet ) {
	global $_ip, $_port, $_socket, $use_tcp;
	if( !$use_tcp ) {
		socket_send( $_socket, $packet, strlen($packet), 0, $_ip, $_port );
	} else {
		$Rez = socket_write( $_socket, $packet, strlen($packet) );
	}
}

function testAswer( $packet, $Length ) {
	if( $Length < 1 ) return false;
	$arPacket = array();
	for( $i=0; $i<$Length; $i++ )
	{
		$arPacket[] = ord($packet[$i]) ;
	}

//DoLog ( "line:". __LINE__ );
	$crc = archives_comp_crc( $arPacket, $Length-1 );
	
//	DoLog ( sprintf ("testAswer %d bytes crc=%02X %02X", $Length, $crc, $arPacket[$Length-1] ), 'DEBUG' );
	return (bool)( $crc === $arPacket[$Length-1] );
}


function archives_comp_crc( &$data, $size )
{
	$crc	= 0x00;

	for( $loop_count = 0; $loop_count < $size; $loop_count++ ) {
	$dat	= $data[$loop_count];

	for( $i = 0; $i < 8; $i++) {
		$feedback_bit	= ($crc ^ $dat) & 0x01;

		if($feedback_bit == 0x01)
		$crc	= $crc ^ 0x18;	// 0x18 = POLYNOM (X^8+X^5+X^4+X^0)
//		$crc	= $crc ^ 0x31;	// 0x18 = POLYNOM (X^8+X^5+X^4+X^0)

		$crc	= ($crc >> 1) & 0x7F;

		if($feedback_bit == 0x01)
		$crc	|= 0x80;

		$dat	= $dat >> 1;
		}
	}

	return $crc;
}

function NetBytesDebug( $buf, $len, $ltrim=0 ,$output = false )
{
	$class =  $output ? 'output' : 'input';
	$PacketsHTML = "<table id='" . $class ."'><tr>";
	$arPacket = array();
	$Packets = ''; // ($output) ? ' >> ' : ' <<-- ';
	for( $i=$ltrim; $i<$len; $i++ ) {
		$PacketsHTML .= sprintf("<td class='n{$i}'>%02X</td>", ord($buf[$i]) )." ";
		$Packets     .= sprintf("%02X ", ord($buf[$i]) )." ";
		if($i<$len-1){
			$arPacket[] = ord($buf[$i]) ;
		}
	}
	$PacketsHTML .= "</tr></table>";
//	DoLog( $PacketsHTML, 'DEBUG.PACKETS' );
	DoLog( $Packets, 'PACKETS', ($output ) ? 'OUT' : 'IN'  );
}

function NetBytesDebugCMD( $buf, $len, $ltrim=0 ,$output = false )
{
	if( $len > 9 )
	{
		$cmd = ord($buf[8])<<8 | ord($buf[9]);

		$bin = decbin($cmd);
		$bin = substr("0000000000000000",0,16 - strlen($bin)) . $bin;

	 	DoLog( sprintf( "CMD: 0x%04X BIN:%u%u %u %u%u%u%u%u", $cmd,
	 		$bin[0], $bin[1], $bin[2], $bin[3], $bin[4], $bin[5], $bin[6], $bin[7]
	 	) );

	 $Header = sprintf( "<table><tr><td>CMD: 0x%04X BIN:</td>", $cmd );
		for( $i=0; $i<strlen($bin); $i++)
		{
			$Header .= sprintf("<td class='b{$i}'>%s</td>", $bin[$i] )." ";
		}
		$Header .= "</tr><tr><td></td><td colspan='2'>flag</td><td>R</td><td colspan='5'>BLOCK</td><td colspan='8'>CMD</td>";
		$Header .= "</tr></table>";
//		DoLog( $Header, 'DEBUG.HEADER' );
	}
}


$socket = false;
$default = array(
	'ip'     => '172.16.16.45',
	'mac'    => '38:32:35:31:00:24:00:46',
	'port'   => 1200,
	'cmd'    => 1111,
	'ta'     => '',
	'tp'     => '',
);


$use_tcp = false;
$use_tcp = true;

	$ip = isset( $_REQUEST['ip'] ) && preg_match( '/^[0-9\.]+$/', $_REQUEST['ip'] )
		? trim($_REQUEST['ip'])
		: $default['ip'];

	$port = isset( $_REQUEST['port'] ) && preg_match( '/^[0-9]{1,5}$/', $_REQUEST['port'] )
		? trim($_REQUEST['port'])
		: $default['port'];

	$mac = isset( $_REQUEST['mac'] ) && preg_match( '/^[0-9a-fA-F:]+$/', $_REQUEST['mac'] )
		? trim($_REQUEST['mac'])
		: $default['mac'];

	$cmd = isset( $_REQUEST['cmd_1'],$_REQUEST['cmd_2'] )
		? $_REQUEST['cmd_1']*256 + $_REQUEST['cmd_2']*1
		: $default['cmd'];

//	$ta = isset( $_REQUEST['ta'] ) && preg_match( '/^[0-9a-fA-F\s\r\n]+$/im', $_REQUEST['ta'] )
//		? trim($_REQUEST['ta'])
//		: $default['ta'];
//	$tp = isset( $_REQUEST['tp'] ) && preg_match( '/^[0-9a-fA-F\s\r\n]+$/im', $_REQUEST['tp'] )
//		? trim($_REQUEST['tp'])
//		: $default['tp'];
	$ta = isset( $_REQUEST['ta'] ) ? trim( $_REQUEST['ta'] ):"";
	$tp = isset( $_REQUEST['tp'] ) ? trim( $_REQUEST['tp'] ):"";
	$tpu = isset( $_REQUEST['tpu'] ) ? 1:0;

//~ header('Content-Type: application/json;');

//~ ini_set('display_errors','0');
    //~ error_reporting( E_ALL );
    
    //~ var_dump($_REQUEST);

$act = isset( $_REQUEST['act'],
	$_REQUEST['ip'],
	$_REQUEST['port'],
	$_REQUEST['mac'],
	$_REQUEST['cmd_1']
) 
	? trim($_REQUEST['act']) 
	: '';

if( $act !== 'do' ) {
	DoLog( "Не верный MAC", 'ERROR' );
	exit();
}

$packet_bytes = sscanf( $_REQUEST['mac'], '%02X:%02X:%02X:%02X:%02X:%02X:%02X:%02X' );
if( !$packet_bytes )
{
	DoLog( "Не верный MAC", 'ERROR' );
	exit();
}

$cmd_bytes = false;
if( $cmd>= 0 and $cmd<= 0x3FFF )
{
	$cmd_bytes = array( 
		($cmd & 0x3FFF) >> 8,
		$cmd & 0xFF,
	);
}

if( !$cmd_bytes )
{
	DoLog( "Не верная команда", 'ERROR' );
	exit();
}

$arPacket = array(
	$packet_bytes[0],
	$packet_bytes[1],
	$packet_bytes[2],
	$packet_bytes[3],
	$packet_bytes[4],
	$packet_bytes[5],
	$packet_bytes[6],
	$packet_bytes[7],
	$cmd_bytes[0],
	$cmd_bytes[1],
);

function AddPacketData( &$arPacket, $ta )
{
	$Hex= '';
	$byte = 0;
	for ( $i = 0; $i < strlen( $ta ); $i += 1 ) {
		$X = 	$ta[$i];
		if( ($X >= '0' && $X <= '9') || ( $X >= 'a' && $X <= 'f' ) || ( $X >= 'A' && $X <= 'F' ) ) {
			$Hex .= $X;
		} else if ( $X == ':' || $X == 0x00 ) {
			if( $Hex != '' ) {
				$byte = hexdec($Hex);
				$Hex = '';
				$arPacket[] = $byte;
			}
		} else {
			printf ("Erorr in symbol %c (%02X)", $X, $X);
		}
	}
	if( $Hex != '' ) {
		$byte = hexdec($Hex);
		$Hex = '';
		$arPacket[] = $byte;
	}
}

if( $tpu )
{
	AddPacketData( $arPacket, $tp );
}
AddPacketData( $arPacket, $ta );

if( $use_crc = 1 )
{
	$arPacket[] = archives_comp_crc( $arPacket, count($arPacket) );
}

		$packet = implode( '', array_map( 'chr', $arPacket ) );


//DoLog ("line:". __LINE__ );

if( !Connect( $ip, $port ) )
{
//	DoLog( "<span class='error'>faild bind</span>", 'ERROR' );
	exit();
}

//DoLog ( "Запрос: &gt; ");
NetBytesDebug( $packet, strlen($packet) , 0 , true );
SendData( $packet );
$ms = 2000;
$len = WaitForAnswer( $buf, $ms, 'testAswer' );

if( $len<1 )
{
	DoLog( sprintf("Нет ответа %d ms", $ms ), 'ERROR' );
  DoLog( sprintf( "Write Fatal"), 'ERROR_WRITE' );
	exit();
}


//NetBytesDebug( $buf, $len , 0 , false );

DoLog( sprintf( "Ответ %d байт. Время %0.2f сек", $len, $ms ), 'INFO' );

$answer_cmd = ord($buf[8])<<8 | ord($buf[9]);

if( $answer_cmd != ($cmd | 0x4000) ){
	DoLog( sprintf( "Каманда ответа %04Xh должно быть %04Xh", $answer_cmd, $cmd | 0x4000 ), 'ERROR' );
}
if( $cmd== 0x1414 /*and $len==15*/ )
{
	// h,m,s, month, day, year
	$day = mktime( 
		ord($buf[13]), 
		ord($buf[14]), 
		isset( $buf[15] ) ? ord($buf[15]) : 0, 
		ord($buf[11]) + 1,
		ord($buf[12]), 
		ord($buf[10]) + 1900
	);
	DoLog( date( 'Y.m.d H:i:s', time() ), 'VALUE_NOW' );
	DoLog( date( 'Y.m.d H:i:s', $day ), 'VALUE_DATETIME' );
        
}
else if( $cmd== 0x1501 /*and $len==15*/ )
// Текущие значения
{
	for( $N=10, $i=1; $N<$len-1; $N += 4, $i++ )
	{
		$int = ord( $buf[$N+0] )<<24 | ord( $buf[$N+1] )<<16 | ord( $buf[$N+2] )<<8 | ord( $buf[$N+3] );
		// echo "<div id='v_{$i}' class='value'>INT {$i}: {$int}</div>";
		DoLog( sprintf("%d", $int ), 'VALUE', "DI{$i}" );
	}

}
else if( $cmd== 0x140A /*and $len==15*/ )
// Кофф
{
	for( $N=10, $i=1; $N<$len-1; $N += 4, $i++ ) {
		$int = ord( $buf[$N+0] )<<24 | ord( $buf[$N+1] )<<16 | ord( $buf[$N+2] )<<8 | ord( $buf[$N+3] );
		DoLog( sprintf("%d", $int ), 'VALUE_COEFS', "DI{$i}" );
	}
  DoLog( sprintf( "Write OK"), 'SUCCESS_WRITE' );
}
else if( $cmd== 0x1403 /*and $len==15*/ )
// версия прошивки
{
	DoLog( sprintf("%d.%d", ord( $buf[10] ), ord( $buf[11] ) ), 'VERSION' );
}
else if( $cmd== 0x1C0A /*and $len==15*/ )
// Кофф
{
	$arName = array(
		1 => 'Делитель',
		2 => 'Множитель',
		3 => 'Смещение'
	);
	for( $N=10, $i=1; $N<$len-1; $N += 4, $i++ )
	{
		$int = ord( $buf[$N+0] )<<24 | ord( $buf[$N+1] )<<16 | ord( $buf[$N+2] )<<8 | ord( $buf[$N+3] );
		$Name = $arName[$i];
		switch( $i )
		{
			case 1 :
//				DoLog( sprintf( "<span class='mnog'>{$int}</span>" ),'INFO');
				DoLog( sprintf( "%d", $int ), 'VALUE_MDOG',"DI".$arPacket[10] );
			break;
			case 2 :
//				DoLog( sprintf( "<span class='delimiter'>{$int}</span>" ),'INFO');
				DoLog( sprintf( "%d", $int ), 'VALUE_DELIM',"DI".$arPacket[10] );
			break;
			case 3 :
//				DoLog( sprintf( "<span class='delta'>{$int}</span>" ),'INFO');
				DoLog( sprintf( "%d", $int ), 'VALUE_DELTA',"DI".$arPacket[10] );
			break;
		}
	}
}
else if( $cmd== 0x150A /*and $len==15*/ )
// Срезы
{
	for( $N=10, $i=1; $N<$len-1; $N += 4, $i++ )
	{
		$int = ord( $buf[$N+0] )<<24 | ord( $buf[$N+1] )<<16 | ord( $buf[$N+2] )<<8 | ord( $buf[$N+3] );
//		DoLog( sprintf( "<div id='s_{$i}' class='value_s'>INT {$i}: {$int}</div>"), 'INFO',"s_{$i}" );
		DoLog( sprintf( "%d", $int ), 'VALUE_SREZ',"DI{$i}" );
//			DoLog( '12345', 'VALUE', "s_1" );
//			DoLog( '12345', 'VALUE', "s_1" );
	}
}
else if( $cmd== 0x1402 /*and $len==15*/ )
{
	$_txt = '';
	for( $N=10, $i=1; $N<$len-1; $N += 1, $i++ ) {
		$_txt .= $buf[$N+0];
	}
		DoLog( sprintf( "{$_txt}") ,'VALUE_IDENT' );
}
else if( $cmd== 0x1C0B /*and $len==15*/ )
{
	DoLog( sprintf( "Write OK"), 'SUCCESS_WRITE' );

}

// запись даты
else if( $cmd== 0x1415 /*and $len==15*/ )
{
	DoLog( sprintf( "Write OK"), 'SUCCESS_WRITE' );

}
else
{
		DoLog( sprintf( "Не верный формат ответа / команда %04X не поддерживается", $cmd ) ,'ERROR' );
}

DoLog( "DONE", 'DEBUG' );

/*echo "<br />
flag - значение
00 Запрос
01 ответ
10 событие
11 ошибка<br />";
*/

?>

