<?php

if( $_SERVER['DOCUMENT_ROOT'] ){
  include( $_SERVER['DOCUMENT_ROOT'] . "task/log.php" );
}

if( !function_exists('log_task') ){
  /***
  * Дебаг лога задач : лог всего
  */
  define( 'TASK_DEBUG_ALL'    , 1); // все

 /**
  * Дебаг лога задач : лог только ошибок
  */
  define( 'TASK_DEBUG_ERROR'  , 2);

  /**
  * Дебаг лога задач : лог выключен
  */
  define( 'TASK_DEBUG_OFF'    , 3);




  // Ключи для ошибок
  define('TASK_INFO'          , 1); // информация
  define('TASK_ERROR'         , 2); // ошибка


  // что хотим логировать. Присвоение
  define('TASK_DEBUG_SET', TASK_DEBUG_ALL);

  function log_task(){
    return true;
  }
}

log_task("\n\nСтарт задач", TASK_INFO);














# SETTINGS
# @max_time_locked -	максимальное время которое необходимо держать задачу в закрутом состоянии
function run_start( $class, $RunTs=false , $Time = 30 , $settings = array() )
{ 
  if( class_exists( $class ) ){
    
    log_task("Запуск задачи : {$class}" , TASK_INFO);
    
    foreach( $settings as $key => $val ){
      log_task("Параметры настроек {$key} : {$val}" , TASK_INFO);
    }
    
  
    $GLOBALS['CronRun'] = true;
    $GLOBALS['FullRules'] = true;
    $GLOBALS['Self'] = user::Id( isset( $settings['Uid'] ) ? $settings['Uid'] : 0 ) ;
    
    $file_class = $_SERVER['DOCUMENT_ROOT']."/task/job/class.".str_replace('job_','',$class).".php";
    
    log_task( "Подключение файла " . $file_class , TASK_INFO );
    log_task( "file_exists  " . (int) file_exists( $file_class ) , TASK_INFO );
    
    include_once $file_class;
    
    log_task( "Файл подключен", TASK_INFO );
    
    $classes = new $class;
    
    log_task( "Класс проинициализирован", TASK_INFO );
    
    log_task("Инициализация пользователя : " . Self()->Login , TASK_INFO);
    
    $Filter = array(
      'Filter' => array(
        'Filename' => str_replace('job_','',$class)
      )
    );
    
    $Task = crontask::Filter($Filter)->First;
    
    
    log_task("Найдена задача в БД : " . $Task->Id , TASK_INFO);
    
    $Log = crontasklog::Id(0);
    
    if( method_exists( $classes , 'Start' ) ){
    
      echo "~~~".$settings['Lid']."~~~\n";
      
      
    
      if( !isset( $settings['Lid']) or !$settings['Lid'] ){
      
        log_task("В задачу не был передан ид лога куда записывать. Создаем новый.", TASK_INFO);
        
        $Filter = array(
          'Filter' => array(
            'Crontask' => $Task->Id
          ),
          'Order'=> array(
            'Id' => 'DESC'
          ),
          'Limit' => 1
        );
        $Log = crontasklog::Filter($Filter)->First;
      }else{
        log_task("В задачу был передан ид лога куда записывать" . $Task->Id , TASK_INFO);
        $Log = crontasklog::Id( (int) $settings['Lid'] );
      }
      
      log_task("ИД лога : ".$Log->Id, TASK_INFO);
      
      log_task("Передали этот идентификатор в ". get_class($classes) , TASK_INFO);
      $classes->LID = $Log;
      
      
      log_task("Start issue", TASK_INFO);
      ob_get_clean();
      ob_start();
      $classes->Start( $RunTs ? $RunTs : null );
      
      ini_set('max_execution_time' , (str_replace( "M" , "" , $Task->Memorylimit ) + 10 ) . "M" );
      
      
      log_task("Задача отработала. Пишем результаты ее выполнения.", TASK_INFO);
      $classes->WriteResultIter();
      ob_get_clean();
      
    }else{
      user_error( 'Class job exists. Method Start not exists' );
    }
  }else{
    user_error( 'Class job is already defined' );
  }
}







if( !isset($_SERVER['DOCUMENT_ROOT']) or ""==$_SERVER['DOCUMENT_ROOT'] ) {
  $_SERVER['DOCUMENT_ROOT'] = __DIR__.'/../';
}
if( isset($_SERVER["argv"]) ) foreach( $_SERVER["argv"] as $Param )
{
  $GLOBALS['CronRun'] = true;
  $GLOBALS['FullRules'] = true;
  
  if( preg_match( '/mode\:(test)/', $Param, $Match ) ) {
    if( 'test' == $Match[1] ) {
      define( '__PHPUNIT_PHAR__', 0 );
      include( "{$_SERVER['DOCUMENT_ROOT']}/test/dbconfig.inc.php" );
    }
  }
  if( preg_match( '/debug\:(true)/', $Param, $Match ) ) {
    if( 'true' == $Match[1] ) {
      include_once($_SERVER['DOCUMENT_ROOT'].'/include/inc.php');
      $GLOBALS['CONFIG']['DEBUG'] = 1;
      echo "Run: debug mode\n";
    }
  }
  if( preg_match( '/(ts)\:(\d+)/', $Param, $Match ) ) {
    if( 'ts' == $Match[1] ) {
      $RunTs = $Match[2];
    }
  }
  else
  {
    $RunTs = "";
  }
}

if( !defined( '__PHPUNIT_PHAR__' ) )
{
  include_once($_SERVER['DOCUMENT_ROOT'].'/include/inc.php');
}

if( empty($_SERVER["argv"]) )
{
  if(task::GetCanTaskView() )
  {
    $Date = new DateTime();
    echo $Date->format( "Y-m-d H:i:s" );
    echo "<table>
    <thead>
      <tr>
        <th>Название задание</th>
        <th>Часы</th>
        <th>Минуты</th>
        <th>Слудующий запуск</th>
        <th>Лог</th>
        <th>Включено</th>
        <th>Заблокировано</th>
        <th>Заданий ожидает</th>
      </tr>
    </thead>
    <tbody>";

  $Now = new DateTime();
  $Hour   = $Now->format('H');
  $Minute = $Now->format('i');

  foreach(crontask::All()->Elements as $iCronTask )
  {
    $DateNextRun = new DateTime();
    $DateNextRun->setTimestamp($iCronTask->NextRun);
    echo "
    <tr id=\"{$iCronTask->Id}\">
      <td>{$iCronTask->Title}</td>
      <td>{$iCronTask->Hour}</td>
      <td>{$iCronTask->Minute}</td>";
      if($iCronTask->IsLocked)
      {
        echo "<td style=\"color:red;\">".date ( "Y-m-d H:i:s", $iCronTask->IsLocked+1800 )."</td>\n";
      }
      else
      {
        echo "<td>{$DateNextRun->format('Y-m-d H:i:s')}</td>\n";
      }
    echo ( $iCronTask->IsLog )
      ? "      <td>Да</td>\n"
      : "      <td>Нет</td>\n";
    echo ( $iCronTask->IsEnabled )
      ? "      <td>Да</td>\n"
      : "      <td>Нет</td>\n";
    echo ( $iCronTask->IsLocked )
      ? "      <td>Да</td>\n"
      : "      <td>Нет</td>\n";
    echo "<td>";
		if( is_callable( array( $iCronTask->JOB, 'GetTasksCount' ) ) )	{
      echo $iCronTask->JOB->GetTasksCount();
    }else{
      echo "---";
    }
    echo "</td>";
    echo "    </tr>\n";
  }
    echo "  </tbody>\n</table>";
    
  }
  else
  {
    Site()->Error404;
  }
  
}
else
{
  # Запуск одной задачи
  if( isset( $_SERVER["argv"] ) && count($_SERVER["argv"])>1  ){
    
    $key = null; # ключ файла
    $uid = null; # пользователь от чьего имени запускается задача
		$lid = null;	# идентификатор записи лога
    
    # сводный массив для передачи аргументов
    $set_from_run = array( 
			'Key' 	=> null,
			'Uid' 	=> null,
			'Lid'		=> null
    );
    
    
    log_task("\n\nЗапуск одной задачи" , TASK_INFO);
    
    $oUser = user::Id(0);
    
    foreach( $_SERVER["argv"] as $arg ){
      if( preg_match( '/key:([a-f0-9]{32})/', $arg , $Match ) ){
        $key = $Match[1];
      }elseif(preg_match( '/worker\:([0-9]+)/', $arg , $Match )){
        $oUser = user::Id($Match[1]);
      }elseif(preg_match( '/lid\:([0-9]+)/', $arg , $Match )){
        $lid = $Match[1];
      }
    }
    
    log_task("Аргументы запуска key:{$key} oUser:{$oUser->Id} Lid:{$lid}" , TASK_INFO);
    
    if( $key === null ) {
      log_task("Ключ задачи на найден. EXIT 2" , TASK_ERROR);
      exit(2);
    }
    $arLook = array(
      'Filter' => array(
        'Key'  => $key,
        'IsEnabled' => 1
      )
    );
    $Tasks = crontask::Filter( $arLook );
    
    if( !$Tasks->Count ) {
      log_task("Задачи на найдены. EXIT 3" , TASK_ERROR);
      exit(3);
    }
    
    $Task = $Tasks->First;
    if( $Task->Is ) {
    
      $set_from_run['Key'] = $key;
    
      if( $lid === null ){
        
        log_task("Создаем новый лог " , TASK_INFO);
        
        $Date = new DateTime();
        $oLid = crontasklog::AddByArray(
          array(
            'CrontaskId'        =>  $Task->Id,
            'DateStart'         =>  $Date->format('Y-m-d H:i:s'),
            'DateEnd'           =>  $Date->format('Y-m-d H:i:s'),
            'Statuscrontasklog' =>  statuscrontasklog::GetStatusByIdent('RUN')->Id,
          )
        );
        
        log_task("ИД лога : {$oLid->Id}" , TASK_INFO);
        
        $set_from_run['Lid'] = $oLid->Id;
      }else{
        $set_from_run['Lid'] = $lid;
      }
    
      if( !$oUser->Is ){
        $Filter = array(
          'Filter' => array(
            'Login' => $Task->Filename . "@job"
          )
        );
        $res = user::Filter( $Filter );
        if( !$res->Count ){
          # AddUser
          $oUser = user::AddByArray(
            array(
              'Login' => $Task->Filename . "@job"
            )
          );
        }else{
          $oUser = $res->First;
        }
      }
      $set_from_run['Uid'] = $oUser->Id;
      
      # необходимо подключить файл
      $Filename = "{$_SERVER['DOCUMENT_ROOT']}/task/job/class.{$Task->Filename}.php";
      if(!file_exists($Filename)){
        log_task("Файл задачи не найден. EXIT 3" , TASK_ERROR);
        exit();
      }
      include_once( $Filename );
      $class = 'job_'.$Task->Filename;
      $GLOBALS['CronJob'] = $Task->Filename;
      
      foreach( $set_from_run as $key => $value ){
        log_task("Аргументы запуска задачи {$key}:{$value}" , TASK_INFO);
      }
      
      run_start( $class, $RunTs , 30 ,  $set_from_run );
    }
    exit(2);
  }else{
    $d = new DateTime();
    $max_time_locked = $d->format("dHis") - 1800;
    $arLook = array(
      'Filter' => array(
        'IsEnabled' => 1,
        // 'IsLocked' => 0,
      )
    );
    $Task = crontask::Filter( $arLook )->Elements;
    foreach($Task as $iCrontask){
      if( $iCrontask and $iCrontask->Is ){
        if( $iCrontask->NextRun > time() || $iCrontask->IsLocked > $max_time_locked ) continue;
        $iCrontask->Run();
        
      }
    }
    exit(2);
  }
}
