<?php

class job_add_task_hour extends Jobs
{
	private	$MyTz;
	private	$TaskHourDatetimeFormatHour = "Y-m-d H:00:00";
	public	$MaxExecTime = 25;
	public	$MaxMemoryUsage = 90000000;
	public	$LogLevel = 1;
	private	$VarDatetimeUTC = 'AddTaskHour.Work.DatetimeUTC';
	private	$VarMeterId = 'AddTaskHour.Work.MeterId';


  function getTitle()
  {
    return "Ежечасный опрос приборов";
  }

  function getDescription()
  {
    return "Добавление задач ежечасного опроса";
  }

	function GetTasksCount()
	{
		$DateTime = new DateTime( "now", new DateTimeZone( 'UTC' ) );
		$TaskHourDatetimeUTC = $DateTime->format( $this->TaskHourDatetimeFormatHour );
		$TaskHourDatetimeUTCStore =  Site()->Config( $this->VarDatetimeUTC );
		$MeterStartId =  Site()->Config( $this->VarMeterId, 0 );
		if( $TaskHourDatetimeUTC !== $TaskHourDatetimeUTCStore )
		{
			$MeterStartId = 0;
		}
		$arLook = array(
			'Filter' => array(
				'Id >' => $MeterStartId,
				'IsExcluded' => 0,
			),
		);
		$Meters = meter::Filter( $arLook );
		return $Meters->Count;
	}





  
  /**
   * Получение приборов по стартовому значению
   * 
   * @param int $start_id
   * @return \TListGroup
   */
  function GetMetersByStartId( $start_id = 0 ){
    $Filter = array(
      'Filter' => array(
        'Id >' => $start_id,
        'IsExcluded' => 0,
      ),
      'Order' => array(
        'Id' => 'ASC'
      )
    );
    return meter::Filter( $Filter );
  }







	function Start( DateTime $DateTime = NULL  )
	{

		global $Manual;
		if( isset($Manual) and $Manual )
				echo "Ручной запуск задачи.\n";
		else
				$Manual = false;

		$this->MyTz = date_default_timezone_get();
		date_default_timezone_set( 'UTC' );

		if( $DateTime )
		{
			echo "Используется предустановленное время:\n{$DateTime->format( $this->TaskHourDatetimeFormatHour )} ({$DateTime->getTimezone()->getName() })\n";
			$DateTime->setTimezone( new DateTimeZone( 'UTC' ) );
			echo "{$DateTime->format( $this->TaskHourDatetimeFormatHour )} ({$DateTime->getTimezone()->getName() })\n";
		}
		else
		{
			$DateTime = new DateTime();
		}
		$TaskHourDatetimeUTC = $DateTime->format( $this->TaskHourDatetimeFormatHour );
    
    $MeterStartId = 0;
		$TaskHourDatetimeUTCStore =  Site()->Config( $this->VarDatetimeUTC, $TaskHourDatetimeUTC );
		$MeterStartId =  Site()->Config( $this->VarMeterId, $MeterStartId );

		echo "MeterStartId сохранено: {$MeterStartId}\n";
		echo "Время UTC текущее: {$TaskHourDatetimeUTC}\n";
		echo "Время UTC сохранено: {$TaskHourDatetimeUTCStore}\n";
    
    // Если начался новый час то провеяем достигли ли конца списка
    // Если достигли то скидываем счетчик приборов на 0
    // Если не достигли то продолжаем
		if( $TaskHourDatetimeUTC !== $TaskHourDatetimeUTCStore ){
      Site()->SetConfig( $this->VarDatetimeUTC, $TaskHourDatetimeUTC );

			$MetersNotEnded = $this->GetMetersByStartId( $MeterStartId );
			if( !$MetersNotEnded->Count ){
				echo "Старт нового цикла назначения заданий, с предыдущего не отработано приборов: {$MetersNotEnded->Count}\n";
				Site()->SetConfig( $this->VarMeterId, 0 );
				Site()->SetConfig( $this->VarDatetimeUTC, $TaskHourDatetimeUTC );
        $MeterStartId = 0;
			}else{
				echo "Продолжение с прибора [meter:{$MeterStartId}][Step]\n";
			}


		}
		else
		{
			if( $Manual ) {
				$MeterStartId = 0;
			}
			echo "Продолжение с прибора [meter:{$MeterStartId}]\n";
		}

    $Meters = $this->GetMetersByStartId( $MeterStartId );
    
    if( !$Meters->Count && $TaskHourDatetimeUTC !== $TaskHourDatetimeUTCStore ){
      $Meters = $this->GetMetersByStartId( 0 );
      echo "Начинаем с 0, так как нет больше приборов.";
    }
    
		$this->IdCount = $Meters->Count;

		echo "Количетство приборов для опроса {$Meters->Count}\n";
		if( $this->LogLevel>0 )
		{
			echo "SQL: {$Meters->Sql}\n";
		}
		$GroupByCount = 100;
		echo "Работа порациями по {$GroupByCount} шт.\n";
		foreach( $Meters->GroupBy($GroupByCount)->Elements as $iGroup )
		{
			foreach( $iGroup->Elements as $i => $iMeter )
			{
				$this->AddIteration();
				
				# Если потеряна связь прибора с конвертором
				if( !$iMeter->Converter->Is ){ 
					echo "Потеряна связь прибора с конвертором\n";
          
          Site()->SetConfig( $this->VarMeterId , $iMeter->Id );
          echo "Установили {$this->VarMeterId} в {$iMeter->Id}\n";
          echo "Проверка - ".Site()->Config($this->VarMeterId);
					continue;
				}
				
				$MeterStartId = $iMeter->Id;
				if( $this->LogLevel>0 )
				{
					echo "[meter:{$iMeter->Id}]";
					if( $this->LogLevel>1 ) echo "\n";
				}
				Site()->SetConfig( $this->VarMeterId, $MeterStartId );

				echo $this->AddTasksForMeter( $iMeter, clone $DateTime );

				if( $this->LogLevel>0 ) echo "\n";


				flush();
		  if( $Manual and 0 ) {
		  		echo "\n\nЗавершено т.к. ручной запуск\n line: ".__LINE__;
		  		return true;
		  }
				if( $this->GetMemoryRun() ) {
					return true;
				}
				if( $this->GetTimeRun() ) {
					return true;
				}


			flush();
		  if( $Manual ) {
		  		echo "\n\nЗавершено т.к. ручной запуск\n line: ".__LINE__;
		  		return true;
		  }
			}


		  if( $this->GetMemoryRun() ) {
	  		return true;
		  }
	  	if( $this->GetTimeRun() ) {
	  		return true;
	  	}

			$iGroup->ElementsFreeMem;
		}


		return array(
    	"Iteration" => $this->Iteration,
    	"Return"		=> $this->GOOD
    );
	}

	function AddTasksForMeter( meter $oMeter, DateTime $DateTime )
	{
		global $Manual;
			if( $this->LogLevel>1 )
			{
				echo "Параметров учета {$oMeter->Parameters->Count}\n";
			}
      if( $oMeter->Timezone->Is )
      {
        $MeterTzIdent = $oMeter->Datetime->getTimezone()->getName();
      }
      else
      {
        $MeterTzIdent = $this->MyTz;
      }

      $DateTime->setTimezone( new DateTimeZone( $MeterTzIdent ) );
		if( $this->LogLevel>1 )
		{
			echo "Время, с часовой зоной прибора: {$DateTime->format( $this->TaskHourDatetimeFormatHour )} ({$DateTime->getTimezone()->getName() })\n";
		}
	   $DateTime->sub( new DateInterval( "PT1H" ) );
     
		foreach( $oMeter->Parameters->Elements as $iMTYParameter )
		{
      
      
      if( $oMeter->IsCalc ){
        $iParameter = $iMTYParameter->Parameter;
      }else{
        $iParameter = $iMTYParameter;
      }
      
			$this->AddIteration();
			if ( $oMeter->IsCalc && !$iMTYParameter->IsUse ) continue;

				$_DT = clone $DateTime;
        if( $iParameter->IsEventLog ){
          echo "Коректировка запроса на 1 часа для журнала\n";
          $_DT->sub( new DateInterval( "PT1H" ) );
        }
        
        $_DT = clone $DateTime;
				$_DT->setTimezone($oMeter->Datetime->getTimezone());

        $arLook = array(
          'Filter' => array(
            'Meter'     => $oMeter->Id,
            'Parameter' => $iParameter->Id,
            'Year'      => $_DT->format( 'Y' ),
            'Month'     => $_DT->format( 'm' ),
            'Day'       => $_DT->format( 'd' ),
            'Hour'      => $_DT->format( 'H' )+1,
          ),
        );
        
        if( $oMeter->IsCalc ){
          echo "Будем ожидать добавления задачи в taskcalc\n";
        }
        
		  if( $Manual ) {
//	        $iMDH = meterdatahourmemory::Filter( $arLook );
		  }else{
//	        $iMDH = meterdatahourmemory::Filter( $arLook );
        }
//        if( $iMDH->Count==0 )
        {
					// Данных нет надо назначить
          $Tasks = task::Filter( $arLook );
          if($this->LogLevel > 1 )
          {
		      if( $iParameter->IsEventLog )
		      {
		        echo "Журнал событий: {$iParameter->Title}\n";
		      }
		      else
		      {
		        echo "Задание: {$iParameter->Title} ";
		      }
		    }

          if( $Tasks->Count == 0 )
          {

            $tsAdd = task::AddByArray( array(
              'MeterId'      => $oMeter->Id,
              'ParameterId'  => $iParameter->Id,
              'Year'         => $_DT->format( 'Y' ),
              'Month'        => $_DT->format( 'm' ),
              'Day'          => $_DT->format( 'd' ),
              'Hour'         => $_DT->format( 'H' )+1,
              'TaskstatusId' => 1,
              'TsStart'      => 0,
              'TsEnd'        => 0,
              'InterpriseId' => $oMeter->Interprise->Id
            ) );




            if( $this->LogLevel>0 )
            {
	         	echo ( $tsAdd->Id )
	         		? "+"
	         		: '-';
		         if( $this->LogLevel>1 )
		         {
		         	echo "\n";
		        	}
            }
          }
//        }else{
//        	$MDH = $iMDH->First;
//        	echo sprintf( "Данные: {$MDH->Value}({$MDH->Loginfo->Title})\n" );
        }

			flush();
			if( $this->GetMemoryRun() ) {
				return true;
			}
			if( $this->GetTimeRun() ) {
				return true;
			}


		}
		return true;
	}

}
