<?php

// calculates the result of an expression in infix notation
function calculate($exp , $date) {
  $pre_res = mathexp_to_rpn($exp,$date);
  $pre_res['value'] = calculate_rpn( $pre_res['value'] );
  return $pre_res;
}
// calculates the result of an expression in reverse polish notation
function calculate_rpn($rpnexp) {
  $stack = array();
  foreach($rpnexp as $item) {
    if (is_operator($item)) {
      if ($item == '+') {
        $j = array_pop($stack);
        $i = array_pop($stack);
        array_push($stack, $i + $j);
      }
      if ($item == '-') {
        $j = array_pop($stack);
        $i = array_pop($stack);
        array_push($stack, $i - $j);
      }
      if ($item == '*') {
        $j = array_pop($stack);
        $i = array_pop($stack);
        array_push($stack, $i * $j);
      }
      if ($item == '/') {
        $j = array_pop($stack);
        $i = array_pop($stack);
        array_push($stack, $i / $j);
      }
      if ($item == '%') {
        $j = array_pop($stack);
        $i = array_pop($stack);
        array_push($stack, $i % $j);
      }
    } else {
      array_push($stack, $item);
    }
  }
  return $stack[0];
}
// converts infix notation to reverse polish notation
function mathexp_to_rpn($mathexp,$date) {
  $precedence = array(
    '(' => 0,
    '-' => 3,
    '+' => 3,
    '*' => 6,
    '/' => 6,
    '%' => 6
  );
  
  
  /* 
    Разбираем запись вида <CLASS>:<ID>:<PARAMETER> в число  
  */
  
  $GLOBALS['DATE'] = $date;
  
  $arLog = array();
  foreach( loginfo::All()->Elements as $iLog ){
    $arLog[$iLog->Logtext] = $iLog;
  }
  
  $GLOBALS['STATUSES'] = $arLog;
  
  $GLOBALS['STATUS'] = $arLog['OK']->Id;
  
  $mathexp = preg_replace_callback('/([a-z]*)\:([0-9]*)\:([0-9]*)/',function ($matches) {
    
    $class = isset( $matches[1] ) ? $matches[1] : false ;
    if( !$class ) return '';
    
    $id = isset( $matches[2] ) ? $matches[2] : false ;
    if( !$id ) return '';
    
    $pid = isset( $matches[3] ) ? $matches[3] : false ;
    if( !$pid ) return '';
    
    if( $class == 'place' ){
      $ids = array();
      foreach( $class::Id($id)->MetersAll->Elements as $iMeter ){
        $id[$iMeter->Id] = $iMeter->Id;
      }
    }elseif( $class == 'converter' ){
      $ids = array();
      foreach( $class::Id($id)->Meters->Elements as $iMeter ){
        $ids[$iMeter->Id] = $iMeter->Id;
      }
    }
    
    $date = $GLOBALS['DATE'];
    
    $Filter = array( 
      'Filter' => array( 
        'Year'      => $date['Year'],
        'Month'     => $date['Month'],
        'Day'       => $date['Day'],
        'Hour'      => $date['Hour'],
        'Meter'     => isset($ids) ? $ids : $id,
        'Parameter' => $pid
    ));
    
    $FMDH = meterdatahour::Filter($Filter);
    
    if( isset( $ids ) && $FMDH->Count != count( $ids ) ){
      $GLOBALS['STATUS'] = $GLOBALS['STATUSES']['OK_NOTFULL']->Id;
    }
    
    if( $FMDH->Count == 1 ){
      return $FMDH->First->Value;
    }elseif( $FMDH->Count > 1 ){
      $value = 0;
      foreach( $FMDH->GroupBy(100)->Elements as $iMDHG ){
        foreach( $iMDHG->Elements as $iMDH ){
          $value = $value + $iMDH->Value;
          
          flush();
          $iMDH->Des;
        }
        $iMDHG->ElementsFreeMem;
      }
      return $value;
    }
    
    return '';
    
  },$mathexp);
  
  
  
  
  $i = 0;
  $final_stack = array();
  $operator_stack = array();
  while ($i < strlen($mathexp)) {
    $char = $mathexp{$i};
    if (is_number($char)) {
      $num = readnumber($mathexp, $i);
      array_push($final_stack, $num);
      $i += strlen($num); continue;
    }
    if (is_operator($char)) {
      $top = end($operator_stack);
      if ($top && $precedence[$char] <= $precedence[$top]) {
        $oper = array_pop($operator_stack);
        array_push($final_stack, $oper);
      }
      array_push($operator_stack, $char);
      $i++; continue;
    }
    if ($char == '(') {
      array_push($operator_stack, $char);
      $i++; continue;
    }
    if ($char == ')') {
      // transfer operators to final stack
      do {
        $operator = array_pop($operator_stack);
        if ($operator == '(') break;
        array_push($final_stack, $operator);
      } while ($operator);
      $i++; continue;
    }
    $i++;
  }
  while ($oper = array_pop($operator_stack)) {
    array_push($final_stack, $oper);
  }
  return array(
    'value' => $final_stack,
    'status' => $GLOBALS['STATUS']
  );
}
function readnumber($string, $i) {
  $number = '';
  while (isset($string[$i]) && is_number($string[$i])) {
    $number .= $string[$i];
    $i++;
  }
  return $number;
}
function is_operator($char) {
  static $operators = array('+', '-', '/', '*', '%');
  return in_array($char, $operators);
}
function is_number($char) {
  return (($char == '.') || ($char >= '0' && $char <= '9'));
}

class job_calcmeter extends Jobs{
  
  function getTitle(){
    return "Суммированные приборы учета";
  }
  
  function getDescription(){
    return "Складываем данные на приборах учета согласно формулам параметров";
  }
  
  
  function Start(){
    
    $Filter = array( 
      'Filter' => array( 
        'Taskstatus' => taskstatus::GetByIdent('Waiting')->Id
    ));
    
    $TaskCalcAll = taskcalc::Filter($Filter);
    
    if( !$TaskCalcAll->Count ){
      echo "Заданий нет\n";
    }
    
    foreach( $TaskCalcAll->GroupBy(100)->Elements as $iTaskG ){
      foreach( $iTaskG->Elements as $iTask ){
        
        $iTask->Taskstatus = taskstatus::GetByIdent('Running');
        $iTask->Save();
        
        $this->AddIteration();
        
        // Получем формулу
        
        $Filter = array( 
          'Filter' => array( 
            'Meter'     => $iTask->Meter->Id,
            'Parameter' => $iTask->Parameter->Id
        ));
        
        $FindFormula = meterformula::Filter($Filter);
        
        if( $FindFormula->Count ){
          $Formula = $FindFormula->First;
          
          $data = array(
            'Year'  => $iTask->Year,
            'Month' => $iTask->Month,
            'Day'   => $iTask->Day,
            'Hour'  => $iTask->Hour,
          );
          
          /*
            array
              status
              value
          */
          $ResCalc = calculate($Formula->Formula , $data);
          
          
          //~ $Filter = array( 
            //~ 'Filter' => array( 
              //~ 'Meter'         => $iTask->Meter->Id,
              //~ 'Parameter'     => $iTask->Parameter->Id,
              //~ 'Year'          => $iTask->Year,
              //~ 'Month'         => $iTask->Month,
              //~ 'Day'           => $iTask->Day,
              //~ 'Hour'          => $iTask->Hour, 
          //~ ));
          //~ if( meterdatahour::Filter($Filter)->Count ){
            //~ echo "Данные уже есть.";
            //~ continue;
          //~ }
          
          // TODO Правильный расчет loginfo
          $Add = meterdatahour::AddByArray(array(
            'MeterId'       => $iTask->Meter->Id,
            'ParameterId'   => $iTask->Parameter->Id,
            'Year'          => $iTask->Year,
            'Month'         => $iTask->Month,
            'Day'           => $iTask->Day,
            'Hour'          => $iTask->Hour,
            'Value'         => $ResCalc['value'],
            'LoginfoId'  => $ResCalc['status']
          ));

          echo "[{$Add->Id}][m:{$Add->Meter->Id}][p:{$Add->Parameter->Id}][{$Add->Year}-{$Add->Month}-{$Add->Day} {$Add->Hour}] Добавлено\n";
          
          flush();
          if( $this->GetMemoryRun() ) {
            return true;
          }
          if( $this->GetTimeRun() ) {
            return true;
          }
        }
        
        $iTask->Delete();
      }
      $iTaskG->ElementsFreeMem;
    }
    
    echo "Завершили работу\n";
    
    return true;
    
  }
}

