<?php
class job_crontasklog_delete_old extends Jobs
{
  function getTitle()
  {
    return "Очистка лога";
  }
  
  function getDescription()
  {
    return "Удаление старого лога по задачам";
  }

  function GetTasksCount() {
    $DateNow = new DateTime();
    $DateNeed = $DateNow->sub( new DateInterval('P1D') );
    $format='Y-m-d H:i:s';
    $date = $DateNeed->format( $format );
    $arLook = array(
      'Filter' => array(
        'TsStart <' => $date
      ),
    );
  	return task::Filter( $arLook )->Count;  	 
	}
	
  function Start()
  {
  	
    $DateNow = new DateTime();
    $DateNeed = $DateNow->sub( new DateInterval('P1D') );
    $format='Y-m-d H:i:s';
    $date = $DateNeed->format( $format );
    $arLook = array(
      'Filter' => array(
        'DateStart <' => $date,
      ),
    );
    
  	$AllCount = crontasklog::Filter( $arLook )->Count;
    $MaxCount = Site()->Config( 'count.delete.crontasklog', 1000 );
    if( $MaxCount < $AllCount ) $arLook['Limit'] = $MaxCount;
  	
  	if(isset($arLook['Limit'])) echo "Limit = {$arLook['Limit']}\n";
  	
    $Logs = crontasklog::Filter( $arLook );
		echo "Удалить {$Logs->Count} старых заданий из {$AllCount}\n";
		echo "SQL = {$Logs->Sql}\n";
    
    foreach( $Logs->GroupBy(100)->Elements as $iLogG ) {
      foreach( $iLogG->Elements as $iLog ) {
    
        echo "Удален лог: {$iLog->Id}\tНачало: {$iLog->DateStart}\tКонец: {$iLog->DateEnd}\tЗадача: {$iLog->Crontask->Title}\n";
        
        $iLog->Delete();
        
        $this->AddIteration();
        
        flush();
		    if( $this->GetMemoryRun() ) {
	    		break 2;
		    }
	    	if( $this->GetTimeRun() ) {
	    		break 2;
	    	}
	  	$iLog->__destruct();
		  }
		  $iLogG->ElementsFreeMem;
    }
    
    return true;
  }
}


