<?php


$GLOBALS['FullRules'] = true;

function SetBitrate( $arParams , $socket ){

  $arPacket = Array( 0xFA, 0xFA, 0x00, 0xFA );

  switch( $arParams['Baudrate'] ){
// Известно только 2400 и 9600 остальное предположение
//  case  1200 : array_push( $arPacket, 0x03 ); break;
    case  2400 : array_push( $arPacket, 0x04 ); break;
    case  4800 : array_push( $arPacket, 0x05 ); break;
    case  9600 : array_push( $arPacket, 0x06 ); break;
//  case 19200 : array_push( $arPacket, 0x07 ); break;
//  case 38400 : array_push( $arPacket, 0x08 ); break;
    default:
      echo "Unknown Baudrate setup";
      return false;
  }
  $Bits = ( $arParams['Bits']-5 );
  if( $Bits<0 or $Bits>4 ){
    return false;
  }
  array_push( $arPacket, $Bits );
  $arParams['Parity'] = strtolower( $arParams['Parity'] );


  switch( $arParams['Parity'] ){
    case  'none' : array_push( $arPacket, 0x00 ); break;
    case   'odd' : array_push( $arPacket, 0x01 ); break;
    case  'even' : array_push( $arPacket, 0x02 ); break;
    case  'mark' : array_push( $arPacket, 0x03 ); break;
    case 'space' : array_push( $arPacket, 0x04 ); break;
    default:
      echo "Unknown Parity setup";
      return false;
  }

  switch( $arParams['StopBits'] ){
    case '1' : array_push( $arPacket, 0x00 ); break;
    case '2' : array_push( $arPacket, 0x01 ); break;
    default:
      echo "Unknown StopBits setup";
      return false;
  }
  
  array_push( $arPacket, 0x00 ); // FlowControl

  array_push( $arPacket, 0x00, 0x00, 0x00, 0x00, 0x00 ); // not2[5];

  $BaudrateL = $arParams['Baudrate'] & 0xFF;
  $BaudrateH = ($arParams['Baudrate'] >> 8 ) & 0xFF;
  array_push( $arPacket, $BaudrateL, $BaudrateH ); // Baudrate

  for( $i=0; $i<52; $i++ ){
    $arPacket[] = 0x00;
  }

  $arPacket[] = 0xFB;
  $arPacket[] = 0xFB;

  $crc = 0x00;
  for( $i=0; $i<count($arPacket); $i++){
    $crc = ( ( $crc + $arPacket[$i]) & 0xFF );
  }
  $arPacket[] = (0xFF - $crc);

  for ($i=0; $i < count($arPacket) ; $i++) { 
    printf("%02X " , $arPacket[$i]);
  }

  $Length = count( $arPacket );
  $Rez = socket_write( 
    $socket,
    implode( '', array_map( 'chr', $arPacket ) ),
    $Length
  );
  if( $Length != $Rez ){
    return false;
  }
  return true;
}




$socket = false;
$default = array(
  'ip'     => '172.16.16.45',
  'mac'    => '38:32:35:31:00:24:00:46',
  'port'   => 1200,
  'cmd'    => 1111,
  'ta'     => '',
  'tp'     => '',
);


$use_tcp = false;
$use_tcp = true;

set_time_limit(60*59);

class job_snr_rscounter_8i extends Jobs{

  private $ip = null;
  private $port = null;

  private $_socket = null;

  protected function Connect( $ip , $port ){

    // if( !$this->_socket ) {
      $this->_socket = socket_create( AF_INET, SOCK_STREAM, SOL_TCP );
    // }
    if ( $this->_socket === false ) {
      DoLog( "ERROR_SOCKET_CREATE", 'ERROR' );
      return false;
    }


    // socket_set_nonblock( $this->_socket );

    DoLog( "Содение c {$this->ip}:{$this->port} .." , "CONNECT" );
    $rez = @socket_connect( $this->_socket, $this->ip, $this->port );

    $sockets_all = array( $this->_socket );
    $ConnectTimeOut = 5;
    $lastAccess = microtime(true);
    $lastPrint = microtime(true);
    DoLog( "0", 'PROGRESS' );
    while( microtime(true)-$lastAccess < $ConnectTimeOut ){
      $r = array( $this->_socket ); 
      $w = array( $this->_socket );
      $f = array( $this->_socket );
      $ret = socket_select( $r, $w, $f , $ConnectTimeOut, $time_out_usec = $ConnectTimeOut * 1000 );
      if( $ret == 2 ){
        usleep( 50 * 1000 );
      }
      else if( $ret !== FALSE ){
        if (in_array($_socket, $f)) {
          DoLog( "Connected Fail" );
          DoLog( "100", 'PROGRESS' );
          return false;
        }
        if (in_array($_socket, $r)) {
          DoLog( "Connected Unknown" );
          DoLog( "100", 'PROGRESS' );
          return false;
        }
        if (in_array($_socket, $w)) {
          DoLog( "100", 'PROGRESS' );
          DoLog( "Connected " );
          return true;
        }
      } else {
        DoLog( "FALSE ??" );
        return true;
      }
    }
    DoLog( "100", 'PROGRESS' );
    DoLog( "Таймаут соединения {$ConnectTimeOut} сек", 'ERROR' );
    return $rez;
  }


  private $Task = null;


  protected function CloseSocket(){
    DoLog( "Удаляем задание", 'TASK' );
    $ar = array(
      'MeterId' => $this->Task->Meter->Id,
      'ParameterId' => $this->Task->Parameter->Id,
      'TarifId' => $this->Task->Tarif->Id,
      'Year' => $this->Task->Year,
      'Month' => $this->Task->Month,
      'Day' => $this->Task->Day,
      'Hour' => $this->Task->Hour,
      'TaskstatusId' => $this->Task->Taskstatus->Id,
      'InterpriseId' => $this->Task->Interprise->Id,
      'UserId' => $this->Task->User->Id,
    );
    // Переносим в конец очереди
    if( $this->Task->Meter->Id && $this->Task->Taskstatus == 1 ){
      DB::Query("DELETE FROM task wHERE id = " . $this->Task->Id);
      $this->Task->Delete();
      $this->Task->Save();
      task::AddByArray($ar);
    }
    DoLog( "добавляем задание", 'TASK' );
    socket_close($this->_socket);
  }


  function getStatus(){
    return array(
      'run' => 'auto'
    );
  }

  function Settins(){
    return array( 'time' => 1 , 'mem' => '10M' );
  }
  

  function getTitle(){
    return "Задача для опроса SNR-RScounter-8I";
  }

  function getDescription(){
    # Основная программа не может опрашивать эти приборы. Пишем на php так как на php программа это может
    return "Костыль для опроса SNR-RScounter-8I";
  }


  function Start(){
    
    # Будем брать 100 заданий
    
    /**
     *
      act:do
      ip:172.31.74.21
      port:50
      mac:F8:F0:82:02:59:E8:00:00
      cmd_1:21
      cmd_2:1
     */
    


    /*
      Ищем сначала все приборы с этим типов
     */
    

    $SQL = Utils::Strip("select task.* 
    from task
    left join meter
      on meter.id = task.meter_id
    left join meter_type
      on meter_type.id = meter.type_id
    where meter_type.dll_id = 'SNR_RS_COUNTER_8I' and task.taskstatus_id = 1 and meter.id = 3793 Limit 1");

    $t = task::Id(0);

    $ListTask = TListGroup::Prepare( $SQL , $t );

    if( !$ListTask->Count ){
      echo "Нет задач";
      return false;
    }


    foreach( $ListTask->GroupBy(10)->Elements as $iTaskGroup ){
      foreach( $iTaskGroup->Elements as $iTask ){

        $this->Task = $iTask;

        $_REQUEST['act'] = "do";
        $_REQUEST['ip'] = $iTask->Meter->Converter->Ip;
        $_REQUEST['port'] = $iTask->Meter->Converter->Port;

        $_REQUEST['mac'] = rtrim(chunk_split($iTask->Meter->NumSerial,2,":"),":");
        $_REQUEST['cmd_1'] = 21;
        $_REQUEST['cmd_2'] = 1;

        $this->ip = isset( $_REQUEST['ip'] ) && preg_match( '/^[0-9\.]+$/', $_REQUEST['ip'] )
          ? trim($_REQUEST['ip'])
          : $default['ip'];

        $this->port = isset( $_REQUEST['port'] ) && preg_match( '/^[0-9]{1,5}$/', $_REQUEST['port'] )
          ? trim($_REQUEST['port'])
          : $default['port'];

        $mac = isset( $_REQUEST['mac'] ) && preg_match( '/^[0-9a-fA-F:]+$/', $_REQUEST['mac'] )
          ? trim($_REQUEST['mac'])
          : $default['mac'];

        $cmd = isset( $_REQUEST['cmd_1'],$_REQUEST['cmd_2'] )
          ? $_REQUEST['cmd_1']*256 + $_REQUEST['cmd_2']*1
          : $default['cmd'];

        $ta = isset( $_REQUEST['ta'] ) ? trim( $_REQUEST['ta'] ):"";
        $tp = isset( $_REQUEST['tp'] ) ? trim( $_REQUEST['tp'] ):"";
        $tpu = isset( $_REQUEST['tpu'] ) ? 1:0;

        $act = isset( $_REQUEST['act'],
          $_REQUEST['ip'],
          $_REQUEST['port'],
          $_REQUEST['mac'],
          $_REQUEST['cmd_1']
        ) 
        ? trim($_REQUEST['act']) 
        : '';

        if( $act !== 'do' ) {
          DoLog( "Не верный MAC", 'ERROR' );
          $this->CloseSocket();
          continue;
        }

        $packet_bytes = sscanf( $_REQUEST['mac'], '%02X:%02X:%02X:%02X:%02X:%02X:%02X:%02X' );
        if( !$packet_bytes ){
          DoLog( "Не верный MAC", 'ERROR' );
          $this->CloseSocket();
          continue;
        }

        $cmd_bytes = false;
        if( $cmd>= 0 and $cmd<= 0x3FFF ){
          $cmd_bytes = array( 
            ($cmd & 0x3FFF) >> 8,
            $cmd & 0xFF,
          );
        }

        if( !$cmd_bytes ){
          DoLog( "Не верная команда", 'ERROR' );
          $this->CloseSocket();
          continue;
        }

        $arPacket = array(
          $packet_bytes[0],
          $packet_bytes[1],
          $packet_bytes[2],
          $packet_bytes[3],
          $packet_bytes[4],
          $packet_bytes[5],
          $packet_bytes[6],
          $packet_bytes[7],
          0x15,
          0x01,
        );

        AddPacketData( $arPacket, $ta );

        if( $use_crc = 1 ){
          $arPacket[] = archives_comp_crc( $arPacket, count($arPacket) );
        }

        $packet = implode( '', array_map( 'chr', $arPacket ) );

        $this->ip = $_REQUEST['ip'];
        $this->port = $_REQUEST['port'];

        if( !$this->Connect() ){
          $this->CloseSocket();
          continue;
        }

        SetBitrate( [ 'Baudrate' => 9600, 'Bits' => 8 , 'Parity' => 'None', 'StopBits'=>'1' ] , $_socket);

        NetBytesDebug( $packet, strlen($packet) , 0 , true );
        $this->SendData( $packet );
        $ms = 2000;
        $len = $this->WaitForAnswer( $buf, $ms, 'testAswer' );

        if( $len<1 ){
          DoLog( sprintf("Нет ответа %d ms", $ms ), 'ERROR' );
          DoLog( sprintf( "Write Fatal"), 'ERROR_WRITE' );
          $this->CloseSocket();
          continue;
        }




        $answer_bytes = array();
        for ($i=0; $i < $len; $i++) { 
          $answer_bytes[] = ord($buf[$i]);
        }

        // проверим что ответ валиден



        if( count($answer_bytes) != 43 ){
          $this->CloseSocket();
          continue;
        }

        if( $answer_bytes[8] != 0x55 || $answer_bytes[9] != 0x01  ){
          $this->CloseSocket();
          continue;
        }

        $lines = array();
        $buf_line = array();
        for ($i=10; $i < 42 ; $i++) { 
          if( count($buf_line) == 4 ){
            $lines[] = $buf_line;
            $buf_line = array();
          }
          $buf_line[] = $answer_bytes[$i];
        }
        $lines[] = $buf_line;

        for ($i=0; $i < count($lines); $i++) { 
          $line = $lines[$i];
          $int = 0;
          $int += $line[0] << 24; 
          $int += $line[1] << 16;
          $int += $line[2] << 8;
          $int += $line[3];
          

          $FilterParameter = array(
            'Filter' => array(
              'Ident' => "COUNT_" . ($i+1)
            )
          );

          $Filter = array(
            'Filter' => array(
              'Meter'     => $iTask->Meter->Id,
              'Parameter' => parameter::Filter($FilterParameter)->First->Id,
              'Year'      => $iTask->Year,
              'Month'     => $iTask->Month,
              'Day'       => $iTask->Day,
              'Hour'      => $iTask->Hour
            )
          );

          $MDHF = meterdatahour::Filter($Filter);

          $LG = loginfo::ByIdent("OK");


          $MDH = meterdatahour::Id(0);

          if( $MDHF->Count >0 ){
            if( $MDHF->First->Loginfo->Id == $LG->Id ){
              continue;
            }else{
              $MDH = $MDHF->First;
            }
          }

          if(!$MDH->Id){
            meterdatahour::AddByArray(array(
              'MeterId'     => $iTask->Meter->Id,
              'ParameterId' => parameter::Filter($FilterParameter)->First->Id,
              'Year'        => $iTask->Year,
              'Month'       => $iTask->Month,
              'Day'         => $iTask->Day,
              'Hour'        => $iTask->Hour,
              'LoginfoId'   => $LG->Id,
              'Value'       => $int,
              'AddTime'     => time()
            ));
          }else{
            $MDH->UpdateByArray(array(
              'Value' => $int,
              'LoginfoId' => $LG->Id,
              'AddTime' => time()
            ));
          }
          $Filter = array(
            'Filter' => array(
              'Meter' => $iTask->Meter->Id,
              'Parameter' => parameter::Filter($FilterParameter)->First->Id,
              'Year' => $iTask->Year,
              'Month' => $iTask->Month,
              'Day' => $iTask->Day,
              'Hour' => $iTask->Hour,
            )
          );
          $ResF = task::Filter($Filter);
          if( $ResF->Count ){
            $ResF->First->UpdateByArray(array(
              'TaskstatusId' => 3
            ));
          }
        }

      }
      $iTaskGroup->ElementsFreeMem;
    }



    return true;
  }




  protected function WaitForAnswer( &$buf, &$ms_need, $funcTestPacketReady = false ){

    $lastAccess = microtime(true);
    $lastPrint = microtime(true);
    $sockets_all = array( $this->_socket );
    $packet = '';
    $Length = 0;
    $ReadTimeOut = min(5, $ms_need/1000); // min 2sec
    $WaitStep = 0;
    DoLog( "0", 'PROGRESS' );
    while( microtime(true)-$lastAccess < $ReadTimeOut )
    {
      $r = array( $this->_socket );
      $w = NULL; //$sockets_all;
      $f = array( $this->_socket );
      if( socket_select( $r,$w, $f , 
          $time_out_sec = 30*1000, 
          $time_out_usec = 50 * 1000
        ) !== FALSE )
      {

        $TmpData = '';
        if ( $InLength = socket_recv( $this->_socket, $TmpData, 1024, 0 ) ) {

          // var_dump($InLength);
          // var_dump(ord($TmpData));

          $packet .= $TmpData;
          $Length += $InLength;
          NetBytesDebug( $TmpData, $InLength );
          if( call_user_func( $funcTestPacketReady, $packet, $Length ) )
          {
            $ms_need = microtime(true)-$lastAccess;
            break;
          }
        }
        if( microtime(true)-$lastAccess > $ReadTimeOut )
        {
          DoLog( "Read TimeOut" ,'ERROR' );
          break;
        }
      }
    }
    DoLog( "100", 'PROGRESS' );
  //  DoLog( 'Done wait '. ++$WaitStep ); 
    $buf = $packet;
    return $Length;
  }

  function SendData( $packet ) {
    $Rez = socket_write( $this->_socket, $packet, strlen($packet) );
  }



}





function testAswer( $packet, $Length ) {
  if( $Length < 1 ) return false;
  $arPacket = array();
  for( $i=0; $i<$Length; $i++ ){
    $arPacket[] = ord($packet[$i]) ;
  }
  $crc = archives_comp_crc( $arPacket, $Length-1 );
  return (bool)( $crc === $arPacket[$Length-1] );
}


function archives_comp_crc( &$data, $size ){
  $crc  = 0x00;

  for( $loop_count = 0; $loop_count < $size; $loop_count++ ) {
  $dat  = $data[$loop_count];

  for( $i = 0; $i < 8; $i++) {
    $feedback_bit = ($crc ^ $dat) & 0x01;

    if($feedback_bit == 0x01)
    $crc  = $crc ^ 0x18;  // 0x18 = POLYNOM (X^8+X^5+X^4+X^0)
//    $crc  = $crc ^ 0x31;  // 0x18 = POLYNOM (X^8+X^5+X^4+X^0)

    $crc  = ($crc >> 1) & 0x7F;

    if($feedback_bit == 0x01)
    $crc  |= 0x80;

    $dat  = $dat >> 1;
    }
  }

  return $crc;
}

function NetBytesDebug( $buf, $len, $ltrim=0 ,$output = false ){
  $class =  $output ? 'output' : 'input';
  $PacketsHTML = "<table id='" . $class ."'><tr>";
  $arPacket = array();
  $Packets = ''; // ($output) ? ' >> ' : ' <<-- ';
  for( $i=$ltrim; $i<$len; $i++ ) {
    $PacketsHTML .= sprintf("<td class='n{$i}'>%02X</td>", ord($buf[$i]) )." ";
    $Packets     .= sprintf("%02X ", ord($buf[$i]) )." ";
    if($i<$len-1){
      $arPacket[] = ord($buf[$i]) ;
    }
  }
  $PacketsHTML .= "</tr></table>";
//  DoLog( $PacketsHTML, 'DEBUG.PACKETS' );
  DoLog( $Packets, 'PACKETS', ($output ) ? 'OUT' : 'IN'  );
}



function DoLog( $text, $mode='DEBUG', $id='' ) {  
  echo $text."\n";
  // echo sprintf ("DoLog( '%s', %s, %s );\n", $mode, json_encode($text), json_encode($id) );
  // file_put_contents(__DIR__."/8i.log", $text,FILE_APPEND);
  // ob_flush();
  // flush();
}


function AddPacketData( &$arPacket, $ta )
{
  $Hex= '';
  $byte = 0;
  for ( $i = 0; $i < strlen( $ta ); $i += 1 ) {
    $X =  $ta[$i];
    if( ($X >= '0' && $X <= '9') || ( $X >= 'a' && $X <= 'f' ) || ( $X >= 'A' && $X <= 'F' ) ) {
      $Hex .= $X;
    } else if ( $X == ':' || $X == 0x00 ) {
      if( $Hex != '' ) {
        $byte = hexdec($Hex);
        $Hex = '';
        $arPacket[] = $byte;
      }
    } else {
      printf ("Erorr in symbol %c (%02X)", $X, $X);
    }
  }
  if( $Hex != '' ) {
    $byte = hexdec($Hex);
    $Hex = '';
    $arPacket[] = $byte;
  }
}