<?php
class job_taskrecover extends Jobs
{
	function getTitle()
	{
		return "Восстановление заданий";
	}
	
	function getDescription()
	{
		return "Восстановление пропущенных заданий, после появления связи с прибором по текущим заданиям, появления статуса работы исправен";
	}

	function QueryTymes( $FromDatetime, $ToDatetime )
	{
		$FromDatetime->setTime( $FromDatetime->format('H'), 0, 0 );
		$ToDatetime->setTime( $ToDatetime->format('H'), 0, 0 );
		
		// Если дата из будущего
		if( $FromDatetime > $ToDatetime	)
		{
			return 0;
		}
		
		$IntervalToNow = $ToDatetime->diff( $FromDatetime );
		return intval(
			$IntervalToNow->format('%Y%M%D%H')
		);
	}
	
	public $AddTaskHourMinLimit = 10000; //Ограничение на длину очереди задач add_task_hour
	public $LimitByParamLook = 12;    //Ограничение на количество просмотра параметра во времени
	public $LimitByParamAdd  = 10;    //Ограничение на количество добавленных заданий на параметр прибора учета
	public $LimitByMeterAdd  = 20;    //Ограничение на количество добавленных заданий на прибора учета
	
	function GetTasksCount()
	{
		$arLook = array(
			'Filter' => array(
				'IsDone' => '1',
			),
			'AddWhere' => 'AND `meter_id` IN ( SELECT `id` from `meter` WHERE `is_ok`=1 )',
		);
		return meterlast::Filter( $arLook )->Count;
	}
	
	
	
	/*
									:						:						:
	+-------------------------------------------------------+
	| 1 | # |   |   | # |   |   | # |   |   | # |           |
	+-------------------------------------------------------+
	| 2 |   | # |   |   | # |   |   | # |   |   | # |       |
	+-------------------------------------------------------+
	| 3 |   |   | # |   |   | # |   |   | # |   |   | # |   |
	+-------------------------------------------------------+
									:						:						:
									
									:						:						:
	+-------------------------------------------------------+
	| 1 | # |   |   | # |   |   | # |   |   | # |           |
	+-------------------------------------------------------+
	| 3 |   |   | # |   |   | # |   |   | # |   |   | # |   |
	+-------------------------------------------------------+
	| 2 |   | # |   |   | # |   |   | # |   |   | # |       |
	+-------------------------------------------------------+
									:						:						:
	
	
	*/
	
	
	
	
	function Start( $NowTimestamp = null )
	{
		if( 0 ) {
			echo "Задание временно заблокировано вручную.\n";
			return true;
		}
//		echo "Задание заблокировано, как требующее обновления для работы с часовыми поясами\n";

		$MyTz = date_default_timezone_get();
		date_default_timezone_set( 'UTC' );
		
		$DateNow = new DateTime( "now", new DateTimeZone( 'UTC' ) );
		if( $NowTimestamp ) {
			$DateNow->setTimestamp($NowTimestamp);
		}
		
		
		$LastId = Site()->Config( 'Taskrecover.LastId', 0 );
		
		$format='Y-m-d H:00:00';
		$arLook = array(
			'Filter' => array( 'IsDone' => 1 ),
		);
		$count_params_all = meterlast::Filter($arLook)->Count;
		$arLook = array(
			'AddWhere' => "AND `id` IN ( SELECT `meter_id` FROM	`meterlast` WHERE `is_done` =1 )",
		);
		$count_meters_all = meter::Filter($arLook)->Count;
    
		echo "Параметров для восстановления: " . $count_params_all . " на " . $count_meters_all . " приборах учета\n";


		$arLook = array(
			'Filter' => array( 'IsDone' => 1 ),
			'AddWhere' => "AND `meter_id` IN ( SELECT `id` FROM `meter` WHERE `is_ok` =1 )",
		);
		$count_params_all = meterlast::Filter($arLook)->Count;
		$arLook = array(
			'Filter'   => array( 'IsOk' => 1 ),
			'AddWhere' => "AND `id` IN ( SELECT `meter_id` FROM `meterlast` WHERE `is_done` =1 )",
		);
		$count_meters_all = meter::Filter($arLook)->Count;
    
		echo "Параметров для восстановления: " . $count_params_all . " на " . $count_meters_all . " приборах учета (Исключены проблемные приборы)\n";


		$LimitConverterId = "AND `converter_id` NOT IN ( SELECT `meter`.`converter_id` FROM `task` LEFT JOIN `meter` ON `task`.`meter_id`=`meter`.`id` WHERE `task`.`user_id` <> 2 GROUP BY `meter`.`converter_id` ) AND converter_id IN ( select id from converter)";
$LimitConverterId = '';
		$arLook = array(
			'Filter' => array( 'IsDone' => 1 ),
			'AddWhere' => "AND `meter_id` IN ( SELECT `id` FROM `meter` WHERE `is_ok` =1 {$LimitConverterId} )",
		);
		$count_params_all = meterlast::Filter($arLook)->Count;
		$arLook = array(
			'Filter'   => array( 'IsOk' => 1 ),
			'AddWhere' => "AND `id` IN ( SELECT `meter_id` FROM `meterlast` WHERE `is_done` =1 ) {$LimitConverterId}",
		);
		$count_meters_all = meter::Filter($arLook)->Count;
		echo "Параметров можно назначить для восстановления: " . $count_params_all . " на " . $count_meters_all . " приборах учета (исключены занятые конвертеры)\n";

		$addTaskHourTasks = crontask::Ident( 'add_task_hour' )->Job->GetTasksCount();
		if( $addTaskHourTasks > $this->AddTaskHourMinLimit  ){
			echo "Задание не выполняется т.к. есть заданя ({$addTaskHourTasks}>{$this->AddTaskHourMinLimit} )для add_task_hour\n";
			return true;
		} else {
			echo "Заданий в очередти 'add_task_hour': {$addTaskHourTasks}\n";
		}

		echo "Назначение заданий только на свободные конвертеры {$LimitConverterId}\n";
		$arParams = Array(
			'Filter' => Array(
				'IsOk'				=> 1,
				'IsExcluded'	=> 0,
//				'Id >'				=> $LastId
			),
			'AddWhere' => "AND `id` IN ( SELECT `meter_id` FROM	`meterlast` WHERE `is_done` =1 ) {$LimitConverterId} ORDER BY id ASC",
		);
		$arMeters = meter::Filter( $arParams );
		
		# Если нету счетчиков для перебора и последний не равен 0, то считаем это окончанием и скидываем на 0
		if($arMeters->Count == 0 && $LastId > 0){
			$LastId = 0;
			$arParams['Filter']['Id >'] = $LastId;
			$arMeters = meter::Filter( $arParams );
		}
		
		
		echo "\$LastId = {$LastId}\n";
		
		

		# Если нету счетчиков для перебора и последний не равен 0, то считаем это окончанием и скидываем на 0
		if($arMeters->Count == 0 && $LastId > 0)
		{
			$LastId = 0;
			$arParams['Filter']['Id >'] = $LastId;
			$arMeters = meter::Filter( $arParams );
		}


		echo "Количество приборов со старыми датами опроса: {$arMeters->Count}\n";
		if( $arMeters->Count == 0 )
		{
			echo "Приборов нет SQL: {$arMeters->Sql}\n";
		}
//		$MaxTaskForMeter = 10; // Максимальное количесво задач для одного прибора
		$StatusAdd = 0;
		//foreach( $arMeters->GroupBy(100)->Elements as $iGroup ) foreach( $iGroup->Elements as $iMeter )
		{
		
			
/*			
			$arParameterId = array();
			
			$Filter = array(
				'Filter' => array(
					'Metertype' => $iMeter->Type->Id
				)
			);
			foreach(metertypeparameter::Filter($Filter)->Elements as $iParameter){
				if( $iParameter->IsUse ){
					$arParameterId[ $iParameter->Parameter->Id ] = $iParameter->Parameter->Id;
				}
			}
*/			

			
			// Данные на прибор TODO: task #950
#			$arLookMeterLast = Array(
#				'Filter' => Array(
#					'Meter' 		=> $iMeter->Id,
#//					'Parameter' => $arParameterId,
#					'IsDone'    => '1',
#//					'Year'      => '2015',
#				),
#			);
			// назначаем задания сначала на самые не отстающие приборы учета
			$arLookMeterLast = array(
				'Filter' => array( 'IsDone' => 1 ),
				'AddWhere' => "AND `meter_id` IN ( SELECT `id` FROM `meter` WHERE `is_ok`=1 {$LimitConverterId} ) ORDER BY `year` DESC, `month` DESC, `day` DESC, `hour` DESC ",
				'Limit'  => 5000,
			);
			
			$arMeterlasts = meterlast::Filter( $arLookMeterLast );
#			$arMeterlasts = $iMeter->LastDataHour;
			
			$DateLast = new DateTime();

			echo " Количество последних данных на счетчик: {$arMeterlasts->Count}\n";

			$LimitByMeterAdd  = $this->LimitByMeterAdd;
			foreach( $arMeterlasts->Elements as $iMeterlast ){
				$iMeter = $iMeterlast->Meter;
				$this->AddIteration();
				echo "	{$iMeterlast->Meterdatahour->Year}-{$iMeterlast->Meterdatahour->Month}-{$iMeterlast->Meterdatahour->Day} {$iMeterlast->Meterdatahour->Hour}:00 {$iMeterlast->Parameter->Ident}\t";
				echo "{$iMeterlast->Meterdatahour->Value}\t{$iMeterlast->Meterdatahour->Loginfo->Logtext}\n";

				echo "\n[{$iMeterlast->Id}]meterlast->IsDone =2\n";
				$iMeterlast->IsDone=2;
				$iMeterlast->Save();

				if( $iMeterlast->Parameter->IsEventLog ) {
						echo "!!! Событие журнала. Удалить.\n";
						$iMeterlast->Delete();
						continue;
				}
				if( !$LimitByMeterAdd ) {
					echo "Превышен лимит назначения заданий на прибор учета {$this->LimitByMeterAdd}";
				}
				
				Site()->SetConfig( 'Taskrecover.LastId', $iMeter->Id );
			
				if( !$iMeter->IsOk )	{
					echo " Статус прибора с ошибками\n";
	//				continue;
				}
	//			$Step = $MaxTaskForMeter; 
				echo "Прибор: {$iMeter->Id}\tAbout: {$iMeter->Converter->Title}/{$iMeter->Title}\n";
				if( $iMeter->Converter->IsExcluded ) {
					echo " Точка опроса исключена из опроса\n";
					continue;
				}
			

				if( !$iMeterlast->Meterdatahour->Is ) {
					// если данных, на которые идет ссылка нет.
					echo "Ссыла mdh не действительна.\n";
					continue;
				}
				
				if( !$iMeterlast->MeterdatahourSkip->Is ) {
					$iMeterlast->MeterdatahourSkip = $iMeterlast->Meterdatahour;
				}
				
				echo "MHDSKIP={$iMeterlast->MeterdatahourSkip->Id} MHD={$iMeterlast->Meterdatahour->Id}\n";

				if( $iMeter->Timezone->Is ) {
					$MeterTzIdent = $iMeter->Datetime->getTimezone()->getName();
				} else {
					$MeterTzIdent = $MyTz;
				}
			 
				echo " Часовой пояс: {$MeterTzIdent}\n";

				$oTimeZoneMtr =	new DateTimeZone( $MeterTzIdent );
				$oTimeZoneUTC =	new DateTimeZone( 'UTC' );

				$DateLast->setTimezone( $oTimeZoneMtr );
				$DateLast->setDate( 
					$iMeterlast->MeterdatahourSkip->Year, 
					$iMeterlast->MeterdatahourSkip->Month,
					$iMeterlast->MeterdatahourSkip->Day
				);

				$DateLast->setTime( $iMeterlast->MeterdatahourSkip->Hour, 0, 0 );
//				( $MDHFormat, $MDHValue $iMeter->DateLast, $oTimeZoneMtr );
				echo "	 Дата последнего опроса : {$DateLast->format($format)} ";
				$DateLast->setTimeZone( $oTimeZoneUTC );
				echo "\tUTC: {$DateLast->format($format)}\n";
				echo "	 Дата сейчас						\t\t\t\tUTC: {$DateNow->format($format)}\n";
				$DateNeed = clone $DateLast;
				$LimitByParamLook = $this->LimitByParamLook;
				$LimitByParamAdd  = $this->LimitByParamAdd;
				while( $LimitByParamLook-- && $this->QueryTymes( $DateNeed, $DateNow ) && $LimitByParamAdd )
				{
				
					flush();
					if( $this->GetMemoryRun() ) {
						break 2; //return true;
					}
					if( $this->GetTimeRun() ) {
						break 2; //return true;
					}

					$DateNeed = $DateNeed->add( new DateInterval('PT1H') );
					$DateNeed->setTimezone( $oTimeZoneUTC );
					$NeedUTCTime = $DateNeed->format($format)." (-".$this->QueryTymes( $DateNow, $DateNeed ).":00)";
					$DateNeed->setTimezone( $oTimeZoneMtr );
					$NeedMeterTime = $DateNeed->format($format). "(+".$this->QueryTymes( $DateLast, $DateNeed ).":00)";
					echo "	 Нужно запросить\t{$NeedMeterTime}\tUTC: {$NeedUTCTime}\n";
					$DMHNeed = clone $DateNeed;
					$DMHNeed	= $DMHNeed->sub( new DateInterval('PT1H') );
					$DMHYear	= $DMHNeed->format( 'Y' );
					$DMHMonth = $DMHNeed->format( 'm' );
					$DMHDay	 = $DMHNeed->format( 'd' );
					$DMHHour	= $DMHNeed->format( 'H' )+1;
					$arMDHLook = array(
						'Filter' => array(
							'Meter'		 => $iMeterlast->Meter->Id,
							'Parameter' => $iMeterlast->Parameter->Id,
							'Year'			=> $DMHYear,
							'Month'		 => $DMHMonth,
							'Day'			 => $DMHDay,
							'Hour'			=> $DMHHour,
						),
					);
					$arTaskLook = array(
						'Filter' => array(
							'Meter'		 => $iMeterlast->Meter->Id,
							'Parameter' => $iMeterlast->Parameter->Id,
							'Year'			=> $DMHYear,
							'Month'		 => $DMHMonth,
							'Day'			 => $DMHDay,
							'Hour'			=> $DMHHour,
						),
					);
					$MDHs = meterdatahour::Filter( $arMDHLook ); 
					if( $MDHs->Count>1 ) {
						echo "Count:{$MDHs->Count} SQL: {$MDHs->Sql}\n";
					}
					$MDH = $MDHs->First;
					echo "		Данные: ";
					if( $MDH->IsOnOkState ){
						echo "Да {$MDH->Value} ({$MDH->Loginfo->Title})";
					}else{
						echo "Нет {$MDH->Value} ({$MDH->Loginfo->Title})";
					}
					$Task = task::Filter( $arTaskLook )->First; 
					echo "	Задание: ";
					if( $Task->Is )
					{
						echo $Task->Taskstatus->Title;
						if( $Task->Taskstatus->Id == 0 )
							$Task->Taskstatus = taskstatus::Id(1);
						echo ", Попытка {$Task->Retry}";
					}
					else
					{
						echo "Нет";
					}
					echo "\n";
					if( !$MDH->IsOnOkState and !$Task->Is )
					{
						$TaskAdd = task::AddByArray( array(
							'MeterId'			=> $iMeterlast->Meter->Id,
							'ParameterId'	=> $iMeterlast->Parameter->Id,
							'Year'				=> $DMHYear,
							'Month'				=> $DMHMonth,
							'Day'					=> $DMHDay,
							'Hour'				=> $DMHHour,
							'TaskstatusId'=> 1,
							'TsStart'			=> 0,
							'TsEnd'				=> 0,
							'UserId'			=> Self()->Id,
							'Retry'        => 1,
							'Retrymax'		=> max( 2, Site()->Config( 'job.task_retry_delete.count', 3 ) ),
						) );
						
						if( $TaskAdd )
						{
							$LimitByParamAdd--; $LimitByMeterAdd--;							
							$StatusAdd++;
							echo "+		Задание добавлено Id:{$TaskAdd->Id}"
								." M:{$TaskAdd->Meter->Id}"
								." P:{$TaskAdd->Parameter->Id}"
								." D:{$TaskAdd->Year}.{$TaskAdd->Month}.{$TaskAdd->Day} ".($TaskAdd->Hour-1).":00-{$TaskAdd->Hour}:00"
								."\n";
						}
					}
					elseif( !$MDH->IsOnOkState && $Task->Taskstatus->Id == 3 )
					{
						$LimitByParamAdd--; $LimitByMeterAdd--;
						$Task->Taskstatus = taskstatus::Id(1);
						$Task->Retry			= 0;
						echo "		 Задание обновлено Id:{$Task->Id}"
							."\tMeter:{$Task->Meter->Id}"
							."\tParameter:{$Task->Parameter->Id}"
							."\tDate:{$Task->Year}.{$Task->Month}.{$Task->Day} ".($Task->Hour-1).":00-{$Task->Hour}:00"
							."\n";
					}
					
					flush();
  	
				}
				
				$iMeterlast->Save();
				
			$iMeterlast->IsDone=2;
			echo "\nmeterlast =2\n";
			
			$iMeterlast->Save();
			
			echo "\n\$LastId = {$iMeter->Id}\n";
			}
			
		}
		if( $StatusAdd )
		{
			echo "Заданий добавлено {$StatusAdd}\n";
		}
		else
		{
			echo "Действий не выполнено\n";
		}
		
		
		return true;
		
		
	}
}
