{if $user_lang eq 'en'}
  {config_load file="en_lang.conf" section="Archive"}
{else}
  {config_load file="ru_lang.conf" section="Archive"}
{/if}
<div class="panel panel-default" id="panel_archive_{$iArchive->Id}">
    <div class="panel-heading"
        style="cursor:pointer;" 
          data-toggle="collapse" 
          data-parent="#accordion" 
          href="#archive_{$iArchive->Id}">
          
        <span>
            <span class="text-center">
              {include file="archive/helpers/block_name.tpl" oArchive=$iArchive}
            </span> 
            
            {if !$iArchive->Procent}
              <div class="pull-right">
                {if $iArchive->IsReady}
                  <button class="btn btn-success btn-xs run_dump">{$smarty.config.upload_button|default:"Загрузить"}</button>
                {/if}
                
                {assign var="hide_menu" value=$iArchive->IsReady && $iArchive->IsDrop}
                {if !$hide_menu}
                  <div class="btn-group">
                      <button 
                        type="button" 
                        class="btn btn-default btn-xs dropdown-toggle glyphicon glyphicon-option-vertical" 
                        data-toggle="dropdown" 
                        aria-expanded="false">
                      </button>
                      <div class="dropdown-menu pull-right list-group" role="menu">
                          <span class="list-group-item edit_archive">
                            <i class="fa fa-pencil"></i> {$smarty.config.menu_edit|default:"Редактировать"}
                          </span>
                          <span class="list-group-item run_archive">
                            <i class="fa fa-play"></i> {$smarty.config.menu_start|default:"Запустить"} {if $iArchive->IsReady}снова{/if}
                          </span>
                          {if $iArchive->IsReady}
                            <a href="/archive/{$iArchive->TransName}.zip">
                              <span class="list-group-item">
                                <i class="fa fa-download"></i> {$smarty.config.download_button|default:"Скачать"}
                              </span>
                            </a>
                          {/if}
                          <span class="list-group-item meter_edit">
                            <i class="fa fa-list-ul"></i> {$smarty.config.menu_meters|default:"Приборы учета"}
                          </span>
                          <span class="list-group-item delete_archive">
                            <i class="fa fa-times"></i> {$smarty.config.menu_delete|default:"Удалить"}
                          </span>
                      </div>
                  </div>
                {/if}
                  
              </div>
            {/if}
        </span>
    
        {if $iArchive->Procent}
          <br>
          <div class="progress">
            <div class="progress-bar progress-bar-striped active" role="progressbar"
            aria-valuenow="{$iArchive->Procent}" aria-valuemin="0" aria-valuemax="100" style="width:{$iArchive->Procent}%">
              {$iArchive->Procent}%
            </div>
          </div>
          
          {if $iArchive->IsForceExit}
            <button class="btn btn-disabled"><i class="fa fa-spinner"></i> {$smarty.config.stoping_button|default:"Останавливаем"}</button>
          {else}
            <button class="btn btn-danger archive_stoped"><i class="fa fa-stop"></i> {$smarty.config.stop_button|default:"Остановить"}</button>
          {/if}

          <button class="btn btn-default pull-right debug_report">{$smarty.config.stop_working_button|default:"stop_working_button"}</button>
        
        {/if}
    </div>
    <div id="archive_{$iArchive->Id}" class="panel-collapse collapse" aria-expanded="false" style="height: 0px;">
        <div class="panel-body">
          
          {if $iArchive->IsReady}
            <div class="alert alert-success alert-dismissable">
              <i class="fa fa-check"></i>
              {if $iArchive->IsDrop}
                {$smarty.config.success_delete_msg|default:"Данные удалены"}
              {else}
                {$smarty.config.success_copy_msg|default:"Данные скопированы"}
              {/if}
            </div>
          {else}
            <div class="alert alert-warning alert-dismissable">
              <i class="fa fa-warning"></i>
              {if $iArchive->IsDrop}
                {$smarty.config.alert_delete_msg|default:"Данные будут удалены"}
              {else}
                {$smarty.config.alert_copy_msg|default:"Данные будут скопированы"}
              {/if}
            </div>
          {/if}
          
          <table class="table">
            <tr>
              <td>{$smarty.config.upload_period|default:"Выгрузка за период"}</td>
              <td>
                <i class="fa fa-calendar"></i> {$iArchive->DaySt}-{$iArchive->MonthSt}-{$iArchive->YearSt} &nbsp;&nbsp;&nbsp;
                <i class="fa fa-calendar"></i> {$iArchive->DaySp}-{$iArchive->MonthSp}-{$iArchive->YearSp}
              </td>
            </tr>
            <tr>
              <td>{$smarty.config.user|default:"Пользователь"}</td>
              <td>
                {include file="user/helpers/block_name.tpl" oUser=$iArchive->User}
              </td>
            </tr>
            <tr>
              <td>{$smarty.config.creating_date|default:"Дата создания"}</td>
              <td>
                {$iArchive->Its|date_format:"%Y-%m-%d %H:%I:%S (%A)"}
              </td>
            </tr>
            <tr>
              <td>{$smarty.config.description|default:"Описание"}</td>
              <td>
                <pre>{$iArchive->Text|default:"--"}</pre>
              </td>
            </tr>
          </table>
          
          
          <div class="text-center">
            <a href="/archive/{$iArchive->TransName}.zip">
              <button class="btn btn-primary">
                <i class="fa  fa-download"></i> {$smarty.config.download_button|default:"Скачать"}
              </button>
            </a>
          </div>
          
          
        </div>
    </div>
</div>