<div class="row">
  <div class="col-lg-12">
    <div class="table-responsive"  id="converter_list">
    </div>
  </div>
</div>
<div class="row">
  <div class="col-lg-12" id="pagination">
  </div>
</div>


<script type="text/template" id="converter_list_tpl">
  <table class="table table-striped table-hover table-sortable">
    <% if( converters.length ){ %>
      <thead>
        {if $Self->IsAdmin}
        <th></th>
        <th></th>
        {/if}
        <% _.each( [
          { ident : "about" , name : "{$smarty.config.table_title|default:'Название'}" },
          { ident : "type"  , name : "{$smarty.config.table_type|default:'Тип'}"      },
          { ident : "ip"    , name : "{$smarty.config.table_ip|default:'Ip'}"       },
          { ident : "port"  , name : "{$smarty.config.table_port|default:'Порт'}"     },
        ] , function( th ){ %>
          <th class="
            <% if( converters.sort_field == th.ident ){ %>
               <% if( converters.sort_ad == "asc" ){ %>
                sortable-asc
               <% }else if( converters.sort_ad == "desc" ){ %>
                sortable-desc
               <% }else{ %>
                sortable
               <% } %>
            <% }else{ %>
               sortable
            <% } %>
          " data-sort="<%= th.ident %>"><%= th.name %></th>
        <% }) %>
        <th colspan="3">{$smarty.config.table_metering_devices|default:"Приборов учета"}</th>
      </thead>
    <% } %>
    <tbody>
      <% if( converters.length ){ %>
        <% _.each( converters.__sort_and_pages() , function( converter ){ %>
          <tr data-cid="<%= converter.cid %>">
            {if $Self->IsAdmin}
              <td class="action<% if( !converter.get("meters_all") ){ %> converter_delete_item<% } %>" >
                <% if( converter.get("meters_all") ){ %>
                <span class="fa fa-times " style="cursor:not-allowed;color:#bfbfbf;" title="{$smarty.config.cant_delete_message|default:'Вы не можете удалить, пока есть дочерние элементы'}"></span>
                <% }else{ %>
                  <i class="fa fa-times" alt="edit"></i>
                <% } %>
              </td>
              <td class="action converter_edit_item">
                <i class="fa fa-pencil " alt="edit"></i>
              </td>
            {/if}
            <td>
              <i class="{literal}<% if( converter.get('meter_ok') == 1 ){ %>text-success
                <% }else if(converter.get('meter_ok') == 2){%>text-warning
                <% }else{%>text-danger<% } %> {/literal}glyphicon glyphicon-transfer"></i>
              <a href="/converter/<%= converter.get('id') %>/"><%= converter.escape("about") %></a>
            </td>
            <td>
              <% var type = converter_types.findWhere({ id : Number(converter.get("type")) }); %>
              <% if( type ){ %>
                <%= converter_types.findWhere({ id : Number(converter.get("type")) }).escape('title') %>
              <% } %>
            </td>
            <td>
              <%= converter.escape("ip") %>
            </td>
            <td>
              <%= converter.escape("port") %>
            </td>
            <td>
              <i class="fa fa-flash"></i>
              <%= converter.get("meters_all") %>
            </td>
            <td>
              <i class="fa fa-flash text-danger"></i>
              <%= converter.get("meters_err") %>
            </td>
            <td>
              <i class="fa fa-flash text-muted"></i>
              <%= converter.get("meters_exc") %>
            </td>
          </tr>
        <% }) %>
      <% }else{ %>
        <tr>
            <td>{$smarty.config.no_items|default:"Нет ни одного элемента"}</td>
        </tr>
      <% } %>
    </tbody>
    {if $Self->IsAdmin}
    <tfoot>
      <tr>
        <th colspan="100" class="text-center" id="add_converter_modal">
          <button style="width:100%;" class="btn btn-default">
            <i class="fa fa-plus-circle "></i>
          </button>
        </th>
      </tr>
    </tfoot>
    {/if}
  </table>
</script>

<script id="converter_add_modal" type="text/template">
  <div class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
      <div class="modal-dialog">
          <div class="modal-content">
              <div class="modal-header">
                  <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                  <h4 class="modal-title">
                    <% if( !converter.get('id') ){ %>
                      {$smarty.config.modal_head_add|default:"Добавление узла учета"}
                    <% }else{ %>
                      {$smarty.config.modal_head_edit|default:"Редактирвоание"} <%= converter.escape('title') %>
                    <% } %>
                  </h4>
              </div>
              <div class="modal-body" id="converter_modal_body">
              </div>
              <div class="modal-footer">
                  <button type="button" class="btn btn-default" data-dismiss="modal">
                    {$smarty.config.modal_close_button|default:"Закрыть"}
                  </button>
                  <button type="button" class="btn btn-<% if( converter.isValid() ){ %>success<% }else{ %>disabled<% } %>" id="save">
                    {$smarty.config.modal_save_button|default:"Сохранить"}
                  </button>
              </div>
          </div>
      </div>
  </div>
</script>



<script id="converter_modal_body_ci_13_tpl" type="text/template">
  <div class="form-group">
    <label class="control-label">{$smarty.config.modal_converter_type|default:"Тип точки опроса"}<sup>*</sup></label>
    <select size="1" name="TypeId" class="form-control"  id="type" >
      <% _.each( converter_types.toArray() , function( type ){ %>
              <option value="<%= type.get('id') %>" 
              <% if( converter.get('id') && converter.get("type") == type.get('id') ){ %>selected<% } %>
              ><%= type.escape('title') %></option>
      <% }) %> 
    </select>
  </div>
</script>

<script id="converter_modal_body_main_tpl" type="text/template">
  <div class="form-group">
    <label class="control-label">{$smarty.config.modal_converter_type|default:"Тип точки опроса"}<sup>*</sup></label>
    <select size="1" name="TypeId" class="form-control"  id="type" >
      <% _.each( converter_types.toArray() , function( type ){ %>
              <option value="<%= type.get('id') %>" 
              <% if( converter.get('id') && converter.get("type") == type.get('id') ){ %>selected<% } %>
              ><%= type.escape('title') %></option>
      <% }) %> 
    </select>
  </div>
  <div class="form-group">
    <label class="control-label">{$smarty.config.modal_ip|default:"Ip"}<sup>*</sup></label>
    <input class="form-control" type="text" name="Ip" id="ip" value="<%= converter.get("ip") %>">
  </div>
  <div class="form-group">
    <label class="control-label">{$smarty.config.modal_port|default:"Port"}<sup>*</sup></label>
    <input class="form-control" type="number" min="1" max="65535" name="Port"  id="port" value="<%= converter.get("port") %>">
  </div>
  <div class="row">
    <div class="col-lg-6" style="
        display: inline-block;
        float: left;
        vertical-align: middle;
    ">
      <a class="more_settings_controller">
        {$smarty.config.modal_more_settings|default:"Расширенные настройки"} <i class="fa-chevron-circle-down fa fa-wf"></i> 
      </a>
    </div>
    <div class="col-lg-6" style="
        display: inline-block;
        float: right;
        vertical-align: middle;
    ">
      <button type="button" class="btn btn-<% if( converter.isValid() ){ %>info<% }else{ %>disabled<% } %> pull-right" id="ping">{$smarty.config.modal_check_connect|default:"Проверить соединение"}</button>
      <i class="glyphicon glyphicon-transfer text-muted fa-fw pull-right" style="
        padding: 9px;
    display: inline-block;
    width: 34px;
" id="ping_res"></i>
    </div>
    <div style="clear:both;"></div>
    <br>
    <div class="alert alert-danger" style="display:none;" id="danger_ping"></div>
    <div class="alert alert-success" style="display:none;" id="success_ping"></div>
    <div class="container_error"></div>
  </div>
  <div class="more_settings hide">
    <div class="form-group ">
      <label class="control-label">{$smarty.config.modal_login|default:"Логин"}</label>
      <input class="form-control" type="text" name="Login" value="<%= converter.escape("login") %>" id="login">
    </div>  
    <div class="form-group ">
      <label class="control-label">{$smarty.config.modal_password|default:"Пароль"}</label>
      <input class="form-control" type="text" name="Password" value="<%= converter.escape("pass") %>"  id="pass">
    </div>  
    <div class="form-group ">
      <label class="control-label">{$smarty.config.modal_title|default:"Название"}</label>
      <input class="form-control" type="text" name="About" value="<%= converter.escape("about") %>" id="about">
    </div>  
    <div class="form-group ">
      <label class="control-label">{$smarty.config.modal_timeout_connect|default:"Время ожидания установки соединения"}</label>
      <input class="form-control" type="text" name="Timeoutconnect" id="timeoutconnect" value="<%= converter.get("timeoutconnect") %>">
    </div>  
    <div class="form-group ">
      <label class="control-label">{$smarty.config.modal_timeout_receive|default:"Время ожидания ответа от прибора"}</label>
      <input class="form-control" type="text" name="Timeoutreceive" id="timeoutreceive" value="<%= converter.get("timeoutreceive") %>">
    </div>  
    <div class="form-group ">
      <label class="control-label">{$smarty.config.modal_web_port|default:"Порт для Web интерфейса"}</label>
      <input class="form-control" type="text" name="Portcontrol" value="<%= converter.get("portcontrol") %>" id="portcontrol">
    </div>  
    <div class="form-group ">
      <label class="control-label">{$smarty.config.modal_exclude_button|default:"Исключено из опроса"}</label>
      <label class="label toggle">
        <input type="checkbox" class="toggle_input" id="IsExcluded" name="IsExcluded" id="excluded" value="" <% if( converter.get('excluded') ){ %>checked{ %>0<% } %>/>
        <div class="toggle-control"></div>
      </label>
    </div>  
    <div class="alert alert-warning" style="display:none;" id="excluded_alert">{$smarty.config.modal_exclude_message|default:"Внимание! Все приборы на этом узле учета не будут опрашиваться!"}</div>
  </div>
</script>
      
<script id="converter_list_sample_tpl" type="text/template">
  <div class="loader">
    <div class="page-preloader-cover">
      <div class="page-preloader__cube page-preloader--cube1"></div>
      <div class="page-preloader__cube page-preloader--cube2"></div>
      <div class="page-preloader__cube page-preloader--cube4"></div>
      <div class="page-preloader__cube page-preloader--cube3"></div>
      <div style="clear:both;"></div>
    </div>
  </div>
  <div class="loader_back"></div>
</script>


<script id="pagination_tpl" type="text/template">
  <% if( pages.length > 1 ){ %>
    <% _.each( pages , function( page ){ %>
      <li <% if( active == (page + 1) ){ %>class="active"<% } %> >
        <a href="#" data-page="<%= page + 1  %>"><%= page + 1  %></a>
      </li>
    <% }) %>
  <% } %>
</script>



<script id="converter_delete_modal" type="text/template">
  <div class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
      <div class="modal-dialog danger">
          <div class="modal-content">
              <div class="modal-header" style="    background-color: #d9534f;
    color: #fff;
    border-radius: 5px 5px 0 0;">
                  <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                  <h4 class="modal-title">
                   {$smarty.config.modal_delete_header|default:"Вы уверены, что хотите удалить"} <%= converter.escape('title') %> ?
                  </h4>
              </div>
              <div class="modal-footer">
                  <button type="button" class="btn btn-default" data-dismiss="modal">
                    {$smarty.config.modal_delete_close|default:"Закрыть"}
                  </button>
                  <button type="button" class="btn btn-danger" id="delete">
                    {$smarty.config.modal_delete_accept|default:"Удалить"}
                  </button>
              </div>
          </div>
      </div>
  </div>
</script>

<script id="counters_tpl" type="text/template">
  <li class="disabled">
      <a>{$smarty.config.view_by|default:"Показывать по"} :</a>
  </li>
  <% _.each( counters , function( count ){ %>
    <li <% if( count == by_count ){ %>class="active"<% } %> >
      <a href="#" data-count="<%= count  %>"><% if( !count ){ %>{$smarty.config.all|default:"Все"}<% }else{ %><%= count  %><% } %></a>
    </li>
  <% }) %>
</script>