{if $user_lang eq 'en'}
	{config_load file="en_lang.conf" section="Log"}
{else}
  {config_load file="ru_lang.conf" section="Log"}
{/if}
<div class="row">
    <div class="col-lg-12">
        <h1 class="page-header">{$smarty.config.logs|default:"История событий на"} 
          <a href="{$oObject->Link}">
            {$oObject->Title|escape}
          </a>
        </h1>
    </div>
</div>


{if $Self->IsAdmin}
  <ul class="nav nav-tabs">
    <li class="active">
      <a href="{$oObject->LinkLog}">
        {$smarty.config.user_logs|default:"Пользовательский журнал"}
      </a>
    </li>
    {if property_exists($oObject,'GetSysLog')}
      <li><a href="{$oObject->LinkSysLog}">{$smarty.config.system_logs|default:"Системный журнал"}</a></li>
    {/if}
    <li><a href="/log/">{$smarty.config.all_logs|default:"Весь журнал"}</a></li>
  </ul>
{/if}


<div class="container-fluid">
  <div class="row">
    <div class="col-lg-12">
        
        {if $oObject->LogList->Count}

          {include file="helpers/pagination.tpl" Pages=$oObject->LogPages}
          
          <ul class="milestones">
            {foreach from=$oObject->LogList->Elements item="iLog"}
                <li>
                  <i class="milestone-{$iLog->CssColor} {$iLog->CssClassIcon}"></i>
                  <p>
                    {include file="user/helpers/block_name.tpl" oUser=$iLog->User}
                    <span class="pull-right text-muted small">
                      <em>
                        {$iLog->Its|date_format:"%Y-%m-%d %H:%I:%S (%A)"}
                      </em>
                    </span>
                  </p>
                  <p>{$iLog->Object} [{$iLog->ObjectId}] 
                    <span class="pull-right text-muted small">
                      <em>
                        #{$iLog->Id}
                      </em>
                    </span>
                  </p>
                  {if $iLog->Object == 'meter' && $iLog->Property == 'Delete'}
                    <button type="button" class="btn btn-default btn-xs spoiler-trigger" data-toggle="collapse">
                      {$smarty.config.more|default:"Подробнее"} <i class="fa  fa-angle-down"></i> 
                    </button>
                    <pre class="collapse out">{assign var="cl" value=$iLog->Object}{var_export(json_decode($cl::Id($iLog->ObjectId)->Title))}</pre>
                  {elseif $iLog->Property == 'Update' || $iLog->Property == 'Add'}
                    <button type="button" class="btn btn-default btn-xs spoiler-trigger" data-toggle="collapse">
                      {$smarty.config.more|default:"Подробнее"} <i class="fa  fa-angle-down"></i>
                    </button>
                    <div class="collapse out">{$iLog->ActionToTpl}</div>
                  {else}
                    {$iLog->ActionToTpl}
                  {/if}
                </li>
            {/foreach}
          </ul>

          {include file="helpers/pagination.tpl" Pages=$oObject->LogPages}

        {else}
          <h3>{$smarty.config.no_logs|default:"Еще ничего не происходило."}</h3>
        {/if}
        
    </div>
  </div>
</div>


{literal}
  <script>
    $(".spoiler-trigger").click(function() {
      $(this).next().collapse('toggle');
    });
  </script>
{/literal}