{assign var="not_require" value=true}
{extends file="layout/lora.layout.tpl"}
{block name="content"}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">{$smarty.config.servers|default:"Сетевые серверы"}</h1>
          
          <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:"Main page"}</a></li>
            <li class="active">{$smarty.config.servers|default:"Сетевые серверы"}</li>
          </ol>
          
      </div>
  </div>
  <div class="panel panel-default">
    <div class="panel-heading">
      {$smarty.config.servers|default:"Сетевые серверы"}
    </div>
    <div class="panel-body">
      <div class="row">
        <div class="col-lg-12">
          <div class="table-responsive" id="lora_list"></div>
        </div>
      </div>
    </div>

    <script type="text/template" id="lora_list_tpl">
      
      <table class="table table-striped table-hover table-sortable">

          <% if( lora_collection.length ){ %> 

            <thead>
              <tr>
                <th></th>
                <th></th>
                <th>{$smarty.config.table_title|default:"Title"}</th>
                <th>{$smarty.config.table_type|default:"Type"}</th>
                <th>{$smarty.config.table_ip|default:"Ip"}</th>
                <th>{$smarty.config.table_port|default:"Port"}</th>
              </tr>
            </thead>

            <tbody>
              <% _.each( lora_collection , function( lora_model ){ %>
                <tr id="<%= lora_model.cid %>">
                  <td class="action lora_delete_item">
                    <i class="fa fa-times" alt="edit"></i>
                  </td>
                  <td class="action lora_edit_item">
                    <i class="fa fa-pencil " alt="edit"></i>
                  </td>
                  <td>
                    <a href="/lorawan/<%= lora_model.get('id') %>/">
                      <i class="glyphicon glyphicon-signal"></i>
                      <%= lora_model.escape('about') %>
                    </a>
                  </td>
                  <td>
                    <% var type = loratype_collection.findWhere({ id : Number( lora_model.get('type') ) }); %>
                    <% if( typeof type != "undefined" ){ %>
                      <%= loratype_collection.findWhere({ id : lora_model.get('type') }).escape('title') %>
                    <% } %>
                  </td>
                  <td>
                    <%= lora_model.get('ip') %>
                  </td>
                  <td>
                    <%= lora_model.get('port') %>
                  </td>
                </tr>
              <% }) %>
            </tbody>

          <% }else{ %>
          

            <tbody>
              <tr>
                <td>{$smarty.config.table_empty_msg|default:"Вы еще ничего не добавили"}</td>
              </tr>
            </tbody>

           <% } %>
        
        <tfoot>
          <tr>
            <th colspan="100" class="text-center" id="add_converter_modal">
              <button style="width:100%;" class="btn btn-default">
                <i class="fa fa-plus-circle "></i>
              </button>
            </th>
          </tr>
        </tfoot>
      </table>

    </script>


    <script type="text/template" id="lora_add_tpl">
      {include file="lorawan/helper/edit_add_form.tpl"}
    </script>
    
    <script id="ip_label_tpl" type="text/template">
      <label class="control-label<% if( invalid ){ %> text-danger<% } %>">
  {$smarty.config.modal_ip|default:"Ip"}<sup>*</sup>
</label>
    </script>


    <script id="port_label_tpl" type="text/template">
      <label class="control-label<% if( invalid ){ %> text-danger<% } %>">{$smarty.config.modal_port|default:"Порт"}<sup>*</sup>
        <% if( invalid ){ %>
          <sup>
            <% switch( reason ){
              case "port is not a string":
                %>{$smarty.config.modal_port_must_be_number_msg|default:"Порт должен быть числом."}<%
                break;
              case "invalid port":
                %>{$smarty.config.modal_invalid_port_msg|default:"modal_invalid_port_msg"}<%
                break;
            } %>
          </sup>
        <% } %>
      </label>
    </script>


    <script id="lora_delete_tpl" type="text/template">
      <div class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
          <div class="modal-dialog danger">
              <div class="modal-content">
                  <div class="modal-header" style="background-color: #d9534f;color: #fff;border-radius: 5px 5px 0 0;">
                      <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                      <h4 class="modal-title">
                       {$smarty.config.modal_delete_accept|default:"Вы уверены, что хотите удалить"} <%= lora_model.escape('about') %> ?
                      </h4>
                  </div>
                  <div class="modal-footer">
                      <button type="button" class="btn btn-default" data-dismiss="modal">
                      {$smarty.config.modal_delete_close_button|default:"Закрыть"}
                      </button>
                      <button type="button" class="btn btn-danger" id="delete">
                      {$smarty.config.modal_delete_delete_button|default:"Удалить"}
                      </button>
                  </div>
              </div>
          </div>
      </div>
    </script>

    <script type="text/javascript" src="/ts/models/lora_converter.js"></script>
    <script type="text/javascript" src="/ts/collections/lora_converters.js"></script>
    <script type="text/javascript" src="/ts/models/convertertype.js"></script>
    <script type="text/javascript" src="/ts/collections/convertertypes.js"></script>
    <script type="text/javascript" src="/ts/views/lora/lora_edit_add_modal.js"></script>
    <script type="text/javascript" src="/ts/views/lora/index.js"></script>
    
  </div>
{/block}
