{assign var="not_require" value=true}
{extends file="layout/lora.layout.tpl"}
{block name="content"}

<script>
  var lora_id = {$Converter->Id}
</script>


<div class="row">
  <div class="col-lg-12">
    <h1 class="page-header">
      <span id="lora_h1"></span>
    </h1>

    <ol class="breadcrumb">
      <li><a href="/">{$smarty.config.breadcrumbs_main|default:"Главная"}</a></li>
      <li><a href="/lorawan/">{$smarty.config.servers|default:"Сетевые серверы"}</a></li>
      <li class="active" id="lora_brads"></li>
    </ol>

  </div>
</div>



<div class="row">
  <div class="col-lg-6 table-responsive">
    <div class="panel panel-default" id="lora_properties"></div>
  </div>
  <div class="col-lg-6 table-responsive">
    <div class="panel panel-default" id="undefined_device"></div>
    <div class="panel panel-default" id="gataways_list"></div>
  </div>
</div>



<div class="row">
  <div class="col-lg-12 table-responsive">
    <div class="panel panel-default" id="lora_meters"></div>
  </div>
</div>


<script type="text/template" id="lora_properties_tpl">
  <div class="panel-heading">
    {$smarty.config.lorawan_table_head|default:"Параметры устройства"}
    <span class="pull-right " id="converter_edit_modal" style="cursor: pointer;">
      <span href="/converter/15/edit/" class="fa fa-pencil"></span>
    </span>
  </div>
  <div class="panel-body">
    <table class="table table-striped table-hover">
      <thead>
        <tr>
          <th>{$smarty.config.lorawan_table_property|default:"Свойство"}</th>
          <th>{$smarty.config.lorawan_table_value|default:"Значение"}</th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td>{$smarty.config.table_title|default:"Название"}</td>
          <td><%= lora_model.escape('about') %></td>
        </tr>
        <tr>
          <td>{$smarty.config.lorawan_table_connection_status|default:"Статус соединения"}</td>
          <td>
            <% if( connect_status ){ %>
            <b class="text-success">{$smarty.config.lorawan_table_connection_status_success|default:"Установлено"}</b>
            <% }else{ %>
            <b class="text-danger">{$smarty.config.lorawan_table_connection_status_error|default:"Не установлено"}</b>
            <% } %>
          </td>
        </tr>
        <tr>
          <td>{$smarty.config.lorawan_table_auth_status|default:"Статус авторизации"}</td>
          <td>
            <% if( status_auth ){ %>
            <b class="text-success">
              {$smarty.config.lorawan_table_auth_status_success|default:"Авторизован"}
            </b>
            <% }else{ %>
            <b class="text-danger">
                {$smarty.config.lorawan_table_auth_status_error|default:"Не авторизован"}
            </b>
            <% } %>
          </td>
        </tr>
        <tr>
          <td>
            {$smarty.config.lorawan_table_status_work|default:"Статус работы"}
          </td>
          <td>
            <% if( status_active){ %>
            <b class="text-success">{$smarty.config.lorawan_table_status_work_success|default:"Активно"}</b>
            <% }else{ %>
            <b class="text-danger">{$smarty.config.lorawan_table_status_work_error|default:"Не активно"}</b>
            <% } %>
          </td>
        </tr>
        <tr>
          <td>{$smarty.config.table_type|default:"Тип"}</td>
          <td>
            {$Converter->Type->Title}
          </td>
        </tr>
        <tr>
          <td>{$smarty.config.table_ip|default:"Ip"}</td>
          <td><%= lora_model.escape('ip') %></td>
        </tr>
        <tr>
          <td>{$smarty.config.table_port|default:"Порт"}</td>
          <td><%= lora_model.escape('port') %></td>
        </tr>
        <tr>
          <td>{$smarty.config.modal_login|default:"Логин"}</td>
          <td><%= lora_model.escape('login') %></td>
        </tr>
        <tr>
          <td>{$smarty.config.modal_password|default:"Пароль"}</td>
          <td><%= lora_model.escape('pass') %></td>
        </tr>
      </tbody>
    </table>

  </div>
</script>


<script type="text/template" id="lora_add_tpl">
  {include file="lorawan/helper/edit_add_form.tpl"}
</script>

<script id="ip_label_tpl" type="text/template">
      <label class="control-label<% if( invalid ){ %> text-danger<% } %>">{$smarty.config.modal_ip|default:"Ip"}<sup>*</sup>
        <% if( invalid ){ %>
          <sup>
            <% switch( reason ){
              case "empty ip":
                %>{$smarty.config.modal_ip_must_be_not_empty|default:"Адрес не может быть пустым."}<%
                break;
              case "invalid ip":
                %>{$smarty.config.modal_ip_invalid_format|default:"Адрес не подходит под формат."}<%
                break;
            } %>
          </sup>
        <% } %>
      </label>
    </script>


    <script id="port_label_tpl" type="text/template">
      <label class="control-label<% if( invalid ){ %> text-danger<% } %>">{$smarty.config.modal_port|default:"Порт"}<sup>*</sup>
        <% if( invalid ){ %>
          <sup>
            <% switch( reason ){
              case "port is not a string":
                %>{$smarty.config.modal_port_must_be_number_msg|default:"Порт должен быть числом."}<%
                break;
              case "invalid port":
                %>{$smarty.config.modal_invalid_port_msg|default:"Допускается диапазон от 1 до 65535."}<%
                break;
            } %>
          </sup>
        <% } %>
      </label>
    </script>

<script type="text/template" id="lora_meters_tpl">
  {include file="lorawan/helper/lora_children.tpl"}
</script>

<script type="text/template" id="lora_counter_add_edit">
  {include file="lorawan/helper/lora_add_edit_counter.tpl"}
</script>

<script type="text/template" id="activation_by_pers_tpl">
  {include file="lorawan/helper/activation_by_pers.tpl"}
</script>

<script type="text/template" id="over_the_air_tpl">
  {include file="lorawan/helper/over_the_air.tpl"}
</script>

<script type="text/template" id="main_settings_tpl">
  {include file="lorawan/helper/main_settings.tpl"}
</script>

<script type="text/template" id="regional_settings_tpl">
  {include file="lorawan/helper/regional_settings.tpl"}
</script>

<script type="text/template" id="device_rx_settings_tpl">
  {include file="lorawan/helper/device_rx_settings.tpl"}
</script>

<script type="text/template" id="delete_counter_tpl">
  {include file="lorawan/helper/delete_form.tpl"}
</script>

<script type="text/template" id="class_c_settings_tpl">
  {include file="lorawan/helper/class_c_settings.tpl"}
</script>
<script type="text/template" id="adaptive_settings_tpl">
  {include file="lorawan/helper/adaptive_data_rate.tpl"}
</script>

<script type="text/template" id="undefined_device_tpl">
  {include file="lorawan/helper/undefined_device_tpl.tpl"}
</script>

<script type="text/template" id="undefined_device_modal_tpl">
  {include file="lorawan/helper/undefined_device_modal.tpl"}
</script>

<script type="text/template" id="modal_delete_tpl">
  {include file="lorawan/helper/modal_delete.tpl"}
</script>

<script type="text/template" id="undefined_device_wait_tpl">
  <div class="panel-heading">
    Идет синхронизация с серверами...
  </div>
</script>


<script type="text/template" id="tbody_unsync_devices_tpl">
  {include file="lorawan/helper/tbody_unsync_devices.tpl"}
</script>  
<script type="text/template" id="gataways_list_tpl">
  <div class="panel-heading">
    {$smarty.config.gateway_head|default:"Базовые станции"}
  </div>
  <div class="panel-body">
    <table class="table">
      <tbody>
        <% _.each( gataways.toArray() , function( gataway ){ %>
        <tr id="<%= gataway.cid %>">
          <td class="action delete_gataway">
            <a href="#" class="fa fa-times"></a>
          </td>
          <td class="action edit_gataway">
            <a href="#" class="fa fa-pencil"></a>
          </td>
          <td>
            <i class="glyphicon glyphicon-signal <% if( gataway.get('active') ){ %>text-success<% }else{ %>text-danger<% } %>"></i>
            <%= gataway.get('gatewayId') %></td>
        </tr>
        <% }) %>
      </tbody>
      <tfoot>
        <tr>
          <td class="action" colspan="100" id="lora_add_gataway">
            <a href="#" class="fa fa-plus-circle"></a>
          </td>
        </tr>
      </tfoot>
    </table>
  </div>
</script>

    <script type="text/template" id="gataway_settings_tpl">
      {include file="lorawan/helper/gataway_modal_edit.tpl"}
    </script>

    <script type="text/template" id="gataway_delete_tpl">
      {include file="lorawan/helper/gataway_modal_delete.tpl"}
    </script>

    <script type="text/javascript" src="/ts/models/lora_converter.js"></script>
    <script type="text/javascript" src="/ts/models/convertertype.js"></script>
    <script type="text/javascript" src="/ts/models/meter.js"></script>
    <script type="text/javascript" src="/ts/models/meter_type.js"></script>
    <script type="text/javascript" src="/ts/models/converter.js"></script>
    <script type="text/javascript" src="/ts/models/lora_device.js"></script>
    <script type="text/javascript" src="/ts/models/lora_type.js"></script>
    <script type="text/javascript" src="/ts/models/lora_device_type.js"></script>
    <script type="text/javascript" src="/ts/models/lora_gataway.js"></script>

    <script type="text/javascript" src="/ts/collections/lora_devices.js"></script>
    <script type="text/javascript" src="/ts/collections/meters.js"></script>
    <script type="text/javascript" src="/ts/collections/meter_types.js"></script>
    <script type="text/javascript" src="/ts/collections/convertertypes.js"></script>
    <script type="text/javascript" src="/ts/collections/lora_types.js"></script>
    <script type="text/javascript" src="/ts/collections/lora_device_types.js"></script>
    <script type="text/javascript" src="/ts/collections/lora_gataway.js"></script>

    <script type="text/javascript" src="/ts/views/lora/lora_edit_add_modal.js"></script>
    <script type="text/javascript" src="/ts/views/lora/info_table.js"></script>
    <script type="text/javascript" src="/ts/views/lora/panel_info_sync.js"></script>
    <script type="text/javascript" src="/ts/views/lora/children_list.js"></script>
    <script type="text/javascript" src="/ts/views/lora/undefined_devices.js"></script>
    <script type="text/javascript" src="/ts/views/lora/meter_modal_edit.js"></script>
    <script type="text/javascript" src="/ts/views/lora/modal_delete.js"></script>
    <script type="text/javascript" src="/ts/views/lora/gataways_list.js"></script>
    <script type="text/javascript" src="/ts/views/lora/gataways_edit_modal.js"></script>
    <script type="text/javascript" src="/ts/views/lora/gataways_delete_modal.js"></script>
    <script type="text/javascript" src="/ts/views/lora/one.js"></script>

    {/block}
