{extends file="layout/meter.layout.tpl"}
{block name="content"}
  {if $user_lang eq 'en'}
    {config_load file="en_lang.conf" section="Log"}
  {else}
    {config_load file="ru_lang.conf" section="Log"}
  {/if}

  {assign var=oMeter value=$oObject}

  <h1 class="page-header">
    {$smarty.config.meter|default:"Прибор учета"} {$oMeter->Title|escape} 
  </h1>
  
  
  <ol class="breadcrumb">
    <li><a href="/">
      {$smarty.config.breadcrumbs_main|default:"Главная"}
      </a></li>
    <li>
      {include file="converter/helpers/block_name.tpl" oConverter=$oMeter->Converter}
    </li>
    <li>
      {include file="meter/helpers/block_name.tpl"}
    </li>
    <li class="active">
      {$smarty.config.log|default:"Лог"}
    </li>
  </ol>


  {if $Self->IsAdmin}
    <ul class="nav nav-tabs">
      <li>
        <a href="{$oObject->LinkLog}">
          {$smarty.config.user_logs|default:"Пользовательский журнал"}
        </a>
      </li>
      <li class="active">
        <a href="{$oObject->Link}syslog/">
          {$smarty.config.system_logs|default:"Системный журнал"}
        </a>
      </li>
    </ul>
  {/if}

  <div class="container-fluid">
    <div class="row">
      <div class="col-lg-12">
          
          {if $Res|count}

            {include file="helpers/pagination.tpl" Pages=$oObject->LogSysPages}
            
            <ul class="milestones">
              {foreach from=$Res item=row}
              <li>
                  <i class="milestone-info fa fa-comment-o"></i>
                  <p>
                    <span class="pull-right text-muted small">
                      <em>
                        {$row.add_time}
                      </em>
                    </span>
                    <br>
                  </p>
                  <br>
                  {foreach from=$row.output item=out}
                    <span class="pull-right small">
                      <em>
                        <b class="text-{if $out.status == "ok"}success{else}warning{/if}">{$out.ident}</b>
                      </em>
                    </span>
                    <br>
                    <pre>{foreach from=$out.hex|str_split:64 item=hex_part}
{$hex_part}
{/foreach}</pre>
                  {/foreach}
                </li>
              {/foreach}
            </ul>

            {include file="helpers/pagination.tpl" Pages=$oObject->LogSysPages}

          {else}
            <h3>{$smarty.config.no_logs|default:"Еще ничего не происходило."}</h3>
          {/if}
          
      </div>
    </div>
  </div>


{*
  <div class="container-fluid">
    <div class="row">
      <div class="col-lg-12">
          
          {if $oObject->LogSysList->Count}

            {include file="helpers/pagination.tpl" Pages=$oObject->LogSysPages}
            
            <ul class="milestones">
              {foreach from=$oObject->LogSysListByPages->Elements item="iLog"}
                  <li>
                    <i class="milestone-info fa fa-comment-o"></i>
                    <p>
                      <span class="pull-right text-muted small">
                        <em>
                          {$iLog->Its|date_format:"%Y-%m-%d %H:%I:%S (%A)"}
                        </em>
                      </span>
                      <br>
                      <span class="pull-right text-muted small">
                        <em>
                          #{$iLog->Id}
                        </em>
                      </span>
                    </p>
                    <br>
                    <pre>{$iLog->ActionToTpl}</pre>
                  </li>
              {/foreach}
            </ul>

            {include file="helpers/pagination.tpl" Pages=$oObject->LogSysPages}

          {else}
            <h3>Еще ничего не происходило.</h3>
          {/if}
          
      </div>
    </div>
  </div>
  *}


  {literal}
    <script>
      $(".spoiler-trigger").click(function() {
        $(this).next().collapse('toggle');
      });
    </script>
  {/literal}
  
  
{/block}
