{extends file="layout/task.layout.tpl"}
{block name="content"}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">
            {$smarty.config.tasks|default:"Задания системы"}
          </h1>
          
          <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:"Главная"}</a></li>
            <li class="active">{$smarty.config.tasks|default:"Задания системы"}</li>
          </ol>
          
      </div>
  </div>
  
  
  <div class="row">
    <div class="col-lg-2">
      
      <div class="panel panel-default">
          <div class="panel-heading">
              {$smarty.config.tasks_total_qty|default:"Общее кол-во"}
          </div>
          <div class="panel-body list-group table-responsive">
            
            <a href="#" class="list-group-item">
                {$smarty.config.tasks_waiting|default:"Ожидает"}
                <span class="pull-right">{$Site->TaskWaiting->Count}</span>
            </a>
            <a href="#" class="list-group-item">
                {$smarty.config.tasks_working|default:"Выполняется"}
                <span class="pull-right">{$Site->TaskRunning->Count}</span>
            </a>
            <a href="#" class="list-group-item">
                {$smarty.config.tasks_done|default:"Выполнено"}
                <span class="pull-right">{$Site->TaskArchived->Count}</span>
            </a>
            
          </div>
      </div>
    
    </div>
    <div class="col-lg-5">
      
      <div class="panel panel-default">
          <div class="panel-heading">
              {$smarty.config.waiting_table_head|default:"Ожидающие"}
          </div>
          <div class="panel-body list-group table-responsive">
            
            <table class="table table-striped table-hover">
              {if $Site->TaskWaitingASCConverter->Count}
                <thead>
                  <tr>
                    <th>{$Site->Config('ru.meter.one')}</th>
                    <th>{$Site->Config('ru.converter.one')}</th>
                    <th>{$Site->Config('ru.task.tasks')}</th>
                  </tr>
                </thead>
              {/if}
              <tbody>
                
                {assign var="Class" value="warning"}
                
                {assign var="LastConverterId" value=0}
                {assign var="class" value=$Class}
                
                {foreach from=$Site->TaskWaitingASCConverter->Elements item="iTask"}
                  <tr class="{$class}">
                    <td>
                      {if $LastConverterId != $iTask->Meter->Converter->Id}
                        {include 
                            file="converter/helpers/block_name.tpl"
                            oConverter=$iTask->Meter->Converter
                        }
                        {if $class==$Class}
                          {assign var="class" value=''}
                        {else}
                          {assign var="class" value=$Class}
                        {/if}
                        {assign var="LastConverterId" value=$iTask->Meter->Converter->Id}
                      {/if}
                    </td>
                    <td>
                      {include 
                            file="meter/helpers/block_name.tpl"
                            oMeter=$iTask->Meter
                        }
                    </td>
                    <td>
                      {$iTask->Meter->TaskWaiting->Count}
                    </td>
                  </tr>
                {foreachelse}
                  <tr>
                    <td>
                      {$smarty.config.no_tasks|default:"Нет заданий"}
                    </td>
                  </tr>
                {/foreach}
              </tbody>
            </table>
            
          </div>
      </div>
    
    </div>
    <div class="col-lg-5">
      
      <div class="panel panel-default">
          <div class="panel-heading">
              {$smarty.config.working_table_head|default:"Выполняемые"}
          </div>
          <div class="panel-body list-group table-responsive">
            
            <table class="table table-striped table-hover">
              {if $Site->TaskRunningASCConverter->Count}
              <thead>
                <tr>
                  <th>{$Site->Config('ru.meter.one')}</th>
                  <th>{$Site->Config('ru.converter.one')}</th>
                  <th>{$Site->Config('ru.task.tasks')}</th>
                </tr>
              </thead>
              {/if}
              <tbody>
                
                
                {assign var="LastConverterId" value=0}
                {assign var="class" value=$Class}
                
                {foreach from=$Site->TaskRunningASCConverter->Elements item="iTask"}
                  <tr>
                    <td>
                      {if $LastConverterId != $iTask->Meter->Converter->Id}
                        {include 
                            file="converter/helpers/block_name.tpl"
                            oConverter=$iTask->Meter->Converter
                        }
                        
                        {if $class==$Class}
                          {assign var="class" value=''}
                        {else}
                          {assign var="class" value=$Class}
                        {/if}
                        
                        {assign var="LastConverterId" value=$iTask->Meter->Converter->Id}
                      {/if}
                    </td>
                    <td>
                      {include 
                            file="meter/helpers/block_name.tpl"
                            oMeter=$iTask->Meter
                        }
                    </td>
                    <td>
                      {$iTask->Meter->TaskRunning->Count}
                    </td>
                  </tr>
                {foreachelse}
                  <tr>
                    <td>
                      {$smarty.config.no_tasks|default:"Нет заданий"}
                    </td>
                  </tr>
                {/foreach}
              </tbody>
            </table>
            
          </div>
      </div>
    
    </div>
  </div>
  
{/block}