{extends file="layout/meter.layout.tpl"}
{block name="content"}


  <h1 class="page-header">Лог "{$oTask->Title}"</h1>
  
  <div class="row">
      <div class="col-lg-8">
          <div class="panel panel-default">
            <div class="panel-heading">
                  График
              </div>
              <div class="panel-body">
                <div id="GRAFIC" style="width:100%; height: 400px;"></div>
              </div>
          </div>
      </div>
      <!-- /.col-lg-4 -->
      <div class="col-lg-4">
          <div class="panel panel-primary">
            <div class="panel-heading">
                  Задачи
              </div>
              <div class="panel-body list-group">
                {foreach from=$Site->Crontask->Elements item="iCrontask"}
                  <a 
                    href="/tasks/{$iCrontask->Id}/"
                    id="logarithmic" 
                    class="list-group-item {if $iCrontask->Id == $oTask->Id}active{/if}">
                      {$iCrontask->Title}
                  </a>
                {/foreach}
              </div>
          </div>
      </div>
  </div>
  
  <table class="table form list">
    
    <thead>
      <tr>
        <th></th>
        <th>Начало</th>
        <th>Конец</th>
        <th>Статус</th>
        <th>Время выполнения</th>
        <th>Итераций</th>
        <th>Удал.Ред.Доб.</th>
        <th>Время</th>
        <th>Просмотр</th>
        <th>Время</th>
        <th>Пик.память</th>
      </tr>
    </thead>
    
    {foreach from=$oTask->DescByPage->Elements item=iLog key=i}
      <tr> 
        <td>
          <a href="more/{$iLog->Id}/"  name="anchor{math equation="z-x-1" z=$oTask->DescByPage->Elements|count x=$i}">#{$iLog->Id}</a>
        </td>
        <td>
          {$iLog->DateStart}
        </td>
        <td>
          {$iLog->DateEnd}
        </td>
        <td>
          {$iLog->Statuscrontasklog->Description|default:"OK"}
        </td>
        <td>
          {$iLog->Timerun|string_format:"%.4f"} сек.
        </td>
        <td>
          {$iLog->Iteration}
        </td>
        <td>
          {$iLog->Updb}
        </td>
        <td>
          {$iLog->Timeupdb|string_format:"%.4f"} сек.
        </td>
        <td>
          {$iLog->Seldb}
        </td>
        <td>
          {$iLog->Timeseldb|string_format:"%.4f"} сек.
        </td>
        <td>
          {($iLog->Memorypeak/1024/1024)|string_format:"%.4f"}
        </td>
      </tr>
    {/foreach}
  </table>


  {include file="helpers/pagination.tpl" Pages=$oTask->GetLogPage()}
  
  
  {literal}
<script>

function returnAr(index){
  var b = []
  var notvalid = 1
  var th_s = $('.form.list').find('td')
  for( var i = 0 ; i < th_s.length ; i++ ){
    if( $( th_s[i] ).index() == index ){
      if( $( th_s[i] ).text().match( /(.*)\ сек\./g ) ){
        cc = Number($( th_s[i] ).text().replace( /(.*)\ сек\./g , function(_,c){
            return c
          }))
          if( cc ) b.push(cc)
          else{
            b.push(notvalid)
          }
      }else if($( th_s[i] ).text().match( /(.*)\ MB/g )){
        cc = Number($( th_s[i] ).text().replace( /(.*)\ MB/g , function(_,c){
            return c
          }))
          if( cc ) b.push(cc)
          else{
            b.push(notvalid)
          }
      }else{
        cc = Number($( th_s[i] ).text())
        if( cc ) b.push(cc)
        else{
          b.push(notvalid)
        }
      }
    }
  }
  return b.reverse()
}

function Render(logarithmic){
  if( typeof logarithmic == 'undefined' ){
    logarithmic = true
  }
  $('#GRAFIC').highcharts({
      title: {
          x: -20 //center
      },
      subtitle: {
          x: -20
      },
      plotOptions:{
        series:{
          events:{
            click: function(e) {
	            GetHash(e.point.category);
	          }
          }
        }
      },
      yAxis: {
          type: function(){
            if( logarithmic ) return 'logarithmic';
          }(),
          plotLines: [{
              value: 0,
              width: 1,
              color: '#808080'
          }]
      },
      legend: {
          layout: 'vertical',
          align: 'right',
          verticalAlign: 'middle',
          borderWidth: 0
      },
      series: [
      {
          name: 'Итераций',
          color: 'blue',
          data: returnAr(5)
      },  {
          name: 'Изменения БД',
          color: 'red',
          data: returnAr(6)
      },
      {
          name: 'Просмотр',
          color: 'green',
          data: returnAr(8)
      }, {
          name: 'Память',
          color: 'rgba(22, 56, 117, 0.38)',
          type: 'area',
          data: returnAr(10)
      }, {
          name: 'Время выполнения',
          color: 'rgba(255, 165, 0, 0.41)',
          type: 'area',
          data: returnAr(4)
      }
      ]
  });
}

function GetHash(id){
  window.location.hash = "#anchor" + id
  $('tr.active').removeClass('active');
  $('a[name="anchor' + id+'"]').closest('tr').addClass('active')
}

if( window.location.hash != '' ){
  GetHash(window.location.hash.replace('#anchor',''))
}

$('#logarithmic').click(function(){
  $('.counter_active').removeClass('counter_active')
  $(this).addClass('counter_active')
  Render(true)
})

$('#normal').click(function(){
  $('.counter_active').removeClass('counter_active')
  $(this).addClass('counter_active')
  Render(false)
})

$.getScript('/js/core/highcharts.js',function(){
  Render(true)
})
</script>


{/literal}

{/block}
